import { Toolbar } from './components/MToolbar.vue';
import { Extension } from '@codemirror/state';
import { getDefaultPlugins, CasketI18nData } from './utils';
import { Options } from 'remark-rehype';
import { type PluggableList } from 'unified';
export interface Plugins {
    remark?: PluggableList;
    rehype?: PluggableList;
    remarkRehypeOptions?: Options;
    codemirror?: Extension[];
    toolbarL?: Toolbar;
    toolbarR?: Toolbar;
}
export type Uploader = ((data: FileList) => {
    url: string;
    alt: string;
}[]) | undefined;
declare let __VLS_typeProps: {
    plugins?: Plugins;
    hideHeader?: boolean;
    hideFooter?: boolean;
    lang?: CasketI18nData[] | CasketI18nData;
    upload?: Uploader;
    height?: string;
    disabled?: boolean;
};
export interface CasketView {
    showEditor: boolean;
    showViewer: boolean;
    fullScreen: boolean;
    interval: number;
    data: Record<string, unknown>;
}
type __VLS_PublicProps = {
    modelValue: string;
} & typeof __VLS_typeProps;
declare const _default: import("vue").DefineComponent<__VLS_WithDefaults<__VLS_TypePropsToOption<__VLS_PublicProps>, {
    plugins: typeof getDefaultPlugins;
    lang: () => CasketI18nData[];
    upload: undefined;
    height: string;
    hideHeader: boolean;
    hideFooter: boolean;
    disabled: boolean;
}>, {}, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
    "update:modelValue": (modelValue: string) => void;
}, string, import("vue").PublicProps, Readonly<import("vue").ExtractPropTypes<__VLS_WithDefaults<__VLS_TypePropsToOption<__VLS_PublicProps>, {
    plugins: typeof getDefaultPlugins;
    lang: () => CasketI18nData[];
    upload: undefined;
    height: string;
    hideHeader: boolean;
    hideFooter: boolean;
    disabled: boolean;
}>>> & {
    "onUpdate:modelValue"?: ((modelValue: string) => any) | undefined;
}, {
    disabled: boolean;
    lang: CasketI18nData | CasketI18nData[];
    upload: (data: FileList) => {
        url: string;
        alt: string;
    }[];
    plugins: Plugins;
    height: string;
    hideHeader: boolean;
    hideFooter: boolean;
}, {}>;
export default _default;

type __VLS_WithDefaults<P, D> = {
    [K in keyof Pick<P, keyof P>]: K extends keyof D ? __VLS_Prettify<P[K] & {
        default: D[K];
    }> : P[K];
};
type __VLS_Prettify<T> = {
    [K in keyof T]: T[K];
} & {};
type __VLS_NonUndefinedable<T> = T extends undefined ? never : T;
type __VLS_TypePropsToOption<T> = {
    [K in keyof T]-?: {} extends Pick<T, K> ? {
        type: import('vue').PropType<__VLS_NonUndefinedable<T[K]>>;
    } : {
        type: import('vue').PropType<T[K]>;
        required: true;
    };
};
