import { defineComponent as bt, shallowRef as fl, inject as Pk, computed as Qt, toRaw as Qk, onMounted as Fc, watch as ft, onBeforeUnmount as $k, h as Gc, ref as Ce, openBlock as ue, createElementBlock as Oe, createElementVNode as q, normalizeClass as wn, renderSlot as dl, createVNode as Vt, unref as oe, createCommentVNode as xn, createBlock as Ci, withCtx as Yt, createTextVNode as As, toDisplayString as ce, withDirectives as Sn, Fragment as di, renderList as pi, vModelSelect as Ck, vModelText as Yn, render as dn, mergeModels as ea, useModel as Hc, nextTick as Tk, onBeforeMount as Ak, normalizeStyle as Rk, isRef as vf, Teleport as Mk } from "vue";
class me {
  /**
  Get the line description around the given position.
  */
  lineAt(e) {
    if (e < 0 || e > this.length)
      throw new RangeError(`Invalid position ${e} in document of length ${this.length}`);
    return this.lineInner(e, !1, 1, 0);
  }
  /**
  Get the description for the given (1-based) line number.
  */
  line(e) {
    if (e < 1 || e > this.lines)
      throw new RangeError(`Invalid line number ${e} in ${this.lines}-line document`);
    return this.lineInner(e, !0, 1, 0);
  }
  /**
  Replace a range of the text with the given content.
  */
  replace(e, t, i) {
    [e, t] = er(this, e, t);
    let r = [];
    return this.decompose(
      0,
      e,
      r,
      2
      /* Open.To */
    ), i.length && i.decompose(
      0,
      i.length,
      r,
      3
      /* Open.To */
    ), this.decompose(
      t,
      this.length,
      r,
      1
      /* Open.From */
    ), sn.from(r, this.length - (t - e) + i.length);
  }
  /**
  Append another document to this one.
  */
  append(e) {
    return this.replace(this.length, this.length, e);
  }
  /**
  Retrieve the text between the given points.
  */
  slice(e, t = this.length) {
    [e, t] = er(this, e, t);
    let i = [];
    return this.decompose(e, t, i, 0), sn.from(i, t - e);
  }
  /**
  Test whether this text is equal to another instance.
  */
  eq(e) {
    if (e == this)
      return !0;
    if (e.length != this.length || e.lines != this.lines)
      return !1;
    let t = this.scanIdentical(e, 1), i = this.length - this.scanIdentical(e, -1), r = new Vr(this), s = new Vr(e);
    for (let o = t, a = t; ; ) {
      if (r.next(o), s.next(o), o = 0, r.lineBreak != s.lineBreak || r.done != s.done || r.value != s.value)
        return !1;
      if (a += r.value.length, r.done || a >= i)
        return !0;
    }
  }
  /**
  Iterate over the text. When `dir` is `-1`, iteration happens
  from end to start. This will return lines and the breaks between
  them as separate strings.
  */
  iter(e = 1) {
    return new Vr(this, e);
  }
  /**
  Iterate over a range of the text. When `from` > `to`, the
  iterator will run in reverse.
  */
  iterRange(e, t = this.length) {
    return new kg(this, e, t);
  }
  /**
  Return a cursor that iterates over the given range of lines,
  _without_ returning the line breaks between, and yielding empty
  strings for empty lines.
  
  When `from` and `to` are given, they should be 1-based line numbers.
  */
  iterLines(e, t) {
    let i;
    if (e == null)
      i = this.iter();
    else {
      t == null && (t = this.lines + 1);
      let r = this.line(e).from;
      i = this.iterRange(r, Math.max(r, t == this.lines + 1 ? this.length : t <= 1 ? 0 : this.line(t - 1).to));
    }
    return new xg(i);
  }
  /**
  Return the document as a string, using newline characters to
  separate lines.
  */
  toString() {
    return this.sliceString(0);
  }
  /**
  Convert the document to an array of lines (which can be
  deserialized again via [`Text.of`](https://codemirror.net/6/docs/ref/#state.Text^of)).
  */
  toJSON() {
    let e = [];
    return this.flatten(e), e;
  }
  /**
  @internal
  */
  constructor() {
  }
  /**
  Create a `Text` instance for the given array of lines.
  */
  static of(e) {
    if (e.length == 0)
      throw new RangeError("A document must have at least one line");
    return e.length == 1 && !e[0] ? me.empty : e.length <= 32 ? new De(e) : sn.from(De.split(e, []));
  }
}
class De extends me {
  constructor(e, t = Zk(e)) {
    super(), this.text = e, this.length = t;
  }
  get lines() {
    return this.text.length;
  }
  get children() {
    return null;
  }
  lineInner(e, t, i, r) {
    for (let s = 0; ; s++) {
      let o = this.text[s], a = r + o.length;
      if ((t ? i : a) >= e)
        return new Ek(r, a, i, o);
      r = a + 1, i++;
    }
  }
  decompose(e, t, i, r) {
    let s = e <= 0 && t >= this.length ? this : new De(Pf(this.text, e, t), Math.min(t, this.length) - Math.max(0, e));
    if (r & 1) {
      let o = i.pop(), a = Io(s.text, o.text.slice(), 0, s.length);
      if (a.length <= 32)
        i.push(new De(a, o.length + s.length));
      else {
        let l = a.length >> 1;
        i.push(new De(a.slice(0, l)), new De(a.slice(l)));
      }
    } else
      i.push(s);
  }
  replace(e, t, i) {
    if (!(i instanceof De))
      return super.replace(e, t, i);
    [e, t] = er(this, e, t);
    let r = Io(this.text, Io(i.text, Pf(this.text, 0, e)), t), s = this.length + i.length - (t - e);
    return r.length <= 32 ? new De(r, s) : sn.from(De.split(r, []), s);
  }
  sliceString(e, t = this.length, i = `
`) {
    [e, t] = er(this, e, t);
    let r = "";
    for (let s = 0, o = 0; s <= t && o < this.text.length; o++) {
      let a = this.text[o], l = s + a.length;
      s > e && o && (r += i), e < l && t > s && (r += a.slice(Math.max(0, e - s), t - s)), s = l + 1;
    }
    return r;
  }
  flatten(e) {
    for (let t of this.text)
      e.push(t);
  }
  scanIdentical() {
    return 0;
  }
  static split(e, t) {
    let i = [], r = -1;
    for (let s of e)
      i.push(s), r += s.length + 1, i.length == 32 && (t.push(new De(i, r)), i = [], r = -1);
    return r > -1 && t.push(new De(i, r)), t;
  }
}
class sn extends me {
  constructor(e, t) {
    super(), this.children = e, this.length = t, this.lines = 0;
    for (let i of e)
      this.lines += i.lines;
  }
  lineInner(e, t, i, r) {
    for (let s = 0; ; s++) {
      let o = this.children[s], a = r + o.length, l = i + o.lines - 1;
      if ((t ? l : a) >= e)
        return o.lineInner(e, t, i, r);
      r = a + 1, i = l + 1;
    }
  }
  decompose(e, t, i, r) {
    for (let s = 0, o = 0; o <= t && s < this.children.length; s++) {
      let a = this.children[s], l = o + a.length;
      if (e <= l && t >= o) {
        let u = r & ((o <= e ? 1 : 0) | (l >= t ? 2 : 0));
        o >= e && l <= t && !u ? i.push(a) : a.decompose(e - o, t - o, i, u);
      }
      o = l + 1;
    }
  }
  replace(e, t, i) {
    if ([e, t] = er(this, e, t), i.lines < this.lines)
      for (let r = 0, s = 0; r < this.children.length; r++) {
        let o = this.children[r], a = s + o.length;
        if (e >= s && t <= a) {
          let l = o.replace(e - s, t - s, i), u = this.lines - o.lines + l.lines;
          if (l.lines < u >> 4 && l.lines > u >> 6) {
            let c = this.children.slice();
            return c[r] = l, new sn(c, this.length - (t - e) + i.length);
          }
          return super.replace(s, a, l);
        }
        s = a + 1;
      }
    return super.replace(e, t, i);
  }
  sliceString(e, t = this.length, i = `
`) {
    [e, t] = er(this, e, t);
    let r = "";
    for (let s = 0, o = 0; s < this.children.length && o <= t; s++) {
      let a = this.children[s], l = o + a.length;
      o > e && s && (r += i), e < l && t > o && (r += a.sliceString(e - o, t - o, i)), o = l + 1;
    }
    return r;
  }
  flatten(e) {
    for (let t of this.children)
      t.flatten(e);
  }
  scanIdentical(e, t) {
    if (!(e instanceof sn))
      return 0;
    let i = 0, [r, s, o, a] = t > 0 ? [0, 0, this.children.length, e.children.length] : [this.children.length - 1, e.children.length - 1, -1, -1];
    for (; ; r += t, s += t) {
      if (r == o || s == a)
        return i;
      let l = this.children[r], u = e.children[s];
      if (l != u)
        return i + l.scanIdentical(u, t);
      i += l.length + 1;
    }
  }
  static from(e, t = e.reduce((i, r) => i + r.length + 1, -1)) {
    let i = 0;
    for (let d of e)
      i += d.lines;
    if (i < 32) {
      let d = [];
      for (let p of e)
        p.flatten(d);
      return new De(d, t);
    }
    let r = Math.max(
      32,
      i >> 5
      /* Tree.BranchShift */
    ), s = r << 1, o = r >> 1, a = [], l = 0, u = -1, c = [];
    function h(d) {
      let p;
      if (d.lines > s && d instanceof sn)
        for (let g of d.children)
          h(g);
      else
        d.lines > o && (l > o || !l) ? (f(), a.push(d)) : d instanceof De && l && (p = c[c.length - 1]) instanceof De && d.lines + p.lines <= 32 ? (l += d.lines, u += d.length + 1, c[c.length - 1] = new De(p.text.concat(d.text), p.length + 1 + d.length)) : (l + d.lines > r && f(), l += d.lines, u += d.length + 1, c.push(d));
    }
    function f() {
      l != 0 && (a.push(c.length == 1 ? c[0] : sn.from(c, u)), u = -1, l = c.length = 0);
    }
    for (let d of e)
      h(d);
    return f(), a.length == 1 ? a[0] : new sn(a, t);
  }
}
me.empty = /* @__PURE__ */ new De([""], 0);
function Zk(n) {
  let e = -1;
  for (let t of n)
    e += t.length + 1;
  return e;
}
function Io(n, e, t = 0, i = 1e9) {
  for (let r = 0, s = 0, o = !0; s < n.length && r <= i; s++) {
    let a = n[s], l = r + a.length;
    l >= t && (l > i && (a = a.slice(0, i - r)), r < t && (a = a.slice(t - r)), o ? (e[e.length - 1] += a, o = !1) : e.push(a)), r = l + 1;
  }
  return e;
}
function Pf(n, e, t) {
  return Io(n, [""], e, t);
}
class Vr {
  constructor(e, t = 1) {
    this.dir = t, this.done = !1, this.lineBreak = !1, this.value = "", this.nodes = [e], this.offsets = [t > 0 ? 1 : (e instanceof De ? e.text.length : e.children.length) << 1];
  }
  nextInner(e, t) {
    for (this.done = this.lineBreak = !1; ; ) {
      let i = this.nodes.length - 1, r = this.nodes[i], s = this.offsets[i], o = s >> 1, a = r instanceof De ? r.text.length : r.children.length;
      if (o == (t > 0 ? a : 0)) {
        if (i == 0)
          return this.done = !0, this.value = "", this;
        t > 0 && this.offsets[i - 1]++, this.nodes.pop(), this.offsets.pop();
      } else if ((s & 1) == (t > 0 ? 0 : 1)) {
        if (this.offsets[i] += t, e == 0)
          return this.lineBreak = !0, this.value = `
`, this;
        e--;
      } else if (r instanceof De) {
        let l = r.text[o + (t < 0 ? -1 : 0)];
        if (this.offsets[i] += t, l.length > Math.max(0, e))
          return this.value = e == 0 ? l : t > 0 ? l.slice(e) : l.slice(0, l.length - e), this;
        e -= l.length;
      } else {
        let l = r.children[o + (t < 0 ? -1 : 0)];
        e > l.length ? (e -= l.length, this.offsets[i] += t) : (t < 0 && this.offsets[i]--, this.nodes.push(l), this.offsets.push(t > 0 ? 1 : (l instanceof De ? l.text.length : l.children.length) << 1));
      }
    }
  }
  next(e = 0) {
    return e < 0 && (this.nextInner(-e, -this.dir), e = this.value.length), this.nextInner(e, this.dir);
  }
}
class kg {
  constructor(e, t, i) {
    this.value = "", this.done = !1, this.cursor = new Vr(e, t > i ? -1 : 1), this.pos = t > i ? e.length : 0, this.from = Math.min(t, i), this.to = Math.max(t, i);
  }
  nextInner(e, t) {
    if (t < 0 ? this.pos <= this.from : this.pos >= this.to)
      return this.value = "", this.done = !0, this;
    e += Math.max(0, t < 0 ? this.pos - this.to : this.from - this.pos);
    let i = t < 0 ? this.pos - this.from : this.to - this.pos;
    e > i && (e = i), i -= e;
    let { value: r } = this.cursor.next(e);
    return this.pos += (r.length + e) * t, this.value = r.length <= i ? r : t < 0 ? r.slice(r.length - i) : r.slice(0, i), this.done = !this.value, this;
  }
  next(e = 0) {
    return e < 0 ? e = Math.max(e, this.from - this.pos) : e > 0 && (e = Math.min(e, this.to - this.pos)), this.nextInner(e, this.cursor.dir);
  }
  get lineBreak() {
    return this.cursor.lineBreak && this.value != "";
  }
}
class xg {
  constructor(e) {
    this.inner = e, this.afterBreak = !0, this.value = "", this.done = !1;
  }
  next(e = 0) {
    let { done: t, lineBreak: i, value: r } = this.inner.next(e);
    return t && this.afterBreak ? (this.value = "", this.afterBreak = !1) : t ? (this.done = !0, this.value = "") : i ? this.afterBreak ? this.value = "" : (this.afterBreak = !0, this.next()) : (this.value = r, this.afterBreak = !1), this;
  }
  get lineBreak() {
    return !1;
  }
}
typeof Symbol < "u" && (me.prototype[Symbol.iterator] = function() {
  return this.iter();
}, Vr.prototype[Symbol.iterator] = kg.prototype[Symbol.iterator] = xg.prototype[Symbol.iterator] = function() {
  return this;
});
let Ek = class {
  /**
  @internal
  */
  constructor(e, t, i, r) {
    this.from = e, this.to = t, this.number = i, this.text = r;
  }
  /**
  The length of the line (not including any line break after it).
  */
  get length() {
    return this.to - this.from;
  }
};
function er(n, e, t) {
  return e = Math.max(0, Math.min(n.length, e)), [e, Math.max(e, Math.min(n.length, t))];
}
let Bi = /* @__PURE__ */ "lc,34,7n,7,7b,19,,,,2,,2,,,20,b,1c,l,g,,2t,7,2,6,2,2,,4,z,,u,r,2j,b,1m,9,9,,o,4,,9,,3,,5,17,3,3b,f,,w,1j,,,,4,8,4,,3,7,a,2,t,,1m,,,,2,4,8,,9,,a,2,q,,2,2,1l,,4,2,4,2,2,3,3,,u,2,3,,b,2,1l,,4,5,,2,4,,k,2,m,6,,,1m,,,2,,4,8,,7,3,a,2,u,,1n,,,,c,,9,,14,,3,,1l,3,5,3,,4,7,2,b,2,t,,1m,,2,,2,,3,,5,2,7,2,b,2,s,2,1l,2,,,2,4,8,,9,,a,2,t,,20,,4,,2,3,,,8,,29,,2,7,c,8,2q,,2,9,b,6,22,2,r,,,,,,1j,e,,5,,2,5,b,,10,9,,2u,4,,6,,2,2,2,p,2,4,3,g,4,d,,2,2,6,,f,,jj,3,qa,3,t,3,t,2,u,2,1s,2,,7,8,,2,b,9,,19,3,3b,2,y,,3a,3,4,2,9,,6,3,63,2,2,,1m,,,7,,,,,2,8,6,a,2,,1c,h,1r,4,1c,7,,,5,,14,9,c,2,w,4,2,2,,3,1k,,,2,3,,,3,1m,8,2,2,48,3,,d,,7,4,,6,,3,2,5i,1m,,5,ek,,5f,x,2da,3,3x,,2o,w,fe,6,2x,2,n9w,4,,a,w,2,28,2,7k,,3,,4,,p,2,5,,47,2,q,i,d,,12,8,p,b,1a,3,1c,,2,4,2,2,13,,1v,6,2,2,2,2,c,,8,,1b,,1f,,,3,2,2,5,2,,,16,2,8,,6m,,2,,4,,fn4,,kh,g,g,g,a6,2,gt,,6a,,45,5,1ae,3,,2,5,4,14,3,4,,4l,2,fx,4,ar,2,49,b,4w,,1i,f,1k,3,1d,4,2,2,1x,3,10,5,,8,1q,,c,2,1g,9,a,4,2,,2n,3,2,,,2,6,,4g,,3,8,l,2,1l,2,,,,,m,,e,7,3,5,5f,8,2,3,,,n,,29,,2,6,,,2,,,2,,2,6j,,2,4,6,2,,2,r,2,2d,8,2,,,2,2y,,,,2,6,,,2t,3,2,4,,5,77,9,,2,6t,,a,2,,,4,,40,4,2,2,4,,w,a,14,6,2,4,8,,9,6,2,3,1a,d,,2,ba,7,,6,,,2a,m,2,7,,2,,2,3e,6,3,,,2,,7,,,20,2,3,,,,9n,2,f0b,5,1n,7,t4,,1r,4,29,,f5k,2,43q,,,3,4,5,8,8,2,7,u,4,44,3,1iz,1j,4,1e,8,,e,,m,5,,f,11s,7,,h,2,7,,2,,5,79,7,c5,4,15s,7,31,7,240,5,gx7k,2o,3k,6o".split(",").map((n) => n ? parseInt(n, 36) : 1);
for (let n = 1; n < Bi.length; n++)
  Bi[n] += Bi[n - 1];
function zk(n) {
  for (let e = 1; e < Bi.length; e += 2)
    if (Bi[e] > n)
      return Bi[e - 1] <= n;
  return !1;
}
function Qf(n) {
  return n >= 127462 && n <= 127487;
}
const $f = 8205;
function Ke(n, e, t = !0, i = !0) {
  return (t ? wg : Dk)(n, e, i);
}
function wg(n, e, t) {
  if (e == n.length)
    return e;
  e && Sg(n.charCodeAt(e)) && vg(n.charCodeAt(e - 1)) && e--;
  let i = Ue(n, e);
  for (e += Rt(i); e < n.length; ) {
    let r = Ue(n, e);
    if (i == $f || r == $f || t && zk(r))
      e += Rt(r), i = r;
    else if (Qf(r)) {
      let s = 0, o = e - 2;
      for (; o >= 0 && Qf(Ue(n, o)); )
        s++, o -= 2;
      if (s % 2 == 0)
        break;
      e += 2;
    } else
      break;
  }
  return e;
}
function Dk(n, e, t) {
  for (; e > 0; ) {
    let i = wg(n, e - 2, t);
    if (i < e)
      return i;
    e--;
  }
  return 0;
}
function Sg(n) {
  return n >= 56320 && n < 57344;
}
function vg(n) {
  return n >= 55296 && n < 56320;
}
function Ue(n, e) {
  let t = n.charCodeAt(e);
  if (!vg(t) || e + 1 == n.length)
    return t;
  let i = n.charCodeAt(e + 1);
  return Sg(i) ? (t - 55296 << 10) + (i - 56320) + 65536 : t;
}
function Kc(n) {
  return n <= 65535 ? String.fromCharCode(n) : (n -= 65536, String.fromCharCode((n >> 10) + 55296, (n & 1023) + 56320));
}
function Rt(n) {
  return n < 65536 ? 1 : 2;
}
const bu = /\r\n?|\n/;
var Ge = /* @__PURE__ */ function(n) {
  return n[n.Simple = 0] = "Simple", n[n.TrackDel = 1] = "TrackDel", n[n.TrackBefore = 2] = "TrackBefore", n[n.TrackAfter = 3] = "TrackAfter", n;
}(Ge || (Ge = {}));
class hn {
  // Sections are encoded as pairs of integers. The first is the
  // length in the current document, and the second is -1 for
  // unaffected sections, and the length of the replacement content
  // otherwise. So an insertion would be (0, n>0), a deletion (n>0,
  // 0), and a replacement two positive numbers.
  /**
  @internal
  */
  constructor(e) {
    this.sections = e;
  }
  /**
  The length of the document before the change.
  */
  get length() {
    let e = 0;
    for (let t = 0; t < this.sections.length; t += 2)
      e += this.sections[t];
    return e;
  }
  /**
  The length of the document after the change.
  */
  get newLength() {
    let e = 0;
    for (let t = 0; t < this.sections.length; t += 2) {
      let i = this.sections[t + 1];
      e += i < 0 ? this.sections[t] : i;
    }
    return e;
  }
  /**
  False when there are actual changes in this set.
  */
  get empty() {
    return this.sections.length == 0 || this.sections.length == 2 && this.sections[1] < 0;
  }
  /**
  Iterate over the unchanged parts left by these changes. `posA`
  provides the position of the range in the old document, `posB`
  the new position in the changed document.
  */
  iterGaps(e) {
    for (let t = 0, i = 0, r = 0; t < this.sections.length; ) {
      let s = this.sections[t++], o = this.sections[t++];
      o < 0 ? (e(i, r, s), r += s) : r += o, i += s;
    }
  }
  /**
  Iterate over the ranges changed by these changes. (See
  [`ChangeSet.iterChanges`](https://codemirror.net/6/docs/ref/#state.ChangeSet.iterChanges) for a
  variant that also provides you with the inserted text.)
  `fromA`/`toA` provides the extent of the change in the starting
  document, `fromB`/`toB` the extent of the replacement in the
  changed document.
  
  When `individual` is true, adjacent changes (which are kept
  separate for [position mapping](https://codemirror.net/6/docs/ref/#state.ChangeDesc.mapPos)) are
  reported separately.
  */
  iterChangedRanges(e, t = !1) {
    yu(this, e, t);
  }
  /**
  Get a description of the inverted form of these changes.
  */
  get invertedDesc() {
    let e = [];
    for (let t = 0; t < this.sections.length; ) {
      let i = this.sections[t++], r = this.sections[t++];
      r < 0 ? e.push(i, r) : e.push(r, i);
    }
    return new hn(e);
  }
  /**
  Compute the combined effect of applying another set of changes
  after this one. The length of the document after this set should
  match the length before `other`.
  */
  composeDesc(e) {
    return this.empty ? e : e.empty ? this : Pg(this, e);
  }
  /**
  Map this description, which should start with the same document
  as `other`, over another set of changes, so that it can be
  applied after it. When `before` is true, map as if the changes
  in `other` happened before the ones in `this`.
  */
  mapDesc(e, t = !1) {
    return e.empty ? this : ku(this, e, t);
  }
  mapPos(e, t = -1, i = Ge.Simple) {
    let r = 0, s = 0;
    for (let o = 0; o < this.sections.length; ) {
      let a = this.sections[o++], l = this.sections[o++], u = r + a;
      if (l < 0) {
        if (u > e)
          return s + (e - r);
        s += a;
      } else {
        if (i != Ge.Simple && u >= e && (i == Ge.TrackDel && r < e && u > e || i == Ge.TrackBefore && r < e || i == Ge.TrackAfter && u > e))
          return null;
        if (u > e || u == e && t < 0 && !a)
          return e == r || t < 0 ? s : s + l;
        s += l;
      }
      r = u;
    }
    if (e > r)
      throw new RangeError(`Position ${e} is out of range for changeset of length ${r}`);
    return s;
  }
  /**
  Check whether these changes touch a given range. When one of the
  changes entirely covers the range, the string `"cover"` is
  returned.
  */
  touchesRange(e, t = e) {
    for (let i = 0, r = 0; i < this.sections.length && r <= t; ) {
      let s = this.sections[i++], o = this.sections[i++], a = r + s;
      if (o >= 0 && r <= t && a >= e)
        return r < e && a > t ? "cover" : !0;
      r = a;
    }
    return !1;
  }
  /**
  @internal
  */
  toString() {
    let e = "";
    for (let t = 0; t < this.sections.length; ) {
      let i = this.sections[t++], r = this.sections[t++];
      e += (e ? " " : "") + i + (r >= 0 ? ":" + r : "");
    }
    return e;
  }
  /**
  Serialize this change desc to a JSON-representable value.
  */
  toJSON() {
    return this.sections;
  }
  /**
  Create a change desc from its JSON representation (as produced
  by [`toJSON`](https://codemirror.net/6/docs/ref/#state.ChangeDesc.toJSON).
  */
  static fromJSON(e) {
    if (!Array.isArray(e) || e.length % 2 || e.some((t) => typeof t != "number"))
      throw new RangeError("Invalid JSON representation of ChangeDesc");
    return new hn(e);
  }
  /**
  @internal
  */
  static create(e) {
    return new hn(e);
  }
}
class We extends hn {
  constructor(e, t) {
    super(e), this.inserted = t;
  }
  /**
  Apply the changes to a document, returning the modified
  document.
  */
  apply(e) {
    if (this.length != e.length)
      throw new RangeError("Applying change set to a document with the wrong length");
    return yu(this, (t, i, r, s, o) => e = e.replace(r, r + (i - t), o), !1), e;
  }
  mapDesc(e, t = !1) {
    return ku(this, e, t, !0);
  }
  /**
  Given the document as it existed _before_ the changes, return a
  change set that represents the inverse of this set, which could
  be used to go from the document created by the changes back to
  the document as it existed before the changes.
  */
  invert(e) {
    let t = this.sections.slice(), i = [];
    for (let r = 0, s = 0; r < t.length; r += 2) {
      let o = t[r], a = t[r + 1];
      if (a >= 0) {
        t[r] = a, t[r + 1] = o;
        let l = r >> 1;
        for (; i.length < l; )
          i.push(me.empty);
        i.push(o ? e.slice(s, s + o) : me.empty);
      }
      s += o;
    }
    return new We(t, i);
  }
  /**
  Combine two subsequent change sets into a single set. `other`
  must start in the document produced by `this`. If `this` goes
  `docA` → `docB` and `other` represents `docB` → `docC`, the
  returned value will represent the change `docA` → `docC`.
  */
  compose(e) {
    return this.empty ? e : e.empty ? this : Pg(this, e, !0);
  }
  /**
  Given another change set starting in the same document, maps this
  change set over the other, producing a new change set that can be
  applied to the document produced by applying `other`. When
  `before` is `true`, order changes as if `this` comes before
  `other`, otherwise (the default) treat `other` as coming first.
  
  Given two changes `A` and `B`, `A.compose(B.map(A))` and
  `B.compose(A.map(B, true))` will produce the same document. This
  provides a basic form of [operational
  transformation](https://en.wikipedia.org/wiki/Operational_transformation),
  and can be used for collaborative editing.
  */
  map(e, t = !1) {
    return e.empty ? this : ku(this, e, t, !0);
  }
  /**
  Iterate over the changed ranges in the document, calling `f` for
  each, with the range in the original document (`fromA`-`toA`)
  and the range that replaces it in the new document
  (`fromB`-`toB`).
  
  When `individual` is true, adjacent changes are reported
  separately.
  */
  iterChanges(e, t = !1) {
    yu(this, e, t);
  }
  /**
  Get a [change description](https://codemirror.net/6/docs/ref/#state.ChangeDesc) for this change
  set.
  */
  get desc() {
    return hn.create(this.sections);
  }
  /**
  @internal
  */
  filter(e) {
    let t = [], i = [], r = [], s = new is(this);
    e:
      for (let o = 0, a = 0; ; ) {
        let l = o == e.length ? 1e9 : e[o++];
        for (; a < l || a == l && s.len == 0; ) {
          if (s.done)
            break e;
          let c = Math.min(s.len, l - a);
          et(r, c, -1);
          let h = s.ins == -1 ? -1 : s.off == 0 ? s.ins : 0;
          et(t, c, h), h > 0 && qn(i, t, s.text), s.forward(c), a += c;
        }
        let u = e[o++];
        for (; a < u; ) {
          if (s.done)
            break e;
          let c = Math.min(s.len, u - a);
          et(t, c, -1), et(r, c, s.ins == -1 ? -1 : s.off == 0 ? s.ins : 0), s.forward(c), a += c;
        }
      }
    return {
      changes: new We(t, i),
      filtered: hn.create(r)
    };
  }
  /**
  Serialize this change set to a JSON-representable value.
  */
  toJSON() {
    let e = [];
    for (let t = 0; t < this.sections.length; t += 2) {
      let i = this.sections[t], r = this.sections[t + 1];
      r < 0 ? e.push(i) : r == 0 ? e.push([i]) : e.push([i].concat(this.inserted[t >> 1].toJSON()));
    }
    return e;
  }
  /**
  Create a change set for the given changes, for a document of the
  given length, using `lineSep` as line separator.
  */
  static of(e, t, i) {
    let r = [], s = [], o = 0, a = null;
    function l(c = !1) {
      if (!c && !r.length)
        return;
      o < t && et(r, t - o, -1);
      let h = new We(r, s);
      a = a ? a.compose(h.map(a)) : h, r = [], s = [], o = 0;
    }
    function u(c) {
      if (Array.isArray(c))
        for (let h of c)
          u(h);
      else if (c instanceof We) {
        if (c.length != t)
          throw new RangeError(`Mismatched change set length (got ${c.length}, expected ${t})`);
        l(), a = a ? a.compose(c.map(a)) : c;
      } else {
        let { from: h, to: f = h, insert: d } = c;
        if (h > f || h < 0 || f > t)
          throw new RangeError(`Invalid change range ${h} to ${f} (in doc of length ${t})`);
        let p = d ? typeof d == "string" ? me.of(d.split(i || bu)) : d : me.empty, g = p.length;
        if (h == f && g == 0)
          return;
        h < o && l(), h > o && et(r, h - o, -1), et(r, f - h, g), qn(s, r, p), o = f;
      }
    }
    return u(e), l(!a), a;
  }
  /**
  Create an empty changeset of the given length.
  */
  static empty(e) {
    return new We(e ? [e, -1] : [], []);
  }
  /**
  Create a changeset from its JSON representation (as produced by
  [`toJSON`](https://codemirror.net/6/docs/ref/#state.ChangeSet.toJSON).
  */
  static fromJSON(e) {
    if (!Array.isArray(e))
      throw new RangeError("Invalid JSON representation of ChangeSet");
    let t = [], i = [];
    for (let r = 0; r < e.length; r++) {
      let s = e[r];
      if (typeof s == "number")
        t.push(s, -1);
      else {
        if (!Array.isArray(s) || typeof s[0] != "number" || s.some((o, a) => a && typeof o != "string"))
          throw new RangeError("Invalid JSON representation of ChangeSet");
        if (s.length == 1)
          t.push(s[0], 0);
        else {
          for (; i.length < r; )
            i.push(me.empty);
          i[r] = me.of(s.slice(1)), t.push(s[0], i[r].length);
        }
      }
    }
    return new We(t, i);
  }
  /**
  @internal
  */
  static createSet(e, t) {
    return new We(e, t);
  }
}
function et(n, e, t, i = !1) {
  if (e == 0 && t <= 0)
    return;
  let r = n.length - 2;
  r >= 0 && t <= 0 && t == n[r + 1] ? n[r] += e : e == 0 && n[r] == 0 ? n[r + 1] += t : i ? (n[r] += e, n[r + 1] += t) : n.push(e, t);
}
function qn(n, e, t) {
  if (t.length == 0)
    return;
  let i = e.length - 2 >> 1;
  if (i < n.length)
    n[n.length - 1] = n[n.length - 1].append(t);
  else {
    for (; n.length < i; )
      n.push(me.empty);
    n.push(t);
  }
}
function yu(n, e, t) {
  let i = n.inserted;
  for (let r = 0, s = 0, o = 0; o < n.sections.length; ) {
    let a = n.sections[o++], l = n.sections[o++];
    if (l < 0)
      r += a, s += a;
    else {
      let u = r, c = s, h = me.empty;
      for (; u += a, c += l, l && i && (h = h.append(i[o - 2 >> 1])), !(t || o == n.sections.length || n.sections[o + 1] < 0); )
        a = n.sections[o++], l = n.sections[o++];
      e(r, u, s, c, h), r = u, s = c;
    }
  }
}
function ku(n, e, t, i = !1) {
  let r = [], s = i ? [] : null, o = new is(n), a = new is(e);
  for (let l = -1; ; )
    if (o.ins == -1 && a.ins == -1) {
      let u = Math.min(o.len, a.len);
      et(r, u, -1), o.forward(u), a.forward(u);
    } else if (a.ins >= 0 && (o.ins < 0 || l == o.i || o.off == 0 && (a.len < o.len || a.len == o.len && !t))) {
      let u = a.len;
      for (et(r, a.ins, -1); u; ) {
        let c = Math.min(o.len, u);
        o.ins >= 0 && l < o.i && o.len <= c && (et(r, 0, o.ins), s && qn(s, r, o.text), l = o.i), o.forward(c), u -= c;
      }
      a.next();
    } else if (o.ins >= 0) {
      let u = 0, c = o.len;
      for (; c; )
        if (a.ins == -1) {
          let h = Math.min(c, a.len);
          u += h, c -= h, a.forward(h);
        } else if (a.ins == 0 && a.len < c)
          c -= a.len, a.next();
        else
          break;
      et(r, u, l < o.i ? o.ins : 0), s && l < o.i && qn(s, r, o.text), l = o.i, o.forward(o.len - c);
    } else {
      if (o.done && a.done)
        return s ? We.createSet(r, s) : hn.create(r);
      throw new Error("Mismatched change set lengths");
    }
}
function Pg(n, e, t = !1) {
  let i = [], r = t ? [] : null, s = new is(n), o = new is(e);
  for (let a = !1; ; ) {
    if (s.done && o.done)
      return r ? We.createSet(i, r) : hn.create(i);
    if (s.ins == 0)
      et(i, s.len, 0, a), s.next();
    else if (o.len == 0 && !o.done)
      et(i, 0, o.ins, a), r && qn(r, i, o.text), o.next();
    else {
      if (s.done || o.done)
        throw new Error("Mismatched change set lengths");
      {
        let l = Math.min(s.len2, o.len), u = i.length;
        if (s.ins == -1) {
          let c = o.ins == -1 ? -1 : o.off ? 0 : o.ins;
          et(i, l, c, a), r && c && qn(r, i, o.text);
        } else
          o.ins == -1 ? (et(i, s.off ? 0 : s.len, l, a), r && qn(r, i, s.textBit(l))) : (et(i, s.off ? 0 : s.len, o.off ? 0 : o.ins, a), r && !o.off && qn(r, i, o.text));
        a = (s.ins > l || o.ins >= 0 && o.len > l) && (a || i.length > u), s.forward2(l), o.forward(l);
      }
    }
  }
}
class is {
  constructor(e) {
    this.set = e, this.i = 0, this.next();
  }
  next() {
    let { sections: e } = this.set;
    this.i < e.length ? (this.len = e[this.i++], this.ins = e[this.i++]) : (this.len = 0, this.ins = -2), this.off = 0;
  }
  get done() {
    return this.ins == -2;
  }
  get len2() {
    return this.ins < 0 ? this.len : this.ins;
  }
  get text() {
    let { inserted: e } = this.set, t = this.i - 2 >> 1;
    return t >= e.length ? me.empty : e[t];
  }
  textBit(e) {
    let { inserted: t } = this.set, i = this.i - 2 >> 1;
    return i >= t.length && !e ? me.empty : t[i].slice(this.off, e == null ? void 0 : this.off + e);
  }
  forward(e) {
    e == this.len ? this.next() : (this.len -= e, this.off += e);
  }
  forward2(e) {
    this.ins == -1 ? this.forward(e) : e == this.ins ? this.next() : (this.ins -= e, this.off += e);
  }
}
class mi {
  constructor(e, t, i) {
    this.from = e, this.to = t, this.flags = i;
  }
  /**
  The anchor of the range—the side that doesn't move when you
  extend it.
  */
  get anchor() {
    return this.flags & 32 ? this.to : this.from;
  }
  /**
  The head of the range, which is moved when the range is
  [extended](https://codemirror.net/6/docs/ref/#state.SelectionRange.extend).
  */
  get head() {
    return this.flags & 32 ? this.from : this.to;
  }
  /**
  True when `anchor` and `head` are at the same position.
  */
  get empty() {
    return this.from == this.to;
  }
  /**
  If this is a cursor that is explicitly associated with the
  character on one of its sides, this returns the side. -1 means
  the character before its position, 1 the character after, and 0
  means no association.
  */
  get assoc() {
    return this.flags & 8 ? -1 : this.flags & 16 ? 1 : 0;
  }
  /**
  The bidirectional text level associated with this cursor, if
  any.
  */
  get bidiLevel() {
    let e = this.flags & 7;
    return e == 7 ? null : e;
  }
  /**
  The goal column (stored vertical offset) associated with a
  cursor. This is used to preserve the vertical position when
  [moving](https://codemirror.net/6/docs/ref/#view.EditorView.moveVertically) across
  lines of different length.
  */
  get goalColumn() {
    let e = this.flags >> 6;
    return e == 16777215 ? void 0 : e;
  }
  /**
  Map this range through a change, producing a valid range in the
  updated document.
  */
  map(e, t = -1) {
    let i, r;
    return this.empty ? i = r = e.mapPos(this.from, t) : (i = e.mapPos(this.from, 1), r = e.mapPos(this.to, -1)), i == this.from && r == this.to ? this : new mi(i, r, this.flags);
  }
  /**
  Extend this range to cover at least `from` to `to`.
  */
  extend(e, t = e) {
    if (e <= this.anchor && t >= this.anchor)
      return $.range(e, t);
    let i = Math.abs(e - this.anchor) > Math.abs(t - this.anchor) ? e : t;
    return $.range(this.anchor, i);
  }
  /**
  Compare this range to another range.
  */
  eq(e, t = !1) {
    return this.anchor == e.anchor && this.head == e.head && (!t || !this.empty || this.assoc == e.assoc);
  }
  /**
  Return a JSON-serializable object representing the range.
  */
  toJSON() {
    return { anchor: this.anchor, head: this.head };
  }
  /**
  Convert a JSON representation of a range to a `SelectionRange`
  instance.
  */
  static fromJSON(e) {
    if (!e || typeof e.anchor != "number" || typeof e.head != "number")
      throw new RangeError("Invalid JSON representation for SelectionRange");
    return $.range(e.anchor, e.head);
  }
  /**
  @internal
  */
  static create(e, t, i) {
    return new mi(e, t, i);
  }
}
class $ {
  constructor(e, t) {
    this.ranges = e, this.mainIndex = t;
  }
  /**
  Map a selection through a change. Used to adjust the selection
  position for changes.
  */
  map(e, t = -1) {
    return e.empty ? this : $.create(this.ranges.map((i) => i.map(e, t)), this.mainIndex);
  }
  /**
  Compare this selection to another selection. By default, ranges
  are compared only by position. When `includeAssoc` is true,
  cursor ranges must also have the same
  [`assoc`](https://codemirror.net/6/docs/ref/#state.SelectionRange.assoc) value.
  */
  eq(e, t = !1) {
    if (this.ranges.length != e.ranges.length || this.mainIndex != e.mainIndex)
      return !1;
    for (let i = 0; i < this.ranges.length; i++)
      if (!this.ranges[i].eq(e.ranges[i], t))
        return !1;
    return !0;
  }
  /**
  Get the primary selection range. Usually, you should make sure
  your code applies to _all_ ranges, by using methods like
  [`changeByRange`](https://codemirror.net/6/docs/ref/#state.EditorState.changeByRange).
  */
  get main() {
    return this.ranges[this.mainIndex];
  }
  /**
  Make sure the selection only has one range. Returns a selection
  holding only the main range from this selection.
  */
  asSingle() {
    return this.ranges.length == 1 ? this : new $([this.main], 0);
  }
  /**
  Extend this selection with an extra range.
  */
  addRange(e, t = !0) {
    return $.create([e].concat(this.ranges), t ? 0 : this.mainIndex + 1);
  }
  /**
  Replace a given range with another range, and then normalize the
  selection to merge and sort ranges if necessary.
  */
  replaceRange(e, t = this.mainIndex) {
    let i = this.ranges.slice();
    return i[t] = e, $.create(i, this.mainIndex);
  }
  /**
  Convert this selection to an object that can be serialized to
  JSON.
  */
  toJSON() {
    return { ranges: this.ranges.map((e) => e.toJSON()), main: this.mainIndex };
  }
  /**
  Create a selection from a JSON representation.
  */
  static fromJSON(e) {
    if (!e || !Array.isArray(e.ranges) || typeof e.main != "number" || e.main >= e.ranges.length)
      throw new RangeError("Invalid JSON representation for EditorSelection");
    return new $(e.ranges.map((t) => mi.fromJSON(t)), e.main);
  }
  /**
  Create a selection holding a single range.
  */
  static single(e, t = e) {
    return new $([$.range(e, t)], 0);
  }
  /**
  Sort and merge the given set of ranges, creating a valid
  selection.
  */
  static create(e, t = 0) {
    if (e.length == 0)
      throw new RangeError("A selection needs at least one range");
    for (let i = 0, r = 0; r < e.length; r++) {
      let s = e[r];
      if (s.empty ? s.from <= i : s.from < i)
        return $.normalized(e.slice(), t);
      i = s.to;
    }
    return new $(e, t);
  }
  /**
  Create a cursor selection range at the given position. You can
  safely ignore the optional arguments in most situations.
  */
  static cursor(e, t = 0, i, r) {
    return mi.create(e, e, (t == 0 ? 0 : t < 0 ? 8 : 16) | (i == null ? 7 : Math.min(6, i)) | (r ?? 16777215) << 6);
  }
  /**
  Create a selection range.
  */
  static range(e, t, i, r) {
    let s = (i ?? 16777215) << 6 | (r == null ? 7 : Math.min(6, r));
    return t < e ? mi.create(t, e, 48 | s) : mi.create(e, t, (t > e ? 8 : 0) | s);
  }
  /**
  @internal
  */
  static normalized(e, t = 0) {
    let i = e[t];
    e.sort((r, s) => r.from - s.from), t = e.indexOf(i);
    for (let r = 1; r < e.length; r++) {
      let s = e[r], o = e[r - 1];
      if (s.empty ? s.from <= o.to : s.from < o.to) {
        let a = o.from, l = Math.max(s.to, o.to);
        r <= t && t--, e.splice(--r, 2, s.anchor > s.head ? $.range(l, a) : $.range(a, l));
      }
    }
    return new $(e, t);
  }
}
function Qg(n, e) {
  for (let t of n.ranges)
    if (t.to > e)
      throw new RangeError("Selection points outside of document");
}
let Jc = 0;
class N {
  constructor(e, t, i, r, s) {
    this.combine = e, this.compareInput = t, this.compare = i, this.isStatic = r, this.id = Jc++, this.default = e([]), this.extensions = typeof s == "function" ? s(this) : s;
  }
  /**
  Returns a facet reader for this facet, which can be used to
  [read](https://codemirror.net/6/docs/ref/#state.EditorState.facet) it but not to define values for it.
  */
  get reader() {
    return this;
  }
  /**
  Define a new facet.
  */
  static define(e = {}) {
    return new N(e.combine || ((t) => t), e.compareInput || ((t, i) => t === i), e.compare || (e.combine ? (t, i) => t === i : eh), !!e.static, e.enables);
  }
  /**
  Returns an extension that adds the given value to this facet.
  */
  of(e) {
    return new Lo([], this, 0, e);
  }
  /**
  Create an extension that computes a value for the facet from a
  state. You must take care to declare the parts of the state that
  this value depends on, since your function is only called again
  for a new state when one of those parts changed.
  
  In cases where your value depends only on a single field, you'll
  want to use the [`from`](https://codemirror.net/6/docs/ref/#state.Facet.from) method instead.
  */
  compute(e, t) {
    if (this.isStatic)
      throw new Error("Can't compute a static facet");
    return new Lo(e, this, 1, t);
  }
  /**
  Create an extension that computes zero or more values for this
  facet from a state.
  */
  computeN(e, t) {
    if (this.isStatic)
      throw new Error("Can't compute a static facet");
    return new Lo(e, this, 2, t);
  }
  from(e, t) {
    return t || (t = (i) => i), this.compute([e], (i) => t(i.field(e)));
  }
}
function eh(n, e) {
  return n == e || n.length == e.length && n.every((t, i) => t === e[i]);
}
class Lo {
  constructor(e, t, i, r) {
    this.dependencies = e, this.facet = t, this.type = i, this.value = r, this.id = Jc++;
  }
  dynamicSlot(e) {
    var t;
    let i = this.value, r = this.facet.compareInput, s = this.id, o = e[s] >> 1, a = this.type == 2, l = !1, u = !1, c = [];
    for (let h of this.dependencies)
      h == "doc" ? l = !0 : h == "selection" ? u = !0 : ((t = e[h.id]) !== null && t !== void 0 ? t : 1) & 1 || c.push(e[h.id]);
    return {
      create(h) {
        return h.values[o] = i(h), 1;
      },
      update(h, f) {
        if (l && f.docChanged || u && (f.docChanged || f.selection) || xu(h, c)) {
          let d = i(h);
          if (a ? !Cf(d, h.values[o], r) : !r(d, h.values[o]))
            return h.values[o] = d, 1;
        }
        return 0;
      },
      reconfigure: (h, f) => {
        let d, p = f.config.address[s];
        if (p != null) {
          let g = na(f, p);
          if (this.dependencies.every((O) => O instanceof N ? f.facet(O) === h.facet(O) : O instanceof Ye ? f.field(O, !1) == h.field(O, !1) : !0) || (a ? Cf(d = i(h), g, r) : r(d = i(h), g)))
            return h.values[o] = g, 0;
        } else
          d = i(h);
        return h.values[o] = d, 1;
      }
    };
  }
}
function Cf(n, e, t) {
  if (n.length != e.length)
    return !1;
  for (let i = 0; i < n.length; i++)
    if (!t(n[i], e[i]))
      return !1;
  return !0;
}
function xu(n, e) {
  let t = !1;
  for (let i of e)
    Yr(n, i) & 1 && (t = !0);
  return t;
}
function Ik(n, e, t) {
  let i = t.map((l) => n[l.id]), r = t.map((l) => l.type), s = i.filter((l) => !(l & 1)), o = n[e.id] >> 1;
  function a(l) {
    let u = [];
    for (let c = 0; c < i.length; c++) {
      let h = na(l, i[c]);
      if (r[c] == 2)
        for (let f of h)
          u.push(f);
      else
        u.push(h);
    }
    return e.combine(u);
  }
  return {
    create(l) {
      for (let u of i)
        Yr(l, u);
      return l.values[o] = a(l), 1;
    },
    update(l, u) {
      if (!xu(l, s))
        return 0;
      let c = a(l);
      return e.compare(c, l.values[o]) ? 0 : (l.values[o] = c, 1);
    },
    reconfigure(l, u) {
      let c = xu(l, i), h = u.config.facets[e.id], f = u.facet(e);
      if (h && !c && eh(t, h))
        return l.values[o] = f, 0;
      let d = a(l);
      return e.compare(d, f) ? (l.values[o] = f, 0) : (l.values[o] = d, 1);
    }
  };
}
const Tf = /* @__PURE__ */ N.define({ static: !0 });
class Ye {
  constructor(e, t, i, r, s) {
    this.id = e, this.createF = t, this.updateF = i, this.compareF = r, this.spec = s, this.provides = void 0;
  }
  /**
  Define a state field.
  */
  static define(e) {
    let t = new Ye(Jc++, e.create, e.update, e.compare || ((i, r) => i === r), e);
    return e.provide && (t.provides = e.provide(t)), t;
  }
  create(e) {
    let t = e.facet(Tf).find((i) => i.field == this);
    return ((t == null ? void 0 : t.create) || this.createF)(e);
  }
  /**
  @internal
  */
  slot(e) {
    let t = e[this.id] >> 1;
    return {
      create: (i) => (i.values[t] = this.create(i), 1),
      update: (i, r) => {
        let s = i.values[t], o = this.updateF(s, r);
        return this.compareF(s, o) ? 0 : (i.values[t] = o, 1);
      },
      reconfigure: (i, r) => r.config.address[this.id] != null ? (i.values[t] = r.field(this), 0) : (i.values[t] = this.create(i), 1)
    };
  }
  /**
  Returns an extension that enables this field and overrides the
  way it is initialized. Can be useful when you need to provide a
  non-default starting value for the field.
  */
  init(e) {
    return [this, Tf.of({ field: this, create: e })];
  }
  /**
  State field instances can be used as
  [`Extension`](https://codemirror.net/6/docs/ref/#state.Extension) values to enable the field in a
  given state.
  */
  get extension() {
    return this;
  }
}
const ci = { lowest: 4, low: 3, default: 2, high: 1, highest: 0 };
function Qr(n) {
  return (e) => new $g(e, n);
}
const Mn = {
  /**
  The highest precedence level, for extensions that should end up
  near the start of the precedence ordering.
  */
  highest: /* @__PURE__ */ Qr(ci.highest),
  /**
  A higher-than-default precedence, for extensions that should
  come before those with default precedence.
  */
  high: /* @__PURE__ */ Qr(ci.high),
  /**
  The default precedence, which is also used for extensions
  without an explicit precedence.
  */
  default: /* @__PURE__ */ Qr(ci.default),
  /**
  A lower-than-default precedence.
  */
  low: /* @__PURE__ */ Qr(ci.low),
  /**
  The lowest precedence level. Meant for things that should end up
  near the end of the extension order.
  */
  lowest: /* @__PURE__ */ Qr(ci.lowest)
};
class $g {
  constructor(e, t) {
    this.inner = e, this.prec = t;
  }
}
class Rs {
  /**
  Create an instance of this compartment to add to your [state
  configuration](https://codemirror.net/6/docs/ref/#state.EditorStateConfig.extensions).
  */
  of(e) {
    return new wu(this, e);
  }
  /**
  Create an [effect](https://codemirror.net/6/docs/ref/#state.TransactionSpec.effects) that
  reconfigures this compartment.
  */
  reconfigure(e) {
    return Rs.reconfigure.of({ compartment: this, extension: e });
  }
  /**
  Get the current content of the compartment in the state, or
  `undefined` if it isn't present.
  */
  get(e) {
    return e.config.compartments.get(this);
  }
}
class wu {
  constructor(e, t) {
    this.compartment = e, this.inner = t;
  }
}
class ta {
  constructor(e, t, i, r, s, o) {
    for (this.base = e, this.compartments = t, this.dynamicSlots = i, this.address = r, this.staticValues = s, this.facets = o, this.statusTemplate = []; this.statusTemplate.length < i.length; )
      this.statusTemplate.push(
        0
        /* SlotStatus.Unresolved */
      );
  }
  staticFacet(e) {
    let t = this.address[e.id];
    return t == null ? e.default : this.staticValues[t >> 1];
  }
  static resolve(e, t, i) {
    let r = [], s = /* @__PURE__ */ Object.create(null), o = /* @__PURE__ */ new Map();
    for (let f of Lk(e, t, o))
      f instanceof Ye ? r.push(f) : (s[f.facet.id] || (s[f.facet.id] = [])).push(f);
    let a = /* @__PURE__ */ Object.create(null), l = [], u = [];
    for (let f of r)
      a[f.id] = u.length << 1, u.push((d) => f.slot(d));
    let c = i == null ? void 0 : i.config.facets;
    for (let f in s) {
      let d = s[f], p = d[0].facet, g = c && c[f] || [];
      if (d.every(
        (O) => O.type == 0
        /* Provider.Static */
      ))
        if (a[p.id] = l.length << 1 | 1, eh(g, d))
          l.push(i.facet(p));
        else {
          let O = p.combine(d.map((m) => m.value));
          l.push(i && p.compare(O, i.facet(p)) ? i.facet(p) : O);
        }
      else {
        for (let O of d)
          O.type == 0 ? (a[O.id] = l.length << 1 | 1, l.push(O.value)) : (a[O.id] = u.length << 1, u.push((m) => O.dynamicSlot(m)));
        a[p.id] = u.length << 1, u.push((O) => Ik(O, p, d));
      }
    }
    let h = u.map((f) => f(a));
    return new ta(e, o, h, a, l, s);
  }
}
function Lk(n, e, t) {
  let i = [[], [], [], [], []], r = /* @__PURE__ */ new Map();
  function s(o, a) {
    let l = r.get(o);
    if (l != null) {
      if (l <= a)
        return;
      let u = i[l].indexOf(o);
      u > -1 && i[l].splice(u, 1), o instanceof wu && t.delete(o.compartment);
    }
    if (r.set(o, a), Array.isArray(o))
      for (let u of o)
        s(u, a);
    else if (o instanceof wu) {
      if (t.has(o.compartment))
        throw new RangeError("Duplicate use of compartment in extensions");
      let u = e.get(o.compartment) || o.inner;
      t.set(o.compartment, u), s(u, a);
    } else if (o instanceof $g)
      s(o.inner, o.prec);
    else if (o instanceof Ye)
      i[a].push(o), o.provides && s(o.provides, a);
    else if (o instanceof Lo)
      i[a].push(o), o.facet.extensions && s(o.facet.extensions, ci.default);
    else {
      let u = o.extension;
      if (!u)
        throw new Error(`Unrecognized extension value in extension set (${o}). This sometimes happens because multiple instances of @codemirror/state are loaded, breaking instanceof checks.`);
      s(u, a);
    }
  }
  return s(n, ci.default), i.reduce((o, a) => o.concat(a));
}
function Yr(n, e) {
  if (e & 1)
    return 2;
  let t = e >> 1, i = n.status[t];
  if (i == 4)
    throw new Error("Cyclic dependency between fields and/or facets");
  if (i & 2)
    return i;
  n.status[t] = 4;
  let r = n.computeSlot(n, n.config.dynamicSlots[t]);
  return n.status[t] = 2 | r;
}
function na(n, e) {
  return e & 1 ? n.config.staticValues[e >> 1] : n.values[e >> 1];
}
const Cg = /* @__PURE__ */ N.define(), Su = /* @__PURE__ */ N.define({
  combine: (n) => n.some((e) => e),
  static: !0
}), Tg = /* @__PURE__ */ N.define({
  combine: (n) => n.length ? n[0] : void 0,
  static: !0
}), Ag = /* @__PURE__ */ N.define(), Rg = /* @__PURE__ */ N.define(), Mg = /* @__PURE__ */ N.define(), Zg = /* @__PURE__ */ N.define({
  combine: (n) => n.length ? n[0] : !1
});
class Zn {
  /**
  @internal
  */
  constructor(e, t) {
    this.type = e, this.value = t;
  }
  /**
  Define a new type of annotation.
  */
  static define() {
    return new _k();
  }
}
class _k {
  /**
  Create an instance of this annotation.
  */
  of(e) {
    return new Zn(this, e);
  }
}
class Xk {
  /**
  @internal
  */
  constructor(e) {
    this.map = e;
  }
  /**
  Create a [state effect](https://codemirror.net/6/docs/ref/#state.StateEffect) instance of this
  type.
  */
  of(e) {
    return new te(this, e);
  }
}
class te {
  /**
  @internal
  */
  constructor(e, t) {
    this.type = e, this.value = t;
  }
  /**
  Map this effect through a position mapping. Will return
  `undefined` when that ends up deleting the effect.
  */
  map(e) {
    let t = this.type.map(this.value, e);
    return t === void 0 ? void 0 : t == this.value ? this : new te(this.type, t);
  }
  /**
  Tells you whether this effect object is of a given
  [type](https://codemirror.net/6/docs/ref/#state.StateEffectType).
  */
  is(e) {
    return this.type == e;
  }
  /**
  Define a new effect type. The type parameter indicates the type
  of values that his effect holds. It should be a type that
  doesn't include `undefined`, since that is used in
  [mapping](https://codemirror.net/6/docs/ref/#state.StateEffect.map) to indicate that an effect is
  removed.
  */
  static define(e = {}) {
    return new Xk(e.map || ((t) => t));
  }
  /**
  Map an array of effects through a change set.
  */
  static mapEffects(e, t) {
    if (!e.length)
      return e;
    let i = [];
    for (let r of e) {
      let s = r.map(t);
      s && i.push(s);
    }
    return i;
  }
}
te.reconfigure = /* @__PURE__ */ te.define();
te.appendConfig = /* @__PURE__ */ te.define();
class _e {
  constructor(e, t, i, r, s, o) {
    this.startState = e, this.changes = t, this.selection = i, this.effects = r, this.annotations = s, this.scrollIntoView = o, this._doc = null, this._state = null, i && Qg(i, t.newLength), s.some((a) => a.type == _e.time) || (this.annotations = s.concat(_e.time.of(Date.now())));
  }
  /**
  @internal
  */
  static create(e, t, i, r, s, o) {
    return new _e(e, t, i, r, s, o);
  }
  /**
  The new document produced by the transaction. Contrary to
  [`.state`](https://codemirror.net/6/docs/ref/#state.Transaction.state)`.doc`, accessing this won't
  force the entire new state to be computed right away, so it is
  recommended that [transaction
  filters](https://codemirror.net/6/docs/ref/#state.EditorState^transactionFilter) use this getter
  when they need to look at the new document.
  */
  get newDoc() {
    return this._doc || (this._doc = this.changes.apply(this.startState.doc));
  }
  /**
  The new selection produced by the transaction. If
  [`this.selection`](https://codemirror.net/6/docs/ref/#state.Transaction.selection) is undefined,
  this will [map](https://codemirror.net/6/docs/ref/#state.EditorSelection.map) the start state's
  current selection through the changes made by the transaction.
  */
  get newSelection() {
    return this.selection || this.startState.selection.map(this.changes);
  }
  /**
  The new state created by the transaction. Computed on demand
  (but retained for subsequent access), so it is recommended not to
  access it in [transaction
  filters](https://codemirror.net/6/docs/ref/#state.EditorState^transactionFilter) when possible.
  */
  get state() {
    return this._state || this.startState.applyTransaction(this), this._state;
  }
  /**
  Get the value of the given annotation type, if any.
  */
  annotation(e) {
    for (let t of this.annotations)
      if (t.type == e)
        return t.value;
  }
  /**
  Indicates whether the transaction changed the document.
  */
  get docChanged() {
    return !this.changes.empty;
  }
  /**
  Indicates whether this transaction reconfigures the state
  (through a [configuration compartment](https://codemirror.net/6/docs/ref/#state.Compartment) or
  with a top-level configuration
  [effect](https://codemirror.net/6/docs/ref/#state.StateEffect^reconfigure).
  */
  get reconfigured() {
    return this.startState.config != this.state.config;
  }
  /**
  Returns true if the transaction has a [user
  event](https://codemirror.net/6/docs/ref/#state.Transaction^userEvent) annotation that is equal to
  or more specific than `event`. For example, if the transaction
  has `"select.pointer"` as user event, `"select"` and
  `"select.pointer"` will match it.
  */
  isUserEvent(e) {
    let t = this.annotation(_e.userEvent);
    return !!(t && (t == e || t.length > e.length && t.slice(0, e.length) == e && t[e.length] == "."));
  }
}
_e.time = /* @__PURE__ */ Zn.define();
_e.userEvent = /* @__PURE__ */ Zn.define();
_e.addToHistory = /* @__PURE__ */ Zn.define();
_e.remote = /* @__PURE__ */ Zn.define();
function Nk(n, e) {
  let t = [];
  for (let i = 0, r = 0; ; ) {
    let s, o;
    if (i < n.length && (r == e.length || e[r] >= n[i]))
      s = n[i++], o = n[i++];
    else if (r < e.length)
      s = e[r++], o = e[r++];
    else
      return t;
    !t.length || t[t.length - 1] < s ? t.push(s, o) : t[t.length - 1] < o && (t[t.length - 1] = o);
  }
}
function Eg(n, e, t) {
  var i;
  let r, s, o;
  return t ? (r = e.changes, s = We.empty(e.changes.length), o = n.changes.compose(e.changes)) : (r = e.changes.map(n.changes), s = n.changes.mapDesc(e.changes, !0), o = n.changes.compose(r)), {
    changes: o,
    selection: e.selection ? e.selection.map(s) : (i = n.selection) === null || i === void 0 ? void 0 : i.map(r),
    effects: te.mapEffects(n.effects, r).concat(te.mapEffects(e.effects, s)),
    annotations: n.annotations.length ? n.annotations.concat(e.annotations) : e.annotations,
    scrollIntoView: n.scrollIntoView || e.scrollIntoView
  };
}
function vu(n, e, t) {
  let i = e.selection, r = Vi(e.annotations);
  return e.userEvent && (r = r.concat(_e.userEvent.of(e.userEvent))), {
    changes: e.changes instanceof We ? e.changes : We.of(e.changes || [], t, n.facet(Tg)),
    selection: i && (i instanceof $ ? i : $.single(i.anchor, i.head)),
    effects: Vi(e.effects),
    annotations: r,
    scrollIntoView: !!e.scrollIntoView
  };
}
function zg(n, e, t) {
  let i = vu(n, e.length ? e[0] : {}, n.doc.length);
  e.length && e[0].filter === !1 && (t = !1);
  for (let s = 1; s < e.length; s++) {
    e[s].filter === !1 && (t = !1);
    let o = !!e[s].sequential;
    i = Eg(i, vu(n, e[s], o ? i.changes.newLength : n.doc.length), o);
  }
  let r = _e.create(n, i.changes, i.selection, i.effects, i.annotations, i.scrollIntoView);
  return qk(t ? Wk(r) : r);
}
function Wk(n) {
  let e = n.startState, t = !0;
  for (let r of e.facet(Ag)) {
    let s = r(n);
    if (s === !1) {
      t = !1;
      break;
    }
    Array.isArray(s) && (t = t === !0 ? s : Nk(t, s));
  }
  if (t !== !0) {
    let r, s;
    if (t === !1)
      s = n.changes.invertedDesc, r = We.empty(e.doc.length);
    else {
      let o = n.changes.filter(t);
      r = o.changes, s = o.filtered.mapDesc(o.changes).invertedDesc;
    }
    n = _e.create(e, r, n.selection && n.selection.map(s), te.mapEffects(n.effects, s), n.annotations, n.scrollIntoView);
  }
  let i = e.facet(Rg);
  for (let r = i.length - 1; r >= 0; r--) {
    let s = i[r](n);
    s instanceof _e ? n = s : Array.isArray(s) && s.length == 1 && s[0] instanceof _e ? n = s[0] : n = zg(e, Vi(s), !1);
  }
  return n;
}
function qk(n) {
  let e = n.startState, t = e.facet(Mg), i = n;
  for (let r = t.length - 1; r >= 0; r--) {
    let s = t[r](n);
    s && Object.keys(s).length && (i = Eg(i, vu(e, s, n.changes.newLength), !0));
  }
  return i == n ? n : _e.create(e, n.changes, n.selection, i.effects, i.annotations, i.scrollIntoView);
}
const Bk = [];
function Vi(n) {
  return n == null ? Bk : Array.isArray(n) ? n : [n];
}
var Ze = /* @__PURE__ */ function(n) {
  return n[n.Word = 0] = "Word", n[n.Space = 1] = "Space", n[n.Other = 2] = "Other", n;
}(Ze || (Ze = {}));
const Vk = /[\u00df\u0587\u0590-\u05f4\u0600-\u06ff\u3040-\u309f\u30a0-\u30ff\u3400-\u4db5\u4e00-\u9fcc\uac00-\ud7af]/;
let Pu;
try {
  Pu = /* @__PURE__ */ new RegExp("[\\p{Alphabetic}\\p{Number}_]", "u");
} catch {
}
function Yk(n) {
  if (Pu)
    return Pu.test(n);
  for (let e = 0; e < n.length; e++) {
    let t = n[e];
    if (/\w/.test(t) || t > "" && (t.toUpperCase() != t.toLowerCase() || Vk.test(t)))
      return !0;
  }
  return !1;
}
function jk(n) {
  return (e) => {
    if (!/\S/.test(e))
      return Ze.Space;
    if (Yk(e))
      return Ze.Word;
    for (let t = 0; t < n.length; t++)
      if (e.indexOf(n[t]) > -1)
        return Ze.Word;
    return Ze.Other;
  };
}
class se {
  constructor(e, t, i, r, s, o) {
    this.config = e, this.doc = t, this.selection = i, this.values = r, this.status = e.statusTemplate.slice(), this.computeSlot = s, o && (o._state = this);
    for (let a = 0; a < this.config.dynamicSlots.length; a++)
      Yr(this, a << 1);
    this.computeSlot = null;
  }
  field(e, t = !0) {
    let i = this.config.address[e.id];
    if (i == null) {
      if (t)
        throw new RangeError("Field is not present in this state");
      return;
    }
    return Yr(this, i), na(this, i);
  }
  /**
  Create a [transaction](https://codemirror.net/6/docs/ref/#state.Transaction) that updates this
  state. Any number of [transaction specs](https://codemirror.net/6/docs/ref/#state.TransactionSpec)
  can be passed. Unless
  [`sequential`](https://codemirror.net/6/docs/ref/#state.TransactionSpec.sequential) is set, the
  [changes](https://codemirror.net/6/docs/ref/#state.TransactionSpec.changes) (if any) of each spec
  are assumed to start in the _current_ document (not the document
  produced by previous specs), and its
  [selection](https://codemirror.net/6/docs/ref/#state.TransactionSpec.selection) and
  [effects](https://codemirror.net/6/docs/ref/#state.TransactionSpec.effects) are assumed to refer
  to the document created by its _own_ changes. The resulting
  transaction contains the combined effect of all the different
  specs. For [selection](https://codemirror.net/6/docs/ref/#state.TransactionSpec.selection), later
  specs take precedence over earlier ones.
  */
  update(...e) {
    return zg(this, e, !0);
  }
  /**
  @internal
  */
  applyTransaction(e) {
    let t = this.config, { base: i, compartments: r } = t;
    for (let a of e.effects)
      a.is(Rs.reconfigure) ? (t && (r = /* @__PURE__ */ new Map(), t.compartments.forEach((l, u) => r.set(u, l)), t = null), r.set(a.value.compartment, a.value.extension)) : a.is(te.reconfigure) ? (t = null, i = a.value) : a.is(te.appendConfig) && (t = null, i = Vi(i).concat(a.value));
    let s;
    t ? s = e.startState.values.slice() : (t = ta.resolve(i, r, this), s = new se(t, this.doc, this.selection, t.dynamicSlots.map(() => null), (l, u) => u.reconfigure(l, this), null).values);
    let o = e.startState.facet(Su) ? e.newSelection : e.newSelection.asSingle();
    new se(t, e.newDoc, o, s, (a, l) => l.update(a, e), e);
  }
  /**
  Create a [transaction spec](https://codemirror.net/6/docs/ref/#state.TransactionSpec) that
  replaces every selection range with the given content.
  */
  replaceSelection(e) {
    return typeof e == "string" && (e = this.toText(e)), this.changeByRange((t) => ({
      changes: { from: t.from, to: t.to, insert: e },
      range: $.cursor(t.from + e.length)
    }));
  }
  /**
  Create a set of changes and a new selection by running the given
  function for each range in the active selection. The function
  can return an optional set of changes (in the coordinate space
  of the start document), plus an updated range (in the coordinate
  space of the document produced by the call's own changes). This
  method will merge all the changes and ranges into a single
  changeset and selection, and return it as a [transaction
  spec](https://codemirror.net/6/docs/ref/#state.TransactionSpec), which can be passed to
  [`update`](https://codemirror.net/6/docs/ref/#state.EditorState.update).
  */
  changeByRange(e) {
    let t = this.selection, i = e(t.ranges[0]), r = this.changes(i.changes), s = [i.range], o = Vi(i.effects);
    for (let a = 1; a < t.ranges.length; a++) {
      let l = e(t.ranges[a]), u = this.changes(l.changes), c = u.map(r);
      for (let f = 0; f < a; f++)
        s[f] = s[f].map(c);
      let h = r.mapDesc(u, !0);
      s.push(l.range.map(h)), r = r.compose(c), o = te.mapEffects(o, c).concat(te.mapEffects(Vi(l.effects), h));
    }
    return {
      changes: r,
      selection: $.create(s, t.mainIndex),
      effects: o
    };
  }
  /**
  Create a [change set](https://codemirror.net/6/docs/ref/#state.ChangeSet) from the given change
  description, taking the state's document length and line
  separator into account.
  */
  changes(e = []) {
    return e instanceof We ? e : We.of(e, this.doc.length, this.facet(se.lineSeparator));
  }
  /**
  Using the state's [line
  separator](https://codemirror.net/6/docs/ref/#state.EditorState^lineSeparator), create a
  [`Text`](https://codemirror.net/6/docs/ref/#state.Text) instance from the given string.
  */
  toText(e) {
    return me.of(e.split(this.facet(se.lineSeparator) || bu));
  }
  /**
  Return the given range of the document as a string.
  */
  sliceDoc(e = 0, t = this.doc.length) {
    return this.doc.sliceString(e, t, this.lineBreak);
  }
  /**
  Get the value of a state [facet](https://codemirror.net/6/docs/ref/#state.Facet).
  */
  facet(e) {
    let t = this.config.address[e.id];
    return t == null ? e.default : (Yr(this, t), na(this, t));
  }
  /**
  Convert this state to a JSON-serializable object. When custom
  fields should be serialized, you can pass them in as an object
  mapping property names (in the resulting object, which should
  not use `doc` or `selection`) to fields.
  */
  toJSON(e) {
    let t = {
      doc: this.sliceDoc(),
      selection: this.selection.toJSON()
    };
    if (e)
      for (let i in e) {
        let r = e[i];
        r instanceof Ye && this.config.address[r.id] != null && (t[i] = r.spec.toJSON(this.field(e[i]), this));
      }
    return t;
  }
  /**
  Deserialize a state from its JSON representation. When custom
  fields should be deserialized, pass the same object you passed
  to [`toJSON`](https://codemirror.net/6/docs/ref/#state.EditorState.toJSON) when serializing as
  third argument.
  */
  static fromJSON(e, t = {}, i) {
    if (!e || typeof e.doc != "string")
      throw new RangeError("Invalid JSON representation for EditorState");
    let r = [];
    if (i) {
      for (let s in i)
        if (Object.prototype.hasOwnProperty.call(e, s)) {
          let o = i[s], a = e[s];
          r.push(o.init((l) => o.spec.fromJSON(a, l)));
        }
    }
    return se.create({
      doc: e.doc,
      selection: $.fromJSON(e.selection),
      extensions: t.extensions ? r.concat([t.extensions]) : r
    });
  }
  /**
  Create a new state. You'll usually only need this when
  initializing an editor—updated states are created by applying
  transactions.
  */
  static create(e = {}) {
    let t = ta.resolve(e.extensions || [], /* @__PURE__ */ new Map()), i = e.doc instanceof me ? e.doc : me.of((e.doc || "").split(t.staticFacet(se.lineSeparator) || bu)), r = e.selection ? e.selection instanceof $ ? e.selection : $.single(e.selection.anchor, e.selection.head) : $.single(0);
    return Qg(r, i.length), t.staticFacet(Su) || (r = r.asSingle()), new se(t, i, r, t.dynamicSlots.map(() => null), (s, o) => o.create(s), null);
  }
  /**
  The size (in columns) of a tab in the document, determined by
  the [`tabSize`](https://codemirror.net/6/docs/ref/#state.EditorState^tabSize) facet.
  */
  get tabSize() {
    return this.facet(se.tabSize);
  }
  /**
  Get the proper [line-break](https://codemirror.net/6/docs/ref/#state.EditorState^lineSeparator)
  string for this state.
  */
  get lineBreak() {
    return this.facet(se.lineSeparator) || `
`;
  }
  /**
  Returns true when the editor is
  [configured](https://codemirror.net/6/docs/ref/#state.EditorState^readOnly) to be read-only.
  */
  get readOnly() {
    return this.facet(Zg);
  }
  /**
  Look up a translation for the given phrase (via the
  [`phrases`](https://codemirror.net/6/docs/ref/#state.EditorState^phrases) facet), or return the
  original string if no translation is found.
  
  If additional arguments are passed, they will be inserted in
  place of markers like `$1` (for the first value) and `$2`, etc.
  A single `$` is equivalent to `$1`, and `$$` will produce a
  literal dollar sign.
  */
  phrase(e, ...t) {
    for (let i of this.facet(se.phrases))
      if (Object.prototype.hasOwnProperty.call(i, e)) {
        e = i[e];
        break;
      }
    return t.length && (e = e.replace(/\$(\$|\d*)/g, (i, r) => {
      if (r == "$")
        return "$";
      let s = +(r || 1);
      return !s || s > t.length ? i : t[s - 1];
    })), e;
  }
  /**
  Find the values for a given language data field, provided by the
  the [`languageData`](https://codemirror.net/6/docs/ref/#state.EditorState^languageData) facet.
  
  Examples of language data fields are...
  
  - [`"commentTokens"`](https://codemirror.net/6/docs/ref/#commands.CommentTokens) for specifying
    comment syntax.
  - [`"autocomplete"`](https://codemirror.net/6/docs/ref/#autocomplete.autocompletion^config.override)
    for providing language-specific completion sources.
  - [`"wordChars"`](https://codemirror.net/6/docs/ref/#state.EditorState.charCategorizer) for adding
    characters that should be considered part of words in this
    language.
  - [`"closeBrackets"`](https://codemirror.net/6/docs/ref/#autocomplete.CloseBracketConfig) controls
    bracket closing behavior.
  */
  languageDataAt(e, t, i = -1) {
    let r = [];
    for (let s of this.facet(Cg))
      for (let o of s(this, t, i))
        Object.prototype.hasOwnProperty.call(o, e) && r.push(o[e]);
    return r;
  }
  /**
  Return a function that can categorize strings (expected to
  represent a single [grapheme cluster](https://codemirror.net/6/docs/ref/#state.findClusterBreak))
  into one of:
  
   - Word (contains an alphanumeric character or a character
     explicitly listed in the local language's `"wordChars"`
     language data, which should be a string)
   - Space (contains only whitespace)
   - Other (anything else)
  */
  charCategorizer(e) {
    return jk(this.languageDataAt("wordChars", e).join(""));
  }
  /**
  Find the word at the given position, meaning the range
  containing all [word](https://codemirror.net/6/docs/ref/#state.CharCategory.Word) characters
  around it. If no word characters are adjacent to the position,
  this returns null.
  */
  wordAt(e) {
    let { text: t, from: i, length: r } = this.doc.lineAt(e), s = this.charCategorizer(e), o = e - i, a = e - i;
    for (; o > 0; ) {
      let l = Ke(t, o, !1);
      if (s(t.slice(l, o)) != Ze.Word)
        break;
      o = l;
    }
    for (; a < r; ) {
      let l = Ke(t, a);
      if (s(t.slice(a, l)) != Ze.Word)
        break;
      a = l;
    }
    return o == a ? null : $.range(o + i, a + i);
  }
}
se.allowMultipleSelections = Su;
se.tabSize = /* @__PURE__ */ N.define({
  combine: (n) => n.length ? n[0] : 4
});
se.lineSeparator = Tg;
se.readOnly = Zg;
se.phrases = /* @__PURE__ */ N.define({
  compare(n, e) {
    let t = Object.keys(n), i = Object.keys(e);
    return t.length == i.length && t.every((r) => n[r] == e[r]);
  }
});
se.languageData = Cg;
se.changeFilter = Ag;
se.transactionFilter = Rg;
se.transactionExtender = Mg;
Rs.reconfigure = /* @__PURE__ */ te.define();
function pn(n, e, t = {}) {
  let i = {};
  for (let r of n)
    for (let s of Object.keys(r)) {
      let o = r[s], a = i[s];
      if (a === void 0)
        i[s] = o;
      else if (!(a === o || o === void 0))
        if (Object.hasOwnProperty.call(t, s))
          i[s] = t[s](a, o);
        else
          throw new Error("Config merge conflict for field " + s);
    }
  for (let r in e)
    i[r] === void 0 && (i[r] = e[r]);
  return i;
}
class ki {
  /**
  Compare this value with another value. Used when comparing
  rangesets. The default implementation compares by identity.
  Unless you are only creating a fixed number of unique instances
  of your value type, it is a good idea to implement this
  properly.
  */
  eq(e) {
    return this == e;
  }
  /**
  Create a [range](https://codemirror.net/6/docs/ref/#state.Range) with this value.
  */
  range(e, t = e) {
    return Qu.create(e, t, this);
  }
}
ki.prototype.startSide = ki.prototype.endSide = 0;
ki.prototype.point = !1;
ki.prototype.mapMode = Ge.TrackDel;
let Qu = class Dg {
  constructor(e, t, i) {
    this.from = e, this.to = t, this.value = i;
  }
  /**
  @internal
  */
  static create(e, t, i) {
    return new Dg(e, t, i);
  }
};
function $u(n, e) {
  return n.from - e.from || n.value.startSide - e.value.startSide;
}
class th {
  constructor(e, t, i, r) {
    this.from = e, this.to = t, this.value = i, this.maxPoint = r;
  }
  get length() {
    return this.to[this.to.length - 1];
  }
  // Find the index of the given position and side. Use the ranges'
  // `from` pos when `end == false`, `to` when `end == true`.
  findIndex(e, t, i, r = 0) {
    let s = i ? this.to : this.from;
    for (let o = r, a = s.length; ; ) {
      if (o == a)
        return o;
      let l = o + a >> 1, u = s[l] - e || (i ? this.value[l].endSide : this.value[l].startSide) - t;
      if (l == o)
        return u >= 0 ? o : a;
      u >= 0 ? a = l : o = l + 1;
    }
  }
  between(e, t, i, r) {
    for (let s = this.findIndex(t, -1e9, !0), o = this.findIndex(i, 1e9, !1, s); s < o; s++)
      if (r(this.from[s] + e, this.to[s] + e, this.value[s]) === !1)
        return !1;
  }
  map(e, t) {
    let i = [], r = [], s = [], o = -1, a = -1;
    for (let l = 0; l < this.value.length; l++) {
      let u = this.value[l], c = this.from[l] + e, h = this.to[l] + e, f, d;
      if (c == h) {
        let p = t.mapPos(c, u.startSide, u.mapMode);
        if (p == null || (f = d = p, u.startSide != u.endSide && (d = t.mapPos(c, u.endSide), d < f)))
          continue;
      } else if (f = t.mapPos(c, u.startSide), d = t.mapPos(h, u.endSide), f > d || f == d && u.startSide > 0 && u.endSide <= 0)
        continue;
      (d - f || u.endSide - u.startSide) < 0 || (o < 0 && (o = f), u.point && (a = Math.max(a, d - f)), i.push(u), r.push(f - o), s.push(d - o));
    }
    return { mapped: i.length ? new th(r, s, i, a) : null, pos: o };
  }
}
class de {
  constructor(e, t, i, r) {
    this.chunkPos = e, this.chunk = t, this.nextLayer = i, this.maxPoint = r;
  }
  /**
  @internal
  */
  static create(e, t, i, r) {
    return new de(e, t, i, r);
  }
  /**
  @internal
  */
  get length() {
    let e = this.chunk.length - 1;
    return e < 0 ? 0 : Math.max(this.chunkEnd(e), this.nextLayer.length);
  }
  /**
  The number of ranges in the set.
  */
  get size() {
    if (this.isEmpty)
      return 0;
    let e = this.nextLayer.size;
    for (let t of this.chunk)
      e += t.value.length;
    return e;
  }
  /**
  @internal
  */
  chunkEnd(e) {
    return this.chunkPos[e] + this.chunk[e].length;
  }
  /**
  Update the range set, optionally adding new ranges or filtering
  out existing ones.
  
  (Note: The type parameter is just there as a kludge to work
  around TypeScript variance issues that prevented `RangeSet<X>`
  from being a subtype of `RangeSet<Y>` when `X` is a subtype of
  `Y`.)
  */
  update(e) {
    let { add: t = [], sort: i = !1, filterFrom: r = 0, filterTo: s = this.length } = e, o = e.filter;
    if (t.length == 0 && !o)
      return this;
    if (i && (t = t.slice().sort($u)), this.isEmpty)
      return t.length ? de.of(t) : this;
    let a = new Ig(this, null, -1).goto(0), l = 0, u = [], c = new Fn();
    for (; a.value || l < t.length; )
      if (l < t.length && (a.from - t[l].from || a.startSide - t[l].value.startSide) >= 0) {
        let h = t[l++];
        c.addInner(h.from, h.to, h.value) || u.push(h);
      } else
        a.rangeIndex == 1 && a.chunkIndex < this.chunk.length && (l == t.length || this.chunkEnd(a.chunkIndex) < t[l].from) && (!o || r > this.chunkEnd(a.chunkIndex) || s < this.chunkPos[a.chunkIndex]) && c.addChunk(this.chunkPos[a.chunkIndex], this.chunk[a.chunkIndex]) ? a.nextChunk() : ((!o || r > a.to || s < a.from || o(a.from, a.to, a.value)) && (c.addInner(a.from, a.to, a.value) || u.push(Qu.create(a.from, a.to, a.value))), a.next());
    return c.finishInner(this.nextLayer.isEmpty && !u.length ? de.empty : this.nextLayer.update({ add: u, filter: o, filterFrom: r, filterTo: s }));
  }
  /**
  Map this range set through a set of changes, return the new set.
  */
  map(e) {
    if (e.empty || this.isEmpty)
      return this;
    let t = [], i = [], r = -1;
    for (let o = 0; o < this.chunk.length; o++) {
      let a = this.chunkPos[o], l = this.chunk[o], u = e.touchesRange(a, a + l.length);
      if (u === !1)
        r = Math.max(r, l.maxPoint), t.push(l), i.push(e.mapPos(a));
      else if (u === !0) {
        let { mapped: c, pos: h } = l.map(a, e);
        c && (r = Math.max(r, c.maxPoint), t.push(c), i.push(h));
      }
    }
    let s = this.nextLayer.map(e);
    return t.length == 0 ? s : new de(i, t, s || de.empty, r);
  }
  /**
  Iterate over the ranges that touch the region `from` to `to`,
  calling `f` for each. There is no guarantee that the ranges will
  be reported in any specific order. When the callback returns
  `false`, iteration stops.
  */
  between(e, t, i) {
    if (!this.isEmpty) {
      for (let r = 0; r < this.chunk.length; r++) {
        let s = this.chunkPos[r], o = this.chunk[r];
        if (t >= s && e <= s + o.length && o.between(s, e - s, t - s, i) === !1)
          return;
      }
      this.nextLayer.between(e, t, i);
    }
  }
  /**
  Iterate over the ranges in this set, in order, including all
  ranges that end at or after `from`.
  */
  iter(e = 0) {
    return rs.from([this]).goto(e);
  }
  /**
  @internal
  */
  get isEmpty() {
    return this.nextLayer == this;
  }
  /**
  Iterate over the ranges in a collection of sets, in order,
  starting from `from`.
  */
  static iter(e, t = 0) {
    return rs.from(e).goto(t);
  }
  /**
  Iterate over two groups of sets, calling methods on `comparator`
  to notify it of possible differences.
  */
  static compare(e, t, i, r, s = -1) {
    let o = e.filter((h) => h.maxPoint > 0 || !h.isEmpty && h.maxPoint >= s), a = t.filter((h) => h.maxPoint > 0 || !h.isEmpty && h.maxPoint >= s), l = Af(o, a, i), u = new $r(o, l, s), c = new $r(a, l, s);
    i.iterGaps((h, f, d) => Rf(u, h, c, f, d, r)), i.empty && i.length == 0 && Rf(u, 0, c, 0, 0, r);
  }
  /**
  Compare the contents of two groups of range sets, returning true
  if they are equivalent in the given range.
  */
  static eq(e, t, i = 0, r) {
    r == null && (r = 999999999);
    let s = e.filter((c) => !c.isEmpty && t.indexOf(c) < 0), o = t.filter((c) => !c.isEmpty && e.indexOf(c) < 0);
    if (s.length != o.length)
      return !1;
    if (!s.length)
      return !0;
    let a = Af(s, o), l = new $r(s, a, 0).goto(i), u = new $r(o, a, 0).goto(i);
    for (; ; ) {
      if (l.to != u.to || !Cu(l.active, u.active) || l.point && (!u.point || !l.point.eq(u.point)))
        return !1;
      if (l.to > r)
        return !0;
      l.next(), u.next();
    }
  }
  /**
  Iterate over a group of range sets at the same time, notifying
  the iterator about the ranges covering every given piece of
  content. Returns the open count (see
  [`SpanIterator.span`](https://codemirror.net/6/docs/ref/#state.SpanIterator.span)) at the end
  of the iteration.
  */
  static spans(e, t, i, r, s = -1) {
    let o = new $r(e, null, s).goto(t), a = t, l = o.openStart;
    for (; ; ) {
      let u = Math.min(o.to, i);
      if (o.point) {
        let c = o.activeForPoint(o.to), h = o.pointFrom < t ? c.length + 1 : o.point.startSide < 0 ? c.length : Math.min(c.length, l);
        r.point(a, u, o.point, c, h, o.pointRank), l = Math.min(o.openEnd(u), c.length);
      } else
        u > a && (r.span(a, u, o.active, l), l = o.openEnd(u));
      if (o.to > i)
        return l + (o.point && o.to > i ? 1 : 0);
      a = o.to, o.next();
    }
  }
  /**
  Create a range set for the given range or array of ranges. By
  default, this expects the ranges to be _sorted_ (by start
  position and, if two start at the same position,
  `value.startSide`). You can pass `true` as second argument to
  cause the method to sort them.
  */
  static of(e, t = !1) {
    let i = new Fn();
    for (let r of e instanceof Qu ? [e] : t ? Uk(e) : e)
      i.add(r.from, r.to, r.value);
    return i.finish();
  }
  /**
  Join an array of range sets into a single set.
  */
  static join(e) {
    if (!e.length)
      return de.empty;
    let t = e[e.length - 1];
    for (let i = e.length - 2; i >= 0; i--)
      for (let r = e[i]; r != de.empty; r = r.nextLayer)
        t = new de(r.chunkPos, r.chunk, t, Math.max(r.maxPoint, t.maxPoint));
    return t;
  }
}
de.empty = /* @__PURE__ */ new de([], [], null, -1);
function Uk(n) {
  if (n.length > 1)
    for (let e = n[0], t = 1; t < n.length; t++) {
      let i = n[t];
      if ($u(e, i) > 0)
        return n.slice().sort($u);
      e = i;
    }
  return n;
}
de.empty.nextLayer = de.empty;
class Fn {
  finishChunk(e) {
    this.chunks.push(new th(this.from, this.to, this.value, this.maxPoint)), this.chunkPos.push(this.chunkStart), this.chunkStart = -1, this.setMaxPoint = Math.max(this.setMaxPoint, this.maxPoint), this.maxPoint = -1, e && (this.from = [], this.to = [], this.value = []);
  }
  /**
  Create an empty builder.
  */
  constructor() {
    this.chunks = [], this.chunkPos = [], this.chunkStart = -1, this.last = null, this.lastFrom = -1e9, this.lastTo = -1e9, this.from = [], this.to = [], this.value = [], this.maxPoint = -1, this.setMaxPoint = -1, this.nextLayer = null;
  }
  /**
  Add a range. Ranges should be added in sorted (by `from` and
  `value.startSide`) order.
  */
  add(e, t, i) {
    this.addInner(e, t, i) || (this.nextLayer || (this.nextLayer = new Fn())).add(e, t, i);
  }
  /**
  @internal
  */
  addInner(e, t, i) {
    let r = e - this.lastTo || i.startSide - this.last.endSide;
    if (r <= 0 && (e - this.lastFrom || i.startSide - this.last.startSide) < 0)
      throw new Error("Ranges must be added sorted by `from` position and `startSide`");
    return r < 0 ? !1 : (this.from.length == 250 && this.finishChunk(!0), this.chunkStart < 0 && (this.chunkStart = e), this.from.push(e - this.chunkStart), this.to.push(t - this.chunkStart), this.last = i, this.lastFrom = e, this.lastTo = t, this.value.push(i), i.point && (this.maxPoint = Math.max(this.maxPoint, t - e)), !0);
  }
  /**
  @internal
  */
  addChunk(e, t) {
    if ((e - this.lastTo || t.value[0].startSide - this.last.endSide) < 0)
      return !1;
    this.from.length && this.finishChunk(!0), this.setMaxPoint = Math.max(this.setMaxPoint, t.maxPoint), this.chunks.push(t), this.chunkPos.push(e);
    let i = t.value.length - 1;
    return this.last = t.value[i], this.lastFrom = t.from[i] + e, this.lastTo = t.to[i] + e, !0;
  }
  /**
  Finish the range set. Returns the new set. The builder can't be
  used anymore after this has been called.
  */
  finish() {
    return this.finishInner(de.empty);
  }
  /**
  @internal
  */
  finishInner(e) {
    if (this.from.length && this.finishChunk(!1), this.chunks.length == 0)
      return e;
    let t = de.create(this.chunkPos, this.chunks, this.nextLayer ? this.nextLayer.finishInner(e) : e, this.setMaxPoint);
    return this.from = null, t;
  }
}
function Af(n, e, t) {
  let i = /* @__PURE__ */ new Map();
  for (let s of n)
    for (let o = 0; o < s.chunk.length; o++)
      s.chunk[o].maxPoint <= 0 && i.set(s.chunk[o], s.chunkPos[o]);
  let r = /* @__PURE__ */ new Set();
  for (let s of e)
    for (let o = 0; o < s.chunk.length; o++) {
      let a = i.get(s.chunk[o]);
      a != null && (t ? t.mapPos(a) : a) == s.chunkPos[o] && !(t != null && t.touchesRange(a, a + s.chunk[o].length)) && r.add(s.chunk[o]);
    }
  return r;
}
class Ig {
  constructor(e, t, i, r = 0) {
    this.layer = e, this.skip = t, this.minPoint = i, this.rank = r;
  }
  get startSide() {
    return this.value ? this.value.startSide : 0;
  }
  get endSide() {
    return this.value ? this.value.endSide : 0;
  }
  goto(e, t = -1e9) {
    return this.chunkIndex = this.rangeIndex = 0, this.gotoInner(e, t, !1), this;
  }
  gotoInner(e, t, i) {
    for (; this.chunkIndex < this.layer.chunk.length; ) {
      let r = this.layer.chunk[this.chunkIndex];
      if (!(this.skip && this.skip.has(r) || this.layer.chunkEnd(this.chunkIndex) < e || r.maxPoint < this.minPoint))
        break;
      this.chunkIndex++, i = !1;
    }
    if (this.chunkIndex < this.layer.chunk.length) {
      let r = this.layer.chunk[this.chunkIndex].findIndex(e - this.layer.chunkPos[this.chunkIndex], t, !0);
      (!i || this.rangeIndex < r) && this.setRangeIndex(r);
    }
    this.next();
  }
  forward(e, t) {
    (this.to - e || this.endSide - t) < 0 && this.gotoInner(e, t, !0);
  }
  next() {
    for (; ; )
      if (this.chunkIndex == this.layer.chunk.length) {
        this.from = this.to = 1e9, this.value = null;
        break;
      } else {
        let e = this.layer.chunkPos[this.chunkIndex], t = this.layer.chunk[this.chunkIndex], i = e + t.from[this.rangeIndex];
        if (this.from = i, this.to = e + t.to[this.rangeIndex], this.value = t.value[this.rangeIndex], this.setRangeIndex(this.rangeIndex + 1), this.minPoint < 0 || this.value.point && this.to - this.from >= this.minPoint)
          break;
      }
  }
  setRangeIndex(e) {
    if (e == this.layer.chunk[this.chunkIndex].value.length) {
      if (this.chunkIndex++, this.skip)
        for (; this.chunkIndex < this.layer.chunk.length && this.skip.has(this.layer.chunk[this.chunkIndex]); )
          this.chunkIndex++;
      this.rangeIndex = 0;
    } else
      this.rangeIndex = e;
  }
  nextChunk() {
    this.chunkIndex++, this.rangeIndex = 0, this.next();
  }
  compare(e) {
    return this.from - e.from || this.startSide - e.startSide || this.rank - e.rank || this.to - e.to || this.endSide - e.endSide;
  }
}
class rs {
  constructor(e) {
    this.heap = e;
  }
  static from(e, t = null, i = -1) {
    let r = [];
    for (let s = 0; s < e.length; s++)
      for (let o = e[s]; !o.isEmpty; o = o.nextLayer)
        o.maxPoint >= i && r.push(new Ig(o, t, i, s));
    return r.length == 1 ? r[0] : new rs(r);
  }
  get startSide() {
    return this.value ? this.value.startSide : 0;
  }
  goto(e, t = -1e9) {
    for (let i of this.heap)
      i.goto(e, t);
    for (let i = this.heap.length >> 1; i >= 0; i--)
      pl(this.heap, i);
    return this.next(), this;
  }
  forward(e, t) {
    for (let i of this.heap)
      i.forward(e, t);
    for (let i = this.heap.length >> 1; i >= 0; i--)
      pl(this.heap, i);
    (this.to - e || this.value.endSide - t) < 0 && this.next();
  }
  next() {
    if (this.heap.length == 0)
      this.from = this.to = 1e9, this.value = null, this.rank = -1;
    else {
      let e = this.heap[0];
      this.from = e.from, this.to = e.to, this.value = e.value, this.rank = e.rank, e.value && e.next(), pl(this.heap, 0);
    }
  }
}
function pl(n, e) {
  for (let t = n[e]; ; ) {
    let i = (e << 1) + 1;
    if (i >= n.length)
      break;
    let r = n[i];
    if (i + 1 < n.length && r.compare(n[i + 1]) >= 0 && (r = n[i + 1], i++), t.compare(r) < 0)
      break;
    n[i] = t, n[e] = r, e = i;
  }
}
class $r {
  constructor(e, t, i) {
    this.minPoint = i, this.active = [], this.activeTo = [], this.activeRank = [], this.minActive = -1, this.point = null, this.pointFrom = 0, this.pointRank = 0, this.to = -1e9, this.endSide = 0, this.openStart = -1, this.cursor = rs.from(e, t, i);
  }
  goto(e, t = -1e9) {
    return this.cursor.goto(e, t), this.active.length = this.activeTo.length = this.activeRank.length = 0, this.minActive = -1, this.to = e, this.endSide = t, this.openStart = -1, this.next(), this;
  }
  forward(e, t) {
    for (; this.minActive > -1 && (this.activeTo[this.minActive] - e || this.active[this.minActive].endSide - t) < 0; )
      this.removeActive(this.minActive);
    this.cursor.forward(e, t);
  }
  removeActive(e) {
    Fs(this.active, e), Fs(this.activeTo, e), Fs(this.activeRank, e), this.minActive = Mf(this.active, this.activeTo);
  }
  addActive(e) {
    let t = 0, { value: i, to: r, rank: s } = this.cursor;
    for (; t < this.activeRank.length && (s - this.activeRank[t] || r - this.activeTo[t]) > 0; )
      t++;
    Gs(this.active, t, i), Gs(this.activeTo, t, r), Gs(this.activeRank, t, s), e && Gs(e, t, this.cursor.from), this.minActive = Mf(this.active, this.activeTo);
  }
  // After calling this, if `this.point` != null, the next range is a
  // point. Otherwise, it's a regular range, covered by `this.active`.
  next() {
    let e = this.to, t = this.point;
    this.point = null;
    let i = this.openStart < 0 ? [] : null;
    for (; ; ) {
      let r = this.minActive;
      if (r > -1 && (this.activeTo[r] - this.cursor.from || this.active[r].endSide - this.cursor.startSide) < 0) {
        if (this.activeTo[r] > e) {
          this.to = this.activeTo[r], this.endSide = this.active[r].endSide;
          break;
        }
        this.removeActive(r), i && Fs(i, r);
      } else if (this.cursor.value)
        if (this.cursor.from > e) {
          this.to = this.cursor.from, this.endSide = this.cursor.startSide;
          break;
        } else {
          let s = this.cursor.value;
          if (!s.point)
            this.addActive(i), this.cursor.next();
          else if (t && this.cursor.to == this.to && this.cursor.from < this.cursor.to)
            this.cursor.next();
          else {
            this.point = s, this.pointFrom = this.cursor.from, this.pointRank = this.cursor.rank, this.to = this.cursor.to, this.endSide = s.endSide, this.cursor.next(), this.forward(this.to, this.endSide);
            break;
          }
        }
      else {
        this.to = this.endSide = 1e9;
        break;
      }
    }
    if (i) {
      this.openStart = 0;
      for (let r = i.length - 1; r >= 0 && i[r] < e; r--)
        this.openStart++;
    }
  }
  activeForPoint(e) {
    if (!this.active.length)
      return this.active;
    let t = [];
    for (let i = this.active.length - 1; i >= 0 && !(this.activeRank[i] < this.pointRank); i--)
      (this.activeTo[i] > e || this.activeTo[i] == e && this.active[i].endSide >= this.point.endSide) && t.push(this.active[i]);
    return t.reverse();
  }
  openEnd(e) {
    let t = 0;
    for (let i = this.activeTo.length - 1; i >= 0 && this.activeTo[i] > e; i--)
      t++;
    return t;
  }
}
function Rf(n, e, t, i, r, s) {
  n.goto(e), t.goto(i);
  let o = i + r, a = i, l = i - e;
  for (; ; ) {
    let u = n.to + l - t.to || n.endSide - t.endSide, c = u < 0 ? n.to + l : t.to, h = Math.min(c, o);
    if (n.point || t.point ? n.point && t.point && (n.point == t.point || n.point.eq(t.point)) && Cu(n.activeForPoint(n.to), t.activeForPoint(t.to)) || s.comparePoint(a, h, n.point, t.point) : h > a && !Cu(n.active, t.active) && s.compareRange(a, h, n.active, t.active), c > o)
      break;
    a = c, u <= 0 && n.next(), u >= 0 && t.next();
  }
}
function Cu(n, e) {
  if (n.length != e.length)
    return !1;
  for (let t = 0; t < n.length; t++)
    if (n[t] != e[t] && !n[t].eq(e[t]))
      return !1;
  return !0;
}
function Fs(n, e) {
  for (let t = e, i = n.length - 1; t < i; t++)
    n[t] = n[t + 1];
  n.pop();
}
function Gs(n, e, t) {
  for (let i = n.length - 1; i >= e; i--)
    n[i + 1] = n[i];
  n[e] = t;
}
function Mf(n, e) {
  let t = -1, i = 1e9;
  for (let r = 0; r < e.length; r++)
    (e[r] - i || n[r].endSide - n[t].endSide) < 0 && (t = r, i = e[r]);
  return t;
}
function Ut(n, e, t = n.length) {
  let i = 0;
  for (let r = 0; r < t; )
    n.charCodeAt(r) == 9 ? (i += e - i % e, r++) : (i++, r = Ke(n, r));
  return i;
}
function Tu(n, e, t, i) {
  for (let r = 0, s = 0; ; ) {
    if (s >= e)
      return r;
    if (r == n.length)
      break;
    s += n.charCodeAt(r) == 9 ? t - s % t : 1, r = Ke(n, r);
  }
  return i === !0 ? -1 : n.length;
}
const Au = "ͼ", Zf = typeof Symbol > "u" ? "__" + Au : Symbol.for(Au), Ru = typeof Symbol > "u" ? "__styleSet" + Math.floor(Math.random() * 1e8) : Symbol("styleSet"), Ef = typeof globalThis < "u" ? globalThis : typeof window < "u" ? window : {};
class Gn {
  // :: (Object<Style>, ?{finish: ?(string) → string})
  // Create a style module from the given spec.
  //
  // When `finish` is given, it is called on regular (non-`@`)
  // selectors (after `&` expansion) to compute the final selector.
  constructor(e, t) {
    this.rules = [];
    let { finish: i } = t || {};
    function r(o) {
      return /^@/.test(o) ? [o] : o.split(/,\s*/);
    }
    function s(o, a, l, u) {
      let c = [], h = /^@(\w+)\b/.exec(o[0]), f = h && h[1] == "keyframes";
      if (h && a == null)
        return l.push(o[0] + ";");
      for (let d in a) {
        let p = a[d];
        if (/&/.test(d))
          s(
            d.split(/,\s*/).map((g) => o.map((O) => g.replace(/&/, O))).reduce((g, O) => g.concat(O)),
            p,
            l
          );
        else if (p && typeof p == "object") {
          if (!h)
            throw new RangeError("The value of a property (" + d + ") should be a primitive value.");
          s(r(d), p, c, f);
        } else
          p != null && c.push(d.replace(/_.*/, "").replace(/[A-Z]/g, (g) => "-" + g.toLowerCase()) + ": " + p + ";");
      }
      (c.length || f) && l.push((i && !h && !u ? o.map(i) : o).join(", ") + " {" + c.join(" ") + "}");
    }
    for (let o in e)
      s(r(o), e[o], this.rules);
  }
  // :: () → string
  // Returns a string containing the module's CSS rules.
  getRules() {
    return this.rules.join(`
`);
  }
  // :: () → string
  // Generate a new unique CSS class name.
  static newName() {
    let e = Ef[Zf] || 1;
    return Ef[Zf] = e + 1, Au + e.toString(36);
  }
  // :: (union<Document, ShadowRoot>, union<[StyleModule], StyleModule>, ?{nonce: ?string})
  //
  // Mount the given set of modules in the given DOM root, which ensures
  // that the CSS rules defined by the module are available in that
  // context.
  //
  // Rules are only added to the document once per root.
  //
  // Rule order will follow the order of the modules, so that rules from
  // modules later in the array take precedence of those from earlier
  // modules. If you call this function multiple times for the same root
  // in a way that changes the order of already mounted modules, the old
  // order will be changed.
  //
  // If a Content Security Policy nonce is provided, it is added to
  // the `<style>` tag generated by the library.
  static mount(e, t, i) {
    let r = e[Ru], s = i && i.nonce;
    r ? s && r.setNonce(s) : r = new Fk(e, s), r.mount(Array.isArray(t) ? t : [t], e);
  }
}
let zf = /* @__PURE__ */ new Map();
class Fk {
  constructor(e, t) {
    let i = e.ownerDocument || e, r = i.defaultView;
    if (!e.head && e.adoptedStyleSheets && r.CSSStyleSheet) {
      let s = zf.get(i);
      if (s)
        return e[Ru] = s;
      this.sheet = new r.CSSStyleSheet(), zf.set(i, this);
    } else
      this.styleTag = i.createElement("style"), t && this.styleTag.setAttribute("nonce", t);
    this.modules = [], e[Ru] = this;
  }
  mount(e, t) {
    let i = this.sheet, r = 0, s = 0;
    for (let o = 0; o < e.length; o++) {
      let a = e[o], l = this.modules.indexOf(a);
      if (l < s && l > -1 && (this.modules.splice(l, 1), s--, l = -1), l == -1) {
        if (this.modules.splice(s++, 0, a), i)
          for (let u = 0; u < a.rules.length; u++)
            i.insertRule(a.rules[u], r++);
      } else {
        for (; s < l; )
          r += this.modules[s++].rules.length;
        r += a.rules.length, s++;
      }
    }
    if (i)
      t.adoptedStyleSheets.indexOf(this.sheet) < 0 && (t.adoptedStyleSheets = [this.sheet, ...t.adoptedStyleSheets]);
    else {
      let o = "";
      for (let l = 0; l < this.modules.length; l++)
        o += this.modules[l].getRules() + `
`;
      this.styleTag.textContent = o;
      let a = t.head || t;
      this.styleTag.parentNode != a && a.insertBefore(this.styleTag, a.firstChild);
    }
  }
  setNonce(e) {
    this.styleTag && this.styleTag.getAttribute("nonce") != e && this.styleTag.setAttribute("nonce", e);
  }
}
var Hn = {
  8: "Backspace",
  9: "Tab",
  10: "Enter",
  12: "NumLock",
  13: "Enter",
  16: "Shift",
  17: "Control",
  18: "Alt",
  20: "CapsLock",
  27: "Escape",
  32: " ",
  33: "PageUp",
  34: "PageDown",
  35: "End",
  36: "Home",
  37: "ArrowLeft",
  38: "ArrowUp",
  39: "ArrowRight",
  40: "ArrowDown",
  44: "PrintScreen",
  45: "Insert",
  46: "Delete",
  59: ";",
  61: "=",
  91: "Meta",
  92: "Meta",
  106: "*",
  107: "+",
  108: ",",
  109: "-",
  110: ".",
  111: "/",
  144: "NumLock",
  145: "ScrollLock",
  160: "Shift",
  161: "Shift",
  162: "Control",
  163: "Control",
  164: "Alt",
  165: "Alt",
  173: "-",
  186: ";",
  187: "=",
  188: ",",
  189: "-",
  190: ".",
  191: "/",
  192: "`",
  219: "[",
  220: "\\",
  221: "]",
  222: "'"
}, ss = {
  48: ")",
  49: "!",
  50: "@",
  51: "#",
  52: "$",
  53: "%",
  54: "^",
  55: "&",
  56: "*",
  57: "(",
  59: ":",
  61: "+",
  173: "_",
  186: ":",
  187: "+",
  188: "<",
  189: "_",
  190: ">",
  191: "?",
  192: "~",
  219: "{",
  220: "|",
  221: "}",
  222: '"'
}, Gk = typeof navigator < "u" && /Mac/.test(navigator.platform), Hk = typeof navigator < "u" && /MSIE \d|Trident\/(?:[7-9]|\d{2,})\..*rv:(\d+)/.exec(navigator.userAgent);
for (var Fe = 0; Fe < 10; Fe++)
  Hn[48 + Fe] = Hn[96 + Fe] = String(Fe);
for (var Fe = 1; Fe <= 24; Fe++)
  Hn[Fe + 111] = "F" + Fe;
for (var Fe = 65; Fe <= 90; Fe++)
  Hn[Fe] = String.fromCharCode(Fe + 32), ss[Fe] = String.fromCharCode(Fe);
for (var ml in Hn)
  ss.hasOwnProperty(ml) || (ss[ml] = Hn[ml]);
function Kk(n) {
  var e = Gk && n.metaKey && n.shiftKey && !n.ctrlKey && !n.altKey || Hk && n.shiftKey && n.key && n.key.length == 1 || n.key == "Unidentified", t = !e && n.key || (n.shiftKey ? ss : Hn)[n.keyCode] || n.key || "Unidentified";
  return t == "Esc" && (t = "Escape"), t == "Del" && (t = "Delete"), t == "Left" && (t = "ArrowLeft"), t == "Up" && (t = "ArrowUp"), t == "Right" && (t = "ArrowRight"), t == "Down" && (t = "ArrowDown"), t;
}
function ia(n) {
  let e;
  return n.nodeType == 11 ? e = n.getSelection ? n : n.ownerDocument : e = n, e.getSelection();
}
function Mu(n, e) {
  return e ? n == e || n.contains(e.nodeType != 1 ? e.parentNode : e) : !1;
}
function Jk(n) {
  let e = n.activeElement;
  for (; e && e.shadowRoot; )
    e = e.shadowRoot.activeElement;
  return e;
}
function _o(n, e) {
  if (!e.anchorNode)
    return !1;
  try {
    return Mu(n, e.anchorNode);
  } catch {
    return !1;
  }
}
function tr(n) {
  return n.nodeType == 3 ? wi(n, 0, n.nodeValue.length).getClientRects() : n.nodeType == 1 ? n.getClientRects() : [];
}
function jr(n, e, t, i) {
  return t ? Df(n, e, t, i, -1) || Df(n, e, t, i, 1) : !1;
}
function xi(n) {
  for (var e = 0; ; e++)
    if (n = n.previousSibling, !n)
      return e;
}
function ra(n) {
  return n.nodeType == 1 && /^(DIV|P|LI|UL|OL|BLOCKQUOTE|DD|DT|H\d|SECTION|PRE)$/.test(n.nodeName);
}
function Df(n, e, t, i, r) {
  for (; ; ) {
    if (n == t && e == i)
      return !0;
    if (e == (r < 0 ? 0 : Qn(n))) {
      if (n.nodeName == "DIV")
        return !1;
      let s = n.parentNode;
      if (!s || s.nodeType != 1)
        return !1;
      e = xi(n) + (r < 0 ? 0 : 1), n = s;
    } else if (n.nodeType == 1) {
      if (n = n.childNodes[e + (r < 0 ? -1 : 0)], n.nodeType == 1 && n.contentEditable == "false")
        return !1;
      e = r < 0 ? Qn(n) : 0;
    } else
      return !1;
  }
}
function Qn(n) {
  return n.nodeType == 3 ? n.nodeValue.length : n.childNodes.length;
}
function Ba(n, e) {
  let t = e ? n.left : n.right;
  return { left: t, right: t, top: n.top, bottom: n.bottom };
}
function ex(n) {
  let e = n.visualViewport;
  return e ? {
    left: 0,
    right: e.width,
    top: 0,
    bottom: e.height
  } : {
    left: 0,
    right: n.innerWidth,
    top: 0,
    bottom: n.innerHeight
  };
}
function Lg(n, e) {
  let t = e.width / n.offsetWidth, i = e.height / n.offsetHeight;
  return (t > 0.995 && t < 1.005 || !isFinite(t) || Math.abs(e.width - n.offsetWidth) < 1) && (t = 1), (i > 0.995 && i < 1.005 || !isFinite(i) || Math.abs(e.height - n.offsetHeight) < 1) && (i = 1), { scaleX: t, scaleY: i };
}
function tx(n, e, t, i, r, s, o, a) {
  let l = n.ownerDocument, u = l.defaultView || window;
  for (let c = n, h = !1; c && !h; )
    if (c.nodeType == 1) {
      let f, d = c == l.body, p = 1, g = 1;
      if (d)
        f = ex(u);
      else {
        if (/^(fixed|sticky)$/.test(getComputedStyle(c).position) && (h = !0), c.scrollHeight <= c.clientHeight && c.scrollWidth <= c.clientWidth) {
          c = c.assignedSlot || c.parentNode;
          continue;
        }
        let b = c.getBoundingClientRect();
        ({ scaleX: p, scaleY: g } = Lg(c, b)), f = {
          left: b.left,
          right: b.left + c.clientWidth * p,
          top: b.top,
          bottom: b.top + c.clientHeight * g
        };
      }
      let O = 0, m = 0;
      if (r == "nearest")
        e.top < f.top ? (m = -(f.top - e.top + o), t > 0 && e.bottom > f.bottom + m && (m = e.bottom - f.bottom + m + o)) : e.bottom > f.bottom && (m = e.bottom - f.bottom + o, t < 0 && e.top - m < f.top && (m = -(f.top + m - e.top + o)));
      else {
        let b = e.bottom - e.top, w = f.bottom - f.top;
        m = (r == "center" && b <= w ? e.top + b / 2 - w / 2 : r == "start" || r == "center" && t < 0 ? e.top - o : e.bottom - w + o) - f.top;
      }
      if (i == "nearest" ? e.left < f.left ? (O = -(f.left - e.left + s), t > 0 && e.right > f.right + O && (O = e.right - f.right + O + s)) : e.right > f.right && (O = e.right - f.right + s, t < 0 && e.left < f.left + O && (O = -(f.left + O - e.left + s))) : O = (i == "center" ? e.left + (e.right - e.left) / 2 - (f.right - f.left) / 2 : i == "start" == a ? e.left - s : e.right - (f.right - f.left) + s) - f.left, O || m)
        if (d)
          u.scrollBy(O, m);
        else {
          let b = 0, w = 0;
          if (m) {
            let Q = c.scrollTop;
            c.scrollTop += m / g, w = (c.scrollTop - Q) * g;
          }
          if (O) {
            let Q = c.scrollLeft;
            c.scrollLeft += O / p, b = (c.scrollLeft - Q) * p;
          }
          e = {
            left: e.left - b,
            top: e.top - w,
            right: e.right - b,
            bottom: e.bottom - w
          }, b && Math.abs(b - O) < 1 && (i = "nearest"), w && Math.abs(w - m) < 1 && (r = "nearest");
        }
      if (d)
        break;
      c = c.assignedSlot || c.parentNode;
    } else if (c.nodeType == 11)
      c = c.host;
    else
      break;
}
function nx(n) {
  let e = n.ownerDocument;
  for (let t = n.parentNode; t && t != e.body; )
    if (t.nodeType == 1) {
      if (t.scrollHeight > t.clientHeight || t.scrollWidth > t.clientWidth)
        return t;
      t = t.assignedSlot || t.parentNode;
    } else if (t.nodeType == 11)
      t = t.host;
    else
      break;
  return null;
}
class ix {
  constructor() {
    this.anchorNode = null, this.anchorOffset = 0, this.focusNode = null, this.focusOffset = 0;
  }
  eq(e) {
    return this.anchorNode == e.anchorNode && this.anchorOffset == e.anchorOffset && this.focusNode == e.focusNode && this.focusOffset == e.focusOffset;
  }
  setRange(e) {
    let { anchorNode: t, focusNode: i } = e;
    this.set(t, Math.min(e.anchorOffset, t ? Qn(t) : 0), i, Math.min(e.focusOffset, i ? Qn(i) : 0));
  }
  set(e, t, i, r) {
    this.anchorNode = e, this.anchorOffset = t, this.focusNode = i, this.focusOffset = r;
  }
}
let Zi = null;
function _g(n) {
  if (n.setActive)
    return n.setActive();
  if (Zi)
    return n.focus(Zi);
  let e = [];
  for (let t = n; t && (e.push(t, t.scrollTop, t.scrollLeft), t != t.ownerDocument); t = t.parentNode)
    ;
  if (n.focus(Zi == null ? {
    get preventScroll() {
      return Zi = { preventScroll: !0 }, !0;
    }
  } : void 0), !Zi) {
    Zi = !1;
    for (let t = 0; t < e.length; ) {
      let i = e[t++], r = e[t++], s = e[t++];
      i.scrollTop != r && (i.scrollTop = r), i.scrollLeft != s && (i.scrollLeft = s);
    }
  }
}
let If;
function wi(n, e, t = e) {
  let i = If || (If = document.createRange());
  return i.setEnd(n, t), i.setStart(n, e), i;
}
function Yi(n, e, t, i) {
  let r = { key: e, code: e, keyCode: t, which: t, cancelable: !0 };
  i && ({ altKey: r.altKey, ctrlKey: r.ctrlKey, shiftKey: r.shiftKey, metaKey: r.metaKey } = i);
  let s = new KeyboardEvent("keydown", r);
  s.synthetic = !0, n.dispatchEvent(s);
  let o = new KeyboardEvent("keyup", r);
  return o.synthetic = !0, n.dispatchEvent(o), s.defaultPrevented || o.defaultPrevented;
}
function rx(n) {
  for (; n; ) {
    if (n && (n.nodeType == 9 || n.nodeType == 11 && n.host))
      return n;
    n = n.assignedSlot || n.parentNode;
  }
  return null;
}
function Xg(n) {
  for (; n.attributes.length; )
    n.removeAttributeNode(n.attributes[0]);
}
function sx(n, e) {
  let t = e.focusNode, i = e.focusOffset;
  if (!t || e.anchorNode != t || e.anchorOffset != i)
    return !1;
  for (i = Math.min(i, Qn(t)); ; )
    if (i) {
      if (t.nodeType != 1)
        return !1;
      let r = t.childNodes[i - 1];
      r.contentEditable == "false" ? i-- : (t = r, i = Qn(t));
    } else {
      if (t == n)
        return !0;
      i = xi(t), t = t.parentNode;
    }
}
function Ng(n) {
  return n.scrollTop > Math.max(1, n.scrollHeight - n.clientHeight - 4);
}
function Wg(n, e) {
  for (let t = n, i = e; ; ) {
    if (t.nodeType == 3 && i > 0)
      return { node: t, offset: i };
    if (t.nodeType == 1 && i > 0) {
      if (t.contentEditable == "false")
        return null;
      t = t.childNodes[i - 1], i = Qn(t);
    } else if (t.parentNode && !ra(t))
      i = xi(t), t = t.parentNode;
    else
      return null;
  }
}
function qg(n, e) {
  for (let t = n, i = e; ; ) {
    if (t.nodeType == 3 && i < t.nodeValue.length)
      return { node: t, offset: i };
    if (t.nodeType == 1 && i < t.childNodes.length) {
      if (t.contentEditable == "false")
        return null;
      t = t.childNodes[i], i = 0;
    } else if (t.parentNode && !ra(t))
      i = xi(t) + 1, t = t.parentNode;
    else
      return null;
  }
}
class tt {
  constructor(e, t, i = !0) {
    this.node = e, this.offset = t, this.precise = i;
  }
  static before(e, t) {
    return new tt(e.parentNode, xi(e), t);
  }
  static after(e, t) {
    return new tt(e.parentNode, xi(e) + 1, t);
  }
}
const nh = [];
class ke {
  constructor() {
    this.parent = null, this.dom = null, this.flags = 2;
  }
  get overrideDOMText() {
    return null;
  }
  get posAtStart() {
    return this.parent ? this.parent.posBefore(this) : 0;
  }
  get posAtEnd() {
    return this.posAtStart + this.length;
  }
  posBefore(e) {
    let t = this.posAtStart;
    for (let i of this.children) {
      if (i == e)
        return t;
      t += i.length + i.breakAfter;
    }
    throw new RangeError("Invalid child in posBefore");
  }
  posAfter(e) {
    return this.posBefore(e) + e.length;
  }
  sync(e, t) {
    if (this.flags & 2) {
      let i = this.dom, r = null, s;
      for (let o of this.children) {
        if (o.flags & 7) {
          if (!o.dom && (s = r ? r.nextSibling : i.firstChild)) {
            let a = ke.get(s);
            (!a || !a.parent && a.canReuseDOM(o)) && o.reuseDOM(s);
          }
          o.sync(e, t), o.flags &= -8;
        }
        if (s = r ? r.nextSibling : i.firstChild, t && !t.written && t.node == i && s != o.dom && (t.written = !0), o.dom.parentNode == i)
          for (; s && s != o.dom; )
            s = Lf(s);
        else
          i.insertBefore(o.dom, s);
        r = o.dom;
      }
      for (s = r ? r.nextSibling : i.firstChild, s && t && t.node == i && (t.written = !0); s; )
        s = Lf(s);
    } else if (this.flags & 1)
      for (let i of this.children)
        i.flags & 7 && (i.sync(e, t), i.flags &= -8);
  }
  reuseDOM(e) {
  }
  localPosFromDOM(e, t) {
    let i;
    if (e == this.dom)
      i = this.dom.childNodes[t];
    else {
      let r = Qn(e) == 0 ? 0 : t == 0 ? -1 : 1;
      for (; ; ) {
        let s = e.parentNode;
        if (s == this.dom)
          break;
        r == 0 && s.firstChild != s.lastChild && (e == s.firstChild ? r = -1 : r = 1), e = s;
      }
      r < 0 ? i = e : i = e.nextSibling;
    }
    if (i == this.dom.firstChild)
      return 0;
    for (; i && !ke.get(i); )
      i = i.nextSibling;
    if (!i)
      return this.length;
    for (let r = 0, s = 0; ; r++) {
      let o = this.children[r];
      if (o.dom == i)
        return s;
      s += o.length + o.breakAfter;
    }
  }
  domBoundsAround(e, t, i = 0) {
    let r = -1, s = -1, o = -1, a = -1;
    for (let l = 0, u = i, c = i; l < this.children.length; l++) {
      let h = this.children[l], f = u + h.length;
      if (u < e && f > t)
        return h.domBoundsAround(e, t, u);
      if (f >= e && r == -1 && (r = l, s = u), u > t && h.dom.parentNode == this.dom) {
        o = l, a = c;
        break;
      }
      c = f, u = f + h.breakAfter;
    }
    return {
      from: s,
      to: a < 0 ? i + this.length : a,
      startDOM: (r ? this.children[r - 1].dom.nextSibling : null) || this.dom.firstChild,
      endDOM: o < this.children.length && o >= 0 ? this.children[o].dom : null
    };
  }
  markDirty(e = !1) {
    this.flags |= 2, this.markParentsDirty(e);
  }
  markParentsDirty(e) {
    for (let t = this.parent; t; t = t.parent) {
      if (e && (t.flags |= 2), t.flags & 1)
        return;
      t.flags |= 1, e = !1;
    }
  }
  setParent(e) {
    this.parent != e && (this.parent = e, this.flags & 7 && this.markParentsDirty(!0));
  }
  setDOM(e) {
    this.dom != e && (this.dom && (this.dom.cmView = null), this.dom = e, e.cmView = this);
  }
  get rootView() {
    for (let e = this; ; ) {
      let t = e.parent;
      if (!t)
        return e;
      e = t;
    }
  }
  replaceChildren(e, t, i = nh) {
    this.markDirty();
    for (let r = e; r < t; r++) {
      let s = this.children[r];
      s.parent == this && i.indexOf(s) < 0 && s.destroy();
    }
    this.children.splice(e, t - e, ...i);
    for (let r = 0; r < i.length; r++)
      i[r].setParent(this);
  }
  ignoreMutation(e) {
    return !1;
  }
  ignoreEvent(e) {
    return !1;
  }
  childCursor(e = this.length) {
    return new Bg(this.children, e, this.children.length);
  }
  childPos(e, t = 1) {
    return this.childCursor().findPos(e, t);
  }
  toString() {
    let e = this.constructor.name.replace("View", "");
    return e + (this.children.length ? "(" + this.children.join() + ")" : this.length ? "[" + (e == "Text" ? this.text : this.length) + "]" : "") + (this.breakAfter ? "#" : "");
  }
  static get(e) {
    return e.cmView;
  }
  get isEditable() {
    return !0;
  }
  get isWidget() {
    return !1;
  }
  get isHidden() {
    return !1;
  }
  merge(e, t, i, r, s, o) {
    return !1;
  }
  become(e) {
    return !1;
  }
  canReuseDOM(e) {
    return e.constructor == this.constructor && !((this.flags | e.flags) & 8);
  }
  // When this is a zero-length view with a side, this should return a
  // number <= 0 to indicate it is before its position, or a
  // number > 0 when after its position.
  getSide() {
    return 0;
  }
  destroy() {
    for (let e of this.children)
      e.parent == this && e.destroy();
    this.parent = null;
  }
}
ke.prototype.breakAfter = 0;
function Lf(n) {
  let e = n.nextSibling;
  return n.parentNode.removeChild(n), e;
}
class Bg {
  constructor(e, t, i) {
    this.children = e, this.pos = t, this.i = i, this.off = 0;
  }
  findPos(e, t = 1) {
    for (; ; ) {
      if (e > this.pos || e == this.pos && (t > 0 || this.i == 0 || this.children[this.i - 1].breakAfter))
        return this.off = e - this.pos, this;
      let i = this.children[--this.i];
      this.pos -= i.length + i.breakAfter;
    }
  }
}
function Vg(n, e, t, i, r, s, o, a, l) {
  let { children: u } = n, c = u.length ? u[e] : null, h = s.length ? s[s.length - 1] : null, f = h ? h.breakAfter : o;
  if (!(e == i && c && !o && !f && s.length < 2 && c.merge(t, r, s.length ? h : null, t == 0, a, l))) {
    if (i < u.length) {
      let d = u[i];
      d && (r < d.length || d.breakAfter && (h != null && h.breakAfter)) ? (e == i && (d = d.split(r), r = 0), !f && h && d.merge(0, r, h, !0, 0, l) ? s[s.length - 1] = d : ((r || d.children.length && !d.children[0].length) && d.merge(0, r, null, !1, 0, l), s.push(d))) : d != null && d.breakAfter && (h ? h.breakAfter = 1 : o = 1), i++;
    }
    for (c && (c.breakAfter = o, t > 0 && (!o && s.length && c.merge(t, c.length, s[0], !1, a, 0) ? c.breakAfter = s.shift().breakAfter : (t < c.length || c.children.length && c.children[c.children.length - 1].length == 0) && c.merge(t, c.length, null, !1, a, 0), e++)); e < i && s.length; )
      if (u[i - 1].become(s[s.length - 1]))
        i--, s.pop(), l = s.length ? 0 : a;
      else if (u[e].become(s[0]))
        e++, s.shift(), a = s.length ? 0 : l;
      else
        break;
    !s.length && e && i < u.length && !u[e - 1].breakAfter && u[i].merge(0, 0, u[e - 1], !1, a, l) && e--, (e < i || s.length) && n.replaceChildren(e, i, s);
  }
}
function Yg(n, e, t, i, r, s) {
  let o = n.childCursor(), { i: a, off: l } = o.findPos(t, 1), { i: u, off: c } = o.findPos(e, -1), h = e - t;
  for (let f of i)
    h += f.length;
  n.length += h, Vg(n, u, c, a, l, i, 0, r, s);
}
let dt = typeof navigator < "u" ? navigator : { userAgent: "", vendor: "", platform: "" }, Zu = typeof document < "u" ? document : { documentElement: { style: {} } };
const Eu = /* @__PURE__ */ /Edge\/(\d+)/.exec(dt.userAgent), jg = /* @__PURE__ */ /MSIE \d/.test(dt.userAgent), zu = /* @__PURE__ */ /Trident\/(?:[7-9]|\d{2,})\..*rv:(\d+)/.exec(dt.userAgent), Va = !!(jg || zu || Eu), _f = !Va && /* @__PURE__ */ /gecko\/(\d+)/i.test(dt.userAgent), gl = !Va && /* @__PURE__ */ /Chrome\/(\d+)/.exec(dt.userAgent), Xf = "webkitFontSmoothing" in Zu.documentElement.style, Ug = !Va && /* @__PURE__ */ /Apple Computer/.test(dt.vendor), Nf = Ug && (/* @__PURE__ */ /Mobile\/\w+/.test(dt.userAgent) || dt.maxTouchPoints > 2);
var W = {
  mac: Nf || /* @__PURE__ */ /Mac/.test(dt.platform),
  windows: /* @__PURE__ */ /Win/.test(dt.platform),
  linux: /* @__PURE__ */ /Linux|X11/.test(dt.platform),
  ie: Va,
  ie_version: jg ? Zu.documentMode || 6 : zu ? +zu[1] : Eu ? +Eu[1] : 0,
  gecko: _f,
  gecko_version: _f ? +(/* @__PURE__ */ /Firefox\/(\d+)/.exec(dt.userAgent) || [0, 0])[1] : 0,
  chrome: !!gl,
  chrome_version: gl ? +gl[1] : 0,
  ios: Nf,
  android: /* @__PURE__ */ /Android\b/.test(dt.userAgent),
  webkit: Xf,
  safari: Ug,
  webkit_version: Xf ? +(/* @__PURE__ */ /\bAppleWebKit\/(\d+)/.exec(dt.userAgent) || [0, 0])[1] : 0,
  tabSize: Zu.documentElement.style.tabSize != null ? "tab-size" : "-moz-tab-size"
};
const ox = 256;
class Ft extends ke {
  constructor(e) {
    super(), this.text = e;
  }
  get length() {
    return this.text.length;
  }
  createDOM(e) {
    this.setDOM(e || document.createTextNode(this.text));
  }
  sync(e, t) {
    this.dom || this.createDOM(), this.dom.nodeValue != this.text && (t && t.node == this.dom && (t.written = !0), this.dom.nodeValue = this.text);
  }
  reuseDOM(e) {
    e.nodeType == 3 && this.createDOM(e);
  }
  merge(e, t, i) {
    return this.flags & 8 || i && (!(i instanceof Ft) || this.length - (t - e) + i.length > ox || i.flags & 8) ? !1 : (this.text = this.text.slice(0, e) + (i ? i.text : "") + this.text.slice(t), this.markDirty(), !0);
  }
  split(e) {
    let t = new Ft(this.text.slice(e));
    return this.text = this.text.slice(0, e), this.markDirty(), t.flags |= this.flags & 8, t;
  }
  localPosFromDOM(e, t) {
    return e == this.dom ? t : t ? this.text.length : 0;
  }
  domAtPos(e) {
    return new tt(this.dom, e);
  }
  domBoundsAround(e, t, i) {
    return { from: i, to: i + this.length, startDOM: this.dom, endDOM: this.dom.nextSibling };
  }
  coordsAt(e, t) {
    return ax(this.dom, e, t);
  }
}
class $n extends ke {
  constructor(e, t = [], i = 0) {
    super(), this.mark = e, this.children = t, this.length = i;
    for (let r of t)
      r.setParent(this);
  }
  setAttrs(e) {
    if (Xg(e), this.mark.class && (e.className = this.mark.class), this.mark.attrs)
      for (let t in this.mark.attrs)
        e.setAttribute(t, this.mark.attrs[t]);
    return e;
  }
  canReuseDOM(e) {
    return super.canReuseDOM(e) && !((this.flags | e.flags) & 8);
  }
  reuseDOM(e) {
    e.nodeName == this.mark.tagName.toUpperCase() && (this.setDOM(e), this.flags |= 6);
  }
  sync(e, t) {
    this.dom ? this.flags & 4 && this.setAttrs(this.dom) : this.setDOM(this.setAttrs(document.createElement(this.mark.tagName))), super.sync(e, t);
  }
  merge(e, t, i, r, s, o) {
    return i && (!(i instanceof $n && i.mark.eq(this.mark)) || e && s <= 0 || t < this.length && o <= 0) ? !1 : (Yg(this, e, t, i ? i.children.slice() : [], s - 1, o - 1), this.markDirty(), !0);
  }
  split(e) {
    let t = [], i = 0, r = -1, s = 0;
    for (let a of this.children) {
      let l = i + a.length;
      l > e && t.push(i < e ? a.split(e - i) : a), r < 0 && i >= e && (r = s), i = l, s++;
    }
    let o = this.length - e;
    return this.length = e, r > -1 && (this.children.length = r, this.markDirty()), new $n(this.mark, t, o);
  }
  domAtPos(e) {
    return Fg(this, e);
  }
  coordsAt(e, t) {
    return Hg(this, e, t);
  }
}
function ax(n, e, t) {
  let i = n.nodeValue.length;
  e > i && (e = i);
  let r = e, s = e, o = 0;
  e == 0 && t < 0 || e == i && t >= 0 ? W.chrome || W.gecko || (e ? (r--, o = 1) : s < i && (s++, o = -1)) : t < 0 ? r-- : s < i && s++;
  let a = wi(n, r, s).getClientRects();
  if (!a.length)
    return null;
  let l = a[(o ? o < 0 : t >= 0) ? 0 : a.length - 1];
  return W.safari && !o && l.width == 0 && (l = Array.prototype.find.call(a, (u) => u.width) || l), o ? Ba(l, o < 0) : l || null;
}
class Bn extends ke {
  static create(e, t, i) {
    return new Bn(e, t, i);
  }
  constructor(e, t, i) {
    super(), this.widget = e, this.length = t, this.side = i, this.prevWidget = null;
  }
  split(e) {
    let t = Bn.create(this.widget, this.length - e, this.side);
    return this.length -= e, t;
  }
  sync(e) {
    (!this.dom || !this.widget.updateDOM(this.dom, e)) && (this.dom && this.prevWidget && this.prevWidget.destroy(this.dom), this.prevWidget = null, this.setDOM(this.widget.toDOM(e)), this.widget.editable || (this.dom.contentEditable = "false"));
  }
  getSide() {
    return this.side;
  }
  merge(e, t, i, r, s, o) {
    return i && (!(i instanceof Bn) || !this.widget.compare(i.widget) || e > 0 && s <= 0 || t < this.length && o <= 0) ? !1 : (this.length = e + (i ? i.length : 0) + (this.length - t), !0);
  }
  become(e) {
    return e instanceof Bn && e.side == this.side && this.widget.constructor == e.widget.constructor ? (this.widget.compare(e.widget) || this.markDirty(!0), this.dom && !this.prevWidget && (this.prevWidget = this.widget), this.widget = e.widget, this.length = e.length, !0) : !1;
  }
  ignoreMutation() {
    return !0;
  }
  ignoreEvent(e) {
    return this.widget.ignoreEvent(e);
  }
  get overrideDOMText() {
    if (this.length == 0)
      return me.empty;
    let e = this;
    for (; e.parent; )
      e = e.parent;
    let { view: t } = e, i = t && t.state.doc, r = this.posAtStart;
    return i ? i.slice(r, r + this.length) : me.empty;
  }
  domAtPos(e) {
    return (this.length ? e == 0 : this.side > 0) ? tt.before(this.dom) : tt.after(this.dom, e == this.length);
  }
  domBoundsAround() {
    return null;
  }
  coordsAt(e, t) {
    let i = this.widget.coordsAt(this.dom, e, t);
    if (i)
      return i;
    let r = this.dom.getClientRects(), s = null;
    if (!r.length)
      return null;
    let o = this.side ? this.side < 0 : e > 0;
    for (let a = o ? r.length - 1 : 0; s = r[a], !(e > 0 ? a == 0 : a == r.length - 1 || s.top < s.bottom); a += o ? -1 : 1)
      ;
    return Ba(s, !o);
  }
  get isEditable() {
    return !1;
  }
  get isWidget() {
    return !0;
  }
  get isHidden() {
    return this.widget.isHidden;
  }
  destroy() {
    super.destroy(), this.dom && this.widget.destroy(this.dom);
  }
}
class nr extends ke {
  constructor(e) {
    super(), this.side = e;
  }
  get length() {
    return 0;
  }
  merge() {
    return !1;
  }
  become(e) {
    return e instanceof nr && e.side == this.side;
  }
  split() {
    return new nr(this.side);
  }
  sync() {
    if (!this.dom) {
      let e = document.createElement("img");
      e.className = "cm-widgetBuffer", e.setAttribute("aria-hidden", "true"), this.setDOM(e);
    }
  }
  getSide() {
    return this.side;
  }
  domAtPos(e) {
    return this.side > 0 ? tt.before(this.dom) : tt.after(this.dom);
  }
  localPosFromDOM() {
    return 0;
  }
  domBoundsAround() {
    return null;
  }
  coordsAt(e) {
    return this.dom.getBoundingClientRect();
  }
  get overrideDOMText() {
    return me.empty;
  }
  get isHidden() {
    return !0;
  }
}
Ft.prototype.children = Bn.prototype.children = nr.prototype.children = nh;
function Fg(n, e) {
  let t = n.dom, { children: i } = n, r = 0;
  for (let s = 0; r < i.length; r++) {
    let o = i[r], a = s + o.length;
    if (!(a == s && o.getSide() <= 0)) {
      if (e > s && e < a && o.dom.parentNode == t)
        return o.domAtPos(e - s);
      if (e <= s)
        break;
      s = a;
    }
  }
  for (let s = r; s > 0; s--) {
    let o = i[s - 1];
    if (o.dom.parentNode == t)
      return o.domAtPos(o.length);
  }
  for (let s = r; s < i.length; s++) {
    let o = i[s];
    if (o.dom.parentNode == t)
      return o.domAtPos(0);
  }
  return new tt(t, 0);
}
function Gg(n, e, t) {
  let i, { children: r } = n;
  t > 0 && e instanceof $n && r.length && (i = r[r.length - 1]) instanceof $n && i.mark.eq(e.mark) ? Gg(i, e.children[0], t - 1) : (r.push(e), e.setParent(n)), n.length += e.length;
}
function Hg(n, e, t) {
  let i = null, r = -1, s = null, o = -1;
  function a(u, c) {
    for (let h = 0, f = 0; h < u.children.length && f <= c; h++) {
      let d = u.children[h], p = f + d.length;
      p >= c && (d.children.length ? a(d, c - f) : (!s || s.isHidden && t > 0) && (p > c || f == p && d.getSide() > 0) ? (s = d, o = c - f) : (f < c || f == p && d.getSide() < 0 && !d.isHidden) && (i = d, r = c - f)), f = p;
    }
  }
  a(n, e);
  let l = (t < 0 ? i : s) || i || s;
  return l ? l.coordsAt(Math.max(0, l == i ? r : o), t) : lx(n);
}
function lx(n) {
  let e = n.dom.lastChild;
  if (!e)
    return n.dom.getBoundingClientRect();
  let t = tr(e);
  return t[t.length - 1] || null;
}
function Du(n, e) {
  for (let t in n)
    t == "class" && e.class ? e.class += " " + n.class : t == "style" && e.style ? e.style += ";" + n.style : e[t] = n[t];
  return e;
}
const Wf = /* @__PURE__ */ Object.create(null);
function ih(n, e, t) {
  if (n == e)
    return !0;
  n || (n = Wf), e || (e = Wf);
  let i = Object.keys(n), r = Object.keys(e);
  if (i.length - (t && i.indexOf(t) > -1 ? 1 : 0) != r.length - (t && r.indexOf(t) > -1 ? 1 : 0))
    return !1;
  for (let s of i)
    if (s != t && (r.indexOf(s) == -1 || n[s] !== e[s]))
      return !1;
  return !0;
}
function Iu(n, e, t) {
  let i = !1;
  if (e)
    for (let r in e)
      t && r in t || (i = !0, r == "style" ? n.style.cssText = "" : n.removeAttribute(r));
  if (t)
    for (let r in t)
      e && e[r] == t[r] || (i = !0, r == "style" ? n.style.cssText = t[r] : n.setAttribute(r, t[r]));
  return i;
}
function ux(n) {
  let e = /* @__PURE__ */ Object.create(null);
  for (let t = 0; t < n.attributes.length; t++) {
    let i = n.attributes[t];
    e[i.name] = i.value;
  }
  return e;
}
class Ne extends ke {
  constructor() {
    super(...arguments), this.children = [], this.length = 0, this.prevAttrs = void 0, this.attrs = null, this.breakAfter = 0;
  }
  // Consumes source
  merge(e, t, i, r, s, o) {
    if (i) {
      if (!(i instanceof Ne))
        return !1;
      this.dom || i.transferDOM(this);
    }
    return r && this.setDeco(i ? i.attrs : null), Yg(this, e, t, i ? i.children.slice() : [], s, o), !0;
  }
  split(e) {
    let t = new Ne();
    if (t.breakAfter = this.breakAfter, this.length == 0)
      return t;
    let { i, off: r } = this.childPos(e);
    r && (t.append(this.children[i].split(r), 0), this.children[i].merge(r, this.children[i].length, null, !1, 0, 0), i++);
    for (let s = i; s < this.children.length; s++)
      t.append(this.children[s], 0);
    for (; i > 0 && this.children[i - 1].length == 0; )
      this.children[--i].destroy();
    return this.children.length = i, this.markDirty(), this.length = e, t;
  }
  transferDOM(e) {
    this.dom && (this.markDirty(), e.setDOM(this.dom), e.prevAttrs = this.prevAttrs === void 0 ? this.attrs : this.prevAttrs, this.prevAttrs = void 0, this.dom = null);
  }
  setDeco(e) {
    ih(this.attrs, e) || (this.dom && (this.prevAttrs = this.attrs, this.markDirty()), this.attrs = e);
  }
  append(e, t) {
    Gg(this, e, t);
  }
  // Only called when building a line view in ContentBuilder
  addLineDeco(e) {
    let t = e.spec.attributes, i = e.spec.class;
    t && (this.attrs = Du(t, this.attrs || {})), i && (this.attrs = Du({ class: i }, this.attrs || {}));
  }
  domAtPos(e) {
    return Fg(this, e);
  }
  reuseDOM(e) {
    e.nodeName == "DIV" && (this.setDOM(e), this.flags |= 6);
  }
  sync(e, t) {
    var i;
    this.dom ? this.flags & 4 && (Xg(this.dom), this.dom.className = "cm-line", this.prevAttrs = this.attrs ? null : void 0) : (this.setDOM(document.createElement("div")), this.dom.className = "cm-line", this.prevAttrs = this.attrs ? null : void 0), this.prevAttrs !== void 0 && (Iu(this.dom, this.prevAttrs, this.attrs), this.dom.classList.add("cm-line"), this.prevAttrs = void 0), super.sync(e, t);
    let r = this.dom.lastChild;
    for (; r && ke.get(r) instanceof $n; )
      r = r.lastChild;
    if (!r || !this.length || r.nodeName != "BR" && ((i = ke.get(r)) === null || i === void 0 ? void 0 : i.isEditable) == !1 && (!W.ios || !this.children.some((s) => s instanceof Ft))) {
      let s = document.createElement("BR");
      s.cmIgnore = !0, this.dom.appendChild(s);
    }
  }
  measureTextSize() {
    if (this.children.length == 0 || this.length > 20)
      return null;
    let e = 0, t;
    for (let i of this.children) {
      if (!(i instanceof Ft) || /[^ -~]/.test(i.text))
        return null;
      let r = tr(i.dom);
      if (r.length != 1)
        return null;
      e += r[0].width, t = r[0].height;
    }
    return e ? {
      lineHeight: this.dom.getBoundingClientRect().height,
      charWidth: e / this.length,
      textHeight: t
    } : null;
  }
  coordsAt(e, t) {
    let i = Hg(this, e, t);
    if (!this.children.length && i && this.parent) {
      let { heightOracle: r } = this.parent.view.viewState, s = i.bottom - i.top;
      if (Math.abs(s - r.lineHeight) < 2 && r.textHeight < s) {
        let o = (s - r.textHeight) / 2;
        return { top: i.top + o, bottom: i.bottom - o, left: i.left, right: i.left };
      }
    }
    return i;
  }
  become(e) {
    return !1;
  }
  covers() {
    return !0;
  }
  static find(e, t) {
    for (let i = 0, r = 0; i < e.children.length; i++) {
      let s = e.children[i], o = r + s.length;
      if (o >= t) {
        if (s instanceof Ne)
          return s;
        if (o > t)
          break;
      }
      r = o + s.breakAfter;
    }
    return null;
  }
}
class vn extends ke {
  constructor(e, t, i) {
    super(), this.widget = e, this.length = t, this.deco = i, this.breakAfter = 0, this.prevWidget = null;
  }
  merge(e, t, i, r, s, o) {
    return i && (!(i instanceof vn) || !this.widget.compare(i.widget) || e > 0 && s <= 0 || t < this.length && o <= 0) ? !1 : (this.length = e + (i ? i.length : 0) + (this.length - t), !0);
  }
  domAtPos(e) {
    return e == 0 ? tt.before(this.dom) : tt.after(this.dom, e == this.length);
  }
  split(e) {
    let t = this.length - e;
    this.length = e;
    let i = new vn(this.widget, t, this.deco);
    return i.breakAfter = this.breakAfter, i;
  }
  get children() {
    return nh;
  }
  sync(e) {
    (!this.dom || !this.widget.updateDOM(this.dom, e)) && (this.dom && this.prevWidget && this.prevWidget.destroy(this.dom), this.prevWidget = null, this.setDOM(this.widget.toDOM(e)), this.widget.editable || (this.dom.contentEditable = "false"));
  }
  get overrideDOMText() {
    return this.parent ? this.parent.view.state.doc.slice(this.posAtStart, this.posAtEnd) : me.empty;
  }
  domBoundsAround() {
    return null;
  }
  become(e) {
    return e instanceof vn && e.widget.constructor == this.widget.constructor ? (e.widget.compare(this.widget) || this.markDirty(!0), this.dom && !this.prevWidget && (this.prevWidget = this.widget), this.widget = e.widget, this.length = e.length, this.deco = e.deco, this.breakAfter = e.breakAfter, !0) : !1;
  }
  ignoreMutation() {
    return !0;
  }
  ignoreEvent(e) {
    return this.widget.ignoreEvent(e);
  }
  get isEditable() {
    return !1;
  }
  get isWidget() {
    return !0;
  }
  coordsAt(e, t) {
    return this.widget.coordsAt(this.dom, e, t);
  }
  destroy() {
    super.destroy(), this.dom && this.widget.destroy(this.dom);
  }
  covers(e) {
    let { startSide: t, endSide: i } = this.deco;
    return t == i ? !1 : e < 0 ? t < 0 : i > 0;
  }
}
class mn {
  /**
  Compare this instance to another instance of the same type.
  (TypeScript can't express this, but only instances of the same
  specific class will be passed to this method.) This is used to
  avoid redrawing widgets when they are replaced by a new
  decoration of the same type. The default implementation just
  returns `false`, which will cause new instances of the widget to
  always be redrawn.
  */
  eq(e) {
    return !1;
  }
  /**
  Update a DOM element created by a widget of the same type (but
  different, non-`eq` content) to reflect this widget. May return
  true to indicate that it could update, false to indicate it
  couldn't (in which case the widget will be redrawn). The default
  implementation just returns false.
  */
  updateDOM(e, t) {
    return !1;
  }
  /**
  @internal
  */
  compare(e) {
    return this == e || this.constructor == e.constructor && this.eq(e);
  }
  /**
  The estimated height this widget will have, to be used when
  estimating the height of content that hasn't been drawn. May
  return -1 to indicate you don't know. The default implementation
  returns -1.
  */
  get estimatedHeight() {
    return -1;
  }
  /**
  For inline widgets that are displayed inline (as opposed to
  `inline-block`) and introduce line breaks (through `<br>` tags
  or textual newlines), this must indicate the amount of line
  breaks they introduce. Defaults to 0.
  */
  get lineBreaks() {
    return 0;
  }
  /**
  Can be used to configure which kinds of events inside the widget
  should be ignored by the editor. The default is to ignore all
  events.
  */
  ignoreEvent(e) {
    return !0;
  }
  /**
  Override the way screen coordinates for positions at/in the
  widget are found. `pos` will be the offset into the widget, and
  `side` the side of the position that is being queried—less than
  zero for before, greater than zero for after, and zero for
  directly at that position.
  */
  coordsAt(e, t, i) {
    return null;
  }
  /**
  @internal
  */
  get isHidden() {
    return !1;
  }
  /**
  @internal
  */
  get editable() {
    return !1;
  }
  /**
  This is called when the an instance of the widget is removed
  from the editor view.
  */
  destroy(e) {
  }
}
var Ot = /* @__PURE__ */ function(n) {
  return n[n.Text = 0] = "Text", n[n.WidgetBefore = 1] = "WidgetBefore", n[n.WidgetAfter = 2] = "WidgetAfter", n[n.WidgetRange = 3] = "WidgetRange", n;
}(Ot || (Ot = {}));
class F extends ki {
  constructor(e, t, i, r) {
    super(), this.startSide = e, this.endSide = t, this.widget = i, this.spec = r;
  }
  /**
  @internal
  */
  get heightRelevant() {
    return !1;
  }
  /**
  Create a mark decoration, which influences the styling of the
  content in its range. Nested mark decorations will cause nested
  DOM elements to be created. Nesting order is determined by
  precedence of the [facet](https://codemirror.net/6/docs/ref/#view.EditorView^decorations), with
  the higher-precedence decorations creating the inner DOM nodes.
  Such elements are split on line boundaries and on the boundaries
  of lower-precedence decorations.
  */
  static mark(e) {
    return new Ms(e);
  }
  /**
  Create a widget decoration, which displays a DOM element at the
  given position.
  */
  static widget(e) {
    let t = Math.max(-1e4, Math.min(1e4, e.side || 0)), i = !!e.block;
    return t += i && !e.inlineOrder ? t > 0 ? 3e8 : -4e8 : t > 0 ? 1e8 : -1e8, new Kn(e, t, t, i, e.widget || null, !1);
  }
  /**
  Create a replace decoration which replaces the given range with
  a widget, or simply hides it.
  */
  static replace(e) {
    let t = !!e.block, i, r;
    if (e.isBlockGap)
      i = -5e8, r = 4e8;
    else {
      let { start: s, end: o } = Kg(e, t);
      i = (s ? t ? -3e8 : -1 : 5e8) - 1, r = (o ? t ? 2e8 : 1 : -6e8) + 1;
    }
    return new Kn(e, i, r, t, e.widget || null, !0);
  }
  /**
  Create a line decoration, which can add DOM attributes to the
  line starting at the given position.
  */
  static line(e) {
    return new Zs(e);
  }
  /**
  Build a [`DecorationSet`](https://codemirror.net/6/docs/ref/#view.DecorationSet) from the given
  decorated range or ranges. If the ranges aren't already sorted,
  pass `true` for `sort` to make the library sort them for you.
  */
  static set(e, t = !1) {
    return de.of(e, t);
  }
  /**
  @internal
  */
  hasHeight() {
    return this.widget ? this.widget.estimatedHeight > -1 : !1;
  }
}
F.none = de.empty;
class Ms extends F {
  constructor(e) {
    let { start: t, end: i } = Kg(e);
    super(t ? -1 : 5e8, i ? 1 : -6e8, null, e), this.tagName = e.tagName || "span", this.class = e.class || "", this.attrs = e.attributes || null;
  }
  eq(e) {
    var t, i;
    return this == e || e instanceof Ms && this.tagName == e.tagName && (this.class || ((t = this.attrs) === null || t === void 0 ? void 0 : t.class)) == (e.class || ((i = e.attrs) === null || i === void 0 ? void 0 : i.class)) && ih(this.attrs, e.attrs, "class");
  }
  range(e, t = e) {
    if (e >= t)
      throw new RangeError("Mark decorations may not be empty");
    return super.range(e, t);
  }
}
Ms.prototype.point = !1;
class Zs extends F {
  constructor(e) {
    super(-2e8, -2e8, null, e);
  }
  eq(e) {
    return e instanceof Zs && this.spec.class == e.spec.class && ih(this.spec.attributes, e.spec.attributes);
  }
  range(e, t = e) {
    if (t != e)
      throw new RangeError("Line decoration ranges must be zero-length");
    return super.range(e, t);
  }
}
Zs.prototype.mapMode = Ge.TrackBefore;
Zs.prototype.point = !0;
class Kn extends F {
  constructor(e, t, i, r, s, o) {
    super(t, i, s, e), this.block = r, this.isReplace = o, this.mapMode = r ? t <= 0 ? Ge.TrackBefore : Ge.TrackAfter : Ge.TrackDel;
  }
  // Only relevant when this.block == true
  get type() {
    return this.startSide != this.endSide ? Ot.WidgetRange : this.startSide <= 0 ? Ot.WidgetBefore : Ot.WidgetAfter;
  }
  get heightRelevant() {
    return this.block || !!this.widget && (this.widget.estimatedHeight >= 5 || this.widget.lineBreaks > 0);
  }
  eq(e) {
    return e instanceof Kn && cx(this.widget, e.widget) && this.block == e.block && this.startSide == e.startSide && this.endSide == e.endSide;
  }
  range(e, t = e) {
    if (this.isReplace && (e > t || e == t && this.startSide > 0 && this.endSide <= 0))
      throw new RangeError("Invalid range for replacement decoration");
    if (!this.isReplace && t != e)
      throw new RangeError("Widget decorations can only have zero-length ranges");
    return super.range(e, t);
  }
}
Kn.prototype.point = !0;
function Kg(n, e = !1) {
  let { inclusiveStart: t, inclusiveEnd: i } = n;
  return t == null && (t = n.inclusive), i == null && (i = n.inclusive), { start: t ?? e, end: i ?? e };
}
function cx(n, e) {
  return n == e || !!(n && e && n.compare(e));
}
function Lu(n, e, t, i = 0) {
  let r = t.length - 1;
  r >= 0 && t[r] + i >= n ? t[r] = Math.max(t[r], e) : t.push(n, e);
}
class Ur {
  constructor(e, t, i, r) {
    this.doc = e, this.pos = t, this.end = i, this.disallowBlockEffectsFor = r, this.content = [], this.curLine = null, this.breakAtStart = 0, this.pendingBuffer = 0, this.bufferMarks = [], this.atCursorPos = !0, this.openStart = -1, this.openEnd = -1, this.text = "", this.textOff = 0, this.cursor = e.iter(), this.skip = t;
  }
  posCovered() {
    if (this.content.length == 0)
      return !this.breakAtStart && this.doc.lineAt(this.pos).from != this.pos;
    let e = this.content[this.content.length - 1];
    return !(e.breakAfter || e instanceof vn && e.deco.endSide < 0);
  }
  getLine() {
    return this.curLine || (this.content.push(this.curLine = new Ne()), this.atCursorPos = !0), this.curLine;
  }
  flushBuffer(e = this.bufferMarks) {
    this.pendingBuffer && (this.curLine.append(Hs(new nr(-1), e), e.length), this.pendingBuffer = 0);
  }
  addBlockWidget(e) {
    this.flushBuffer(), this.curLine = null, this.content.push(e);
  }
  finish(e) {
    this.pendingBuffer && e <= this.bufferMarks.length ? this.flushBuffer() : this.pendingBuffer = 0, !this.posCovered() && !(e && this.content.length && this.content[this.content.length - 1] instanceof vn) && this.getLine();
  }
  buildText(e, t, i) {
    for (; e > 0; ) {
      if (this.textOff == this.text.length) {
        let { value: s, lineBreak: o, done: a } = this.cursor.next(this.skip);
        if (this.skip = 0, a)
          throw new Error("Ran out of text content when drawing inline views");
        if (o) {
          this.posCovered() || this.getLine(), this.content.length ? this.content[this.content.length - 1].breakAfter = 1 : this.breakAtStart = 1, this.flushBuffer(), this.curLine = null, this.atCursorPos = !0, e--;
          continue;
        } else
          this.text = s, this.textOff = 0;
      }
      let r = Math.min(
        this.text.length - this.textOff,
        e,
        512
        /* T.Chunk */
      );
      this.flushBuffer(t.slice(t.length - i)), this.getLine().append(Hs(new Ft(this.text.slice(this.textOff, this.textOff + r)), t), i), this.atCursorPos = !0, this.textOff += r, e -= r, i = 0;
    }
  }
  span(e, t, i, r) {
    this.buildText(t - e, i, r), this.pos = t, this.openStart < 0 && (this.openStart = r);
  }
  point(e, t, i, r, s, o) {
    if (this.disallowBlockEffectsFor[o] && i instanceof Kn) {
      if (i.block)
        throw new RangeError("Block decorations may not be specified via plugins");
      if (t > this.doc.lineAt(this.pos).to)
        throw new RangeError("Decorations that replace line breaks may not be specified via plugins");
    }
    let a = t - e;
    if (i instanceof Kn)
      if (i.block)
        i.startSide > 0 && !this.posCovered() && this.getLine(), this.addBlockWidget(new vn(i.widget || ir.block, a, i));
      else {
        let l = Bn.create(i.widget || ir.inline, a, a ? 0 : i.startSide), u = this.atCursorPos && !l.isEditable && s <= r.length && (e < t || i.startSide > 0), c = !l.isEditable && (e < t || s > r.length || i.startSide <= 0), h = this.getLine();
        this.pendingBuffer == 2 && !u && !l.isEditable && (this.pendingBuffer = 0), this.flushBuffer(r), u && (h.append(Hs(new nr(1), r), s), s = r.length + Math.max(0, s - r.length)), h.append(Hs(l, r), s), this.atCursorPos = c, this.pendingBuffer = c ? e < t || s > r.length ? 1 : 2 : 0, this.pendingBuffer && (this.bufferMarks = r.slice());
      }
    else
      this.doc.lineAt(this.pos).from == this.pos && this.getLine().addLineDeco(i);
    a && (this.textOff + a <= this.text.length ? this.textOff += a : (this.skip += a - (this.text.length - this.textOff), this.text = "", this.textOff = 0), this.pos = t), this.openStart < 0 && (this.openStart = s);
  }
  static build(e, t, i, r, s) {
    let o = new Ur(e, t, i, s);
    return o.openEnd = de.spans(r, t, i, o), o.openStart < 0 && (o.openStart = o.openEnd), o.finish(o.openEnd), o;
  }
}
function Hs(n, e) {
  for (let t of e)
    n = new $n(t, [n], n.length);
  return n;
}
class ir extends mn {
  constructor(e) {
    super(), this.tag = e;
  }
  eq(e) {
    return e.tag == this.tag;
  }
  toDOM() {
    return document.createElement(this.tag);
  }
  updateDOM(e) {
    return e.nodeName.toLowerCase() == this.tag;
  }
  get isHidden() {
    return !0;
  }
}
ir.inline = /* @__PURE__ */ new ir("span");
ir.block = /* @__PURE__ */ new ir("div");
var Ae = /* @__PURE__ */ function(n) {
  return n[n.LTR = 0] = "LTR", n[n.RTL = 1] = "RTL", n;
}(Ae || (Ae = {}));
const Si = Ae.LTR, rh = Ae.RTL;
function Jg(n) {
  let e = [];
  for (let t = 0; t < n.length; t++)
    e.push(1 << +n[t]);
  return e;
}
const hx = /* @__PURE__ */ Jg("88888888888888888888888888888888888666888888787833333333337888888000000000000000000000000008888880000000000000000000000000088888888888888888888888888888888888887866668888088888663380888308888800000000000000000000000800000000000000000000000000000008"), fx = /* @__PURE__ */ Jg("4444448826627288999999999992222222222222222222222222222222222222222222222229999999999999999999994444444444644222822222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222999999949999999229989999223333333333"), _u = /* @__PURE__ */ Object.create(null), Jt = [];
for (let n of ["()", "[]", "{}"]) {
  let e = /* @__PURE__ */ n.charCodeAt(0), t = /* @__PURE__ */ n.charCodeAt(1);
  _u[e] = t, _u[t] = -e;
}
function eO(n) {
  return n <= 247 ? hx[n] : 1424 <= n && n <= 1524 ? 2 : 1536 <= n && n <= 1785 ? fx[n - 1536] : 1774 <= n && n <= 2220 ? 4 : 8192 <= n && n <= 8204 ? 256 : 64336 <= n && n <= 65023 ? 4 : 1;
}
const dx = /[\u0590-\u05f4\u0600-\u06ff\u0700-\u08ac\ufb50-\ufdff]/;
class Vn {
  /**
  The direction of this span.
  */
  get dir() {
    return this.level % 2 ? rh : Si;
  }
  /**
  @internal
  */
  constructor(e, t, i) {
    this.from = e, this.to = t, this.level = i;
  }
  /**
  @internal
  */
  side(e, t) {
    return this.dir == t == e ? this.to : this.from;
  }
  /**
  @internal
  */
  forward(e, t) {
    return e == (this.dir == t);
  }
  /**
  @internal
  */
  static find(e, t, i, r) {
    let s = -1;
    for (let o = 0; o < e.length; o++) {
      let a = e[o];
      if (a.from <= t && a.to >= t) {
        if (a.level == i)
          return o;
        (s < 0 || (r != 0 ? r < 0 ? a.from < t : a.to > t : e[s].level > a.level)) && (s = o);
      }
    }
    if (s < 0)
      throw new RangeError("Index out of range");
    return s;
  }
}
function tO(n, e) {
  if (n.length != e.length)
    return !1;
  for (let t = 0; t < n.length; t++) {
    let i = n[t], r = e[t];
    if (i.from != r.from || i.to != r.to || i.direction != r.direction || !tO(i.inner, r.inner))
      return !1;
  }
  return !0;
}
const ye = [];
function px(n, e, t, i, r) {
  for (let s = 0; s <= i.length; s++) {
    let o = s ? i[s - 1].to : e, a = s < i.length ? i[s].from : t, l = s ? 256 : r;
    for (let u = o, c = l, h = l; u < a; u++) {
      let f = eO(n.charCodeAt(u));
      f == 512 ? f = c : f == 8 && h == 4 && (f = 16), ye[u] = f == 4 ? 2 : f, f & 7 && (h = f), c = f;
    }
    for (let u = o, c = l, h = l; u < a; u++) {
      let f = ye[u];
      if (f == 128)
        u < a - 1 && c == ye[u + 1] && c & 24 ? f = ye[u] = c : ye[u] = 256;
      else if (f == 64) {
        let d = u + 1;
        for (; d < a && ye[d] == 64; )
          d++;
        let p = u && c == 8 || d < t && ye[d] == 8 ? h == 1 ? 1 : 8 : 256;
        for (let g = u; g < d; g++)
          ye[g] = p;
        u = d - 1;
      } else
        f == 8 && h == 1 && (ye[u] = 1);
      c = f, f & 7 && (h = f);
    }
  }
}
function mx(n, e, t, i, r) {
  let s = r == 1 ? 2 : 1;
  for (let o = 0, a = 0, l = 0; o <= i.length; o++) {
    let u = o ? i[o - 1].to : e, c = o < i.length ? i[o].from : t;
    for (let h = u, f, d, p; h < c; h++)
      if (d = _u[f = n.charCodeAt(h)])
        if (d < 0) {
          for (let g = a - 3; g >= 0; g -= 3)
            if (Jt[g + 1] == -d) {
              let O = Jt[g + 2], m = O & 2 ? r : O & 4 ? O & 1 ? s : r : 0;
              m && (ye[h] = ye[Jt[g]] = m), a = g;
              break;
            }
        } else {
          if (Jt.length == 189)
            break;
          Jt[a++] = h, Jt[a++] = f, Jt[a++] = l;
        }
      else if ((p = ye[h]) == 2 || p == 1) {
        let g = p == r;
        l = g ? 0 : 1;
        for (let O = a - 3; O >= 0; O -= 3) {
          let m = Jt[O + 2];
          if (m & 2)
            break;
          if (g)
            Jt[O + 2] |= 2;
          else {
            if (m & 4)
              break;
            Jt[O + 2] |= 4;
          }
        }
      }
  }
}
function gx(n, e, t, i) {
  for (let r = 0, s = i; r <= t.length; r++) {
    let o = r ? t[r - 1].to : n, a = r < t.length ? t[r].from : e;
    for (let l = o; l < a; ) {
      let u = ye[l];
      if (u == 256) {
        let c = l + 1;
        for (; ; )
          if (c == a) {
            if (r == t.length)
              break;
            c = t[r++].to, a = r < t.length ? t[r].from : e;
          } else if (ye[c] == 256)
            c++;
          else
            break;
        let h = s == 1, f = (c < e ? ye[c] : i) == 1, d = h == f ? h ? 1 : 2 : i;
        for (let p = c, g = r, O = g ? t[g - 1].to : n; p > l; )
          p == O && (p = t[--g].from, O = g ? t[g - 1].to : n), ye[--p] = d;
        l = c;
      } else
        s = u, l++;
    }
  }
}
function Xu(n, e, t, i, r, s, o) {
  let a = i % 2 ? 2 : 1;
  if (i % 2 == r % 2)
    for (let l = e, u = 0; l < t; ) {
      let c = !0, h = !1;
      if (u == s.length || l < s[u].from) {
        let g = ye[l];
        g != a && (c = !1, h = g == 16);
      }
      let f = !c && a == 1 ? [] : null, d = c ? i : i + 1, p = l;
      e:
        for (; ; )
          if (u < s.length && p == s[u].from) {
            if (h)
              break e;
            let g = s[u];
            if (!c)
              for (let O = g.to, m = u + 1; ; ) {
                if (O == t)
                  break e;
                if (m < s.length && s[m].from == O)
                  O = s[m++].to;
                else {
                  if (ye[O] == a)
                    break e;
                  break;
                }
              }
            if (u++, f)
              f.push(g);
            else {
              g.from > l && o.push(new Vn(l, g.from, d));
              let O = g.direction == Si != !(d % 2);
              Nu(n, O ? i + 1 : i, r, g.inner, g.from, g.to, o), l = g.to;
            }
            p = g.to;
          } else {
            if (p == t || (c ? ye[p] != a : ye[p] == a))
              break;
            p++;
          }
      f ? Xu(n, l, p, i + 1, r, f, o) : l < p && o.push(new Vn(l, p, d)), l = p;
    }
  else
    for (let l = t, u = s.length; l > e; ) {
      let c = !0, h = !1;
      if (!u || l > s[u - 1].to) {
        let g = ye[l - 1];
        g != a && (c = !1, h = g == 16);
      }
      let f = !c && a == 1 ? [] : null, d = c ? i : i + 1, p = l;
      e:
        for (; ; )
          if (u && p == s[u - 1].to) {
            if (h)
              break e;
            let g = s[--u];
            if (!c)
              for (let O = g.from, m = u; ; ) {
                if (O == e)
                  break e;
                if (m && s[m - 1].to == O)
                  O = s[--m].from;
                else {
                  if (ye[O - 1] == a)
                    break e;
                  break;
                }
              }
            if (f)
              f.push(g);
            else {
              g.to < l && o.push(new Vn(g.to, l, d));
              let O = g.direction == Si != !(d % 2);
              Nu(n, O ? i + 1 : i, r, g.inner, g.from, g.to, o), l = g.from;
            }
            p = g.from;
          } else {
            if (p == e || (c ? ye[p - 1] != a : ye[p - 1] == a))
              break;
            p--;
          }
      f ? Xu(n, p, l, i + 1, r, f, o) : p < l && o.push(new Vn(p, l, d)), l = p;
    }
}
function Nu(n, e, t, i, r, s, o) {
  let a = e % 2 ? 2 : 1;
  px(n, r, s, i, a), mx(n, r, s, i, a), gx(r, s, i, a), Xu(n, r, s, e, t, i, o);
}
function Ox(n, e, t) {
  if (!n)
    return [new Vn(0, 0, e == rh ? 1 : 0)];
  if (e == Si && !t.length && !dx.test(n))
    return nO(n.length);
  if (t.length)
    for (; n.length > ye.length; )
      ye[ye.length] = 256;
  let i = [], r = e == Si ? 0 : 1;
  return Nu(n, r, r, t, 0, n.length, i), i;
}
function nO(n) {
  return [new Vn(0, n, 0)];
}
let iO = "";
function bx(n, e, t, i, r) {
  var s;
  let o = i.head - n.from, a = Vn.find(e, o, (s = i.bidiLevel) !== null && s !== void 0 ? s : -1, i.assoc), l = e[a], u = l.side(r, t);
  if (o == u) {
    let f = a += r ? 1 : -1;
    if (f < 0 || f >= e.length)
      return null;
    l = e[a = f], o = l.side(!r, t), u = l.side(r, t);
  }
  let c = Ke(n.text, o, l.forward(r, t));
  (c < l.from || c > l.to) && (c = u), iO = n.text.slice(Math.min(o, c), Math.max(o, c));
  let h = a == (r ? e.length - 1 : 0) ? null : e[a + (r ? 1 : -1)];
  return h && c == u && h.level + (r ? 0 : 1) < l.level ? $.cursor(h.side(!r, t) + n.from, h.forward(r, t) ? 1 : -1, h.level) : $.cursor(c + n.from, l.forward(r, t) ? -1 : 1, l.level);
}
function yx(n, e, t) {
  for (let i = e; i < t; i++) {
    let r = eO(n.charCodeAt(i));
    if (r == 1)
      return Si;
    if (r == 2 || r == 4)
      return rh;
  }
  return Si;
}
const rO = /* @__PURE__ */ N.define(), sO = /* @__PURE__ */ N.define(), oO = /* @__PURE__ */ N.define(), aO = /* @__PURE__ */ N.define(), Wu = /* @__PURE__ */ N.define(), lO = /* @__PURE__ */ N.define(), uO = /* @__PURE__ */ N.define(), cO = /* @__PURE__ */ N.define({
  combine: (n) => n.some((e) => e)
}), hO = /* @__PURE__ */ N.define({
  combine: (n) => n.some((e) => e)
}), fO = /* @__PURE__ */ N.define();
class ji {
  constructor(e, t = "nearest", i = "nearest", r = 5, s = 5, o = !1) {
    this.range = e, this.y = t, this.x = i, this.yMargin = r, this.xMargin = s, this.isSnapshot = o;
  }
  map(e) {
    return e.empty ? this : new ji(this.range.map(e), this.y, this.x, this.yMargin, this.xMargin, this.isSnapshot);
  }
  clip(e) {
    return this.range.to <= e.doc.length ? this : new ji($.cursor(e.doc.length), this.y, this.x, this.yMargin, this.xMargin, this.isSnapshot);
  }
}
const Ks = /* @__PURE__ */ te.define({ map: (n, e) => n.map(e) });
function mt(n, e, t) {
  let i = n.facet(aO);
  i.length ? i[0](e) : window.onerror ? window.onerror(String(e), t, void 0, void 0, e) : t ? console.error(t + ":", e) : console.error(e);
}
const Ya = /* @__PURE__ */ N.define({ combine: (n) => n.length ? n[0] : !0 });
let kx = 0;
const Lr = /* @__PURE__ */ N.define();
class Ie {
  constructor(e, t, i, r, s) {
    this.id = e, this.create = t, this.domEventHandlers = i, this.domEventObservers = r, this.extension = s(this);
  }
  /**
  Define a plugin from a constructor function that creates the
  plugin's value, given an editor view.
  */
  static define(e, t) {
    const { eventHandlers: i, eventObservers: r, provide: s, decorations: o } = t || {};
    return new Ie(kx++, e, i, r, (a) => {
      let l = [Lr.of(a)];
      return o && l.push(os.of((u) => {
        let c = u.plugin(a);
        return c ? o(c) : F.none;
      })), s && l.push(s(a)), l;
    });
  }
  /**
  Create a plugin for a class whose constructor takes a single
  editor view as argument.
  */
  static fromClass(e, t) {
    return Ie.define((i) => new e(i), t);
  }
}
class Ol {
  constructor(e) {
    this.spec = e, this.mustUpdate = null, this.value = null;
  }
  update(e) {
    if (this.value) {
      if (this.mustUpdate) {
        let t = this.mustUpdate;
        if (this.mustUpdate = null, this.value.update)
          try {
            this.value.update(t);
          } catch (i) {
            if (mt(t.state, i, "CodeMirror plugin crashed"), this.value.destroy)
              try {
                this.value.destroy();
              } catch {
              }
            this.deactivate();
          }
      }
    } else if (this.spec)
      try {
        this.value = this.spec.create(e);
      } catch (t) {
        mt(e.state, t, "CodeMirror plugin crashed"), this.deactivate();
      }
    return this;
  }
  destroy(e) {
    var t;
    if (!((t = this.value) === null || t === void 0) && t.destroy)
      try {
        this.value.destroy();
      } catch (i) {
        mt(e.state, i, "CodeMirror plugin crashed");
      }
  }
  deactivate() {
    this.spec = this.value = null;
  }
}
const dO = /* @__PURE__ */ N.define(), sh = /* @__PURE__ */ N.define(), os = /* @__PURE__ */ N.define(), pO = /* @__PURE__ */ N.define(), oh = /* @__PURE__ */ N.define(), mO = /* @__PURE__ */ N.define();
function qf(n, e) {
  let t = n.state.facet(mO);
  if (!t.length)
    return t;
  let i = t.map((s) => s instanceof Function ? s(n) : s), r = [];
  return de.spans(i, e.from, e.to, {
    point() {
    },
    span(s, o, a, l) {
      let u = s - e.from, c = o - e.from, h = r;
      for (let f = a.length - 1; f >= 0; f--, l--) {
        let d = a[f].spec.bidiIsolate, p;
        if (d == null && (d = yx(e.text, u, c)), l > 0 && h.length && (p = h[h.length - 1]).to == u && p.direction == d)
          p.to = c, h = p.inner;
        else {
          let g = { from: u, to: c, direction: d, inner: [] };
          h.push(g), h = g.inner;
        }
      }
    }
  }), r;
}
const gO = /* @__PURE__ */ N.define();
function OO(n) {
  let e = 0, t = 0, i = 0, r = 0;
  for (let s of n.state.facet(gO)) {
    let o = s(n);
    o && (o.left != null && (e = Math.max(e, o.left)), o.right != null && (t = Math.max(t, o.right)), o.top != null && (i = Math.max(i, o.top)), o.bottom != null && (r = Math.max(r, o.bottom)));
  }
  return { left: e, right: t, top: i, bottom: r };
}
const _r = /* @__PURE__ */ N.define();
class zt {
  constructor(e, t, i, r) {
    this.fromA = e, this.toA = t, this.fromB = i, this.toB = r;
  }
  join(e) {
    return new zt(Math.min(this.fromA, e.fromA), Math.max(this.toA, e.toA), Math.min(this.fromB, e.fromB), Math.max(this.toB, e.toB));
  }
  addToSet(e) {
    let t = e.length, i = this;
    for (; t > 0; t--) {
      let r = e[t - 1];
      if (!(r.fromA > i.toA)) {
        if (r.toA < i.fromA)
          break;
        i = i.join(r), e.splice(t - 1, 1);
      }
    }
    return e.splice(t, 0, i), e;
  }
  static extendWithRanges(e, t) {
    if (t.length == 0)
      return e;
    let i = [];
    for (let r = 0, s = 0, o = 0, a = 0; ; r++) {
      let l = r == e.length ? null : e[r], u = o - a, c = l ? l.fromB : 1e9;
      for (; s < t.length && t[s] < c; ) {
        let h = t[s], f = t[s + 1], d = Math.max(a, h), p = Math.min(c, f);
        if (d <= p && new zt(d + u, p + u, d, p).addToSet(i), f > c)
          break;
        s += 2;
      }
      if (!l)
        return i;
      new zt(l.fromA, l.toA, l.fromB, l.toB).addToSet(i), o = l.toA, a = l.toB;
    }
  }
}
class sa {
  constructor(e, t, i) {
    this.view = e, this.state = t, this.transactions = i, this.flags = 0, this.startState = e.state, this.changes = We.empty(this.startState.doc.length);
    for (let s of i)
      this.changes = this.changes.compose(s.changes);
    let r = [];
    this.changes.iterChangedRanges((s, o, a, l) => r.push(new zt(s, o, a, l))), this.changedRanges = r;
  }
  /**
  @internal
  */
  static create(e, t, i) {
    return new sa(e, t, i);
  }
  /**
  Tells you whether the [viewport](https://codemirror.net/6/docs/ref/#view.EditorView.viewport) or
  [visible ranges](https://codemirror.net/6/docs/ref/#view.EditorView.visibleRanges) changed in this
  update.
  */
  get viewportChanged() {
    return (this.flags & 4) > 0;
  }
  /**
  Indicates whether the height of a block element in the editor
  changed in this update.
  */
  get heightChanged() {
    return (this.flags & 2) > 0;
  }
  /**
  Returns true when the document was modified or the size of the
  editor, or elements within the editor, changed.
  */
  get geometryChanged() {
    return this.docChanged || (this.flags & 10) > 0;
  }
  /**
  True when this update indicates a focus change.
  */
  get focusChanged() {
    return (this.flags & 1) > 0;
  }
  /**
  Whether the document changed in this update.
  */
  get docChanged() {
    return !this.changes.empty;
  }
  /**
  Whether the selection was explicitly set in this update.
  */
  get selectionSet() {
    return this.transactions.some((e) => e.selection);
  }
  /**
  @internal
  */
  get empty() {
    return this.flags == 0 && this.transactions.length == 0;
  }
}
class Bf extends ke {
  get length() {
    return this.view.state.doc.length;
  }
  constructor(e) {
    super(), this.view = e, this.decorations = [], this.dynamicDecorationMap = [], this.domChanged = null, this.hasComposition = null, this.markedForComposition = /* @__PURE__ */ new Set(), this.lastCompositionAfterCursor = !1, this.minWidth = 0, this.minWidthFrom = 0, this.minWidthTo = 0, this.impreciseAnchor = null, this.impreciseHead = null, this.forceSelection = !1, this.lastUpdate = Date.now(), this.setDOM(e.contentDOM), this.children = [new Ne()], this.children[0].setParent(this), this.updateDeco(), this.updateInner([new zt(0, 0, 0, e.state.doc.length)], 0, null);
  }
  // Update the document view to a given state.
  update(e) {
    var t;
    let i = e.changedRanges;
    this.minWidth > 0 && i.length && (i.every(({ fromA: u, toA: c }) => c < this.minWidthFrom || u > this.minWidthTo) ? (this.minWidthFrom = e.changes.mapPos(this.minWidthFrom, 1), this.minWidthTo = e.changes.mapPos(this.minWidthTo, 1)) : this.minWidth = this.minWidthFrom = this.minWidthTo = 0);
    let r = -1;
    this.view.inputState.composing >= 0 && (!((t = this.domChanged) === null || t === void 0) && t.newSel ? r = this.domChanged.newSel.head : !$x(e.changes, this.hasComposition) && !e.selectionSet && (r = e.state.selection.main.head));
    let s = r > -1 ? wx(this.view, e.changes, r) : null;
    if (this.domChanged = null, this.hasComposition) {
      this.markedForComposition.clear();
      let { from: u, to: c } = this.hasComposition;
      i = new zt(u, c, e.changes.mapPos(u, -1), e.changes.mapPos(c, 1)).addToSet(i.slice());
    }
    this.hasComposition = s ? { from: s.range.fromB, to: s.range.toB } : null, (W.ie || W.chrome) && !s && e && e.state.doc.lines != e.startState.doc.lines && (this.forceSelection = !0);
    let o = this.decorations, a = this.updateDeco(), l = Px(o, a, e.changes);
    return i = zt.extendWithRanges(i, l), !(this.flags & 7) && i.length == 0 ? !1 : (this.updateInner(i, e.startState.doc.length, s), e.transactions.length && (this.lastUpdate = Date.now()), !0);
  }
  // Used by update and the constructor do perform the actual DOM
  // update
  updateInner(e, t, i) {
    this.view.viewState.mustMeasureContent = !0, this.updateChildren(e, t, i);
    let { observer: r } = this.view;
    r.ignore(() => {
      this.dom.style.height = this.view.viewState.contentHeight / this.view.scaleY + "px", this.dom.style.flexBasis = this.minWidth ? this.minWidth + "px" : "";
      let o = W.chrome || W.ios ? { node: r.selectionRange.focusNode, written: !1 } : void 0;
      this.sync(this.view, o), this.flags &= -8, o && (o.written || r.selectionRange.focusNode != o.node) && (this.forceSelection = !0), this.dom.style.height = "";
    }), this.markedForComposition.forEach(
      (o) => o.flags &= -9
      /* ViewFlag.Composition */
    );
    let s = [];
    if (this.view.viewport.from || this.view.viewport.to < this.view.state.doc.length)
      for (let o of this.children)
        o instanceof vn && o.widget instanceof Vf && s.push(o.dom);
    r.updateGaps(s);
  }
  updateChildren(e, t, i) {
    let r = i ? i.range.addToSet(e.slice()) : e, s = this.childCursor(t);
    for (let o = r.length - 1; ; o--) {
      let a = o >= 0 ? r[o] : null;
      if (!a)
        break;
      let { fromA: l, toA: u, fromB: c, toB: h } = a, f, d, p, g;
      if (i && i.range.fromB < h && i.range.toB > c) {
        let Q = Ur.build(this.view.state.doc, c, i.range.fromB, this.decorations, this.dynamicDecorationMap), v = Ur.build(this.view.state.doc, i.range.toB, h, this.decorations, this.dynamicDecorationMap);
        d = Q.breakAtStart, p = Q.openStart, g = v.openEnd;
        let k = this.compositionView(i);
        v.breakAtStart ? k.breakAfter = 1 : v.content.length && k.merge(k.length, k.length, v.content[0], !1, v.openStart, 0) && (k.breakAfter = v.content[0].breakAfter, v.content.shift()), Q.content.length && k.merge(0, 0, Q.content[Q.content.length - 1], !0, 0, Q.openEnd) && Q.content.pop(), f = Q.content.concat(k).concat(v.content);
      } else
        ({ content: f, breakAtStart: d, openStart: p, openEnd: g } = Ur.build(this.view.state.doc, c, h, this.decorations, this.dynamicDecorationMap));
      let { i: O, off: m } = s.findPos(u, 1), { i: b, off: w } = s.findPos(l, -1);
      Vg(this, b, w, O, m, f, d, p, g);
    }
    i && this.fixCompositionDOM(i);
  }
  compositionView(e) {
    let t = new Ft(e.text.nodeValue);
    t.flags |= 8;
    for (let { deco: r } of e.marks)
      t = new $n(r, [t], t.length);
    let i = new Ne();
    return i.append(t, 0), i;
  }
  fixCompositionDOM(e) {
    let t = (s, o) => {
      o.flags |= 8 | (o.children.some(
        (l) => l.flags & 7
        /* ViewFlag.Dirty */
      ) ? 1 : 0), this.markedForComposition.add(o);
      let a = ke.get(s);
      a && a != o && (a.dom = null), o.setDOM(s);
    }, i = this.childPos(e.range.fromB, 1), r = this.children[i.i];
    t(e.line, r);
    for (let s = e.marks.length - 1; s >= -1; s--)
      i = r.childPos(i.off, 1), r = r.children[i.i], t(s >= 0 ? e.marks[s].node : e.text, r);
  }
  // Sync the DOM selection to this.state.selection
  updateSelection(e = !1, t = !1) {
    (e || !this.view.observer.selectionRange.focusNode) && this.view.observer.readSelectionRange();
    let i = this.view.root.activeElement, r = i == this.dom, s = !r && _o(this.dom, this.view.observer.selectionRange) && !(i && this.dom.contains(i));
    if (!(r || t || s))
      return;
    let o = this.forceSelection;
    this.forceSelection = !1;
    let a = this.view.state.selection.main, l = this.moveToLine(this.domAtPos(a.anchor)), u = a.empty ? l : this.moveToLine(this.domAtPos(a.head));
    if (W.gecko && a.empty && !this.hasComposition && xx(l)) {
      let h = document.createTextNode("");
      this.view.observer.ignore(() => l.node.insertBefore(h, l.node.childNodes[l.offset] || null)), l = u = new tt(h, 0), o = !0;
    }
    let c = this.view.observer.selectionRange;
    (o || !c.focusNode || (!jr(l.node, l.offset, c.anchorNode, c.anchorOffset) || !jr(u.node, u.offset, c.focusNode, c.focusOffset)) && !this.suppressWidgetCursorChange(c, a)) && (this.view.observer.ignore(() => {
      W.android && W.chrome && this.dom.contains(c.focusNode) && Qx(c.focusNode, this.dom) && (this.dom.blur(), this.dom.focus({ preventScroll: !0 }));
      let h = ia(this.view.root);
      if (h)
        if (a.empty) {
          if (W.gecko) {
            let f = Sx(l.node, l.offset);
            if (f && f != 3) {
              let d = (f == 1 ? Wg : qg)(l.node, l.offset);
              d && (l = new tt(d.node, d.offset));
            }
          }
          h.collapse(l.node, l.offset), a.bidiLevel != null && h.caretBidiLevel !== void 0 && (h.caretBidiLevel = a.bidiLevel);
        } else if (h.extend) {
          h.collapse(l.node, l.offset);
          try {
            h.extend(u.node, u.offset);
          } catch {
          }
        } else {
          let f = document.createRange();
          a.anchor > a.head && ([l, u] = [u, l]), f.setEnd(u.node, u.offset), f.setStart(l.node, l.offset), h.removeAllRanges(), h.addRange(f);
        }
      s && this.view.root.activeElement == this.dom && (this.dom.blur(), i && i.focus());
    }), this.view.observer.setSelectionRange(l, u)), this.impreciseAnchor = l.precise ? null : new tt(c.anchorNode, c.anchorOffset), this.impreciseHead = u.precise ? null : new tt(c.focusNode, c.focusOffset);
  }
  // If a zero-length widget is inserted next to the cursor during
  // composition, avoid moving it across it and disrupting the
  // composition.
  suppressWidgetCursorChange(e, t) {
    return this.hasComposition && t.empty && jr(e.focusNode, e.focusOffset, e.anchorNode, e.anchorOffset) && this.posFromDOM(e.focusNode, e.focusOffset) == t.head;
  }
  enforceCursorAssoc() {
    if (this.hasComposition)
      return;
    let { view: e } = this, t = e.state.selection.main, i = ia(e.root), { anchorNode: r, anchorOffset: s } = e.observer.selectionRange;
    if (!i || !t.empty || !t.assoc || !i.modify)
      return;
    let o = Ne.find(this, t.head);
    if (!o)
      return;
    let a = o.posAtStart;
    if (t.head == a || t.head == a + o.length)
      return;
    let l = this.coordsAt(t.head, -1), u = this.coordsAt(t.head, 1);
    if (!l || !u || l.bottom > u.top)
      return;
    let c = this.domAtPos(t.head + t.assoc);
    i.collapse(c.node, c.offset), i.modify("move", t.assoc < 0 ? "forward" : "backward", "lineboundary"), e.observer.readSelectionRange();
    let h = e.observer.selectionRange;
    e.docView.posFromDOM(h.anchorNode, h.anchorOffset) != t.from && i.collapse(r, s);
  }
  // If a position is in/near a block widget, move it to a nearby text
  // line, since we don't want the cursor inside a block widget.
  moveToLine(e) {
    let t = this.dom, i;
    if (e.node != t)
      return e;
    for (let r = e.offset; !i && r < t.childNodes.length; r++) {
      let s = ke.get(t.childNodes[r]);
      s instanceof Ne && (i = s.domAtPos(0));
    }
    for (let r = e.offset - 1; !i && r >= 0; r--) {
      let s = ke.get(t.childNodes[r]);
      s instanceof Ne && (i = s.domAtPos(s.length));
    }
    return i ? new tt(i.node, i.offset, !0) : e;
  }
  nearest(e) {
    for (let t = e; t; ) {
      let i = ke.get(t);
      if (i && i.rootView == this)
        return i;
      t = t.parentNode;
    }
    return null;
  }
  posFromDOM(e, t) {
    let i = this.nearest(e);
    if (!i)
      throw new RangeError("Trying to find position for a DOM position outside of the document");
    return i.localPosFromDOM(e, t) + i.posAtStart;
  }
  domAtPos(e) {
    let { i: t, off: i } = this.childCursor().findPos(e, -1);
    for (; t < this.children.length - 1; ) {
      let r = this.children[t];
      if (i < r.length || r instanceof Ne)
        break;
      t++, i = 0;
    }
    return this.children[t].domAtPos(i);
  }
  coordsAt(e, t) {
    let i = null, r = 0;
    for (let s = this.length, o = this.children.length - 1; o >= 0; o--) {
      let a = this.children[o], l = s - a.breakAfter, u = l - a.length;
      if (l < e)
        break;
      if (u <= e && (u < e || a.covers(-1)) && (l > e || a.covers(1)) && (!i || a instanceof Ne && !(i instanceof Ne && t >= 0)))
        i = a, r = u;
      else if (i && u == e && l == e && a instanceof vn && Math.abs(t) < 2) {
        if (a.deco.startSide < 0)
          break;
        o && (i = null);
      }
      s = u;
    }
    return i ? i.coordsAt(e - r, t) : null;
  }
  coordsForChar(e) {
    let { i: t, off: i } = this.childPos(e, 1), r = this.children[t];
    if (!(r instanceof Ne))
      return null;
    for (; r.children.length; ) {
      let { i: a, off: l } = r.childPos(i, 1);
      for (; ; a++) {
        if (a == r.children.length)
          return null;
        if ((r = r.children[a]).length)
          break;
      }
      i = l;
    }
    if (!(r instanceof Ft))
      return null;
    let s = Ke(r.text, i);
    if (s == i)
      return null;
    let o = wi(r.dom, i, s).getClientRects();
    for (let a = 0; a < o.length; a++) {
      let l = o[a];
      if (a == o.length - 1 || l.top < l.bottom && l.left < l.right)
        return l;
    }
    return null;
  }
  measureVisibleLineHeights(e) {
    let t = [], { from: i, to: r } = e, s = this.view.contentDOM.clientWidth, o = s > Math.max(this.view.scrollDOM.clientWidth, this.minWidth) + 1, a = -1, l = this.view.textDirection == Ae.LTR;
    for (let u = 0, c = 0; c < this.children.length; c++) {
      let h = this.children[c], f = u + h.length;
      if (f > r)
        break;
      if (u >= i) {
        let d = h.dom.getBoundingClientRect();
        if (t.push(d.height), o) {
          let p = h.dom.lastChild, g = p ? tr(p) : [];
          if (g.length) {
            let O = g[g.length - 1], m = l ? O.right - d.left : d.right - O.left;
            m > a && (a = m, this.minWidth = s, this.minWidthFrom = u, this.minWidthTo = f);
          }
        }
      }
      u = f + h.breakAfter;
    }
    return t;
  }
  textDirectionAt(e) {
    let { i: t } = this.childPos(e, 1);
    return getComputedStyle(this.children[t].dom).direction == "rtl" ? Ae.RTL : Ae.LTR;
  }
  measureTextSize() {
    for (let s of this.children)
      if (s instanceof Ne) {
        let o = s.measureTextSize();
        if (o)
          return o;
      }
    let e = document.createElement("div"), t, i, r;
    return e.className = "cm-line", e.style.width = "99999px", e.style.position = "absolute", e.textContent = "abc def ghi jkl mno pqr stu", this.view.observer.ignore(() => {
      this.dom.appendChild(e);
      let s = tr(e.firstChild)[0];
      t = e.getBoundingClientRect().height, i = s ? s.width / 27 : 7, r = s ? s.height : t, e.remove();
    }), { lineHeight: t, charWidth: i, textHeight: r };
  }
  childCursor(e = this.length) {
    let t = this.children.length;
    return t && (e -= this.children[--t].length), new Bg(this.children, e, t);
  }
  computeBlockGapDeco() {
    let e = [], t = this.view.viewState;
    for (let i = 0, r = 0; ; r++) {
      let s = r == t.viewports.length ? null : t.viewports[r], o = s ? s.from - 1 : this.length;
      if (o > i) {
        let a = (t.lineBlockAt(o).bottom - t.lineBlockAt(i).top) / this.view.scaleY;
        e.push(F.replace({
          widget: new Vf(a),
          block: !0,
          inclusive: !0,
          isBlockGap: !0
        }).range(i, o));
      }
      if (!s)
        break;
      i = s.to + 1;
    }
    return F.set(e);
  }
  updateDeco() {
    let e = 0, t = this.view.state.facet(os).map((s) => (this.dynamicDecorationMap[e++] = typeof s == "function") ? s(this.view) : s), i = !1, r = this.view.state.facet(pO).map((s, o) => {
      let a = typeof s == "function";
      return a && (i = !0), a ? s(this.view) : s;
    });
    for (r.length && (this.dynamicDecorationMap[e++] = i, t.push(de.join(r))), this.decorations = [
      ...t,
      this.computeBlockGapDeco(),
      this.view.viewState.lineGapDeco
    ]; e < this.decorations.length; )
      this.dynamicDecorationMap[e++] = !1;
    return this.decorations;
  }
  scrollIntoView(e) {
    if (e.isSnapshot) {
      let u = this.view.viewState.lineBlockAt(e.range.head);
      this.view.scrollDOM.scrollTop = u.top - e.yMargin, this.view.scrollDOM.scrollLeft = e.xMargin;
      return;
    }
    for (let u of this.view.state.facet(fO))
      try {
        if (u(this.view, e.range, e))
          return !0;
      } catch (c) {
        mt(this.view.state, c, "scroll handler");
      }
    let { range: t } = e, i = this.coordsAt(t.head, t.empty ? t.assoc : t.head > t.anchor ? -1 : 1), r;
    if (!i)
      return;
    !t.empty && (r = this.coordsAt(t.anchor, t.anchor > t.head ? -1 : 1)) && (i = {
      left: Math.min(i.left, r.left),
      top: Math.min(i.top, r.top),
      right: Math.max(i.right, r.right),
      bottom: Math.max(i.bottom, r.bottom)
    });
    let s = OO(this.view), o = {
      left: i.left - s.left,
      top: i.top - s.top,
      right: i.right + s.right,
      bottom: i.bottom + s.bottom
    }, { offsetWidth: a, offsetHeight: l } = this.view.scrollDOM;
    tx(this.view.scrollDOM, o, t.head < t.anchor ? -1 : 1, e.x, e.y, Math.max(Math.min(e.xMargin, a), -a), Math.max(Math.min(e.yMargin, l), -l), this.view.textDirection == Ae.LTR);
  }
}
function xx(n) {
  return n.node.nodeType == 1 && n.node.firstChild && (n.offset == 0 || n.node.childNodes[n.offset - 1].contentEditable == "false") && (n.offset == n.node.childNodes.length || n.node.childNodes[n.offset].contentEditable == "false");
}
class Vf extends mn {
  constructor(e) {
    super(), this.height = e;
  }
  toDOM() {
    let e = document.createElement("div");
    return e.className = "cm-gap", this.updateDOM(e), e;
  }
  eq(e) {
    return e.height == this.height;
  }
  updateDOM(e) {
    return e.style.height = this.height + "px", !0;
  }
  get editable() {
    return !0;
  }
  get estimatedHeight() {
    return this.height;
  }
  ignoreEvent() {
    return !1;
  }
}
function bO(n, e) {
  let t = n.observer.selectionRange;
  if (!t.focusNode)
    return null;
  let i = Wg(t.focusNode, t.focusOffset), r = qg(t.focusNode, t.focusOffset), s = i || r;
  if (r && i && r.node != i.node) {
    let a = ke.get(r.node);
    if (!a || a instanceof Ft && a.text != r.node.nodeValue)
      s = r;
    else if (n.docView.lastCompositionAfterCursor) {
      let l = ke.get(i.node);
      !l || l instanceof Ft && l.text != i.node.nodeValue || (s = r);
    }
  }
  if (n.docView.lastCompositionAfterCursor = s != i, !s)
    return null;
  let o = e - s.offset;
  return { from: o, to: o + s.node.nodeValue.length, node: s.node };
}
function wx(n, e, t) {
  let i = bO(n, t);
  if (!i)
    return null;
  let { node: r, from: s, to: o } = i, a = r.nodeValue;
  if (/[\n\r]/.test(a) || n.state.doc.sliceString(i.from, i.to) != a)
    return null;
  let l = e.invertedDesc, u = new zt(l.mapPos(s), l.mapPos(o), s, o), c = [];
  for (let h = r.parentNode; ; h = h.parentNode) {
    let f = ke.get(h);
    if (f instanceof $n)
      c.push({ node: h, deco: f.mark });
    else {
      if (f instanceof Ne || h.nodeName == "DIV" && h.parentNode == n.contentDOM)
        return { range: u, text: r, marks: c, line: h };
      if (h != n.contentDOM)
        c.push({ node: h, deco: new Ms({
          inclusive: !0,
          attributes: ux(h),
          tagName: h.tagName.toLowerCase()
        }) });
      else
        return null;
    }
  }
}
function Sx(n, e) {
  return n.nodeType != 1 ? 0 : (e && n.childNodes[e - 1].contentEditable == "false" ? 1 : 0) | (e < n.childNodes.length && n.childNodes[e].contentEditable == "false" ? 2 : 0);
}
let vx = class {
  constructor() {
    this.changes = [];
  }
  compareRange(e, t) {
    Lu(e, t, this.changes);
  }
  comparePoint(e, t) {
    Lu(e, t, this.changes);
  }
};
function Px(n, e, t) {
  let i = new vx();
  return de.compare(n, e, t, i), i.changes;
}
function Qx(n, e) {
  for (let t = n; t && t != e; t = t.assignedSlot || t.parentNode)
    if (t.nodeType == 1 && t.contentEditable == "false")
      return !0;
  return !1;
}
function $x(n, e) {
  let t = !1;
  return e && n.iterChangedRanges((i, r) => {
    i < e.to && r > e.from && (t = !0);
  }), t;
}
function Cx(n, e, t = 1) {
  let i = n.charCategorizer(e), r = n.doc.lineAt(e), s = e - r.from;
  if (r.length == 0)
    return $.cursor(e);
  s == 0 ? t = 1 : s == r.length && (t = -1);
  let o = s, a = s;
  t < 0 ? o = Ke(r.text, s, !1) : a = Ke(r.text, s);
  let l = i(r.text.slice(o, a));
  for (; o > 0; ) {
    let u = Ke(r.text, o, !1);
    if (i(r.text.slice(u, o)) != l)
      break;
    o = u;
  }
  for (; a < r.length; ) {
    let u = Ke(r.text, a);
    if (i(r.text.slice(a, u)) != l)
      break;
    a = u;
  }
  return $.range(o + r.from, a + r.from);
}
function Tx(n, e) {
  return e.left > n ? e.left - n : Math.max(0, n - e.right);
}
function Ax(n, e) {
  return e.top > n ? e.top - n : Math.max(0, n - e.bottom);
}
function bl(n, e) {
  return n.top < e.bottom - 1 && n.bottom > e.top + 1;
}
function Yf(n, e) {
  return e < n.top ? { top: e, left: n.left, right: n.right, bottom: n.bottom } : n;
}
function jf(n, e) {
  return e > n.bottom ? { top: n.top, left: n.left, right: n.right, bottom: e } : n;
}
function qu(n, e, t) {
  let i, r, s, o, a = !1, l, u, c, h;
  for (let p = n.firstChild; p; p = p.nextSibling) {
    let g = tr(p);
    for (let O = 0; O < g.length; O++) {
      let m = g[O];
      r && bl(r, m) && (m = Yf(jf(m, r.bottom), r.top));
      let b = Tx(e, m), w = Ax(t, m);
      if (b == 0 && w == 0)
        return p.nodeType == 3 ? Uf(p, e, t) : qu(p, e, t);
      if (!i || o > w || o == w && s > b) {
        i = p, r = m, s = b, o = w;
        let Q = w ? t < m.top ? -1 : 1 : b ? e < m.left ? -1 : 1 : 0;
        a = !Q || (Q > 0 ? O < g.length - 1 : O > 0);
      }
      b == 0 ? t > m.bottom && (!c || c.bottom < m.bottom) ? (l = p, c = m) : t < m.top && (!h || h.top > m.top) && (u = p, h = m) : c && bl(c, m) ? c = jf(c, m.bottom) : h && bl(h, m) && (h = Yf(h, m.top));
    }
  }
  if (c && c.bottom >= t ? (i = l, r = c) : h && h.top <= t && (i = u, r = h), !i)
    return { node: n, offset: 0 };
  let f = Math.max(r.left, Math.min(r.right, e));
  if (i.nodeType == 3)
    return Uf(i, f, t);
  if (a && i.contentEditable != "false")
    return qu(i, f, t);
  let d = Array.prototype.indexOf.call(n.childNodes, i) + (e >= (r.left + r.right) / 2 ? 1 : 0);
  return { node: n, offset: d };
}
function Uf(n, e, t) {
  let i = n.nodeValue.length, r = -1, s = 1e9, o = 0;
  for (let a = 0; a < i; a++) {
    let l = wi(n, a, a + 1).getClientRects();
    for (let u = 0; u < l.length; u++) {
      let c = l[u];
      if (c.top == c.bottom)
        continue;
      o || (o = e - c.left);
      let h = (c.top > t ? c.top - t : t - c.bottom) - 1;
      if (c.left - 1 <= e && c.right + 1 >= e && h < s) {
        let f = e >= (c.left + c.right) / 2, d = f;
        if ((W.chrome || W.gecko) && wi(n, a).getBoundingClientRect().left == c.right && (d = !f), h <= 0)
          return { node: n, offset: a + (d ? 1 : 0) };
        r = a + (d ? 1 : 0), s = h;
      }
    }
  }
  return { node: n, offset: r > -1 ? r : o > 0 ? n.nodeValue.length : 0 };
}
function yO(n, e, t, i = -1) {
  var r, s;
  let o = n.contentDOM.getBoundingClientRect(), a = o.top + n.viewState.paddingTop, l, { docHeight: u } = n.viewState, { x: c, y: h } = e, f = h - a;
  if (f < 0)
    return 0;
  if (f > u)
    return n.state.doc.length;
  for (let Q = n.viewState.heightOracle.textHeight / 2, v = !1; l = n.elementAtHeight(f), l.type != Ot.Text; )
    for (; f = i > 0 ? l.bottom + Q : l.top - Q, !(f >= 0 && f <= u); ) {
      if (v)
        return t ? null : 0;
      v = !0, i = -i;
    }
  h = a + f;
  let d = l.from;
  if (d < n.viewport.from)
    return n.viewport.from == 0 ? 0 : t ? null : Ff(n, o, l, c, h);
  if (d > n.viewport.to)
    return n.viewport.to == n.state.doc.length ? n.state.doc.length : t ? null : Ff(n, o, l, c, h);
  let p = n.dom.ownerDocument, g = n.root.elementFromPoint ? n.root : p, O = g.elementFromPoint(c, h);
  O && !n.contentDOM.contains(O) && (O = null), O || (c = Math.max(o.left + 1, Math.min(o.right - 1, c)), O = g.elementFromPoint(c, h), O && !n.contentDOM.contains(O) && (O = null));
  let m, b = -1;
  if (O && ((r = n.docView.nearest(O)) === null || r === void 0 ? void 0 : r.isEditable) != !1) {
    if (p.caretPositionFromPoint) {
      let Q = p.caretPositionFromPoint(c, h);
      Q && ({ offsetNode: m, offset: b } = Q);
    } else if (p.caretRangeFromPoint) {
      let Q = p.caretRangeFromPoint(c, h);
      Q && ({ startContainer: m, startOffset: b } = Q, (!n.contentDOM.contains(m) || W.safari && Rx(m, b, c) || W.chrome && Mx(m, b, c)) && (m = void 0));
    }
  }
  if (!m || !n.docView.dom.contains(m)) {
    let Q = Ne.find(n.docView, d);
    if (!Q)
      return f > l.top + l.height / 2 ? l.to : l.from;
    ({ node: m, offset: b } = qu(Q.dom, c, h));
  }
  let w = n.docView.nearest(m);
  if (!w)
    return null;
  if (w.isWidget && ((s = w.dom) === null || s === void 0 ? void 0 : s.nodeType) == 1) {
    let Q = w.dom.getBoundingClientRect();
    return e.y < Q.top || e.y <= Q.bottom && e.x <= (Q.left + Q.right) / 2 ? w.posAtStart : w.posAtEnd;
  } else
    return w.localPosFromDOM(m, b) + w.posAtStart;
}
function Ff(n, e, t, i, r) {
  let s = Math.round((i - e.left) * n.defaultCharacterWidth);
  if (n.lineWrapping && t.height > n.defaultLineHeight * 1.5) {
    let a = n.viewState.heightOracle.textHeight, l = Math.floor((r - t.top - (n.defaultLineHeight - a) * 0.5) / a);
    s += l * n.viewState.heightOracle.lineLength;
  }
  let o = n.state.sliceDoc(t.from, t.to);
  return t.from + Tu(o, s, n.state.tabSize);
}
function Rx(n, e, t) {
  let i;
  if (n.nodeType != 3 || e != (i = n.nodeValue.length))
    return !1;
  for (let r = n.nextSibling; r; r = r.nextSibling)
    if (r.nodeType != 1 || r.nodeName != "BR")
      return !1;
  return wi(n, i - 1, i).getBoundingClientRect().left > t;
}
function Mx(n, e, t) {
  if (e != 0)
    return !1;
  for (let r = n; ; ) {
    let s = r.parentNode;
    if (!s || s.nodeType != 1 || s.firstChild != r)
      return !1;
    if (s.classList.contains("cm-line"))
      break;
    r = s;
  }
  let i = n.nodeType == 1 ? n.getBoundingClientRect() : wi(n, 0, Math.max(n.nodeValue.length, 1)).getBoundingClientRect();
  return t - i.left > 5;
}
function Bu(n, e) {
  let t = n.lineBlockAt(e);
  if (Array.isArray(t.type)) {
    for (let i of t.type)
      if (i.to > e || i.to == e && (i.to == t.to || i.type == Ot.Text))
        return i;
  }
  return t;
}
function Zx(n, e, t, i) {
  let r = Bu(n, e.head), s = !i || r.type != Ot.Text || !(n.lineWrapping || r.widgetLineBreaks) ? null : n.coordsAtPos(e.assoc < 0 && e.head > r.from ? e.head - 1 : e.head);
  if (s) {
    let o = n.dom.getBoundingClientRect(), a = n.textDirectionAt(r.from), l = n.posAtCoords({
      x: t == (a == Ae.LTR) ? o.right - 1 : o.left + 1,
      y: (s.top + s.bottom) / 2
    });
    if (l != null)
      return $.cursor(l, t ? -1 : 1);
  }
  return $.cursor(t ? r.to : r.from, t ? -1 : 1);
}
function Gf(n, e, t, i) {
  let r = n.state.doc.lineAt(e.head), s = n.bidiSpans(r), o = n.textDirectionAt(r.from);
  for (let a = e, l = null; ; ) {
    let u = bx(r, s, o, a, t), c = iO;
    if (!u) {
      if (r.number == (t ? n.state.doc.lines : 1))
        return a;
      c = `
`, r = n.state.doc.line(r.number + (t ? 1 : -1)), s = n.bidiSpans(r), u = n.visualLineSide(r, !t);
    }
    if (l) {
      if (!l(c))
        return a;
    } else {
      if (!i)
        return u;
      l = i(c);
    }
    a = u;
  }
}
function Ex(n, e, t) {
  let i = n.state.charCategorizer(e), r = i(t);
  return (s) => {
    let o = i(s);
    return r == Ze.Space && (r = o), r == o;
  };
}
function zx(n, e, t, i) {
  let r = e.head, s = t ? 1 : -1;
  if (r == (t ? n.state.doc.length : 0))
    return $.cursor(r, e.assoc);
  let o = e.goalColumn, a, l = n.contentDOM.getBoundingClientRect(), u = n.coordsAtPos(r, e.assoc || -1), c = n.documentTop;
  if (u)
    o == null && (o = u.left - l.left), a = s < 0 ? u.top : u.bottom;
  else {
    let d = n.viewState.lineBlockAt(r);
    o == null && (o = Math.min(l.right - l.left, n.defaultCharacterWidth * (r - d.from))), a = (s < 0 ? d.top : d.bottom) + c;
  }
  let h = l.left + o, f = i ?? n.viewState.heightOracle.textHeight >> 1;
  for (let d = 0; ; d += 10) {
    let p = a + (f + d) * s, g = yO(n, { x: h, y: p }, !1, s);
    if (p < l.top || p > l.bottom || (s < 0 ? g < r : g > r)) {
      let O = n.docView.coordsForChar(g), m = !O || p < O.top ? -1 : 1;
      return $.cursor(g, m, void 0, o);
    }
  }
}
function Xo(n, e, t) {
  for (; ; ) {
    let i = 0;
    for (let r of n)
      r.between(e - 1, e + 1, (s, o, a) => {
        if (e > s && e < o) {
          let l = i || t || (e - s < o - e ? -1 : 1);
          e = l < 0 ? s : o, i = l;
        }
      });
    if (!i)
      return e;
  }
}
function yl(n, e, t) {
  let i = Xo(n.state.facet(oh).map((r) => r(n)), t.from, e.head > t.from ? -1 : 1);
  return i == t.from ? t : $.cursor(i, i < t.from ? 1 : -1);
}
class Dx {
  setSelectionOrigin(e) {
    this.lastSelectionOrigin = e, this.lastSelectionTime = Date.now();
  }
  constructor(e) {
    this.view = e, this.lastKeyCode = 0, this.lastKeyTime = 0, this.lastTouchTime = 0, this.lastFocusTime = 0, this.lastScrollTop = 0, this.lastScrollLeft = 0, this.pendingIOSKey = void 0, this.tabFocusMode = -1, this.lastSelectionOrigin = null, this.lastSelectionTime = 0, this.lastContextMenu = 0, this.scrollHandlers = [], this.handlers = /* @__PURE__ */ Object.create(null), this.composing = -1, this.compositionFirstChange = null, this.compositionEndedAt = 0, this.compositionPendingKey = !1, this.compositionPendingChange = !1, this.mouseSelection = null, this.draggedContent = null, this.handleEvent = this.handleEvent.bind(this), this.notifiedFocused = e.hasFocus, W.safari && e.contentDOM.addEventListener("input", () => null), W.gecko && Kx(e.contentDOM.ownerDocument);
  }
  handleEvent(e) {
    !Bx(this.view, e) || this.ignoreDuringComposition(e) || e.type == "keydown" && this.keydown(e) || this.runHandlers(e.type, e);
  }
  runHandlers(e, t) {
    let i = this.handlers[e];
    if (i) {
      for (let r of i.observers)
        r(this.view, t);
      for (let r of i.handlers) {
        if (t.defaultPrevented)
          break;
        if (r(this.view, t)) {
          t.preventDefault();
          break;
        }
      }
    }
  }
  ensureHandlers(e) {
    let t = Ix(e), i = this.handlers, r = this.view.contentDOM;
    for (let s in t)
      if (s != "scroll") {
        let o = !t[s].handlers.length, a = i[s];
        a && o != !a.handlers.length && (r.removeEventListener(s, this.handleEvent), a = null), a || r.addEventListener(s, this.handleEvent, { passive: o });
      }
    for (let s in i)
      s != "scroll" && !t[s] && r.removeEventListener(s, this.handleEvent);
    this.handlers = t;
  }
  keydown(e) {
    if (this.lastKeyCode = e.keyCode, this.lastKeyTime = Date.now(), e.keyCode == 9 && this.tabFocusMode > -1 && (!this.tabFocusMode || Date.now() <= this.tabFocusMode))
      return !0;
    if (this.tabFocusMode > 0 && e.keyCode != 27 && xO.indexOf(e.keyCode) < 0 && (this.tabFocusMode = -1), W.android && W.chrome && !e.synthetic && (e.keyCode == 13 || e.keyCode == 8))
      return this.view.observer.delayAndroidKey(e.key, e.keyCode), !0;
    let t;
    return W.ios && !e.synthetic && !e.altKey && !e.metaKey && ((t = kO.find((i) => i.keyCode == e.keyCode)) && !e.ctrlKey || Lx.indexOf(e.key) > -1 && e.ctrlKey && !e.shiftKey) ? (this.pendingIOSKey = t || e, setTimeout(() => this.flushIOSKey(), 250), !0) : (e.keyCode != 229 && this.view.observer.forceFlush(), !1);
  }
  flushIOSKey(e) {
    let t = this.pendingIOSKey;
    return !t || t.key == "Enter" && e && e.from < e.to && /^\S+$/.test(e.insert.toString()) ? !1 : (this.pendingIOSKey = void 0, Yi(this.view.contentDOM, t.key, t.keyCode, t instanceof KeyboardEvent ? t : void 0));
  }
  ignoreDuringComposition(e) {
    return /^key/.test(e.type) ? this.composing > 0 ? !0 : W.safari && !W.ios && this.compositionPendingKey && Date.now() - this.compositionEndedAt < 100 ? (this.compositionPendingKey = !1, !0) : !1 : !1;
  }
  startMouseSelection(e) {
    this.mouseSelection && this.mouseSelection.destroy(), this.mouseSelection = e;
  }
  update(e) {
    this.mouseSelection && this.mouseSelection.update(e), this.draggedContent && e.docChanged && (this.draggedContent = this.draggedContent.map(e.changes)), e.transactions.length && (this.lastKeyCode = this.lastSelectionTime = 0);
  }
  destroy() {
    this.mouseSelection && this.mouseSelection.destroy();
  }
}
function Hf(n, e) {
  return (t, i) => {
    try {
      return e.call(n, i, t);
    } catch (r) {
      mt(t.state, r);
    }
  };
}
function Ix(n) {
  let e = /* @__PURE__ */ Object.create(null);
  function t(i) {
    return e[i] || (e[i] = { observers: [], handlers: [] });
  }
  for (let i of n) {
    let r = i.spec;
    if (r && r.domEventHandlers)
      for (let s in r.domEventHandlers) {
        let o = r.domEventHandlers[s];
        o && t(s).handlers.push(Hf(i.value, o));
      }
    if (r && r.domEventObservers)
      for (let s in r.domEventObservers) {
        let o = r.domEventObservers[s];
        o && t(s).observers.push(Hf(i.value, o));
      }
  }
  for (let i in Gt)
    t(i).handlers.push(Gt[i]);
  for (let i in It)
    t(i).observers.push(It[i]);
  return e;
}
const kO = [
  { key: "Backspace", keyCode: 8, inputType: "deleteContentBackward" },
  { key: "Enter", keyCode: 13, inputType: "insertParagraph" },
  { key: "Enter", keyCode: 13, inputType: "insertLineBreak" },
  { key: "Delete", keyCode: 46, inputType: "deleteContentForward" }
], Lx = "dthko", xO = [16, 17, 18, 20, 91, 92, 224, 225], Js = 6;
function eo(n) {
  return Math.max(0, n) * 0.7 + 8;
}
function _x(n, e) {
  return Math.max(Math.abs(n.clientX - e.clientX), Math.abs(n.clientY - e.clientY));
}
class Xx {
  constructor(e, t, i, r) {
    this.view = e, this.startEvent = t, this.style = i, this.mustSelect = r, this.scrollSpeed = { x: 0, y: 0 }, this.scrolling = -1, this.lastEvent = t, this.scrollParent = nx(e.contentDOM), this.atoms = e.state.facet(oh).map((o) => o(e));
    let s = e.contentDOM.ownerDocument;
    s.addEventListener("mousemove", this.move = this.move.bind(this)), s.addEventListener("mouseup", this.up = this.up.bind(this)), this.extend = t.shiftKey, this.multiple = e.state.facet(se.allowMultipleSelections) && Nx(e, t), this.dragging = qx(e, t) && PO(t) == 1 ? null : !1;
  }
  start(e) {
    this.dragging === !1 && this.select(e);
  }
  move(e) {
    var t;
    if (e.buttons == 0)
      return this.destroy();
    if (this.dragging || this.dragging == null && _x(this.startEvent, e) < 10)
      return;
    this.select(this.lastEvent = e);
    let i = 0, r = 0, s = ((t = this.scrollParent) === null || t === void 0 ? void 0 : t.getBoundingClientRect()) || { left: 0, top: 0, right: this.view.win.innerWidth, bottom: this.view.win.innerHeight }, o = OO(this.view);
    e.clientX - o.left <= s.left + Js ? i = -eo(s.left - e.clientX) : e.clientX + o.right >= s.right - Js && (i = eo(e.clientX - s.right)), e.clientY - o.top <= s.top + Js ? r = -eo(s.top - e.clientY) : e.clientY + o.bottom >= s.bottom - Js && (r = eo(e.clientY - s.bottom)), this.setScrollSpeed(i, r);
  }
  up(e) {
    this.dragging == null && this.select(this.lastEvent), this.dragging || e.preventDefault(), this.destroy();
  }
  destroy() {
    this.setScrollSpeed(0, 0);
    let e = this.view.contentDOM.ownerDocument;
    e.removeEventListener("mousemove", this.move), e.removeEventListener("mouseup", this.up), this.view.inputState.mouseSelection = this.view.inputState.draggedContent = null;
  }
  setScrollSpeed(e, t) {
    this.scrollSpeed = { x: e, y: t }, e || t ? this.scrolling < 0 && (this.scrolling = setInterval(() => this.scroll(), 50)) : this.scrolling > -1 && (clearInterval(this.scrolling), this.scrolling = -1);
  }
  scroll() {
    this.scrollParent ? (this.scrollParent.scrollLeft += this.scrollSpeed.x, this.scrollParent.scrollTop += this.scrollSpeed.y) : this.view.win.scrollBy(this.scrollSpeed.x, this.scrollSpeed.y), this.dragging === !1 && this.select(this.lastEvent);
  }
  skipAtoms(e) {
    let t = null;
    for (let i = 0; i < e.ranges.length; i++) {
      let r = e.ranges[i], s = null;
      if (r.empty) {
        let o = Xo(this.atoms, r.from, 0);
        o != r.from && (s = $.cursor(o, -1));
      } else {
        let o = Xo(this.atoms, r.from, -1), a = Xo(this.atoms, r.to, 1);
        (o != r.from || a != r.to) && (s = $.range(r.from == r.anchor ? o : a, r.from == r.head ? o : a));
      }
      s && (t || (t = e.ranges.slice()), t[i] = s);
    }
    return t ? $.create(t, e.mainIndex) : e;
  }
  select(e) {
    let { view: t } = this, i = this.skipAtoms(this.style.get(e, this.extend, this.multiple));
    (this.mustSelect || !i.eq(t.state.selection, this.dragging === !1)) && this.view.dispatch({
      selection: i,
      userEvent: "select.pointer"
    }), this.mustSelect = !1;
  }
  update(e) {
    e.transactions.some((t) => t.isUserEvent("input.type")) ? this.destroy() : this.style.update(e) && setTimeout(() => this.select(this.lastEvent), 20);
  }
}
function Nx(n, e) {
  let t = n.state.facet(rO);
  return t.length ? t[0](e) : W.mac ? e.metaKey : e.ctrlKey;
}
function Wx(n, e) {
  let t = n.state.facet(sO);
  return t.length ? t[0](e) : W.mac ? !e.altKey : !e.ctrlKey;
}
function qx(n, e) {
  let { main: t } = n.state.selection;
  if (t.empty)
    return !1;
  let i = ia(n.root);
  if (!i || i.rangeCount == 0)
    return !0;
  let r = i.getRangeAt(0).getClientRects();
  for (let s = 0; s < r.length; s++) {
    let o = r[s];
    if (o.left <= e.clientX && o.right >= e.clientX && o.top <= e.clientY && o.bottom >= e.clientY)
      return !0;
  }
  return !1;
}
function Bx(n, e) {
  if (!e.bubbles)
    return !0;
  if (e.defaultPrevented)
    return !1;
  for (let t = e.target, i; t != n.contentDOM; t = t.parentNode)
    if (!t || t.nodeType == 11 || (i = ke.get(t)) && i.ignoreEvent(e))
      return !1;
  return !0;
}
const Gt = /* @__PURE__ */ Object.create(null), It = /* @__PURE__ */ Object.create(null), wO = W.ie && W.ie_version < 15 || W.ios && W.webkit_version < 604;
function Vx(n) {
  let e = n.dom.parentNode;
  if (!e)
    return;
  let t = e.appendChild(document.createElement("textarea"));
  t.style.cssText = "position: fixed; left: -10000px; top: 10px", t.focus(), setTimeout(() => {
    n.focus(), t.remove(), SO(n, t.value);
  }, 50);
}
function SO(n, e) {
  let { state: t } = n, i, r = 1, s = t.toText(e), o = s.lines == t.selection.ranges.length;
  if (Vu != null && t.selection.ranges.every((l) => l.empty) && Vu == s.toString()) {
    let l = -1;
    i = t.changeByRange((u) => {
      let c = t.doc.lineAt(u.from);
      if (c.from == l)
        return { range: u };
      l = c.from;
      let h = t.toText((o ? s.line(r++).text : e) + t.lineBreak);
      return {
        changes: { from: c.from, insert: h },
        range: $.cursor(u.from + h.length)
      };
    });
  } else
    o ? i = t.changeByRange((l) => {
      let u = s.line(r++);
      return {
        changes: { from: l.from, to: l.to, insert: u.text },
        range: $.cursor(l.from + u.length)
      };
    }) : i = t.replaceSelection(s);
  n.dispatch(i, {
    userEvent: "input.paste",
    scrollIntoView: !0
  });
}
It.scroll = (n) => {
  n.inputState.lastScrollTop = n.scrollDOM.scrollTop, n.inputState.lastScrollLeft = n.scrollDOM.scrollLeft;
};
Gt.keydown = (n, e) => (n.inputState.setSelectionOrigin("select"), e.keyCode == 27 && n.inputState.tabFocusMode != 0 && (n.inputState.tabFocusMode = Date.now() + 2e3), !1);
It.touchstart = (n, e) => {
  n.inputState.lastTouchTime = Date.now(), n.inputState.setSelectionOrigin("select.pointer");
};
It.touchmove = (n) => {
  n.inputState.setSelectionOrigin("select.pointer");
};
Gt.mousedown = (n, e) => {
  if (n.observer.flush(), n.inputState.lastTouchTime > Date.now() - 2e3)
    return !1;
  let t = null;
  for (let i of n.state.facet(oO))
    if (t = i(n, e), t)
      break;
  if (!t && e.button == 0 && (t = Ux(n, e)), t) {
    let i = !n.hasFocus;
    n.inputState.startMouseSelection(new Xx(n, e, t, i)), i && n.observer.ignore(() => {
      _g(n.contentDOM);
      let s = n.root.activeElement;
      s && !s.contains(n.contentDOM) && s.blur();
    });
    let r = n.inputState.mouseSelection;
    if (r)
      return r.start(e), r.dragging === !1;
  }
  return !1;
};
function Kf(n, e, t, i) {
  if (i == 1)
    return $.cursor(e, t);
  if (i == 2)
    return Cx(n.state, e, t);
  {
    let r = Ne.find(n.docView, e), s = n.state.doc.lineAt(r ? r.posAtEnd : e), o = r ? r.posAtStart : s.from, a = r ? r.posAtEnd : s.to;
    return a < n.state.doc.length && a == s.to && a++, $.range(o, a);
  }
}
let vO = (n, e) => n >= e.top && n <= e.bottom, Jf = (n, e, t) => vO(e, t) && n >= t.left && n <= t.right;
function Yx(n, e, t, i) {
  let r = Ne.find(n.docView, e);
  if (!r)
    return 1;
  let s = e - r.posAtStart;
  if (s == 0)
    return 1;
  if (s == r.length)
    return -1;
  let o = r.coordsAt(s, -1);
  if (o && Jf(t, i, o))
    return -1;
  let a = r.coordsAt(s, 1);
  return a && Jf(t, i, a) ? 1 : o && vO(i, o) ? -1 : 1;
}
function ed(n, e) {
  let t = n.posAtCoords({ x: e.clientX, y: e.clientY }, !1);
  return { pos: t, bias: Yx(n, t, e.clientX, e.clientY) };
}
const jx = W.ie && W.ie_version <= 11;
let td = null, nd = 0, id = 0;
function PO(n) {
  if (!jx)
    return n.detail;
  let e = td, t = id;
  return td = n, id = Date.now(), nd = !e || t > Date.now() - 400 && Math.abs(e.clientX - n.clientX) < 2 && Math.abs(e.clientY - n.clientY) < 2 ? (nd + 1) % 3 : 1;
}
function Ux(n, e) {
  let t = ed(n, e), i = PO(e), r = n.state.selection;
  return {
    update(s) {
      s.docChanged && (t.pos = s.changes.mapPos(t.pos), r = r.map(s.changes));
    },
    get(s, o, a) {
      let l = ed(n, s), u, c = Kf(n, l.pos, l.bias, i);
      if (t.pos != l.pos && !o) {
        let h = Kf(n, t.pos, t.bias, i), f = Math.min(h.from, c.from), d = Math.max(h.to, c.to);
        c = f < c.from ? $.range(f, d) : $.range(d, f);
      }
      return o ? r.replaceRange(r.main.extend(c.from, c.to)) : a && i == 1 && r.ranges.length > 1 && (u = Fx(r, l.pos)) ? u : a ? r.addRange(c) : $.create([c]);
    }
  };
}
function Fx(n, e) {
  for (let t = 0; t < n.ranges.length; t++) {
    let { from: i, to: r } = n.ranges[t];
    if (i <= e && r >= e)
      return $.create(n.ranges.slice(0, t).concat(n.ranges.slice(t + 1)), n.mainIndex == t ? 0 : n.mainIndex - (n.mainIndex > t ? 1 : 0));
  }
  return null;
}
Gt.dragstart = (n, e) => {
  let { selection: { main: t } } = n.state;
  if (e.target.draggable) {
    let r = n.docView.nearest(e.target);
    if (r && r.isWidget) {
      let s = r.posAtStart, o = s + r.length;
      (s >= t.to || o <= t.from) && (t = $.range(s, o));
    }
  }
  let { inputState: i } = n;
  return i.mouseSelection && (i.mouseSelection.dragging = !0), i.draggedContent = t, e.dataTransfer && (e.dataTransfer.setData("Text", n.state.sliceDoc(t.from, t.to)), e.dataTransfer.effectAllowed = "copyMove"), !1;
};
Gt.dragend = (n) => (n.inputState.draggedContent = null, !1);
function rd(n, e, t, i) {
  if (!t)
    return;
  let r = n.posAtCoords({ x: e.clientX, y: e.clientY }, !1), { draggedContent: s } = n.inputState, o = i && s && Wx(n, e) ? { from: s.from, to: s.to } : null, a = { from: r, insert: t }, l = n.state.changes(o ? [o, a] : a);
  n.focus(), n.dispatch({
    changes: l,
    selection: { anchor: l.mapPos(r, -1), head: l.mapPos(r, 1) },
    userEvent: o ? "move.drop" : "input.drop"
  }), n.inputState.draggedContent = null;
}
Gt.drop = (n, e) => {
  if (!e.dataTransfer)
    return !1;
  if (n.state.readOnly)
    return !0;
  let t = e.dataTransfer.files;
  if (t && t.length) {
    let i = Array(t.length), r = 0, s = () => {
      ++r == t.length && rd(n, e, i.filter((o) => o != null).join(n.state.lineBreak), !1);
    };
    for (let o = 0; o < t.length; o++) {
      let a = new FileReader();
      a.onerror = s, a.onload = () => {
        /[\x00-\x08\x0e-\x1f]{2}/.test(a.result) || (i[o] = a.result), s();
      }, a.readAsText(t[o]);
    }
    return !0;
  } else {
    let i = e.dataTransfer.getData("Text");
    if (i)
      return rd(n, e, i, !0), !0;
  }
  return !1;
};
Gt.paste = (n, e) => {
  if (n.state.readOnly)
    return !0;
  n.observer.flush();
  let t = wO ? null : e.clipboardData;
  return t ? (SO(n, t.getData("text/plain") || t.getData("text/uri-list")), !0) : (Vx(n), !1);
};
function Gx(n, e) {
  let t = n.dom.parentNode;
  if (!t)
    return;
  let i = t.appendChild(document.createElement("textarea"));
  i.style.cssText = "position: fixed; left: -10000px; top: 10px", i.value = e, i.focus(), i.selectionEnd = e.length, i.selectionStart = 0, setTimeout(() => {
    i.remove(), n.focus();
  }, 50);
}
function Hx(n) {
  let e = [], t = [], i = !1;
  for (let r of n.selection.ranges)
    r.empty || (e.push(n.sliceDoc(r.from, r.to)), t.push(r));
  if (!e.length) {
    let r = -1;
    for (let { from: s } of n.selection.ranges) {
      let o = n.doc.lineAt(s);
      o.number > r && (e.push(o.text), t.push({ from: o.from, to: Math.min(n.doc.length, o.to + 1) })), r = o.number;
    }
    i = !0;
  }
  return { text: e.join(n.lineBreak), ranges: t, linewise: i };
}
let Vu = null;
Gt.copy = Gt.cut = (n, e) => {
  let { text: t, ranges: i, linewise: r } = Hx(n.state);
  if (!t && !r)
    return !1;
  Vu = r ? t : null, e.type == "cut" && !n.state.readOnly && n.dispatch({
    changes: i,
    scrollIntoView: !0,
    userEvent: "delete.cut"
  });
  let s = wO ? null : e.clipboardData;
  return s ? (s.clearData(), s.setData("text/plain", t), !0) : (Gx(n, t), !1);
};
const QO = /* @__PURE__ */ Zn.define();
function $O(n, e) {
  let t = [];
  for (let i of n.facet(uO)) {
    let r = i(n, e);
    r && t.push(r);
  }
  return t ? n.update({ effects: t, annotations: QO.of(!0) }) : null;
}
function CO(n) {
  setTimeout(() => {
    let e = n.hasFocus;
    if (e != n.inputState.notifiedFocused) {
      let t = $O(n.state, e);
      t ? n.dispatch(t) : n.update([]);
    }
  }, 10);
}
It.focus = (n) => {
  n.inputState.lastFocusTime = Date.now(), !n.scrollDOM.scrollTop && (n.inputState.lastScrollTop || n.inputState.lastScrollLeft) && (n.scrollDOM.scrollTop = n.inputState.lastScrollTop, n.scrollDOM.scrollLeft = n.inputState.lastScrollLeft), CO(n);
};
It.blur = (n) => {
  n.observer.clearSelectionRange(), CO(n);
};
It.compositionstart = It.compositionupdate = (n) => {
  n.inputState.compositionFirstChange == null && (n.inputState.compositionFirstChange = !0), n.inputState.composing < 0 && (n.inputState.composing = 0);
};
It.compositionend = (n) => {
  n.inputState.composing = -1, n.inputState.compositionEndedAt = Date.now(), n.inputState.compositionPendingKey = !0, n.inputState.compositionPendingChange = n.observer.pendingRecords().length > 0, n.inputState.compositionFirstChange = null, W.chrome && W.android ? n.observer.flushSoon() : n.inputState.compositionPendingChange ? Promise.resolve().then(() => n.observer.flush()) : setTimeout(() => {
    n.inputState.composing < 0 && n.docView.hasComposition && n.update([]);
  }, 50);
};
It.contextmenu = (n) => {
  n.inputState.lastContextMenu = Date.now();
};
Gt.beforeinput = (n, e) => {
  var t;
  let i;
  if (W.chrome && W.android && (i = kO.find((r) => r.inputType == e.inputType)) && (n.observer.delayAndroidKey(i.key, i.keyCode), i.key == "Backspace" || i.key == "Delete")) {
    let r = ((t = window.visualViewport) === null || t === void 0 ? void 0 : t.height) || 0;
    setTimeout(() => {
      var s;
      (((s = window.visualViewport) === null || s === void 0 ? void 0 : s.height) || 0) > r + 10 && n.hasFocus && (n.contentDOM.blur(), n.focus());
    }, 100);
  }
  return W.ios && e.inputType == "deleteContentForward" && n.observer.flushSoon(), W.safari && e.inputType == "insertText" && n.inputState.composing >= 0 && setTimeout(() => It.compositionend(n, e), 20), !1;
};
const sd = /* @__PURE__ */ new Set();
function Kx(n) {
  sd.has(n) || (sd.add(n), n.addEventListener("copy", () => {
  }), n.addEventListener("cut", () => {
  }));
}
const od = ["pre-wrap", "normal", "pre-line", "break-spaces"];
class Jx {
  constructor(e) {
    this.lineWrapping = e, this.doc = me.empty, this.heightSamples = {}, this.lineHeight = 14, this.charWidth = 7, this.textHeight = 14, this.lineLength = 30, this.heightChanged = !1;
  }
  heightForGap(e, t) {
    let i = this.doc.lineAt(t).number - this.doc.lineAt(e).number + 1;
    return this.lineWrapping && (i += Math.max(0, Math.ceil((t - e - i * this.lineLength * 0.5) / this.lineLength))), this.lineHeight * i;
  }
  heightForLine(e) {
    return this.lineWrapping ? (1 + Math.max(0, Math.ceil((e - this.lineLength) / (this.lineLength - 5)))) * this.lineHeight : this.lineHeight;
  }
  setDoc(e) {
    return this.doc = e, this;
  }
  mustRefreshForWrapping(e) {
    return od.indexOf(e) > -1 != this.lineWrapping;
  }
  mustRefreshForHeights(e) {
    let t = !1;
    for (let i = 0; i < e.length; i++) {
      let r = e[i];
      r < 0 ? i++ : this.heightSamples[Math.floor(r * 10)] || (t = !0, this.heightSamples[Math.floor(r * 10)] = !0);
    }
    return t;
  }
  refresh(e, t, i, r, s, o) {
    let a = od.indexOf(e) > -1, l = Math.round(t) != Math.round(this.lineHeight) || this.lineWrapping != a;
    if (this.lineWrapping = a, this.lineHeight = t, this.charWidth = i, this.textHeight = r, this.lineLength = s, l) {
      this.heightSamples = {};
      for (let u = 0; u < o.length; u++) {
        let c = o[u];
        c < 0 ? u++ : this.heightSamples[Math.floor(c * 10)] = !0;
      }
    }
    return l;
  }
}
class ew {
  constructor(e, t) {
    this.from = e, this.heights = t, this.index = 0;
  }
  get more() {
    return this.index < this.heights.length;
  }
}
class on {
  /**
  @internal
  */
  constructor(e, t, i, r, s) {
    this.from = e, this.length = t, this.top = i, this.height = r, this._content = s;
  }
  /**
  The type of element this is. When querying lines, this may be
  an array of all the blocks that make up the line.
  */
  get type() {
    return typeof this._content == "number" ? Ot.Text : Array.isArray(this._content) ? this._content : this._content.type;
  }
  /**
  The end of the element as a document position.
  */
  get to() {
    return this.from + this.length;
  }
  /**
  The bottom position of the element.
  */
  get bottom() {
    return this.top + this.height;
  }
  /**
  If this is a widget block, this will return the widget
  associated with it.
  */
  get widget() {
    return this._content instanceof Kn ? this._content.widget : null;
  }
  /**
  If this is a textblock, this holds the number of line breaks
  that appear in widgets inside the block.
  */
  get widgetLineBreaks() {
    return typeof this._content == "number" ? this._content : 0;
  }
  /**
  @internal
  */
  join(e) {
    let t = (Array.isArray(this._content) ? this._content : [this]).concat(Array.isArray(e._content) ? e._content : [e]);
    return new on(this.from, this.length + e.length, this.top, this.height + e.height, t);
  }
}
var $e = /* @__PURE__ */ function(n) {
  return n[n.ByPos = 0] = "ByPos", n[n.ByHeight = 1] = "ByHeight", n[n.ByPosNoHeight = 2] = "ByPosNoHeight", n;
}($e || ($e = {}));
const No = 1e-3;
class lt {
  constructor(e, t, i = 2) {
    this.length = e, this.height = t, this.flags = i;
  }
  get outdated() {
    return (this.flags & 2) > 0;
  }
  set outdated(e) {
    this.flags = (e ? 2 : 0) | this.flags & -3;
  }
  setHeight(e, t) {
    this.height != t && (Math.abs(this.height - t) > No && (e.heightChanged = !0), this.height = t);
  }
  // Base case is to replace a leaf node, which simply builds a tree
  // from the new nodes and returns that (HeightMapBranch and
  // HeightMapGap override this to actually use from/to)
  replace(e, t, i) {
    return lt.of(i);
  }
  // Again, these are base cases, and are overridden for branch and gap nodes.
  decomposeLeft(e, t) {
    t.push(this);
  }
  decomposeRight(e, t) {
    t.push(this);
  }
  applyChanges(e, t, i, r) {
    let s = this, o = i.doc;
    for (let a = r.length - 1; a >= 0; a--) {
      let { fromA: l, toA: u, fromB: c, toB: h } = r[a], f = s.lineAt(l, $e.ByPosNoHeight, i.setDoc(t), 0, 0), d = f.to >= u ? f : s.lineAt(u, $e.ByPosNoHeight, i, 0, 0);
      for (h += d.to - u, u = d.to; a > 0 && f.from <= r[a - 1].toA; )
        l = r[a - 1].fromA, c = r[a - 1].fromB, a--, l < f.from && (f = s.lineAt(l, $e.ByPosNoHeight, i, 0, 0));
      c += f.from - l, l = f.from;
      let p = ah.build(i.setDoc(o), e, c, h);
      s = s.replace(l, u, p);
    }
    return s.updateHeight(i, 0);
  }
  static empty() {
    return new Pt(0, 0);
  }
  // nodes uses null values to indicate the position of line breaks.
  // There are never line breaks at the start or end of the array, or
  // two line breaks next to each other, and the array isn't allowed
  // to be empty (same restrictions as return value from the builder).
  static of(e) {
    if (e.length == 1)
      return e[0];
    let t = 0, i = e.length, r = 0, s = 0;
    for (; ; )
      if (t == i)
        if (r > s * 2) {
          let a = e[t - 1];
          a.break ? e.splice(--t, 1, a.left, null, a.right) : e.splice(--t, 1, a.left, a.right), i += 1 + a.break, r -= a.size;
        } else if (s > r * 2) {
          let a = e[i];
          a.break ? e.splice(i, 1, a.left, null, a.right) : e.splice(i, 1, a.left, a.right), i += 2 + a.break, s -= a.size;
        } else
          break;
      else if (r < s) {
        let a = e[t++];
        a && (r += a.size);
      } else {
        let a = e[--i];
        a && (s += a.size);
      }
    let o = 0;
    return e[t - 1] == null ? (o = 1, t--) : e[t] == null && (o = 1, i++), new tw(lt.of(e.slice(0, t)), o, lt.of(e.slice(i)));
  }
}
lt.prototype.size = 1;
class TO extends lt {
  constructor(e, t, i) {
    super(e, t), this.deco = i;
  }
  blockAt(e, t, i, r) {
    return new on(r, this.length, i, this.height, this.deco || 0);
  }
  lineAt(e, t, i, r, s) {
    return this.blockAt(0, i, r, s);
  }
  forEachLine(e, t, i, r, s, o) {
    e <= s + this.length && t >= s && o(this.blockAt(0, i, r, s));
  }
  updateHeight(e, t = 0, i = !1, r) {
    return r && r.from <= t && r.more && this.setHeight(e, r.heights[r.index++]), this.outdated = !1, this;
  }
  toString() {
    return `block(${this.length})`;
  }
}
class Pt extends TO {
  constructor(e, t) {
    super(e, t, null), this.collapsed = 0, this.widgetHeight = 0, this.breaks = 0;
  }
  blockAt(e, t, i, r) {
    return new on(r, this.length, i, this.height, this.breaks);
  }
  replace(e, t, i) {
    let r = i[0];
    return i.length == 1 && (r instanceof Pt || r instanceof je && r.flags & 4) && Math.abs(this.length - r.length) < 10 ? (r instanceof je ? r = new Pt(r.length, this.height) : r.height = this.height, this.outdated || (r.outdated = !1), r) : lt.of(i);
  }
  updateHeight(e, t = 0, i = !1, r) {
    return r && r.from <= t && r.more ? this.setHeight(e, r.heights[r.index++]) : (i || this.outdated) && this.setHeight(e, Math.max(this.widgetHeight, e.heightForLine(this.length - this.collapsed)) + this.breaks * e.lineHeight), this.outdated = !1, this;
  }
  toString() {
    return `line(${this.length}${this.collapsed ? -this.collapsed : ""}${this.widgetHeight ? ":" + this.widgetHeight : ""})`;
  }
}
class je extends lt {
  constructor(e) {
    super(e, 0);
  }
  heightMetrics(e, t) {
    let i = e.doc.lineAt(t).number, r = e.doc.lineAt(t + this.length).number, s = r - i + 1, o, a = 0;
    if (e.lineWrapping) {
      let l = Math.min(this.height, e.lineHeight * s);
      o = l / s, this.length > s + 1 && (a = (this.height - l) / (this.length - s - 1));
    } else
      o = this.height / s;
    return { firstLine: i, lastLine: r, perLine: o, perChar: a };
  }
  blockAt(e, t, i, r) {
    let { firstLine: s, lastLine: o, perLine: a, perChar: l } = this.heightMetrics(t, r);
    if (t.lineWrapping) {
      let u = r + (e < t.lineHeight ? 0 : Math.round(Math.max(0, Math.min(1, (e - i) / this.height)) * this.length)), c = t.doc.lineAt(u), h = a + c.length * l, f = Math.max(i, e - h / 2);
      return new on(c.from, c.length, f, h, 0);
    } else {
      let u = Math.max(0, Math.min(o - s, Math.floor((e - i) / a))), { from: c, length: h } = t.doc.line(s + u);
      return new on(c, h, i + a * u, a, 0);
    }
  }
  lineAt(e, t, i, r, s) {
    if (t == $e.ByHeight)
      return this.blockAt(e, i, r, s);
    if (t == $e.ByPosNoHeight) {
      let { from: d, to: p } = i.doc.lineAt(e);
      return new on(d, p - d, 0, 0, 0);
    }
    let { firstLine: o, perLine: a, perChar: l } = this.heightMetrics(i, s), u = i.doc.lineAt(e), c = a + u.length * l, h = u.number - o, f = r + a * h + l * (u.from - s - h);
    return new on(u.from, u.length, Math.max(r, Math.min(f, r + this.height - c)), c, 0);
  }
  forEachLine(e, t, i, r, s, o) {
    e = Math.max(e, s), t = Math.min(t, s + this.length);
    let { firstLine: a, perLine: l, perChar: u } = this.heightMetrics(i, s);
    for (let c = e, h = r; c <= t; ) {
      let f = i.doc.lineAt(c);
      if (c == e) {
        let p = f.number - a;
        h += l * p + u * (e - s - p);
      }
      let d = l + u * f.length;
      o(new on(f.from, f.length, h, d, 0)), h += d, c = f.to + 1;
    }
  }
  replace(e, t, i) {
    let r = this.length - t;
    if (r > 0) {
      let s = i[i.length - 1];
      s instanceof je ? i[i.length - 1] = new je(s.length + r) : i.push(null, new je(r - 1));
    }
    if (e > 0) {
      let s = i[0];
      s instanceof je ? i[0] = new je(e + s.length) : i.unshift(new je(e - 1), null);
    }
    return lt.of(i);
  }
  decomposeLeft(e, t) {
    t.push(new je(e - 1), null);
  }
  decomposeRight(e, t) {
    t.push(null, new je(this.length - e - 1));
  }
  updateHeight(e, t = 0, i = !1, r) {
    let s = t + this.length;
    if (r && r.from <= t + this.length && r.more) {
      let o = [], a = Math.max(t, r.from), l = -1;
      for (r.from > t && o.push(new je(r.from - t - 1).updateHeight(e, t)); a <= s && r.more; ) {
        let c = e.doc.lineAt(a).length;
        o.length && o.push(null);
        let h = r.heights[r.index++];
        l == -1 ? l = h : Math.abs(h - l) >= No && (l = -2);
        let f = new Pt(c, h);
        f.outdated = !1, o.push(f), a += c + 1;
      }
      a <= s && o.push(null, new je(s - a).updateHeight(e, a));
      let u = lt.of(o);
      return (l < 0 || Math.abs(u.height - this.height) >= No || Math.abs(l - this.heightMetrics(e, t).perLine) >= No) && (e.heightChanged = !0), u;
    } else
      (i || this.outdated) && (this.setHeight(e, e.heightForGap(t, t + this.length)), this.outdated = !1);
    return this;
  }
  toString() {
    return `gap(${this.length})`;
  }
}
class tw extends lt {
  constructor(e, t, i) {
    super(e.length + t + i.length, e.height + i.height, t | (e.outdated || i.outdated ? 2 : 0)), this.left = e, this.right = i, this.size = e.size + i.size;
  }
  get break() {
    return this.flags & 1;
  }
  blockAt(e, t, i, r) {
    let s = i + this.left.height;
    return e < s ? this.left.blockAt(e, t, i, r) : this.right.blockAt(e, t, s, r + this.left.length + this.break);
  }
  lineAt(e, t, i, r, s) {
    let o = r + this.left.height, a = s + this.left.length + this.break, l = t == $e.ByHeight ? e < o : e < a, u = l ? this.left.lineAt(e, t, i, r, s) : this.right.lineAt(e, t, i, o, a);
    if (this.break || (l ? u.to < a : u.from > a))
      return u;
    let c = t == $e.ByPosNoHeight ? $e.ByPosNoHeight : $e.ByPos;
    return l ? u.join(this.right.lineAt(a, c, i, o, a)) : this.left.lineAt(a, c, i, r, s).join(u);
  }
  forEachLine(e, t, i, r, s, o) {
    let a = r + this.left.height, l = s + this.left.length + this.break;
    if (this.break)
      e < l && this.left.forEachLine(e, t, i, r, s, o), t >= l && this.right.forEachLine(e, t, i, a, l, o);
    else {
      let u = this.lineAt(l, $e.ByPos, i, r, s);
      e < u.from && this.left.forEachLine(e, u.from - 1, i, r, s, o), u.to >= e && u.from <= t && o(u), t > u.to && this.right.forEachLine(u.to + 1, t, i, a, l, o);
    }
  }
  replace(e, t, i) {
    let r = this.left.length + this.break;
    if (t < r)
      return this.balanced(this.left.replace(e, t, i), this.right);
    if (e > this.left.length)
      return this.balanced(this.left, this.right.replace(e - r, t - r, i));
    let s = [];
    e > 0 && this.decomposeLeft(e, s);
    let o = s.length;
    for (let a of i)
      s.push(a);
    if (e > 0 && ad(s, o - 1), t < this.length) {
      let a = s.length;
      this.decomposeRight(t, s), ad(s, a);
    }
    return lt.of(s);
  }
  decomposeLeft(e, t) {
    let i = this.left.length;
    if (e <= i)
      return this.left.decomposeLeft(e, t);
    t.push(this.left), this.break && (i++, e >= i && t.push(null)), e > i && this.right.decomposeLeft(e - i, t);
  }
  decomposeRight(e, t) {
    let i = this.left.length, r = i + this.break;
    if (e >= r)
      return this.right.decomposeRight(e - r, t);
    e < i && this.left.decomposeRight(e, t), this.break && e < r && t.push(null), t.push(this.right);
  }
  balanced(e, t) {
    return e.size > 2 * t.size || t.size > 2 * e.size ? lt.of(this.break ? [e, null, t] : [e, t]) : (this.left = e, this.right = t, this.height = e.height + t.height, this.outdated = e.outdated || t.outdated, this.size = e.size + t.size, this.length = e.length + this.break + t.length, this);
  }
  updateHeight(e, t = 0, i = !1, r) {
    let { left: s, right: o } = this, a = t + s.length + this.break, l = null;
    return r && r.from <= t + s.length && r.more ? l = s = s.updateHeight(e, t, i, r) : s.updateHeight(e, t, i), r && r.from <= a + o.length && r.more ? l = o = o.updateHeight(e, a, i, r) : o.updateHeight(e, a, i), l ? this.balanced(s, o) : (this.height = this.left.height + this.right.height, this.outdated = !1, this);
  }
  toString() {
    return this.left + (this.break ? " " : "-") + this.right;
  }
}
function ad(n, e) {
  let t, i;
  n[e] == null && (t = n[e - 1]) instanceof je && (i = n[e + 1]) instanceof je && n.splice(e - 1, 3, new je(t.length + 1 + i.length));
}
const nw = 5;
class ah {
  constructor(e, t) {
    this.pos = e, this.oracle = t, this.nodes = [], this.lineStart = -1, this.lineEnd = -1, this.covering = null, this.writtenTo = e;
  }
  get isCovered() {
    return this.covering && this.nodes[this.nodes.length - 1] == this.covering;
  }
  span(e, t) {
    if (this.lineStart > -1) {
      let i = Math.min(t, this.lineEnd), r = this.nodes[this.nodes.length - 1];
      r instanceof Pt ? r.length += i - this.pos : (i > this.pos || !this.isCovered) && this.nodes.push(new Pt(i - this.pos, -1)), this.writtenTo = i, t > i && (this.nodes.push(null), this.writtenTo++, this.lineStart = -1);
    }
    this.pos = t;
  }
  point(e, t, i) {
    if (e < t || i.heightRelevant) {
      let r = i.widget ? i.widget.estimatedHeight : 0, s = i.widget ? i.widget.lineBreaks : 0;
      r < 0 && (r = this.oracle.lineHeight);
      let o = t - e;
      i.block ? this.addBlock(new TO(o, r, i)) : (o || s || r >= nw) && this.addLineDeco(r, s, o);
    } else
      t > e && this.span(e, t);
    this.lineEnd > -1 && this.lineEnd < this.pos && (this.lineEnd = this.oracle.doc.lineAt(this.pos).to);
  }
  enterLine() {
    if (this.lineStart > -1)
      return;
    let { from: e, to: t } = this.oracle.doc.lineAt(this.pos);
    this.lineStart = e, this.lineEnd = t, this.writtenTo < e && ((this.writtenTo < e - 1 || this.nodes[this.nodes.length - 1] == null) && this.nodes.push(this.blankContent(this.writtenTo, e - 1)), this.nodes.push(null)), this.pos > e && this.nodes.push(new Pt(this.pos - e, -1)), this.writtenTo = this.pos;
  }
  blankContent(e, t) {
    let i = new je(t - e);
    return this.oracle.doc.lineAt(e).to == t && (i.flags |= 4), i;
  }
  ensureLine() {
    this.enterLine();
    let e = this.nodes.length ? this.nodes[this.nodes.length - 1] : null;
    if (e instanceof Pt)
      return e;
    let t = new Pt(0, -1);
    return this.nodes.push(t), t;
  }
  addBlock(e) {
    this.enterLine();
    let t = e.deco;
    t && t.startSide > 0 && !this.isCovered && this.ensureLine(), this.nodes.push(e), this.writtenTo = this.pos = this.pos + e.length, t && t.endSide > 0 && (this.covering = e);
  }
  addLineDeco(e, t, i) {
    let r = this.ensureLine();
    r.length += i, r.collapsed += i, r.widgetHeight = Math.max(r.widgetHeight, e), r.breaks += t, this.writtenTo = this.pos = this.pos + i;
  }
  finish(e) {
    let t = this.nodes.length == 0 ? null : this.nodes[this.nodes.length - 1];
    this.lineStart > -1 && !(t instanceof Pt) && !this.isCovered ? this.nodes.push(new Pt(0, -1)) : (this.writtenTo < this.pos || t == null) && this.nodes.push(this.blankContent(this.writtenTo, this.pos));
    let i = e;
    for (let r of this.nodes)
      r instanceof Pt && r.updateHeight(this.oracle, i), i += r ? r.length : 1;
    return this.nodes;
  }
  // Always called with a region that on both sides either stretches
  // to a line break or the end of the document.
  // The returned array uses null to indicate line breaks, but never
  // starts or ends in a line break, or has multiple line breaks next
  // to each other.
  static build(e, t, i, r) {
    let s = new ah(i, e);
    return de.spans(t, i, r, s, 0), s.finish(i);
  }
}
function iw(n, e, t) {
  let i = new rw();
  return de.compare(n, e, t, i, 0), i.changes;
}
class rw {
  constructor() {
    this.changes = [];
  }
  compareRange() {
  }
  comparePoint(e, t, i, r) {
    (e < t || i && i.heightRelevant || r && r.heightRelevant) && Lu(e, t, this.changes, 5);
  }
}
function sw(n, e) {
  let t = n.getBoundingClientRect(), i = n.ownerDocument, r = i.defaultView || window, s = Math.max(0, t.left), o = Math.min(r.innerWidth, t.right), a = Math.max(0, t.top), l = Math.min(r.innerHeight, t.bottom);
  for (let u = n.parentNode; u && u != i.body; )
    if (u.nodeType == 1) {
      let c = u, h = window.getComputedStyle(c);
      if ((c.scrollHeight > c.clientHeight || c.scrollWidth > c.clientWidth) && h.overflow != "visible") {
        let f = c.getBoundingClientRect();
        s = Math.max(s, f.left), o = Math.min(o, f.right), a = Math.max(a, f.top), l = u == n.parentNode ? f.bottom : Math.min(l, f.bottom);
      }
      u = h.position == "absolute" || h.position == "fixed" ? c.offsetParent : c.parentNode;
    } else if (u.nodeType == 11)
      u = u.host;
    else
      break;
  return {
    left: s - t.left,
    right: Math.max(s, o) - t.left,
    top: a - (t.top + e),
    bottom: Math.max(a, l) - (t.top + e)
  };
}
function ow(n, e) {
  let t = n.getBoundingClientRect();
  return {
    left: 0,
    right: t.right - t.left,
    top: e,
    bottom: t.bottom - (t.top + e)
  };
}
class kl {
  constructor(e, t, i) {
    this.from = e, this.to = t, this.size = i;
  }
  static same(e, t) {
    if (e.length != t.length)
      return !1;
    for (let i = 0; i < e.length; i++) {
      let r = e[i], s = t[i];
      if (r.from != s.from || r.to != s.to || r.size != s.size)
        return !1;
    }
    return !0;
  }
  draw(e, t) {
    return F.replace({
      widget: new aw(this.size * (t ? e.scaleY : e.scaleX), t)
    }).range(this.from, this.to);
  }
}
class aw extends mn {
  constructor(e, t) {
    super(), this.size = e, this.vertical = t;
  }
  eq(e) {
    return e.size == this.size && e.vertical == this.vertical;
  }
  toDOM() {
    let e = document.createElement("div");
    return this.vertical ? e.style.height = this.size + "px" : (e.style.width = this.size + "px", e.style.height = "2px", e.style.display = "inline-block"), e;
  }
  get estimatedHeight() {
    return this.vertical ? this.size : -1;
  }
}
class ld {
  constructor(e) {
    this.state = e, this.pixelViewport = { left: 0, right: window.innerWidth, top: 0, bottom: 0 }, this.inView = !0, this.paddingTop = 0, this.paddingBottom = 0, this.contentDOMWidth = 0, this.contentDOMHeight = 0, this.editorHeight = 0, this.editorWidth = 0, this.scrollTop = 0, this.scrolledToBottom = !1, this.scaleX = 1, this.scaleY = 1, this.scrollAnchorPos = 0, this.scrollAnchorHeight = -1, this.scaler = ud, this.scrollTarget = null, this.printing = !1, this.mustMeasureContent = !0, this.defaultTextDirection = Ae.LTR, this.visibleRanges = [], this.mustEnforceCursorAssoc = !1;
    let t = e.facet(sh).some((i) => typeof i != "function" && i.class == "cm-lineWrapping");
    this.heightOracle = new Jx(t), this.stateDeco = e.facet(os).filter((i) => typeof i != "function"), this.heightMap = lt.empty().applyChanges(this.stateDeco, me.empty, this.heightOracle.setDoc(e.doc), [new zt(0, 0, 0, e.doc.length)]);
    for (let i = 0; i < 2 && (this.viewport = this.getViewport(0, null), !!this.updateForViewport()); i++)
      ;
    this.updateViewportLines(), this.lineGaps = this.ensureLineGaps([]), this.lineGapDeco = F.set(this.lineGaps.map((i) => i.draw(this, !1))), this.computeVisibleRanges();
  }
  updateForViewport() {
    let e = [this.viewport], { main: t } = this.state.selection;
    for (let i = 0; i <= 1; i++) {
      let r = i ? t.head : t.anchor;
      if (!e.some(({ from: s, to: o }) => r >= s && r <= o)) {
        let { from: s, to: o } = this.lineBlockAt(r);
        e.push(new to(s, o));
      }
    }
    return this.viewports = e.sort((i, r) => i.from - r.from), this.updateScaler();
  }
  updateScaler() {
    let e = this.scaler;
    return this.scaler = this.heightMap.height <= 7e6 ? ud : new lh(this.heightOracle, this.heightMap, this.viewports), e.eq(this.scaler) ? 0 : 2;
  }
  updateViewportLines() {
    this.viewportLines = [], this.heightMap.forEachLine(this.viewport.from, this.viewport.to, this.heightOracle.setDoc(this.state.doc), 0, 0, (e) => {
      this.viewportLines.push(Xr(e, this.scaler));
    });
  }
  update(e, t = null) {
    this.state = e.state;
    let i = this.stateDeco;
    this.stateDeco = this.state.facet(os).filter((c) => typeof c != "function");
    let r = e.changedRanges, s = zt.extendWithRanges(r, iw(i, this.stateDeco, e ? e.changes : We.empty(this.state.doc.length))), o = this.heightMap.height, a = this.scrolledToBottom ? null : this.scrollAnchorAt(this.scrollTop);
    this.heightMap = this.heightMap.applyChanges(this.stateDeco, e.startState.doc, this.heightOracle.setDoc(this.state.doc), s), this.heightMap.height != o && (e.flags |= 2), a ? (this.scrollAnchorPos = e.changes.mapPos(a.from, -1), this.scrollAnchorHeight = a.top) : (this.scrollAnchorPos = -1, this.scrollAnchorHeight = this.heightMap.height);
    let l = s.length ? this.mapViewport(this.viewport, e.changes) : this.viewport;
    (t && (t.range.head < l.from || t.range.head > l.to) || !this.viewportIsAppropriate(l)) && (l = this.getViewport(0, t));
    let u = l.from != this.viewport.from || l.to != this.viewport.to;
    this.viewport = l, e.flags |= this.updateForViewport(), (u || !e.changes.empty || e.flags & 2) && this.updateViewportLines(), (this.lineGaps.length || this.viewport.to - this.viewport.from > 4e3) && this.updateLineGaps(this.ensureLineGaps(this.mapLineGaps(this.lineGaps, e.changes))), e.flags |= this.computeVisibleRanges(), t && (this.scrollTarget = t), !this.mustEnforceCursorAssoc && e.selectionSet && e.view.lineWrapping && e.state.selection.main.empty && e.state.selection.main.assoc && !e.state.facet(hO) && (this.mustEnforceCursorAssoc = !0);
  }
  measure(e) {
    let t = e.contentDOM, i = window.getComputedStyle(t), r = this.heightOracle, s = i.whiteSpace;
    this.defaultTextDirection = i.direction == "rtl" ? Ae.RTL : Ae.LTR;
    let o = this.heightOracle.mustRefreshForWrapping(s), a = t.getBoundingClientRect(), l = o || this.mustMeasureContent || this.contentDOMHeight != a.height;
    this.contentDOMHeight = a.height, this.mustMeasureContent = !1;
    let u = 0, c = 0;
    if (a.width && a.height) {
      let { scaleX: Q, scaleY: v } = Lg(t, a);
      (Q > 5e-3 && Math.abs(this.scaleX - Q) > 5e-3 || v > 5e-3 && Math.abs(this.scaleY - v) > 5e-3) && (this.scaleX = Q, this.scaleY = v, u |= 8, o = l = !0);
    }
    let h = (parseInt(i.paddingTop) || 0) * this.scaleY, f = (parseInt(i.paddingBottom) || 0) * this.scaleY;
    (this.paddingTop != h || this.paddingBottom != f) && (this.paddingTop = h, this.paddingBottom = f, u |= 10), this.editorWidth != e.scrollDOM.clientWidth && (r.lineWrapping && (l = !0), this.editorWidth = e.scrollDOM.clientWidth, u |= 8);
    let d = e.scrollDOM.scrollTop * this.scaleY;
    this.scrollTop != d && (this.scrollAnchorHeight = -1, this.scrollTop = d), this.scrolledToBottom = Ng(e.scrollDOM);
    let p = (this.printing ? ow : sw)(t, this.paddingTop), g = p.top - this.pixelViewport.top, O = p.bottom - this.pixelViewport.bottom;
    this.pixelViewport = p;
    let m = this.pixelViewport.bottom > this.pixelViewport.top && this.pixelViewport.right > this.pixelViewport.left;
    if (m != this.inView && (this.inView = m, m && (l = !0)), !this.inView && !this.scrollTarget)
      return 0;
    let b = a.width;
    if ((this.contentDOMWidth != b || this.editorHeight != e.scrollDOM.clientHeight) && (this.contentDOMWidth = a.width, this.editorHeight = e.scrollDOM.clientHeight, u |= 8), l) {
      let Q = e.docView.measureVisibleLineHeights(this.viewport);
      if (r.mustRefreshForHeights(Q) && (o = !0), o || r.lineWrapping && Math.abs(b - this.contentDOMWidth) > r.charWidth) {
        let { lineHeight: v, charWidth: k, textHeight: C } = e.docView.measureTextSize();
        o = v > 0 && r.refresh(s, v, k, C, b / k, Q), o && (e.docView.minWidth = 0, u |= 8);
      }
      g > 0 && O > 0 ? c = Math.max(g, O) : g < 0 && O < 0 && (c = Math.min(g, O)), r.heightChanged = !1;
      for (let v of this.viewports) {
        let k = v.from == this.viewport.from ? Q : e.docView.measureVisibleLineHeights(v);
        this.heightMap = (o ? lt.empty().applyChanges(this.stateDeco, me.empty, this.heightOracle, [new zt(0, 0, 0, e.state.doc.length)]) : this.heightMap).updateHeight(r, 0, o, new ew(v.from, k));
      }
      r.heightChanged && (u |= 2);
    }
    let w = !this.viewportIsAppropriate(this.viewport, c) || this.scrollTarget && (this.scrollTarget.range.head < this.viewport.from || this.scrollTarget.range.head > this.viewport.to);
    return w && (u & 2 && (u |= this.updateScaler()), this.viewport = this.getViewport(c, this.scrollTarget), u |= this.updateForViewport()), (u & 2 || w) && this.updateViewportLines(), (this.lineGaps.length || this.viewport.to - this.viewport.from > 4e3) && this.updateLineGaps(this.ensureLineGaps(o ? [] : this.lineGaps, e)), u |= this.computeVisibleRanges(), this.mustEnforceCursorAssoc && (this.mustEnforceCursorAssoc = !1, e.docView.enforceCursorAssoc()), u;
  }
  get visibleTop() {
    return this.scaler.fromDOM(this.pixelViewport.top);
  }
  get visibleBottom() {
    return this.scaler.fromDOM(this.pixelViewport.bottom);
  }
  getViewport(e, t) {
    let i = 0.5 - Math.max(-0.5, Math.min(0.5, e / 1e3 / 2)), r = this.heightMap, s = this.heightOracle, { visibleTop: o, visibleBottom: a } = this, l = new to(r.lineAt(o - i * 1e3, $e.ByHeight, s, 0, 0).from, r.lineAt(a + (1 - i) * 1e3, $e.ByHeight, s, 0, 0).to);
    if (t) {
      let { head: u } = t.range;
      if (u < l.from || u > l.to) {
        let c = Math.min(this.editorHeight, this.pixelViewport.bottom - this.pixelViewport.top), h = r.lineAt(u, $e.ByPos, s, 0, 0), f;
        t.y == "center" ? f = (h.top + h.bottom) / 2 - c / 2 : t.y == "start" || t.y == "nearest" && u < l.from ? f = h.top : f = h.bottom - c, l = new to(r.lineAt(f - 1e3 / 2, $e.ByHeight, s, 0, 0).from, r.lineAt(f + c + 1e3 / 2, $e.ByHeight, s, 0, 0).to);
      }
    }
    return l;
  }
  mapViewport(e, t) {
    let i = t.mapPos(e.from, -1), r = t.mapPos(e.to, 1);
    return new to(this.heightMap.lineAt(i, $e.ByPos, this.heightOracle, 0, 0).from, this.heightMap.lineAt(r, $e.ByPos, this.heightOracle, 0, 0).to);
  }
  // Checks if a given viewport covers the visible part of the
  // document and not too much beyond that.
  viewportIsAppropriate({ from: e, to: t }, i = 0) {
    if (!this.inView)
      return !0;
    let { top: r } = this.heightMap.lineAt(e, $e.ByPos, this.heightOracle, 0, 0), { bottom: s } = this.heightMap.lineAt(t, $e.ByPos, this.heightOracle, 0, 0), { visibleTop: o, visibleBottom: a } = this;
    return (e == 0 || r <= o - Math.max(10, Math.min(
      -i,
      250
      /* VP.MaxCoverMargin */
    ))) && (t == this.state.doc.length || s >= a + Math.max(10, Math.min(
      i,
      250
      /* VP.MaxCoverMargin */
    ))) && r > o - 2 * 1e3 && s < a + 2 * 1e3;
  }
  mapLineGaps(e, t) {
    if (!e.length || t.empty)
      return e;
    let i = [];
    for (let r of e)
      t.touchesRange(r.from, r.to) || i.push(new kl(t.mapPos(r.from), t.mapPos(r.to), r.size));
    return i;
  }
  // Computes positions in the viewport where the start or end of a
  // line should be hidden, trying to reuse existing line gaps when
  // appropriate to avoid unneccesary redraws.
  // Uses crude character-counting for the positioning and sizing,
  // since actual DOM coordinates aren't always available and
  // predictable. Relies on generous margins (see LG.Margin) to hide
  // the artifacts this might produce from the user.
  ensureLineGaps(e, t) {
    let i = this.heightOracle.lineWrapping, r = i ? 1e4 : 2e3, s = r >> 1, o = r << 1;
    if (this.defaultTextDirection != Ae.LTR && !i)
      return [];
    let a = [], l = (u, c, h, f) => {
      if (c - u < s)
        return;
      let d = this.state.selection.main, p = [d.from];
      d.empty || p.push(d.to);
      for (let O of p)
        if (O > u && O < c) {
          l(u, O - 10, h, f), l(O + 10, c, h, f);
          return;
        }
      let g = uw(e, (O) => O.from >= h.from && O.to <= h.to && Math.abs(O.from - u) < s && Math.abs(O.to - c) < s && !p.some((m) => O.from < m && O.to > m));
      if (!g) {
        if (c < h.to && t && i && t.visibleRanges.some((O) => O.from <= c && O.to >= c)) {
          let O = t.moveToLineBoundary($.cursor(c), !1, !0).head;
          O > u && (c = O);
        }
        g = new kl(u, c, this.gapSize(h, u, c, f));
      }
      a.push(g);
    };
    for (let u of this.viewportLines) {
      if (u.length < o)
        continue;
      let c = lw(u.from, u.to, this.stateDeco);
      if (c.total < o)
        continue;
      let h = this.scrollTarget ? this.scrollTarget.range.head : null, f, d;
      if (i) {
        let p = r / this.heightOracle.lineLength * this.heightOracle.lineHeight, g, O;
        if (h != null) {
          let m = io(c, h), b = ((this.visibleBottom - this.visibleTop) / 2 + p) / u.height;
          g = m - b, O = m + b;
        } else
          g = (this.visibleTop - u.top - p) / u.height, O = (this.visibleBottom - u.top + p) / u.height;
        f = no(c, g), d = no(c, O);
      } else {
        let p = c.total * this.heightOracle.charWidth, g = r * this.heightOracle.charWidth, O, m;
        if (h != null) {
          let b = io(c, h), w = ((this.pixelViewport.right - this.pixelViewport.left) / 2 + g) / p;
          O = b - w, m = b + w;
        } else
          O = (this.pixelViewport.left - g) / p, m = (this.pixelViewport.right + g) / p;
        f = no(c, O), d = no(c, m);
      }
      f > u.from && l(u.from, f, u, c), d < u.to && l(d, u.to, u, c);
    }
    return a;
  }
  gapSize(e, t, i, r) {
    let s = io(r, i) - io(r, t);
    return this.heightOracle.lineWrapping ? e.height * s : r.total * this.heightOracle.charWidth * s;
  }
  updateLineGaps(e) {
    kl.same(e, this.lineGaps) || (this.lineGaps = e, this.lineGapDeco = F.set(e.map((t) => t.draw(this, this.heightOracle.lineWrapping))));
  }
  computeVisibleRanges() {
    let e = this.stateDeco;
    this.lineGaps.length && (e = e.concat(this.lineGapDeco));
    let t = [];
    de.spans(e, this.viewport.from, this.viewport.to, {
      span(r, s) {
        t.push({ from: r, to: s });
      },
      point() {
      }
    }, 20);
    let i = t.length != this.visibleRanges.length || this.visibleRanges.some((r, s) => r.from != t[s].from || r.to != t[s].to);
    return this.visibleRanges = t, i ? 4 : 0;
  }
  lineBlockAt(e) {
    return e >= this.viewport.from && e <= this.viewport.to && this.viewportLines.find((t) => t.from <= e && t.to >= e) || Xr(this.heightMap.lineAt(e, $e.ByPos, this.heightOracle, 0, 0), this.scaler);
  }
  lineBlockAtHeight(e) {
    return e >= this.viewportLines[0].top && e <= this.viewportLines[this.viewportLines.length - 1].bottom && this.viewportLines.find((t) => t.top <= e && t.bottom >= e) || Xr(this.heightMap.lineAt(this.scaler.fromDOM(e), $e.ByHeight, this.heightOracle, 0, 0), this.scaler);
  }
  scrollAnchorAt(e) {
    let t = this.lineBlockAtHeight(e + 8);
    return t.from >= this.viewport.from || this.viewportLines[0].top - e > 200 ? t : this.viewportLines[0];
  }
  elementAtHeight(e) {
    return Xr(this.heightMap.blockAt(this.scaler.fromDOM(e), this.heightOracle, 0, 0), this.scaler);
  }
  get docHeight() {
    return this.scaler.toDOM(this.heightMap.height);
  }
  get contentHeight() {
    return this.docHeight + this.paddingTop + this.paddingBottom;
  }
}
class to {
  constructor(e, t) {
    this.from = e, this.to = t;
  }
}
function lw(n, e, t) {
  let i = [], r = n, s = 0;
  return de.spans(t, n, e, {
    span() {
    },
    point(o, a) {
      o > r && (i.push({ from: r, to: o }), s += o - r), r = a;
    }
  }, 20), r < e && (i.push({ from: r, to: e }), s += e - r), { total: s, ranges: i };
}
function no({ total: n, ranges: e }, t) {
  if (t <= 0)
    return e[0].from;
  if (t >= 1)
    return e[e.length - 1].to;
  let i = Math.floor(n * t);
  for (let r = 0; ; r++) {
    let { from: s, to: o } = e[r], a = o - s;
    if (i <= a)
      return s + i;
    i -= a;
  }
}
function io(n, e) {
  let t = 0;
  for (let { from: i, to: r } of n.ranges) {
    if (e <= r) {
      t += e - i;
      break;
    }
    t += r - i;
  }
  return t / n.total;
}
function uw(n, e) {
  for (let t of n)
    if (e(t))
      return t;
}
const ud = {
  toDOM(n) {
    return n;
  },
  fromDOM(n) {
    return n;
  },
  scale: 1,
  eq(n) {
    return n == this;
  }
};
class lh {
  constructor(e, t, i) {
    let r = 0, s = 0, o = 0;
    this.viewports = i.map(({ from: a, to: l }) => {
      let u = t.lineAt(a, $e.ByPos, e, 0, 0).top, c = t.lineAt(l, $e.ByPos, e, 0, 0).bottom;
      return r += c - u, { from: a, to: l, top: u, bottom: c, domTop: 0, domBottom: 0 };
    }), this.scale = (7e6 - r) / (t.height - r);
    for (let a of this.viewports)
      a.domTop = o + (a.top - s) * this.scale, o = a.domBottom = a.domTop + (a.bottom - a.top), s = a.bottom;
  }
  toDOM(e) {
    for (let t = 0, i = 0, r = 0; ; t++) {
      let s = t < this.viewports.length ? this.viewports[t] : null;
      if (!s || e < s.top)
        return r + (e - i) * this.scale;
      if (e <= s.bottom)
        return s.domTop + (e - s.top);
      i = s.bottom, r = s.domBottom;
    }
  }
  fromDOM(e) {
    for (let t = 0, i = 0, r = 0; ; t++) {
      let s = t < this.viewports.length ? this.viewports[t] : null;
      if (!s || e < s.domTop)
        return i + (e - r) / this.scale;
      if (e <= s.domBottom)
        return s.top + (e - s.domTop);
      i = s.bottom, r = s.domBottom;
    }
  }
  eq(e) {
    return e instanceof lh ? this.scale == e.scale && this.viewports.length == e.viewports.length && this.viewports.every((t, i) => t.from == e.viewports[i].from && t.to == e.viewports[i].to) : !1;
  }
}
function Xr(n, e) {
  if (e.scale == 1)
    return n;
  let t = e.toDOM(n.top), i = e.toDOM(n.bottom);
  return new on(n.from, n.length, t, i - t, Array.isArray(n._content) ? n._content.map((r) => Xr(r, e)) : n._content);
}
const ro = /* @__PURE__ */ N.define({ combine: (n) => n.join(" ") }), Yu = /* @__PURE__ */ N.define({ combine: (n) => n.indexOf(!0) > -1 }), ju = /* @__PURE__ */ Gn.newName(), AO = /* @__PURE__ */ Gn.newName(), RO = /* @__PURE__ */ Gn.newName(), MO = { "&light": "." + AO, "&dark": "." + RO };
function Uu(n, e, t) {
  return new Gn(e, {
    finish(i) {
      return /&/.test(i) ? i.replace(/&\w*/, (r) => {
        if (r == "&")
          return n;
        if (!t || !t[r])
          throw new RangeError(`Unsupported selector: ${r}`);
        return t[r];
      }) : n + " " + i;
    }
  });
}
const cw = /* @__PURE__ */ Uu("." + ju, {
  "&": {
    position: "relative !important",
    boxSizing: "border-box",
    "&.cm-focused": {
      // Provide a simple default outline to make sure a focused
      // editor is visually distinct. Can't leave the default behavior
      // because that will apply to the content element, which is
      // inside the scrollable container and doesn't include the
      // gutters. We also can't use an 'auto' outline, since those
      // are, for some reason, drawn behind the element content, which
      // will cause things like the active line background to cover
      // the outline (#297).
      outline: "1px dotted #212121"
    },
    display: "flex !important",
    flexDirection: "column"
  },
  ".cm-scroller": {
    display: "flex !important",
    alignItems: "flex-start !important",
    fontFamily: "monospace",
    lineHeight: 1.4,
    height: "100%",
    overflowX: "auto",
    position: "relative",
    zIndex: 0
  },
  ".cm-content": {
    margin: 0,
    flexGrow: 2,
    flexShrink: 0,
    display: "block",
    whiteSpace: "pre",
    wordWrap: "normal",
    // https://github.com/codemirror/dev/issues/456
    boxSizing: "border-box",
    minHeight: "100%",
    padding: "4px 0",
    outline: "none",
    "&[contenteditable=true]": {
      WebkitUserModify: "read-write-plaintext-only"
    }
  },
  ".cm-lineWrapping": {
    whiteSpace_fallback: "pre-wrap",
    // For IE
    whiteSpace: "break-spaces",
    wordBreak: "break-word",
    // For Safari, which doesn't support overflow-wrap: anywhere
    overflowWrap: "anywhere",
    flexShrink: 1
  },
  "&light .cm-content": { caretColor: "black" },
  "&dark .cm-content": { caretColor: "white" },
  ".cm-line": {
    display: "block",
    padding: "0 2px 0 6px"
  },
  ".cm-layer": {
    position: "absolute",
    left: 0,
    top: 0,
    contain: "size style",
    "& > *": {
      position: "absolute"
    }
  },
  "&light .cm-selectionBackground": {
    background: "#d9d9d9"
  },
  "&dark .cm-selectionBackground": {
    background: "#222"
  },
  "&light.cm-focused > .cm-scroller > .cm-selectionLayer .cm-selectionBackground": {
    background: "#d7d4f0"
  },
  "&dark.cm-focused > .cm-scroller > .cm-selectionLayer .cm-selectionBackground": {
    background: "#233"
  },
  ".cm-cursorLayer": {
    pointerEvents: "none"
  },
  "&.cm-focused > .cm-scroller > .cm-cursorLayer": {
    animation: "steps(1) cm-blink 1.2s infinite"
  },
  // Two animations defined so that we can switch between them to
  // restart the animation without forcing another style
  // recomputation.
  "@keyframes cm-blink": { "0%": {}, "50%": { opacity: 0 }, "100%": {} },
  "@keyframes cm-blink2": { "0%": {}, "50%": { opacity: 0 }, "100%": {} },
  ".cm-cursor, .cm-dropCursor": {
    borderLeft: "1.2px solid black",
    marginLeft: "-0.6px",
    pointerEvents: "none"
  },
  ".cm-cursor": {
    display: "none"
  },
  "&dark .cm-cursor": {
    borderLeftColor: "#444"
  },
  ".cm-dropCursor": {
    position: "absolute"
  },
  "&.cm-focused > .cm-scroller > .cm-cursorLayer .cm-cursor": {
    display: "block"
  },
  ".cm-iso": {
    unicodeBidi: "isolate"
  },
  ".cm-announced": {
    position: "fixed",
    top: "-10000px"
  },
  "@media print": {
    ".cm-announced": { display: "none" }
  },
  "&light .cm-activeLine": { backgroundColor: "#cceeff44" },
  "&dark .cm-activeLine": { backgroundColor: "#99eeff33" },
  "&light .cm-specialChar": { color: "red" },
  "&dark .cm-specialChar": { color: "#f78" },
  ".cm-gutters": {
    flexShrink: 0,
    display: "flex",
    height: "100%",
    boxSizing: "border-box",
    insetInlineStart: 0,
    zIndex: 200
  },
  "&light .cm-gutters": {
    backgroundColor: "#f5f5f5",
    color: "#6c6c6c",
    borderRight: "1px solid #ddd"
  },
  "&dark .cm-gutters": {
    backgroundColor: "#333338",
    color: "#ccc"
  },
  ".cm-gutter": {
    display: "flex !important",
    // Necessary -- prevents margin collapsing
    flexDirection: "column",
    flexShrink: 0,
    boxSizing: "border-box",
    minHeight: "100%",
    overflow: "hidden"
  },
  ".cm-gutterElement": {
    boxSizing: "border-box"
  },
  ".cm-lineNumbers .cm-gutterElement": {
    padding: "0 3px 0 5px",
    minWidth: "20px",
    textAlign: "right",
    whiteSpace: "nowrap"
  },
  "&light .cm-activeLineGutter": {
    backgroundColor: "#e2f2ff"
  },
  "&dark .cm-activeLineGutter": {
    backgroundColor: "#222227"
  },
  ".cm-panels": {
    boxSizing: "border-box",
    position: "sticky",
    left: 0,
    right: 0
  },
  "&light .cm-panels": {
    backgroundColor: "#f5f5f5",
    color: "black"
  },
  "&light .cm-panels-top": {
    borderBottom: "1px solid #ddd"
  },
  "&light .cm-panels-bottom": {
    borderTop: "1px solid #ddd"
  },
  "&dark .cm-panels": {
    backgroundColor: "#333338",
    color: "white"
  },
  ".cm-tab": {
    display: "inline-block",
    overflow: "hidden",
    verticalAlign: "bottom"
  },
  ".cm-widgetBuffer": {
    verticalAlign: "text-top",
    height: "1em",
    width: 0,
    display: "inline"
  },
  ".cm-placeholder": {
    color: "#888",
    display: "inline-block",
    verticalAlign: "top"
  },
  ".cm-highlightSpace:before": {
    content: "attr(data-display)",
    position: "absolute",
    pointerEvents: "none",
    color: "#888"
  },
  ".cm-highlightTab": {
    backgroundImage: `url('data:image/svg+xml,<svg xmlns="http://www.w3.org/2000/svg" width="200" height="20"><path stroke="%23888" stroke-width="1" fill="none" d="M1 10H196L190 5M190 15L196 10M197 4L197 16"/></svg>')`,
    backgroundSize: "auto 100%",
    backgroundPosition: "right 90%",
    backgroundRepeat: "no-repeat"
  },
  ".cm-trailingSpace": {
    backgroundColor: "#ff332255"
  },
  ".cm-button": {
    verticalAlign: "middle",
    color: "inherit",
    fontSize: "70%",
    padding: ".2em 1em",
    borderRadius: "1px"
  },
  "&light .cm-button": {
    backgroundImage: "linear-gradient(#eff1f5, #d9d9df)",
    border: "1px solid #888",
    "&:active": {
      backgroundImage: "linear-gradient(#b4b4b4, #d0d3d6)"
    }
  },
  "&dark .cm-button": {
    backgroundImage: "linear-gradient(#393939, #111)",
    border: "1px solid #888",
    "&:active": {
      backgroundImage: "linear-gradient(#111, #333)"
    }
  },
  ".cm-textfield": {
    verticalAlign: "middle",
    color: "inherit",
    fontSize: "70%",
    border: "1px solid silver",
    padding: ".2em .5em"
  },
  "&light .cm-textfield": {
    backgroundColor: "white"
  },
  "&dark .cm-textfield": {
    border: "1px solid #555",
    backgroundColor: "inherit"
  }
}, MO), Nr = "￿";
class hw {
  constructor(e, t) {
    this.points = e, this.text = "", this.lineSeparator = t.facet(se.lineSeparator);
  }
  append(e) {
    this.text += e;
  }
  lineBreak() {
    this.text += Nr;
  }
  readRange(e, t) {
    if (!e)
      return this;
    let i = e.parentNode;
    for (let r = e; ; ) {
      this.findPointBefore(i, r);
      let s = this.text.length;
      this.readNode(r);
      let o = r.nextSibling;
      if (o == t)
        break;
      let a = ke.get(r), l = ke.get(o);
      (a && l ? a.breakAfter : (a ? a.breakAfter : ra(r)) || ra(o) && (r.nodeName != "BR" || r.cmIgnore) && this.text.length > s) && this.lineBreak(), r = o;
    }
    return this.findPointBefore(i, t), this;
  }
  readTextNode(e) {
    let t = e.nodeValue;
    for (let i of this.points)
      i.node == e && (i.pos = this.text.length + Math.min(i.offset, t.length));
    for (let i = 0, r = this.lineSeparator ? null : /\r\n?|\n/g; ; ) {
      let s = -1, o = 1, a;
      if (this.lineSeparator ? (s = t.indexOf(this.lineSeparator, i), o = this.lineSeparator.length) : (a = r.exec(t)) && (s = a.index, o = a[0].length), this.append(t.slice(i, s < 0 ? t.length : s)), s < 0)
        break;
      if (this.lineBreak(), o > 1)
        for (let l of this.points)
          l.node == e && l.pos > this.text.length && (l.pos -= o - 1);
      i = s + o;
    }
  }
  readNode(e) {
    if (e.cmIgnore)
      return;
    let t = ke.get(e), i = t && t.overrideDOMText;
    if (i != null) {
      this.findPointInside(e, i.length);
      for (let r = i.iter(); !r.next().done; )
        r.lineBreak ? this.lineBreak() : this.append(r.value);
    } else
      e.nodeType == 3 ? this.readTextNode(e) : e.nodeName == "BR" ? e.nextSibling && this.lineBreak() : e.nodeType == 1 && this.readRange(e.firstChild, null);
  }
  findPointBefore(e, t) {
    for (let i of this.points)
      i.node == e && e.childNodes[i.offset] == t && (i.pos = this.text.length);
  }
  findPointInside(e, t) {
    for (let i of this.points)
      (e.nodeType == 3 ? i.node == e : e.contains(i.node)) && (i.pos = this.text.length + (fw(e, i.node, i.offset) ? t : 0));
  }
}
function fw(n, e, t) {
  for (; ; ) {
    if (!e || t < Qn(e))
      return !1;
    if (e == n)
      return !0;
    t = xi(e) + 1, e = e.parentNode;
  }
}
class cd {
  constructor(e, t) {
    this.node = e, this.offset = t, this.pos = -1;
  }
}
class dw {
  constructor(e, t, i, r) {
    this.typeOver = r, this.bounds = null, this.text = "", this.domChanged = t > -1;
    let { impreciseHead: s, impreciseAnchor: o } = e.docView;
    if (e.state.readOnly && t > -1)
      this.newSel = null;
    else if (t > -1 && (this.bounds = e.docView.domBoundsAround(t, i, 0))) {
      let a = s || o ? [] : gw(e), l = new hw(a, e.state);
      l.readRange(this.bounds.startDOM, this.bounds.endDOM), this.text = l.text, this.newSel = Ow(a, this.bounds.from);
    } else {
      let a = e.observer.selectionRange, l = s && s.node == a.focusNode && s.offset == a.focusOffset || !Mu(e.contentDOM, a.focusNode) ? e.state.selection.main.head : e.docView.posFromDOM(a.focusNode, a.focusOffset), u = o && o.node == a.anchorNode && o.offset == a.anchorOffset || !Mu(e.contentDOM, a.anchorNode) ? e.state.selection.main.anchor : e.docView.posFromDOM(a.anchorNode, a.anchorOffset), c = e.viewport;
      if ((W.ios || W.chrome) && e.state.selection.main.empty && l != u && (c.from > 0 || c.to < e.state.doc.length)) {
        let h = Math.min(l, u), f = Math.max(l, u), d = c.from - h, p = c.to - f;
        (d == 0 || d == 1 || h == 0) && (p == 0 || p == -1 || f == e.state.doc.length) && (l = 0, u = e.state.doc.length);
      }
      this.newSel = $.single(u, l);
    }
  }
}
function ZO(n, e) {
  let t, { newSel: i } = e, r = n.state.selection.main, s = n.inputState.lastKeyTime > Date.now() - 100 ? n.inputState.lastKeyCode : -1;
  if (e.bounds) {
    let { from: o, to: a } = e.bounds, l = r.from, u = null;
    (s === 8 || W.android && e.text.length < a - o) && (l = r.to, u = "end");
    let c = mw(n.state.doc.sliceString(o, a, Nr), e.text, l - o, u);
    c && (W.chrome && s == 13 && c.toB == c.from + 2 && e.text.slice(c.from, c.toB) == Nr + Nr && c.toB--, t = {
      from: o + c.from,
      to: o + c.toA,
      insert: me.of(e.text.slice(c.from, c.toB).split(Nr))
    });
  } else
    i && (!n.hasFocus && n.state.facet(Ya) || i.main.eq(r)) && (i = null);
  if (!t && !i)
    return !1;
  if (!t && e.typeOver && !r.empty && i && i.main.empty ? t = { from: r.from, to: r.to, insert: n.state.doc.slice(r.from, r.to) } : t && t.from >= r.from && t.to <= r.to && (t.from != r.from || t.to != r.to) && r.to - r.from - (t.to - t.from) <= 4 ? t = {
    from: r.from,
    to: r.to,
    insert: n.state.doc.slice(r.from, t.from).append(t.insert).append(n.state.doc.slice(t.to, r.to))
  } : (W.mac || W.android) && t && t.from == t.to && t.from == r.head - 1 && /^\. ?$/.test(t.insert.toString()) && n.contentDOM.getAttribute("autocorrect") == "off" ? (i && t.insert.length == 2 && (i = $.single(i.main.anchor - 1, i.main.head - 1)), t = { from: r.from, to: r.to, insert: me.of([" "]) }) : W.chrome && t && t.from == t.to && t.from == r.head && t.insert.toString() == `
 ` && n.lineWrapping && (i && (i = $.single(i.main.anchor - 1, i.main.head - 1)), t = { from: r.from, to: r.to, insert: me.of([" "]) }), t) {
    if (W.ios && n.inputState.flushIOSKey(t) || W.android && (t.to == r.to && // GBoard will sometimes remove a space it just inserted
    // after a completion when you press enter
    (t.from == r.from || t.from == r.from - 1 && n.state.sliceDoc(t.from, r.from) == " ") && t.insert.length == 1 && t.insert.lines == 2 && Yi(n.contentDOM, "Enter", 13) || (t.from == r.from - 1 && t.to == r.to && t.insert.length == 0 || s == 8 && t.insert.length < t.to - t.from && t.to > r.head) && Yi(n.contentDOM, "Backspace", 8) || t.from == r.from && t.to == r.to + 1 && t.insert.length == 0 && Yi(n.contentDOM, "Delete", 46)))
      return !0;
    let o = t.insert.toString();
    n.inputState.composing >= 0 && n.inputState.composing++;
    let a, l = () => a || (a = pw(n, t, i));
    return n.state.facet(lO).some((u) => u(n, t.from, t.to, o, l)) || n.dispatch(l()), !0;
  } else if (i && !i.main.eq(r)) {
    let o = !1, a = "select";
    return n.inputState.lastSelectionTime > Date.now() - 50 && (n.inputState.lastSelectionOrigin == "select" && (o = !0), a = n.inputState.lastSelectionOrigin), n.dispatch({ selection: i, scrollIntoView: o, userEvent: a }), !0;
  } else
    return !1;
}
function pw(n, e, t) {
  let i, r = n.state, s = r.selection.main;
  if (e.from >= s.from && e.to <= s.to && e.to - e.from >= (s.to - s.from) / 3 && (!t || t.main.empty && t.main.from == e.from + e.insert.length) && n.inputState.composing < 0) {
    let a = s.from < e.from ? r.sliceDoc(s.from, e.from) : "", l = s.to > e.to ? r.sliceDoc(e.to, s.to) : "";
    i = r.replaceSelection(n.state.toText(a + e.insert.sliceString(0, void 0, n.state.lineBreak) + l));
  } else {
    let a = r.changes(e), l = t && t.main.to <= a.newLength ? t.main : void 0;
    if (r.selection.ranges.length > 1 && n.inputState.composing >= 0 && e.to <= s.to && e.to >= s.to - 10) {
      let u = n.state.sliceDoc(e.from, e.to), c, h = t && bO(n, t.main.head);
      if (h) {
        let p = e.insert.length - (e.to - e.from);
        c = { from: h.from, to: h.to - p };
      } else
        c = n.state.doc.lineAt(s.head);
      let f = s.to - e.to, d = s.to - s.from;
      i = r.changeByRange((p) => {
        if (p.from == s.from && p.to == s.to)
          return { changes: a, range: l || p.map(a) };
        let g = p.to - f, O = g - u.length;
        if (p.to - p.from != d || n.state.sliceDoc(O, g) != u || // Unfortunately, there's no way to make multiple
        // changes in the same node work without aborting
        // composition, so cursors in the composition range are
        // ignored.
        p.to >= c.from && p.from <= c.to)
          return { range: p };
        let m = r.changes({ from: O, to: g, insert: e.insert }), b = p.to - s.to;
        return {
          changes: m,
          range: l ? $.range(Math.max(0, l.anchor + b), Math.max(0, l.head + b)) : p.map(m)
        };
      });
    } else
      i = {
        changes: a,
        selection: l && r.selection.replaceRange(l)
      };
  }
  let o = "input.type";
  return (n.composing || n.inputState.compositionPendingChange && n.inputState.compositionEndedAt > Date.now() - 50) && (n.inputState.compositionPendingChange = !1, o += ".compose", n.inputState.compositionFirstChange && (o += ".start", n.inputState.compositionFirstChange = !1)), r.update(i, { userEvent: o, scrollIntoView: !0 });
}
function mw(n, e, t, i) {
  let r = Math.min(n.length, e.length), s = 0;
  for (; s < r && n.charCodeAt(s) == e.charCodeAt(s); )
    s++;
  if (s == r && n.length == e.length)
    return null;
  let o = n.length, a = e.length;
  for (; o > 0 && a > 0 && n.charCodeAt(o - 1) == e.charCodeAt(a - 1); )
    o--, a--;
  if (i == "end") {
    let l = Math.max(0, s - Math.min(o, a));
    t -= o + l - s;
  }
  if (o < s && n.length < e.length) {
    let l = t <= s && t >= o ? s - t : 0;
    s -= l, a = s + (a - o), o = s;
  } else if (a < s) {
    let l = t <= s && t >= a ? s - t : 0;
    s -= l, o = s + (o - a), a = s;
  }
  return { from: s, toA: o, toB: a };
}
function gw(n) {
  let e = [];
  if (n.root.activeElement != n.contentDOM)
    return e;
  let { anchorNode: t, anchorOffset: i, focusNode: r, focusOffset: s } = n.observer.selectionRange;
  return t && (e.push(new cd(t, i)), (r != t || s != i) && e.push(new cd(r, s))), e;
}
function Ow(n, e) {
  if (n.length == 0)
    return null;
  let t = n[0].pos, i = n.length == 2 ? n[1].pos : t;
  return t > -1 && i > -1 ? $.single(t + e, i + e) : null;
}
const bw = {
  childList: !0,
  characterData: !0,
  subtree: !0,
  attributes: !0,
  characterDataOldValue: !0
}, xl = W.ie && W.ie_version <= 11;
class yw {
  constructor(e) {
    this.view = e, this.active = !1, this.selectionRange = new ix(), this.selectionChanged = !1, this.delayedFlush = -1, this.resizeTimeout = -1, this.queue = [], this.delayedAndroidKey = null, this.flushingAndroidKey = -1, this.lastChange = 0, this.scrollTargets = [], this.intersection = null, this.resizeScroll = null, this.intersecting = !1, this.gapIntersection = null, this.gaps = [], this.printQuery = null, this.parentCheck = -1, this.dom = e.contentDOM, this.observer = new MutationObserver((t) => {
      for (let i of t)
        this.queue.push(i);
      (W.ie && W.ie_version <= 11 || W.ios && e.composing) && t.some((i) => i.type == "childList" && i.removedNodes.length || i.type == "characterData" && i.oldValue.length > i.target.nodeValue.length) ? this.flushSoon() : this.flush();
    }), xl && (this.onCharData = (t) => {
      this.queue.push({
        target: t.target,
        type: "characterData",
        oldValue: t.prevValue
      }), this.flushSoon();
    }), this.onSelectionChange = this.onSelectionChange.bind(this), this.onResize = this.onResize.bind(this), this.onPrint = this.onPrint.bind(this), this.onScroll = this.onScroll.bind(this), window.matchMedia && (this.printQuery = window.matchMedia("print")), typeof ResizeObserver == "function" && (this.resizeScroll = new ResizeObserver(() => {
      var t;
      ((t = this.view.docView) === null || t === void 0 ? void 0 : t.lastUpdate) < Date.now() - 75 && this.onResize();
    }), this.resizeScroll.observe(e.scrollDOM)), this.addWindowListeners(this.win = e.win), this.start(), typeof IntersectionObserver == "function" && (this.intersection = new IntersectionObserver((t) => {
      this.parentCheck < 0 && (this.parentCheck = setTimeout(this.listenForScroll.bind(this), 1e3)), t.length > 0 && t[t.length - 1].intersectionRatio > 0 != this.intersecting && (this.intersecting = !this.intersecting, this.intersecting != this.view.inView && this.onScrollChanged(document.createEvent("Event")));
    }, { threshold: [0, 1e-3] }), this.intersection.observe(this.dom), this.gapIntersection = new IntersectionObserver((t) => {
      t.length > 0 && t[t.length - 1].intersectionRatio > 0 && this.onScrollChanged(document.createEvent("Event"));
    }, {})), this.listenForScroll(), this.readSelectionRange();
  }
  onScrollChanged(e) {
    this.view.inputState.runHandlers("scroll", e), this.intersecting && this.view.measure();
  }
  onScroll(e) {
    this.intersecting && this.flush(!1), this.onScrollChanged(e);
  }
  onResize() {
    this.resizeTimeout < 0 && (this.resizeTimeout = setTimeout(() => {
      this.resizeTimeout = -1, this.view.requestMeasure();
    }, 50));
  }
  onPrint(e) {
    e.type == "change" && !e.matches || (this.view.viewState.printing = !0, this.view.measure(), setTimeout(() => {
      this.view.viewState.printing = !1, this.view.requestMeasure();
    }, 500));
  }
  updateGaps(e) {
    if (this.gapIntersection && (e.length != this.gaps.length || this.gaps.some((t, i) => t != e[i]))) {
      this.gapIntersection.disconnect();
      for (let t of e)
        this.gapIntersection.observe(t);
      this.gaps = e;
    }
  }
  onSelectionChange(e) {
    let t = this.selectionChanged;
    if (!this.readSelectionRange() || this.delayedAndroidKey)
      return;
    let { view: i } = this, r = this.selectionRange;
    if (i.state.facet(Ya) ? i.root.activeElement != this.dom : !_o(i.dom, r))
      return;
    let s = r.anchorNode && i.docView.nearest(r.anchorNode);
    if (s && s.ignoreEvent(e)) {
      t || (this.selectionChanged = !1);
      return;
    }
    (W.ie && W.ie_version <= 11 || W.android && W.chrome) && !i.state.selection.main.empty && // (Selection.isCollapsed isn't reliable on IE)
    r.focusNode && jr(r.focusNode, r.focusOffset, r.anchorNode, r.anchorOffset) ? this.flushSoon() : this.flush(!1);
  }
  readSelectionRange() {
    let { view: e } = this, t = ia(e.root);
    if (!t)
      return !1;
    let i = W.safari && e.root.nodeType == 11 && Jk(this.dom.ownerDocument) == this.dom && kw(this.view, t) || t;
    if (!i || this.selectionRange.eq(i))
      return !1;
    let r = _o(this.dom, i);
    return r && !this.selectionChanged && e.inputState.lastFocusTime > Date.now() - 200 && e.inputState.lastTouchTime < Date.now() - 300 && sx(this.dom, i) ? (this.view.inputState.lastFocusTime = 0, e.docView.updateSelection(), !1) : (this.selectionRange.setRange(i), r && (this.selectionChanged = !0), !0);
  }
  setSelectionRange(e, t) {
    this.selectionRange.set(e.node, e.offset, t.node, t.offset), this.selectionChanged = !1;
  }
  clearSelectionRange() {
    this.selectionRange.set(null, 0, null, 0);
  }
  listenForScroll() {
    this.parentCheck = -1;
    let e = 0, t = null;
    for (let i = this.dom; i; )
      if (i.nodeType == 1)
        !t && e < this.scrollTargets.length && this.scrollTargets[e] == i ? e++ : t || (t = this.scrollTargets.slice(0, e)), t && t.push(i), i = i.assignedSlot || i.parentNode;
      else if (i.nodeType == 11)
        i = i.host;
      else
        break;
    if (e < this.scrollTargets.length && !t && (t = this.scrollTargets.slice(0, e)), t) {
      for (let i of this.scrollTargets)
        i.removeEventListener("scroll", this.onScroll);
      for (let i of this.scrollTargets = t)
        i.addEventListener("scroll", this.onScroll);
    }
  }
  ignore(e) {
    if (!this.active)
      return e();
    try {
      return this.stop(), e();
    } finally {
      this.start(), this.clear();
    }
  }
  start() {
    this.active || (this.observer.observe(this.dom, bw), xl && this.dom.addEventListener("DOMCharacterDataModified", this.onCharData), this.active = !0);
  }
  stop() {
    this.active && (this.active = !1, this.observer.disconnect(), xl && this.dom.removeEventListener("DOMCharacterDataModified", this.onCharData));
  }
  // Throw away any pending changes
  clear() {
    this.processRecords(), this.queue.length = 0, this.selectionChanged = !1;
  }
  // Chrome Android, especially in combination with GBoard, not only
  // doesn't reliably fire regular key events, but also often
  // surrounds the effect of enter or backspace with a bunch of
  // composition events that, when interrupted, cause text duplication
  // or other kinds of corruption. This hack makes the editor back off
  // from handling DOM changes for a moment when such a key is
  // detected (via beforeinput or keydown), and then tries to flush
  // them or, if that has no effect, dispatches the given key.
  delayAndroidKey(e, t) {
    var i;
    if (!this.delayedAndroidKey) {
      let r = () => {
        let s = this.delayedAndroidKey;
        s && (this.clearDelayedAndroidKey(), this.view.inputState.lastKeyCode = s.keyCode, this.view.inputState.lastKeyTime = Date.now(), !this.flush() && s.force && Yi(this.dom, s.key, s.keyCode));
      };
      this.flushingAndroidKey = this.view.win.requestAnimationFrame(r);
    }
    (!this.delayedAndroidKey || e == "Enter") && (this.delayedAndroidKey = {
      key: e,
      keyCode: t,
      // Only run the key handler when no changes are detected if
      // this isn't coming right after another change, in which case
      // it is probably part of a weird chain of updates, and should
      // be ignored if it returns the DOM to its previous state.
      force: this.lastChange < Date.now() - 50 || !!(!((i = this.delayedAndroidKey) === null || i === void 0) && i.force)
    });
  }
  clearDelayedAndroidKey() {
    this.win.cancelAnimationFrame(this.flushingAndroidKey), this.delayedAndroidKey = null, this.flushingAndroidKey = -1;
  }
  flushSoon() {
    this.delayedFlush < 0 && (this.delayedFlush = this.view.win.requestAnimationFrame(() => {
      this.delayedFlush = -1, this.flush();
    }));
  }
  forceFlush() {
    this.delayedFlush >= 0 && (this.view.win.cancelAnimationFrame(this.delayedFlush), this.delayedFlush = -1), this.flush();
  }
  pendingRecords() {
    for (let e of this.observer.takeRecords())
      this.queue.push(e);
    return this.queue;
  }
  processRecords() {
    let e = this.pendingRecords();
    e.length && (this.queue = []);
    let t = -1, i = -1, r = !1;
    for (let s of e) {
      let o = this.readMutation(s);
      o && (o.typeOver && (r = !0), t == -1 ? { from: t, to: i } = o : (t = Math.min(o.from, t), i = Math.max(o.to, i)));
    }
    return { from: t, to: i, typeOver: r };
  }
  readChange() {
    let { from: e, to: t, typeOver: i } = this.processRecords(), r = this.selectionChanged && _o(this.dom, this.selectionRange);
    if (e < 0 && !r)
      return null;
    e > -1 && (this.lastChange = Date.now()), this.view.inputState.lastFocusTime = 0, this.selectionChanged = !1;
    let s = new dw(this.view, e, t, i);
    return this.view.docView.domChanged = { newSel: s.newSel ? s.newSel.main : null }, s;
  }
  // Apply pending changes, if any
  flush(e = !0) {
    if (this.delayedFlush >= 0 || this.delayedAndroidKey)
      return !1;
    e && this.readSelectionRange();
    let t = this.readChange();
    if (!t)
      return this.view.requestMeasure(), !1;
    let i = this.view.state, r = ZO(this.view, t);
    return this.view.state == i && (t.domChanged || t.newSel && !t.newSel.main.eq(this.view.state.selection.main)) && this.view.update([]), r;
  }
  readMutation(e) {
    let t = this.view.docView.nearest(e.target);
    if (!t || t.ignoreMutation(e))
      return null;
    if (t.markDirty(e.type == "attributes"), e.type == "attributes" && (t.flags |= 4), e.type == "childList") {
      let i = hd(t, e.previousSibling || e.target.previousSibling, -1), r = hd(t, e.nextSibling || e.target.nextSibling, 1);
      return {
        from: i ? t.posAfter(i) : t.posAtStart,
        to: r ? t.posBefore(r) : t.posAtEnd,
        typeOver: !1
      };
    } else
      return e.type == "characterData" ? { from: t.posAtStart, to: t.posAtEnd, typeOver: e.target.nodeValue == e.oldValue } : null;
  }
  setWindow(e) {
    e != this.win && (this.removeWindowListeners(this.win), this.win = e, this.addWindowListeners(this.win));
  }
  addWindowListeners(e) {
    e.addEventListener("resize", this.onResize), this.printQuery ? this.printQuery.addEventListener("change", this.onPrint) : e.addEventListener("beforeprint", this.onPrint), e.addEventListener("scroll", this.onScroll), e.document.addEventListener("selectionchange", this.onSelectionChange);
  }
  removeWindowListeners(e) {
    e.removeEventListener("scroll", this.onScroll), e.removeEventListener("resize", this.onResize), this.printQuery ? this.printQuery.removeEventListener("change", this.onPrint) : e.removeEventListener("beforeprint", this.onPrint), e.document.removeEventListener("selectionchange", this.onSelectionChange);
  }
  destroy() {
    var e, t, i;
    this.stop(), (e = this.intersection) === null || e === void 0 || e.disconnect(), (t = this.gapIntersection) === null || t === void 0 || t.disconnect(), (i = this.resizeScroll) === null || i === void 0 || i.disconnect();
    for (let r of this.scrollTargets)
      r.removeEventListener("scroll", this.onScroll);
    this.removeWindowListeners(this.win), clearTimeout(this.parentCheck), clearTimeout(this.resizeTimeout), this.win.cancelAnimationFrame(this.delayedFlush), this.win.cancelAnimationFrame(this.flushingAndroidKey);
  }
}
function hd(n, e, t) {
  for (; e; ) {
    let i = ke.get(e);
    if (i && i.parent == n)
      return i;
    let r = e.parentNode;
    e = r != n.dom ? r : t > 0 ? e.nextSibling : e.previousSibling;
  }
  return null;
}
function fd(n, e) {
  let t = e.startContainer, i = e.startOffset, r = e.endContainer, s = e.endOffset, o = n.docView.domAtPos(n.state.selection.main.anchor);
  return jr(o.node, o.offset, r, s) && ([t, i, r, s] = [r, s, t, i]), { anchorNode: t, anchorOffset: i, focusNode: r, focusOffset: s };
}
function kw(n, e) {
  if (e.getComposedRanges) {
    let r = e.getComposedRanges(n.root)[0];
    if (r)
      return fd(n, r);
  }
  let t = null;
  function i(r) {
    r.preventDefault(), r.stopImmediatePropagation(), t = r.getTargetRanges()[0];
  }
  return n.contentDOM.addEventListener("beforeinput", i, !0), n.dom.ownerDocument.execCommand("indent"), n.contentDOM.removeEventListener("beforeinput", i, !0), t ? fd(n, t) : null;
}
class _ {
  /**
  The current editor state.
  */
  get state() {
    return this.viewState.state;
  }
  /**
  To be able to display large documents without consuming too much
  memory or overloading the browser, CodeMirror only draws the
  code that is visible (plus a margin around it) to the DOM. This
  property tells you the extent of the current drawn viewport, in
  document positions.
  */
  get viewport() {
    return this.viewState.viewport;
  }
  /**
  When there are, for example, large collapsed ranges in the
  viewport, its size can be a lot bigger than the actual visible
  content. Thus, if you are doing something like styling the
  content in the viewport, it is preferable to only do so for
  these ranges, which are the subset of the viewport that is
  actually drawn.
  */
  get visibleRanges() {
    return this.viewState.visibleRanges;
  }
  /**
  Returns false when the editor is entirely scrolled out of view
  or otherwise hidden.
  */
  get inView() {
    return this.viewState.inView;
  }
  /**
  Indicates whether the user is currently composing text via
  [IME](https://en.wikipedia.org/wiki/Input_method), and at least
  one change has been made in the current composition.
  */
  get composing() {
    return this.inputState.composing > 0;
  }
  /**
  Indicates whether the user is currently in composing state. Note
  that on some platforms, like Android, this will be the case a
  lot, since just putting the cursor on a word starts a
  composition there.
  */
  get compositionStarted() {
    return this.inputState.composing >= 0;
  }
  /**
  The document or shadow root that the view lives in.
  */
  get root() {
    return this._root;
  }
  /**
  @internal
  */
  get win() {
    return this.dom.ownerDocument.defaultView || window;
  }
  /**
  Construct a new view. You'll want to either provide a `parent`
  option, or put `view.dom` into your document after creating a
  view, so that the user can see the editor.
  */
  constructor(e = {}) {
    this.plugins = [], this.pluginMap = /* @__PURE__ */ new Map(), this.editorAttrs = {}, this.contentAttrs = {}, this.bidiCache = [], this.destroyed = !1, this.updateState = 2, this.measureScheduled = -1, this.measureRequests = [], this.contentDOM = document.createElement("div"), this.scrollDOM = document.createElement("div"), this.scrollDOM.tabIndex = -1, this.scrollDOM.className = "cm-scroller", this.scrollDOM.appendChild(this.contentDOM), this.announceDOM = document.createElement("div"), this.announceDOM.className = "cm-announced", this.announceDOM.setAttribute("aria-live", "polite"), this.dom = document.createElement("div"), this.dom.appendChild(this.announceDOM), this.dom.appendChild(this.scrollDOM), e.parent && e.parent.appendChild(this.dom);
    let { dispatch: t } = e;
    this.dispatchTransactions = e.dispatchTransactions || t && ((i) => i.forEach((r) => t(r, this))) || ((i) => this.update(i)), this.dispatch = this.dispatch.bind(this), this._root = e.root || rx(e.parent) || document, this.viewState = new ld(e.state || se.create(e)), e.scrollTo && e.scrollTo.is(Ks) && (this.viewState.scrollTarget = e.scrollTo.value.clip(this.viewState.state)), this.plugins = this.state.facet(Lr).map((i) => new Ol(i));
    for (let i of this.plugins)
      i.update(this);
    this.observer = new yw(this), this.inputState = new Dx(this), this.inputState.ensureHandlers(this.plugins), this.docView = new Bf(this), this.mountStyles(), this.updateAttrs(), this.updateState = 0, this.requestMeasure();
  }
  dispatch(...e) {
    let t = e.length == 1 && e[0] instanceof _e ? e : e.length == 1 && Array.isArray(e[0]) ? e[0] : [this.state.update(...e)];
    this.dispatchTransactions(t, this);
  }
  /**
  Update the view for the given array of transactions. This will
  update the visible document and selection to match the state
  produced by the transactions, and notify view plugins of the
  change. You should usually call
  [`dispatch`](https://codemirror.net/6/docs/ref/#view.EditorView.dispatch) instead, which uses this
  as a primitive.
  */
  update(e) {
    if (this.updateState != 0)
      throw new Error("Calls to EditorView.update are not allowed while an update is in progress");
    let t = !1, i = !1, r, s = this.state;
    for (let f of e) {
      if (f.startState != s)
        throw new RangeError("Trying to update state with a transaction that doesn't start from the previous state.");
      s = f.state;
    }
    if (this.destroyed) {
      this.viewState.state = s;
      return;
    }
    let o = this.hasFocus, a = 0, l = null;
    e.some((f) => f.annotation(QO)) ? (this.inputState.notifiedFocused = o, a = 1) : o != this.inputState.notifiedFocused && (this.inputState.notifiedFocused = o, l = $O(s, o), l || (a = 1));
    let u = this.observer.delayedAndroidKey, c = null;
    if (u ? (this.observer.clearDelayedAndroidKey(), c = this.observer.readChange(), (c && !this.state.doc.eq(s.doc) || !this.state.selection.eq(s.selection)) && (c = null)) : this.observer.clear(), s.facet(se.phrases) != this.state.facet(se.phrases))
      return this.setState(s);
    r = sa.create(this, s, e), r.flags |= a;
    let h = this.viewState.scrollTarget;
    try {
      this.updateState = 2;
      for (let f of e) {
        if (h && (h = h.map(f.changes)), f.scrollIntoView) {
          let { main: d } = f.state.selection;
          h = new ji(d.empty ? d : $.cursor(d.head, d.head > d.anchor ? -1 : 1));
        }
        for (let d of f.effects)
          d.is(Ks) && (h = d.value.clip(this.state));
      }
      this.viewState.update(r, h), this.bidiCache = oa.update(this.bidiCache, r.changes), r.empty || (this.updatePlugins(r), this.inputState.update(r)), t = this.docView.update(r), this.state.facet(_r) != this.styleModules && this.mountStyles(), i = this.updateAttrs(), this.showAnnouncements(e), this.docView.updateSelection(t, e.some((f) => f.isUserEvent("select.pointer")));
    } finally {
      this.updateState = 0;
    }
    if (r.startState.facet(ro) != r.state.facet(ro) && (this.viewState.mustMeasureContent = !0), (t || i || h || this.viewState.mustEnforceCursorAssoc || this.viewState.mustMeasureContent) && this.requestMeasure(), t && this.docViewUpdate(), !r.empty)
      for (let f of this.state.facet(Wu))
        try {
          f(r);
        } catch (d) {
          mt(this.state, d, "update listener");
        }
    (l || c) && Promise.resolve().then(() => {
      l && this.state == l.startState && this.dispatch(l), c && !ZO(this, c) && u.force && Yi(this.contentDOM, u.key, u.keyCode);
    });
  }
  /**
  Reset the view to the given state. (This will cause the entire
  document to be redrawn and all view plugins to be reinitialized,
  so you should probably only use it when the new state isn't
  derived from the old state. Otherwise, use
  [`dispatch`](https://codemirror.net/6/docs/ref/#view.EditorView.dispatch) instead.)
  */
  setState(e) {
    if (this.updateState != 0)
      throw new Error("Calls to EditorView.setState are not allowed while an update is in progress");
    if (this.destroyed) {
      this.viewState.state = e;
      return;
    }
    this.updateState = 2;
    let t = this.hasFocus;
    try {
      for (let i of this.plugins)
        i.destroy(this);
      this.viewState = new ld(e), this.plugins = e.facet(Lr).map((i) => new Ol(i)), this.pluginMap.clear();
      for (let i of this.plugins)
        i.update(this);
      this.docView.destroy(), this.docView = new Bf(this), this.inputState.ensureHandlers(this.plugins), this.mountStyles(), this.updateAttrs(), this.bidiCache = [];
    } finally {
      this.updateState = 0;
    }
    t && this.focus(), this.requestMeasure();
  }
  updatePlugins(e) {
    let t = e.startState.facet(Lr), i = e.state.facet(Lr);
    if (t != i) {
      let r = [];
      for (let s of i) {
        let o = t.indexOf(s);
        if (o < 0)
          r.push(new Ol(s));
        else {
          let a = this.plugins[o];
          a.mustUpdate = e, r.push(a);
        }
      }
      for (let s of this.plugins)
        s.mustUpdate != e && s.destroy(this);
      this.plugins = r, this.pluginMap.clear();
    } else
      for (let r of this.plugins)
        r.mustUpdate = e;
    for (let r = 0; r < this.plugins.length; r++)
      this.plugins[r].update(this);
    t != i && this.inputState.ensureHandlers(this.plugins);
  }
  docViewUpdate() {
    for (let e of this.plugins) {
      let t = e.value;
      if (t && t.docViewUpdate)
        try {
          t.docViewUpdate(this);
        } catch (i) {
          mt(this.state, i, "doc view update listener");
        }
    }
  }
  /**
  @internal
  */
  measure(e = !0) {
    if (this.destroyed)
      return;
    if (this.measureScheduled > -1 && this.win.cancelAnimationFrame(this.measureScheduled), this.observer.delayedAndroidKey) {
      this.measureScheduled = -1, this.requestMeasure();
      return;
    }
    this.measureScheduled = 0, e && this.observer.forceFlush();
    let t = null, i = this.scrollDOM, r = i.scrollTop * this.scaleY, { scrollAnchorPos: s, scrollAnchorHeight: o } = this.viewState;
    Math.abs(r - this.viewState.scrollTop) > 1 && (o = -1), this.viewState.scrollAnchorHeight = -1;
    try {
      for (let a = 0; ; a++) {
        if (o < 0)
          if (Ng(i))
            s = -1, o = this.viewState.heightMap.height;
          else {
            let d = this.viewState.scrollAnchorAt(r);
            s = d.from, o = d.top;
          }
        this.updateState = 1;
        let l = this.viewState.measure(this);
        if (!l && !this.measureRequests.length && this.viewState.scrollTarget == null)
          break;
        if (a > 5) {
          console.warn(this.measureRequests.length ? "Measure loop restarted more than 5 times" : "Viewport failed to stabilize");
          break;
        }
        let u = [];
        l & 4 || ([this.measureRequests, u] = [u, this.measureRequests]);
        let c = u.map((d) => {
          try {
            return d.read(this);
          } catch (p) {
            return mt(this.state, p), dd;
          }
        }), h = sa.create(this, this.state, []), f = !1;
        h.flags |= l, t ? t.flags |= l : t = h, this.updateState = 2, h.empty || (this.updatePlugins(h), this.inputState.update(h), this.updateAttrs(), f = this.docView.update(h), f && this.docViewUpdate());
        for (let d = 0; d < u.length; d++)
          if (c[d] != dd)
            try {
              let p = u[d];
              p.write && p.write(c[d], this);
            } catch (p) {
              mt(this.state, p);
            }
        if (f && this.docView.updateSelection(!0), !h.viewportChanged && this.measureRequests.length == 0) {
          if (this.viewState.editorHeight)
            if (this.viewState.scrollTarget) {
              this.docView.scrollIntoView(this.viewState.scrollTarget), this.viewState.scrollTarget = null, o = -1;
              continue;
            } else {
              let p = (s < 0 ? this.viewState.heightMap.height : this.viewState.lineBlockAt(s).top) - o;
              if (p > 1 || p < -1) {
                r = r + p, i.scrollTop = r / this.scaleY, o = -1;
                continue;
              }
            }
          break;
        }
      }
    } finally {
      this.updateState = 0, this.measureScheduled = -1;
    }
    if (t && !t.empty)
      for (let a of this.state.facet(Wu))
        a(t);
  }
  /**
  Get the CSS classes for the currently active editor themes.
  */
  get themeClasses() {
    return ju + " " + (this.state.facet(Yu) ? RO : AO) + " " + this.state.facet(ro);
  }
  updateAttrs() {
    let e = pd(this, dO, {
      class: "cm-editor" + (this.hasFocus ? " cm-focused " : " ") + this.themeClasses
    }), t = {
      spellcheck: "false",
      autocorrect: "off",
      autocapitalize: "off",
      translate: "no",
      contenteditable: this.state.facet(Ya) ? "true" : "false",
      class: "cm-content",
      style: `${W.tabSize}: ${this.state.tabSize}`,
      role: "textbox",
      "aria-multiline": "true"
    };
    this.state.readOnly && (t["aria-readonly"] = "true"), pd(this, sh, t);
    let i = this.observer.ignore(() => {
      let r = Iu(this.contentDOM, this.contentAttrs, t), s = Iu(this.dom, this.editorAttrs, e);
      return r || s;
    });
    return this.editorAttrs = e, this.contentAttrs = t, i;
  }
  showAnnouncements(e) {
    let t = !0;
    for (let i of e)
      for (let r of i.effects)
        if (r.is(_.announce)) {
          t && (this.announceDOM.textContent = ""), t = !1;
          let s = this.announceDOM.appendChild(document.createElement("div"));
          s.textContent = r.value;
        }
  }
  mountStyles() {
    this.styleModules = this.state.facet(_r);
    let e = this.state.facet(_.cspNonce);
    Gn.mount(this.root, this.styleModules.concat(cw).reverse(), e ? { nonce: e } : void 0);
  }
  readMeasured() {
    if (this.updateState == 2)
      throw new Error("Reading the editor layout isn't allowed during an update");
    this.updateState == 0 && this.measureScheduled > -1 && this.measure(!1);
  }
  /**
  Schedule a layout measurement, optionally providing callbacks to
  do custom DOM measuring followed by a DOM write phase. Using
  this is preferable reading DOM layout directly from, for
  example, an event handler, because it'll make sure measuring and
  drawing done by other components is synchronized, avoiding
  unnecessary DOM layout computations.
  */
  requestMeasure(e) {
    if (this.measureScheduled < 0 && (this.measureScheduled = this.win.requestAnimationFrame(() => this.measure())), e) {
      if (this.measureRequests.indexOf(e) > -1)
        return;
      if (e.key != null) {
        for (let t = 0; t < this.measureRequests.length; t++)
          if (this.measureRequests[t].key === e.key) {
            this.measureRequests[t] = e;
            return;
          }
      }
      this.measureRequests.push(e);
    }
  }
  /**
  Get the value of a specific plugin, if present. Note that
  plugins that crash can be dropped from a view, so even when you
  know you registered a given plugin, it is recommended to check
  the return value of this method.
  */
  plugin(e) {
    let t = this.pluginMap.get(e);
    return (t === void 0 || t && t.spec != e) && this.pluginMap.set(e, t = this.plugins.find((i) => i.spec == e) || null), t && t.update(this).value;
  }
  /**
  The top position of the document, in screen coordinates. This
  may be negative when the editor is scrolled down. Points
  directly to the top of the first line, not above the padding.
  */
  get documentTop() {
    return this.contentDOM.getBoundingClientRect().top + this.viewState.paddingTop;
  }
  /**
  Reports the padding above and below the document.
  */
  get documentPadding() {
    return { top: this.viewState.paddingTop, bottom: this.viewState.paddingBottom };
  }
  /**
  If the editor is transformed with CSS, this provides the scale
  along the X axis. Otherwise, it will just be 1. Note that
  transforms other than translation and scaling are not supported.
  */
  get scaleX() {
    return this.viewState.scaleX;
  }
  /**
  Provide the CSS transformed scale along the Y axis.
  */
  get scaleY() {
    return this.viewState.scaleY;
  }
  /**
  Find the text line or block widget at the given vertical
  position (which is interpreted as relative to the [top of the
  document](https://codemirror.net/6/docs/ref/#view.EditorView.documentTop)).
  */
  elementAtHeight(e) {
    return this.readMeasured(), this.viewState.elementAtHeight(e);
  }
  /**
  Find the line block (see
  [`lineBlockAt`](https://codemirror.net/6/docs/ref/#view.EditorView.lineBlockAt) at the given
  height, again interpreted relative to the [top of the
  document](https://codemirror.net/6/docs/ref/#view.EditorView.documentTop).
  */
  lineBlockAtHeight(e) {
    return this.readMeasured(), this.viewState.lineBlockAtHeight(e);
  }
  /**
  Get the extent and vertical position of all [line
  blocks](https://codemirror.net/6/docs/ref/#view.EditorView.lineBlockAt) in the viewport. Positions
  are relative to the [top of the
  document](https://codemirror.net/6/docs/ref/#view.EditorView.documentTop);
  */
  get viewportLineBlocks() {
    return this.viewState.viewportLines;
  }
  /**
  Find the line block around the given document position. A line
  block is a range delimited on both sides by either a
  non-[hidden](https://codemirror.net/6/docs/ref/#view.Decoration^replace) line breaks, or the
  start/end of the document. It will usually just hold a line of
  text, but may be broken into multiple textblocks by block
  widgets.
  */
  lineBlockAt(e) {
    return this.viewState.lineBlockAt(e);
  }
  /**
  The editor's total content height.
  */
  get contentHeight() {
    return this.viewState.contentHeight;
  }
  /**
  Move a cursor position by [grapheme
  cluster](https://codemirror.net/6/docs/ref/#state.findClusterBreak). `forward` determines whether
  the motion is away from the line start, or towards it. In
  bidirectional text, the line is traversed in visual order, using
  the editor's [text direction](https://codemirror.net/6/docs/ref/#view.EditorView.textDirection).
  When the start position was the last one on the line, the
  returned position will be across the line break. If there is no
  further line, the original position is returned.
  
  By default, this method moves over a single cluster. The
  optional `by` argument can be used to move across more. It will
  be called with the first cluster as argument, and should return
  a predicate that determines, for each subsequent cluster,
  whether it should also be moved over.
  */
  moveByChar(e, t, i) {
    return yl(this, e, Gf(this, e, t, i));
  }
  /**
  Move a cursor position across the next group of either
  [letters](https://codemirror.net/6/docs/ref/#state.EditorState.charCategorizer) or non-letter
  non-whitespace characters.
  */
  moveByGroup(e, t) {
    return yl(this, e, Gf(this, e, t, (i) => Ex(this, e.head, i)));
  }
  /**
  Get the cursor position visually at the start or end of a line.
  Note that this may differ from the _logical_ position at its
  start or end (which is simply at `line.from`/`line.to`) if text
  at the start or end goes against the line's base text direction.
  */
  visualLineSide(e, t) {
    let i = this.bidiSpans(e), r = this.textDirectionAt(e.from), s = i[t ? i.length - 1 : 0];
    return $.cursor(s.side(t, r) + e.from, s.forward(!t, r) ? 1 : -1);
  }
  /**
  Move to the next line boundary in the given direction. If
  `includeWrap` is true, line wrapping is on, and there is a
  further wrap point on the current line, the wrap point will be
  returned. Otherwise this function will return the start or end
  of the line.
  */
  moveToLineBoundary(e, t, i = !0) {
    return Zx(this, e, t, i);
  }
  /**
  Move a cursor position vertically. When `distance` isn't given,
  it defaults to moving to the next line (including wrapped
  lines). Otherwise, `distance` should provide a positive distance
  in pixels.
  
  When `start` has a
  [`goalColumn`](https://codemirror.net/6/docs/ref/#state.SelectionRange.goalColumn), the vertical
  motion will use that as a target horizontal position. Otherwise,
  the cursor's own horizontal position is used. The returned
  cursor will have its goal column set to whichever column was
  used.
  */
  moveVertically(e, t, i) {
    return yl(this, e, zx(this, e, t, i));
  }
  /**
  Find the DOM parent node and offset (child offset if `node` is
  an element, character offset when it is a text node) at the
  given document position.
  
  Note that for positions that aren't currently in
  `visibleRanges`, the resulting DOM position isn't necessarily
  meaningful (it may just point before or after a placeholder
  element).
  */
  domAtPos(e) {
    return this.docView.domAtPos(e);
  }
  /**
  Find the document position at the given DOM node. Can be useful
  for associating positions with DOM events. Will raise an error
  when `node` isn't part of the editor content.
  */
  posAtDOM(e, t = 0) {
    return this.docView.posFromDOM(e, t);
  }
  posAtCoords(e, t = !0) {
    return this.readMeasured(), yO(this, e, t);
  }
  /**
  Get the screen coordinates at the given document position.
  `side` determines whether the coordinates are based on the
  element before (-1) or after (1) the position (if no element is
  available on the given side, the method will transparently use
  another strategy to get reasonable coordinates).
  */
  coordsAtPos(e, t = 1) {
    this.readMeasured();
    let i = this.docView.coordsAt(e, t);
    if (!i || i.left == i.right)
      return i;
    let r = this.state.doc.lineAt(e), s = this.bidiSpans(r), o = s[Vn.find(s, e - r.from, -1, t)];
    return Ba(i, o.dir == Ae.LTR == t > 0);
  }
  /**
  Return the rectangle around a given character. If `pos` does not
  point in front of a character that is in the viewport and
  rendered (i.e. not replaced, not a line break), this will return
  null. For space characters that are a line wrap point, this will
  return the position before the line break.
  */
  coordsForChar(e) {
    return this.readMeasured(), this.docView.coordsForChar(e);
  }
  /**
  The default width of a character in the editor. May not
  accurately reflect the width of all characters (given variable
  width fonts or styling of invididual ranges).
  */
  get defaultCharacterWidth() {
    return this.viewState.heightOracle.charWidth;
  }
  /**
  The default height of a line in the editor. May not be accurate
  for all lines.
  */
  get defaultLineHeight() {
    return this.viewState.heightOracle.lineHeight;
  }
  /**
  The text direction
  ([`direction`](https://developer.mozilla.org/en-US/docs/Web/CSS/direction)
  CSS property) of the editor's content element.
  */
  get textDirection() {
    return this.viewState.defaultTextDirection;
  }
  /**
  Find the text direction of the block at the given position, as
  assigned by CSS. If
  [`perLineTextDirection`](https://codemirror.net/6/docs/ref/#view.EditorView^perLineTextDirection)
  isn't enabled, or the given position is outside of the viewport,
  this will always return the same as
  [`textDirection`](https://codemirror.net/6/docs/ref/#view.EditorView.textDirection). Note that
  this may trigger a DOM layout.
  */
  textDirectionAt(e) {
    return !this.state.facet(cO) || e < this.viewport.from || e > this.viewport.to ? this.textDirection : (this.readMeasured(), this.docView.textDirectionAt(e));
  }
  /**
  Whether this editor [wraps lines](https://codemirror.net/6/docs/ref/#view.EditorView.lineWrapping)
  (as determined by the
  [`white-space`](https://developer.mozilla.org/en-US/docs/Web/CSS/white-space)
  CSS property of its content element).
  */
  get lineWrapping() {
    return this.viewState.heightOracle.lineWrapping;
  }
  /**
  Returns the bidirectional text structure of the given line
  (which should be in the current document) as an array of span
  objects. The order of these spans matches the [text
  direction](https://codemirror.net/6/docs/ref/#view.EditorView.textDirection)—if that is
  left-to-right, the leftmost spans come first, otherwise the
  rightmost spans come first.
  */
  bidiSpans(e) {
    if (e.length > xw)
      return nO(e.length);
    let t = this.textDirectionAt(e.from), i;
    for (let s of this.bidiCache)
      if (s.from == e.from && s.dir == t && (s.fresh || tO(s.isolates, i = qf(this, e))))
        return s.order;
    i || (i = qf(this, e));
    let r = Ox(e.text, t, i);
    return this.bidiCache.push(new oa(e.from, e.to, t, i, !0, r)), r;
  }
  /**
  Check whether the editor has focus.
  */
  get hasFocus() {
    var e;
    return (this.dom.ownerDocument.hasFocus() || W.safari && ((e = this.inputState) === null || e === void 0 ? void 0 : e.lastContextMenu) > Date.now() - 3e4) && this.root.activeElement == this.contentDOM;
  }
  /**
  Put focus on the editor.
  */
  focus() {
    this.observer.ignore(() => {
      _g(this.contentDOM), this.docView.updateSelection();
    });
  }
  /**
  Update the [root](https://codemirror.net/6/docs/ref/##view.EditorViewConfig.root) in which the editor lives. This is only
  necessary when moving the editor's existing DOM to a new window or shadow root.
  */
  setRoot(e) {
    this._root != e && (this._root = e, this.observer.setWindow((e.nodeType == 9 ? e : e.ownerDocument).defaultView || window), this.mountStyles());
  }
  /**
  Clean up this editor view, removing its element from the
  document, unregistering event handlers, and notifying
  plugins. The view instance can no longer be used after
  calling this.
  */
  destroy() {
    for (let e of this.plugins)
      e.destroy(this);
    this.plugins = [], this.inputState.destroy(), this.docView.destroy(), this.dom.remove(), this.observer.destroy(), this.measureScheduled > -1 && this.win.cancelAnimationFrame(this.measureScheduled), this.destroyed = !0;
  }
  /**
  Returns an effect that can be
  [added](https://codemirror.net/6/docs/ref/#state.TransactionSpec.effects) to a transaction to
  cause it to scroll the given position or range into view.
  */
  static scrollIntoView(e, t = {}) {
    return Ks.of(new ji(typeof e == "number" ? $.cursor(e) : e, t.y, t.x, t.yMargin, t.xMargin));
  }
  /**
  Return an effect that resets the editor to its current (at the
  time this method was called) scroll position. Note that this
  only affects the editor's own scrollable element, not parents.
  See also
  [`EditorViewConfig.scrollTo`](https://codemirror.net/6/docs/ref/#view.EditorViewConfig.scrollTo).
  
  The effect should be used with a document identical to the one
  it was created for. Failing to do so is not an error, but may
  not scroll to the expected position. You can
  [map](https://codemirror.net/6/docs/ref/#state.StateEffect.map) the effect to account for changes.
  */
  scrollSnapshot() {
    let { scrollTop: e, scrollLeft: t } = this.scrollDOM, i = this.viewState.scrollAnchorAt(e);
    return Ks.of(new ji($.cursor(i.from), "start", "start", i.top - e, t, !0));
  }
  /**
  Enable or disable tab-focus mode, which disables key bindings
  for Tab and Shift-Tab, letting the browser's default
  focus-changing behavior go through instead. This is useful to
  prevent trapping keyboard users in your editor.
  
  Without argument, this toggles the mode. With a boolean, it
  enables (true) or disables it (false). Given a number, it
  temporarily enables the mode until that number of milliseconds
  have passed or another non-Tab key is pressed.
  */
  setTabFocusMode(e) {
    e == null ? this.inputState.tabFocusMode = this.inputState.tabFocusMode < 0 ? 0 : -1 : typeof e == "boolean" ? this.inputState.tabFocusMode = e ? 0 : -1 : this.inputState.tabFocusMode != 0 && (this.inputState.tabFocusMode = Date.now() + e);
  }
  /**
  Returns an extension that can be used to add DOM event handlers.
  The value should be an object mapping event names to handler
  functions. For any given event, such functions are ordered by
  extension precedence, and the first handler to return true will
  be assumed to have handled that event, and no other handlers or
  built-in behavior will be activated for it. These are registered
  on the [content element](https://codemirror.net/6/docs/ref/#view.EditorView.contentDOM), except
  for `scroll` handlers, which will be called any time the
  editor's [scroll element](https://codemirror.net/6/docs/ref/#view.EditorView.scrollDOM) or one of
  its parent nodes is scrolled.
  */
  static domEventHandlers(e) {
    return Ie.define(() => ({}), { eventHandlers: e });
  }
  /**
  Create an extension that registers DOM event observers. Contrary
  to event [handlers](https://codemirror.net/6/docs/ref/#view.EditorView^domEventHandlers),
  observers can't be prevented from running by a higher-precedence
  handler returning true. They also don't prevent other handlers
  and observers from running when they return true, and should not
  call `preventDefault`.
  */
  static domEventObservers(e) {
    return Ie.define(() => ({}), { eventObservers: e });
  }
  /**
  Create a theme extension. The first argument can be a
  [`style-mod`](https://github.com/marijnh/style-mod#documentation)
  style spec providing the styles for the theme. These will be
  prefixed with a generated class for the style.
  
  Because the selectors will be prefixed with a scope class, rule
  that directly match the editor's [wrapper
  element](https://codemirror.net/6/docs/ref/#view.EditorView.dom)—to which the scope class will be
  added—need to be explicitly differentiated by adding an `&` to
  the selector for that element—for example
  `&.cm-focused`.
  
  When `dark` is set to true, the theme will be marked as dark,
  which will cause the `&dark` rules from [base
  themes](https://codemirror.net/6/docs/ref/#view.EditorView^baseTheme) to be used (as opposed to
  `&light` when a light theme is active).
  */
  static theme(e, t) {
    let i = Gn.newName(), r = [ro.of(i), _r.of(Uu(`.${i}`, e))];
    return t && t.dark && r.push(Yu.of(!0)), r;
  }
  /**
  Create an extension that adds styles to the base theme. Like
  with [`theme`](https://codemirror.net/6/docs/ref/#view.EditorView^theme), use `&` to indicate the
  place of the editor wrapper element when directly targeting
  that. You can also use `&dark` or `&light` instead to only
  target editors with a dark or light theme.
  */
  static baseTheme(e) {
    return Mn.lowest(_r.of(Uu("." + ju, e, MO)));
  }
  /**
  Retrieve an editor view instance from the view's DOM
  representation.
  */
  static findFromDOM(e) {
    var t;
    let i = e.querySelector(".cm-content"), r = i && ke.get(i) || ke.get(e);
    return ((t = r == null ? void 0 : r.rootView) === null || t === void 0 ? void 0 : t.view) || null;
  }
}
_.styleModule = _r;
_.inputHandler = lO;
_.scrollHandler = fO;
_.focusChangeEffect = uO;
_.perLineTextDirection = cO;
_.exceptionSink = aO;
_.updateListener = Wu;
_.editable = Ya;
_.mouseSelectionStyle = oO;
_.dragMovesSelection = sO;
_.clickAddsSelectionRange = rO;
_.decorations = os;
_.outerDecorations = pO;
_.atomicRanges = oh;
_.bidiIsolatedRanges = mO;
_.scrollMargins = gO;
_.darkTheme = Yu;
_.cspNonce = /* @__PURE__ */ N.define({ combine: (n) => n.length ? n[0] : "" });
_.contentAttributes = sh;
_.editorAttributes = dO;
_.lineWrapping = /* @__PURE__ */ _.contentAttributes.of({ class: "cm-lineWrapping" });
_.announce = /* @__PURE__ */ te.define();
const xw = 4096, dd = {};
class oa {
  constructor(e, t, i, r, s, o) {
    this.from = e, this.to = t, this.dir = i, this.isolates = r, this.fresh = s, this.order = o;
  }
  static update(e, t) {
    if (t.empty && !e.some((s) => s.fresh))
      return e;
    let i = [], r = e.length ? e[e.length - 1].dir : Ae.LTR;
    for (let s = Math.max(0, e.length - 10); s < e.length; s++) {
      let o = e[s];
      o.dir == r && !t.touchesRange(o.from, o.to) && i.push(new oa(t.mapPos(o.from, 1), t.mapPos(o.to, -1), o.dir, o.isolates, !1, o.order));
    }
    return i;
  }
}
function pd(n, e, t) {
  for (let i = n.state.facet(e), r = i.length - 1; r >= 0; r--) {
    let s = i[r], o = typeof s == "function" ? s(n) : s;
    o && Du(o, t);
  }
  return t;
}
const ww = W.mac ? "mac" : W.windows ? "win" : W.linux ? "linux" : "key";
function Sw(n, e) {
  const t = n.split(/-(?!$)/);
  let i = t[t.length - 1];
  i == "Space" && (i = " ");
  let r, s, o, a;
  for (let l = 0; l < t.length - 1; ++l) {
    const u = t[l];
    if (/^(cmd|meta|m)$/i.test(u))
      a = !0;
    else if (/^a(lt)?$/i.test(u))
      r = !0;
    else if (/^(c|ctrl|control)$/i.test(u))
      s = !0;
    else if (/^s(hift)?$/i.test(u))
      o = !0;
    else if (/^mod$/i.test(u))
      e == "mac" ? a = !0 : s = !0;
    else
      throw new Error("Unrecognized modifier name: " + u);
  }
  return r && (i = "Alt-" + i), s && (i = "Ctrl-" + i), a && (i = "Meta-" + i), o && (i = "Shift-" + i), i;
}
function so(n, e, t) {
  return e.altKey && (n = "Alt-" + n), e.ctrlKey && (n = "Ctrl-" + n), e.metaKey && (n = "Meta-" + n), t !== !1 && e.shiftKey && (n = "Shift-" + n), n;
}
const vw = /* @__PURE__ */ Mn.default(/* @__PURE__ */ _.domEventHandlers({
  keydown(n, e) {
    return zO(EO(e.state), n, e, "editor");
  }
})), dr = /* @__PURE__ */ N.define({ enables: vw }), md = /* @__PURE__ */ new WeakMap();
function EO(n) {
  let e = n.facet(dr), t = md.get(e);
  return t || md.set(e, t = $w(e.reduce((i, r) => i.concat(r), []))), t;
}
function Pw(n, e, t) {
  return zO(EO(n.state), e, n, t);
}
let Wn = null;
const Qw = 4e3;
function $w(n, e = ww) {
  let t = /* @__PURE__ */ Object.create(null), i = /* @__PURE__ */ Object.create(null), r = (o, a) => {
    let l = i[o];
    if (l == null)
      i[o] = a;
    else if (l != a)
      throw new Error("Key binding " + o + " is used both as a regular binding and as a multi-stroke prefix");
  }, s = (o, a, l, u, c) => {
    var h, f;
    let d = t[o] || (t[o] = /* @__PURE__ */ Object.create(null)), p = a.split(/ (?!$)/).map((m) => Sw(m, e));
    for (let m = 1; m < p.length; m++) {
      let b = p.slice(0, m).join(" ");
      r(b, !0), d[b] || (d[b] = {
        preventDefault: !0,
        stopPropagation: !1,
        run: [(w) => {
          let Q = Wn = { view: w, prefix: b, scope: o };
          return setTimeout(() => {
            Wn == Q && (Wn = null);
          }, Qw), !0;
        }]
      });
    }
    let g = p.join(" ");
    r(g, !1);
    let O = d[g] || (d[g] = {
      preventDefault: !1,
      stopPropagation: !1,
      run: ((f = (h = d._any) === null || h === void 0 ? void 0 : h.run) === null || f === void 0 ? void 0 : f.slice()) || []
    });
    l && O.run.push(l), u && (O.preventDefault = !0), c && (O.stopPropagation = !0);
  };
  for (let o of n) {
    let a = o.scope ? o.scope.split(" ") : ["editor"];
    if (o.any)
      for (let u of a) {
        let c = t[u] || (t[u] = /* @__PURE__ */ Object.create(null));
        c._any || (c._any = { preventDefault: !1, stopPropagation: !1, run: [] });
        let { any: h } = o;
        for (let f in c)
          c[f].run.push((d) => h(d, Fu));
      }
    let l = o[e] || o.key;
    if (l)
      for (let u of a)
        s(u, l, o.run, o.preventDefault, o.stopPropagation), o.shift && s(u, "Shift-" + l, o.shift, o.preventDefault, o.stopPropagation);
  }
  return t;
}
let Fu = null;
function zO(n, e, t, i) {
  Fu = e;
  let r = Kk(e), s = Ue(r, 0), o = Rt(s) == r.length && r != " ", a = "", l = !1, u = !1, c = !1;
  Wn && Wn.view == t && Wn.scope == i && (a = Wn.prefix + " ", xO.indexOf(e.keyCode) < 0 && (u = !0, Wn = null));
  let h = /* @__PURE__ */ new Set(), f = (O) => {
    if (O) {
      for (let m of O.run)
        if (!h.has(m) && (h.add(m), m(t)))
          return O.stopPropagation && (c = !0), !0;
      O.preventDefault && (O.stopPropagation && (c = !0), u = !0);
    }
    return !1;
  }, d = n[i], p, g;
  return d && (f(d[a + so(r, e, !o)]) ? l = !0 : o && (e.altKey || e.metaKey || e.ctrlKey) && // Ctrl-Alt may be used for AltGr on Windows
  !(W.windows && e.ctrlKey && e.altKey) && (p = Hn[e.keyCode]) && p != r ? (f(d[a + so(p, e, !0)]) || e.shiftKey && (g = ss[e.keyCode]) != r && g != p && f(d[a + so(g, e, !1)])) && (l = !0) : o && e.shiftKey && f(d[a + so(r, e, !0)]) && (l = !0), !l && f(d._any) && (l = !0)), u && (l = !0), l && c && e.stopPropagation(), Fu = null, l;
}
class Es {
  /**
  Create a marker with the given class and dimensions. If `width`
  is null, the DOM element will get no width style.
  */
  constructor(e, t, i, r, s) {
    this.className = e, this.left = t, this.top = i, this.width = r, this.height = s;
  }
  draw() {
    let e = document.createElement("div");
    return e.className = this.className, this.adjust(e), e;
  }
  update(e, t) {
    return t.className != this.className ? !1 : (this.adjust(e), !0);
  }
  adjust(e) {
    e.style.left = this.left + "px", e.style.top = this.top + "px", this.width != null && (e.style.width = this.width + "px"), e.style.height = this.height + "px";
  }
  eq(e) {
    return this.left == e.left && this.top == e.top && this.width == e.width && this.height == e.height && this.className == e.className;
  }
  /**
  Create a set of rectangles for the given selection range,
  assigning them theclass`className`. Will create a single
  rectangle for empty ranges, and a set of selection-style
  rectangles covering the range's content (in a bidi-aware
  way) for non-empty ones.
  */
  static forRange(e, t, i) {
    if (i.empty) {
      let r = e.coordsAtPos(i.head, i.assoc || 1);
      if (!r)
        return [];
      let s = DO(e);
      return [new Es(t, r.left - s.left, r.top - s.top, null, r.bottom - r.top)];
    } else
      return Cw(e, t, i);
  }
}
function DO(n) {
  let e = n.scrollDOM.getBoundingClientRect();
  return { left: (n.textDirection == Ae.LTR ? e.left : e.right - n.scrollDOM.clientWidth * n.scaleX) - n.scrollDOM.scrollLeft * n.scaleX, top: e.top - n.scrollDOM.scrollTop * n.scaleY };
}
function gd(n, e, t, i) {
  let r = n.coordsAtPos(e, t * 2);
  if (!r)
    return i;
  let s = n.dom.getBoundingClientRect(), o = (r.top + r.bottom) / 2, a = n.posAtCoords({ x: s.left + 1, y: o }), l = n.posAtCoords({ x: s.right - 1, y: o });
  return a == null || l == null ? i : { from: Math.max(i.from, Math.min(a, l)), to: Math.min(i.to, Math.max(a, l)) };
}
function Cw(n, e, t) {
  if (t.to <= n.viewport.from || t.from >= n.viewport.to)
    return [];
  let i = Math.max(t.from, n.viewport.from), r = Math.min(t.to, n.viewport.to), s = n.textDirection == Ae.LTR, o = n.contentDOM, a = o.getBoundingClientRect(), l = DO(n), u = o.querySelector(".cm-line"), c = u && window.getComputedStyle(u), h = a.left + (c ? parseInt(c.paddingLeft) + Math.min(0, parseInt(c.textIndent)) : 0), f = a.right - (c ? parseInt(c.paddingRight) : 0), d = Bu(n, i), p = Bu(n, r), g = d.type == Ot.Text ? d : null, O = p.type == Ot.Text ? p : null;
  if (g && (n.lineWrapping || d.widgetLineBreaks) && (g = gd(n, i, 1, g)), O && (n.lineWrapping || p.widgetLineBreaks) && (O = gd(n, r, -1, O)), g && O && g.from == O.from && g.to == O.to)
    return b(w(t.from, t.to, g));
  {
    let v = g ? w(t.from, null, g) : Q(d, !1), k = O ? w(null, t.to, O) : Q(p, !0), C = [];
    return (g || d).to < (O || p).from - (g && O ? 1 : 0) || d.widgetLineBreaks > 1 && v.bottom + n.defaultLineHeight / 2 < k.top ? C.push(m(h, v.bottom, f, k.top)) : v.bottom < k.top && n.elementAtHeight((v.bottom + k.top) / 2).type == Ot.Text && (v.bottom = k.top = (v.bottom + k.top) / 2), b(v).concat(C).concat(b(k));
  }
  function m(v, k, C, I) {
    return new Es(
      e,
      v - l.left,
      k - l.top - 0.01,
      C - v,
      I - k + 0.01
      /* C.Epsilon */
    );
  }
  function b({ top: v, bottom: k, horizontal: C }) {
    let I = [];
    for (let z = 0; z < C.length; z += 2)
      I.push(m(C[z], v, C[z + 1], k));
    return I;
  }
  function w(v, k, C) {
    let I = 1e9, z = -1e9, P = [];
    function R(U, E, B, H, K) {
      let re = n.coordsAtPos(U, U == C.to ? -2 : 2), y = n.coordsAtPos(B, B == C.from ? 2 : -2);
      !re || !y || (I = Math.min(re.top, y.top, I), z = Math.max(re.bottom, y.bottom, z), K == Ae.LTR ? P.push(s && E ? h : re.left, s && H ? f : y.right) : P.push(!s && H ? h : y.left, !s && E ? f : re.right));
    }
    let A = v ?? C.from, j = k ?? C.to;
    for (let U of n.visibleRanges)
      if (U.to > A && U.from < j)
        for (let E = Math.max(U.from, A), B = Math.min(U.to, j); ; ) {
          let H = n.state.doc.lineAt(E);
          for (let K of n.bidiSpans(H)) {
            let re = K.from + H.from, y = K.to + H.from;
            if (re >= B)
              break;
            y > E && R(Math.max(re, E), v == null && re <= A, Math.min(y, B), k == null && y >= j, K.dir);
          }
          if (E = H.to + 1, E >= B)
            break;
        }
    return P.length == 0 && R(A, v == null, j, k == null, n.textDirection), { top: I, bottom: z, horizontal: P };
  }
  function Q(v, k) {
    let C = a.top + (k ? v.top : v.bottom);
    return { top: C, bottom: C, horizontal: [] };
  }
}
function Tw(n, e) {
  return n.constructor == e.constructor && n.eq(e);
}
class Aw {
  constructor(e, t) {
    this.view = e, this.layer = t, this.drawn = [], this.scaleX = 1, this.scaleY = 1, this.measureReq = { read: this.measure.bind(this), write: this.draw.bind(this) }, this.dom = e.scrollDOM.appendChild(document.createElement("div")), this.dom.classList.add("cm-layer"), t.above && this.dom.classList.add("cm-layer-above"), t.class && this.dom.classList.add(t.class), this.scale(), this.dom.setAttribute("aria-hidden", "true"), this.setOrder(e.state), e.requestMeasure(this.measureReq), t.mount && t.mount(this.dom, e);
  }
  update(e) {
    e.startState.facet(Wo) != e.state.facet(Wo) && this.setOrder(e.state), (this.layer.update(e, this.dom) || e.geometryChanged) && (this.scale(), e.view.requestMeasure(this.measureReq));
  }
  docViewUpdate(e) {
    this.layer.updateOnDocViewUpdate !== !1 && e.requestMeasure(this.measureReq);
  }
  setOrder(e) {
    let t = 0, i = e.facet(Wo);
    for (; t < i.length && i[t] != this.layer; )
      t++;
    this.dom.style.zIndex = String((this.layer.above ? 150 : -1) - t);
  }
  measure() {
    return this.layer.markers(this.view);
  }
  scale() {
    let { scaleX: e, scaleY: t } = this.view;
    (e != this.scaleX || t != this.scaleY) && (this.scaleX = e, this.scaleY = t, this.dom.style.transform = `scale(${1 / e}, ${1 / t})`);
  }
  draw(e) {
    if (e.length != this.drawn.length || e.some((t, i) => !Tw(t, this.drawn[i]))) {
      let t = this.dom.firstChild, i = 0;
      for (let r of e)
        r.update && t && r.constructor && this.drawn[i].constructor && r.update(t, this.drawn[i]) ? (t = t.nextSibling, i++) : this.dom.insertBefore(r.draw(), t);
      for (; t; ) {
        let r = t.nextSibling;
        t.remove(), t = r;
      }
      this.drawn = e;
    }
  }
  destroy() {
    this.layer.destroy && this.layer.destroy(this.dom, this.view), this.dom.remove();
  }
}
const Wo = /* @__PURE__ */ N.define();
function IO(n) {
  return [
    Ie.define((e) => new Aw(e, n)),
    Wo.of(n)
  ];
}
const LO = !W.ios, as = /* @__PURE__ */ N.define({
  combine(n) {
    return pn(n, {
      cursorBlinkRate: 1200,
      drawRangeCursor: !0
    }, {
      cursorBlinkRate: (e, t) => Math.min(e, t),
      drawRangeCursor: (e, t) => e || t
    });
  }
});
function Rw(n = {}) {
  return [
    as.of(n),
    Mw,
    Zw,
    Ew,
    hO.of(!0)
  ];
}
function _O(n) {
  return n.startState.facet(as) != n.state.facet(as);
}
const Mw = /* @__PURE__ */ IO({
  above: !0,
  markers(n) {
    let { state: e } = n, t = e.facet(as), i = [];
    for (let r of e.selection.ranges) {
      let s = r == e.selection.main;
      if (r.empty ? !s || LO : t.drawRangeCursor) {
        let o = s ? "cm-cursor cm-cursor-primary" : "cm-cursor cm-cursor-secondary", a = r.empty ? r : $.cursor(r.head, r.head > r.anchor ? -1 : 1);
        for (let l of Es.forRange(n, o, a))
          i.push(l);
      }
    }
    return i;
  },
  update(n, e) {
    n.transactions.some((i) => i.selection) && (e.style.animationName = e.style.animationName == "cm-blink" ? "cm-blink2" : "cm-blink");
    let t = _O(n);
    return t && Od(n.state, e), n.docChanged || n.selectionSet || t;
  },
  mount(n, e) {
    Od(e.state, n);
  },
  class: "cm-cursorLayer"
});
function Od(n, e) {
  e.style.animationDuration = n.facet(as).cursorBlinkRate + "ms";
}
const Zw = /* @__PURE__ */ IO({
  above: !1,
  markers(n) {
    return n.state.selection.ranges.map((e) => e.empty ? [] : Es.forRange(n, "cm-selectionBackground", e)).reduce((e, t) => e.concat(t));
  },
  update(n, e) {
    return n.docChanged || n.selectionSet || n.viewportChanged || _O(n);
  },
  class: "cm-selectionLayer"
}), Gu = {
  ".cm-line": {
    "& ::selection, &::selection": { backgroundColor: "transparent !important" }
  },
  ".cm-content": {
    "& :focus": {
      caretColor: "initial !important",
      "&::selection, & ::selection": {
        backgroundColor: "Highlight !important"
      }
    }
  }
};
LO && (Gu[".cm-line"].caretColor = Gu[".cm-content"].caretColor = "transparent !important");
const Ew = /* @__PURE__ */ Mn.highest(/* @__PURE__ */ _.theme(Gu)), XO = /* @__PURE__ */ te.define({
  map(n, e) {
    return n == null ? null : e.mapPos(n);
  }
}), Wr = /* @__PURE__ */ Ye.define({
  create() {
    return null;
  },
  update(n, e) {
    return n != null && (n = e.changes.mapPos(n)), e.effects.reduce((t, i) => i.is(XO) ? i.value : t, n);
  }
}), zw = /* @__PURE__ */ Ie.fromClass(class {
  constructor(n) {
    this.view = n, this.cursor = null, this.measureReq = { read: this.readPos.bind(this), write: this.drawCursor.bind(this) };
  }
  update(n) {
    var e;
    let t = n.state.field(Wr);
    t == null ? this.cursor != null && ((e = this.cursor) === null || e === void 0 || e.remove(), this.cursor = null) : (this.cursor || (this.cursor = this.view.scrollDOM.appendChild(document.createElement("div")), this.cursor.className = "cm-dropCursor"), (n.startState.field(Wr) != t || n.docChanged || n.geometryChanged) && this.view.requestMeasure(this.measureReq));
  }
  readPos() {
    let { view: n } = this, e = n.state.field(Wr), t = e != null && n.coordsAtPos(e);
    if (!t)
      return null;
    let i = n.scrollDOM.getBoundingClientRect();
    return {
      left: t.left - i.left + n.scrollDOM.scrollLeft * n.scaleX,
      top: t.top - i.top + n.scrollDOM.scrollTop * n.scaleY,
      height: t.bottom - t.top
    };
  }
  drawCursor(n) {
    if (this.cursor) {
      let { scaleX: e, scaleY: t } = this.view;
      n ? (this.cursor.style.left = n.left / e + "px", this.cursor.style.top = n.top / t + "px", this.cursor.style.height = n.height / t + "px") : this.cursor.style.left = "-100000px";
    }
  }
  destroy() {
    this.cursor && this.cursor.remove();
  }
  setDropPos(n) {
    this.view.state.field(Wr) != n && this.view.dispatch({ effects: XO.of(n) });
  }
}, {
  eventObservers: {
    dragover(n) {
      this.setDropPos(this.view.posAtCoords({ x: n.clientX, y: n.clientY }));
    },
    dragleave(n) {
      (n.target == this.view.contentDOM || !this.view.contentDOM.contains(n.relatedTarget)) && this.setDropPos(null);
    },
    dragend() {
      this.setDropPos(null);
    },
    drop() {
      this.setDropPos(null);
    }
  }
});
function Dw() {
  return [Wr, zw];
}
function bd(n, e, t, i, r) {
  e.lastIndex = 0;
  for (let s = n.iterRange(t, i), o = t, a; !s.next().done; o += s.value.length)
    if (!s.lineBreak)
      for (; a = e.exec(s.value); )
        r(o + a.index, a);
}
function Iw(n, e) {
  let t = n.visibleRanges;
  if (t.length == 1 && t[0].from == n.viewport.from && t[0].to == n.viewport.to)
    return t;
  let i = [];
  for (let { from: r, to: s } of t)
    r = Math.max(n.state.doc.lineAt(r).from, r - e), s = Math.min(n.state.doc.lineAt(s).to, s + e), i.length && i[i.length - 1].to >= r ? i[i.length - 1].to = s : i.push({ from: r, to: s });
  return i;
}
class Lw {
  /**
  Create a decorator.
  */
  constructor(e) {
    const { regexp: t, decoration: i, decorate: r, boundary: s, maxLength: o = 1e3 } = e;
    if (!t.global)
      throw new RangeError("The regular expression given to MatchDecorator should have its 'g' flag set");
    if (this.regexp = t, r)
      this.addMatch = (a, l, u, c) => r(c, u, u + a[0].length, a, l);
    else if (typeof i == "function")
      this.addMatch = (a, l, u, c) => {
        let h = i(a, l, u);
        h && c(u, u + a[0].length, h);
      };
    else if (i)
      this.addMatch = (a, l, u, c) => c(u, u + a[0].length, i);
    else
      throw new RangeError("Either 'decorate' or 'decoration' should be provided to MatchDecorator");
    this.boundary = s, this.maxLength = o;
  }
  /**
  Compute the full set of decorations for matches in the given
  view's viewport. You'll want to call this when initializing your
  plugin.
  */
  createDeco(e) {
    let t = new Fn(), i = t.add.bind(t);
    for (let { from: r, to: s } of Iw(e, this.maxLength))
      bd(e.state.doc, this.regexp, r, s, (o, a) => this.addMatch(a, e, o, i));
    return t.finish();
  }
  /**
  Update a set of decorations for a view update. `deco` _must_ be
  the set of decorations produced by _this_ `MatchDecorator` for
  the view state before the update.
  */
  updateDeco(e, t) {
    let i = 1e9, r = -1;
    return e.docChanged && e.changes.iterChanges((s, o, a, l) => {
      l > e.view.viewport.from && a < e.view.viewport.to && (i = Math.min(a, i), r = Math.max(l, r));
    }), e.viewportChanged || r - i > 1e3 ? this.createDeco(e.view) : r > -1 ? this.updateRange(e.view, t.map(e.changes), i, r) : t;
  }
  updateRange(e, t, i, r) {
    for (let s of e.visibleRanges) {
      let o = Math.max(s.from, i), a = Math.min(s.to, r);
      if (a > o) {
        let l = e.state.doc.lineAt(o), u = l.to < a ? e.state.doc.lineAt(a) : l, c = Math.max(s.from, l.from), h = Math.min(s.to, u.to);
        if (this.boundary) {
          for (; o > l.from; o--)
            if (this.boundary.test(l.text[o - 1 - l.from])) {
              c = o;
              break;
            }
          for (; a < u.to; a++)
            if (this.boundary.test(u.text[a - u.from])) {
              h = a;
              break;
            }
        }
        let f = [], d, p = (g, O, m) => f.push(m.range(g, O));
        if (l == u)
          for (this.regexp.lastIndex = c - l.from; (d = this.regexp.exec(l.text)) && d.index < h - l.from; )
            this.addMatch(d, e, d.index + l.from, p);
        else
          bd(e.state.doc, this.regexp, c, h, (g, O) => this.addMatch(O, e, g, p));
        t = t.update({ filterFrom: c, filterTo: h, filter: (g, O) => g < c || O > h, add: f });
      }
    }
    return t;
  }
}
const Hu = /x/.unicode != null ? "gu" : "g", _w = /* @__PURE__ */ new RegExp(`[\0-\b
--­؜​‎‏\u2028\u2029‭‮⁦⁧⁩\uFEFF￹-￼]`, Hu), Xw = {
  0: "null",
  7: "bell",
  8: "backspace",
  10: "newline",
  11: "vertical tab",
  13: "carriage return",
  27: "escape",
  8203: "zero width space",
  8204: "zero width non-joiner",
  8205: "zero width joiner",
  8206: "left-to-right mark",
  8207: "right-to-left mark",
  8232: "line separator",
  8237: "left-to-right override",
  8238: "right-to-left override",
  8294: "left-to-right isolate",
  8295: "right-to-left isolate",
  8297: "pop directional isolate",
  8233: "paragraph separator",
  65279: "zero width no-break space",
  65532: "object replacement"
};
let wl = null;
function Nw() {
  var n;
  if (wl == null && typeof document < "u" && document.body) {
    let e = document.body.style;
    wl = ((n = e.tabSize) !== null && n !== void 0 ? n : e.MozTabSize) != null;
  }
  return wl || !1;
}
const qo = /* @__PURE__ */ N.define({
  combine(n) {
    let e = pn(n, {
      render: null,
      specialChars: _w,
      addSpecialChars: null
    });
    return (e.replaceTabs = !Nw()) && (e.specialChars = new RegExp("	|" + e.specialChars.source, Hu)), e.addSpecialChars && (e.specialChars = new RegExp(e.specialChars.source + "|" + e.addSpecialChars.source, Hu)), e;
  }
});
function Ww(n = {}) {
  return [qo.of(n), qw()];
}
let yd = null;
function qw() {
  return yd || (yd = Ie.fromClass(class {
    constructor(n) {
      this.view = n, this.decorations = F.none, this.decorationCache = /* @__PURE__ */ Object.create(null), this.decorator = this.makeDecorator(n.state.facet(qo)), this.decorations = this.decorator.createDeco(n);
    }
    makeDecorator(n) {
      return new Lw({
        regexp: n.specialChars,
        decoration: (e, t, i) => {
          let { doc: r } = t.state, s = Ue(e[0], 0);
          if (s == 9) {
            let o = r.lineAt(i), a = t.state.tabSize, l = Ut(o.text, a, i - o.from);
            return F.replace({
              widget: new jw((a - l % a) * this.view.defaultCharacterWidth / this.view.scaleX)
            });
          }
          return this.decorationCache[s] || (this.decorationCache[s] = F.replace({ widget: new Yw(n, s) }));
        },
        boundary: n.replaceTabs ? void 0 : /[^]/
      });
    }
    update(n) {
      let e = n.state.facet(qo);
      n.startState.facet(qo) != e ? (this.decorator = this.makeDecorator(e), this.decorations = this.decorator.createDeco(n.view)) : this.decorations = this.decorator.updateDeco(n, this.decorations);
    }
  }, {
    decorations: (n) => n.decorations
  }));
}
const Bw = "•";
function Vw(n) {
  return n >= 32 ? Bw : n == 10 ? "␤" : String.fromCharCode(9216 + n);
}
class Yw extends mn {
  constructor(e, t) {
    super(), this.options = e, this.code = t;
  }
  eq(e) {
    return e.code == this.code;
  }
  toDOM(e) {
    let t = Vw(this.code), i = e.state.phrase("Control character") + " " + (Xw[this.code] || "0x" + this.code.toString(16)), r = this.options.render && this.options.render(this.code, i, t);
    if (r)
      return r;
    let s = document.createElement("span");
    return s.textContent = t, s.title = i, s.setAttribute("aria-label", i), s.className = "cm-specialChar", s;
  }
  ignoreEvent() {
    return !1;
  }
}
class jw extends mn {
  constructor(e) {
    super(), this.width = e;
  }
  eq(e) {
    return e.width == this.width;
  }
  toDOM() {
    let e = document.createElement("span");
    return e.textContent = "	", e.className = "cm-tab", e.style.width = this.width + "px", e;
  }
  ignoreEvent() {
    return !1;
  }
}
function Uw() {
  return Gw;
}
const Fw = /* @__PURE__ */ F.line({ class: "cm-activeLine" }), Gw = /* @__PURE__ */ Ie.fromClass(class {
  constructor(n) {
    this.decorations = this.getDeco(n);
  }
  update(n) {
    (n.docChanged || n.selectionSet) && (this.decorations = this.getDeco(n.view));
  }
  getDeco(n) {
    let e = -1, t = [];
    for (let i of n.state.selection.ranges) {
      let r = n.lineBlockAt(i.head);
      r.from > e && (t.push(Fw.range(r.from)), e = r.from);
    }
    return F.set(t);
  }
}, {
  decorations: (n) => n.decorations
});
class Hw extends mn {
  constructor(e) {
    super(), this.content = e;
  }
  toDOM() {
    let e = document.createElement("span");
    return e.className = "cm-placeholder", e.style.pointerEvents = "none", e.appendChild(typeof this.content == "string" ? document.createTextNode(this.content) : this.content), typeof this.content == "string" ? e.setAttribute("aria-label", "placeholder " + this.content) : e.setAttribute("aria-hidden", "true"), e;
  }
  coordsAt(e) {
    let t = e.firstChild ? tr(e.firstChild) : [];
    if (!t.length)
      return null;
    let i = window.getComputedStyle(e.parentNode), r = Ba(t[0], i.direction != "rtl"), s = parseInt(i.lineHeight);
    return r.bottom - r.top > s * 1.5 ? { left: r.left, right: r.right, top: r.top, bottom: r.top + s } : r;
  }
  ignoreEvent() {
    return !1;
  }
}
function Kw(n) {
  return Ie.fromClass(class {
    constructor(e) {
      this.view = e, this.placeholder = n ? F.set([F.widget({ widget: new Hw(n), side: 1 }).range(0)]) : F.none;
    }
    get decorations() {
      return this.view.state.doc.length ? F.none : this.placeholder;
    }
  }, { decorations: (e) => e.decorations });
}
const Ku = 2e3;
function Jw(n, e, t) {
  let i = Math.min(e.line, t.line), r = Math.max(e.line, t.line), s = [];
  if (e.off > Ku || t.off > Ku || e.col < 0 || t.col < 0) {
    let o = Math.min(e.off, t.off), a = Math.max(e.off, t.off);
    for (let l = i; l <= r; l++) {
      let u = n.doc.line(l);
      u.length <= a && s.push($.range(u.from + o, u.to + a));
    }
  } else {
    let o = Math.min(e.col, t.col), a = Math.max(e.col, t.col);
    for (let l = i; l <= r; l++) {
      let u = n.doc.line(l), c = Tu(u.text, o, n.tabSize, !0);
      if (c < 0)
        s.push($.cursor(u.to));
      else {
        let h = Tu(u.text, a, n.tabSize);
        s.push($.range(u.from + c, u.from + h));
      }
    }
  }
  return s;
}
function eS(n, e) {
  let t = n.coordsAtPos(n.viewport.from);
  return t ? Math.round(Math.abs((t.left - e) / n.defaultCharacterWidth)) : -1;
}
function kd(n, e) {
  let t = n.posAtCoords({ x: e.clientX, y: e.clientY }, !1), i = n.state.doc.lineAt(t), r = t - i.from, s = r > Ku ? -1 : r == i.length ? eS(n, e.clientX) : Ut(i.text, n.state.tabSize, t - i.from);
  return { line: i.number, col: s, off: r };
}
function tS(n, e) {
  let t = kd(n, e), i = n.state.selection;
  return t ? {
    update(r) {
      if (r.docChanged) {
        let s = r.changes.mapPos(r.startState.doc.line(t.line).from), o = r.state.doc.lineAt(s);
        t = { line: o.number, col: t.col, off: Math.min(t.off, o.length) }, i = i.map(r.changes);
      }
    },
    get(r, s, o) {
      let a = kd(n, r);
      if (!a)
        return i;
      let l = Jw(n.state, t, a);
      return l.length ? o ? $.create(l.concat(i.ranges)) : $.create(l) : i;
    }
  } : null;
}
function nS(n) {
  let e = (t) => t.altKey && t.button == 0;
  return _.mouseSelectionStyle.of((t, i) => e(i) ? tS(t, i) : null);
}
const iS = {
  Alt: [18, (n) => !!n.altKey],
  Control: [17, (n) => !!n.ctrlKey],
  Shift: [16, (n) => !!n.shiftKey],
  Meta: [91, (n) => !!n.metaKey]
}, rS = { style: "cursor: crosshair" };
function sS(n = {}) {
  let [e, t] = iS[n.key || "Alt"], i = Ie.fromClass(class {
    constructor(r) {
      this.view = r, this.isDown = !1;
    }
    set(r) {
      this.isDown != r && (this.isDown = r, this.view.update([]));
    }
  }, {
    eventObservers: {
      keydown(r) {
        this.set(r.keyCode == e || t(r));
      },
      keyup(r) {
        (r.keyCode == e || !t(r)) && this.set(!1);
      },
      mousemove(r) {
        this.set(t(r));
      }
    }
  });
  return [
    i,
    _.contentAttributes.of((r) => {
      var s;
      return !((s = r.plugin(i)) === null || s === void 0) && s.isDown ? rS : null;
    })
  ];
}
const Cr = "-10000px";
class NO {
  constructor(e, t, i, r) {
    this.facet = t, this.createTooltipView = i, this.removeTooltipView = r, this.input = e.state.facet(t), this.tooltips = this.input.filter((o) => o);
    let s = null;
    this.tooltipViews = this.tooltips.map((o) => s = i(o, s));
  }
  update(e, t) {
    var i;
    let r = e.state.facet(this.facet), s = r.filter((l) => l);
    if (r === this.input) {
      for (let l of this.tooltipViews)
        l.update && l.update(e);
      return !1;
    }
    let o = [], a = t ? [] : null;
    for (let l = 0; l < s.length; l++) {
      let u = s[l], c = -1;
      if (u) {
        for (let h = 0; h < this.tooltips.length; h++) {
          let f = this.tooltips[h];
          f && f.create == u.create && (c = h);
        }
        if (c < 0)
          o[l] = this.createTooltipView(u, l ? o[l - 1] : null), a && (a[l] = !!u.above);
        else {
          let h = o[l] = this.tooltipViews[c];
          a && (a[l] = t[c]), h.update && h.update(e);
        }
      }
    }
    for (let l of this.tooltipViews)
      o.indexOf(l) < 0 && (this.removeTooltipView(l), (i = l.destroy) === null || i === void 0 || i.call(l));
    return t && (a.forEach((l, u) => t[u] = l), t.length = a.length), this.input = r, this.tooltips = s, this.tooltipViews = o, !0;
  }
}
function oS(n) {
  let { win: e } = n;
  return { top: 0, left: 0, bottom: e.innerHeight, right: e.innerWidth };
}
const Sl = /* @__PURE__ */ N.define({
  combine: (n) => {
    var e, t, i;
    return {
      position: W.ios ? "absolute" : ((e = n.find((r) => r.position)) === null || e === void 0 ? void 0 : e.position) || "fixed",
      parent: ((t = n.find((r) => r.parent)) === null || t === void 0 ? void 0 : t.parent) || null,
      tooltipSpace: ((i = n.find((r) => r.tooltipSpace)) === null || i === void 0 ? void 0 : i.tooltipSpace) || oS
    };
  }
}), xd = /* @__PURE__ */ new WeakMap(), uh = /* @__PURE__ */ Ie.fromClass(class {
  constructor(n) {
    this.view = n, this.above = [], this.inView = !0, this.madeAbsolute = !1, this.lastTransaction = 0, this.measureTimeout = -1;
    let e = n.state.facet(Sl);
    this.position = e.position, this.parent = e.parent, this.classes = n.themeClasses, this.createContainer(), this.measureReq = { read: this.readMeasure.bind(this), write: this.writeMeasure.bind(this), key: this }, this.resizeObserver = typeof ResizeObserver == "function" ? new ResizeObserver(() => this.measureSoon()) : null, this.manager = new NO(n, ch, (t, i) => this.createTooltip(t, i), (t) => {
      this.resizeObserver && this.resizeObserver.unobserve(t.dom), t.dom.remove();
    }), this.above = this.manager.tooltips.map((t) => !!t.above), this.intersectionObserver = typeof IntersectionObserver == "function" ? new IntersectionObserver((t) => {
      Date.now() > this.lastTransaction - 50 && t.length > 0 && t[t.length - 1].intersectionRatio < 1 && this.measureSoon();
    }, { threshold: [1] }) : null, this.observeIntersection(), n.win.addEventListener("resize", this.measureSoon = this.measureSoon.bind(this)), this.maybeMeasure();
  }
  createContainer() {
    this.parent ? (this.container = document.createElement("div"), this.container.style.position = "relative", this.container.className = this.view.themeClasses, this.parent.appendChild(this.container)) : this.container = this.view.dom;
  }
  observeIntersection() {
    if (this.intersectionObserver) {
      this.intersectionObserver.disconnect();
      for (let n of this.manager.tooltipViews)
        this.intersectionObserver.observe(n.dom);
    }
  }
  measureSoon() {
    this.measureTimeout < 0 && (this.measureTimeout = setTimeout(() => {
      this.measureTimeout = -1, this.maybeMeasure();
    }, 50));
  }
  update(n) {
    n.transactions.length && (this.lastTransaction = Date.now());
    let e = this.manager.update(n, this.above);
    e && this.observeIntersection();
    let t = e || n.geometryChanged, i = n.state.facet(Sl);
    if (i.position != this.position && !this.madeAbsolute) {
      this.position = i.position;
      for (let r of this.manager.tooltipViews)
        r.dom.style.position = this.position;
      t = !0;
    }
    if (i.parent != this.parent) {
      this.parent && this.container.remove(), this.parent = i.parent, this.createContainer();
      for (let r of this.manager.tooltipViews)
        this.container.appendChild(r.dom);
      t = !0;
    } else
      this.parent && this.view.themeClasses != this.classes && (this.classes = this.container.className = this.view.themeClasses);
    t && this.maybeMeasure();
  }
  createTooltip(n, e) {
    let t = n.create(this.view), i = e ? e.dom : null;
    if (t.dom.classList.add("cm-tooltip"), n.arrow && !t.dom.querySelector(".cm-tooltip > .cm-tooltip-arrow")) {
      let r = document.createElement("div");
      r.className = "cm-tooltip-arrow", t.dom.appendChild(r);
    }
    return t.dom.style.position = this.position, t.dom.style.top = Cr, t.dom.style.left = "0px", this.container.insertBefore(t.dom, i), t.mount && t.mount(this.view), this.resizeObserver && this.resizeObserver.observe(t.dom), t;
  }
  destroy() {
    var n, e, t;
    this.view.win.removeEventListener("resize", this.measureSoon);
    for (let i of this.manager.tooltipViews)
      i.dom.remove(), (n = i.destroy) === null || n === void 0 || n.call(i);
    this.parent && this.container.remove(), (e = this.resizeObserver) === null || e === void 0 || e.disconnect(), (t = this.intersectionObserver) === null || t === void 0 || t.disconnect(), clearTimeout(this.measureTimeout);
  }
  readMeasure() {
    let n = this.view.dom.getBoundingClientRect(), e = 1, t = 1, i = !1;
    if (this.position == "fixed" && this.manager.tooltipViews.length) {
      let { dom: r } = this.manager.tooltipViews[0];
      if (W.gecko)
        i = r.offsetParent != this.container.ownerDocument.body;
      else if (r.style.top == Cr && r.style.left == "0px") {
        let s = r.getBoundingClientRect();
        i = Math.abs(s.top + 1e4) > 1 || Math.abs(s.left) > 1;
      }
    }
    if (i || this.position == "absolute")
      if (this.parent) {
        let r = this.parent.getBoundingClientRect();
        r.width && r.height && (e = r.width / this.parent.offsetWidth, t = r.height / this.parent.offsetHeight);
      } else
        ({ scaleX: e, scaleY: t } = this.view.viewState);
    return {
      editor: n,
      parent: this.parent ? this.container.getBoundingClientRect() : n,
      pos: this.manager.tooltips.map((r, s) => {
        let o = this.manager.tooltipViews[s];
        return o.getCoords ? o.getCoords(r.pos) : this.view.coordsAtPos(r.pos);
      }),
      size: this.manager.tooltipViews.map(({ dom: r }) => r.getBoundingClientRect()),
      space: this.view.state.facet(Sl).tooltipSpace(this.view),
      scaleX: e,
      scaleY: t,
      makeAbsolute: i
    };
  }
  writeMeasure(n) {
    var e;
    if (n.makeAbsolute) {
      this.madeAbsolute = !0, this.position = "absolute";
      for (let a of this.manager.tooltipViews)
        a.dom.style.position = "absolute";
    }
    let { editor: t, space: i, scaleX: r, scaleY: s } = n, o = [];
    for (let a = 0; a < this.manager.tooltips.length; a++) {
      let l = this.manager.tooltips[a], u = this.manager.tooltipViews[a], { dom: c } = u, h = n.pos[a], f = n.size[a];
      if (!h || h.bottom <= Math.max(t.top, i.top) || h.top >= Math.min(t.bottom, i.bottom) || h.right < Math.max(t.left, i.left) - 0.1 || h.left > Math.min(t.right, i.right) + 0.1) {
        c.style.top = Cr;
        continue;
      }
      let d = l.arrow ? u.dom.querySelector(".cm-tooltip-arrow") : null, p = d ? 7 : 0, g = f.right - f.left, O = (e = xd.get(u)) !== null && e !== void 0 ? e : f.bottom - f.top, m = u.offset || lS, b = this.view.textDirection == Ae.LTR, w = f.width > i.right - i.left ? b ? i.left : i.right - f.width : b ? Math.min(h.left - (d ? 14 : 0) + m.x, i.right - g) : Math.max(i.left, h.left - g + (d ? 14 : 0) - m.x), Q = this.above[a];
      !l.strictSide && (Q ? h.top - (f.bottom - f.top) - m.y < i.top : h.bottom + (f.bottom - f.top) + m.y > i.bottom) && Q == i.bottom - h.bottom > h.top - i.top && (Q = this.above[a] = !Q);
      let v = (Q ? h.top - i.top : i.bottom - h.bottom) - p;
      if (v < O && u.resize !== !1) {
        if (v < this.view.defaultLineHeight) {
          c.style.top = Cr;
          continue;
        }
        xd.set(u, O), c.style.height = (O = v) / s + "px";
      } else
        c.style.height && (c.style.height = "");
      let k = Q ? h.top - O - p - m.y : h.bottom + p + m.y, C = w + g;
      if (u.overlap !== !0)
        for (let I of o)
          I.left < C && I.right > w && I.top < k + O && I.bottom > k && (k = Q ? I.top - O - 2 - p : I.bottom + p + 2);
      if (this.position == "absolute" ? (c.style.top = (k - n.parent.top) / s + "px", c.style.left = (w - n.parent.left) / r + "px") : (c.style.top = k / s + "px", c.style.left = w / r + "px"), d) {
        let I = h.left + (b ? m.x : -m.x) - (w + 14 - 7);
        d.style.left = I / r + "px";
      }
      u.overlap !== !0 && o.push({ left: w, top: k, right: C, bottom: k + O }), c.classList.toggle("cm-tooltip-above", Q), c.classList.toggle("cm-tooltip-below", !Q), u.positioned && u.positioned(n.space);
    }
  }
  maybeMeasure() {
    if (this.manager.tooltips.length && (this.view.inView && this.view.requestMeasure(this.measureReq), this.inView != this.view.inView && (this.inView = this.view.inView, !this.inView)))
      for (let n of this.manager.tooltipViews)
        n.dom.style.top = Cr;
  }
}, {
  eventObservers: {
    scroll() {
      this.maybeMeasure();
    }
  }
}), aS = /* @__PURE__ */ _.baseTheme({
  ".cm-tooltip": {
    zIndex: 100,
    boxSizing: "border-box"
  },
  "&light .cm-tooltip": {
    border: "1px solid #bbb",
    backgroundColor: "#f5f5f5"
  },
  "&light .cm-tooltip-section:not(:first-child)": {
    borderTop: "1px solid #bbb"
  },
  "&dark .cm-tooltip": {
    backgroundColor: "#333338",
    color: "white"
  },
  ".cm-tooltip-arrow": {
    height: "7px",
    width: `${7 * 2}px`,
    position: "absolute",
    zIndex: -1,
    overflow: "hidden",
    "&:before, &:after": {
      content: "''",
      position: "absolute",
      width: 0,
      height: 0,
      borderLeft: "7px solid transparent",
      borderRight: "7px solid transparent"
    },
    ".cm-tooltip-above &": {
      bottom: "-7px",
      "&:before": {
        borderTop: "7px solid #bbb"
      },
      "&:after": {
        borderTop: "7px solid #f5f5f5",
        bottom: "1px"
      }
    },
    ".cm-tooltip-below &": {
      top: "-7px",
      "&:before": {
        borderBottom: "7px solid #bbb"
      },
      "&:after": {
        borderBottom: "7px solid #f5f5f5",
        top: "1px"
      }
    }
  },
  "&dark .cm-tooltip .cm-tooltip-arrow": {
    "&:before": {
      borderTopColor: "#333338",
      borderBottomColor: "#333338"
    },
    "&:after": {
      borderTopColor: "transparent",
      borderBottomColor: "transparent"
    }
  }
}), lS = { x: 0, y: 0 }, ch = /* @__PURE__ */ N.define({
  enables: [uh, aS]
}), aa = /* @__PURE__ */ N.define({
  combine: (n) => n.reduce((e, t) => e.concat(t), [])
});
class ja {
  // Needs to be static so that host tooltip instances always match
  static create(e) {
    return new ja(e);
  }
  constructor(e) {
    this.view = e, this.mounted = !1, this.dom = document.createElement("div"), this.dom.classList.add("cm-tooltip-hover"), this.manager = new NO(e, aa, (t, i) => this.createHostedView(t, i), (t) => t.dom.remove());
  }
  createHostedView(e, t) {
    let i = e.create(this.view);
    return i.dom.classList.add("cm-tooltip-section"), this.dom.insertBefore(i.dom, t ? t.dom.nextSibling : this.dom.firstChild), this.mounted && i.mount && i.mount(this.view), i;
  }
  mount(e) {
    for (let t of this.manager.tooltipViews)
      t.mount && t.mount(e);
    this.mounted = !0;
  }
  positioned(e) {
    for (let t of this.manager.tooltipViews)
      t.positioned && t.positioned(e);
  }
  update(e) {
    this.manager.update(e);
  }
  destroy() {
    var e;
    for (let t of this.manager.tooltipViews)
      (e = t.destroy) === null || e === void 0 || e.call(t);
  }
  passProp(e) {
    let t;
    for (let i of this.manager.tooltipViews) {
      let r = i[e];
      if (r !== void 0) {
        if (t === void 0)
          t = r;
        else if (t !== r)
          return;
      }
    }
    return t;
  }
  get offset() {
    return this.passProp("offset");
  }
  get getCoords() {
    return this.passProp("getCoords");
  }
  get overlap() {
    return this.passProp("overlap");
  }
  get resize() {
    return this.passProp("resize");
  }
}
const uS = /* @__PURE__ */ ch.compute([aa], (n) => {
  let e = n.facet(aa);
  return e.length === 0 ? null : {
    pos: Math.min(...e.map((t) => t.pos)),
    end: Math.max(...e.map((t) => {
      var i;
      return (i = t.end) !== null && i !== void 0 ? i : t.pos;
    })),
    create: ja.create,
    above: e[0].above,
    arrow: e.some((t) => t.arrow)
  };
});
class cS {
  constructor(e, t, i, r, s) {
    this.view = e, this.source = t, this.field = i, this.setHover = r, this.hoverTime = s, this.hoverTimeout = -1, this.restartTimeout = -1, this.pending = null, this.lastMove = { x: 0, y: 0, target: e.dom, time: 0 }, this.checkHover = this.checkHover.bind(this), e.dom.addEventListener("mouseleave", this.mouseleave = this.mouseleave.bind(this)), e.dom.addEventListener("mousemove", this.mousemove = this.mousemove.bind(this));
  }
  update() {
    this.pending && (this.pending = null, clearTimeout(this.restartTimeout), this.restartTimeout = setTimeout(() => this.startHover(), 20));
  }
  get active() {
    return this.view.state.field(this.field);
  }
  checkHover() {
    if (this.hoverTimeout = -1, this.active.length)
      return;
    let e = Date.now() - this.lastMove.time;
    e < this.hoverTime ? this.hoverTimeout = setTimeout(this.checkHover, this.hoverTime - e) : this.startHover();
  }
  startHover() {
    clearTimeout(this.restartTimeout);
    let { view: e, lastMove: t } = this, i = e.docView.nearest(t.target);
    if (!i)
      return;
    let r, s = 1;
    if (i instanceof Bn)
      r = i.posAtStart;
    else {
      if (r = e.posAtCoords(t), r == null)
        return;
      let a = e.coordsAtPos(r);
      if (!a || t.y < a.top || t.y > a.bottom || t.x < a.left - e.defaultCharacterWidth || t.x > a.right + e.defaultCharacterWidth)
        return;
      let l = e.bidiSpans(e.state.doc.lineAt(r)).find((c) => c.from <= r && c.to >= r), u = l && l.dir == Ae.RTL ? -1 : 1;
      s = t.x < a.left ? -u : u;
    }
    let o = this.source(e, r, s);
    if (o != null && o.then) {
      let a = this.pending = { pos: r };
      o.then((l) => {
        this.pending == a && (this.pending = null, l && !(Array.isArray(l) && !l.length) && e.dispatch({ effects: this.setHover.of(Array.isArray(l) ? l : [l]) }));
      }, (l) => mt(e.state, l, "hover tooltip"));
    } else
      o && !(Array.isArray(o) && !o.length) && e.dispatch({ effects: this.setHover.of(Array.isArray(o) ? o : [o]) });
  }
  get tooltip() {
    let e = this.view.plugin(uh), t = e ? e.manager.tooltips.findIndex((i) => i.create == ja.create) : -1;
    return t > -1 ? e.manager.tooltipViews[t] : null;
  }
  mousemove(e) {
    var t, i;
    this.lastMove = { x: e.clientX, y: e.clientY, target: e.target, time: Date.now() }, this.hoverTimeout < 0 && (this.hoverTimeout = setTimeout(this.checkHover, this.hoverTime));
    let { active: r, tooltip: s } = this;
    if (r.length && s && !hS(s.dom, e) || this.pending) {
      let { pos: o } = r[0] || this.pending, a = (i = (t = r[0]) === null || t === void 0 ? void 0 : t.end) !== null && i !== void 0 ? i : o;
      (o == a ? this.view.posAtCoords(this.lastMove) != o : !fS(this.view, o, a, e.clientX, e.clientY)) && (this.view.dispatch({ effects: this.setHover.of([]) }), this.pending = null);
    }
  }
  mouseleave(e) {
    clearTimeout(this.hoverTimeout), this.hoverTimeout = -1;
    let { active: t } = this;
    if (t.length) {
      let { tooltip: i } = this;
      i && i.dom.contains(e.relatedTarget) ? this.watchTooltipLeave(i.dom) : this.view.dispatch({ effects: this.setHover.of([]) });
    }
  }
  watchTooltipLeave(e) {
    let t = (i) => {
      e.removeEventListener("mouseleave", t), this.active.length && !this.view.dom.contains(i.relatedTarget) && this.view.dispatch({ effects: this.setHover.of([]) });
    };
    e.addEventListener("mouseleave", t);
  }
  destroy() {
    clearTimeout(this.hoverTimeout), this.view.dom.removeEventListener("mouseleave", this.mouseleave), this.view.dom.removeEventListener("mousemove", this.mousemove);
  }
}
const oo = 4;
function hS(n, e) {
  let t = n.getBoundingClientRect();
  return e.clientX >= t.left - oo && e.clientX <= t.right + oo && e.clientY >= t.top - oo && e.clientY <= t.bottom + oo;
}
function fS(n, e, t, i, r, s) {
  let o = n.scrollDOM.getBoundingClientRect(), a = n.documentTop + n.documentPadding.top + n.contentHeight;
  if (o.left > i || o.right < i || o.top > r || Math.min(o.bottom, a) < r)
    return !1;
  let l = n.posAtCoords({ x: i, y: r }, !1);
  return l >= e && l <= t;
}
function dS(n, e = {}) {
  let t = te.define(), i = Ye.define({
    create() {
      return [];
    },
    update(r, s) {
      if (r.length && (e.hideOnChange && (s.docChanged || s.selection) ? r = [] : e.hideOn && (r = r.filter((o) => !e.hideOn(s, o))), s.docChanged)) {
        let o = [];
        for (let a of r) {
          let l = s.changes.mapPos(a.pos, -1, Ge.TrackDel);
          if (l != null) {
            let u = Object.assign(/* @__PURE__ */ Object.create(null), a);
            u.pos = l, u.end != null && (u.end = s.changes.mapPos(u.end)), o.push(u);
          }
        }
        r = o;
      }
      for (let o of s.effects)
        o.is(t) && (r = o.value), o.is(pS) && (r = []);
      return r;
    },
    provide: (r) => aa.from(r)
  });
  return [
    i,
    Ie.define((r) => new cS(
      r,
      n,
      i,
      t,
      e.hoverTime || 300
      /* Hover.Time */
    )),
    uS
  ];
}
function WO(n, e) {
  let t = n.plugin(uh);
  if (!t)
    return null;
  let i = t.manager.tooltips.indexOf(e);
  return i < 0 ? null : t.manager.tooltipViews[i];
}
const pS = /* @__PURE__ */ te.define(), wd = /* @__PURE__ */ N.define({
  combine(n) {
    let e, t;
    for (let i of n)
      e = e || i.topContainer, t = t || i.bottomContainer;
    return { topContainer: e, bottomContainer: t };
  }
});
function ls(n, e) {
  let t = n.plugin(qO), i = t ? t.specs.indexOf(e) : -1;
  return i > -1 ? t.panels[i] : null;
}
const qO = /* @__PURE__ */ Ie.fromClass(class {
  constructor(n) {
    this.input = n.state.facet(us), this.specs = this.input.filter((t) => t), this.panels = this.specs.map((t) => t(n));
    let e = n.state.facet(wd);
    this.top = new ao(n, !0, e.topContainer), this.bottom = new ao(n, !1, e.bottomContainer), this.top.sync(this.panels.filter((t) => t.top)), this.bottom.sync(this.panels.filter((t) => !t.top));
    for (let t of this.panels)
      t.dom.classList.add("cm-panel"), t.mount && t.mount();
  }
  update(n) {
    let e = n.state.facet(wd);
    this.top.container != e.topContainer && (this.top.sync([]), this.top = new ao(n.view, !0, e.topContainer)), this.bottom.container != e.bottomContainer && (this.bottom.sync([]), this.bottom = new ao(n.view, !1, e.bottomContainer)), this.top.syncClasses(), this.bottom.syncClasses();
    let t = n.state.facet(us);
    if (t != this.input) {
      let i = t.filter((l) => l), r = [], s = [], o = [], a = [];
      for (let l of i) {
        let u = this.specs.indexOf(l), c;
        u < 0 ? (c = l(n.view), a.push(c)) : (c = this.panels[u], c.update && c.update(n)), r.push(c), (c.top ? s : o).push(c);
      }
      this.specs = i, this.panels = r, this.top.sync(s), this.bottom.sync(o);
      for (let l of a)
        l.dom.classList.add("cm-panel"), l.mount && l.mount();
    } else
      for (let i of this.panels)
        i.update && i.update(n);
  }
  destroy() {
    this.top.sync([]), this.bottom.sync([]);
  }
}, {
  provide: (n) => _.scrollMargins.of((e) => {
    let t = e.plugin(n);
    return t && { top: t.top.scrollMargin(), bottom: t.bottom.scrollMargin() };
  })
});
class ao {
  constructor(e, t, i) {
    this.view = e, this.top = t, this.container = i, this.dom = void 0, this.classes = "", this.panels = [], this.syncClasses();
  }
  sync(e) {
    for (let t of this.panels)
      t.destroy && e.indexOf(t) < 0 && t.destroy();
    this.panels = e, this.syncDOM();
  }
  syncDOM() {
    if (this.panels.length == 0) {
      this.dom && (this.dom.remove(), this.dom = void 0);
      return;
    }
    if (!this.dom) {
      this.dom = document.createElement("div"), this.dom.className = this.top ? "cm-panels cm-panels-top" : "cm-panels cm-panels-bottom", this.dom.style[this.top ? "top" : "bottom"] = "0";
      let t = this.container || this.view.dom;
      t.insertBefore(this.dom, this.top ? t.firstChild : null);
    }
    let e = this.dom.firstChild;
    for (let t of this.panels)
      if (t.dom.parentNode == this.dom) {
        for (; e != t.dom; )
          e = Sd(e);
        e = e.nextSibling;
      } else
        this.dom.insertBefore(t.dom, e);
    for (; e; )
      e = Sd(e);
  }
  scrollMargin() {
    return !this.dom || this.container ? 0 : Math.max(0, this.top ? this.dom.getBoundingClientRect().bottom - Math.max(0, this.view.scrollDOM.getBoundingClientRect().top) : Math.min(innerHeight, this.view.scrollDOM.getBoundingClientRect().bottom) - this.dom.getBoundingClientRect().top);
  }
  syncClasses() {
    if (!(!this.container || this.classes == this.view.themeClasses)) {
      for (let e of this.classes.split(" "))
        e && this.container.classList.remove(e);
      for (let e of (this.classes = this.view.themeClasses).split(" "))
        e && this.container.classList.add(e);
    }
  }
}
function Sd(n) {
  let e = n.nextSibling;
  return n.remove(), e;
}
const us = /* @__PURE__ */ N.define({
  enables: qO
});
class Cn extends ki {
  /**
  @internal
  */
  compare(e) {
    return this == e || this.constructor == e.constructor && this.eq(e);
  }
  /**
  Compare this marker to another marker of the same type.
  */
  eq(e) {
    return !1;
  }
  /**
  Called if the marker has a `toDOM` method and its representation
  was removed from a gutter.
  */
  destroy(e) {
  }
}
Cn.prototype.elementClass = "";
Cn.prototype.toDOM = void 0;
Cn.prototype.mapMode = Ge.TrackBefore;
Cn.prototype.startSide = Cn.prototype.endSide = -1;
Cn.prototype.point = !0;
const Bo = /* @__PURE__ */ N.define(), mS = {
  class: "",
  renderEmptyElements: !1,
  elementStyle: "",
  markers: () => de.empty,
  lineMarker: () => null,
  widgetMarker: () => null,
  lineMarkerChange: null,
  initialSpacer: null,
  updateSpacer: null,
  domEventHandlers: {}
}, Fr = /* @__PURE__ */ N.define();
function gS(n) {
  return [BO(), Fr.of(Object.assign(Object.assign({}, mS), n))];
}
const vd = /* @__PURE__ */ N.define({
  combine: (n) => n.some((e) => e)
});
function BO(n) {
  return [
    OS
  ];
}
const OS = /* @__PURE__ */ Ie.fromClass(class {
  constructor(n) {
    this.view = n, this.prevViewport = n.viewport, this.dom = document.createElement("div"), this.dom.className = "cm-gutters", this.dom.setAttribute("aria-hidden", "true"), this.dom.style.minHeight = this.view.contentHeight / this.view.scaleY + "px", this.gutters = n.state.facet(Fr).map((e) => new Qd(n, e));
    for (let e of this.gutters)
      this.dom.appendChild(e.dom);
    this.fixed = !n.state.facet(vd), this.fixed && (this.dom.style.position = "sticky"), this.syncGutters(!1), n.scrollDOM.insertBefore(this.dom, n.contentDOM);
  }
  update(n) {
    if (this.updateGutters(n)) {
      let e = this.prevViewport, t = n.view.viewport, i = Math.min(e.to, t.to) - Math.max(e.from, t.from);
      this.syncGutters(i < (t.to - t.from) * 0.8);
    }
    n.geometryChanged && (this.dom.style.minHeight = this.view.contentHeight / this.view.scaleY + "px"), this.view.state.facet(vd) != !this.fixed && (this.fixed = !this.fixed, this.dom.style.position = this.fixed ? "sticky" : ""), this.prevViewport = n.view.viewport;
  }
  syncGutters(n) {
    let e = this.dom.nextSibling;
    n && this.dom.remove();
    let t = de.iter(this.view.state.facet(Bo), this.view.viewport.from), i = [], r = this.gutters.map((s) => new bS(s, this.view.viewport, -this.view.documentPadding.top));
    for (let s of this.view.viewportLineBlocks)
      if (i.length && (i = []), Array.isArray(s.type)) {
        let o = !0;
        for (let a of s.type)
          if (a.type == Ot.Text && o) {
            Ju(t, i, a.from);
            for (let l of r)
              l.line(this.view, a, i);
            o = !1;
          } else if (a.widget)
            for (let l of r)
              l.widget(this.view, a);
      } else if (s.type == Ot.Text) {
        Ju(t, i, s.from);
        for (let o of r)
          o.line(this.view, s, i);
      } else if (s.widget)
        for (let o of r)
          o.widget(this.view, s);
    for (let s of r)
      s.finish();
    n && this.view.scrollDOM.insertBefore(this.dom, e);
  }
  updateGutters(n) {
    let e = n.startState.facet(Fr), t = n.state.facet(Fr), i = n.docChanged || n.heightChanged || n.viewportChanged || !de.eq(n.startState.facet(Bo), n.state.facet(Bo), n.view.viewport.from, n.view.viewport.to);
    if (e == t)
      for (let r of this.gutters)
        r.update(n) && (i = !0);
    else {
      i = !0;
      let r = [];
      for (let s of t) {
        let o = e.indexOf(s);
        o < 0 ? r.push(new Qd(this.view, s)) : (this.gutters[o].update(n), r.push(this.gutters[o]));
      }
      for (let s of this.gutters)
        s.dom.remove(), r.indexOf(s) < 0 && s.destroy();
      for (let s of r)
        this.dom.appendChild(s.dom);
      this.gutters = r;
    }
    return i;
  }
  destroy() {
    for (let n of this.gutters)
      n.destroy();
    this.dom.remove();
  }
}, {
  provide: (n) => _.scrollMargins.of((e) => {
    let t = e.plugin(n);
    return !t || t.gutters.length == 0 || !t.fixed ? null : e.textDirection == Ae.LTR ? { left: t.dom.offsetWidth * e.scaleX } : { right: t.dom.offsetWidth * e.scaleX };
  })
});
function Pd(n) {
  return Array.isArray(n) ? n : [n];
}
function Ju(n, e, t) {
  for (; n.value && n.from <= t; )
    n.from == t && e.push(n.value), n.next();
}
class bS {
  constructor(e, t, i) {
    this.gutter = e, this.height = i, this.i = 0, this.cursor = de.iter(e.markers, t.from);
  }
  addElement(e, t, i) {
    let { gutter: r } = this, s = (t.top - this.height) / e.scaleY, o = t.height / e.scaleY;
    if (this.i == r.elements.length) {
      let a = new VO(e, o, s, i);
      r.elements.push(a), r.dom.appendChild(a.dom);
    } else
      r.elements[this.i].update(e, o, s, i);
    this.height = t.bottom, this.i++;
  }
  line(e, t, i) {
    let r = [];
    Ju(this.cursor, r, t.from), i.length && (r = r.concat(i));
    let s = this.gutter.config.lineMarker(e, t, r);
    s && r.unshift(s);
    let o = this.gutter;
    r.length == 0 && !o.config.renderEmptyElements || this.addElement(e, t, r);
  }
  widget(e, t) {
    let i = this.gutter.config.widgetMarker(e, t.widget, t);
    i && this.addElement(e, t, [i]);
  }
  finish() {
    let e = this.gutter;
    for (; e.elements.length > this.i; ) {
      let t = e.elements.pop();
      e.dom.removeChild(t.dom), t.destroy();
    }
  }
}
class Qd {
  constructor(e, t) {
    this.view = e, this.config = t, this.elements = [], this.spacer = null, this.dom = document.createElement("div"), this.dom.className = "cm-gutter" + (this.config.class ? " " + this.config.class : "");
    for (let i in t.domEventHandlers)
      this.dom.addEventListener(i, (r) => {
        let s = r.target, o;
        if (s != this.dom && this.dom.contains(s)) {
          for (; s.parentNode != this.dom; )
            s = s.parentNode;
          let l = s.getBoundingClientRect();
          o = (l.top + l.bottom) / 2;
        } else
          o = r.clientY;
        let a = e.lineBlockAtHeight(o - e.documentTop);
        t.domEventHandlers[i](e, a, r) && r.preventDefault();
      });
    this.markers = Pd(t.markers(e)), t.initialSpacer && (this.spacer = new VO(e, 0, 0, [t.initialSpacer(e)]), this.dom.appendChild(this.spacer.dom), this.spacer.dom.style.cssText += "visibility: hidden; pointer-events: none");
  }
  update(e) {
    let t = this.markers;
    if (this.markers = Pd(this.config.markers(e.view)), this.spacer && this.config.updateSpacer) {
      let r = this.config.updateSpacer(this.spacer.markers[0], e);
      r != this.spacer.markers[0] && this.spacer.update(e.view, 0, 0, [r]);
    }
    let i = e.view.viewport;
    return !de.eq(this.markers, t, i.from, i.to) || (this.config.lineMarkerChange ? this.config.lineMarkerChange(e) : !1);
  }
  destroy() {
    for (let e of this.elements)
      e.destroy();
  }
}
class VO {
  constructor(e, t, i, r) {
    this.height = -1, this.above = 0, this.markers = [], this.dom = document.createElement("div"), this.dom.className = "cm-gutterElement", this.update(e, t, i, r);
  }
  update(e, t, i, r) {
    this.height != t && (this.height = t, this.dom.style.height = t + "px"), this.above != i && (this.dom.style.marginTop = (this.above = i) ? i + "px" : ""), yS(this.markers, r) || this.setMarkers(e, r);
  }
  setMarkers(e, t) {
    let i = "cm-gutterElement", r = this.dom.firstChild;
    for (let s = 0, o = 0; ; ) {
      let a = o, l = s < t.length ? t[s++] : null, u = !1;
      if (l) {
        let c = l.elementClass;
        c && (i += " " + c);
        for (let h = o; h < this.markers.length; h++)
          if (this.markers[h].compare(l)) {
            a = h, u = !0;
            break;
          }
      } else
        a = this.markers.length;
      for (; o < a; ) {
        let c = this.markers[o++];
        if (c.toDOM) {
          c.destroy(r);
          let h = r.nextSibling;
          r.remove(), r = h;
        }
      }
      if (!l)
        break;
      l.toDOM && (u ? r = r.nextSibling : this.dom.insertBefore(l.toDOM(e), r)), u && o++;
    }
    this.dom.className = i, this.markers = t;
  }
  destroy() {
    this.setMarkers(null, []);
  }
}
function yS(n, e) {
  if (n.length != e.length)
    return !1;
  for (let t = 0; t < n.length; t++)
    if (!n[t].compare(e[t]))
      return !1;
  return !0;
}
const kS = /* @__PURE__ */ N.define(), Xi = /* @__PURE__ */ N.define({
  combine(n) {
    return pn(n, { formatNumber: String, domEventHandlers: {} }, {
      domEventHandlers(e, t) {
        let i = Object.assign({}, e);
        for (let r in t) {
          let s = i[r], o = t[r];
          i[r] = s ? (a, l, u) => s(a, l, u) || o(a, l, u) : o;
        }
        return i;
      }
    });
  }
});
class vl extends Cn {
  constructor(e) {
    super(), this.number = e;
  }
  eq(e) {
    return this.number == e.number;
  }
  toDOM() {
    return document.createTextNode(this.number);
  }
}
function Pl(n, e) {
  return n.state.facet(Xi).formatNumber(e, n.state);
}
const xS = /* @__PURE__ */ Fr.compute([Xi], (n) => ({
  class: "cm-lineNumbers",
  renderEmptyElements: !1,
  markers(e) {
    return e.state.facet(kS);
  },
  lineMarker(e, t, i) {
    return i.some((r) => r.toDOM) ? null : new vl(Pl(e, e.state.doc.lineAt(t.from).number));
  },
  widgetMarker: () => null,
  lineMarkerChange: (e) => e.startState.facet(Xi) != e.state.facet(Xi),
  initialSpacer(e) {
    return new vl(Pl(e, $d(e.state.doc.lines)));
  },
  updateSpacer(e, t) {
    let i = Pl(t.view, $d(t.view.state.doc.lines));
    return i == e.number ? e : new vl(i);
  },
  domEventHandlers: n.facet(Xi).domEventHandlers
}));
function wS(n = {}) {
  return [
    Xi.of(n),
    BO(),
    xS
  ];
}
function $d(n) {
  let e = 9;
  for (; e < n; )
    e = e * 10 + 9;
  return e;
}
const SS = /* @__PURE__ */ new class extends Cn {
  constructor() {
    super(...arguments), this.elementClass = "cm-activeLineGutter";
  }
}(), vS = /* @__PURE__ */ Bo.compute(["selection"], (n) => {
  let e = [], t = -1;
  for (let i of n.selection.ranges) {
    let r = n.doc.lineAt(i.head).from;
    r > t && (t = r, e.push(SS.range(r)));
  }
  return de.of(e);
});
function PS() {
  return vS;
}
const YO = 1024;
let QS = 0;
class Mt {
  constructor(e, t) {
    this.from = e, this.to = t;
  }
}
class J {
  /**
  Create a new node prop type.
  */
  constructor(e = {}) {
    this.id = QS++, this.perNode = !!e.perNode, this.deserialize = e.deserialize || (() => {
      throw new Error("This node type doesn't define a deserialize function");
    });
  }
  /**
  This is meant to be used with
  [`NodeSet.extend`](#common.NodeSet.extend) or
  [`LRParser.configure`](#lr.ParserConfig.props) to compute
  prop values for each node type in the set. Takes a [match
  object](#common.NodeType^match) or function that returns undefined
  if the node type doesn't get this prop, and the prop's value if
  it does.
  */
  add(e) {
    if (this.perNode)
      throw new RangeError("Can't add per-node props to node types");
    return typeof e != "function" && (e = qe.match(e)), (t) => {
      let i = e(t);
      return i === void 0 ? null : [this, i];
    };
  }
}
J.closedBy = new J({ deserialize: (n) => n.split(" ") });
J.openedBy = new J({ deserialize: (n) => n.split(" ") });
J.group = new J({ deserialize: (n) => n.split(" ") });
J.isolate = new J({ deserialize: (n) => {
  if (n && n != "rtl" && n != "ltr" && n != "auto")
    throw new RangeError("Invalid value for isolate: " + n);
  return n || "auto";
} });
J.contextHash = new J({ perNode: !0 });
J.lookAhead = new J({ perNode: !0 });
J.mounted = new J({ perNode: !0 });
class cs {
  constructor(e, t, i) {
    this.tree = e, this.overlay = t, this.parser = i;
  }
  /**
  @internal
  */
  static get(e) {
    return e && e.props && e.props[J.mounted.id];
  }
}
const $S = /* @__PURE__ */ Object.create(null);
class qe {
  /**
  @internal
  */
  constructor(e, t, i, r = 0) {
    this.name = e, this.props = t, this.id = i, this.flags = r;
  }
  /**
  Define a node type.
  */
  static define(e) {
    let t = e.props && e.props.length ? /* @__PURE__ */ Object.create(null) : $S, i = (e.top ? 1 : 0) | (e.skipped ? 2 : 0) | (e.error ? 4 : 0) | (e.name == null ? 8 : 0), r = new qe(e.name || "", t, e.id, i);
    if (e.props) {
      for (let s of e.props)
        if (Array.isArray(s) || (s = s(r)), s) {
          if (s[0].perNode)
            throw new RangeError("Can't store a per-node prop on a node type");
          t[s[0].id] = s[1];
        }
    }
    return r;
  }
  /**
  Retrieves a node prop for this type. Will return `undefined` if
  the prop isn't present on this node.
  */
  prop(e) {
    return this.props[e.id];
  }
  /**
  True when this is the top node of a grammar.
  */
  get isTop() {
    return (this.flags & 1) > 0;
  }
  /**
  True when this node is produced by a skip rule.
  */
  get isSkipped() {
    return (this.flags & 2) > 0;
  }
  /**
  Indicates whether this is an error node.
  */
  get isError() {
    return (this.flags & 4) > 0;
  }
  /**
  When true, this node type doesn't correspond to a user-declared
  named node, for example because it is used to cache repetition.
  */
  get isAnonymous() {
    return (this.flags & 8) > 0;
  }
  /**
  Returns true when this node's name or one of its
  [groups](#common.NodeProp^group) matches the given string.
  */
  is(e) {
    if (typeof e == "string") {
      if (this.name == e)
        return !0;
      let t = this.prop(J.group);
      return t ? t.indexOf(e) > -1 : !1;
    }
    return this.id == e;
  }
  /**
  Create a function from node types to arbitrary values by
  specifying an object whose property names are node or
  [group](#common.NodeProp^group) names. Often useful with
  [`NodeProp.add`](#common.NodeProp.add). You can put multiple
  names, separated by spaces, in a single property name to map
  multiple node names to a single value.
  */
  static match(e) {
    let t = /* @__PURE__ */ Object.create(null);
    for (let i in e)
      for (let r of i.split(" "))
        t[r] = e[i];
    return (i) => {
      for (let r = i.prop(J.group), s = -1; s < (r ? r.length : 0); s++) {
        let o = t[s < 0 ? i.name : r[s]];
        if (o)
          return o;
      }
    };
  }
}
qe.none = new qe(
  "",
  /* @__PURE__ */ Object.create(null),
  0,
  8
  /* NodeFlag.Anonymous */
);
class zs {
  /**
  Create a set with the given types. The `id` property of each
  type should correspond to its position within the array.
  */
  constructor(e) {
    this.types = e;
    for (let t = 0; t < e.length; t++)
      if (e[t].id != t)
        throw new RangeError("Node type ids should correspond to array positions when creating a node set");
  }
  /**
  Create a copy of this set with some node properties added. The
  arguments to this method can be created with
  [`NodeProp.add`](#common.NodeProp.add).
  */
  extend(...e) {
    let t = [];
    for (let i of this.types) {
      let r = null;
      for (let s of e) {
        let o = s(i);
        o && (r || (r = Object.assign({}, i.props)), r[o[0].id] = o[1]);
      }
      t.push(r ? new qe(i.name, r, i.id, i.flags) : i);
    }
    return new zs(t);
  }
}
const lo = /* @__PURE__ */ new WeakMap(), Cd = /* @__PURE__ */ new WeakMap();
var ve;
(function(n) {
  n[n.ExcludeBuffers = 1] = "ExcludeBuffers", n[n.IncludeAnonymous = 2] = "IncludeAnonymous", n[n.IgnoreMounts = 4] = "IgnoreMounts", n[n.IgnoreOverlays = 8] = "IgnoreOverlays";
})(ve || (ve = {}));
class ge {
  /**
  Construct a new tree. See also [`Tree.build`](#common.Tree^build).
  */
  constructor(e, t, i, r, s) {
    if (this.type = e, this.children = t, this.positions = i, this.length = r, this.props = null, s && s.length) {
      this.props = /* @__PURE__ */ Object.create(null);
      for (let [o, a] of s)
        this.props[typeof o == "number" ? o : o.id] = a;
    }
  }
  /**
  @internal
  */
  toString() {
    let e = cs.get(this);
    if (e && !e.overlay)
      return e.tree.toString();
    let t = "";
    for (let i of this.children) {
      let r = i.toString();
      r && (t && (t += ","), t += r);
    }
    return this.type.name ? (/\W/.test(this.type.name) && !this.type.isError ? JSON.stringify(this.type.name) : this.type.name) + (t.length ? "(" + t + ")" : "") : t;
  }
  /**
  Get a [tree cursor](#common.TreeCursor) positioned at the top of
  the tree. Mode can be used to [control](#common.IterMode) which
  nodes the cursor visits.
  */
  cursor(e = 0) {
    return new la(this.topNode, e);
  }
  /**
  Get a [tree cursor](#common.TreeCursor) pointing into this tree
  at the given position and side (see
  [`moveTo`](#common.TreeCursor.moveTo).
  */
  cursorAt(e, t = 0, i = 0) {
    let r = lo.get(this) || this.topNode, s = new la(r);
    return s.moveTo(e, t), lo.set(this, s._tree), s;
  }
  /**
  Get a [syntax node](#common.SyntaxNode) object for the top of the
  tree.
  */
  get topNode() {
    return new it(this, 0, 0, null);
  }
  /**
  Get the [syntax node](#common.SyntaxNode) at the given position.
  If `side` is -1, this will move into nodes that end at the
  position. If 1, it'll move into nodes that start at the
  position. With 0, it'll only enter nodes that cover the position
  from both sides.
  
  Note that this will not enter
  [overlays](#common.MountedTree.overlay), and you often want
  [`resolveInner`](#common.Tree.resolveInner) instead.
  */
  resolve(e, t = 0) {
    let i = hs(lo.get(this) || this.topNode, e, t, !1);
    return lo.set(this, i), i;
  }
  /**
  Like [`resolve`](#common.Tree.resolve), but will enter
  [overlaid](#common.MountedTree.overlay) nodes, producing a syntax node
  pointing into the innermost overlaid tree at the given position
  (with parent links going through all parent structure, including
  the host trees).
  */
  resolveInner(e, t = 0) {
    let i = hs(Cd.get(this) || this.topNode, e, t, !0);
    return Cd.set(this, i), i;
  }
  /**
  In some situations, it can be useful to iterate through all
  nodes around a position, including those in overlays that don't
  directly cover the position. This method gives you an iterator
  that will produce all nodes, from small to big, around the given
  position.
  */
  resolveStack(e, t = 0) {
    return AS(this, e, t);
  }
  /**
  Iterate over the tree and its children, calling `enter` for any
  node that touches the `from`/`to` region (if given) before
  running over such a node's children, and `leave` (if given) when
  leaving the node. When `enter` returns `false`, that node will
  not have its children iterated over (or `leave` called).
  */
  iterate(e) {
    let { enter: t, leave: i, from: r = 0, to: s = this.length } = e, o = e.mode || 0, a = (o & ve.IncludeAnonymous) > 0;
    for (let l = this.cursor(o | ve.IncludeAnonymous); ; ) {
      let u = !1;
      if (l.from <= s && l.to >= r && (!a && l.type.isAnonymous || t(l) !== !1)) {
        if (l.firstChild())
          continue;
        u = !0;
      }
      for (; u && i && (a || !l.type.isAnonymous) && i(l), !l.nextSibling(); ) {
        if (!l.parent())
          return;
        u = !0;
      }
    }
  }
  /**
  Get the value of the given [node prop](#common.NodeProp) for this
  node. Works with both per-node and per-type props.
  */
  prop(e) {
    return e.perNode ? this.props ? this.props[e.id] : void 0 : this.type.prop(e);
  }
  /**
  Returns the node's [per-node props](#common.NodeProp.perNode) in a
  format that can be passed to the [`Tree`](#common.Tree)
  constructor.
  */
  get propValues() {
    let e = [];
    if (this.props)
      for (let t in this.props)
        e.push([+t, this.props[t]]);
    return e;
  }
  /**
  Balance the direct children of this tree, producing a copy of
  which may have children grouped into subtrees with type
  [`NodeType.none`](#common.NodeType^none).
  */
  balance(e = {}) {
    return this.children.length <= 8 ? this : dh(qe.none, this.children, this.positions, 0, this.children.length, 0, this.length, (t, i, r) => new ge(this.type, t, i, r, this.propValues), e.makeTree || ((t, i, r) => new ge(qe.none, t, i, r)));
  }
  /**
  Build a tree from a postfix-ordered buffer of node information,
  or a cursor over such a buffer.
  */
  static build(e) {
    return RS(e);
  }
}
ge.empty = new ge(qe.none, [], [], 0);
class hh {
  constructor(e, t) {
    this.buffer = e, this.index = t;
  }
  get id() {
    return this.buffer[this.index - 4];
  }
  get start() {
    return this.buffer[this.index - 3];
  }
  get end() {
    return this.buffer[this.index - 2];
  }
  get size() {
    return this.buffer[this.index - 1];
  }
  get pos() {
    return this.index;
  }
  next() {
    this.index -= 4;
  }
  fork() {
    return new hh(this.buffer, this.index);
  }
}
class Jn {
  /**
  Create a tree buffer.
  */
  constructor(e, t, i) {
    this.buffer = e, this.length = t, this.set = i;
  }
  /**
  @internal
  */
  get type() {
    return qe.none;
  }
  /**
  @internal
  */
  toString() {
    let e = [];
    for (let t = 0; t < this.buffer.length; )
      e.push(this.childString(t)), t = this.buffer[t + 3];
    return e.join(",");
  }
  /**
  @internal
  */
  childString(e) {
    let t = this.buffer[e], i = this.buffer[e + 3], r = this.set.types[t], s = r.name;
    if (/\W/.test(s) && !r.isError && (s = JSON.stringify(s)), e += 4, i == e)
      return s;
    let o = [];
    for (; e < i; )
      o.push(this.childString(e)), e = this.buffer[e + 3];
    return s + "(" + o.join(",") + ")";
  }
  /**
  @internal
  */
  findChild(e, t, i, r, s) {
    let { buffer: o } = this, a = -1;
    for (let l = e; l != t && !(jO(s, r, o[l + 1], o[l + 2]) && (a = l, i > 0)); l = o[l + 3])
      ;
    return a;
  }
  /**
  @internal
  */
  slice(e, t, i) {
    let r = this.buffer, s = new Uint16Array(t - e), o = 0;
    for (let a = e, l = 0; a < t; ) {
      s[l++] = r[a++], s[l++] = r[a++] - i;
      let u = s[l++] = r[a++] - i;
      s[l++] = r[a++] - e, o = Math.max(o, u);
    }
    return new Jn(s, o, this.set);
  }
}
function jO(n, e, t, i) {
  switch (n) {
    case -2:
      return t < e;
    case -1:
      return i >= e && t < e;
    case 0:
      return t < e && i > e;
    case 1:
      return t <= e && i > e;
    case 2:
      return i > e;
    case 4:
      return !0;
  }
}
function hs(n, e, t, i) {
  for (var r; n.from == n.to || (t < 1 ? n.from >= e : n.from > e) || (t > -1 ? n.to <= e : n.to < e); ) {
    let o = !i && n instanceof it && n.index < 0 ? null : n.parent;
    if (!o)
      return n;
    n = o;
  }
  let s = i ? 0 : ve.IgnoreOverlays;
  if (i)
    for (let o = n, a = o.parent; a; o = a, a = o.parent)
      o instanceof it && o.index < 0 && ((r = a.enter(e, t, s)) === null || r === void 0 ? void 0 : r.from) != o.from && (n = a);
  for (; ; ) {
    let o = n.enter(e, t, s);
    if (!o)
      return n;
    n = o;
  }
}
class UO {
  cursor(e = 0) {
    return new la(this, e);
  }
  getChild(e, t = null, i = null) {
    let r = Td(this, e, t, i);
    return r.length ? r[0] : null;
  }
  getChildren(e, t = null, i = null) {
    return Td(this, e, t, i);
  }
  resolve(e, t = 0) {
    return hs(this, e, t, !1);
  }
  resolveInner(e, t = 0) {
    return hs(this, e, t, !0);
  }
  matchContext(e) {
    return ec(this, e);
  }
  enterUnfinishedNodesBefore(e) {
    let t = this.childBefore(e), i = this;
    for (; t; ) {
      let r = t.lastChild;
      if (!r || r.to != t.to)
        break;
      r.type.isError && r.from == r.to ? (i = t, t = r.prevSibling) : t = r;
    }
    return i;
  }
  get node() {
    return this;
  }
  get next() {
    return this.parent;
  }
}
class it extends UO {
  constructor(e, t, i, r) {
    super(), this._tree = e, this.from = t, this.index = i, this._parent = r;
  }
  get type() {
    return this._tree.type;
  }
  get name() {
    return this._tree.type.name;
  }
  get to() {
    return this.from + this._tree.length;
  }
  nextChild(e, t, i, r, s = 0) {
    for (let o = this; ; ) {
      for (let { children: a, positions: l } = o._tree, u = t > 0 ? a.length : -1; e != u; e += t) {
        let c = a[e], h = l[e] + o.from;
        if (jO(r, i, h, h + c.length)) {
          if (c instanceof Jn) {
            if (s & ve.ExcludeBuffers)
              continue;
            let f = c.findChild(0, c.buffer.length, t, i - h, r);
            if (f > -1)
              return new an(new CS(o, c, e, h), null, f);
          } else if (s & ve.IncludeAnonymous || !c.type.isAnonymous || fh(c)) {
            let f;
            if (!(s & ve.IgnoreMounts) && (f = cs.get(c)) && !f.overlay)
              return new it(f.tree, h, e, o);
            let d = new it(c, h, e, o);
            return s & ve.IncludeAnonymous || !d.type.isAnonymous ? d : d.nextChild(t < 0 ? c.children.length - 1 : 0, t, i, r);
          }
        }
      }
      if (s & ve.IncludeAnonymous || !o.type.isAnonymous || (o.index >= 0 ? e = o.index + t : e = t < 0 ? -1 : o._parent._tree.children.length, o = o._parent, !o))
        return null;
    }
  }
  get firstChild() {
    return this.nextChild(
      0,
      1,
      0,
      4
      /* Side.DontCare */
    );
  }
  get lastChild() {
    return this.nextChild(
      this._tree.children.length - 1,
      -1,
      0,
      4
      /* Side.DontCare */
    );
  }
  childAfter(e) {
    return this.nextChild(
      0,
      1,
      e,
      2
      /* Side.After */
    );
  }
  childBefore(e) {
    return this.nextChild(
      this._tree.children.length - 1,
      -1,
      e,
      -2
      /* Side.Before */
    );
  }
  enter(e, t, i = 0) {
    let r;
    if (!(i & ve.IgnoreOverlays) && (r = cs.get(this._tree)) && r.overlay) {
      let s = e - this.from;
      for (let { from: o, to: a } of r.overlay)
        if ((t > 0 ? o <= s : o < s) && (t < 0 ? a >= s : a > s))
          return new it(r.tree, r.overlay[0].from + this.from, -1, this);
    }
    return this.nextChild(0, 1, e, t, i);
  }
  nextSignificantParent() {
    let e = this;
    for (; e.type.isAnonymous && e._parent; )
      e = e._parent;
    return e;
  }
  get parent() {
    return this._parent ? this._parent.nextSignificantParent() : null;
  }
  get nextSibling() {
    return this._parent && this.index >= 0 ? this._parent.nextChild(
      this.index + 1,
      1,
      0,
      4
      /* Side.DontCare */
    ) : null;
  }
  get prevSibling() {
    return this._parent && this.index >= 0 ? this._parent.nextChild(
      this.index - 1,
      -1,
      0,
      4
      /* Side.DontCare */
    ) : null;
  }
  get tree() {
    return this._tree;
  }
  toTree() {
    return this._tree;
  }
  /**
  @internal
  */
  toString() {
    return this._tree.toString();
  }
}
function Td(n, e, t, i) {
  let r = n.cursor(), s = [];
  if (!r.firstChild())
    return s;
  if (t != null) {
    for (let o = !1; !o; )
      if (o = r.type.is(t), !r.nextSibling())
        return s;
  }
  for (; ; ) {
    if (i != null && r.type.is(i))
      return s;
    if (r.type.is(e) && s.push(r.node), !r.nextSibling())
      return i == null ? s : [];
  }
}
function ec(n, e, t = e.length - 1) {
  for (let i = n.parent; t >= 0; i = i.parent) {
    if (!i)
      return !1;
    if (!i.type.isAnonymous) {
      if (e[t] && e[t] != i.name)
        return !1;
      t--;
    }
  }
  return !0;
}
class CS {
  constructor(e, t, i, r) {
    this.parent = e, this.buffer = t, this.index = i, this.start = r;
  }
}
class an extends UO {
  get name() {
    return this.type.name;
  }
  get from() {
    return this.context.start + this.context.buffer.buffer[this.index + 1];
  }
  get to() {
    return this.context.start + this.context.buffer.buffer[this.index + 2];
  }
  constructor(e, t, i) {
    super(), this.context = e, this._parent = t, this.index = i, this.type = e.buffer.set.types[e.buffer.buffer[i]];
  }
  child(e, t, i) {
    let { buffer: r } = this.context, s = r.findChild(this.index + 4, r.buffer[this.index + 3], e, t - this.context.start, i);
    return s < 0 ? null : new an(this.context, this, s);
  }
  get firstChild() {
    return this.child(
      1,
      0,
      4
      /* Side.DontCare */
    );
  }
  get lastChild() {
    return this.child(
      -1,
      0,
      4
      /* Side.DontCare */
    );
  }
  childAfter(e) {
    return this.child(
      1,
      e,
      2
      /* Side.After */
    );
  }
  childBefore(e) {
    return this.child(
      -1,
      e,
      -2
      /* Side.Before */
    );
  }
  enter(e, t, i = 0) {
    if (i & ve.ExcludeBuffers)
      return null;
    let { buffer: r } = this.context, s = r.findChild(this.index + 4, r.buffer[this.index + 3], t > 0 ? 1 : -1, e - this.context.start, t);
    return s < 0 ? null : new an(this.context, this, s);
  }
  get parent() {
    return this._parent || this.context.parent.nextSignificantParent();
  }
  externalSibling(e) {
    return this._parent ? null : this.context.parent.nextChild(
      this.context.index + e,
      e,
      0,
      4
      /* Side.DontCare */
    );
  }
  get nextSibling() {
    let { buffer: e } = this.context, t = e.buffer[this.index + 3];
    return t < (this._parent ? e.buffer[this._parent.index + 3] : e.buffer.length) ? new an(this.context, this._parent, t) : this.externalSibling(1);
  }
  get prevSibling() {
    let { buffer: e } = this.context, t = this._parent ? this._parent.index + 4 : 0;
    return this.index == t ? this.externalSibling(-1) : new an(this.context, this._parent, e.findChild(
      t,
      this.index,
      -1,
      0,
      4
      /* Side.DontCare */
    ));
  }
  get tree() {
    return null;
  }
  toTree() {
    let e = [], t = [], { buffer: i } = this.context, r = this.index + 4, s = i.buffer[this.index + 3];
    if (s > r) {
      let o = i.buffer[this.index + 1];
      e.push(i.slice(r, s, o)), t.push(0);
    }
    return new ge(this.type, e, t, this.to - this.from);
  }
  /**
  @internal
  */
  toString() {
    return this.context.buffer.childString(this.index);
  }
}
function FO(n) {
  if (!n.length)
    return null;
  let e = 0, t = n[0];
  for (let s = 1; s < n.length; s++) {
    let o = n[s];
    (o.from > t.from || o.to < t.to) && (t = o, e = s);
  }
  let i = t instanceof it && t.index < 0 ? null : t.parent, r = n.slice();
  return i ? r[e] = i : r.splice(e, 1), new TS(r, t);
}
class TS {
  constructor(e, t) {
    this.heads = e, this.node = t;
  }
  get next() {
    return FO(this.heads);
  }
}
function AS(n, e, t) {
  let i = n.resolveInner(e, t), r = null;
  for (let s = i instanceof it ? i : i.context.parent; s; s = s.parent)
    if (s.index < 0) {
      let o = s.parent;
      (r || (r = [i])).push(o.resolve(e, t)), s = o;
    } else {
      let o = cs.get(s.tree);
      if (o && o.overlay && o.overlay[0].from <= e && o.overlay[o.overlay.length - 1].to >= e) {
        let a = new it(o.tree, o.overlay[0].from + s.from, -1, s);
        (r || (r = [i])).push(hs(a, e, t, !1));
      }
    }
  return r ? FO(r) : i;
}
class la {
  /**
  Shorthand for `.type.name`.
  */
  get name() {
    return this.type.name;
  }
  /**
  @internal
  */
  constructor(e, t = 0) {
    if (this.mode = t, this.buffer = null, this.stack = [], this.index = 0, this.bufferNode = null, e instanceof it)
      this.yieldNode(e);
    else {
      this._tree = e.context.parent, this.buffer = e.context;
      for (let i = e._parent; i; i = i._parent)
        this.stack.unshift(i.index);
      this.bufferNode = e, this.yieldBuf(e.index);
    }
  }
  yieldNode(e) {
    return e ? (this._tree = e, this.type = e.type, this.from = e.from, this.to = e.to, !0) : !1;
  }
  yieldBuf(e, t) {
    this.index = e;
    let { start: i, buffer: r } = this.buffer;
    return this.type = t || r.set.types[r.buffer[e]], this.from = i + r.buffer[e + 1], this.to = i + r.buffer[e + 2], !0;
  }
  /**
  @internal
  */
  yield(e) {
    return e ? e instanceof it ? (this.buffer = null, this.yieldNode(e)) : (this.buffer = e.context, this.yieldBuf(e.index, e.type)) : !1;
  }
  /**
  @internal
  */
  toString() {
    return this.buffer ? this.buffer.buffer.childString(this.index) : this._tree.toString();
  }
  /**
  @internal
  */
  enterChild(e, t, i) {
    if (!this.buffer)
      return this.yield(this._tree.nextChild(e < 0 ? this._tree._tree.children.length - 1 : 0, e, t, i, this.mode));
    let { buffer: r } = this.buffer, s = r.findChild(this.index + 4, r.buffer[this.index + 3], e, t - this.buffer.start, i);
    return s < 0 ? !1 : (this.stack.push(this.index), this.yieldBuf(s));
  }
  /**
  Move the cursor to this node's first child. When this returns
  false, the node has no child, and the cursor has not been moved.
  */
  firstChild() {
    return this.enterChild(
      1,
      0,
      4
      /* Side.DontCare */
    );
  }
  /**
  Move the cursor to this node's last child.
  */
  lastChild() {
    return this.enterChild(
      -1,
      0,
      4
      /* Side.DontCare */
    );
  }
  /**
  Move the cursor to the first child that ends after `pos`.
  */
  childAfter(e) {
    return this.enterChild(
      1,
      e,
      2
      /* Side.After */
    );
  }
  /**
  Move to the last child that starts before `pos`.
  */
  childBefore(e) {
    return this.enterChild(
      -1,
      e,
      -2
      /* Side.Before */
    );
  }
  /**
  Move the cursor to the child around `pos`. If side is -1 the
  child may end at that position, when 1 it may start there. This
  will also enter [overlaid](#common.MountedTree.overlay)
  [mounted](#common.NodeProp^mounted) trees unless `overlays` is
  set to false.
  */
  enter(e, t, i = this.mode) {
    return this.buffer ? i & ve.ExcludeBuffers ? !1 : this.enterChild(1, e, t) : this.yield(this._tree.enter(e, t, i));
  }
  /**
  Move to the node's parent node, if this isn't the top node.
  */
  parent() {
    if (!this.buffer)
      return this.yieldNode(this.mode & ve.IncludeAnonymous ? this._tree._parent : this._tree.parent);
    if (this.stack.length)
      return this.yieldBuf(this.stack.pop());
    let e = this.mode & ve.IncludeAnonymous ? this.buffer.parent : this.buffer.parent.nextSignificantParent();
    return this.buffer = null, this.yieldNode(e);
  }
  /**
  @internal
  */
  sibling(e) {
    if (!this.buffer)
      return this._tree._parent ? this.yield(this._tree.index < 0 ? null : this._tree._parent.nextChild(this._tree.index + e, e, 0, 4, this.mode)) : !1;
    let { buffer: t } = this.buffer, i = this.stack.length - 1;
    if (e < 0) {
      let r = i < 0 ? 0 : this.stack[i] + 4;
      if (this.index != r)
        return this.yieldBuf(t.findChild(
          r,
          this.index,
          -1,
          0,
          4
          /* Side.DontCare */
        ));
    } else {
      let r = t.buffer[this.index + 3];
      if (r < (i < 0 ? t.buffer.length : t.buffer[this.stack[i] + 3]))
        return this.yieldBuf(r);
    }
    return i < 0 ? this.yield(this.buffer.parent.nextChild(this.buffer.index + e, e, 0, 4, this.mode)) : !1;
  }
  /**
  Move to this node's next sibling, if any.
  */
  nextSibling() {
    return this.sibling(1);
  }
  /**
  Move to this node's previous sibling, if any.
  */
  prevSibling() {
    return this.sibling(-1);
  }
  atLastNode(e) {
    let t, i, { buffer: r } = this;
    if (r) {
      if (e > 0) {
        if (this.index < r.buffer.buffer.length)
          return !1;
      } else
        for (let s = 0; s < this.index; s++)
          if (r.buffer.buffer[s + 3] < this.index)
            return !1;
      ({ index: t, parent: i } = r);
    } else
      ({ index: t, _parent: i } = this._tree);
    for (; i; { index: t, _parent: i } = i)
      if (t > -1)
        for (let s = t + e, o = e < 0 ? -1 : i._tree.children.length; s != o; s += e) {
          let a = i._tree.children[s];
          if (this.mode & ve.IncludeAnonymous || a instanceof Jn || !a.type.isAnonymous || fh(a))
            return !1;
        }
    return !0;
  }
  move(e, t) {
    if (t && this.enterChild(
      e,
      0,
      4
      /* Side.DontCare */
    ))
      return !0;
    for (; ; ) {
      if (this.sibling(e))
        return !0;
      if (this.atLastNode(e) || !this.parent())
        return !1;
    }
  }
  /**
  Move to the next node in a
  [pre-order](https://en.wikipedia.org/wiki/Tree_traversal#Pre-order,_NLR)
  traversal, going from a node to its first child or, if the
  current node is empty or `enter` is false, its next sibling or
  the next sibling of the first parent node that has one.
  */
  next(e = !0) {
    return this.move(1, e);
  }
  /**
  Move to the next node in a last-to-first pre-order traveral. A
  node is followed by its last child or, if it has none, its
  previous sibling or the previous sibling of the first parent
  node that has one.
  */
  prev(e = !0) {
    return this.move(-1, e);
  }
  /**
  Move the cursor to the innermost node that covers `pos`. If
  `side` is -1, it will enter nodes that end at `pos`. If it is 1,
  it will enter nodes that start at `pos`.
  */
  moveTo(e, t = 0) {
    for (; (this.from == this.to || (t < 1 ? this.from >= e : this.from > e) || (t > -1 ? this.to <= e : this.to < e)) && this.parent(); )
      ;
    for (; this.enterChild(1, e, t); )
      ;
    return this;
  }
  /**
  Get a [syntax node](#common.SyntaxNode) at the cursor's current
  position.
  */
  get node() {
    if (!this.buffer)
      return this._tree;
    let e = this.bufferNode, t = null, i = 0;
    if (e && e.context == this.buffer)
      e:
        for (let r = this.index, s = this.stack.length; s >= 0; ) {
          for (let o = e; o; o = o._parent)
            if (o.index == r) {
              if (r == this.index)
                return o;
              t = o, i = s + 1;
              break e;
            }
          r = this.stack[--s];
        }
    for (let r = i; r < this.stack.length; r++)
      t = new an(this.buffer, t, this.stack[r]);
    return this.bufferNode = new an(this.buffer, t, this.index);
  }
  /**
  Get the [tree](#common.Tree) that represents the current node, if
  any. Will return null when the node is in a [tree
  buffer](#common.TreeBuffer).
  */
  get tree() {
    return this.buffer ? null : this._tree._tree;
  }
  /**
  Iterate over the current node and all its descendants, calling
  `enter` when entering a node and `leave`, if given, when leaving
  one. When `enter` returns `false`, any children of that node are
  skipped, and `leave` isn't called for it.
  */
  iterate(e, t) {
    for (let i = 0; ; ) {
      let r = !1;
      if (this.type.isAnonymous || e(this) !== !1) {
        if (this.firstChild()) {
          i++;
          continue;
        }
        this.type.isAnonymous || (r = !0);
      }
      for (; r && t && t(this), r = this.type.isAnonymous, !this.nextSibling(); ) {
        if (!i)
          return;
        this.parent(), i--, r = !0;
      }
    }
  }
  /**
  Test whether the current node matches a given context—a sequence
  of direct parent node names. Empty strings in the context array
  are treated as wildcards.
  */
  matchContext(e) {
    if (!this.buffer)
      return ec(this.node, e);
    let { buffer: t } = this.buffer, { types: i } = t.set;
    for (let r = e.length - 1, s = this.stack.length - 1; r >= 0; s--) {
      if (s < 0)
        return ec(this.node, e, r);
      let o = i[t.buffer[this.stack[s]]];
      if (!o.isAnonymous) {
        if (e[r] && e[r] != o.name)
          return !1;
        r--;
      }
    }
    return !0;
  }
}
function fh(n) {
  return n.children.some((e) => e instanceof Jn || !e.type.isAnonymous || fh(e));
}
function RS(n) {
  var e;
  let { buffer: t, nodeSet: i, maxBufferLength: r = YO, reused: s = [], minRepeatType: o = i.types.length } = n, a = Array.isArray(t) ? new hh(t, t.length) : t, l = i.types, u = 0, c = 0;
  function h(v, k, C, I, z, P) {
    let { id: R, start: A, end: j, size: U } = a, E = c;
    for (; U < 0; )
      if (a.next(), U == -1) {
        let y = s[R];
        C.push(y), I.push(A - v);
        return;
      } else if (U == -3) {
        u = R;
        return;
      } else if (U == -4) {
        c = R;
        return;
      } else
        throw new RangeError(`Unrecognized record size: ${U}`);
    let B = l[R], H, K, re = A - v;
    if (j - A <= r && (K = O(a.pos - k, z))) {
      let y = new Uint16Array(K.size - K.skip), ne = a.pos - K.size, Qe = y.length;
      for (; a.pos > ne; )
        Qe = m(K.start, y, Qe);
      H = new Jn(y, j - K.start, i), re = K.start - v;
    } else {
      let y = a.pos - U;
      a.next();
      let ne = [], Qe = [], S = R >= o ? R : -1, Ee = 0, Je = j;
      for (; a.pos > y; )
        S >= 0 && a.id == S && a.size >= 0 ? (a.end <= Je - r && (p(ne, Qe, A, Ee, a.end, Je, S, E), Ee = ne.length, Je = a.end), a.next()) : P > 2500 ? f(A, y, ne, Qe) : h(A, y, ne, Qe, S, P + 1);
      if (S >= 0 && Ee > 0 && Ee < ne.length && p(ne, Qe, A, Ee, A, Je, S, E), ne.reverse(), Qe.reverse(), S > -1 && Ee > 0) {
        let Me = d(B);
        H = dh(B, ne, Qe, 0, ne.length, 0, j - A, Me, Me);
      } else
        H = g(B, ne, Qe, j - A, E - j);
    }
    C.push(H), I.push(re);
  }
  function f(v, k, C, I) {
    let z = [], P = 0, R = -1;
    for (; a.pos > k; ) {
      let { id: A, start: j, end: U, size: E } = a;
      if (E > 4)
        a.next();
      else {
        if (R > -1 && j < R)
          break;
        R < 0 && (R = U - r), z.push(A, j, U), P++, a.next();
      }
    }
    if (P) {
      let A = new Uint16Array(P * 4), j = z[z.length - 2];
      for (let U = z.length - 3, E = 0; U >= 0; U -= 3)
        A[E++] = z[U], A[E++] = z[U + 1] - j, A[E++] = z[U + 2] - j, A[E++] = E;
      C.push(new Jn(A, z[2] - j, i)), I.push(j - v);
    }
  }
  function d(v) {
    return (k, C, I) => {
      let z = 0, P = k.length - 1, R, A;
      if (P >= 0 && (R = k[P]) instanceof ge) {
        if (!P && R.type == v && R.length == I)
          return R;
        (A = R.prop(J.lookAhead)) && (z = C[P] + R.length + A);
      }
      return g(v, k, C, I, z);
    };
  }
  function p(v, k, C, I, z, P, R, A) {
    let j = [], U = [];
    for (; v.length > I; )
      j.push(v.pop()), U.push(k.pop() + C - z);
    v.push(g(i.types[R], j, U, P - z, A - P)), k.push(z - C);
  }
  function g(v, k, C, I, z = 0, P) {
    if (u) {
      let R = [J.contextHash, u];
      P = P ? [R].concat(P) : [R];
    }
    if (z > 25) {
      let R = [J.lookAhead, z];
      P = P ? [R].concat(P) : [R];
    }
    return new ge(v, k, C, I, P);
  }
  function O(v, k) {
    let C = a.fork(), I = 0, z = 0, P = 0, R = C.end - r, A = { size: 0, start: 0, skip: 0 };
    e:
      for (let j = C.pos - v; C.pos > j; ) {
        let U = C.size;
        if (C.id == k && U >= 0) {
          A.size = I, A.start = z, A.skip = P, P += 4, I += 4, C.next();
          continue;
        }
        let E = C.pos - U;
        if (U < 0 || E < j || C.start < R)
          break;
        let B = C.id >= o ? 4 : 0, H = C.start;
        for (C.next(); C.pos > E; ) {
          if (C.size < 0)
            if (C.size == -3)
              B += 4;
            else
              break e;
          else
            C.id >= o && (B += 4);
          C.next();
        }
        z = H, I += U, P += B;
      }
    return (k < 0 || I == v) && (A.size = I, A.start = z, A.skip = P), A.size > 4 ? A : void 0;
  }
  function m(v, k, C) {
    let { id: I, start: z, end: P, size: R } = a;
    if (a.next(), R >= 0 && I < o) {
      let A = C;
      if (R > 4) {
        let j = a.pos - (R - 4);
        for (; a.pos > j; )
          C = m(v, k, C);
      }
      k[--C] = A, k[--C] = P - v, k[--C] = z - v, k[--C] = I;
    } else
      R == -3 ? u = I : R == -4 && (c = I);
    return C;
  }
  let b = [], w = [];
  for (; a.pos > 0; )
    h(n.start || 0, n.bufferStart || 0, b, w, -1, 0);
  let Q = (e = n.length) !== null && e !== void 0 ? e : b.length ? w[0] + b[0].length : 0;
  return new ge(l[n.topID], b.reverse(), w.reverse(), Q);
}
const Ad = /* @__PURE__ */ new WeakMap();
function Vo(n, e) {
  if (!n.isAnonymous || e instanceof Jn || e.type != n)
    return 1;
  let t = Ad.get(e);
  if (t == null) {
    t = 1;
    for (let i of e.children) {
      if (i.type != n || !(i instanceof ge)) {
        t = 1;
        break;
      }
      t += Vo(n, i);
    }
    Ad.set(e, t);
  }
  return t;
}
function dh(n, e, t, i, r, s, o, a, l) {
  let u = 0;
  for (let p = i; p < r; p++)
    u += Vo(n, e[p]);
  let c = Math.ceil(
    u * 1.5 / 8
    /* Balance.BranchFactor */
  ), h = [], f = [];
  function d(p, g, O, m, b) {
    for (let w = O; w < m; ) {
      let Q = w, v = g[w], k = Vo(n, p[w]);
      for (w++; w < m; w++) {
        let C = Vo(n, p[w]);
        if (k + C >= c)
          break;
        k += C;
      }
      if (w == Q + 1) {
        if (k > c) {
          let C = p[Q];
          d(C.children, C.positions, 0, C.children.length, g[Q] + b);
          continue;
        }
        h.push(p[Q]);
      } else {
        let C = g[w - 1] + p[w - 1].length - v;
        h.push(dh(n, p, g, Q, w, v, C, null, l));
      }
      f.push(v + b - s);
    }
  }
  return d(e, t, i, r, 0), (a || l)(h, f, o);
}
class GO {
  constructor() {
    this.map = /* @__PURE__ */ new WeakMap();
  }
  setBuffer(e, t, i) {
    let r = this.map.get(e);
    r || this.map.set(e, r = /* @__PURE__ */ new Map()), r.set(t, i);
  }
  getBuffer(e, t) {
    let i = this.map.get(e);
    return i && i.get(t);
  }
  /**
  Set the value for this syntax node.
  */
  set(e, t) {
    e instanceof an ? this.setBuffer(e.context.buffer, e.index, t) : e instanceof it && this.map.set(e.tree, t);
  }
  /**
  Retrieve value for this syntax node, if it exists in the map.
  */
  get(e) {
    return e instanceof an ? this.getBuffer(e.context.buffer, e.index) : e instanceof it ? this.map.get(e.tree) : void 0;
  }
  /**
  Set the value for the node that a cursor currently points to.
  */
  cursorSet(e, t) {
    e.buffer ? this.setBuffer(e.buffer.buffer, e.index, t) : this.map.set(e.tree, t);
  }
  /**
  Retrieve the value for the node that a cursor currently points
  to.
  */
  cursorGet(e) {
    return e.buffer ? this.getBuffer(e.buffer.buffer, e.index) : this.map.get(e.tree);
  }
}
class Pn {
  /**
  Construct a tree fragment. You'll usually want to use
  [`addTree`](#common.TreeFragment^addTree) and
  [`applyChanges`](#common.TreeFragment^applyChanges) instead of
  calling this directly.
  */
  constructor(e, t, i, r, s = !1, o = !1) {
    this.from = e, this.to = t, this.tree = i, this.offset = r, this.open = (s ? 1 : 0) | (o ? 2 : 0);
  }
  /**
  Whether the start of the fragment represents the start of a
  parse, or the end of a change. (In the second case, it may not
  be safe to reuse some nodes at the start, depending on the
  parsing algorithm.)
  */
  get openStart() {
    return (this.open & 1) > 0;
  }
  /**
  Whether the end of the fragment represents the end of a
  full-document parse, or the start of a change.
  */
  get openEnd() {
    return (this.open & 2) > 0;
  }
  /**
  Create a set of fragments from a freshly parsed tree, or update
  an existing set of fragments by replacing the ones that overlap
  with a tree with content from the new tree. When `partial` is
  true, the parse is treated as incomplete, and the resulting
  fragment has [`openEnd`](#common.TreeFragment.openEnd) set to
  true.
  */
  static addTree(e, t = [], i = !1) {
    let r = [new Pn(0, e.length, e, 0, !1, i)];
    for (let s of t)
      s.to > e.length && r.push(s);
    return r;
  }
  /**
  Apply a set of edits to an array of fragments, removing or
  splitting fragments as necessary to remove edited ranges, and
  adjusting offsets for fragments that moved.
  */
  static applyChanges(e, t, i = 128) {
    if (!t.length)
      return e;
    let r = [], s = 1, o = e.length ? e[0] : null;
    for (let a = 0, l = 0, u = 0; ; a++) {
      let c = a < t.length ? t[a] : null, h = c ? c.fromA : 1e9;
      if (h - l >= i)
        for (; o && o.from < h; ) {
          let f = o;
          if (l >= f.from || h <= f.to || u) {
            let d = Math.max(f.from, l) - u, p = Math.min(f.to, h) - u;
            f = d >= p ? null : new Pn(d, p, f.tree, f.offset + u, a > 0, !!c);
          }
          if (f && r.push(f), o.to > h)
            break;
          o = s < e.length ? e[s++] : null;
        }
      if (!c)
        break;
      l = c.toA, u = c.toA - c.toB;
    }
    return r;
  }
}
class ph {
  /**
  Start a parse, returning a [partial parse](#common.PartialParse)
  object. [`fragments`](#common.TreeFragment) can be passed in to
  make the parse incremental.
  
  By default, the entire input is parsed. You can pass `ranges`,
  which should be a sorted array of non-empty, non-overlapping
  ranges, to parse only those ranges. The tree returned in that
  case will start at `ranges[0].from`.
  */
  startParse(e, t, i) {
    return typeof e == "string" && (e = new MS(e)), i = i ? i.length ? i.map((r) => new Mt(r.from, r.to)) : [new Mt(0, 0)] : [new Mt(0, e.length)], this.createParse(e, t || [], i);
  }
  /**
  Run a full parse, returning the resulting tree.
  */
  parse(e, t, i) {
    let r = this.startParse(e, t, i);
    for (; ; ) {
      let s = r.advance();
      if (s)
        return s;
    }
  }
}
class MS {
  constructor(e) {
    this.string = e;
  }
  get length() {
    return this.string.length;
  }
  chunk(e) {
    return this.string.slice(e);
  }
  get lineChunks() {
    return !1;
  }
  read(e, t) {
    return this.string.slice(e, t);
  }
}
function HO(n) {
  return (e, t, i, r) => new ES(e, n, t, i, r);
}
class Rd {
  constructor(e, t, i, r, s) {
    this.parser = e, this.parse = t, this.overlay = i, this.target = r, this.from = s;
  }
}
function Md(n) {
  if (!n.length || n.some((e) => e.from >= e.to))
    throw new RangeError("Invalid inner parse ranges given: " + JSON.stringify(n));
}
class ZS {
  constructor(e, t, i, r, s, o, a) {
    this.parser = e, this.predicate = t, this.mounts = i, this.index = r, this.start = s, this.target = o, this.prev = a, this.depth = 0, this.ranges = [];
  }
}
const tc = new J({ perNode: !0 });
class ES {
  constructor(e, t, i, r, s) {
    this.nest = t, this.input = i, this.fragments = r, this.ranges = s, this.inner = [], this.innerDone = 0, this.baseTree = null, this.stoppedAt = null, this.baseParse = e;
  }
  advance() {
    if (this.baseParse) {
      let i = this.baseParse.advance();
      if (!i)
        return null;
      if (this.baseParse = null, this.baseTree = i, this.startInner(), this.stoppedAt != null)
        for (let r of this.inner)
          r.parse.stopAt(this.stoppedAt);
    }
    if (this.innerDone == this.inner.length) {
      let i = this.baseTree;
      return this.stoppedAt != null && (i = new ge(i.type, i.children, i.positions, i.length, i.propValues.concat([[tc, this.stoppedAt]]))), i;
    }
    let e = this.inner[this.innerDone], t = e.parse.advance();
    if (t) {
      this.innerDone++;
      let i = Object.assign(/* @__PURE__ */ Object.create(null), e.target.props);
      i[J.mounted.id] = new cs(t, e.overlay, e.parser), e.target.props = i;
    }
    return null;
  }
  get parsedPos() {
    if (this.baseParse)
      return 0;
    let e = this.input.length;
    for (let t = this.innerDone; t < this.inner.length; t++)
      this.inner[t].from < e && (e = Math.min(e, this.inner[t].parse.parsedPos));
    return e;
  }
  stopAt(e) {
    if (this.stoppedAt = e, this.baseParse)
      this.baseParse.stopAt(e);
    else
      for (let t = this.innerDone; t < this.inner.length; t++)
        this.inner[t].parse.stopAt(e);
  }
  startInner() {
    let e = new IS(this.fragments), t = null, i = null, r = new la(new it(this.baseTree, this.ranges[0].from, 0, null), ve.IncludeAnonymous | ve.IgnoreMounts);
    e:
      for (let s, o; ; ) {
        let a = !0, l;
        if (this.stoppedAt != null && r.from >= this.stoppedAt)
          a = !1;
        else if (e.hasNode(r)) {
          if (t) {
            let u = t.mounts.find((c) => c.frag.from <= r.from && c.frag.to >= r.to && c.mount.overlay);
            if (u)
              for (let c of u.mount.overlay) {
                let h = c.from + u.pos, f = c.to + u.pos;
                h >= r.from && f <= r.to && !t.ranges.some((d) => d.from < f && d.to > h) && t.ranges.push({ from: h, to: f });
              }
          }
          a = !1;
        } else if (i && (o = zS(i.ranges, r.from, r.to)))
          a = o != 2;
        else if (!r.type.isAnonymous && (s = this.nest(r, this.input)) && (r.from < r.to || !s.overlay)) {
          r.tree || DS(r);
          let u = e.findMounts(r.from, s.parser);
          if (typeof s.overlay == "function")
            t = new ZS(s.parser, s.overlay, u, this.inner.length, r.from, r.tree, t);
          else {
            let c = zd(this.ranges, s.overlay || (r.from < r.to ? [new Mt(r.from, r.to)] : []));
            c.length && Md(c), (c.length || !s.overlay) && this.inner.push(new Rd(s.parser, c.length ? s.parser.startParse(this.input, Dd(u, c), c) : s.parser.startParse(""), s.overlay ? s.overlay.map((h) => new Mt(h.from - r.from, h.to - r.from)) : null, r.tree, c.length ? c[0].from : r.from)), s.overlay ? c.length && (i = { ranges: c, depth: 0, prev: i }) : a = !1;
          }
        } else
          t && (l = t.predicate(r)) && (l === !0 && (l = new Mt(r.from, r.to)), l.from < l.to && t.ranges.push(l));
        if (a && r.firstChild())
          t && t.depth++, i && i.depth++;
        else
          for (; !r.nextSibling(); ) {
            if (!r.parent())
              break e;
            if (t && !--t.depth) {
              let u = zd(this.ranges, t.ranges);
              u.length && (Md(u), this.inner.splice(t.index, 0, new Rd(t.parser, t.parser.startParse(this.input, Dd(t.mounts, u), u), t.ranges.map((c) => new Mt(c.from - t.start, c.to - t.start)), t.target, u[0].from))), t = t.prev;
            }
            i && !--i.depth && (i = i.prev);
          }
      }
  }
}
function zS(n, e, t) {
  for (let i of n) {
    if (i.from >= t)
      break;
    if (i.to > e)
      return i.from <= e && i.to >= t ? 2 : 1;
  }
  return 0;
}
function Zd(n, e, t, i, r, s) {
  if (e < t) {
    let o = n.buffer[e + 1];
    i.push(n.slice(e, t, o)), r.push(o - s);
  }
}
function DS(n) {
  let { node: e } = n, t = [], i = e.context.buffer;
  do
    t.push(n.index), n.parent();
  while (!n.tree);
  let r = n.tree, s = r.children.indexOf(i), o = r.children[s], a = o.buffer, l = [s];
  function u(c, h, f, d, p, g) {
    let O = t[g], m = [], b = [];
    Zd(o, c, O, m, b, d);
    let w = a[O + 1], Q = a[O + 2];
    l.push(m.length);
    let v = g ? u(O + 4, a[O + 3], o.set.types[a[O]], w, Q - w, g - 1) : e.toTree();
    return m.push(v), b.push(w - d), Zd(o, a[O + 3], h, m, b, d), new ge(f, m, b, p);
  }
  r.children[s] = u(0, a.length, qe.none, 0, o.length, t.length - 1);
  for (let c of l) {
    let h = n.tree.children[c], f = n.tree.positions[c];
    n.yield(new it(h, f + n.from, c, n._tree));
  }
}
class Ed {
  constructor(e, t) {
    this.offset = t, this.done = !1, this.cursor = e.cursor(ve.IncludeAnonymous | ve.IgnoreMounts);
  }
  // Move to the first node (in pre-order) that starts at or after `pos`.
  moveTo(e) {
    let { cursor: t } = this, i = e - this.offset;
    for (; !this.done && t.from < i; )
      t.to >= e && t.enter(i, 1, ve.IgnoreOverlays | ve.ExcludeBuffers) || t.next(!1) || (this.done = !0);
  }
  hasNode(e) {
    if (this.moveTo(e.from), !this.done && this.cursor.from + this.offset == e.from && this.cursor.tree)
      for (let t = this.cursor.tree; ; ) {
        if (t == e.tree)
          return !0;
        if (t.children.length && t.positions[0] == 0 && t.children[0] instanceof ge)
          t = t.children[0];
        else
          break;
      }
    return !1;
  }
}
let IS = class {
  constructor(e) {
    var t;
    if (this.fragments = e, this.curTo = 0, this.fragI = 0, e.length) {
      let i = this.curFrag = e[0];
      this.curTo = (t = i.tree.prop(tc)) !== null && t !== void 0 ? t : i.to, this.inner = new Ed(i.tree, -i.offset);
    } else
      this.curFrag = this.inner = null;
  }
  hasNode(e) {
    for (; this.curFrag && e.from >= this.curTo; )
      this.nextFrag();
    return this.curFrag && this.curFrag.from <= e.from && this.curTo >= e.to && this.inner.hasNode(e);
  }
  nextFrag() {
    var e;
    if (this.fragI++, this.fragI == this.fragments.length)
      this.curFrag = this.inner = null;
    else {
      let t = this.curFrag = this.fragments[this.fragI];
      this.curTo = (e = t.tree.prop(tc)) !== null && e !== void 0 ? e : t.to, this.inner = new Ed(t.tree, -t.offset);
    }
  }
  findMounts(e, t) {
    var i;
    let r = [];
    if (this.inner) {
      this.inner.cursor.moveTo(e, 1);
      for (let s = this.inner.cursor.node; s; s = s.parent) {
        let o = (i = s.tree) === null || i === void 0 ? void 0 : i.prop(J.mounted);
        if (o && o.parser == t)
          for (let a = this.fragI; a < this.fragments.length; a++) {
            let l = this.fragments[a];
            if (l.from >= s.to)
              break;
            l.tree == this.curFrag.tree && r.push({
              frag: l,
              pos: s.from - l.offset,
              mount: o
            });
          }
      }
    }
    return r;
  }
};
function zd(n, e) {
  let t = null, i = e;
  for (let r = 1, s = 0; r < n.length; r++) {
    let o = n[r - 1].to, a = n[r].from;
    for (; s < i.length; s++) {
      let l = i[s];
      if (l.from >= a)
        break;
      l.to <= o || (t || (i = t = e.slice()), l.from < o ? (t[s] = new Mt(l.from, o), l.to > a && t.splice(s + 1, 0, new Mt(a, l.to))) : l.to > a ? t[s--] = new Mt(a, l.to) : t.splice(s--, 1));
    }
  }
  return i;
}
function LS(n, e, t, i) {
  let r = 0, s = 0, o = !1, a = !1, l = -1e9, u = [];
  for (; ; ) {
    let c = r == n.length ? 1e9 : o ? n[r].to : n[r].from, h = s == e.length ? 1e9 : a ? e[s].to : e[s].from;
    if (o != a) {
      let f = Math.max(l, t), d = Math.min(c, h, i);
      f < d && u.push(new Mt(f, d));
    }
    if (l = Math.min(c, h), l == 1e9)
      break;
    c == l && (o ? (o = !1, r++) : o = !0), h == l && (a ? (a = !1, s++) : a = !0);
  }
  return u;
}
function Dd(n, e) {
  let t = [];
  for (let { pos: i, mount: r, frag: s } of n) {
    let o = i + (r.overlay ? r.overlay[0].from : 0), a = o + r.tree.length, l = Math.max(s.from, o), u = Math.min(s.to, a);
    if (r.overlay) {
      let c = r.overlay.map((f) => new Mt(f.from + i, f.to + i)), h = LS(e, c, l, u);
      for (let f = 0, d = l; ; f++) {
        let p = f == h.length, g = p ? u : h[f].from;
        if (g > d && t.push(new Pn(d, g, r.tree, -o, s.from >= d || s.openStart, s.to <= g || s.openEnd)), p)
          break;
        d = h[f].to;
      }
    } else
      t.push(new Pn(l, u, r.tree, -o, s.from >= o || s.openStart, s.to <= a || s.openEnd));
  }
  return t;
}
let _S = 0;
class Wt {
  /**
  @internal
  */
  constructor(e, t, i) {
    this.set = e, this.base = t, this.modified = i, this.id = _S++;
  }
  /**
  Define a new tag. If `parent` is given, the tag is treated as a
  sub-tag of that parent, and
  [highlighters](#highlight.tagHighlighter) that don't mention
  this tag will try to fall back to the parent tag (or grandparent
  tag, etc).
  */
  static define(e) {
    if (e != null && e.base)
      throw new Error("Can not derive from a modified tag");
    let t = new Wt([], null, []);
    if (t.set.push(t), e)
      for (let i of e.set)
        t.set.push(i);
    return t;
  }
  /**
  Define a tag _modifier_, which is a function that, given a tag,
  will return a tag that is a subtag of the original. Applying the
  same modifier to a twice tag will return the same value (`m1(t1)
  == m1(t1)`) and applying multiple modifiers will, regardless or
  order, produce the same tag (`m1(m2(t1)) == m2(m1(t1))`).
  
  When multiple modifiers are applied to a given base tag, each
  smaller set of modifiers is registered as a parent, so that for
  example `m1(m2(m3(t1)))` is a subtype of `m1(m2(t1))`,
  `m1(m3(t1)`, and so on.
  */
  static defineModifier() {
    let e = new ua();
    return (t) => t.modified.indexOf(e) > -1 ? t : ua.get(t.base || t, t.modified.concat(e).sort((i, r) => i.id - r.id));
  }
}
let XS = 0;
class ua {
  constructor() {
    this.instances = [], this.id = XS++;
  }
  static get(e, t) {
    if (!t.length)
      return e;
    let i = t[0].instances.find((a) => a.base == e && NS(t, a.modified));
    if (i)
      return i;
    let r = [], s = new Wt(r, e, t);
    for (let a of t)
      a.instances.push(s);
    let o = WS(t);
    for (let a of e.set)
      if (!a.modified.length)
        for (let l of o)
          r.push(ua.get(a, l));
    return s;
  }
}
function NS(n, e) {
  return n.length == e.length && n.every((t, i) => t == e[i]);
}
function WS(n) {
  let e = [[]];
  for (let t = 0; t < n.length; t++)
    for (let i = 0, r = e.length; i < r; i++)
      e.push(e[i].concat(n[t]));
  return e.sort((t, i) => i.length - t.length);
}
function pr(n) {
  let e = /* @__PURE__ */ Object.create(null);
  for (let t in n) {
    let i = n[t];
    Array.isArray(i) || (i = [i]);
    for (let r of t.split(" "))
      if (r) {
        let s = [], o = 2, a = r;
        for (let h = 0; ; ) {
          if (a == "..." && h > 0 && h + 3 == r.length) {
            o = 1;
            break;
          }
          let f = /^"(?:[^"\\]|\\.)*?"|[^\/!]+/.exec(a);
          if (!f)
            throw new RangeError("Invalid path: " + r);
          if (s.push(f[0] == "*" ? "" : f[0][0] == '"' ? JSON.parse(f[0]) : f[0]), h += f[0].length, h == r.length)
            break;
          let d = r[h++];
          if (h == r.length && d == "!") {
            o = 0;
            break;
          }
          if (d != "/")
            throw new RangeError("Invalid path: " + r);
          a = r.slice(h);
        }
        let l = s.length - 1, u = s[l];
        if (!u)
          throw new RangeError("Invalid path: " + r);
        let c = new ca(i, o, l > 0 ? s.slice(0, l) : null);
        e[u] = c.sort(e[u]);
      }
  }
  return KO.add(e);
}
const KO = new J();
class ca {
  constructor(e, t, i, r) {
    this.tags = e, this.mode = t, this.context = i, this.next = r;
  }
  get opaque() {
    return this.mode == 0;
  }
  get inherit() {
    return this.mode == 1;
  }
  sort(e) {
    return !e || e.depth < this.depth ? (this.next = e, this) : (e.next = this.sort(e.next), e);
  }
  get depth() {
    return this.context ? this.context.length : 0;
  }
}
ca.empty = new ca([], 2, null);
function JO(n, e) {
  let t = /* @__PURE__ */ Object.create(null);
  for (let s of n)
    if (!Array.isArray(s.tag))
      t[s.tag.id] = s.class;
    else
      for (let o of s.tag)
        t[o.id] = s.class;
  let { scope: i, all: r = null } = e || {};
  return {
    style: (s) => {
      let o = r;
      for (let a of s)
        for (let l of a.set) {
          let u = t[l.id];
          if (u) {
            o = o ? o + " " + u : u;
            break;
          }
        }
      return o;
    },
    scope: i
  };
}
function qS(n, e) {
  let t = null;
  for (let i of n) {
    let r = i.style(e);
    r && (t = t ? t + " " + r : r);
  }
  return t;
}
function BS(n, e, t, i = 0, r = n.length) {
  let s = new VS(i, Array.isArray(e) ? e : [e], t);
  s.highlightRange(n.cursor(), i, r, "", s.highlighters), s.flush(r);
}
class VS {
  constructor(e, t, i) {
    this.at = e, this.highlighters = t, this.span = i, this.class = "";
  }
  startSpan(e, t) {
    t != this.class && (this.flush(e), e > this.at && (this.at = e), this.class = t);
  }
  flush(e) {
    e > this.at && this.class && this.span(this.at, e, this.class);
  }
  highlightRange(e, t, i, r, s) {
    let { type: o, from: a, to: l } = e;
    if (a >= i || l <= t)
      return;
    o.isTop && (s = this.highlighters.filter((d) => !d.scope || d.scope(o)));
    let u = r, c = YS(e) || ca.empty, h = qS(s, c.tags);
    if (h && (u && (u += " "), u += h, c.mode == 1 && (r += (r ? " " : "") + h)), this.startSpan(Math.max(t, a), u), c.opaque)
      return;
    let f = e.tree && e.tree.prop(J.mounted);
    if (f && f.overlay) {
      let d = e.node.enter(f.overlay[0].from + a, 1), p = this.highlighters.filter((O) => !O.scope || O.scope(f.tree.type)), g = e.firstChild();
      for (let O = 0, m = a; ; O++) {
        let b = O < f.overlay.length ? f.overlay[O] : null, w = b ? b.from + a : l, Q = Math.max(t, m), v = Math.min(i, w);
        if (Q < v && g)
          for (; e.from < v && (this.highlightRange(e, Q, v, r, s), this.startSpan(Math.min(v, e.to), u), !(e.to >= w || !e.nextSibling())); )
            ;
        if (!b || w > i)
          break;
        m = b.to + a, m > t && (this.highlightRange(d.cursor(), Math.max(t, b.from + a), Math.min(i, m), "", p), this.startSpan(Math.min(i, m), u));
      }
      g && e.parent();
    } else if (e.firstChild()) {
      f && (r = "");
      do
        if (!(e.to <= t)) {
          if (e.from >= i)
            break;
          this.highlightRange(e, t, i, r, s), this.startSpan(Math.min(i, e.to), u);
        }
      while (e.nextSibling());
      e.parent();
    }
  }
}
function YS(n) {
  let e = n.type.prop(KO);
  for (; e && e.context && !n.matchContext(e.context); )
    e = e.next;
  return e || null;
}
const L = Wt.define, uo = L(), Xn = L(), Id = L(Xn), Ld = L(Xn), Nn = L(), co = L(Nn), Ql = L(Nn), nn = L(), ai = L(nn), en = L(), tn = L(), nc = L(), Tr = L(nc), ho = L(), x = {
  /**
  A comment.
  */
  comment: uo,
  /**
  A line [comment](#highlight.tags.comment).
  */
  lineComment: L(uo),
  /**
  A block [comment](#highlight.tags.comment).
  */
  blockComment: L(uo),
  /**
  A documentation [comment](#highlight.tags.comment).
  */
  docComment: L(uo),
  /**
  Any kind of identifier.
  */
  name: Xn,
  /**
  The [name](#highlight.tags.name) of a variable.
  */
  variableName: L(Xn),
  /**
  A type [name](#highlight.tags.name).
  */
  typeName: Id,
  /**
  A tag name (subtag of [`typeName`](#highlight.tags.typeName)).
  */
  tagName: L(Id),
  /**
  A property or field [name](#highlight.tags.name).
  */
  propertyName: Ld,
  /**
  An attribute name (subtag of [`propertyName`](#highlight.tags.propertyName)).
  */
  attributeName: L(Ld),
  /**
  The [name](#highlight.tags.name) of a class.
  */
  className: L(Xn),
  /**
  A label [name](#highlight.tags.name).
  */
  labelName: L(Xn),
  /**
  A namespace [name](#highlight.tags.name).
  */
  namespace: L(Xn),
  /**
  The [name](#highlight.tags.name) of a macro.
  */
  macroName: L(Xn),
  /**
  A literal value.
  */
  literal: Nn,
  /**
  A string [literal](#highlight.tags.literal).
  */
  string: co,
  /**
  A documentation [string](#highlight.tags.string).
  */
  docString: L(co),
  /**
  A character literal (subtag of [string](#highlight.tags.string)).
  */
  character: L(co),
  /**
  An attribute value (subtag of [string](#highlight.tags.string)).
  */
  attributeValue: L(co),
  /**
  A number [literal](#highlight.tags.literal).
  */
  number: Ql,
  /**
  An integer [number](#highlight.tags.number) literal.
  */
  integer: L(Ql),
  /**
  A floating-point [number](#highlight.tags.number) literal.
  */
  float: L(Ql),
  /**
  A boolean [literal](#highlight.tags.literal).
  */
  bool: L(Nn),
  /**
  Regular expression [literal](#highlight.tags.literal).
  */
  regexp: L(Nn),
  /**
  An escape [literal](#highlight.tags.literal), for example a
  backslash escape in a string.
  */
  escape: L(Nn),
  /**
  A color [literal](#highlight.tags.literal).
  */
  color: L(Nn),
  /**
  A URL [literal](#highlight.tags.literal).
  */
  url: L(Nn),
  /**
  A language keyword.
  */
  keyword: en,
  /**
  The [keyword](#highlight.tags.keyword) for the self or this
  object.
  */
  self: L(en),
  /**
  The [keyword](#highlight.tags.keyword) for null.
  */
  null: L(en),
  /**
  A [keyword](#highlight.tags.keyword) denoting some atomic value.
  */
  atom: L(en),
  /**
  A [keyword](#highlight.tags.keyword) that represents a unit.
  */
  unit: L(en),
  /**
  A modifier [keyword](#highlight.tags.keyword).
  */
  modifier: L(en),
  /**
  A [keyword](#highlight.tags.keyword) that acts as an operator.
  */
  operatorKeyword: L(en),
  /**
  A control-flow related [keyword](#highlight.tags.keyword).
  */
  controlKeyword: L(en),
  /**
  A [keyword](#highlight.tags.keyword) that defines something.
  */
  definitionKeyword: L(en),
  /**
  A [keyword](#highlight.tags.keyword) related to defining or
  interfacing with modules.
  */
  moduleKeyword: L(en),
  /**
  An operator.
  */
  operator: tn,
  /**
  An [operator](#highlight.tags.operator) that dereferences something.
  */
  derefOperator: L(tn),
  /**
  Arithmetic-related [operator](#highlight.tags.operator).
  */
  arithmeticOperator: L(tn),
  /**
  Logical [operator](#highlight.tags.operator).
  */
  logicOperator: L(tn),
  /**
  Bit [operator](#highlight.tags.operator).
  */
  bitwiseOperator: L(tn),
  /**
  Comparison [operator](#highlight.tags.operator).
  */
  compareOperator: L(tn),
  /**
  [Operator](#highlight.tags.operator) that updates its operand.
  */
  updateOperator: L(tn),
  /**
  [Operator](#highlight.tags.operator) that defines something.
  */
  definitionOperator: L(tn),
  /**
  Type-related [operator](#highlight.tags.operator).
  */
  typeOperator: L(tn),
  /**
  Control-flow [operator](#highlight.tags.operator).
  */
  controlOperator: L(tn),
  /**
  Program or markup punctuation.
  */
  punctuation: nc,
  /**
  [Punctuation](#highlight.tags.punctuation) that separates
  things.
  */
  separator: L(nc),
  /**
  Bracket-style [punctuation](#highlight.tags.punctuation).
  */
  bracket: Tr,
  /**
  Angle [brackets](#highlight.tags.bracket) (usually `<` and `>`
  tokens).
  */
  angleBracket: L(Tr),
  /**
  Square [brackets](#highlight.tags.bracket) (usually `[` and `]`
  tokens).
  */
  squareBracket: L(Tr),
  /**
  Parentheses (usually `(` and `)` tokens). Subtag of
  [bracket](#highlight.tags.bracket).
  */
  paren: L(Tr),
  /**
  Braces (usually `{` and `}` tokens). Subtag of
  [bracket](#highlight.tags.bracket).
  */
  brace: L(Tr),
  /**
  Content, for example plain text in XML or markup documents.
  */
  content: nn,
  /**
  [Content](#highlight.tags.content) that represents a heading.
  */
  heading: ai,
  /**
  A level 1 [heading](#highlight.tags.heading).
  */
  heading1: L(ai),
  /**
  A level 2 [heading](#highlight.tags.heading).
  */
  heading2: L(ai),
  /**
  A level 3 [heading](#highlight.tags.heading).
  */
  heading3: L(ai),
  /**
  A level 4 [heading](#highlight.tags.heading).
  */
  heading4: L(ai),
  /**
  A level 5 [heading](#highlight.tags.heading).
  */
  heading5: L(ai),
  /**
  A level 6 [heading](#highlight.tags.heading).
  */
  heading6: L(ai),
  /**
  A prose separator (such as a horizontal rule).
  */
  contentSeparator: L(nn),
  /**
  [Content](#highlight.tags.content) that represents a list.
  */
  list: L(nn),
  /**
  [Content](#highlight.tags.content) that represents a quote.
  */
  quote: L(nn),
  /**
  [Content](#highlight.tags.content) that is emphasized.
  */
  emphasis: L(nn),
  /**
  [Content](#highlight.tags.content) that is styled strong.
  */
  strong: L(nn),
  /**
  [Content](#highlight.tags.content) that is part of a link.
  */
  link: L(nn),
  /**
  [Content](#highlight.tags.content) that is styled as code or
  monospace.
  */
  monospace: L(nn),
  /**
  [Content](#highlight.tags.content) that has a strike-through
  style.
  */
  strikethrough: L(nn),
  /**
  Inserted text in a change-tracking format.
  */
  inserted: L(),
  /**
  Deleted text.
  */
  deleted: L(),
  /**
  Changed text.
  */
  changed: L(),
  /**
  An invalid or unsyntactic element.
  */
  invalid: L(),
  /**
  Metadata or meta-instruction.
  */
  meta: ho,
  /**
  [Metadata](#highlight.tags.meta) that applies to the entire
  document.
  */
  documentMeta: L(ho),
  /**
  [Metadata](#highlight.tags.meta) that annotates or adds
  attributes to a given syntactic element.
  */
  annotation: L(ho),
  /**
  Processing instruction or preprocessor directive. Subtag of
  [meta](#highlight.tags.meta).
  */
  processingInstruction: L(ho),
  /**
  [Modifier](#highlight.Tag^defineModifier) that indicates that a
  given element is being defined. Expected to be used with the
  various [name](#highlight.tags.name) tags.
  */
  definition: Wt.defineModifier(),
  /**
  [Modifier](#highlight.Tag^defineModifier) that indicates that
  something is constant. Mostly expected to be used with
  [variable names](#highlight.tags.variableName).
  */
  constant: Wt.defineModifier(),
  /**
  [Modifier](#highlight.Tag^defineModifier) used to indicate that
  a [variable](#highlight.tags.variableName) or [property
  name](#highlight.tags.propertyName) is being called or defined
  as a function.
  */
  function: Wt.defineModifier(),
  /**
  [Modifier](#highlight.Tag^defineModifier) that can be applied to
  [names](#highlight.tags.name) to indicate that they belong to
  the language's standard environment.
  */
  standard: Wt.defineModifier(),
  /**
  [Modifier](#highlight.Tag^defineModifier) that indicates a given
  [names](#highlight.tags.name) is local to some scope.
  */
  local: Wt.defineModifier(),
  /**
  A generic variant [modifier](#highlight.Tag^defineModifier) that
  can be used to tag language-specific alternative variants of
  some common tag. It is recommended for themes to define special
  forms of at least the [string](#highlight.tags.string) and
  [variable name](#highlight.tags.variableName) tags, since those
  come up a lot.
  */
  special: Wt.defineModifier()
};
JO([
  { tag: x.link, class: "tok-link" },
  { tag: x.heading, class: "tok-heading" },
  { tag: x.emphasis, class: "tok-emphasis" },
  { tag: x.strong, class: "tok-strong" },
  { tag: x.keyword, class: "tok-keyword" },
  { tag: x.atom, class: "tok-atom" },
  { tag: x.bool, class: "tok-bool" },
  { tag: x.url, class: "tok-url" },
  { tag: x.labelName, class: "tok-labelName" },
  { tag: x.inserted, class: "tok-inserted" },
  { tag: x.deleted, class: "tok-deleted" },
  { tag: x.literal, class: "tok-literal" },
  { tag: x.string, class: "tok-string" },
  { tag: x.number, class: "tok-number" },
  { tag: [x.regexp, x.escape, x.special(x.string)], class: "tok-string2" },
  { tag: x.variableName, class: "tok-variableName" },
  { tag: x.local(x.variableName), class: "tok-variableName tok-local" },
  { tag: x.definition(x.variableName), class: "tok-variableName tok-definition" },
  { tag: x.special(x.variableName), class: "tok-variableName2" },
  { tag: x.definition(x.propertyName), class: "tok-propertyName tok-definition" },
  { tag: x.typeName, class: "tok-typeName" },
  { tag: x.namespace, class: "tok-namespace" },
  { tag: x.className, class: "tok-className" },
  { tag: x.macroName, class: "tok-macroName" },
  { tag: x.propertyName, class: "tok-propertyName" },
  { tag: x.operator, class: "tok-operator" },
  { tag: x.comment, class: "tok-comment" },
  { tag: x.meta, class: "tok-meta" },
  { tag: x.invalid, class: "tok-invalid" },
  { tag: x.punctuation, class: "tok-punctuation" }
]);
var $l;
const gi = /* @__PURE__ */ new J();
function mh(n) {
  return N.define({
    combine: n ? (e) => e.concat(n) : void 0
  });
}
const gh = /* @__PURE__ */ new J();
class Zt {
  /**
  Construct a language object. If you need to invoke this
  directly, first define a data facet with
  [`defineLanguageFacet`](https://codemirror.net/6/docs/ref/#language.defineLanguageFacet), and then
  configure your parser to [attach](https://codemirror.net/6/docs/ref/#language.languageDataProp) it
  to the language's outer syntax node.
  */
  constructor(e, t, i = [], r = "") {
    this.data = e, this.name = r, se.prototype.hasOwnProperty("tree") || Object.defineProperty(se.prototype, "tree", { get() {
      return Pe(this);
    } }), this.parser = t, this.extension = [
      ei.of(this),
      se.languageData.of((s, o, a) => {
        let l = _d(s, o, a), u = l.type.prop(gi);
        if (!u)
          return [];
        let c = s.facet(u), h = l.type.prop(gh);
        if (h) {
          let f = l.resolve(o - l.from, a);
          for (let d of h)
            if (d.test(f, s)) {
              let p = s.facet(d.facet);
              return d.type == "replace" ? p : p.concat(c);
            }
        }
        return c;
      })
    ].concat(i);
  }
  /**
  Query whether this language is active at the given position.
  */
  isActiveAt(e, t, i = -1) {
    return _d(e, t, i).type.prop(gi) == this.data;
  }
  /**
  Find the document regions that were parsed using this language.
  The returned regions will _include_ any nested languages rooted
  in this language, when those exist.
  */
  findRegions(e) {
    let t = e.facet(ei);
    if ((t == null ? void 0 : t.data) == this.data)
      return [{ from: 0, to: e.doc.length }];
    if (!t || !t.allowsNesting)
      return [];
    let i = [], r = (s, o) => {
      if (s.prop(gi) == this.data) {
        i.push({ from: o, to: o + s.length });
        return;
      }
      let a = s.prop(J.mounted);
      if (a) {
        if (a.tree.prop(gi) == this.data) {
          if (a.overlay)
            for (let l of a.overlay)
              i.push({ from: l.from + o, to: l.to + o });
          else
            i.push({ from: o, to: o + s.length });
          return;
        } else if (a.overlay) {
          let l = i.length;
          if (r(a.tree, a.overlay[0].from + o), i.length > l)
            return;
        }
      }
      for (let l = 0; l < s.children.length; l++) {
        let u = s.children[l];
        u instanceof ge && r(u, s.positions[l] + o);
      }
    };
    return r(Pe(e), 0), i;
  }
  /**
  Indicates whether this language allows nested languages. The
  default implementation returns true.
  */
  get allowsNesting() {
    return !0;
  }
}
Zt.setState = /* @__PURE__ */ te.define();
function _d(n, e, t) {
  let i = n.facet(ei), r = Pe(n).topNode;
  if (!i || i.allowsNesting)
    for (let s = r; s; s = s.enter(e, t, ve.ExcludeBuffers))
      s.type.isTop && (r = s);
  return r;
}
class rr extends Zt {
  constructor(e, t, i) {
    super(e, t, [], i), this.parser = t;
  }
  /**
  Define a language from a parser.
  */
  static define(e) {
    let t = mh(e.languageData);
    return new rr(t, e.parser.configure({
      props: [gi.add((i) => i.isTop ? t : void 0)]
    }), e.name);
  }
  /**
  Create a new instance of this language with a reconfigured
  version of its parser and optionally a new name.
  */
  configure(e, t) {
    return new rr(this.data, this.parser.configure(e), t || this.name);
  }
  get allowsNesting() {
    return this.parser.hasWrappers();
  }
}
function Pe(n) {
  let e = n.field(Zt.state, !1);
  return e ? e.tree : ge.empty;
}
class jS {
  /**
  Create an input object for the given document.
  */
  constructor(e) {
    this.doc = e, this.cursorPos = 0, this.string = "", this.cursor = e.iter();
  }
  get length() {
    return this.doc.length;
  }
  syncTo(e) {
    return this.string = this.cursor.next(e - this.cursorPos).value, this.cursorPos = e + this.string.length, this.cursorPos - this.string.length;
  }
  chunk(e) {
    return this.syncTo(e), this.string;
  }
  get lineChunks() {
    return !0;
  }
  read(e, t) {
    let i = this.cursorPos - this.string.length;
    return e < i || t >= this.cursorPos ? this.doc.sliceString(e, t) : this.string.slice(e - i, t - i);
  }
}
let Ar = null;
class fs {
  constructor(e, t, i = [], r, s, o, a, l) {
    this.parser = e, this.state = t, this.fragments = i, this.tree = r, this.treeLen = s, this.viewport = o, this.skipped = a, this.scheduleOn = l, this.parse = null, this.tempSkipped = [];
  }
  /**
  @internal
  */
  static create(e, t, i) {
    return new fs(e, t, [], ge.empty, 0, i, [], null);
  }
  startParse() {
    return this.parser.startParse(new jS(this.state.doc), this.fragments);
  }
  /**
  @internal
  */
  work(e, t) {
    return t != null && t >= this.state.doc.length && (t = void 0), this.tree != ge.empty && this.isDone(t ?? this.state.doc.length) ? (this.takeTree(), !0) : this.withContext(() => {
      var i;
      if (typeof e == "number") {
        let r = Date.now() + e;
        e = () => Date.now() > r;
      }
      for (this.parse || (this.parse = this.startParse()), t != null && (this.parse.stoppedAt == null || this.parse.stoppedAt > t) && t < this.state.doc.length && this.parse.stopAt(t); ; ) {
        let r = this.parse.advance();
        if (r)
          if (this.fragments = this.withoutTempSkipped(Pn.addTree(r, this.fragments, this.parse.stoppedAt != null)), this.treeLen = (i = this.parse.stoppedAt) !== null && i !== void 0 ? i : this.state.doc.length, this.tree = r, this.parse = null, this.treeLen < (t ?? this.state.doc.length))
            this.parse = this.startParse();
          else
            return !0;
        if (e())
          return !1;
      }
    });
  }
  /**
  @internal
  */
  takeTree() {
    let e, t;
    this.parse && (e = this.parse.parsedPos) >= this.treeLen && ((this.parse.stoppedAt == null || this.parse.stoppedAt > e) && this.parse.stopAt(e), this.withContext(() => {
      for (; !(t = this.parse.advance()); )
        ;
    }), this.treeLen = e, this.tree = t, this.fragments = this.withoutTempSkipped(Pn.addTree(this.tree, this.fragments, !0)), this.parse = null);
  }
  withContext(e) {
    let t = Ar;
    Ar = this;
    try {
      return e();
    } finally {
      Ar = t;
    }
  }
  withoutTempSkipped(e) {
    for (let t; t = this.tempSkipped.pop(); )
      e = Xd(e, t.from, t.to);
    return e;
  }
  /**
  @internal
  */
  changes(e, t) {
    let { fragments: i, tree: r, treeLen: s, viewport: o, skipped: a } = this;
    if (this.takeTree(), !e.empty) {
      let l = [];
      if (e.iterChangedRanges((u, c, h, f) => l.push({ fromA: u, toA: c, fromB: h, toB: f })), i = Pn.applyChanges(i, l), r = ge.empty, s = 0, o = { from: e.mapPos(o.from, -1), to: e.mapPos(o.to, 1) }, this.skipped.length) {
        a = [];
        for (let u of this.skipped) {
          let c = e.mapPos(u.from, 1), h = e.mapPos(u.to, -1);
          c < h && a.push({ from: c, to: h });
        }
      }
    }
    return new fs(this.parser, t, i, r, s, o, a, this.scheduleOn);
  }
  /**
  @internal
  */
  updateViewport(e) {
    if (this.viewport.from == e.from && this.viewport.to == e.to)
      return !1;
    this.viewport = e;
    let t = this.skipped.length;
    for (let i = 0; i < this.skipped.length; i++) {
      let { from: r, to: s } = this.skipped[i];
      r < e.to && s > e.from && (this.fragments = Xd(this.fragments, r, s), this.skipped.splice(i--, 1));
    }
    return this.skipped.length >= t ? !1 : (this.reset(), !0);
  }
  /**
  @internal
  */
  reset() {
    this.parse && (this.takeTree(), this.parse = null);
  }
  /**
  Notify the parse scheduler that the given region was skipped
  because it wasn't in view, and the parse should be restarted
  when it comes into view.
  */
  skipUntilInView(e, t) {
    this.skipped.push({ from: e, to: t });
  }
  /**
  Returns a parser intended to be used as placeholder when
  asynchronously loading a nested parser. It'll skip its input and
  mark it as not-really-parsed, so that the next update will parse
  it again.
  
  When `until` is given, a reparse will be scheduled when that
  promise resolves.
  */
  static getSkippingParser(e) {
    return new class extends ph {
      createParse(t, i, r) {
        let s = r[0].from, o = r[r.length - 1].to;
        return {
          parsedPos: s,
          advance() {
            let l = Ar;
            if (l) {
              for (let u of r)
                l.tempSkipped.push(u);
              e && (l.scheduleOn = l.scheduleOn ? Promise.all([l.scheduleOn, e]) : e);
            }
            return this.parsedPos = o, new ge(qe.none, [], [], o - s);
          },
          stoppedAt: null,
          stopAt() {
          }
        };
      }
    }();
  }
  /**
  @internal
  */
  isDone(e) {
    e = Math.min(e, this.state.doc.length);
    let t = this.fragments;
    return this.treeLen >= e && t.length && t[0].from == 0 && t[0].to >= e;
  }
  /**
  Get the context for the current parse, or `null` if no editor
  parse is in progress.
  */
  static get() {
    return Ar;
  }
}
function Xd(n, e, t) {
  return Pn.applyChanges(n, [{ fromA: e, toA: t, fromB: e, toB: t }]);
}
class sr {
  constructor(e) {
    this.context = e, this.tree = e.tree;
  }
  apply(e) {
    if (!e.docChanged && this.tree == this.context.tree)
      return this;
    let t = this.context.changes(e.changes, e.state), i = this.context.treeLen == e.startState.doc.length ? void 0 : Math.max(e.changes.mapPos(this.context.treeLen), t.viewport.to);
    return t.work(20, i) || t.takeTree(), new sr(t);
  }
  static init(e) {
    let t = Math.min(3e3, e.doc.length), i = fs.create(e.facet(ei).parser, e, { from: 0, to: t });
    return i.work(20, t) || i.takeTree(), new sr(i);
  }
}
Zt.state = /* @__PURE__ */ Ye.define({
  create: sr.init,
  update(n, e) {
    for (let t of e.effects)
      if (t.is(Zt.setState))
        return t.value;
    return e.startState.facet(ei) != e.state.facet(ei) ? sr.init(e.state) : n.apply(e);
  }
});
let e1 = (n) => {
  let e = setTimeout(
    () => n(),
    500
    /* Work.MaxPause */
  );
  return () => clearTimeout(e);
};
typeof requestIdleCallback < "u" && (e1 = (n) => {
  let e = -1, t = setTimeout(
    () => {
      e = requestIdleCallback(n, {
        timeout: 400
        /* Work.MinPause */
      });
    },
    100
    /* Work.MinPause */
  );
  return () => e < 0 ? clearTimeout(t) : cancelIdleCallback(e);
});
const Cl = typeof navigator < "u" && (!(($l = navigator.scheduling) === null || $l === void 0) && $l.isInputPending) ? () => navigator.scheduling.isInputPending() : null, US = /* @__PURE__ */ Ie.fromClass(class {
  constructor(e) {
    this.view = e, this.working = null, this.workScheduled = 0, this.chunkEnd = -1, this.chunkBudget = -1, this.work = this.work.bind(this), this.scheduleWork();
  }
  update(e) {
    let t = this.view.state.field(Zt.state).context;
    (t.updateViewport(e.view.viewport) || this.view.viewport.to > t.treeLen) && this.scheduleWork(), (e.docChanged || e.selectionSet) && (this.view.hasFocus && (this.chunkBudget += 50), this.scheduleWork()), this.checkAsyncSchedule(t);
  }
  scheduleWork() {
    if (this.working)
      return;
    let { state: e } = this.view, t = e.field(Zt.state);
    (t.tree != t.context.tree || !t.context.isDone(e.doc.length)) && (this.working = e1(this.work));
  }
  work(e) {
    this.working = null;
    let t = Date.now();
    if (this.chunkEnd < t && (this.chunkEnd < 0 || this.view.hasFocus) && (this.chunkEnd = t + 3e4, this.chunkBudget = 3e3), this.chunkBudget <= 0)
      return;
    let { state: i, viewport: { to: r } } = this.view, s = i.field(Zt.state);
    if (s.tree == s.context.tree && s.context.isDone(
      r + 1e5
      /* Work.MaxParseAhead */
    ))
      return;
    let o = Date.now() + Math.min(this.chunkBudget, 100, e && !Cl ? Math.max(25, e.timeRemaining() - 5) : 1e9), a = s.context.treeLen < r && i.doc.length > r + 1e3, l = s.context.work(() => Cl && Cl() || Date.now() > o, r + (a ? 0 : 1e5));
    this.chunkBudget -= Date.now() - t, (l || this.chunkBudget <= 0) && (s.context.takeTree(), this.view.dispatch({ effects: Zt.setState.of(new sr(s.context)) })), this.chunkBudget > 0 && !(l && !a) && this.scheduleWork(), this.checkAsyncSchedule(s.context);
  }
  checkAsyncSchedule(e) {
    e.scheduleOn && (this.workScheduled++, e.scheduleOn.then(() => this.scheduleWork()).catch((t) => mt(this.view.state, t)).then(() => this.workScheduled--), e.scheduleOn = null);
  }
  destroy() {
    this.working && this.working();
  }
  isWorking() {
    return !!(this.working || this.workScheduled > 0);
  }
}, {
  eventHandlers: { focus() {
    this.scheduleWork();
  } }
}), ei = /* @__PURE__ */ N.define({
  combine(n) {
    return n.length ? n[0] : null;
  },
  enables: (n) => [
    Zt.state,
    US,
    _.contentAttributes.compute([n], (e) => {
      let t = e.facet(n);
      return t && t.name ? { "data-language": t.name } : {};
    })
  ]
});
class ds {
  /**
  Create a language support object.
  */
  constructor(e, t = []) {
    this.language = e, this.support = t, this.extension = [e, t];
  }
}
class ha {
  constructor(e, t, i, r, s, o = void 0) {
    this.name = e, this.alias = t, this.extensions = i, this.filename = r, this.loadFunc = s, this.support = o, this.loading = null;
  }
  /**
  Start loading the the language. Will return a promise that
  resolves to a [`LanguageSupport`](https://codemirror.net/6/docs/ref/#language.LanguageSupport)
  object when the language successfully loads.
  */
  load() {
    return this.loading || (this.loading = this.loadFunc().then((e) => this.support = e, (e) => {
      throw this.loading = null, e;
    }));
  }
  /**
  Create a language description.
  */
  static of(e) {
    let { load: t, support: i } = e;
    if (!t) {
      if (!i)
        throw new RangeError("Must pass either 'load' or 'support' to LanguageDescription.of");
      t = () => Promise.resolve(i);
    }
    return new ha(e.name, (e.alias || []).concat(e.name).map((r) => r.toLowerCase()), e.extensions || [], e.filename, t, i);
  }
  /**
  Look for a language in the given array of descriptions that
  matches the filename. Will first match
  [`filename`](https://codemirror.net/6/docs/ref/#language.LanguageDescription.filename) patterns,
  and then [extensions](https://codemirror.net/6/docs/ref/#language.LanguageDescription.extensions),
  and return the first language that matches.
  */
  static matchFilename(e, t) {
    for (let r of e)
      if (r.filename && r.filename.test(t))
        return r;
    let i = /\.([^.]+)$/.exec(t);
    if (i) {
      for (let r of e)
        if (r.extensions.indexOf(i[1]) > -1)
          return r;
    }
    return null;
  }
  /**
  Look for a language whose name or alias matches the the given
  name (case-insensitively). If `fuzzy` is true, and no direct
  matchs is found, this'll also search for a language whose name
  or alias occurs in the string (for names shorter than three
  characters, only when surrounded by non-word characters).
  */
  static matchLanguageName(e, t, i = !0) {
    t = t.toLowerCase();
    for (let r of e)
      if (r.alias.some((s) => s == t))
        return r;
    if (i)
      for (let r of e)
        for (let s of r.alias) {
          let o = t.indexOf(s);
          if (o > -1 && (s.length > 2 || !/\w/.test(t[o - 1]) && !/\w/.test(t[o + s.length])))
            return r;
        }
    return null;
  }
}
const FS = /* @__PURE__ */ N.define(), mr = /* @__PURE__ */ N.define({
  combine: (n) => {
    if (!n.length)
      return "  ";
    let e = n[0];
    if (!e || /\S/.test(e) || Array.from(e).some((t) => t != e[0]))
      throw new Error("Invalid indent unit: " + JSON.stringify(n[0]));
    return e;
  }
});
function fa(n) {
  let e = n.facet(mr);
  return e.charCodeAt(0) == 9 ? n.tabSize * e.length : e.length;
}
function ps(n, e) {
  let t = "", i = n.tabSize, r = n.facet(mr)[0];
  if (r == "	") {
    for (; e >= i; )
      t += "	", e -= i;
    r = " ";
  }
  for (let s = 0; s < e; s++)
    t += r;
  return t;
}
function Oh(n, e) {
  n instanceof se && (n = new Ua(n));
  for (let i of n.state.facet(FS)) {
    let r = i(n, e);
    if (r !== void 0)
      return r;
  }
  let t = Pe(n.state);
  return t.length >= e ? GS(n, t, e) : null;
}
class Ua {
  /**
  Create an indent context.
  */
  constructor(e, t = {}) {
    this.state = e, this.options = t, this.unit = fa(e);
  }
  /**
  Get a description of the line at the given position, taking
  [simulated line
  breaks](https://codemirror.net/6/docs/ref/#language.IndentContext.constructor^options.simulateBreak)
  into account. If there is such a break at `pos`, the `bias`
  argument determines whether the part of the line line before or
  after the break is used.
  */
  lineAt(e, t = 1) {
    let i = this.state.doc.lineAt(e), { simulateBreak: r, simulateDoubleBreak: s } = this.options;
    return r != null && r >= i.from && r <= i.to ? s && r == e ? { text: "", from: e } : (t < 0 ? r < e : r <= e) ? { text: i.text.slice(r - i.from), from: r } : { text: i.text.slice(0, r - i.from), from: i.from } : i;
  }
  /**
  Get the text directly after `pos`, either the entire line
  or the next 100 characters, whichever is shorter.
  */
  textAfterPos(e, t = 1) {
    if (this.options.simulateDoubleBreak && e == this.options.simulateBreak)
      return "";
    let { text: i, from: r } = this.lineAt(e, t);
    return i.slice(e - r, Math.min(i.length, e + 100 - r));
  }
  /**
  Find the column for the given position.
  */
  column(e, t = 1) {
    let { text: i, from: r } = this.lineAt(e, t), s = this.countColumn(i, e - r), o = this.options.overrideIndentation ? this.options.overrideIndentation(r) : -1;
    return o > -1 && (s += o - this.countColumn(i, i.search(/\S|$/))), s;
  }
  /**
  Find the column position (taking tabs into account) of the given
  position in the given string.
  */
  countColumn(e, t = e.length) {
    return Ut(e, this.state.tabSize, t);
  }
  /**
  Find the indentation column of the line at the given point.
  */
  lineIndent(e, t = 1) {
    let { text: i, from: r } = this.lineAt(e, t), s = this.options.overrideIndentation;
    if (s) {
      let o = s(r);
      if (o > -1)
        return o;
    }
    return this.countColumn(i, i.search(/\S|$/));
  }
  /**
  Returns the [simulated line
  break](https://codemirror.net/6/docs/ref/#language.IndentContext.constructor^options.simulateBreak)
  for this context, if any.
  */
  get simulatedBreak() {
    return this.options.simulateBreak || null;
  }
}
const Ds = /* @__PURE__ */ new J();
function GS(n, e, t) {
  let i = e.resolveStack(t), r = i.node.enterUnfinishedNodesBefore(t);
  if (r != i.node) {
    let s = [];
    for (let o = r; o != i.node; o = o.parent)
      s.push(o);
    for (let o = s.length - 1; o >= 0; o--)
      i = { node: s[o], next: i };
  }
  return t1(i, n, t);
}
function t1(n, e, t) {
  for (let i = n; i; i = i.next) {
    let r = KS(i.node);
    if (r)
      return r(bh.create(e, t, i));
  }
  return 0;
}
function HS(n) {
  return n.pos == n.options.simulateBreak && n.options.simulateDoubleBreak;
}
function KS(n) {
  let e = n.type.prop(Ds);
  if (e)
    return e;
  let t = n.firstChild, i;
  if (t && (i = t.type.prop(J.closedBy))) {
    let r = n.lastChild, s = r && i.indexOf(r.name) > -1;
    return (o) => n1(o, !0, 1, void 0, s && !HS(o) ? r.from : void 0);
  }
  return n.parent == null ? JS : null;
}
function JS() {
  return 0;
}
class bh extends Ua {
  constructor(e, t, i) {
    super(e.state, e.options), this.base = e, this.pos = t, this.context = i;
  }
  /**
  The syntax tree node to which the indentation strategy
  applies.
  */
  get node() {
    return this.context.node;
  }
  /**
  @internal
  */
  static create(e, t, i) {
    return new bh(e, t, i);
  }
  /**
  Get the text directly after `this.pos`, either the entire line
  or the next 100 characters, whichever is shorter.
  */
  get textAfter() {
    return this.textAfterPos(this.pos);
  }
  /**
  Get the indentation at the reference line for `this.node`, which
  is the line on which it starts, unless there is a node that is
  _not_ a parent of this node covering the start of that line. If
  so, the line at the start of that node is tried, again skipping
  on if it is covered by another such node.
  */
  get baseIndent() {
    return this.baseIndentFor(this.node);
  }
  /**
  Get the indentation for the reference line of the given node
  (see [`baseIndent`](https://codemirror.net/6/docs/ref/#language.TreeIndentContext.baseIndent)).
  */
  baseIndentFor(e) {
    let t = this.state.doc.lineAt(e.from);
    for (; ; ) {
      let i = e.resolve(t.from);
      for (; i.parent && i.parent.from == i.from; )
        i = i.parent;
      if (ev(i, e))
        break;
      t = this.state.doc.lineAt(i.from);
    }
    return this.lineIndent(t.from);
  }
  /**
  Continue looking for indentations in the node's parent nodes,
  and return the result of that.
  */
  continue() {
    return t1(this.context.next, this.base, this.pos);
  }
}
function ev(n, e) {
  for (let t = e; t; t = t.parent)
    if (n == t)
      return !0;
  return !1;
}
function tv(n) {
  let e = n.node, t = e.childAfter(e.from), i = e.lastChild;
  if (!t)
    return null;
  let r = n.options.simulateBreak, s = n.state.doc.lineAt(t.from), o = r == null || r <= s.from ? s.to : Math.min(s.to, r);
  for (let a = t.to; ; ) {
    let l = e.childAfter(a);
    if (!l || l == i)
      return null;
    if (!l.type.isSkipped)
      return l.from < o ? t : null;
    a = l.to;
  }
}
function nv({ closing: n, align: e = !0, units: t = 1 }) {
  return (i) => n1(i, e, t, n);
}
function n1(n, e, t, i, r) {
  let s = n.textAfter, o = s.match(/^\s*/)[0].length, a = i && s.slice(o, o + i.length) == i || r == n.pos + o, l = e ? tv(n) : null;
  return l ? a ? n.column(l.from) : n.column(l.to) : n.baseIndent + (a ? 0 : n.unit * t);
}
const iv = (n) => n.baseIndent;
function Yo({ except: n, units: e = 1 } = {}) {
  return (t) => {
    let i = n && n.test(t.textAfter);
    return t.baseIndent + (i ? 0 : e * t.unit);
  };
}
const rv = 200;
function sv() {
  return se.transactionFilter.of((n) => {
    if (!n.docChanged || !n.isUserEvent("input.type") && !n.isUserEvent("input.complete"))
      return n;
    let e = n.startState.languageDataAt("indentOnInput", n.startState.selection.main.head);
    if (!e.length)
      return n;
    let t = n.newDoc, { head: i } = n.newSelection.main, r = t.lineAt(i);
    if (i > r.from + rv)
      return n;
    let s = t.sliceString(r.from, i);
    if (!e.some((u) => u.test(s)))
      return n;
    let { state: o } = n, a = -1, l = [];
    for (let { head: u } of o.selection.ranges) {
      let c = o.doc.lineAt(u);
      if (c.from == a)
        continue;
      a = c.from;
      let h = Oh(o, c.from);
      if (h == null)
        continue;
      let f = /^\s*/.exec(c.text)[0], d = ps(o, h);
      f != d && l.push({ from: c.from, to: c.from + f.length, insert: d });
    }
    return l.length ? [n, { changes: l, sequential: !0 }] : n;
  });
}
const i1 = /* @__PURE__ */ N.define(), gr = /* @__PURE__ */ new J();
function r1(n) {
  let e = n.firstChild, t = n.lastChild;
  return e && e.to < t.from ? { from: e.to, to: t.type.isError ? n.to : t.from } : null;
}
function ov(n, e, t) {
  let i = Pe(n);
  if (i.length < t)
    return null;
  let r = i.resolveStack(t, 1), s = null;
  for (let o = r; o; o = o.next) {
    let a = o.node;
    if (a.to <= t || a.from > t)
      continue;
    if (s && a.from < e)
      break;
    let l = a.type.prop(gr);
    if (l && (a.to < i.length - 50 || i.length == n.doc.length || !av(a))) {
      let u = l(a, n);
      u && u.from <= t && u.from >= e && u.to > t && (s = u);
    }
  }
  return s;
}
function av(n) {
  let e = n.lastChild;
  return e && e.to == n.to && e.type.isError;
}
function da(n, e, t) {
  for (let i of n.facet(i1)) {
    let r = i(n, e, t);
    if (r)
      return r;
  }
  return ov(n, e, t);
}
function s1(n, e) {
  let t = e.mapPos(n.from, 1), i = e.mapPos(n.to, -1);
  return t >= i ? void 0 : { from: t, to: i };
}
const Fa = /* @__PURE__ */ te.define({ map: s1 }), Is = /* @__PURE__ */ te.define({ map: s1 });
function o1(n) {
  let e = [];
  for (let { head: t } of n.state.selection.ranges)
    e.some((i) => i.from <= t && i.to >= t) || e.push(n.lineBlockAt(t));
  return e;
}
const vi = /* @__PURE__ */ Ye.define({
  create() {
    return F.none;
  },
  update(n, e) {
    n = n.map(e.changes);
    for (let t of e.effects)
      if (t.is(Fa) && !lv(n, t.value.from, t.value.to)) {
        let { preparePlaceholder: i } = e.state.facet(u1), r = i ? F.replace({ widget: new mv(i(e.state, t.value)) }) : Nd;
        n = n.update({ add: [r.range(t.value.from, t.value.to)] });
      } else
        t.is(Is) && (n = n.update({
          filter: (i, r) => t.value.from != i || t.value.to != r,
          filterFrom: t.value.from,
          filterTo: t.value.to
        }));
    if (e.selection) {
      let t = !1, { head: i } = e.selection.main;
      n.between(i, i, (r, s) => {
        r < i && s > i && (t = !0);
      }), t && (n = n.update({
        filterFrom: i,
        filterTo: i,
        filter: (r, s) => s <= i || r >= i
      }));
    }
    return n;
  },
  provide: (n) => _.decorations.from(n),
  toJSON(n, e) {
    let t = [];
    return n.between(0, e.doc.length, (i, r) => {
      t.push(i, r);
    }), t;
  },
  fromJSON(n) {
    if (!Array.isArray(n) || n.length % 2)
      throw new RangeError("Invalid JSON for fold state");
    let e = [];
    for (let t = 0; t < n.length; ) {
      let i = n[t++], r = n[t++];
      if (typeof i != "number" || typeof r != "number")
        throw new RangeError("Invalid JSON for fold state");
      e.push(Nd.range(i, r));
    }
    return F.set(e, !0);
  }
});
function pa(n, e, t) {
  var i;
  let r = null;
  return (i = n.field(vi, !1)) === null || i === void 0 || i.between(e, t, (s, o) => {
    (!r || r.from > s) && (r = { from: s, to: o });
  }), r;
}
function lv(n, e, t) {
  let i = !1;
  return n.between(e, e, (r, s) => {
    r == e && s == t && (i = !0);
  }), i;
}
function a1(n, e) {
  return n.field(vi, !1) ? e : e.concat(te.appendConfig.of(c1()));
}
const uv = (n) => {
  for (let e of o1(n)) {
    let t = da(n.state, e.from, e.to);
    if (t)
      return n.dispatch({ effects: a1(n.state, [Fa.of(t), l1(n, t)]) }), !0;
  }
  return !1;
}, cv = (n) => {
  if (!n.state.field(vi, !1))
    return !1;
  let e = [];
  for (let t of o1(n)) {
    let i = pa(n.state, t.from, t.to);
    i && e.push(Is.of(i), l1(n, i, !1));
  }
  return e.length && n.dispatch({ effects: e }), e.length > 0;
};
function l1(n, e, t = !0) {
  let i = n.state.doc.lineAt(e.from).number, r = n.state.doc.lineAt(e.to).number;
  return _.announce.of(`${n.state.phrase(t ? "Folded lines" : "Unfolded lines")} ${i} ${n.state.phrase("to")} ${r}.`);
}
const hv = (n) => {
  let { state: e } = n, t = [];
  for (let i = 0; i < e.doc.length; ) {
    let r = n.lineBlockAt(i), s = da(e, r.from, r.to);
    s && t.push(Fa.of(s)), i = (s ? n.lineBlockAt(s.to) : r).to + 1;
  }
  return t.length && n.dispatch({ effects: a1(n.state, t) }), !!t.length;
}, fv = (n) => {
  let e = n.state.field(vi, !1);
  if (!e || !e.size)
    return !1;
  let t = [];
  return e.between(0, n.state.doc.length, (i, r) => {
    t.push(Is.of({ from: i, to: r }));
  }), n.dispatch({ effects: t }), !0;
}, dv = [
  { key: "Ctrl-Shift-[", mac: "Cmd-Alt-[", run: uv },
  { key: "Ctrl-Shift-]", mac: "Cmd-Alt-]", run: cv },
  { key: "Ctrl-Alt-[", run: hv },
  { key: "Ctrl-Alt-]", run: fv }
], pv = {
  placeholderDOM: null,
  preparePlaceholder: null,
  placeholderText: "…"
}, u1 = /* @__PURE__ */ N.define({
  combine(n) {
    return pn(n, pv);
  }
});
function c1(n) {
  return [vi, bv];
}
function h1(n, e) {
  let { state: t } = n, i = t.facet(u1), r = (o) => {
    let a = n.lineBlockAt(n.posAtDOM(o.target)), l = pa(n.state, a.from, a.to);
    l && n.dispatch({ effects: Is.of(l) }), o.preventDefault();
  };
  if (i.placeholderDOM)
    return i.placeholderDOM(n, r, e);
  let s = document.createElement("span");
  return s.textContent = i.placeholderText, s.setAttribute("aria-label", t.phrase("folded code")), s.title = t.phrase("unfold"), s.className = "cm-foldPlaceholder", s.onclick = r, s;
}
const Nd = /* @__PURE__ */ F.replace({ widget: /* @__PURE__ */ new class extends mn {
  toDOM(n) {
    return h1(n, null);
  }
}() });
class mv extends mn {
  constructor(e) {
    super(), this.value = e;
  }
  eq(e) {
    return this.value == e.value;
  }
  toDOM(e) {
    return h1(e, this.value);
  }
}
const gv = {
  openText: "⌄",
  closedText: "›",
  markerDOM: null,
  domEventHandlers: {},
  foldingChanged: () => !1
};
class Tl extends Cn {
  constructor(e, t) {
    super(), this.config = e, this.open = t;
  }
  eq(e) {
    return this.config == e.config && this.open == e.open;
  }
  toDOM(e) {
    if (this.config.markerDOM)
      return this.config.markerDOM(this.open);
    let t = document.createElement("span");
    return t.textContent = this.open ? this.config.openText : this.config.closedText, t.title = e.state.phrase(this.open ? "Fold line" : "Unfold line"), t;
  }
}
function Ov(n = {}) {
  let e = Object.assign(Object.assign({}, gv), n), t = new Tl(e, !0), i = new Tl(e, !1), r = Ie.fromClass(class {
    constructor(o) {
      this.from = o.viewport.from, this.markers = this.buildMarkers(o);
    }
    update(o) {
      (o.docChanged || o.viewportChanged || o.startState.facet(ei) != o.state.facet(ei) || o.startState.field(vi, !1) != o.state.field(vi, !1) || Pe(o.startState) != Pe(o.state) || e.foldingChanged(o)) && (this.markers = this.buildMarkers(o.view));
    }
    buildMarkers(o) {
      let a = new Fn();
      for (let l of o.viewportLineBlocks) {
        let u = pa(o.state, l.from, l.to) ? i : da(o.state, l.from, l.to) ? t : null;
        u && a.add(l.from, l.from, u);
      }
      return a.finish();
    }
  }), { domEventHandlers: s } = e;
  return [
    r,
    gS({
      class: "cm-foldGutter",
      markers(o) {
        var a;
        return ((a = o.plugin(r)) === null || a === void 0 ? void 0 : a.markers) || de.empty;
      },
      initialSpacer() {
        return new Tl(e, !1);
      },
      domEventHandlers: Object.assign(Object.assign({}, s), { click: (o, a, l) => {
        if (s.click && s.click(o, a, l))
          return !0;
        let u = pa(o.state, a.from, a.to);
        if (u)
          return o.dispatch({ effects: Is.of(u) }), !0;
        let c = da(o.state, a.from, a.to);
        return c ? (o.dispatch({ effects: Fa.of(c) }), !0) : !1;
      } })
    }),
    c1()
  ];
}
const bv = /* @__PURE__ */ _.baseTheme({
  ".cm-foldPlaceholder": {
    backgroundColor: "#eee",
    border: "1px solid #ddd",
    color: "#888",
    borderRadius: ".2em",
    margin: "0 1px",
    padding: "0 1px",
    cursor: "pointer"
  },
  ".cm-foldGutter span": {
    padding: "0 1px",
    cursor: "pointer"
  }
});
class Ga {
  constructor(e, t) {
    this.specs = e;
    let i;
    function r(a) {
      let l = Gn.newName();
      return (i || (i = /* @__PURE__ */ Object.create(null)))["." + l] = a, l;
    }
    const s = typeof t.all == "string" ? t.all : t.all ? r(t.all) : void 0, o = t.scope;
    this.scope = o instanceof Zt ? (a) => a.prop(gi) == o.data : o ? (a) => a == o : void 0, this.style = JO(e.map((a) => ({
      tag: a.tag,
      class: a.class || r(Object.assign({}, a, { tag: null }))
    })), {
      all: s
    }).style, this.module = i ? new Gn(i) : null, this.themeType = t.themeType;
  }
  /**
  Create a highlighter style that associates the given styles to
  the given tags. The specs must be objects that hold a style tag
  or array of tags in their `tag` property, and either a single
  `class` property providing a static CSS class (for highlighter
  that rely on external styling), or a
  [`style-mod`](https://github.com/marijnh/style-mod#documentation)-style
  set of CSS properties (which define the styling for those tags).
  
  The CSS rules created for a highlighter will be emitted in the
  order of the spec's properties. That means that for elements that
  have multiple tags associated with them, styles defined further
  down in the list will have a higher CSS precedence than styles
  defined earlier.
  */
  static define(e, t) {
    return new Ga(e, t || {});
  }
}
const ic = /* @__PURE__ */ N.define(), f1 = /* @__PURE__ */ N.define({
  combine(n) {
    return n.length ? [n[0]] : null;
  }
});
function Al(n) {
  let e = n.facet(ic);
  return e.length ? e : n.facet(f1);
}
function yv(n, e) {
  let t = [xv], i;
  return n instanceof Ga && (n.module && t.push(_.styleModule.of(n.module)), i = n.themeType), e != null && e.fallback ? t.push(f1.of(n)) : i ? t.push(ic.computeN([_.darkTheme], (r) => r.facet(_.darkTheme) == (i == "dark") ? [n] : [])) : t.push(ic.of(n)), t;
}
class kv {
  constructor(e) {
    this.markCache = /* @__PURE__ */ Object.create(null), this.tree = Pe(e.state), this.decorations = this.buildDeco(e, Al(e.state)), this.decoratedTo = e.viewport.to;
  }
  update(e) {
    let t = Pe(e.state), i = Al(e.state), r = i != Al(e.startState), { viewport: s } = e.view, o = e.changes.mapPos(this.decoratedTo, 1);
    t.length < s.to && !r && t.type == this.tree.type && o >= s.to ? (this.decorations = this.decorations.map(e.changes), this.decoratedTo = o) : (t != this.tree || e.viewportChanged || r) && (this.tree = t, this.decorations = this.buildDeco(e.view, i), this.decoratedTo = s.to);
  }
  buildDeco(e, t) {
    if (!t || !this.tree.length)
      return F.none;
    let i = new Fn();
    for (let { from: r, to: s } of e.visibleRanges)
      BS(this.tree, t, (o, a, l) => {
        i.add(o, a, this.markCache[l] || (this.markCache[l] = F.mark({ class: l })));
      }, r, s);
    return i.finish();
  }
}
const xv = /* @__PURE__ */ Mn.high(/* @__PURE__ */ Ie.fromClass(kv, {
  decorations: (n) => n.decorations
})), wv = /* @__PURE__ */ Ga.define([
  {
    tag: x.meta,
    color: "#404740"
  },
  {
    tag: x.link,
    textDecoration: "underline"
  },
  {
    tag: x.heading,
    textDecoration: "underline",
    fontWeight: "bold"
  },
  {
    tag: x.emphasis,
    fontStyle: "italic"
  },
  {
    tag: x.strong,
    fontWeight: "bold"
  },
  {
    tag: x.strikethrough,
    textDecoration: "line-through"
  },
  {
    tag: x.keyword,
    color: "#708"
  },
  {
    tag: [x.atom, x.bool, x.url, x.contentSeparator, x.labelName],
    color: "#219"
  },
  {
    tag: [x.literal, x.inserted],
    color: "#164"
  },
  {
    tag: [x.string, x.deleted],
    color: "#a11"
  },
  {
    tag: [x.regexp, x.escape, /* @__PURE__ */ x.special(x.string)],
    color: "#e40"
  },
  {
    tag: /* @__PURE__ */ x.definition(x.variableName),
    color: "#00f"
  },
  {
    tag: /* @__PURE__ */ x.local(x.variableName),
    color: "#30a"
  },
  {
    tag: [x.typeName, x.namespace],
    color: "#085"
  },
  {
    tag: x.className,
    color: "#167"
  },
  {
    tag: [/* @__PURE__ */ x.special(x.variableName), x.macroName],
    color: "#256"
  },
  {
    tag: /* @__PURE__ */ x.definition(x.propertyName),
    color: "#00c"
  },
  {
    tag: x.comment,
    color: "#940"
  },
  {
    tag: x.invalid,
    color: "#f00"
  }
]), Sv = /* @__PURE__ */ _.baseTheme({
  "&.cm-focused .cm-matchingBracket": { backgroundColor: "#328c8252" },
  "&.cm-focused .cm-nonmatchingBracket": { backgroundColor: "#bb555544" }
}), d1 = 1e4, p1 = "()[]{}", m1 = /* @__PURE__ */ N.define({
  combine(n) {
    return pn(n, {
      afterCursor: !0,
      brackets: p1,
      maxScanDistance: d1,
      renderMatch: Qv
    });
  }
}), vv = /* @__PURE__ */ F.mark({ class: "cm-matchingBracket" }), Pv = /* @__PURE__ */ F.mark({ class: "cm-nonmatchingBracket" });
function Qv(n) {
  let e = [], t = n.matched ? vv : Pv;
  return e.push(t.range(n.start.from, n.start.to)), n.end && e.push(t.range(n.end.from, n.end.to)), e;
}
const $v = /* @__PURE__ */ Ye.define({
  create() {
    return F.none;
  },
  update(n, e) {
    if (!e.docChanged && !e.selection)
      return n;
    let t = [], i = e.state.facet(m1);
    for (let r of e.state.selection.ranges) {
      if (!r.empty)
        continue;
      let s = ln(e.state, r.head, -1, i) || r.head > 0 && ln(e.state, r.head - 1, 1, i) || i.afterCursor && (ln(e.state, r.head, 1, i) || r.head < e.state.doc.length && ln(e.state, r.head + 1, -1, i));
      s && (t = t.concat(i.renderMatch(s, e.state)));
    }
    return F.set(t, !0);
  },
  provide: (n) => _.decorations.from(n)
}), Cv = [
  $v,
  Sv
];
function Tv(n = {}) {
  return [m1.of(n), Cv];
}
const g1 = /* @__PURE__ */ new J();
function rc(n, e, t) {
  let i = n.prop(e < 0 ? J.openedBy : J.closedBy);
  if (i)
    return i;
  if (n.name.length == 1) {
    let r = t.indexOf(n.name);
    if (r > -1 && r % 2 == (e < 0 ? 1 : 0))
      return [t[r + e]];
  }
  return null;
}
function sc(n) {
  let e = n.type.prop(g1);
  return e ? e(n.node) : n;
}
function ln(n, e, t, i = {}) {
  let r = i.maxScanDistance || d1, s = i.brackets || p1, o = Pe(n), a = o.resolveInner(e, t);
  for (let l = a; l; l = l.parent) {
    let u = rc(l.type, t, s);
    if (u && l.from < l.to) {
      let c = sc(l);
      if (c && (t > 0 ? e >= c.from && e < c.to : e > c.from && e <= c.to))
        return Av(n, e, t, l, c, u, s);
    }
  }
  return Rv(n, e, t, o, a.type, r, s);
}
function Av(n, e, t, i, r, s, o) {
  let a = i.parent, l = { from: r.from, to: r.to }, u = 0, c = a == null ? void 0 : a.cursor();
  if (c && (t < 0 ? c.childBefore(i.from) : c.childAfter(i.to)))
    do
      if (t < 0 ? c.to <= i.from : c.from >= i.to) {
        if (u == 0 && s.indexOf(c.type.name) > -1 && c.from < c.to) {
          let h = sc(c);
          return { start: l, end: h ? { from: h.from, to: h.to } : void 0, matched: !0 };
        } else if (rc(c.type, t, o))
          u++;
        else if (rc(c.type, -t, o)) {
          if (u == 0) {
            let h = sc(c);
            return {
              start: l,
              end: h && h.from < h.to ? { from: h.from, to: h.to } : void 0,
              matched: !1
            };
          }
          u--;
        }
      }
    while (t < 0 ? c.prevSibling() : c.nextSibling());
  return { start: l, matched: !1 };
}
function Rv(n, e, t, i, r, s, o) {
  let a = t < 0 ? n.sliceDoc(e - 1, e) : n.sliceDoc(e, e + 1), l = o.indexOf(a);
  if (l < 0 || l % 2 == 0 != t > 0)
    return null;
  let u = { from: t < 0 ? e - 1 : e, to: t > 0 ? e + 1 : e }, c = n.doc.iterRange(e, t > 0 ? n.doc.length : 0), h = 0;
  for (let f = 0; !c.next().done && f <= s; ) {
    let d = c.value;
    t < 0 && (f += d.length);
    let p = e + f * t;
    for (let g = t > 0 ? 0 : d.length - 1, O = t > 0 ? d.length : -1; g != O; g += t) {
      let m = o.indexOf(d[g]);
      if (!(m < 0 || i.resolveInner(p + g, 1).type != r))
        if (m % 2 == 0 == t > 0)
          h++;
        else {
          if (h == 1)
            return { start: u, end: { from: p + g, to: p + g + 1 }, matched: m >> 1 == l >> 1 };
          h--;
        }
    }
    t > 0 && (f += d.length);
  }
  return c.done ? { start: u, matched: !1 } : null;
}
const Mv = /* @__PURE__ */ Object.create(null), Wd = [qe.none], qd = [], Bd = /* @__PURE__ */ Object.create(null), Zv = /* @__PURE__ */ Object.create(null);
for (let [n, e] of [
  ["variable", "variableName"],
  ["variable-2", "variableName.special"],
  ["string-2", "string.special"],
  ["def", "variableName.definition"],
  ["tag", "tagName"],
  ["attribute", "attributeName"],
  ["type", "typeName"],
  ["builtin", "variableName.standard"],
  ["qualifier", "modifier"],
  ["error", "invalid"],
  ["header", "heading"],
  ["property", "propertyName"]
])
  Zv[n] = /* @__PURE__ */ Ev(Mv, e);
function Rl(n, e) {
  qd.indexOf(n) > -1 || (qd.push(n), console.warn(e));
}
function Ev(n, e) {
  let t = [];
  for (let a of e.split(" ")) {
    let l = [];
    for (let u of a.split(".")) {
      let c = n[u] || x[u];
      c ? typeof c == "function" ? l.length ? l = l.map(c) : Rl(u, `Modifier ${u} used at start of tag`) : l.length ? Rl(u, `Tag ${u} used as modifier`) : l = Array.isArray(c) ? c : [c] : Rl(u, `Unknown highlighting tag ${u}`);
    }
    for (let u of l)
      t.push(u);
  }
  if (!t.length)
    return 0;
  let i = e.replace(/ /g, "_"), r = i + " " + t.map((a) => a.id), s = Bd[r];
  if (s)
    return s.id;
  let o = Bd[r] = qe.define({
    id: Wd.length,
    name: i,
    props: [pr({ [i]: t })]
  });
  return Wd.push(o), o.id;
}
Ae.RTL, Ae.LTR;
const zv = (n) => {
  let { state: e } = n, t = e.doc.lineAt(e.selection.main.from), i = kh(n.state, t.from);
  return i.line ? Dv(n) : i.block ? Lv(n) : !1;
};
function yh(n, e) {
  return ({ state: t, dispatch: i }) => {
    if (t.readOnly)
      return !1;
    let r = n(e, t);
    return r ? (i(t.update(r)), !0) : !1;
  };
}
const Dv = /* @__PURE__ */ yh(
  Nv,
  0
  /* CommentOption.Toggle */
), Iv = /* @__PURE__ */ yh(
  O1,
  0
  /* CommentOption.Toggle */
), Lv = /* @__PURE__ */ yh(
  (n, e) => O1(n, e, Xv(e)),
  0
  /* CommentOption.Toggle */
);
function kh(n, e) {
  let t = n.languageDataAt("commentTokens", e);
  return t.length ? t[0] : {};
}
const Rr = 50;
function _v(n, { open: e, close: t }, i, r) {
  let s = n.sliceDoc(i - Rr, i), o = n.sliceDoc(r, r + Rr), a = /\s*$/.exec(s)[0].length, l = /^\s*/.exec(o)[0].length, u = s.length - a;
  if (s.slice(u - e.length, u) == e && o.slice(l, l + t.length) == t)
    return {
      open: { pos: i - a, margin: a && 1 },
      close: { pos: r + l, margin: l && 1 }
    };
  let c, h;
  r - i <= 2 * Rr ? c = h = n.sliceDoc(i, r) : (c = n.sliceDoc(i, i + Rr), h = n.sliceDoc(r - Rr, r));
  let f = /^\s*/.exec(c)[0].length, d = /\s*$/.exec(h)[0].length, p = h.length - d - t.length;
  return c.slice(f, f + e.length) == e && h.slice(p, p + t.length) == t ? {
    open: {
      pos: i + f + e.length,
      margin: /\s/.test(c.charAt(f + e.length)) ? 1 : 0
    },
    close: {
      pos: r - d - t.length,
      margin: /\s/.test(h.charAt(p - 1)) ? 1 : 0
    }
  } : null;
}
function Xv(n) {
  let e = [];
  for (let t of n.selection.ranges) {
    let i = n.doc.lineAt(t.from), r = t.to <= i.to ? i : n.doc.lineAt(t.to), s = e.length - 1;
    s >= 0 && e[s].to > i.from ? e[s].to = r.to : e.push({ from: i.from + /^\s*/.exec(i.text)[0].length, to: r.to });
  }
  return e;
}
function O1(n, e, t = e.selection.ranges) {
  let i = t.map((s) => kh(e, s.from).block);
  if (!i.every((s) => s))
    return null;
  let r = t.map((s, o) => _v(e, i[o], s.from, s.to));
  if (n != 2 && !r.every((s) => s))
    return { changes: e.changes(t.map((s, o) => r[o] ? [] : [{ from: s.from, insert: i[o].open + " " }, { from: s.to, insert: " " + i[o].close }])) };
  if (n != 1 && r.some((s) => s)) {
    let s = [];
    for (let o = 0, a; o < r.length; o++)
      if (a = r[o]) {
        let l = i[o], { open: u, close: c } = a;
        s.push({ from: u.pos - l.open.length, to: u.pos + u.margin }, { from: c.pos - c.margin, to: c.pos + l.close.length });
      }
    return { changes: s };
  }
  return null;
}
function Nv(n, e, t = e.selection.ranges) {
  let i = [], r = -1;
  for (let { from: s, to: o } of t) {
    let a = i.length, l = 1e9, u = kh(e, s).line;
    if (u) {
      for (let c = s; c <= o; ) {
        let h = e.doc.lineAt(c);
        if (h.from > r && (s == o || o > h.from)) {
          r = h.from;
          let f = /^\s*/.exec(h.text)[0].length, d = f == h.length, p = h.text.slice(f, f + u.length) == u ? f : -1;
          f < h.text.length && f < l && (l = f), i.push({ line: h, comment: p, token: u, indent: f, empty: d, single: !1 });
        }
        c = h.to + 1;
      }
      if (l < 1e9)
        for (let c = a; c < i.length; c++)
          i[c].indent < i[c].line.text.length && (i[c].indent = l);
      i.length == a + 1 && (i[a].single = !0);
    }
  }
  if (n != 2 && i.some((s) => s.comment < 0 && (!s.empty || s.single))) {
    let s = [];
    for (let { line: a, token: l, indent: u, empty: c, single: h } of i)
      (h || !c) && s.push({ from: a.from + u, insert: l + " " });
    let o = e.changes(s);
    return { changes: o, selection: e.selection.map(o, 1) };
  } else if (n != 1 && i.some((s) => s.comment >= 0)) {
    let s = [];
    for (let { line: o, comment: a, token: l } of i)
      if (a >= 0) {
        let u = o.from + a, c = u + l.length;
        o.text[c - o.from] == " " && c++, s.push({ from: u, to: c });
      }
    return { changes: s };
  }
  return null;
}
const oc = /* @__PURE__ */ Zn.define(), Wv = /* @__PURE__ */ Zn.define(), qv = /* @__PURE__ */ N.define(), b1 = /* @__PURE__ */ N.define({
  combine(n) {
    return pn(n, {
      minDepth: 100,
      newGroupDelay: 500,
      joinToEvent: (e, t) => t
    }, {
      minDepth: Math.max,
      newGroupDelay: Math.min,
      joinToEvent: (e, t) => (i, r) => e(i, r) || t(i, r)
    });
  }
}), y1 = /* @__PURE__ */ Ye.define({
  create() {
    return un.empty;
  },
  update(n, e) {
    let t = e.state.facet(b1), i = e.annotation(oc);
    if (i) {
      let l = gt.fromTransaction(e, i.selection), u = i.side, c = u == 0 ? n.undone : n.done;
      return l ? c = ma(c, c.length, t.minDepth, l) : c = w1(c, e.startState.selection), new un(u == 0 ? i.rest : c, u == 0 ? c : i.rest);
    }
    let r = e.annotation(Wv);
    if ((r == "full" || r == "before") && (n = n.isolate()), e.annotation(_e.addToHistory) === !1)
      return e.changes.empty ? n : n.addMapping(e.changes.desc);
    let s = gt.fromTransaction(e), o = e.annotation(_e.time), a = e.annotation(_e.userEvent);
    return s ? n = n.addChanges(s, o, a, t, e) : e.selection && (n = n.addSelection(e.startState.selection, o, a, t.newGroupDelay)), (r == "full" || r == "after") && (n = n.isolate()), n;
  },
  toJSON(n) {
    return { done: n.done.map((e) => e.toJSON()), undone: n.undone.map((e) => e.toJSON()) };
  },
  fromJSON(n) {
    return new un(n.done.map(gt.fromJSON), n.undone.map(gt.fromJSON));
  }
});
function Bv(n = {}) {
  return [
    y1,
    b1.of(n),
    _.domEventHandlers({
      beforeinput(e, t) {
        let i = e.inputType == "historyUndo" ? k1 : e.inputType == "historyRedo" ? ac : null;
        return i ? (e.preventDefault(), i(t)) : !1;
      }
    })
  ];
}
function Ha(n, e) {
  return function({ state: t, dispatch: i }) {
    if (!e && t.readOnly)
      return !1;
    let r = t.field(y1, !1);
    if (!r)
      return !1;
    let s = r.pop(n, t, e);
    return s ? (i(s), !0) : !1;
  };
}
const k1 = /* @__PURE__ */ Ha(0, !1), ac = /* @__PURE__ */ Ha(1, !1), Vv = /* @__PURE__ */ Ha(0, !0), Yv = /* @__PURE__ */ Ha(1, !0);
class gt {
  constructor(e, t, i, r, s) {
    this.changes = e, this.effects = t, this.mapped = i, this.startSelection = r, this.selectionsAfter = s;
  }
  setSelAfter(e) {
    return new gt(this.changes, this.effects, this.mapped, this.startSelection, e);
  }
  toJSON() {
    var e, t, i;
    return {
      changes: (e = this.changes) === null || e === void 0 ? void 0 : e.toJSON(),
      mapped: (t = this.mapped) === null || t === void 0 ? void 0 : t.toJSON(),
      startSelection: (i = this.startSelection) === null || i === void 0 ? void 0 : i.toJSON(),
      selectionsAfter: this.selectionsAfter.map((r) => r.toJSON())
    };
  }
  static fromJSON(e) {
    return new gt(e.changes && We.fromJSON(e.changes), [], e.mapped && hn.fromJSON(e.mapped), e.startSelection && $.fromJSON(e.startSelection), e.selectionsAfter.map($.fromJSON));
  }
  // This does not check `addToHistory` and such, it assumes the
  // transaction needs to be converted to an item. Returns null when
  // there are no changes or effects in the transaction.
  static fromTransaction(e, t) {
    let i = Et;
    for (let r of e.startState.facet(qv)) {
      let s = r(e);
      s.length && (i = i.concat(s));
    }
    return !i.length && e.changes.empty ? null : new gt(e.changes.invert(e.startState.doc), i, void 0, t || e.startState.selection, Et);
  }
  static selection(e) {
    return new gt(void 0, Et, void 0, void 0, e);
  }
}
function ma(n, e, t, i) {
  let r = e + 1 > t + 20 ? e - t - 1 : 0, s = n.slice(r, e);
  return s.push(i), s;
}
function jv(n, e) {
  let t = [], i = !1;
  return n.iterChangedRanges((r, s) => t.push(r, s)), e.iterChangedRanges((r, s, o, a) => {
    for (let l = 0; l < t.length; ) {
      let u = t[l++], c = t[l++];
      a >= u && o <= c && (i = !0);
    }
  }), i;
}
function Uv(n, e) {
  return n.ranges.length == e.ranges.length && n.ranges.filter((t, i) => t.empty != e.ranges[i].empty).length === 0;
}
function x1(n, e) {
  return n.length ? e.length ? n.concat(e) : n : e;
}
const Et = [], Fv = 200;
function w1(n, e) {
  if (n.length) {
    let t = n[n.length - 1], i = t.selectionsAfter.slice(Math.max(0, t.selectionsAfter.length - Fv));
    return i.length && i[i.length - 1].eq(e) ? n : (i.push(e), ma(n, n.length - 1, 1e9, t.setSelAfter(i)));
  } else
    return [gt.selection([e])];
}
function Gv(n) {
  let e = n[n.length - 1], t = n.slice();
  return t[n.length - 1] = e.setSelAfter(e.selectionsAfter.slice(0, e.selectionsAfter.length - 1)), t;
}
function Ml(n, e) {
  if (!n.length)
    return n;
  let t = n.length, i = Et;
  for (; t; ) {
    let r = Hv(n[t - 1], e, i);
    if (r.changes && !r.changes.empty || r.effects.length) {
      let s = n.slice(0, t);
      return s[t - 1] = r, s;
    } else
      e = r.mapped, t--, i = r.selectionsAfter;
  }
  return i.length ? [gt.selection(i)] : Et;
}
function Hv(n, e, t) {
  let i = x1(n.selectionsAfter.length ? n.selectionsAfter.map((a) => a.map(e)) : Et, t);
  if (!n.changes)
    return gt.selection(i);
  let r = n.changes.map(e), s = e.mapDesc(n.changes, !0), o = n.mapped ? n.mapped.composeDesc(s) : s;
  return new gt(r, te.mapEffects(n.effects, e), o, n.startSelection.map(s), i);
}
const Kv = /^(input\.type|delete)($|\.)/;
class un {
  constructor(e, t, i = 0, r = void 0) {
    this.done = e, this.undone = t, this.prevTime = i, this.prevUserEvent = r;
  }
  isolate() {
    return this.prevTime ? new un(this.done, this.undone) : this;
  }
  addChanges(e, t, i, r, s) {
    let o = this.done, a = o[o.length - 1];
    return a && a.changes && !a.changes.empty && e.changes && (!i || Kv.test(i)) && (!a.selectionsAfter.length && t - this.prevTime < r.newGroupDelay && r.joinToEvent(s, jv(a.changes, e.changes)) || // For compose (but not compose.start) events, always join with previous event
    i == "input.type.compose") ? o = ma(o, o.length - 1, r.minDepth, new gt(e.changes.compose(a.changes), x1(e.effects, a.effects), a.mapped, a.startSelection, Et)) : o = ma(o, o.length, r.minDepth, e), new un(o, Et, t, i);
  }
  addSelection(e, t, i, r) {
    let s = this.done.length ? this.done[this.done.length - 1].selectionsAfter : Et;
    return s.length > 0 && t - this.prevTime < r && i == this.prevUserEvent && i && /^select($|\.)/.test(i) && Uv(s[s.length - 1], e) ? this : new un(w1(this.done, e), this.undone, t, i);
  }
  addMapping(e) {
    return new un(Ml(this.done, e), Ml(this.undone, e), this.prevTime, this.prevUserEvent);
  }
  pop(e, t, i) {
    let r = e == 0 ? this.done : this.undone;
    if (r.length == 0)
      return null;
    let s = r[r.length - 1], o = s.selectionsAfter[0] || t.selection;
    if (i && s.selectionsAfter.length)
      return t.update({
        selection: s.selectionsAfter[s.selectionsAfter.length - 1],
        annotations: oc.of({ side: e, rest: Gv(r), selection: o }),
        userEvent: e == 0 ? "select.undo" : "select.redo",
        scrollIntoView: !0
      });
    if (s.changes) {
      let a = r.length == 1 ? Et : r.slice(0, r.length - 1);
      return s.mapped && (a = Ml(a, s.mapped)), t.update({
        changes: s.changes,
        selection: s.startSelection,
        effects: s.effects,
        annotations: oc.of({ side: e, rest: a, selection: o }),
        filter: !1,
        userEvent: e == 0 ? "undo" : "redo",
        scrollIntoView: !0
      });
    } else
      return null;
  }
}
un.empty = /* @__PURE__ */ new un(Et, Et);
const Jv = [
  { key: "Mod-z", run: k1, preventDefault: !0 },
  { key: "Mod-y", mac: "Mod-Shift-z", run: ac, preventDefault: !0 },
  { linux: "Ctrl-Shift-z", run: ac, preventDefault: !0 },
  { key: "Mod-u", run: Vv, preventDefault: !0 },
  { key: "Alt-u", mac: "Mod-Shift-u", run: Yv, preventDefault: !0 }
];
function Or(n, e) {
  return $.create(n.ranges.map(e), n.mainIndex);
}
function gn(n, e) {
  return n.update({ selection: e, scrollIntoView: !0, userEvent: "select" });
}
function Ht({ state: n, dispatch: e }, t) {
  let i = Or(n.selection, t);
  return i.eq(n.selection, !0) ? !1 : (e(gn(n, i)), !0);
}
function Ka(n, e) {
  return $.cursor(e ? n.to : n.from);
}
function S1(n, e) {
  return Ht(n, (t) => t.empty ? n.moveByChar(t, e) : Ka(t, e));
}
function rt(n) {
  return n.textDirectionAt(n.state.selection.main.head) == Ae.LTR;
}
const v1 = (n) => S1(n, !rt(n)), P1 = (n) => S1(n, rt(n));
function Q1(n, e) {
  return Ht(n, (t) => t.empty ? n.moveByGroup(t, e) : Ka(t, e));
}
const e2 = (n) => Q1(n, !rt(n)), t2 = (n) => Q1(n, rt(n));
function n2(n, e, t) {
  if (e.type.prop(t))
    return !0;
  let i = e.to - e.from;
  return i && (i > 2 || /[^\s,.;:]/.test(n.sliceDoc(e.from, e.to))) || e.firstChild;
}
function Ja(n, e, t) {
  let i = Pe(n).resolveInner(e.head), r = t ? J.closedBy : J.openedBy;
  for (let l = e.head; ; ) {
    let u = t ? i.childAfter(l) : i.childBefore(l);
    if (!u)
      break;
    n2(n, u, r) ? i = u : l = t ? u.to : u.from;
  }
  let s = i.type.prop(r), o, a;
  return s && (o = t ? ln(n, i.from, 1) : ln(n, i.to, -1)) && o.matched ? a = t ? o.end.to : o.end.from : a = t ? i.to : i.from, $.cursor(a, t ? -1 : 1);
}
const i2 = (n) => Ht(n, (e) => Ja(n.state, e, !rt(n))), r2 = (n) => Ht(n, (e) => Ja(n.state, e, rt(n)));
function $1(n, e) {
  return Ht(n, (t) => {
    if (!t.empty)
      return Ka(t, e);
    let i = n.moveVertically(t, e);
    return i.head != t.head ? i : n.moveToLineBoundary(t, e);
  });
}
const C1 = (n) => $1(n, !1), T1 = (n) => $1(n, !0);
function A1(n) {
  let e = n.scrollDOM.clientHeight < n.scrollDOM.scrollHeight - 2, t = 0, i = 0, r;
  if (e) {
    for (let s of n.state.facet(_.scrollMargins)) {
      let o = s(n);
      o != null && o.top && (t = Math.max(o == null ? void 0 : o.top, t)), o != null && o.bottom && (i = Math.max(o == null ? void 0 : o.bottom, i));
    }
    r = n.scrollDOM.clientHeight - t - i;
  } else
    r = (n.dom.ownerDocument.defaultView || window).innerHeight;
  return {
    marginTop: t,
    marginBottom: i,
    selfScroll: e,
    height: Math.max(n.defaultLineHeight, r - 5)
  };
}
function R1(n, e) {
  let t = A1(n), { state: i } = n, r = Or(i.selection, (o) => o.empty ? n.moveVertically(o, e, t.height) : Ka(o, e));
  if (r.eq(i.selection))
    return !1;
  let s;
  if (t.selfScroll) {
    let o = n.coordsAtPos(i.selection.main.head), a = n.scrollDOM.getBoundingClientRect(), l = a.top + t.marginTop, u = a.bottom - t.marginBottom;
    o && o.top > l && o.bottom < u && (s = _.scrollIntoView(r.main.head, { y: "start", yMargin: o.top - l }));
  }
  return n.dispatch(gn(i, r), { effects: s }), !0;
}
const Vd = (n) => R1(n, !1), lc = (n) => R1(n, !0);
function ri(n, e, t) {
  let i = n.lineBlockAt(e.head), r = n.moveToLineBoundary(e, t);
  if (r.head == e.head && r.head != (t ? i.to : i.from) && (r = n.moveToLineBoundary(e, t, !1)), !t && r.head == i.from && i.length) {
    let s = /^\s*/.exec(n.state.sliceDoc(i.from, Math.min(i.from + 100, i.to)))[0].length;
    s && e.head != i.from + s && (r = $.cursor(i.from + s));
  }
  return r;
}
const s2 = (n) => Ht(n, (e) => ri(n, e, !0)), o2 = (n) => Ht(n, (e) => ri(n, e, !1)), a2 = (n) => Ht(n, (e) => ri(n, e, !rt(n))), l2 = (n) => Ht(n, (e) => ri(n, e, rt(n))), u2 = (n) => Ht(n, (e) => $.cursor(n.lineBlockAt(e.head).from, 1)), c2 = (n) => Ht(n, (e) => $.cursor(n.lineBlockAt(e.head).to, -1));
function h2(n, e, t) {
  let i = !1, r = Or(n.selection, (s) => {
    let o = ln(n, s.head, -1) || ln(n, s.head, 1) || s.head > 0 && ln(n, s.head - 1, 1) || s.head < n.doc.length && ln(n, s.head + 1, -1);
    if (!o || !o.end)
      return s;
    i = !0;
    let a = o.start.from == s.head ? o.end.to : o.end.from;
    return $.cursor(a);
  });
  return i ? (e(gn(n, r)), !0) : !1;
}
const f2 = ({ state: n, dispatch: e }) => h2(n, e);
function Lt(n, e) {
  let t = Or(n.state.selection, (i) => {
    let r = e(i);
    return $.range(i.anchor, r.head, r.goalColumn, r.bidiLevel || void 0);
  });
  return t.eq(n.state.selection) ? !1 : (n.dispatch(gn(n.state, t)), !0);
}
function M1(n, e) {
  return Lt(n, (t) => n.moveByChar(t, e));
}
const Z1 = (n) => M1(n, !rt(n)), E1 = (n) => M1(n, rt(n));
function z1(n, e) {
  return Lt(n, (t) => n.moveByGroup(t, e));
}
const d2 = (n) => z1(n, !rt(n)), p2 = (n) => z1(n, rt(n)), m2 = (n) => Lt(n, (e) => Ja(n.state, e, !rt(n))), g2 = (n) => Lt(n, (e) => Ja(n.state, e, rt(n)));
function D1(n, e) {
  return Lt(n, (t) => n.moveVertically(t, e));
}
const I1 = (n) => D1(n, !1), L1 = (n) => D1(n, !0);
function _1(n, e) {
  return Lt(n, (t) => n.moveVertically(t, e, A1(n).height));
}
const Yd = (n) => _1(n, !1), jd = (n) => _1(n, !0), O2 = (n) => Lt(n, (e) => ri(n, e, !0)), b2 = (n) => Lt(n, (e) => ri(n, e, !1)), y2 = (n) => Lt(n, (e) => ri(n, e, !rt(n))), k2 = (n) => Lt(n, (e) => ri(n, e, rt(n))), x2 = (n) => Lt(n, (e) => $.cursor(n.lineBlockAt(e.head).from)), w2 = (n) => Lt(n, (e) => $.cursor(n.lineBlockAt(e.head).to)), Ud = ({ state: n, dispatch: e }) => (e(gn(n, { anchor: 0 })), !0), Fd = ({ state: n, dispatch: e }) => (e(gn(n, { anchor: n.doc.length })), !0), Gd = ({ state: n, dispatch: e }) => (e(gn(n, { anchor: n.selection.main.anchor, head: 0 })), !0), Hd = ({ state: n, dispatch: e }) => (e(gn(n, { anchor: n.selection.main.anchor, head: n.doc.length })), !0), S2 = ({ state: n, dispatch: e }) => (e(n.update({ selection: { anchor: 0, head: n.doc.length }, userEvent: "select" })), !0), v2 = ({ state: n, dispatch: e }) => {
  let t = el(n).map(({ from: i, to: r }) => $.range(i, Math.min(r + 1, n.doc.length)));
  return e(n.update({ selection: $.create(t), userEvent: "select" })), !0;
}, P2 = ({ state: n, dispatch: e }) => {
  let t = Or(n.selection, (i) => {
    var r;
    let s = Pe(n).resolveStack(i.from, 1);
    for (let o = s; o; o = o.next) {
      let { node: a } = o;
      if ((a.from < i.from && a.to >= i.to || a.to > i.to && a.from <= i.from) && (!((r = a.parent) === null || r === void 0) && r.parent))
        return $.range(a.to, a.from);
    }
    return i;
  });
  return e(gn(n, t)), !0;
}, Q2 = ({ state: n, dispatch: e }) => {
  let t = n.selection, i = null;
  return t.ranges.length > 1 ? i = $.create([t.main]) : t.main.empty || (i = $.create([$.cursor(t.main.head)])), i ? (e(gn(n, i)), !0) : !1;
};
function Ls(n, e) {
  if (n.state.readOnly)
    return !1;
  let t = "delete.selection", { state: i } = n, r = i.changeByRange((s) => {
    let { from: o, to: a } = s;
    if (o == a) {
      let l = e(s);
      l < o ? (t = "delete.backward", l = fo(n, l, !1)) : l > o && (t = "delete.forward", l = fo(n, l, !0)), o = Math.min(o, l), a = Math.max(a, l);
    } else
      o = fo(n, o, !1), a = fo(n, a, !0);
    return o == a ? { range: s } : { changes: { from: o, to: a }, range: $.cursor(o, o < s.head ? -1 : 1) };
  });
  return r.changes.empty ? !1 : (n.dispatch(i.update(r, {
    scrollIntoView: !0,
    userEvent: t,
    effects: t == "delete.selection" ? _.announce.of(i.phrase("Selection deleted")) : void 0
  })), !0);
}
function fo(n, e, t) {
  if (n instanceof _)
    for (let i of n.state.facet(_.atomicRanges).map((r) => r(n)))
      i.between(e, e, (r, s) => {
        r < e && s > e && (e = t ? s : r);
      });
  return e;
}
const X1 = (n, e, t) => Ls(n, (i) => {
  let r = i.from, { state: s } = n, o = s.doc.lineAt(r), a, l;
  if (t && !e && r > o.from && r < o.from + 200 && !/[^ \t]/.test(a = o.text.slice(0, r - o.from))) {
    if (a[a.length - 1] == "	")
      return r - 1;
    let u = Ut(a, s.tabSize), c = u % fa(s) || fa(s);
    for (let h = 0; h < c && a[a.length - 1 - h] == " "; h++)
      r--;
    l = r;
  } else
    l = Ke(o.text, r - o.from, e, e) + o.from, l == r && o.number != (e ? s.doc.lines : 1) ? l += e ? 1 : -1 : !e && /[\ufe00-\ufe0f]/.test(o.text.slice(l - o.from, r - o.from)) && (l = Ke(o.text, l - o.from, !1, !1) + o.from);
  return l;
}), uc = (n) => X1(n, !1, !0), N1 = (n) => X1(n, !0, !1), W1 = (n, e) => Ls(n, (t) => {
  let i = t.head, { state: r } = n, s = r.doc.lineAt(i), o = r.charCategorizer(i);
  for (let a = null; ; ) {
    if (i == (e ? s.to : s.from)) {
      i == t.head && s.number != (e ? r.doc.lines : 1) && (i += e ? 1 : -1);
      break;
    }
    let l = Ke(s.text, i - s.from, e) + s.from, u = s.text.slice(Math.min(i, l) - s.from, Math.max(i, l) - s.from), c = o(u);
    if (a != null && c != a)
      break;
    (u != " " || i != t.head) && (a = c), i = l;
  }
  return i;
}), q1 = (n) => W1(n, !1), $2 = (n) => W1(n, !0), C2 = (n) => Ls(n, (e) => {
  let t = n.lineBlockAt(e.head).to;
  return e.head < t ? t : Math.min(n.state.doc.length, e.head + 1);
}), T2 = (n) => Ls(n, (e) => {
  let t = n.moveToLineBoundary(e, !1).head;
  return e.head > t ? t : Math.max(0, e.head - 1);
}), A2 = (n) => Ls(n, (e) => {
  let t = n.moveToLineBoundary(e, !0).head;
  return e.head < t ? t : Math.min(n.state.doc.length, e.head + 1);
}), R2 = ({ state: n, dispatch: e }) => {
  if (n.readOnly)
    return !1;
  let t = n.changeByRange((i) => ({
    changes: { from: i.from, to: i.to, insert: me.of(["", ""]) },
    range: $.cursor(i.from)
  }));
  return e(n.update(t, { scrollIntoView: !0, userEvent: "input" })), !0;
}, M2 = ({ state: n, dispatch: e }) => {
  if (n.readOnly)
    return !1;
  let t = n.changeByRange((i) => {
    if (!i.empty || i.from == 0 || i.from == n.doc.length)
      return { range: i };
    let r = i.from, s = n.doc.lineAt(r), o = r == s.from ? r - 1 : Ke(s.text, r - s.from, !1) + s.from, a = r == s.to ? r + 1 : Ke(s.text, r - s.from, !0) + s.from;
    return {
      changes: { from: o, to: a, insert: n.doc.slice(r, a).append(n.doc.slice(o, r)) },
      range: $.cursor(a)
    };
  });
  return t.changes.empty ? !1 : (e(n.update(t, { scrollIntoView: !0, userEvent: "move.character" })), !0);
};
function el(n) {
  let e = [], t = -1;
  for (let i of n.selection.ranges) {
    let r = n.doc.lineAt(i.from), s = n.doc.lineAt(i.to);
    if (!i.empty && i.to == s.from && (s = n.doc.lineAt(i.to - 1)), t >= r.number) {
      let o = e[e.length - 1];
      o.to = s.to, o.ranges.push(i);
    } else
      e.push({ from: r.from, to: s.to, ranges: [i] });
    t = s.number + 1;
  }
  return e;
}
function B1(n, e, t) {
  if (n.readOnly)
    return !1;
  let i = [], r = [];
  for (let s of el(n)) {
    if (t ? s.to == n.doc.length : s.from == 0)
      continue;
    let o = n.doc.lineAt(t ? s.to + 1 : s.from - 1), a = o.length + 1;
    if (t) {
      i.push({ from: s.to, to: o.to }, { from: s.from, insert: o.text + n.lineBreak });
      for (let l of s.ranges)
        r.push($.range(Math.min(n.doc.length, l.anchor + a), Math.min(n.doc.length, l.head + a)));
    } else {
      i.push({ from: o.from, to: s.from }, { from: s.to, insert: n.lineBreak + o.text });
      for (let l of s.ranges)
        r.push($.range(l.anchor - a, l.head - a));
    }
  }
  return i.length ? (e(n.update({
    changes: i,
    scrollIntoView: !0,
    selection: $.create(r, n.selection.mainIndex),
    userEvent: "move.line"
  })), !0) : !1;
}
const Z2 = ({ state: n, dispatch: e }) => B1(n, e, !1), E2 = ({ state: n, dispatch: e }) => B1(n, e, !0);
function V1(n, e, t) {
  if (n.readOnly)
    return !1;
  let i = [];
  for (let r of el(n))
    t ? i.push({ from: r.from, insert: n.doc.slice(r.from, r.to) + n.lineBreak }) : i.push({ from: r.to, insert: n.lineBreak + n.doc.slice(r.from, r.to) });
  return e(n.update({ changes: i, scrollIntoView: !0, userEvent: "input.copyline" })), !0;
}
const z2 = ({ state: n, dispatch: e }) => V1(n, e, !1), D2 = ({ state: n, dispatch: e }) => V1(n, e, !0), I2 = (n) => {
  if (n.state.readOnly)
    return !1;
  let { state: e } = n, t = e.changes(el(e).map(({ from: r, to: s }) => (r > 0 ? r-- : s < e.doc.length && s++, { from: r, to: s }))), i = Or(e.selection, (r) => {
    let s;
    if (n.lineWrapping) {
      let o = n.lineBlockAt(r.head), a = n.coordsAtPos(r.head, r.assoc || 1);
      a && (s = o.bottom + n.documentTop - a.bottom + n.defaultLineHeight / 2);
    }
    return n.moveVertically(r, !0, s);
  }).map(t);
  return n.dispatch({ changes: t, selection: i, scrollIntoView: !0, userEvent: "delete.line" }), !0;
};
function L2(n, e) {
  if (/\(\)|\[\]|\{\}/.test(n.sliceDoc(e - 1, e + 1)))
    return { from: e, to: e };
  let t = Pe(n).resolveInner(e), i = t.childBefore(e), r = t.childAfter(e), s;
  return i && r && i.to <= e && r.from >= e && (s = i.type.prop(J.closedBy)) && s.indexOf(r.name) > -1 && n.doc.lineAt(i.to).from == n.doc.lineAt(r.from).from && !/\S/.test(n.sliceDoc(i.to, r.from)) ? { from: i.to, to: r.from } : null;
}
const _2 = /* @__PURE__ */ Y1(!1), X2 = /* @__PURE__ */ Y1(!0);
function Y1(n) {
  return ({ state: e, dispatch: t }) => {
    if (e.readOnly)
      return !1;
    let i = e.changeByRange((r) => {
      let { from: s, to: o } = r, a = e.doc.lineAt(s), l = !n && s == o && L2(e, s);
      n && (s = o = (o <= a.to ? a : e.doc.lineAt(o)).to);
      let u = new Ua(e, { simulateBreak: s, simulateDoubleBreak: !!l }), c = Oh(u, s);
      for (c == null && (c = Ut(/^\s*/.exec(e.doc.lineAt(s).text)[0], e.tabSize)); o < a.to && /\s/.test(a.text[o - a.from]); )
        o++;
      l ? { from: s, to: o } = l : s > a.from && s < a.from + 100 && !/\S/.test(a.text.slice(0, s)) && (s = a.from);
      let h = ["", ps(e, c)];
      return l && h.push(ps(e, u.lineIndent(a.from, -1))), {
        changes: { from: s, to: o, insert: me.of(h) },
        range: $.cursor(s + 1 + h[1].length)
      };
    });
    return t(e.update(i, { scrollIntoView: !0, userEvent: "input" })), !0;
  };
}
function xh(n, e) {
  let t = -1;
  return n.changeByRange((i) => {
    let r = [];
    for (let o = i.from; o <= i.to; ) {
      let a = n.doc.lineAt(o);
      a.number > t && (i.empty || i.to > a.from) && (e(a, r, i), t = a.number), o = a.to + 1;
    }
    let s = n.changes(r);
    return {
      changes: r,
      range: $.range(s.mapPos(i.anchor, 1), s.mapPos(i.head, 1))
    };
  });
}
const N2 = ({ state: n, dispatch: e }) => {
  if (n.readOnly)
    return !1;
  let t = /* @__PURE__ */ Object.create(null), i = new Ua(n, { overrideIndentation: (s) => {
    let o = t[s];
    return o ?? -1;
  } }), r = xh(n, (s, o, a) => {
    let l = Oh(i, s.from);
    if (l == null)
      return;
    /\S/.test(s.text) || (l = 0);
    let u = /^\s*/.exec(s.text)[0], c = ps(n, l);
    (u != c || a.from < s.from + u.length) && (t[s.from] = l, o.push({ from: s.from, to: s.from + u.length, insert: c }));
  });
  return r.changes.empty || e(n.update(r, { userEvent: "indent" })), !0;
}, j1 = ({ state: n, dispatch: e }) => n.readOnly ? !1 : (e(n.update(xh(n, (t, i) => {
  i.push({ from: t.from, insert: n.facet(mr) });
}), { userEvent: "input.indent" })), !0), U1 = ({ state: n, dispatch: e }) => n.readOnly ? !1 : (e(n.update(xh(n, (t, i) => {
  let r = /^\s*/.exec(t.text)[0];
  if (!r)
    return;
  let s = Ut(r, n.tabSize), o = 0, a = ps(n, Math.max(0, s - fa(n)));
  for (; o < r.length && o < a.length && r.charCodeAt(o) == a.charCodeAt(o); )
    o++;
  i.push({ from: t.from + o, to: t.from + r.length, insert: a.slice(o) });
}), { userEvent: "delete.dedent" })), !0), W2 = (n) => (n.setTabFocusMode(), !0), q2 = [
  { key: "Ctrl-b", run: v1, shift: Z1, preventDefault: !0 },
  { key: "Ctrl-f", run: P1, shift: E1 },
  { key: "Ctrl-p", run: C1, shift: I1 },
  { key: "Ctrl-n", run: T1, shift: L1 },
  { key: "Ctrl-a", run: u2, shift: x2 },
  { key: "Ctrl-e", run: c2, shift: w2 },
  { key: "Ctrl-d", run: N1 },
  { key: "Ctrl-h", run: uc },
  { key: "Ctrl-k", run: C2 },
  { key: "Ctrl-Alt-h", run: q1 },
  { key: "Ctrl-o", run: R2 },
  { key: "Ctrl-t", run: M2 },
  { key: "Ctrl-v", run: lc }
], B2 = /* @__PURE__ */ [
  { key: "ArrowLeft", run: v1, shift: Z1, preventDefault: !0 },
  { key: "Mod-ArrowLeft", mac: "Alt-ArrowLeft", run: e2, shift: d2, preventDefault: !0 },
  { mac: "Cmd-ArrowLeft", run: a2, shift: y2, preventDefault: !0 },
  { key: "ArrowRight", run: P1, shift: E1, preventDefault: !0 },
  { key: "Mod-ArrowRight", mac: "Alt-ArrowRight", run: t2, shift: p2, preventDefault: !0 },
  { mac: "Cmd-ArrowRight", run: l2, shift: k2, preventDefault: !0 },
  { key: "ArrowUp", run: C1, shift: I1, preventDefault: !0 },
  { mac: "Cmd-ArrowUp", run: Ud, shift: Gd },
  { mac: "Ctrl-ArrowUp", run: Vd, shift: Yd },
  { key: "ArrowDown", run: T1, shift: L1, preventDefault: !0 },
  { mac: "Cmd-ArrowDown", run: Fd, shift: Hd },
  { mac: "Ctrl-ArrowDown", run: lc, shift: jd },
  { key: "PageUp", run: Vd, shift: Yd },
  { key: "PageDown", run: lc, shift: jd },
  { key: "Home", run: o2, shift: b2, preventDefault: !0 },
  { key: "Mod-Home", run: Ud, shift: Gd },
  { key: "End", run: s2, shift: O2, preventDefault: !0 },
  { key: "Mod-End", run: Fd, shift: Hd },
  { key: "Enter", run: _2 },
  { key: "Mod-a", run: S2 },
  { key: "Backspace", run: uc, shift: uc },
  { key: "Delete", run: N1 },
  { key: "Mod-Backspace", mac: "Alt-Backspace", run: q1 },
  { key: "Mod-Delete", mac: "Alt-Delete", run: $2 },
  { mac: "Mod-Backspace", run: T2 },
  { mac: "Mod-Delete", run: A2 }
].concat(/* @__PURE__ */ q2.map((n) => ({ mac: n.key, run: n.run, shift: n.shift }))), V2 = /* @__PURE__ */ [
  { key: "Alt-ArrowLeft", mac: "Ctrl-ArrowLeft", run: i2, shift: m2 },
  { key: "Alt-ArrowRight", mac: "Ctrl-ArrowRight", run: r2, shift: g2 },
  { key: "Alt-ArrowUp", run: Z2 },
  { key: "Shift-Alt-ArrowUp", run: z2 },
  { key: "Alt-ArrowDown", run: E2 },
  { key: "Shift-Alt-ArrowDown", run: D2 },
  { key: "Escape", run: Q2 },
  { key: "Mod-Enter", run: X2 },
  { key: "Alt-l", mac: "Ctrl-l", run: v2 },
  { key: "Mod-i", run: P2, preventDefault: !0 },
  { key: "Mod-[", run: U1 },
  { key: "Mod-]", run: j1 },
  { key: "Mod-Alt-\\", run: N2 },
  { key: "Shift-Mod-k", run: I2 },
  { key: "Shift-Mod-\\", run: f2 },
  { key: "Mod-/", run: zv },
  { key: "Alt-A", run: Iv },
  { key: "Ctrl-m", mac: "Shift-Alt-m", run: W2 }
].concat(B2), Y2 = { key: "Tab", run: j1, shift: U1 };
function Se() {
  var n = arguments[0];
  typeof n == "string" && (n = document.createElement(n));
  var e = 1, t = arguments[1];
  if (t && typeof t == "object" && t.nodeType == null && !Array.isArray(t)) {
    for (var i in t)
      if (Object.prototype.hasOwnProperty.call(t, i)) {
        var r = t[i];
        typeof r == "string" ? n.setAttribute(i, r) : r != null && (n[i] = r);
      }
    e++;
  }
  for (; e < arguments.length; e++)
    F1(n, arguments[e]);
  return n;
}
function F1(n, e) {
  if (typeof e == "string")
    n.appendChild(document.createTextNode(e));
  else if (e != null)
    if (e.nodeType != null)
      n.appendChild(e);
    else if (Array.isArray(e))
      for (var t = 0; t < e.length; t++)
        F1(n, e[t]);
    else
      throw new RangeError("Unsupported child node: " + e);
}
const Kd = typeof String.prototype.normalize == "function" ? (n) => n.normalize("NFKD") : (n) => n;
class or {
  /**
  Create a text cursor. The query is the search string, `from` to
  `to` provides the region to search.
  
  When `normalize` is given, it will be called, on both the query
  string and the content it is matched against, before comparing.
  You can, for example, create a case-insensitive search by
  passing `s => s.toLowerCase()`.
  
  Text is always normalized with
  [`.normalize("NFKD")`](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/String/normalize)
  (when supported).
  */
  constructor(e, t, i = 0, r = e.length, s, o) {
    this.test = o, this.value = { from: 0, to: 0 }, this.done = !1, this.matches = [], this.buffer = "", this.bufferPos = 0, this.iter = e.iterRange(i, r), this.bufferStart = i, this.normalize = s ? (a) => s(Kd(a)) : Kd, this.query = this.normalize(t);
  }
  peek() {
    if (this.bufferPos == this.buffer.length) {
      if (this.bufferStart += this.buffer.length, this.iter.next(), this.iter.done)
        return -1;
      this.bufferPos = 0, this.buffer = this.iter.value;
    }
    return Ue(this.buffer, this.bufferPos);
  }
  /**
  Look for the next match. Updates the iterator's
  [`value`](https://codemirror.net/6/docs/ref/#search.SearchCursor.value) and
  [`done`](https://codemirror.net/6/docs/ref/#search.SearchCursor.done) properties. Should be called
  at least once before using the cursor.
  */
  next() {
    for (; this.matches.length; )
      this.matches.pop();
    return this.nextOverlapping();
  }
  /**
  The `next` method will ignore matches that partially overlap a
  previous match. This method behaves like `next`, but includes
  such matches.
  */
  nextOverlapping() {
    for (; ; ) {
      let e = this.peek();
      if (e < 0)
        return this.done = !0, this;
      let t = Kc(e), i = this.bufferStart + this.bufferPos;
      this.bufferPos += Rt(e);
      let r = this.normalize(t);
      for (let s = 0, o = i; ; s++) {
        let a = r.charCodeAt(s), l = this.match(a, o, this.bufferPos + this.bufferStart);
        if (s == r.length - 1) {
          if (l)
            return this.value = l, this;
          break;
        }
        o == i && s < t.length && t.charCodeAt(s) == a && o++;
      }
    }
  }
  match(e, t, i) {
    let r = null;
    for (let s = 0; s < this.matches.length; s += 2) {
      let o = this.matches[s], a = !1;
      this.query.charCodeAt(o) == e && (o == this.query.length - 1 ? r = { from: this.matches[s + 1], to: i } : (this.matches[s]++, a = !0)), a || (this.matches.splice(s, 2), s -= 2);
    }
    return this.query.charCodeAt(0) == e && (this.query.length == 1 ? r = { from: t, to: i } : this.matches.push(1, t)), r && this.test && !this.test(r.from, r.to, this.buffer, this.bufferStart) && (r = null), r;
  }
}
typeof Symbol < "u" && (or.prototype[Symbol.iterator] = function() {
  return this;
});
const G1 = { from: -1, to: -1, match: /* @__PURE__ */ /.*/.exec("") }, wh = "gm" + (/x/.unicode == null ? "" : "u");
class H1 {
  /**
  Create a cursor that will search the given range in the given
  document. `query` should be the raw pattern (as you'd pass it to
  `new RegExp`).
  */
  constructor(e, t, i, r = 0, s = e.length) {
    if (this.text = e, this.to = s, this.curLine = "", this.done = !1, this.value = G1, /\\[sWDnr]|\n|\r|\[\^/.test(t))
      return new K1(e, t, i, r, s);
    this.re = new RegExp(t, wh + (i != null && i.ignoreCase ? "i" : "")), this.test = i == null ? void 0 : i.test, this.iter = e.iter();
    let o = e.lineAt(r);
    this.curLineStart = o.from, this.matchPos = ga(e, r), this.getLine(this.curLineStart);
  }
  getLine(e) {
    this.iter.next(e), this.iter.lineBreak ? this.curLine = "" : (this.curLine = this.iter.value, this.curLineStart + this.curLine.length > this.to && (this.curLine = this.curLine.slice(0, this.to - this.curLineStart)), this.iter.next());
  }
  nextLine() {
    this.curLineStart = this.curLineStart + this.curLine.length + 1, this.curLineStart > this.to ? this.curLine = "" : this.getLine(0);
  }
  /**
  Move to the next match, if there is one.
  */
  next() {
    for (let e = this.matchPos - this.curLineStart; ; ) {
      this.re.lastIndex = e;
      let t = this.matchPos <= this.to && this.re.exec(this.curLine);
      if (t) {
        let i = this.curLineStart + t.index, r = i + t[0].length;
        if (this.matchPos = ga(this.text, r + (i == r ? 1 : 0)), i == this.curLineStart + this.curLine.length && this.nextLine(), (i < r || i > this.value.to) && (!this.test || this.test(i, r, t)))
          return this.value = { from: i, to: r, match: t }, this;
        e = this.matchPos - this.curLineStart;
      } else if (this.curLineStart + this.curLine.length < this.to)
        this.nextLine(), e = 0;
      else
        return this.done = !0, this;
    }
  }
}
const Zl = /* @__PURE__ */ new WeakMap();
class Ui {
  constructor(e, t) {
    this.from = e, this.text = t;
  }
  get to() {
    return this.from + this.text.length;
  }
  static get(e, t, i) {
    let r = Zl.get(e);
    if (!r || r.from >= i || r.to <= t) {
      let a = new Ui(t, e.sliceString(t, i));
      return Zl.set(e, a), a;
    }
    if (r.from == t && r.to == i)
      return r;
    let { text: s, from: o } = r;
    return o > t && (s = e.sliceString(t, o) + s, o = t), r.to < i && (s += e.sliceString(r.to, i)), Zl.set(e, new Ui(o, s)), new Ui(t, s.slice(t - o, i - o));
  }
}
class K1 {
  constructor(e, t, i, r, s) {
    this.text = e, this.to = s, this.done = !1, this.value = G1, this.matchPos = ga(e, r), this.re = new RegExp(t, wh + (i != null && i.ignoreCase ? "i" : "")), this.test = i == null ? void 0 : i.test, this.flat = Ui.get(e, r, this.chunkEnd(
      r + 5e3
      /* Chunk.Base */
    ));
  }
  chunkEnd(e) {
    return e >= this.to ? this.to : this.text.lineAt(e).to;
  }
  next() {
    for (; ; ) {
      let e = this.re.lastIndex = this.matchPos - this.flat.from, t = this.re.exec(this.flat.text);
      if (t && !t[0] && t.index == e && (this.re.lastIndex = e + 1, t = this.re.exec(this.flat.text)), t) {
        let i = this.flat.from + t.index, r = i + t[0].length;
        if ((this.flat.to >= this.to || t.index + t[0].length <= this.flat.text.length - 10) && (!this.test || this.test(i, r, t)))
          return this.value = { from: i, to: r, match: t }, this.matchPos = ga(this.text, r + (i == r ? 1 : 0)), this;
      }
      if (this.flat.to == this.to)
        return this.done = !0, this;
      this.flat = Ui.get(this.text, this.flat.from, this.chunkEnd(this.flat.from + this.flat.text.length * 2));
    }
  }
}
typeof Symbol < "u" && (H1.prototype[Symbol.iterator] = K1.prototype[Symbol.iterator] = function() {
  return this;
});
function j2(n) {
  try {
    return new RegExp(n, wh), !0;
  } catch {
    return !1;
  }
}
function ga(n, e) {
  if (e >= n.length)
    return e;
  let t = n.lineAt(e), i;
  for (; e < t.to && (i = t.text.charCodeAt(e - t.from)) >= 56320 && i < 57344; )
    e++;
  return e;
}
function cc(n) {
  let e = String(n.state.doc.lineAt(n.state.selection.main.head).number), t = Se("input", { class: "cm-textfield", name: "line", value: e }), i = Se("form", {
    class: "cm-gotoLine",
    onkeydown: (s) => {
      s.keyCode == 27 ? (s.preventDefault(), n.dispatch({ effects: Oa.of(!1) }), n.focus()) : s.keyCode == 13 && (s.preventDefault(), r());
    },
    onsubmit: (s) => {
      s.preventDefault(), r();
    }
  }, Se("label", n.state.phrase("Go to line"), ": ", t), " ", Se("button", { class: "cm-button", type: "submit" }, n.state.phrase("go")));
  function r() {
    let s = /^([+-])?(\d+)?(:\d+)?(%)?$/.exec(t.value);
    if (!s)
      return;
    let { state: o } = n, a = o.doc.lineAt(o.selection.main.head), [, l, u, c, h] = s, f = c ? +c.slice(1) : 0, d = u ? +u : a.number;
    if (u && h) {
      let O = d / 100;
      l && (O = O * (l == "-" ? -1 : 1) + a.number / o.doc.lines), d = Math.round(o.doc.lines * O);
    } else
      u && l && (d = d * (l == "-" ? -1 : 1) + a.number);
    let p = o.doc.line(Math.max(1, Math.min(o.doc.lines, d))), g = $.cursor(p.from + Math.max(0, Math.min(f, p.length)));
    n.dispatch({
      effects: [Oa.of(!1), _.scrollIntoView(g.from, { y: "center" })],
      selection: g
    }), n.focus();
  }
  return { dom: i };
}
const Oa = /* @__PURE__ */ te.define(), Jd = /* @__PURE__ */ Ye.define({
  create() {
    return !0;
  },
  update(n, e) {
    for (let t of e.effects)
      t.is(Oa) && (n = t.value);
    return n;
  },
  provide: (n) => us.from(n, (e) => e ? cc : null)
}), U2 = (n) => {
  let e = ls(n, cc);
  if (!e) {
    let t = [Oa.of(!0)];
    n.state.field(Jd, !1) == null && t.push(te.appendConfig.of([Jd, F2])), n.dispatch({ effects: t }), e = ls(n, cc);
  }
  return e && e.dom.querySelector("input").select(), !0;
}, F2 = /* @__PURE__ */ _.baseTheme({
  ".cm-panel.cm-gotoLine": {
    padding: "2px 6px 4px",
    "& label": { fontSize: "80%" }
  }
}), G2 = {
  highlightWordAroundCursor: !1,
  minSelectionLength: 1,
  maxMatches: 100,
  wholeWords: !1
}, H2 = /* @__PURE__ */ N.define({
  combine(n) {
    return pn(n, G2, {
      highlightWordAroundCursor: (e, t) => e || t,
      minSelectionLength: Math.min,
      maxMatches: Math.min
    });
  }
});
function K2(n) {
  return [iP, nP];
}
const J2 = /* @__PURE__ */ F.mark({ class: "cm-selectionMatch" }), eP = /* @__PURE__ */ F.mark({ class: "cm-selectionMatch cm-selectionMatch-main" });
function ep(n, e, t, i) {
  return (t == 0 || n(e.sliceDoc(t - 1, t)) != Ze.Word) && (i == e.doc.length || n(e.sliceDoc(i, i + 1)) != Ze.Word);
}
function tP(n, e, t, i) {
  return n(e.sliceDoc(t, t + 1)) == Ze.Word && n(e.sliceDoc(i - 1, i)) == Ze.Word;
}
const nP = /* @__PURE__ */ Ie.fromClass(class {
  constructor(n) {
    this.decorations = this.getDeco(n);
  }
  update(n) {
    (n.selectionSet || n.docChanged || n.viewportChanged) && (this.decorations = this.getDeco(n.view));
  }
  getDeco(n) {
    let e = n.state.facet(H2), { state: t } = n, i = t.selection;
    if (i.ranges.length > 1)
      return F.none;
    let r = i.main, s, o = null;
    if (r.empty) {
      if (!e.highlightWordAroundCursor)
        return F.none;
      let l = t.wordAt(r.head);
      if (!l)
        return F.none;
      o = t.charCategorizer(r.head), s = t.sliceDoc(l.from, l.to);
    } else {
      let l = r.to - r.from;
      if (l < e.minSelectionLength || l > 200)
        return F.none;
      if (e.wholeWords) {
        if (s = t.sliceDoc(r.from, r.to), o = t.charCategorizer(r.head), !(ep(o, t, r.from, r.to) && tP(o, t, r.from, r.to)))
          return F.none;
      } else if (s = t.sliceDoc(r.from, r.to), !s)
        return F.none;
    }
    let a = [];
    for (let l of n.visibleRanges) {
      let u = new or(t.doc, s, l.from, l.to);
      for (; !u.next().done; ) {
        let { from: c, to: h } = u.value;
        if ((!o || ep(o, t, c, h)) && (r.empty && c <= r.from && h >= r.to ? a.push(eP.range(c, h)) : (c >= r.to || h <= r.from) && a.push(J2.range(c, h)), a.length > e.maxMatches))
          return F.none;
      }
    }
    return F.set(a);
  }
}, {
  decorations: (n) => n.decorations
}), iP = /* @__PURE__ */ _.baseTheme({
  ".cm-selectionMatch": { backgroundColor: "#99ff7780" },
  ".cm-searchMatch .cm-selectionMatch": { backgroundColor: "transparent" }
}), rP = ({ state: n, dispatch: e }) => {
  let { selection: t } = n, i = $.create(t.ranges.map((r) => n.wordAt(r.head) || $.cursor(r.head)), t.mainIndex);
  return i.eq(t) ? !1 : (e(n.update({ selection: i })), !0);
};
function sP(n, e) {
  let { main: t, ranges: i } = n.selection, r = n.wordAt(t.head), s = r && r.from == t.from && r.to == t.to;
  for (let o = !1, a = new or(n.doc, e, i[i.length - 1].to); ; )
    if (a.next(), a.done) {
      if (o)
        return null;
      a = new or(n.doc, e, 0, Math.max(0, i[i.length - 1].from - 1)), o = !0;
    } else {
      if (o && i.some((l) => l.from == a.value.from))
        continue;
      if (s) {
        let l = n.wordAt(a.value.from);
        if (!l || l.from != a.value.from || l.to != a.value.to)
          continue;
      }
      return a.value;
    }
}
const oP = ({ state: n, dispatch: e }) => {
  let { ranges: t } = n.selection;
  if (t.some((s) => s.from === s.to))
    return rP({ state: n, dispatch: e });
  let i = n.sliceDoc(t[0].from, t[0].to);
  if (n.selection.ranges.some((s) => n.sliceDoc(s.from, s.to) != i))
    return !1;
  let r = sP(n, i);
  return r ? (e(n.update({
    selection: n.selection.addRange($.range(r.from, r.to), !1),
    effects: _.scrollIntoView(r.to)
  })), !0) : !1;
}, br = /* @__PURE__ */ N.define({
  combine(n) {
    return pn(n, {
      top: !1,
      caseSensitive: !1,
      literal: !1,
      regexp: !1,
      wholeWord: !1,
      createPanel: (e) => new bP(e),
      scrollToMatch: (e) => _.scrollIntoView(e)
    });
  }
});
class J1 {
  /**
  Create a query object.
  */
  constructor(e) {
    this.search = e.search, this.caseSensitive = !!e.caseSensitive, this.literal = !!e.literal, this.regexp = !!e.regexp, this.replace = e.replace || "", this.valid = !!this.search && (!this.regexp || j2(this.search)), this.unquoted = this.unquote(this.search), this.wholeWord = !!e.wholeWord;
  }
  /**
  @internal
  */
  unquote(e) {
    return this.literal ? e : e.replace(/\\([nrt\\])/g, (t, i) => i == "n" ? `
` : i == "r" ? "\r" : i == "t" ? "	" : "\\");
  }
  /**
  Compare this query to another query.
  */
  eq(e) {
    return this.search == e.search && this.replace == e.replace && this.caseSensitive == e.caseSensitive && this.regexp == e.regexp && this.wholeWord == e.wholeWord;
  }
  /**
  @internal
  */
  create() {
    return this.regexp ? new cP(this) : new lP(this);
  }
  /**
  Get a search cursor for this query, searching through the given
  range in the given state.
  */
  getCursor(e, t = 0, i) {
    let r = e.doc ? e : se.create({ doc: e });
    return i == null && (i = r.doc.length), this.regexp ? Di(this, r, t, i) : zi(this, r, t, i);
  }
}
class e0 {
  constructor(e) {
    this.spec = e;
  }
}
function zi(n, e, t, i) {
  return new or(e.doc, n.unquoted, t, i, n.caseSensitive ? void 0 : (r) => r.toLowerCase(), n.wholeWord ? aP(e.doc, e.charCategorizer(e.selection.main.head)) : void 0);
}
function aP(n, e) {
  return (t, i, r, s) => ((s > t || s + r.length < i) && (s = Math.max(0, t - 2), r = n.sliceString(s, Math.min(n.length, i + 2))), (e(ba(r, t - s)) != Ze.Word || e(ya(r, t - s)) != Ze.Word) && (e(ya(r, i - s)) != Ze.Word || e(ba(r, i - s)) != Ze.Word));
}
class lP extends e0 {
  constructor(e) {
    super(e);
  }
  nextMatch(e, t, i) {
    let r = zi(this.spec, e, i, e.doc.length).nextOverlapping();
    return r.done && (r = zi(this.spec, e, 0, t).nextOverlapping()), r.done ? null : r.value;
  }
  // Searching in reverse is, rather than implementing an inverted search
  // cursor, done by scanning chunk after chunk forward.
  prevMatchInRange(e, t, i) {
    for (let r = i; ; ) {
      let s = Math.max(t, r - 1e4 - this.spec.unquoted.length), o = zi(this.spec, e, s, r), a = null;
      for (; !o.nextOverlapping().done; )
        a = o.value;
      if (a)
        return a;
      if (s == t)
        return null;
      r -= 1e4;
    }
  }
  prevMatch(e, t, i) {
    return this.prevMatchInRange(e, 0, t) || this.prevMatchInRange(e, i, e.doc.length);
  }
  getReplacement(e) {
    return this.spec.unquote(this.spec.replace);
  }
  matchAll(e, t) {
    let i = zi(this.spec, e, 0, e.doc.length), r = [];
    for (; !i.next().done; ) {
      if (r.length >= t)
        return null;
      r.push(i.value);
    }
    return r;
  }
  highlight(e, t, i, r) {
    let s = zi(this.spec, e, Math.max(0, t - this.spec.unquoted.length), Math.min(i + this.spec.unquoted.length, e.doc.length));
    for (; !s.next().done; )
      r(s.value.from, s.value.to);
  }
}
function Di(n, e, t, i) {
  return new H1(e.doc, n.search, {
    ignoreCase: !n.caseSensitive,
    test: n.wholeWord ? uP(e.charCategorizer(e.selection.main.head)) : void 0
  }, t, i);
}
function ba(n, e) {
  return n.slice(Ke(n, e, !1), e);
}
function ya(n, e) {
  return n.slice(e, Ke(n, e));
}
function uP(n) {
  return (e, t, i) => !i[0].length || (n(ba(i.input, i.index)) != Ze.Word || n(ya(i.input, i.index)) != Ze.Word) && (n(ya(i.input, i.index + i[0].length)) != Ze.Word || n(ba(i.input, i.index + i[0].length)) != Ze.Word);
}
class cP extends e0 {
  nextMatch(e, t, i) {
    let r = Di(this.spec, e, i, e.doc.length).next();
    return r.done && (r = Di(this.spec, e, 0, t).next()), r.done ? null : r.value;
  }
  prevMatchInRange(e, t, i) {
    for (let r = 1; ; r++) {
      let s = Math.max(
        t,
        i - r * 1e4
        /* FindPrev.ChunkSize */
      ), o = Di(this.spec, e, s, i), a = null;
      for (; !o.next().done; )
        a = o.value;
      if (a && (s == t || a.from > s + 10))
        return a;
      if (s == t)
        return null;
    }
  }
  prevMatch(e, t, i) {
    return this.prevMatchInRange(e, 0, t) || this.prevMatchInRange(e, i, e.doc.length);
  }
  getReplacement(e) {
    return this.spec.unquote(this.spec.replace).replace(/\$([$&\d+])/g, (t, i) => i == "$" ? "$" : i == "&" ? e.match[0] : i != "0" && +i < e.match.length ? e.match[i] : t);
  }
  matchAll(e, t) {
    let i = Di(this.spec, e, 0, e.doc.length), r = [];
    for (; !i.next().done; ) {
      if (r.length >= t)
        return null;
      r.push(i.value);
    }
    return r;
  }
  highlight(e, t, i, r) {
    let s = Di(this.spec, e, Math.max(
      0,
      t - 250
      /* RegExp.HighlightMargin */
    ), Math.min(i + 250, e.doc.length));
    for (; !s.next().done; )
      r(s.value.from, s.value.to);
  }
}
const ms = /* @__PURE__ */ te.define(), Sh = /* @__PURE__ */ te.define(), jn = /* @__PURE__ */ Ye.define({
  create(n) {
    return new El(hc(n).create(), null);
  },
  update(n, e) {
    for (let t of e.effects)
      t.is(ms) ? n = new El(t.value.create(), n.panel) : t.is(Sh) && (n = new El(n.query, t.value ? vh : null));
    return n;
  },
  provide: (n) => us.from(n, (e) => e.panel)
});
class El {
  constructor(e, t) {
    this.query = e, this.panel = t;
  }
}
const hP = /* @__PURE__ */ F.mark({ class: "cm-searchMatch" }), fP = /* @__PURE__ */ F.mark({ class: "cm-searchMatch cm-searchMatch-selected" }), dP = /* @__PURE__ */ Ie.fromClass(class {
  constructor(n) {
    this.view = n, this.decorations = this.highlight(n.state.field(jn));
  }
  update(n) {
    let e = n.state.field(jn);
    (e != n.startState.field(jn) || n.docChanged || n.selectionSet || n.viewportChanged) && (this.decorations = this.highlight(e));
  }
  highlight({ query: n, panel: e }) {
    if (!e || !n.spec.valid)
      return F.none;
    let { view: t } = this, i = new Fn();
    for (let r = 0, s = t.visibleRanges, o = s.length; r < o; r++) {
      let { from: a, to: l } = s[r];
      for (; r < o - 1 && l > s[r + 1].from - 2 * 250; )
        l = s[++r].to;
      n.highlight(t.state, a, l, (u, c) => {
        let h = t.state.selection.ranges.some((f) => f.from == u && f.to == c);
        i.add(u, c, h ? fP : hP);
      });
    }
    return i.finish();
  }
}, {
  decorations: (n) => n.decorations
});
function _s(n) {
  return (e) => {
    let t = e.state.field(jn, !1);
    return t && t.query.spec.valid ? n(e, t) : i0(e);
  };
}
const ka = /* @__PURE__ */ _s((n, { query: e }) => {
  let { to: t } = n.state.selection.main, i = e.nextMatch(n.state, t, t);
  if (!i)
    return !1;
  let r = $.single(i.from, i.to), s = n.state.facet(br);
  return n.dispatch({
    selection: r,
    effects: [Ph(n, i), s.scrollToMatch(r.main, n)],
    userEvent: "select.search"
  }), n0(n), !0;
}), xa = /* @__PURE__ */ _s((n, { query: e }) => {
  let { state: t } = n, { from: i } = t.selection.main, r = e.prevMatch(t, i, i);
  if (!r)
    return !1;
  let s = $.single(r.from, r.to), o = n.state.facet(br);
  return n.dispatch({
    selection: s,
    effects: [Ph(n, r), o.scrollToMatch(s.main, n)],
    userEvent: "select.search"
  }), n0(n), !0;
}), pP = /* @__PURE__ */ _s((n, { query: e }) => {
  let t = e.matchAll(n.state, 1e3);
  return !t || !t.length ? !1 : (n.dispatch({
    selection: $.create(t.map((i) => $.range(i.from, i.to))),
    userEvent: "select.search.matches"
  }), !0);
}), mP = ({ state: n, dispatch: e }) => {
  let t = n.selection;
  if (t.ranges.length > 1 || t.main.empty)
    return !1;
  let { from: i, to: r } = t.main, s = [], o = 0;
  for (let a = new or(n.doc, n.sliceDoc(i, r)); !a.next().done; ) {
    if (s.length > 1e3)
      return !1;
    a.value.from == i && (o = s.length), s.push($.range(a.value.from, a.value.to));
  }
  return e(n.update({
    selection: $.create(s, o),
    userEvent: "select.search.matches"
  })), !0;
}, tp = /* @__PURE__ */ _s((n, { query: e }) => {
  let { state: t } = n, { from: i, to: r } = t.selection.main;
  if (t.readOnly)
    return !1;
  let s = e.nextMatch(t, i, i);
  if (!s)
    return !1;
  let o = [], a, l, u = [];
  if (s.from == i && s.to == r && (l = t.toText(e.getReplacement(s)), o.push({ from: s.from, to: s.to, insert: l }), s = e.nextMatch(t, s.from, s.to), u.push(_.announce.of(t.phrase("replaced match on line $", t.doc.lineAt(i).number) + "."))), s) {
    let c = o.length == 0 || o[0].from >= s.to ? 0 : s.to - s.from - l.length;
    a = $.single(s.from - c, s.to - c), u.push(Ph(n, s)), u.push(t.facet(br).scrollToMatch(a.main, n));
  }
  return n.dispatch({
    changes: o,
    selection: a,
    effects: u,
    userEvent: "input.replace"
  }), !0;
}), gP = /* @__PURE__ */ _s((n, { query: e }) => {
  if (n.state.readOnly)
    return !1;
  let t = e.matchAll(n.state, 1e9).map((r) => {
    let { from: s, to: o } = r;
    return { from: s, to: o, insert: e.getReplacement(r) };
  });
  if (!t.length)
    return !1;
  let i = n.state.phrase("replaced $ matches", t.length) + ".";
  return n.dispatch({
    changes: t,
    effects: _.announce.of(i),
    userEvent: "input.replace.all"
  }), !0;
});
function vh(n) {
  return n.state.facet(br).createPanel(n);
}
function hc(n, e) {
  var t, i, r, s, o;
  let a = n.selection.main, l = a.empty || a.to > a.from + 100 ? "" : n.sliceDoc(a.from, a.to);
  if (e && !l)
    return e;
  let u = n.facet(br);
  return new J1({
    search: ((t = e == null ? void 0 : e.literal) !== null && t !== void 0 ? t : u.literal) ? l : l.replace(/\n/g, "\\n"),
    caseSensitive: (i = e == null ? void 0 : e.caseSensitive) !== null && i !== void 0 ? i : u.caseSensitive,
    literal: (r = e == null ? void 0 : e.literal) !== null && r !== void 0 ? r : u.literal,
    regexp: (s = e == null ? void 0 : e.regexp) !== null && s !== void 0 ? s : u.regexp,
    wholeWord: (o = e == null ? void 0 : e.wholeWord) !== null && o !== void 0 ? o : u.wholeWord
  });
}
function t0(n) {
  let e = ls(n, vh);
  return e && e.dom.querySelector("[main-field]");
}
function n0(n) {
  let e = t0(n);
  e && e == n.root.activeElement && e.select();
}
const i0 = (n) => {
  let e = n.state.field(jn, !1);
  if (e && e.panel) {
    let t = t0(n);
    if (t && t != n.root.activeElement) {
      let i = hc(n.state, e.query.spec);
      i.valid && n.dispatch({ effects: ms.of(i) }), t.focus(), t.select();
    }
  } else
    n.dispatch({ effects: [
      Sh.of(!0),
      e ? ms.of(hc(n.state, e.query.spec)) : te.appendConfig.of(kP)
    ] });
  return !0;
}, r0 = (n) => {
  let e = n.state.field(jn, !1);
  if (!e || !e.panel)
    return !1;
  let t = ls(n, vh);
  return t && t.dom.contains(n.root.activeElement) && n.focus(), n.dispatch({ effects: Sh.of(!1) }), !0;
}, OP = [
  { key: "Mod-f", run: i0, scope: "editor search-panel" },
  { key: "F3", run: ka, shift: xa, scope: "editor search-panel", preventDefault: !0 },
  { key: "Mod-g", run: ka, shift: xa, scope: "editor search-panel", preventDefault: !0 },
  { key: "Escape", run: r0, scope: "editor search-panel" },
  { key: "Mod-Shift-l", run: mP },
  { key: "Mod-Alt-g", run: U2 },
  { key: "Mod-d", run: oP, preventDefault: !0 }
];
class bP {
  constructor(e) {
    this.view = e;
    let t = this.query = e.state.field(jn).query.spec;
    this.commit = this.commit.bind(this), this.searchField = Se("input", {
      value: t.search,
      placeholder: xt(e, "Find"),
      "aria-label": xt(e, "Find"),
      class: "cm-textfield",
      name: "search",
      form: "",
      "main-field": "true",
      onchange: this.commit,
      onkeyup: this.commit
    }), this.replaceField = Se("input", {
      value: t.replace,
      placeholder: xt(e, "Replace"),
      "aria-label": xt(e, "Replace"),
      class: "cm-textfield",
      name: "replace",
      form: "",
      onchange: this.commit,
      onkeyup: this.commit
    }), this.caseField = Se("input", {
      type: "checkbox",
      name: "case",
      form: "",
      checked: t.caseSensitive,
      onchange: this.commit
    }), this.reField = Se("input", {
      type: "checkbox",
      name: "re",
      form: "",
      checked: t.regexp,
      onchange: this.commit
    }), this.wordField = Se("input", {
      type: "checkbox",
      name: "word",
      form: "",
      checked: t.wholeWord,
      onchange: this.commit
    });
    function i(r, s, o) {
      return Se("button", { class: "cm-button", name: r, onclick: s, type: "button" }, o);
    }
    this.dom = Se("div", { onkeydown: (r) => this.keydown(r), class: "cm-search" }, [
      this.searchField,
      i("next", () => ka(e), [xt(e, "next")]),
      i("prev", () => xa(e), [xt(e, "previous")]),
      i("select", () => pP(e), [xt(e, "all")]),
      Se("label", null, [this.caseField, xt(e, "match case")]),
      Se("label", null, [this.reField, xt(e, "regexp")]),
      Se("label", null, [this.wordField, xt(e, "by word")]),
      ...e.state.readOnly ? [] : [
        Se("br"),
        this.replaceField,
        i("replace", () => tp(e), [xt(e, "replace")]),
        i("replaceAll", () => gP(e), [xt(e, "replace all")])
      ],
      Se("button", {
        name: "close",
        onclick: () => r0(e),
        "aria-label": xt(e, "close"),
        type: "button"
      }, ["×"])
    ]);
  }
  commit() {
    let e = new J1({
      search: this.searchField.value,
      caseSensitive: this.caseField.checked,
      regexp: this.reField.checked,
      wholeWord: this.wordField.checked,
      replace: this.replaceField.value
    });
    e.eq(this.query) || (this.query = e, this.view.dispatch({ effects: ms.of(e) }));
  }
  keydown(e) {
    Pw(this.view, e, "search-panel") ? e.preventDefault() : e.keyCode == 13 && e.target == this.searchField ? (e.preventDefault(), (e.shiftKey ? xa : ka)(this.view)) : e.keyCode == 13 && e.target == this.replaceField && (e.preventDefault(), tp(this.view));
  }
  update(e) {
    for (let t of e.transactions)
      for (let i of t.effects)
        i.is(ms) && !i.value.eq(this.query) && this.setQuery(i.value);
  }
  setQuery(e) {
    this.query = e, this.searchField.value = e.search, this.replaceField.value = e.replace, this.caseField.checked = e.caseSensitive, this.reField.checked = e.regexp, this.wordField.checked = e.wholeWord;
  }
  mount() {
    this.searchField.select();
  }
  get pos() {
    return 80;
  }
  get top() {
    return this.view.state.facet(br).top;
  }
}
function xt(n, e) {
  return n.state.phrase(e);
}
const po = 30, mo = /[\s\.,:;?!]/;
function Ph(n, { from: e, to: t }) {
  let i = n.state.doc.lineAt(e), r = n.state.doc.lineAt(t).to, s = Math.max(i.from, e - po), o = Math.min(r, t + po), a = n.state.sliceDoc(s, o);
  if (s != i.from) {
    for (let l = 0; l < po; l++)
      if (!mo.test(a[l + 1]) && mo.test(a[l])) {
        a = a.slice(l);
        break;
      }
  }
  if (o != r) {
    for (let l = a.length - 1; l > a.length - po; l--)
      if (!mo.test(a[l - 1]) && mo.test(a[l])) {
        a = a.slice(0, l);
        break;
      }
  }
  return _.announce.of(`${n.state.phrase("current match")}. ${a} ${n.state.phrase("on line")} ${i.number}.`);
}
const yP = /* @__PURE__ */ _.baseTheme({
  ".cm-panel.cm-search": {
    padding: "2px 6px 4px",
    position: "relative",
    "& [name=close]": {
      position: "absolute",
      top: "0",
      right: "4px",
      backgroundColor: "inherit",
      border: "none",
      font: "inherit",
      padding: 0,
      margin: 0
    },
    "& input, & button, & label": {
      margin: ".2em .6em .2em 0"
    },
    "& input[type=checkbox]": {
      marginRight: ".2em"
    },
    "& label": {
      fontSize: "80%",
      whiteSpace: "pre"
    }
  },
  "&light .cm-searchMatch": { backgroundColor: "#ffff0054" },
  "&dark .cm-searchMatch": { backgroundColor: "#00ffff8a" },
  "&light .cm-searchMatch-selected": { backgroundColor: "#ff6a0054" },
  "&dark .cm-searchMatch-selected": { backgroundColor: "#ff00ff8a" }
}), kP = [
  jn,
  /* @__PURE__ */ Mn.low(dP),
  yP
];
class Qh {
  /**
  Create a new completion context. (Mostly useful for testing
  completion sources—in the editor, the extension will create
  these for you.)
  */
  constructor(e, t, i) {
    this.state = e, this.pos = t, this.explicit = i, this.abortListeners = [];
  }
  /**
  Get the extent, content, and (if there is a token) type of the
  token before `this.pos`.
  */
  tokenBefore(e) {
    let t = Pe(this.state).resolveInner(this.pos, -1);
    for (; t && e.indexOf(t.name) < 0; )
      t = t.parent;
    return t ? {
      from: t.from,
      to: this.pos,
      text: this.state.sliceDoc(t.from, this.pos),
      type: t.type
    } : null;
  }
  /**
  Get the match of the given expression directly before the
  cursor.
  */
  matchBefore(e) {
    let t = this.state.doc.lineAt(this.pos), i = Math.max(t.from, this.pos - 250), r = t.text.slice(i - t.from, this.pos - t.from), s = r.search(o0(e, !1));
    return s < 0 ? null : { from: i + s, to: this.pos, text: r.slice(s) };
  }
  /**
  Yields true when the query has been aborted. Can be useful in
  asynchronous queries to avoid doing work that will be ignored.
  */
  get aborted() {
    return this.abortListeners == null;
  }
  /**
  Allows you to register abort handlers, which will be called when
  the query is
  [aborted](https://codemirror.net/6/docs/ref/#autocomplete.CompletionContext.aborted).
  */
  addEventListener(e, t) {
    e == "abort" && this.abortListeners && this.abortListeners.push(t);
  }
}
function np(n) {
  let e = Object.keys(n).join(""), t = /\w/.test(e);
  return t && (e = e.replace(/\w/g, "")), `[${t ? "\\w" : ""}${e.replace(/[^\w\s]/g, "\\$&")}]`;
}
function xP(n) {
  let e = /* @__PURE__ */ Object.create(null), t = /* @__PURE__ */ Object.create(null);
  for (let { label: r } of n) {
    e[r[0]] = !0;
    for (let s = 1; s < r.length; s++)
      t[r[s]] = !0;
  }
  let i = np(e) + np(t) + "*$";
  return [new RegExp("^" + i), new RegExp(i)];
}
function s0(n) {
  let e = n.map((r) => typeof r == "string" ? { label: r } : r), [t, i] = e.every((r) => /^\w+$/.test(r.label)) ? [/\w*$/, /\w+$/] : xP(e);
  return (r) => {
    let s = r.matchBefore(i);
    return s || r.explicit ? { from: s ? s.from : r.pos, options: e, validFor: t } : null;
  };
}
function wP(n, e) {
  return (t) => {
    for (let i = Pe(t.state).resolveInner(t.pos, -1); i; i = i.parent) {
      if (n.indexOf(i.name) > -1)
        return null;
      if (i.type.isTop)
        break;
    }
    return e(t);
  };
}
class ip {
  constructor(e, t, i, r) {
    this.completion = e, this.source = t, this.match = i, this.score = r;
  }
}
function Un(n) {
  return n.selection.main.from;
}
function o0(n, e) {
  var t;
  let { source: i } = n, r = e && i[0] != "^", s = i[i.length - 1] != "$";
  return !r && !s ? n : new RegExp(`${r ? "^" : ""}(?:${i})${s ? "$" : ""}`, (t = n.flags) !== null && t !== void 0 ? t : n.ignoreCase ? "i" : "");
}
const $h = /* @__PURE__ */ Zn.define();
function SP(n, e, t, i) {
  let { main: r } = n.selection, s = t - r.from, o = i - r.from;
  return Object.assign(Object.assign({}, n.changeByRange((a) => a != r && t != i && n.sliceDoc(a.from + s, a.from + o) != n.sliceDoc(t, i) ? { range: a } : {
    changes: { from: a.from + s, to: i == r.from ? a.to : a.from + o, insert: e },
    range: $.cursor(a.from + s + e.length)
  })), { scrollIntoView: !0, userEvent: "input.complete" });
}
const rp = /* @__PURE__ */ new WeakMap();
function vP(n) {
  if (!Array.isArray(n))
    return n;
  let e = rp.get(n);
  return e || rp.set(n, e = s0(n)), e;
}
const wa = /* @__PURE__ */ te.define(), gs = /* @__PURE__ */ te.define();
class PP {
  constructor(e) {
    this.pattern = e, this.chars = [], this.folded = [], this.any = [], this.precise = [], this.byWord = [], this.score = 0, this.matched = [];
    for (let t = 0; t < e.length; ) {
      let i = Ue(e, t), r = Rt(i);
      this.chars.push(i);
      let s = e.slice(t, t + r), o = s.toUpperCase();
      this.folded.push(Ue(o == s ? s.toLowerCase() : o, 0)), t += r;
    }
    this.astral = e.length != this.chars.length;
  }
  ret(e, t) {
    return this.score = e, this.matched = t, this;
  }
  // Matches a given word (completion) against the pattern (input).
  // Will return a boolean indicating whether there was a match and,
  // on success, set `this.score` to the score, `this.matched` to an
  // array of `from, to` pairs indicating the matched parts of `word`.
  //
  // The score is a number that is more negative the worse the match
  // is. See `Penalty` above.
  match(e) {
    if (this.pattern.length == 0)
      return this.ret(-100, []);
    if (e.length < this.pattern.length)
      return null;
    let { chars: t, folded: i, any: r, precise: s, byWord: o } = this;
    if (t.length == 1) {
      let b = Ue(e, 0), w = Rt(b), Q = w == e.length ? 0 : -100;
      if (b != t[0])
        if (b == i[0])
          Q += -200;
        else
          return null;
      return this.ret(Q, [0, w]);
    }
    let a = e.indexOf(this.pattern);
    if (a == 0)
      return this.ret(e.length == this.pattern.length ? 0 : -100, [0, this.pattern.length]);
    let l = t.length, u = 0;
    if (a < 0) {
      for (let b = 0, w = Math.min(e.length, 200); b < w && u < l; ) {
        let Q = Ue(e, b);
        (Q == t[u] || Q == i[u]) && (r[u++] = b), b += Rt(Q);
      }
      if (u < l)
        return null;
    }
    let c = 0, h = 0, f = !1, d = 0, p = -1, g = -1, O = /[a-z]/.test(e), m = !0;
    for (let b = 0, w = Math.min(e.length, 200), Q = 0; b < w && h < l; ) {
      let v = Ue(e, b);
      a < 0 && (c < l && v == t[c] && (s[c++] = b), d < l && (v == t[d] || v == i[d] ? (d == 0 && (p = b), g = b + 1, d++) : d = 0));
      let k, C = v < 255 ? v >= 48 && v <= 57 || v >= 97 && v <= 122 ? 2 : v >= 65 && v <= 90 ? 1 : 0 : (k = Kc(v)) != k.toLowerCase() ? 1 : k != k.toUpperCase() ? 2 : 0;
      (!b || C == 1 && O || Q == 0 && C != 0) && (t[h] == v || i[h] == v && (f = !0) ? o[h++] = b : o.length && (m = !1)), Q = C, b += Rt(v);
    }
    return h == l && o[0] == 0 && m ? this.result(-100 + (f ? -200 : 0), o, e) : d == l && p == 0 ? this.ret(-200 - e.length + (g == e.length ? 0 : -100), [0, g]) : a > -1 ? this.ret(-700 - e.length, [a, a + this.pattern.length]) : d == l ? this.ret(-900 - e.length, [p, g]) : h == l ? this.result(-100 + (f ? -200 : 0) + -700 + (m ? 0 : -1100), o, e) : t.length == 2 ? null : this.result((r[0] ? -700 : 0) + -200 + -1100, r, e);
  }
  result(e, t, i) {
    let r = [], s = 0;
    for (let o of t) {
      let a = o + (this.astral ? Rt(Ue(i, o)) : 1);
      s && r[s - 1] == o ? r[s - 1] = a : (r[s++] = o, r[s++] = a);
    }
    return this.ret(e - i.length, r);
  }
}
class QP {
  constructor(e) {
    this.pattern = e, this.matched = [], this.score = 0, this.folded = e.toLowerCase();
  }
  match(e) {
    if (e.length < this.pattern.length)
      return null;
    let t = e.slice(0, this.pattern.length), i = t == this.pattern ? 0 : t.toLowerCase() == this.folded ? -200 : null;
    return i == null ? null : (this.matched = [0, t.length], this.score = i + (e.length == this.pattern.length ? 0 : -100), this);
  }
}
const He = /* @__PURE__ */ N.define({
  combine(n) {
    return pn(n, {
      activateOnTyping: !0,
      activateOnCompletion: () => !1,
      activateOnTypingDelay: 100,
      selectOnOpen: !0,
      override: null,
      closeOnBlur: !0,
      maxRenderedOptions: 100,
      defaultKeymap: !0,
      tooltipClass: () => "",
      optionClass: () => "",
      aboveCursor: !1,
      icons: !0,
      addToOptions: [],
      positionInfo: $P,
      filterStrict: !1,
      compareCompletions: (e, t) => e.label.localeCompare(t.label),
      interactionDelay: 75,
      updateSyncTime: 100
    }, {
      defaultKeymap: (e, t) => e && t,
      closeOnBlur: (e, t) => e && t,
      icons: (e, t) => e && t,
      tooltipClass: (e, t) => (i) => sp(e(i), t(i)),
      optionClass: (e, t) => (i) => sp(e(i), t(i)),
      addToOptions: (e, t) => e.concat(t),
      filterStrict: (e, t) => e || t
    });
  }
});
function sp(n, e) {
  return n ? e ? n + " " + e : n : e;
}
function $P(n, e, t, i, r, s) {
  let o = n.textDirection == Ae.RTL, a = o, l = !1, u = "top", c, h, f = e.left - r.left, d = r.right - e.right, p = i.right - i.left, g = i.bottom - i.top;
  if (a && f < Math.min(p, d) ? a = !1 : !a && d < Math.min(p, f) && (a = !0), p <= (a ? f : d))
    c = Math.max(r.top, Math.min(t.top, r.bottom - g)) - e.top, h = Math.min(400, a ? f : d);
  else {
    l = !0, h = Math.min(
      400,
      (o ? e.right : r.right - e.left) - 30
      /* Info.Margin */
    );
    let b = r.bottom - e.bottom;
    b >= g || b > e.top ? c = t.bottom - e.top : (u = "bottom", c = e.bottom - t.top);
  }
  let O = (e.bottom - e.top) / s.offsetHeight, m = (e.right - e.left) / s.offsetWidth;
  return {
    style: `${u}: ${c / O}px; max-width: ${h / m}px`,
    class: "cm-completionInfo-" + (l ? o ? "left-narrow" : "right-narrow" : a ? "left" : "right")
  };
}
function CP(n) {
  let e = n.addToOptions.slice();
  return n.icons && e.push({
    render(t) {
      let i = document.createElement("div");
      return i.classList.add("cm-completionIcon"), t.type && i.classList.add(...t.type.split(/\s+/g).map((r) => "cm-completionIcon-" + r)), i.setAttribute("aria-hidden", "true"), i;
    },
    position: 20
  }), e.push({
    render(t, i, r, s) {
      let o = document.createElement("span");
      o.className = "cm-completionLabel";
      let a = t.displayLabel || t.label, l = 0;
      for (let u = 0; u < s.length; ) {
        let c = s[u++], h = s[u++];
        c > l && o.appendChild(document.createTextNode(a.slice(l, c)));
        let f = o.appendChild(document.createElement("span"));
        f.appendChild(document.createTextNode(a.slice(c, h))), f.className = "cm-completionMatchedText", l = h;
      }
      return l < a.length && o.appendChild(document.createTextNode(a.slice(l))), o;
    },
    position: 50
  }, {
    render(t) {
      if (!t.detail)
        return null;
      let i = document.createElement("span");
      return i.className = "cm-completionDetail", i.textContent = t.detail, i;
    },
    position: 80
  }), e.sort((t, i) => t.position - i.position).map((t) => t.render);
}
function zl(n, e, t) {
  if (n <= t)
    return { from: 0, to: n };
  if (e < 0 && (e = 0), e <= n >> 1) {
    let r = Math.floor(e / t);
    return { from: r * t, to: (r + 1) * t };
  }
  let i = Math.floor((n - e) / t);
  return { from: n - (i + 1) * t, to: n - i * t };
}
class TP {
  constructor(e, t, i) {
    this.view = e, this.stateField = t, this.applyCompletion = i, this.info = null, this.infoDestroy = null, this.placeInfoReq = {
      read: () => this.measureInfo(),
      write: (l) => this.placeInfo(l),
      key: this
    }, this.space = null, this.currentClass = "";
    let r = e.state.field(t), { options: s, selected: o } = r.open, a = e.state.facet(He);
    this.optionContent = CP(a), this.optionClass = a.optionClass, this.tooltipClass = a.tooltipClass, this.range = zl(s.length, o, a.maxRenderedOptions), this.dom = document.createElement("div"), this.dom.className = "cm-tooltip-autocomplete", this.updateTooltipClass(e.state), this.dom.addEventListener("mousedown", (l) => {
      let { options: u } = e.state.field(t).open;
      for (let c = l.target, h; c && c != this.dom; c = c.parentNode)
        if (c.nodeName == "LI" && (h = /-(\d+)$/.exec(c.id)) && +h[1] < u.length) {
          this.applyCompletion(e, u[+h[1]]), l.preventDefault();
          return;
        }
    }), this.dom.addEventListener("focusout", (l) => {
      let u = e.state.field(this.stateField, !1);
      u && u.tooltip && e.state.facet(He).closeOnBlur && l.relatedTarget != e.contentDOM && e.dispatch({ effects: gs.of(null) });
    }), this.showOptions(s, r.id);
  }
  mount() {
    this.updateSel();
  }
  showOptions(e, t) {
    this.list && this.list.remove(), this.list = this.dom.appendChild(this.createListBox(e, t, this.range)), this.list.addEventListener("scroll", () => {
      this.info && this.view.requestMeasure(this.placeInfoReq);
    });
  }
  update(e) {
    var t;
    let i = e.state.field(this.stateField), r = e.startState.field(this.stateField);
    if (this.updateTooltipClass(e.state), i != r) {
      let { options: s, selected: o, disabled: a } = i.open;
      (!r.open || r.open.options != s) && (this.range = zl(s.length, o, e.state.facet(He).maxRenderedOptions), this.showOptions(s, i.id)), this.updateSel(), a != ((t = r.open) === null || t === void 0 ? void 0 : t.disabled) && this.dom.classList.toggle("cm-tooltip-autocomplete-disabled", !!a);
    }
  }
  updateTooltipClass(e) {
    let t = this.tooltipClass(e);
    if (t != this.currentClass) {
      for (let i of this.currentClass.split(" "))
        i && this.dom.classList.remove(i);
      for (let i of t.split(" "))
        i && this.dom.classList.add(i);
      this.currentClass = t;
    }
  }
  positioned(e) {
    this.space = e, this.info && this.view.requestMeasure(this.placeInfoReq);
  }
  updateSel() {
    let e = this.view.state.field(this.stateField), t = e.open;
    if ((t.selected > -1 && t.selected < this.range.from || t.selected >= this.range.to) && (this.range = zl(t.options.length, t.selected, this.view.state.facet(He).maxRenderedOptions), this.showOptions(t.options, e.id)), this.updateSelectedOption(t.selected)) {
      this.destroyInfo();
      let { completion: i } = t.options[t.selected], { info: r } = i;
      if (!r)
        return;
      let s = typeof r == "string" ? document.createTextNode(r) : r(i);
      if (!s)
        return;
      "then" in s ? s.then((o) => {
        o && this.view.state.field(this.stateField, !1) == e && this.addInfoPane(o, i);
      }).catch((o) => mt(this.view.state, o, "completion info")) : this.addInfoPane(s, i);
    }
  }
  addInfoPane(e, t) {
    this.destroyInfo();
    let i = this.info = document.createElement("div");
    if (i.className = "cm-tooltip cm-completionInfo", e.nodeType != null)
      i.appendChild(e), this.infoDestroy = null;
    else {
      let { dom: r, destroy: s } = e;
      i.appendChild(r), this.infoDestroy = s || null;
    }
    this.dom.appendChild(i), this.view.requestMeasure(this.placeInfoReq);
  }
  updateSelectedOption(e) {
    let t = null;
    for (let i = this.list.firstChild, r = this.range.from; i; i = i.nextSibling, r++)
      i.nodeName != "LI" || !i.id ? r-- : r == e ? i.hasAttribute("aria-selected") || (i.setAttribute("aria-selected", "true"), t = i) : i.hasAttribute("aria-selected") && i.removeAttribute("aria-selected");
    return t && RP(this.list, t), t;
  }
  measureInfo() {
    let e = this.dom.querySelector("[aria-selected]");
    if (!e || !this.info)
      return null;
    let t = this.dom.getBoundingClientRect(), i = this.info.getBoundingClientRect(), r = e.getBoundingClientRect(), s = this.space;
    if (!s) {
      let o = this.dom.ownerDocument.defaultView || window;
      s = { left: 0, top: 0, right: o.innerWidth, bottom: o.innerHeight };
    }
    return r.top > Math.min(s.bottom, t.bottom) - 10 || r.bottom < Math.max(s.top, t.top) + 10 ? null : this.view.state.facet(He).positionInfo(this.view, t, r, i, s, this.dom);
  }
  placeInfo(e) {
    this.info && (e ? (e.style && (this.info.style.cssText = e.style), this.info.className = "cm-tooltip cm-completionInfo " + (e.class || "")) : this.info.style.cssText = "top: -1e6px");
  }
  createListBox(e, t, i) {
    const r = document.createElement("ul");
    r.id = t, r.setAttribute("role", "listbox"), r.setAttribute("aria-expanded", "true"), r.setAttribute("aria-label", this.view.state.phrase("Completions"));
    let s = null;
    for (let o = i.from; o < i.to; o++) {
      let { completion: a, match: l } = e[o], { section: u } = a;
      if (u) {
        let f = typeof u == "string" ? u : u.name;
        if (f != s && (o > i.from || i.from == 0))
          if (s = f, typeof u != "string" && u.header)
            r.appendChild(u.header(u));
          else {
            let d = r.appendChild(document.createElement("completion-section"));
            d.textContent = f;
          }
      }
      const c = r.appendChild(document.createElement("li"));
      c.id = t + "-" + o, c.setAttribute("role", "option");
      let h = this.optionClass(a);
      h && (c.className = h);
      for (let f of this.optionContent) {
        let d = f(a, this.view.state, this.view, l);
        d && c.appendChild(d);
      }
    }
    return i.from && r.classList.add("cm-completionListIncompleteTop"), i.to < e.length && r.classList.add("cm-completionListIncompleteBottom"), r;
  }
  destroyInfo() {
    this.info && (this.infoDestroy && this.infoDestroy(), this.info.remove(), this.info = null);
  }
  destroy() {
    this.destroyInfo();
  }
}
function AP(n, e) {
  return (t) => new TP(t, n, e);
}
function RP(n, e) {
  let t = n.getBoundingClientRect(), i = e.getBoundingClientRect(), r = t.height / n.offsetHeight;
  i.top < t.top ? n.scrollTop -= (t.top - i.top) / r : i.bottom > t.bottom && (n.scrollTop += (i.bottom - t.bottom) / r);
}
function op(n) {
  return (n.boost || 0) * 100 + (n.apply ? 10 : 0) + (n.info ? 5 : 0) + (n.type ? 1 : 0);
}
function MP(n, e) {
  let t = [], i = null, r = (u) => {
    t.push(u);
    let { section: c } = u.completion;
    if (c) {
      i || (i = []);
      let h = typeof c == "string" ? c : c.name;
      i.some((f) => f.name == h) || i.push(typeof c == "string" ? { name: h } : c);
    }
  }, s = e.facet(He);
  for (let u of n)
    if (u.hasResult()) {
      let c = u.result.getMatch;
      if (u.result.filter === !1)
        for (let h of u.result.options)
          r(new ip(h, u.source, c ? c(h) : [], 1e9 - t.length));
      else {
        let h = e.sliceDoc(u.from, u.to), f, d = s.filterStrict ? new QP(h) : new PP(h);
        for (let p of u.result.options)
          if (f = d.match(p.label)) {
            let g = p.displayLabel ? c ? c(p, f.matched) : [] : f.matched;
            r(new ip(p, u.source, g, f.score + (p.boost || 0)));
          }
      }
    }
  if (i) {
    let u = /* @__PURE__ */ Object.create(null), c = 0, h = (f, d) => {
      var p, g;
      return ((p = f.rank) !== null && p !== void 0 ? p : 1e9) - ((g = d.rank) !== null && g !== void 0 ? g : 1e9) || (f.name < d.name ? -1 : 1);
    };
    for (let f of i.sort(h))
      c -= 1e5, u[f.name] = c;
    for (let f of t) {
      let { section: d } = f.completion;
      d && (f.score += u[typeof d == "string" ? d : d.name]);
    }
  }
  let o = [], a = null, l = s.compareCompletions;
  for (let u of t.sort((c, h) => h.score - c.score || l(c.completion, h.completion))) {
    let c = u.completion;
    !a || a.label != c.label || a.detail != c.detail || a.type != null && c.type != null && a.type != c.type || a.apply != c.apply || a.boost != c.boost ? o.push(u) : op(u.completion) > op(a) && (o[o.length - 1] = u), a = u.completion;
  }
  return o;
}
class Ni {
  constructor(e, t, i, r, s, o) {
    this.options = e, this.attrs = t, this.tooltip = i, this.timestamp = r, this.selected = s, this.disabled = o;
  }
  setSelected(e, t) {
    return e == this.selected || e >= this.options.length ? this : new Ni(this.options, ap(t, e), this.tooltip, this.timestamp, e, this.disabled);
  }
  static build(e, t, i, r, s) {
    let o = MP(e, t);
    if (!o.length)
      return r && e.some(
        (l) => l.state == 1
        /* State.Pending */
      ) ? new Ni(r.options, r.attrs, r.tooltip, r.timestamp, r.selected, !0) : null;
    let a = t.facet(He).selectOnOpen ? 0 : -1;
    if (r && r.selected != a && r.selected != -1) {
      let l = r.options[r.selected].completion;
      for (let u = 0; u < o.length; u++)
        if (o[u].completion == l) {
          a = u;
          break;
        }
    }
    return new Ni(o, ap(i, a), {
      pos: e.reduce((l, u) => u.hasResult() ? Math.min(l, u.from) : l, 1e8),
      create: IP,
      above: s.aboveCursor
    }, r ? r.timestamp : Date.now(), a, !1);
  }
  map(e) {
    return new Ni(this.options, this.attrs, Object.assign(Object.assign({}, this.tooltip), { pos: e.mapPos(this.tooltip.pos) }), this.timestamp, this.selected, this.disabled);
  }
}
class Sa {
  constructor(e, t, i) {
    this.active = e, this.id = t, this.open = i;
  }
  static start() {
    return new Sa(zP, "cm-ac-" + Math.floor(Math.random() * 2e6).toString(36), null);
  }
  update(e) {
    let { state: t } = e, i = t.facet(He), s = (i.override || t.languageDataAt("autocomplete", Un(t)).map(vP)).map((a) => (this.active.find((u) => u.source == a) || new st(
      a,
      this.active.some(
        (u) => u.state != 0
        /* State.Inactive */
      ) ? 1 : 0
      /* State.Inactive */
    )).update(e, i));
    s.length == this.active.length && s.every((a, l) => a == this.active[l]) && (s = this.active);
    let o = this.open;
    o && e.docChanged && (o = o.map(e.changes)), e.selection || s.some((a) => a.hasResult() && e.changes.touchesRange(a.from, a.to)) || !ZP(s, this.active) ? o = Ni.build(s, t, this.id, o, i) : o && o.disabled && !s.some(
      (a) => a.state == 1
      /* State.Pending */
    ) && (o = null), !o && s.every(
      (a) => a.state != 1
      /* State.Pending */
    ) && s.some((a) => a.hasResult()) && (s = s.map((a) => a.hasResult() ? new st(
      a.source,
      0
      /* State.Inactive */
    ) : a));
    for (let a of e.effects)
      a.is(l0) && (o = o && o.setSelected(a.value, this.id));
    return s == this.active && o == this.open ? this : new Sa(s, this.id, o);
  }
  get tooltip() {
    return this.open ? this.open.tooltip : null;
  }
  get attrs() {
    return this.open ? this.open.attrs : EP;
  }
}
function ZP(n, e) {
  if (n == e)
    return !0;
  for (let t = 0, i = 0; ; ) {
    for (; t < n.length && !n[t].hasResult; )
      t++;
    for (; i < e.length && !e[i].hasResult; )
      i++;
    let r = t == n.length, s = i == e.length;
    if (r || s)
      return r == s;
    if (n[t++].result != e[i++].result)
      return !1;
  }
}
const EP = {
  "aria-autocomplete": "list"
};
function ap(n, e) {
  let t = {
    "aria-autocomplete": "list",
    "aria-haspopup": "listbox",
    "aria-controls": n
  };
  return e > -1 && (t["aria-activedescendant"] = n + "-" + e), t;
}
const zP = [];
function fc(n, e) {
  if (n.isUserEvent("input.complete")) {
    let t = n.annotation($h);
    if (t && e.activateOnCompletion(t))
      return "input";
  }
  return n.isUserEvent("input.type") ? "input" : n.isUserEvent("delete.backward") ? "delete" : null;
}
class st {
  constructor(e, t, i = -1) {
    this.source = e, this.state = t, this.explicitPos = i;
  }
  hasResult() {
    return !1;
  }
  update(e, t) {
    let i = fc(e, t), r = this;
    i ? r = r.handleUserEvent(e, i, t) : e.docChanged ? r = r.handleChange(e) : e.selection && r.state != 0 && (r = new st(
      r.source,
      0
      /* State.Inactive */
    ));
    for (let s of e.effects)
      if (s.is(wa))
        r = new st(r.source, 1, s.value ? Un(e.state) : -1);
      else if (s.is(gs))
        r = new st(
          r.source,
          0
          /* State.Inactive */
        );
      else if (s.is(a0))
        for (let o of s.value)
          o.source == r.source && (r = o);
    return r;
  }
  handleUserEvent(e, t, i) {
    return t == "delete" || !i.activateOnTyping ? this.map(e.changes) : new st(
      this.source,
      1
      /* State.Pending */
    );
  }
  handleChange(e) {
    return e.changes.touchesRange(Un(e.startState)) ? new st(
      this.source,
      0
      /* State.Inactive */
    ) : this.map(e.changes);
  }
  map(e) {
    return e.empty || this.explicitPos < 0 ? this : new st(this.source, this.state, e.mapPos(this.explicitPos));
  }
}
class Fi extends st {
  constructor(e, t, i, r, s) {
    super(e, 2, t), this.result = i, this.from = r, this.to = s;
  }
  hasResult() {
    return !0;
  }
  handleUserEvent(e, t, i) {
    var r;
    let s = this.result;
    s.map && !e.changes.empty && (s = s.map(s, e.changes));
    let o = e.changes.mapPos(this.from), a = e.changes.mapPos(this.to, 1), l = Un(e.state);
    if ((this.explicitPos < 0 ? l <= o : l < this.from) || l > a || !s || t == "delete" && Un(e.startState) == this.from)
      return new st(
        this.source,
        t == "input" && i.activateOnTyping ? 1 : 0
        /* State.Inactive */
      );
    let u = this.explicitPos < 0 ? -1 : e.changes.mapPos(this.explicitPos);
    return DP(s.validFor, e.state, o, a) ? new Fi(this.source, u, s, o, a) : s.update && (s = s.update(s, o, a, new Qh(e.state, l, u >= 0))) ? new Fi(this.source, u, s, s.from, (r = s.to) !== null && r !== void 0 ? r : Un(e.state)) : new st(this.source, 1, u);
  }
  handleChange(e) {
    return e.changes.touchesRange(this.from, this.to) ? new st(
      this.source,
      0
      /* State.Inactive */
    ) : this.map(e.changes);
  }
  map(e) {
    return e.empty ? this : (this.result.map ? this.result.map(this.result, e) : this.result) ? new Fi(this.source, this.explicitPos < 0 ? -1 : e.mapPos(this.explicitPos), this.result, e.mapPos(this.from), e.mapPos(this.to, 1)) : new st(
      this.source,
      0
      /* State.Inactive */
    );
  }
}
function DP(n, e, t, i) {
  if (!n)
    return !1;
  let r = e.sliceDoc(t, i);
  return typeof n == "function" ? n(r, t, i, e) : o0(n, !0).test(r);
}
const a0 = /* @__PURE__ */ te.define({
  map(n, e) {
    return n.map((t) => t.map(e));
  }
}), l0 = /* @__PURE__ */ te.define(), pt = /* @__PURE__ */ Ye.define({
  create() {
    return Sa.start();
  },
  update(n, e) {
    return n.update(e);
  },
  provide: (n) => [
    ch.from(n, (e) => e.tooltip),
    _.contentAttributes.from(n, (e) => e.attrs)
  ]
});
function Ch(n, e) {
  const t = e.completion.apply || e.completion.label;
  let i = n.state.field(pt).active.find((r) => r.source == e.source);
  return i instanceof Fi ? (typeof t == "string" ? n.dispatch(Object.assign(Object.assign({}, SP(n.state, t, i.from, i.to)), { annotations: $h.of(e.completion) })) : t(n, e.completion, i.from, i.to), !0) : !1;
}
const IP = /* @__PURE__ */ AP(pt, Ch);
function go(n, e = "option") {
  return (t) => {
    let i = t.state.field(pt, !1);
    if (!i || !i.open || i.open.disabled || Date.now() - i.open.timestamp < t.state.facet(He).interactionDelay)
      return !1;
    let r = 1, s;
    e == "page" && (s = WO(t, i.open.tooltip)) && (r = Math.max(2, Math.floor(s.dom.offsetHeight / s.dom.querySelector("li").offsetHeight) - 1));
    let { length: o } = i.open.options, a = i.open.selected > -1 ? i.open.selected + r * (n ? 1 : -1) : n ? 0 : o - 1;
    return a < 0 ? a = e == "page" ? 0 : o - 1 : a >= o && (a = e == "page" ? o - 1 : 0), t.dispatch({ effects: l0.of(a) }), !0;
  };
}
const LP = (n) => {
  let e = n.state.field(pt, !1);
  return n.state.readOnly || !e || !e.open || e.open.selected < 0 || e.open.disabled || Date.now() - e.open.timestamp < n.state.facet(He).interactionDelay ? !1 : Ch(n, e.open.options[e.open.selected]);
}, _P = (n) => n.state.field(pt, !1) ? (n.dispatch({ effects: wa.of(!0) }), !0) : !1, XP = (n) => {
  let e = n.state.field(pt, !1);
  return !e || !e.active.some(
    (t) => t.state != 0
    /* State.Inactive */
  ) ? !1 : (n.dispatch({ effects: gs.of(null) }), !0);
};
class NP {
  constructor(e, t) {
    this.active = e, this.context = t, this.time = Date.now(), this.updates = [], this.done = void 0;
  }
}
const WP = 50, qP = 1e3, BP = /* @__PURE__ */ Ie.fromClass(class {
  constructor(n) {
    this.view = n, this.debounceUpdate = -1, this.running = [], this.debounceAccept = -1, this.pendingStart = !1, this.composing = 0;
    for (let e of n.state.field(pt).active)
      e.state == 1 && this.startQuery(e);
  }
  update(n) {
    let e = n.state.field(pt), t = n.state.facet(He);
    if (!n.selectionSet && !n.docChanged && n.startState.field(pt) == e)
      return;
    let i = n.transactions.some((s) => (s.selection || s.docChanged) && !fc(s, t));
    for (let s = 0; s < this.running.length; s++) {
      let o = this.running[s];
      if (i || o.updates.length + n.transactions.length > WP && Date.now() - o.time > qP) {
        for (let a of o.context.abortListeners)
          try {
            a();
          } catch (l) {
            mt(this.view.state, l);
          }
        o.context.abortListeners = null, this.running.splice(s--, 1);
      } else
        o.updates.push(...n.transactions);
    }
    this.debounceUpdate > -1 && clearTimeout(this.debounceUpdate), n.transactions.some((s) => s.effects.some((o) => o.is(wa))) && (this.pendingStart = !0);
    let r = this.pendingStart ? 50 : t.activateOnTypingDelay;
    if (this.debounceUpdate = e.active.some((s) => s.state == 1 && !this.running.some((o) => o.active.source == s.source)) ? setTimeout(() => this.startUpdate(), r) : -1, this.composing != 0)
      for (let s of n.transactions)
        fc(s, t) == "input" ? this.composing = 2 : this.composing == 2 && s.selection && (this.composing = 3);
  }
  startUpdate() {
    this.debounceUpdate = -1, this.pendingStart = !1;
    let { state: n } = this.view, e = n.field(pt);
    for (let t of e.active)
      t.state == 1 && !this.running.some((i) => i.active.source == t.source) && this.startQuery(t);
  }
  startQuery(n) {
    let { state: e } = this.view, t = Un(e), i = new Qh(e, t, n.explicitPos == t), r = new NP(n, i);
    this.running.push(r), Promise.resolve(n.source(i)).then((s) => {
      r.context.aborted || (r.done = s || null, this.scheduleAccept());
    }, (s) => {
      this.view.dispatch({ effects: gs.of(null) }), mt(this.view.state, s);
    });
  }
  scheduleAccept() {
    this.running.every((n) => n.done !== void 0) ? this.accept() : this.debounceAccept < 0 && (this.debounceAccept = setTimeout(() => this.accept(), this.view.state.facet(He).updateSyncTime));
  }
  // For each finished query in this.running, try to create a result
  // or, if appropriate, restart the query.
  accept() {
    var n;
    this.debounceAccept > -1 && clearTimeout(this.debounceAccept), this.debounceAccept = -1;
    let e = [], t = this.view.state.facet(He);
    for (let i = 0; i < this.running.length; i++) {
      let r = this.running[i];
      if (r.done === void 0)
        continue;
      if (this.running.splice(i--, 1), r.done) {
        let o = new Fi(r.active.source, r.active.explicitPos, r.done, r.done.from, (n = r.done.to) !== null && n !== void 0 ? n : Un(r.updates.length ? r.updates[0].startState : this.view.state));
        for (let a of r.updates)
          o = o.update(a, t);
        if (o.hasResult()) {
          e.push(o);
          continue;
        }
      }
      let s = this.view.state.field(pt).active.find((o) => o.source == r.active.source);
      if (s && s.state == 1)
        if (r.done == null) {
          let o = new st(
            r.active.source,
            0
            /* State.Inactive */
          );
          for (let a of r.updates)
            o = o.update(a, t);
          o.state != 1 && e.push(o);
        } else
          this.startQuery(s);
    }
    e.length && this.view.dispatch({ effects: a0.of(e) });
  }
}, {
  eventHandlers: {
    blur(n) {
      let e = this.view.state.field(pt, !1);
      if (e && e.tooltip && this.view.state.facet(He).closeOnBlur) {
        let t = e.open && WO(this.view, e.open.tooltip);
        (!t || !t.dom.contains(n.relatedTarget)) && setTimeout(() => this.view.dispatch({ effects: gs.of(null) }), 10);
      }
    },
    compositionstart() {
      this.composing = 1;
    },
    compositionend() {
      this.composing == 3 && setTimeout(() => this.view.dispatch({ effects: wa.of(!1) }), 20), this.composing = 0;
    }
  }
}), VP = typeof navigator == "object" && /* @__PURE__ */ /Win/.test(navigator.platform), YP = /* @__PURE__ */ Mn.highest(/* @__PURE__ */ _.domEventHandlers({
  keydown(n, e) {
    let t = e.state.field(pt, !1);
    if (!t || !t.open || t.open.disabled || t.open.selected < 0 || n.key.length > 1 || n.ctrlKey && !(VP && n.altKey) || n.metaKey)
      return !1;
    let i = t.open.options[t.open.selected], r = t.active.find((o) => o.source == i.source), s = i.completion.commitCharacters || r.result.commitCharacters;
    return s && s.indexOf(n.key) > -1 && Ch(e, i), !1;
  }
})), u0 = /* @__PURE__ */ _.baseTheme({
  ".cm-tooltip.cm-tooltip-autocomplete": {
    "& > ul": {
      fontFamily: "monospace",
      whiteSpace: "nowrap",
      overflow: "hidden auto",
      maxWidth_fallback: "700px",
      maxWidth: "min(700px, 95vw)",
      minWidth: "250px",
      maxHeight: "10em",
      height: "100%",
      listStyle: "none",
      margin: 0,
      padding: 0,
      "& > li, & > completion-section": {
        padding: "1px 3px",
        lineHeight: 1.2
      },
      "& > li": {
        overflowX: "hidden",
        textOverflow: "ellipsis",
        cursor: "pointer"
      },
      "& > completion-section": {
        display: "list-item",
        borderBottom: "1px solid silver",
        paddingLeft: "0.5em",
        opacity: 0.7
      }
    }
  },
  "&light .cm-tooltip-autocomplete ul li[aria-selected]": {
    background: "#17c",
    color: "white"
  },
  "&light .cm-tooltip-autocomplete-disabled ul li[aria-selected]": {
    background: "#777"
  },
  "&dark .cm-tooltip-autocomplete ul li[aria-selected]": {
    background: "#347",
    color: "white"
  },
  "&dark .cm-tooltip-autocomplete-disabled ul li[aria-selected]": {
    background: "#444"
  },
  ".cm-completionListIncompleteTop:before, .cm-completionListIncompleteBottom:after": {
    content: '"···"',
    opacity: 0.5,
    display: "block",
    textAlign: "center"
  },
  ".cm-tooltip.cm-completionInfo": {
    position: "absolute",
    padding: "3px 9px",
    width: "max-content",
    maxWidth: "400px",
    boxSizing: "border-box"
  },
  ".cm-completionInfo.cm-completionInfo-left": { right: "100%" },
  ".cm-completionInfo.cm-completionInfo-right": { left: "100%" },
  ".cm-completionInfo.cm-completionInfo-left-narrow": { right: "30px" },
  ".cm-completionInfo.cm-completionInfo-right-narrow": { left: "30px" },
  "&light .cm-snippetField": { backgroundColor: "#00000022" },
  "&dark .cm-snippetField": { backgroundColor: "#ffffff22" },
  ".cm-snippetFieldPosition": {
    verticalAlign: "text-top",
    width: 0,
    height: "1.15em",
    display: "inline-block",
    margin: "0 -0.7px -.7em",
    borderLeft: "1.4px dotted #888"
  },
  ".cm-completionMatchedText": {
    textDecoration: "underline"
  },
  ".cm-completionDetail": {
    marginLeft: "0.5em",
    fontStyle: "italic"
  },
  ".cm-completionIcon": {
    fontSize: "90%",
    width: ".8em",
    display: "inline-block",
    textAlign: "center",
    paddingRight: ".6em",
    opacity: "0.6",
    boxSizing: "content-box"
  },
  ".cm-completionIcon-function, .cm-completionIcon-method": {
    "&:after": { content: "'ƒ'" }
  },
  ".cm-completionIcon-class": {
    "&:after": { content: "'○'" }
  },
  ".cm-completionIcon-interface": {
    "&:after": { content: "'◌'" }
  },
  ".cm-completionIcon-variable": {
    "&:after": { content: "'𝑥'" }
  },
  ".cm-completionIcon-constant": {
    "&:after": { content: "'𝐶'" }
  },
  ".cm-completionIcon-type": {
    "&:after": { content: "'𝑡'" }
  },
  ".cm-completionIcon-enum": {
    "&:after": { content: "'∪'" }
  },
  ".cm-completionIcon-property": {
    "&:after": { content: "'□'" }
  },
  ".cm-completionIcon-keyword": {
    "&:after": { content: "'🔑︎'" }
    // Disable emoji rendering
  },
  ".cm-completionIcon-namespace": {
    "&:after": { content: "'▢'" }
  },
  ".cm-completionIcon-text": {
    "&:after": { content: "'abc'", fontSize: "50%", verticalAlign: "middle" }
  }
});
class jP {
  constructor(e, t, i, r) {
    this.field = e, this.line = t, this.from = i, this.to = r;
  }
}
class Th {
  constructor(e, t, i) {
    this.field = e, this.from = t, this.to = i;
  }
  map(e) {
    let t = e.mapPos(this.from, -1, Ge.TrackDel), i = e.mapPos(this.to, 1, Ge.TrackDel);
    return t == null || i == null ? null : new Th(this.field, t, i);
  }
}
class Ah {
  constructor(e, t) {
    this.lines = e, this.fieldPositions = t;
  }
  instantiate(e, t) {
    let i = [], r = [t], s = e.doc.lineAt(t), o = /^\s*/.exec(s.text)[0];
    for (let l of this.lines) {
      if (i.length) {
        let u = o, c = /^\t*/.exec(l)[0].length;
        for (let h = 0; h < c; h++)
          u += e.facet(mr);
        r.push(t + u.length - c), l = u + l.slice(c);
      }
      i.push(l), t += l.length + 1;
    }
    let a = this.fieldPositions.map((l) => new Th(l.field, r[l.line] + l.from, r[l.line] + l.to));
    return { text: i, ranges: a };
  }
  static parse(e) {
    let t = [], i = [], r = [], s;
    for (let o of e.split(/\r\n?|\n/)) {
      for (; s = /[#$]\{(?:(\d+)(?::([^}]*))?|((?:\\[{}]|[^}])*))\}/.exec(o); ) {
        let a = s[1] ? +s[1] : null, l = s[2] || s[3] || "", u = -1, c = l.replace(/\\[{}]/g, (h) => h[1]);
        for (let h = 0; h < t.length; h++)
          (a != null ? t[h].seq == a : c && t[h].name == c) && (u = h);
        if (u < 0) {
          let h = 0;
          for (; h < t.length && (a == null || t[h].seq != null && t[h].seq < a); )
            h++;
          t.splice(h, 0, { seq: a, name: c }), u = h;
          for (let f of r)
            f.field >= u && f.field++;
        }
        r.push(new jP(u, i.length, s.index, s.index + c.length)), o = o.slice(0, s.index) + l + o.slice(s.index + s[0].length);
      }
      o = o.replace(/\\([{}])/g, (a, l, u) => {
        for (let c of r)
          c.line == i.length && c.from > u && (c.from--, c.to--);
        return l;
      }), i.push(o);
    }
    return new Ah(i, r);
  }
}
let UP = /* @__PURE__ */ F.widget({ widget: /* @__PURE__ */ new class extends mn {
  toDOM() {
    let n = document.createElement("span");
    return n.className = "cm-snippetFieldPosition", n;
  }
  ignoreEvent() {
    return !1;
  }
}() }), FP = /* @__PURE__ */ F.mark({ class: "cm-snippetField" });
class yr {
  constructor(e, t) {
    this.ranges = e, this.active = t, this.deco = F.set(e.map((i) => (i.from == i.to ? UP : FP).range(i.from, i.to)));
  }
  map(e) {
    let t = [];
    for (let i of this.ranges) {
      let r = i.map(e);
      if (!r)
        return null;
      t.push(r);
    }
    return new yr(t, this.active);
  }
  selectionInsideField(e) {
    return e.ranges.every((t) => this.ranges.some((i) => i.field == this.active && i.from <= t.from && i.to >= t.to));
  }
}
const Xs = /* @__PURE__ */ te.define({
  map(n, e) {
    return n && n.map(e);
  }
}), GP = /* @__PURE__ */ te.define(), Os = /* @__PURE__ */ Ye.define({
  create() {
    return null;
  },
  update(n, e) {
    for (let t of e.effects) {
      if (t.is(Xs))
        return t.value;
      if (t.is(GP) && n)
        return new yr(n.ranges, t.value);
    }
    return n && e.docChanged && (n = n.map(e.changes)), n && e.selection && !n.selectionInsideField(e.selection) && (n = null), n;
  },
  provide: (n) => _.decorations.from(n, (e) => e ? e.deco : F.none)
});
function Rh(n, e) {
  return $.create(n.filter((t) => t.field == e).map((t) => $.range(t.from, t.to)));
}
function HP(n) {
  let e = Ah.parse(n);
  return (t, i, r, s) => {
    let { text: o, ranges: a } = e.instantiate(t.state, r), l = {
      changes: { from: r, to: s, insert: me.of(o) },
      scrollIntoView: !0,
      annotations: i ? [$h.of(i), _e.userEvent.of("input.complete")] : void 0
    };
    if (a.length && (l.selection = Rh(a, 0)), a.some((u) => u.field > 0)) {
      let u = new yr(a, 0), c = l.effects = [Xs.of(u)];
      t.state.field(Os, !1) === void 0 && c.push(te.appendConfig.of([Os, nQ, iQ, u0]));
    }
    t.dispatch(t.state.update(l));
  };
}
function c0(n) {
  return ({ state: e, dispatch: t }) => {
    let i = e.field(Os, !1);
    if (!i || n < 0 && i.active == 0)
      return !1;
    let r = i.active + n, s = n > 0 && !i.ranges.some((o) => o.field == r + n);
    return t(e.update({
      selection: Rh(i.ranges, r),
      effects: Xs.of(s ? null : new yr(i.ranges, r)),
      scrollIntoView: !0
    })), !0;
  };
}
const KP = ({ state: n, dispatch: e }) => n.field(Os, !1) ? (e(n.update({ effects: Xs.of(null) })), !0) : !1, JP = /* @__PURE__ */ c0(1), eQ = /* @__PURE__ */ c0(-1), tQ = [
  { key: "Tab", run: JP, shift: eQ },
  { key: "Escape", run: KP }
], lp = /* @__PURE__ */ N.define({
  combine(n) {
    return n.length ? n[0] : tQ;
  }
}), nQ = /* @__PURE__ */ Mn.highest(/* @__PURE__ */ dr.compute([lp], (n) => n.facet(lp)));
function ht(n, e) {
  return Object.assign(Object.assign({}, e), { apply: HP(n) });
}
const iQ = /* @__PURE__ */ _.domEventHandlers({
  mousedown(n, e) {
    let t = e.state.field(Os, !1), i;
    if (!t || (i = e.posAtCoords({ x: n.clientX, y: n.clientY })) == null)
      return !1;
    let r = t.ranges.find((s) => s.from <= i && s.to >= i);
    return !r || r.field == t.active ? !1 : (e.dispatch({
      selection: Rh(t.ranges, r.field),
      effects: Xs.of(t.ranges.some((s) => s.field > r.field) ? new yr(t.ranges, r.field) : null),
      scrollIntoView: !0
    }), !0);
  }
}), bs = {
  brackets: ["(", "[", "{", "'", '"'],
  before: ")]}:;>",
  stringPrefixes: []
}, Oi = /* @__PURE__ */ te.define({
  map(n, e) {
    let t = e.mapPos(n, -1, Ge.TrackAfter);
    return t ?? void 0;
  }
}), Mh = /* @__PURE__ */ new class extends ki {
}();
Mh.startSide = 1;
Mh.endSide = -1;
const h0 = /* @__PURE__ */ Ye.define({
  create() {
    return de.empty;
  },
  update(n, e) {
    if (n = n.map(e.changes), e.selection) {
      let t = e.state.doc.lineAt(e.selection.main.head);
      n = n.update({ filter: (i) => i >= t.from && i <= t.to });
    }
    for (let t of e.effects)
      t.is(Oi) && (n = n.update({ add: [Mh.range(t.value, t.value + 1)] }));
    return n;
  }
});
function rQ() {
  return [oQ, h0];
}
const Dl = "()[]{}<>";
function f0(n) {
  for (let e = 0; e < Dl.length; e += 2)
    if (Dl.charCodeAt(e) == n)
      return Dl.charAt(e + 1);
  return Kc(n < 128 ? n : n + 1);
}
function d0(n, e) {
  return n.languageDataAt("closeBrackets", e)[0] || bs;
}
const sQ = typeof navigator == "object" && /* @__PURE__ */ /Android\b/.test(navigator.userAgent), oQ = /* @__PURE__ */ _.inputHandler.of((n, e, t, i) => {
  if ((sQ ? n.composing : n.compositionStarted) || n.state.readOnly)
    return !1;
  let r = n.state.selection.main;
  if (i.length > 2 || i.length == 2 && Rt(Ue(i, 0)) == 1 || e != r.from || t != r.to)
    return !1;
  let s = uQ(n.state, i);
  return s ? (n.dispatch(s), !0) : !1;
}), aQ = ({ state: n, dispatch: e }) => {
  if (n.readOnly)
    return !1;
  let i = d0(n, n.selection.main.head).brackets || bs.brackets, r = null, s = n.changeByRange((o) => {
    if (o.empty) {
      let a = cQ(n.doc, o.head);
      for (let l of i)
        if (l == a && tl(n.doc, o.head) == f0(Ue(l, 0)))
          return {
            changes: { from: o.head - l.length, to: o.head + l.length },
            range: $.cursor(o.head - l.length)
          };
    }
    return { range: r = o };
  });
  return r || e(n.update(s, { scrollIntoView: !0, userEvent: "delete.backward" })), !r;
}, lQ = [
  { key: "Backspace", run: aQ }
];
function uQ(n, e) {
  let t = d0(n, n.selection.main.head), i = t.brackets || bs.brackets;
  for (let r of i) {
    let s = f0(Ue(r, 0));
    if (e == r)
      return s == r ? dQ(n, r, i.indexOf(r + r + r) > -1, t) : hQ(n, r, s, t.before || bs.before);
    if (e == s && p0(n, n.selection.main.from))
      return fQ(n, r, s);
  }
  return null;
}
function p0(n, e) {
  let t = !1;
  return n.field(h0).between(0, n.doc.length, (i) => {
    i == e && (t = !0);
  }), t;
}
function tl(n, e) {
  let t = n.sliceString(e, e + 2);
  return t.slice(0, Rt(Ue(t, 0)));
}
function cQ(n, e) {
  let t = n.sliceString(e - 2, e);
  return Rt(Ue(t, 0)) == t.length ? t : t.slice(1);
}
function hQ(n, e, t, i) {
  let r = null, s = n.changeByRange((o) => {
    if (!o.empty)
      return {
        changes: [{ insert: e, from: o.from }, { insert: t, from: o.to }],
        effects: Oi.of(o.to + e.length),
        range: $.range(o.anchor + e.length, o.head + e.length)
      };
    let a = tl(n.doc, o.head);
    return !a || /\s/.test(a) || i.indexOf(a) > -1 ? {
      changes: { insert: e + t, from: o.head },
      effects: Oi.of(o.head + e.length),
      range: $.cursor(o.head + e.length)
    } : { range: r = o };
  });
  return r ? null : n.update(s, {
    scrollIntoView: !0,
    userEvent: "input.type"
  });
}
function fQ(n, e, t) {
  let i = null, r = n.changeByRange((s) => s.empty && tl(n.doc, s.head) == t ? {
    changes: { from: s.head, to: s.head + t.length, insert: t },
    range: $.cursor(s.head + t.length)
  } : i = { range: s });
  return i ? null : n.update(r, {
    scrollIntoView: !0,
    userEvent: "input.type"
  });
}
function dQ(n, e, t, i) {
  let r = i.stringPrefixes || bs.stringPrefixes, s = null, o = n.changeByRange((a) => {
    if (!a.empty)
      return {
        changes: [{ insert: e, from: a.from }, { insert: e, from: a.to }],
        effects: Oi.of(a.to + e.length),
        range: $.range(a.anchor + e.length, a.head + e.length)
      };
    let l = a.head, u = tl(n.doc, l), c;
    if (u == e) {
      if (up(n, l))
        return {
          changes: { insert: e + e, from: l },
          effects: Oi.of(l + e.length),
          range: $.cursor(l + e.length)
        };
      if (p0(n, l)) {
        let f = t && n.sliceDoc(l, l + e.length * 3) == e + e + e ? e + e + e : e;
        return {
          changes: { from: l, to: l + f.length, insert: f },
          range: $.cursor(l + f.length)
        };
      }
    } else {
      if (t && n.sliceDoc(l - 2 * e.length, l) == e + e && (c = cp(n, l - 2 * e.length, r)) > -1 && up(n, c))
        return {
          changes: { insert: e + e + e + e, from: l },
          effects: Oi.of(l + e.length),
          range: $.cursor(l + e.length)
        };
      if (n.charCategorizer(l)(u) != Ze.Word && cp(n, l, r) > -1 && !pQ(n, l, e, r))
        return {
          changes: { insert: e + e, from: l },
          effects: Oi.of(l + e.length),
          range: $.cursor(l + e.length)
        };
    }
    return { range: s = a };
  });
  return s ? null : n.update(o, {
    scrollIntoView: !0,
    userEvent: "input.type"
  });
}
function up(n, e) {
  let t = Pe(n).resolveInner(e + 1);
  return t.parent && t.from == e;
}
function pQ(n, e, t, i) {
  let r = Pe(n).resolveInner(e, -1), s = i.reduce((o, a) => Math.max(o, a.length), 0);
  for (let o = 0; o < 5; o++) {
    let a = n.sliceDoc(r.from, Math.min(r.to, r.from + t.length + s)), l = a.indexOf(t);
    if (!l || l > -1 && i.indexOf(a.slice(0, l)) > -1) {
      let c = r.firstChild;
      for (; c && c.from == r.from && c.to - c.from > t.length + l; ) {
        if (n.sliceDoc(c.to - t.length, c.to) == t)
          return !1;
        c = c.firstChild;
      }
      return !0;
    }
    let u = r.to == e && r.parent;
    if (!u)
      break;
    r = u;
  }
  return !1;
}
function cp(n, e, t) {
  let i = n.charCategorizer(e);
  if (i(n.sliceDoc(e - 1, e)) != Ze.Word)
    return e;
  for (let r of t) {
    let s = e - r.length;
    if (n.sliceDoc(s, e) == r && i(n.sliceDoc(s - 1, s)) != Ze.Word)
      return s;
  }
  return -1;
}
function mQ(n = {}) {
  return [
    YP,
    pt,
    He.of(n),
    BP,
    gQ,
    u0
  ];
}
const m0 = [
  { key: "Ctrl-Space", run: _P },
  { key: "Escape", run: XP },
  { key: "ArrowDown", run: /* @__PURE__ */ go(!0) },
  { key: "ArrowUp", run: /* @__PURE__ */ go(!1) },
  { key: "PageDown", run: /* @__PURE__ */ go(!0, "page") },
  { key: "PageUp", run: /* @__PURE__ */ go(!1, "page") },
  { key: "Enter", run: LP }
], gQ = /* @__PURE__ */ Mn.highest(/* @__PURE__ */ dr.computeN([He], (n) => n.facet(He).defaultKeymap ? [m0] : []));
class OQ {
  constructor(e, t, i) {
    this.from = e, this.to = t, this.diagnostic = i;
  }
}
class hi {
  constructor(e, t, i) {
    this.diagnostics = e, this.panel = t, this.selected = i;
  }
  static init(e, t, i) {
    let r = e, s = i.facet(ys).markerFilter;
    s && (r = s(r, i));
    let o = F.set(r.map((a) => a.from == a.to || a.from == a.to - 1 && i.doc.lineAt(a.from).to == a.from ? F.widget({
      widget: new QQ(a),
      diagnostic: a
    }).range(a.from) : F.mark({
      attributes: { class: "cm-lintRange cm-lintRange-" + a.severity + (a.markClass ? " " + a.markClass : "") },
      diagnostic: a,
      inclusive: !0
    }).range(a.from, a.to)), !0);
    return new hi(o, t, ar(o));
  }
}
function ar(n, e = null, t = 0) {
  let i = null;
  return n.between(t, 1e9, (r, s, { spec: o }) => {
    if (!(e && o.diagnostic != e))
      return i = new OQ(r, s, o.diagnostic), !1;
  }), i;
}
function bQ(n, e) {
  let t = e.pos, i = e.end || t, r = n.state.facet(ys).hideOn(n, t, i);
  if (r != null)
    return r;
  let s = n.startState.doc.lineAt(e.pos);
  return !!(n.effects.some((o) => o.is(g0)) || n.changes.touchesRange(s.from, Math.max(s.to, i)));
}
function yQ(n, e) {
  return n.field($t, !1) ? e : e.concat(te.appendConfig.of(TQ));
}
const g0 = /* @__PURE__ */ te.define(), Zh = /* @__PURE__ */ te.define(), O0 = /* @__PURE__ */ te.define(), $t = /* @__PURE__ */ Ye.define({
  create() {
    return new hi(F.none, null, null);
  },
  update(n, e) {
    if (e.docChanged && n.diagnostics.size) {
      let t = n.diagnostics.map(e.changes), i = null, r = n.panel;
      if (n.selected) {
        let s = e.changes.mapPos(n.selected.from, 1);
        i = ar(t, n.selected.diagnostic, s) || ar(t, null, s);
      }
      !t.size && r && e.state.facet(ys).autoPanel && (r = null), n = new hi(t, r, i);
    }
    for (let t of e.effects)
      if (t.is(g0)) {
        let i = e.state.facet(ys).autoPanel ? t.value.length ? ks.open : null : n.panel;
        n = hi.init(t.value, i, e.state);
      } else
        t.is(Zh) ? n = new hi(n.diagnostics, t.value ? ks.open : null, n.selected) : t.is(O0) && (n = new hi(n.diagnostics, n.panel, t.value));
    return n;
  },
  provide: (n) => [
    us.from(n, (e) => e.panel),
    _.decorations.from(n, (e) => e.diagnostics)
  ]
}), kQ = /* @__PURE__ */ F.mark({ class: "cm-lintRange cm-lintRange-active", inclusive: !0 });
function xQ(n, e, t) {
  let { diagnostics: i } = n.state.field($t), r = [], s = 2e8, o = 0;
  i.between(e - (t < 0 ? 1 : 0), e + (t > 0 ? 1 : 0), (l, u, { spec: c }) => {
    e >= l && e <= u && (l == u || (e > l || t > 0) && (e < u || t < 0)) && (r.push(c.diagnostic), s = Math.min(l, s), o = Math.max(u, o));
  });
  let a = n.state.facet(ys).tooltipFilter;
  return a && (r = a(r, n.state)), r.length ? {
    pos: s,
    end: o,
    above: n.state.doc.lineAt(s).to < o,
    create() {
      return { dom: wQ(n, r) };
    }
  } : null;
}
function wQ(n, e) {
  return Se("ul", { class: "cm-tooltip-lint" }, e.map((t) => y0(n, t, !1)));
}
const SQ = (n) => {
  let e = n.state.field($t, !1);
  (!e || !e.panel) && n.dispatch({ effects: yQ(n.state, [Zh.of(!0)]) });
  let t = ls(n, ks.open);
  return t && t.dom.querySelector(".cm-panel-lint ul").focus(), !0;
}, hp = (n) => {
  let e = n.state.field($t, !1);
  return !e || !e.panel ? !1 : (n.dispatch({ effects: Zh.of(!1) }), !0);
}, vQ = (n) => {
  let e = n.state.field($t, !1);
  if (!e)
    return !1;
  let t = n.state.selection.main, i = e.diagnostics.iter(t.to + 1);
  return !i.value && (i = e.diagnostics.iter(0), !i.value || i.from == t.from && i.to == t.to) ? !1 : (n.dispatch({ selection: { anchor: i.from, head: i.to }, scrollIntoView: !0 }), !0);
}, PQ = [
  { key: "Mod-Shift-m", run: SQ, preventDefault: !0 },
  { key: "F8", run: vQ }
], ys = /* @__PURE__ */ N.define({
  combine(n) {
    return Object.assign({ sources: n.map((e) => e.source).filter((e) => e != null) }, pn(n.map((e) => e.config), {
      delay: 750,
      markerFilter: null,
      tooltipFilter: null,
      needsRefresh: null,
      hideOn: () => null
    }, {
      needsRefresh: (e, t) => e ? t ? (i) => e(i) || t(i) : e : t
    }));
  }
});
function b0(n) {
  let e = [];
  if (n)
    e:
      for (let { name: t } of n) {
        for (let i = 0; i < t.length; i++) {
          let r = t[i];
          if (/[a-zA-Z]/.test(r) && !e.some((s) => s.toLowerCase() == r.toLowerCase())) {
            e.push(r);
            continue e;
          }
        }
        e.push("");
      }
  return e;
}
function y0(n, e, t) {
  var i;
  let r = t ? b0(e.actions) : [];
  return Se("li", { class: "cm-diagnostic cm-diagnostic-" + e.severity }, Se("span", { class: "cm-diagnosticText" }, e.renderMessage ? e.renderMessage(n) : e.message), (i = e.actions) === null || i === void 0 ? void 0 : i.map((s, o) => {
    let a = !1, l = (f) => {
      if (f.preventDefault(), a)
        return;
      a = !0;
      let d = ar(n.state.field($t).diagnostics, e);
      d && s.apply(n, d.from, d.to);
    }, { name: u } = s, c = r[o] ? u.indexOf(r[o]) : -1, h = c < 0 ? u : [
      u.slice(0, c),
      Se("u", u.slice(c, c + 1)),
      u.slice(c + 1)
    ];
    return Se("button", {
      type: "button",
      class: "cm-diagnosticAction",
      onclick: l,
      onmousedown: l,
      "aria-label": ` Action: ${u}${c < 0 ? "" : ` (access key "${r[o]})"`}.`
    }, h);
  }), e.source && Se("div", { class: "cm-diagnosticSource" }, e.source));
}
class QQ extends mn {
  constructor(e) {
    super(), this.diagnostic = e;
  }
  eq(e) {
    return e.diagnostic == this.diagnostic;
  }
  toDOM() {
    return Se("span", { class: "cm-lintPoint cm-lintPoint-" + this.diagnostic.severity });
  }
}
class fp {
  constructor(e, t) {
    this.diagnostic = t, this.id = "item_" + Math.floor(Math.random() * 4294967295).toString(16), this.dom = y0(e, t, !0), this.dom.id = this.id, this.dom.setAttribute("role", "option");
  }
}
class ks {
  constructor(e) {
    this.view = e, this.items = [];
    let t = (r) => {
      if (r.keyCode == 27)
        hp(this.view), this.view.focus();
      else if (r.keyCode == 38 || r.keyCode == 33)
        this.moveSelection((this.selectedIndex - 1 + this.items.length) % this.items.length);
      else if (r.keyCode == 40 || r.keyCode == 34)
        this.moveSelection((this.selectedIndex + 1) % this.items.length);
      else if (r.keyCode == 36)
        this.moveSelection(0);
      else if (r.keyCode == 35)
        this.moveSelection(this.items.length - 1);
      else if (r.keyCode == 13)
        this.view.focus();
      else if (r.keyCode >= 65 && r.keyCode <= 90 && this.selectedIndex >= 0) {
        let { diagnostic: s } = this.items[this.selectedIndex], o = b0(s.actions);
        for (let a = 0; a < o.length; a++)
          if (o[a].toUpperCase().charCodeAt(0) == r.keyCode) {
            let l = ar(this.view.state.field($t).diagnostics, s);
            l && s.actions[a].apply(e, l.from, l.to);
          }
      } else
        return;
      r.preventDefault();
    }, i = (r) => {
      for (let s = 0; s < this.items.length; s++)
        this.items[s].dom.contains(r.target) && this.moveSelection(s);
    };
    this.list = Se("ul", {
      tabIndex: 0,
      role: "listbox",
      "aria-label": this.view.state.phrase("Diagnostics"),
      onkeydown: t,
      onclick: i
    }), this.dom = Se("div", { class: "cm-panel-lint" }, this.list, Se("button", {
      type: "button",
      name: "close",
      "aria-label": this.view.state.phrase("close"),
      onclick: () => hp(this.view)
    }, "×")), this.update();
  }
  get selectedIndex() {
    let e = this.view.state.field($t).selected;
    if (!e)
      return -1;
    for (let t = 0; t < this.items.length; t++)
      if (this.items[t].diagnostic == e.diagnostic)
        return t;
    return -1;
  }
  update() {
    let { diagnostics: e, selected: t } = this.view.state.field($t), i = 0, r = !1, s = null;
    for (e.between(0, this.view.state.doc.length, (o, a, { spec: l }) => {
      let u = -1, c;
      for (let h = i; h < this.items.length; h++)
        if (this.items[h].diagnostic == l.diagnostic) {
          u = h;
          break;
        }
      u < 0 ? (c = new fp(this.view, l.diagnostic), this.items.splice(i, 0, c), r = !0) : (c = this.items[u], u > i && (this.items.splice(i, u - i), r = !0)), t && c.diagnostic == t.diagnostic ? c.dom.hasAttribute("aria-selected") || (c.dom.setAttribute("aria-selected", "true"), s = c) : c.dom.hasAttribute("aria-selected") && c.dom.removeAttribute("aria-selected"), i++;
    }); i < this.items.length && !(this.items.length == 1 && this.items[0].diagnostic.from < 0); )
      r = !0, this.items.pop();
    this.items.length == 0 && (this.items.push(new fp(this.view, {
      from: -1,
      to: -1,
      severity: "info",
      message: this.view.state.phrase("No diagnostics")
    })), r = !0), s ? (this.list.setAttribute("aria-activedescendant", s.id), this.view.requestMeasure({
      key: this,
      read: () => ({ sel: s.dom.getBoundingClientRect(), panel: this.list.getBoundingClientRect() }),
      write: ({ sel: o, panel: a }) => {
        let l = a.height / this.list.offsetHeight;
        o.top < a.top ? this.list.scrollTop -= (a.top - o.top) / l : o.bottom > a.bottom && (this.list.scrollTop += (o.bottom - a.bottom) / l);
      }
    })) : this.selectedIndex < 0 && this.list.removeAttribute("aria-activedescendant"), r && this.sync();
  }
  sync() {
    let e = this.list.firstChild;
    function t() {
      let i = e;
      e = i.nextSibling, i.remove();
    }
    for (let i of this.items)
      if (i.dom.parentNode == this.list) {
        for (; e != i.dom; )
          t();
        e = i.dom.nextSibling;
      } else
        this.list.insertBefore(i.dom, e);
    for (; e; )
      t();
  }
  moveSelection(e) {
    if (this.selectedIndex < 0)
      return;
    let t = this.view.state.field($t), i = ar(t.diagnostics, this.items[e].diagnostic);
    i && this.view.dispatch({
      selection: { anchor: i.from, head: i.to },
      scrollIntoView: !0,
      effects: O0.of(i)
    });
  }
  static open(e) {
    return new ks(e);
  }
}
function $Q(n, e = 'viewBox="0 0 40 40"') {
  return `url('data:image/svg+xml,<svg xmlns="http://www.w3.org/2000/svg" ${e}>${encodeURIComponent(n)}</svg>')`;
}
function Oo(n) {
  return $Q(`<path d="m0 2.5 l2 -1.5 l1 0 l2 1.5 l1 0" stroke="${n}" fill="none" stroke-width=".7"/>`, 'width="6" height="3"');
}
const CQ = /* @__PURE__ */ _.baseTheme({
  ".cm-diagnostic": {
    padding: "3px 6px 3px 8px",
    marginLeft: "-1px",
    display: "block",
    whiteSpace: "pre-wrap"
  },
  ".cm-diagnostic-error": { borderLeft: "5px solid #d11" },
  ".cm-diagnostic-warning": { borderLeft: "5px solid orange" },
  ".cm-diagnostic-info": { borderLeft: "5px solid #999" },
  ".cm-diagnostic-hint": { borderLeft: "5px solid #66d" },
  ".cm-diagnosticAction": {
    font: "inherit",
    border: "none",
    padding: "2px 4px",
    backgroundColor: "#444",
    color: "white",
    borderRadius: "3px",
    marginLeft: "8px",
    cursor: "pointer"
  },
  ".cm-diagnosticSource": {
    fontSize: "70%",
    opacity: 0.7
  },
  ".cm-lintRange": {
    backgroundPosition: "left bottom",
    backgroundRepeat: "repeat-x",
    paddingBottom: "0.7px"
  },
  ".cm-lintRange-error": { backgroundImage: /* @__PURE__ */ Oo("#d11") },
  ".cm-lintRange-warning": { backgroundImage: /* @__PURE__ */ Oo("orange") },
  ".cm-lintRange-info": { backgroundImage: /* @__PURE__ */ Oo("#999") },
  ".cm-lintRange-hint": { backgroundImage: /* @__PURE__ */ Oo("#66d") },
  ".cm-lintRange-active": { backgroundColor: "#ffdd9980" },
  ".cm-tooltip-lint": {
    padding: 0,
    margin: 0
  },
  ".cm-lintPoint": {
    position: "relative",
    "&:after": {
      content: '""',
      position: "absolute",
      bottom: 0,
      left: "-2px",
      borderLeft: "3px solid transparent",
      borderRight: "3px solid transparent",
      borderBottom: "4px solid #d11"
    }
  },
  ".cm-lintPoint-warning": {
    "&:after": { borderBottomColor: "orange" }
  },
  ".cm-lintPoint-info": {
    "&:after": { borderBottomColor: "#999" }
  },
  ".cm-lintPoint-hint": {
    "&:after": { borderBottomColor: "#66d" }
  },
  ".cm-panel.cm-panel-lint": {
    position: "relative",
    "& ul": {
      maxHeight: "100px",
      overflowY: "auto",
      "& [aria-selected]": {
        backgroundColor: "#ddd",
        "& u": { textDecoration: "underline" }
      },
      "&:focus [aria-selected]": {
        background_fallback: "#bdf",
        backgroundColor: "Highlight",
        color_fallback: "white",
        color: "HighlightText"
      },
      "& u": { textDecoration: "none" },
      padding: 0,
      margin: 0
    },
    "& [name=close]": {
      position: "absolute",
      top: "0",
      right: "2px",
      background: "inherit",
      border: "none",
      font: "inherit",
      padding: 0,
      margin: 0
    }
  }
}), TQ = [
  $t,
  /* @__PURE__ */ _.decorations.compute([$t], (n) => {
    let { selected: e, panel: t } = n.field($t);
    return !e || !t || e.from == e.to ? F.none : F.set([
      kQ.range(e.from, e.to)
    ]);
  }),
  /* @__PURE__ */ dS(xQ, { hideOn: bQ }),
  CQ
], AQ = [
  wS(),
  PS(),
  Ww(),
  Bv(),
  Ov(),
  Rw(),
  Dw(),
  se.allowMultipleSelections.of(!0),
  sv(),
  yv(wv, { fallback: !0 }),
  Tv(),
  rQ(),
  mQ(),
  nS(),
  sS(),
  Uw(),
  K2(),
  dr.of([
    ...lQ,
    ...V2,
    ...OP,
    ...Jv,
    ...dv,
    ...m0,
    ...PQ
  ])
];
/*!
* VueCodemirror v6.1.1
* Copyright (c) Surmon. All rights reserved.
* Released under the MIT License.
* Surmon
*/
var RQ = Object.freeze({ autofocus: !1, disabled: !1, indentWithTab: !0, tabSize: 2, placeholder: "", autoDestroy: !0, extensions: [AQ] }), MQ = Symbol("vue-codemirror-global-config"), ot, ZQ = function(n) {
  var e = n.onUpdate, t = n.onChange, i = n.onFocus, r = n.onBlur, s = function(o, a) {
    var l = {};
    for (var u in o)
      Object.prototype.hasOwnProperty.call(o, u) && a.indexOf(u) < 0 && (l[u] = o[u]);
    if (o != null && typeof Object.getOwnPropertySymbols == "function") {
      var c = 0;
      for (u = Object.getOwnPropertySymbols(o); c < u.length; c++)
        a.indexOf(u[c]) < 0 && Object.prototype.propertyIsEnumerable.call(o, u[c]) && (l[u[c]] = o[u[c]]);
    }
    return l;
  }(n, ["onUpdate", "onChange", "onFocus", "onBlur"]);
  return se.create({ doc: s.doc, selection: s.selection, extensions: (Array.isArray(s.extensions) ? s.extensions : [s.extensions]).concat([_.updateListener.of(function(o) {
    e(o), o.docChanged && t(o.state.doc.toString(), o), o.focusChanged && (o.view.hasFocus ? i(o) : r(o));
  })]) });
}, Ii = function(n) {
  var e = new Rs();
  return { compartment: e, run: function(t) {
    e.get(n.state) ? n.dispatch({ effects: e.reconfigure(t) }) : n.dispatch({ effects: te.appendConfig.of(e.of(t)) });
  } };
}, dp = function(n, e) {
  var t = Ii(n), i = t.compartment, r = t.run;
  return function(s) {
    var o = i.get(n.state);
    r(s ?? o !== e ? e : []);
  };
}, bo = { type: Boolean, default: void 0 }, EQ = { autofocus: bo, disabled: bo, indentWithTab: bo, tabSize: Number, placeholder: String, style: Object, autoDestroy: bo, phrases: Object, root: Object, extensions: Array, selection: Object }, zQ = { modelValue: { type: String, default: "" } }, DQ = Object.assign(Object.assign({}, EQ), zQ);
(function(n) {
  n.Change = "change", n.Update = "update", n.Focus = "focus", n.Blur = "blur", n.Ready = "ready", n.ModelUpdate = "update:modelValue";
})(ot || (ot = {}));
var fi = {};
fi[ot.Change] = function(n, e) {
  return !0;
}, fi[ot.Update] = function(n) {
  return !0;
}, fi[ot.Focus] = function(n) {
  return !0;
}, fi[ot.Blur] = function(n) {
  return !0;
}, fi[ot.Ready] = function(n) {
  return !0;
};
var k0 = {};
k0[ot.ModelUpdate] = fi[ot.Change];
var IQ = Object.assign(Object.assign({}, fi), k0), LQ = bt({ name: "VueCodemirror", props: Object.assign({}, DQ), emits: Object.assign({}, IQ), setup: function(n, e) {
  var t = fl(), i = fl(), r = fl(), s = Object.assign(Object.assign({}, RQ), Pk(MQ, {})), o = Qt(function() {
    var a = {};
    return Object.keys(Qk(n)).forEach(function(l) {
      var u;
      l !== "modelValue" && (a[l] = (u = n[l]) !== null && u !== void 0 ? u : s[l]);
    }), a;
  });
  return Fc(function() {
    var a;
    i.value = ZQ({ doc: n.modelValue, selection: o.value.selection, extensions: (a = s.extensions) !== null && a !== void 0 ? a : [], onFocus: function(u) {
      return e.emit(ot.Focus, u);
    }, onBlur: function(u) {
      return e.emit(ot.Blur, u);
    }, onUpdate: function(u) {
      return e.emit(ot.Update, u);
    }, onChange: function(u, c) {
      u !== n.modelValue && (e.emit(ot.Change, u, c), e.emit(ot.ModelUpdate, u, c));
    } }), r.value = function(u) {
      return new _(Object.assign({}, u));
    }({ state: i.value, parent: t.value, root: o.value.root });
    var l = function(u) {
      var c = function() {
        return u.state.doc.toString();
      }, h = Ii(u).run, f = dp(u, [_.editable.of(!1), se.readOnly.of(!0)]), d = dp(u, dr.of([Y2])), p = Ii(u).run, g = Ii(u).run, O = Ii(u).run, m = Ii(u).run;
      return { focus: function() {
        return u.focus();
      }, getDoc: c, setDoc: function(b) {
        b !== c() && u.dispatch({ changes: { from: 0, to: u.state.doc.length, insert: b } });
      }, reExtensions: h, toggleDisabled: f, toggleIndentWithTab: d, setTabSize: function(b) {
        p([se.tabSize.of(b), mr.of(" ".repeat(b))]);
      }, setPhrases: function(b) {
        g([se.phrases.of(b)]);
      }, setPlaceholder: function(b) {
        O(Kw(b));
      }, setStyle: function(b) {
        b === void 0 && (b = {}), m(_.theme({ "&": Object.assign({}, b) }));
      } };
    }(r.value);
    ft(function() {
      return n.modelValue;
    }, function(u) {
      u !== l.getDoc() && l.setDoc(u);
    }), ft(function() {
      return n.extensions;
    }, function(u) {
      return l.reExtensions(u || []);
    }, { immediate: !0 }), ft(function() {
      return o.value.disabled;
    }, function(u) {
      return l.toggleDisabled(u);
    }, { immediate: !0 }), ft(function() {
      return o.value.indentWithTab;
    }, function(u) {
      return l.toggleIndentWithTab(u);
    }, { immediate: !0 }), ft(function() {
      return o.value.tabSize;
    }, function(u) {
      return l.setTabSize(u);
    }, { immediate: !0 }), ft(function() {
      return o.value.phrases;
    }, function(u) {
      return l.setPhrases(u || {});
    }, { immediate: !0 }), ft(function() {
      return o.value.placeholder;
    }, function(u) {
      return l.setPlaceholder(u);
    }, { immediate: !0 }), ft(function() {
      return o.value.style;
    }, function(u) {
      return l.setStyle(u);
    }, { immediate: !0 }), o.value.autofocus && l.focus(), e.emit(ot.Ready, { state: i.value, view: r.value, container: t.value });
  }), $k(function() {
    o.value.autoDestroy && r.value && function(a) {
      a.destroy();
    }(r.value);
  }), function() {
    return Gc("div", { class: "v-codemirror", style: { display: "contents" }, ref: t });
  };
} }), _Q = LQ;
function va(n, e) {
  const t = String(n);
  if (typeof e != "string")
    throw new TypeError("Expected character");
  let i = 0, r = t.indexOf(e);
  for (; r !== -1; )
    i++, r = t.indexOf(e, r + e.length);
  return i;
}
const at = si(/[A-Za-z]/), nt = si(/[\dA-Za-z]/), XQ = si(/[#-'*+\--9=?A-Z^-~]/);
function Pa(n) {
  return (
    // Special whitespace codes (which have negative values), C0 and Control
    // character DEL
    n !== null && (n < 32 || n === 127)
  );
}
const dc = si(/\d/), NQ = si(/[\dA-Fa-f]/), WQ = si(/[!-/:-@[-`{-~]/);
function G(n) {
  return n !== null && n < -2;
}
function xe(n) {
  return n !== null && (n < 0 || n === 32);
}
function ae(n) {
  return n === -2 || n === -1 || n === 32;
}
const nl = si(new RegExp("\\p{P}|\\p{S}", "u")), Pi = si(/\s/);
function si(n) {
  return e;
  function e(t) {
    return t !== null && t > -1 && n.test(String.fromCharCode(t));
  }
}
function qQ(n) {
  if (typeof n != "string")
    throw new TypeError("Expected a string");
  return n.replace(/[|\\{}()[\]^$+*?.]/g, "\\$&").replace(/-/g, "\\x2d");
}
const il = (
  // Note: overloads in JSDoc can’t yet use different `@template`s.
  /**
   * @type {(
   *   (<Condition extends string>(test: Condition) => (node: unknown, index?: number | null | undefined, parent?: Parent | null | undefined, context?: unknown) => node is Node & {type: Condition}) &
   *   (<Condition extends Props>(test: Condition) => (node: unknown, index?: number | null | undefined, parent?: Parent | null | undefined, context?: unknown) => node is Node & Condition) &
   *   (<Condition extends TestFunction>(test: Condition) => (node: unknown, index?: number | null | undefined, parent?: Parent | null | undefined, context?: unknown) => node is Node & Predicate<Condition, Node>) &
   *   ((test?: null | undefined) => (node?: unknown, index?: number | null | undefined, parent?: Parent | null | undefined, context?: unknown) => node is Node) &
   *   ((test?: Test) => Check)
   * )}
   */
  /**
   * @param {Test} [test]
   * @returns {Check}
   */
  function(n) {
    if (n == null)
      return jQ;
    if (typeof n == "function")
      return rl(n);
    if (typeof n == "object")
      return Array.isArray(n) ? BQ(n) : VQ(n);
    if (typeof n == "string")
      return YQ(n);
    throw new Error("Expected function, string, or object as test");
  }
);
function BQ(n) {
  const e = [];
  let t = -1;
  for (; ++t < n.length; )
    e[t] = il(n[t]);
  return rl(i);
  function i(...r) {
    let s = -1;
    for (; ++s < e.length; )
      if (e[s].apply(this, r))
        return !0;
    return !1;
  }
}
function VQ(n) {
  const e = (
    /** @type {Record<string, unknown>} */
    n
  );
  return rl(t);
  function t(i) {
    const r = (
      /** @type {Record<string, unknown>} */
      /** @type {unknown} */
      i
    );
    let s;
    for (s in n)
      if (r[s] !== e[s])
        return !1;
    return !0;
  }
}
function YQ(n) {
  return rl(e);
  function e(t) {
    return t && t.type === n;
  }
}
function rl(n) {
  return e;
  function e(t, i, r) {
    return !!(UQ(t) && n.call(
      this,
      t,
      typeof i == "number" ? i : void 0,
      r || void 0
    ));
  }
}
function jQ() {
  return !0;
}
function UQ(n) {
  return n !== null && typeof n == "object" && "type" in n;
}
const x0 = [], FQ = !0, pc = !1, GQ = "skip";
function w0(n, e, t, i) {
  let r;
  typeof e == "function" && typeof t != "function" ? (i = t, t = e) : r = e;
  const s = il(r), o = i ? -1 : 1;
  a(n, void 0, [])();
  function a(l, u, c) {
    const h = (
      /** @type {Record<string, unknown>} */
      l && typeof l == "object" ? l : {}
    );
    if (typeof h.type == "string") {
      const d = (
        // `hast`
        typeof h.tagName == "string" ? h.tagName : (
          // `xast`
          typeof h.name == "string" ? h.name : void 0
        )
      );
      Object.defineProperty(f, "name", {
        value: "node (" + (l.type + (d ? "<" + d + ">" : "")) + ")"
      });
    }
    return f;
    function f() {
      let d = x0, p, g, O;
      if ((!e || s(l, u, c[c.length - 1] || void 0)) && (d = HQ(t(l, c)), d[0] === pc))
        return d;
      if ("children" in l && l.children) {
        const m = (
          /** @type {UnistParent} */
          l
        );
        if (m.children && d[0] !== GQ)
          for (g = (i ? m.children.length : -1) + o, O = c.concat(m); g > -1 && g < m.children.length; ) {
            const b = m.children[g];
            if (p = a(b, g, O)(), p[0] === pc)
              return p;
            g = typeof p[1] == "number" ? p[1] : g + o;
          }
      }
      return d;
    }
  }
}
function HQ(n) {
  return Array.isArray(n) ? n : typeof n == "number" ? [FQ, n] : n == null ? x0 : [n];
}
function KQ(n, e, t) {
  const r = il((t || {}).ignore || []), s = JQ(e);
  let o = -1;
  for (; ++o < s.length; )
    w0(n, "text", a);
  function a(u, c) {
    let h = -1, f;
    for (; ++h < c.length; ) {
      const d = c[h], p = f ? f.children : void 0;
      if (r(
        d,
        p ? p.indexOf(d) : void 0,
        f
      ))
        return;
      f = d;
    }
    if (f)
      return l(u, c);
  }
  function l(u, c) {
    const h = c[c.length - 1], f = s[o][0], d = s[o][1];
    let p = 0;
    const O = h.children.indexOf(u);
    let m = !1, b = [];
    f.lastIndex = 0;
    let w = f.exec(u.value);
    for (; w; ) {
      const Q = w.index, v = {
        index: w.index,
        input: w.input,
        stack: [...c, u]
      };
      let k = d(...w, v);
      if (typeof k == "string" && (k = k.length > 0 ? { type: "text", value: k } : void 0), k === !1 ? f.lastIndex = Q + 1 : (p !== Q && b.push({
        type: "text",
        value: u.value.slice(p, Q)
      }), Array.isArray(k) ? b.push(...k) : k && b.push(k), p = Q + w[0].length, m = !0), !f.global)
        break;
      w = f.exec(u.value);
    }
    return m ? (p < u.value.length && b.push({ type: "text", value: u.value.slice(p) }), h.children.splice(O, 1, ...b)) : b = [u], O + b.length;
  }
}
function JQ(n) {
  const e = [];
  if (!Array.isArray(n))
    throw new TypeError("Expected find and replace tuple or list of tuples");
  const t = !n[0] || Array.isArray(n[0]) ? n : [n];
  let i = -1;
  for (; ++i < t.length; ) {
    const r = t[i];
    e.push([e$(r[0]), t$(r[1])]);
  }
  return e;
}
function e$(n) {
  return typeof n == "string" ? new RegExp(qQ(n), "g") : n;
}
function t$(n) {
  return typeof n == "function" ? n : function() {
    return n;
  };
}
const Il = "phrasing", Ll = ["autolink", "link", "image", "label"];
function n$() {
  return {
    transforms: [u$],
    enter: {
      literalAutolink: r$,
      literalAutolinkEmail: _l,
      literalAutolinkHttp: _l,
      literalAutolinkWww: _l
    },
    exit: {
      literalAutolink: l$,
      literalAutolinkEmail: a$,
      literalAutolinkHttp: s$,
      literalAutolinkWww: o$
    }
  };
}
function i$() {
  return {
    unsafe: [
      {
        character: "@",
        before: "[+\\-.\\w]",
        after: "[\\-.\\w]",
        inConstruct: Il,
        notInConstruct: Ll
      },
      {
        character: ".",
        before: "[Ww]",
        after: "[\\-.\\w]",
        inConstruct: Il,
        notInConstruct: Ll
      },
      {
        character: ":",
        before: "[ps]",
        after: "\\/",
        inConstruct: Il,
        notInConstruct: Ll
      }
    ]
  };
}
function r$(n) {
  this.enter({ type: "link", title: null, url: "", children: [] }, n);
}
function _l(n) {
  this.config.enter.autolinkProtocol.call(this, n);
}
function s$(n) {
  this.config.exit.autolinkProtocol.call(this, n);
}
function o$(n) {
  this.config.exit.data.call(this, n);
  const e = this.stack[this.stack.length - 1];
  e.type, e.url = "http://" + this.sliceSerialize(n);
}
function a$(n) {
  this.config.exit.autolinkEmail.call(this, n);
}
function l$(n) {
  this.exit(n);
}
function u$(n) {
  KQ(
    n,
    [
      [/(https?:\/\/|www(?=\.))([-.\w]+)([^ \t\r\n]*)/gi, c$],
      [/([-.\w+]+)@([-\w]+(?:\.[-\w]+)+)/g, h$]
    ],
    { ignore: ["link", "linkReference"] }
  );
}
function c$(n, e, t, i, r) {
  let s = "";
  if (!S0(r) || (/^w/i.test(e) && (t = e + t, e = "", s = "http://"), !f$(t)))
    return !1;
  const o = d$(t + i);
  if (!o[0])
    return !1;
  const a = {
    type: "link",
    title: null,
    url: s + e + o[0],
    children: [{ type: "text", value: e + o[0] }]
  };
  return o[1] ? [a, { type: "text", value: o[1] }] : a;
}
function h$(n, e, t, i) {
  return (
    // Not an expected previous character.
    !S0(i, !0) || // Label ends in not allowed character.
    /[-\d_]$/.test(t) ? !1 : {
      type: "link",
      title: null,
      url: "mailto:" + e + "@" + t,
      children: [{ type: "text", value: e + "@" + t }]
    }
  );
}
function f$(n) {
  const e = n.split(".");
  return !(e.length < 2 || e[e.length - 1] && (/_/.test(e[e.length - 1]) || !/[a-zA-Z\d]/.test(e[e.length - 1])) || e[e.length - 2] && (/_/.test(e[e.length - 2]) || !/[a-zA-Z\d]/.test(e[e.length - 2])));
}
function d$(n) {
  const e = /[!"&'),.:;<>?\]}]+$/.exec(n);
  if (!e)
    return [n, void 0];
  n = n.slice(0, e.index);
  let t = e[0], i = t.indexOf(")");
  const r = va(n, "(");
  let s = va(n, ")");
  for (; i !== -1 && r > s; )
    n += t.slice(0, i + 1), t = t.slice(i + 1), i = t.indexOf(")"), s++;
  return [n, t];
}
function S0(n, e) {
  const t = n.input.charCodeAt(n.index - 1);
  return (n.index === 0 || Pi(t) || nl(t)) && (!e || t !== 47);
}
function jt(n) {
  return n.replace(/[\t\n\r ]+/g, " ").replace(/^ | $/g, "").toLowerCase().toUpperCase();
}
v0.peek = v$;
function p$() {
  return {
    enter: {
      gfmFootnoteDefinition: g$,
      gfmFootnoteDefinitionLabelString: O$,
      gfmFootnoteCall: k$,
      gfmFootnoteCallString: x$
    },
    exit: {
      gfmFootnoteDefinition: y$,
      gfmFootnoteDefinitionLabelString: b$,
      gfmFootnoteCall: S$,
      gfmFootnoteCallString: w$
    }
  };
}
function m$() {
  return {
    // This is on by default already.
    unsafe: [{ character: "[", inConstruct: ["phrasing", "label", "reference"] }],
    handlers: { footnoteDefinition: P$, footnoteReference: v0 }
  };
}
function g$(n) {
  this.enter(
    { type: "footnoteDefinition", identifier: "", label: "", children: [] },
    n
  );
}
function O$() {
  this.buffer();
}
function b$(n) {
  const e = this.resume(), t = this.stack[this.stack.length - 1];
  t.type, t.label = e, t.identifier = jt(
    this.sliceSerialize(n)
  ).toLowerCase();
}
function y$(n) {
  this.exit(n);
}
function k$(n) {
  this.enter({ type: "footnoteReference", identifier: "", label: "" }, n);
}
function x$() {
  this.buffer();
}
function w$(n) {
  const e = this.resume(), t = this.stack[this.stack.length - 1];
  t.type, t.label = e, t.identifier = jt(
    this.sliceSerialize(n)
  ).toLowerCase();
}
function S$(n) {
  this.exit(n);
}
function v0(n, e, t, i) {
  const r = t.createTracker(i);
  let s = r.move("[^");
  const o = t.enter("footnoteReference"), a = t.enter("reference");
  return s += r.move(
    t.safe(t.associationId(n), {
      ...r.current(),
      before: s,
      after: "]"
    })
  ), a(), o(), s += r.move("]"), s;
}
function v$() {
  return "[";
}
function P$(n, e, t, i) {
  const r = t.createTracker(i);
  let s = r.move("[^");
  const o = t.enter("footnoteDefinition"), a = t.enter("label");
  return s += r.move(
    t.safe(t.associationId(n), {
      ...r.current(),
      before: s,
      after: "]"
    })
  ), a(), s += r.move(
    "]:" + (n.children && n.children.length > 0 ? " " : "")
  ), r.shift(4), s += r.move(
    t.indentLines(t.containerFlow(n, r.current()), Q$)
  ), o(), s;
}
function Q$(n, e, t) {
  return e === 0 ? n : (t ? "" : "    ") + n;
}
const $$ = [
  "autolink",
  "destinationLiteral",
  "destinationRaw",
  "reference",
  "titleQuote",
  "titleApostrophe"
];
P0.peek = M$;
function C$() {
  return {
    canContainEols: ["delete"],
    enter: { strikethrough: A$ },
    exit: { strikethrough: R$ }
  };
}
function T$() {
  return {
    unsafe: [
      {
        character: "~",
        inConstruct: "phrasing",
        notInConstruct: $$
      }
    ],
    handlers: { delete: P0 }
  };
}
function A$(n) {
  this.enter({ type: "delete", children: [] }, n);
}
function R$(n) {
  this.exit(n);
}
function P0(n, e, t, i) {
  const r = t.createTracker(i), s = t.enter("strikethrough");
  let o = r.move("~~");
  return o += t.containerPhrasing(n, {
    ...r.current(),
    before: o,
    after: "~"
  }), o += r.move("~~"), s(), o;
}
function M$() {
  return "~";
}
function Z$(n, e = {}) {
  const t = (e.align || []).concat(), i = e.stringLength || z$, r = [], s = [], o = [], a = [];
  let l = 0, u = -1;
  for (; ++u < n.length; ) {
    const p = [], g = [];
    let O = -1;
    for (n[u].length > l && (l = n[u].length); ++O < n[u].length; ) {
      const m = E$(n[u][O]);
      if (e.alignDelimiters !== !1) {
        const b = i(m);
        g[O] = b, (a[O] === void 0 || b > a[O]) && (a[O] = b);
      }
      p.push(m);
    }
    s[u] = p, o[u] = g;
  }
  let c = -1;
  if (typeof t == "object" && "length" in t)
    for (; ++c < l; )
      r[c] = pp(t[c]);
  else {
    const p = pp(t);
    for (; ++c < l; )
      r[c] = p;
  }
  c = -1;
  const h = [], f = [];
  for (; ++c < l; ) {
    const p = r[c];
    let g = "", O = "";
    p === 99 ? (g = ":", O = ":") : p === 108 ? g = ":" : p === 114 && (O = ":");
    let m = e.alignDelimiters === !1 ? 1 : Math.max(
      1,
      a[c] - g.length - O.length
    );
    const b = g + "-".repeat(m) + O;
    e.alignDelimiters !== !1 && (m = g.length + m + O.length, m > a[c] && (a[c] = m), f[c] = m), h[c] = b;
  }
  s.splice(1, 0, h), o.splice(1, 0, f), u = -1;
  const d = [];
  for (; ++u < s.length; ) {
    const p = s[u], g = o[u];
    c = -1;
    const O = [];
    for (; ++c < l; ) {
      const m = p[c] || "";
      let b = "", w = "";
      if (e.alignDelimiters !== !1) {
        const Q = a[c] - (g[c] || 0), v = r[c];
        v === 114 ? b = " ".repeat(Q) : v === 99 ? Q % 2 ? (b = " ".repeat(Q / 2 + 0.5), w = " ".repeat(Q / 2 - 0.5)) : (b = " ".repeat(Q / 2), w = b) : w = " ".repeat(Q);
      }
      e.delimiterStart !== !1 && !c && O.push("|"), e.padding !== !1 && // Don’t add the opening space if we’re not aligning and the cell is
      // empty: there will be a closing space.
      !(e.alignDelimiters === !1 && m === "") && (e.delimiterStart !== !1 || c) && O.push(" "), e.alignDelimiters !== !1 && O.push(b), O.push(m), e.alignDelimiters !== !1 && O.push(w), e.padding !== !1 && O.push(" "), (e.delimiterEnd !== !1 || c !== l - 1) && O.push("|");
    }
    d.push(
      e.delimiterEnd === !1 ? O.join("").replace(/ +$/, "") : O.join("")
    );
  }
  return d.join(`
`);
}
function E$(n) {
  return n == null ? "" : String(n);
}
function z$(n) {
  return n.length;
}
function pp(n) {
  const e = typeof n == "string" ? n.codePointAt(0) : 0;
  return e === 67 || e === 99 ? 99 : e === 76 || e === 108 ? 108 : e === 82 || e === 114 ? 114 : 0;
}
const mp = {}.hasOwnProperty;
function D$(n, e) {
  const t = e || {};
  function i(r, ...s) {
    let o = i.invalid;
    const a = i.handlers;
    if (r && mp.call(r, n)) {
      const l = String(r[n]);
      o = mp.call(a, l) ? a[l] : i.unknown;
    }
    if (o)
      return o.call(this, r, ...s);
  }
  return i.handlers = t.handlers || {}, i.invalid = t.invalid, i.unknown = t.unknown, i;
}
function I$(n, e, t, i) {
  const r = t.enter("blockquote"), s = t.createTracker(i);
  s.move("> "), s.shift(2);
  const o = t.indentLines(
    t.containerFlow(n, s.current()),
    L$
  );
  return r(), o;
}
function L$(n, e, t) {
  return ">" + (t ? "" : " ") + n;
}
function _$(n, e) {
  return gp(n, e.inConstruct, !0) && !gp(n, e.notInConstruct, !1);
}
function gp(n, e, t) {
  if (typeof e == "string" && (e = [e]), !e || e.length === 0)
    return t;
  let i = -1;
  for (; ++i < e.length; )
    if (n.includes(e[i]))
      return !0;
  return !1;
}
function Op(n, e, t, i) {
  let r = -1;
  for (; ++r < t.unsafe.length; )
    if (t.unsafe[r].character === `
` && _$(t.stack, t.unsafe[r]))
      return /[ \t]/.test(i.before) ? "" : " ";
  return `\\
`;
}
function X$(n, e) {
  const t = String(n);
  let i = t.indexOf(e), r = i, s = 0, o = 0;
  if (typeof e != "string")
    throw new TypeError("Expected substring");
  for (; i !== -1; )
    i === r ? ++s > o && (o = s) : s = 1, r = i + e.length, i = t.indexOf(e, r);
  return o;
}
function N$(n, e) {
  return !!(e.options.fences === !1 && n.value && // If there’s no info…
  !n.lang && // And there’s a non-whitespace character…
  /[^ \r\n]/.test(n.value) && // And the value doesn’t start or end in a blank…
  !/^[\t ]*(?:[\r\n]|$)|(?:^|[\r\n])[\t ]*$/.test(n.value));
}
function W$(n) {
  const e = n.options.fence || "`";
  if (e !== "`" && e !== "~")
    throw new Error(
      "Cannot serialize code with `" + e + "` for `options.fence`, expected `` ` `` or `~`"
    );
  return e;
}
function q$(n, e, t, i) {
  const r = W$(t), s = n.value || "", o = r === "`" ? "GraveAccent" : "Tilde";
  if (N$(n, t)) {
    const h = t.enter("codeIndented"), f = t.indentLines(s, B$);
    return h(), f;
  }
  const a = t.createTracker(i), l = r.repeat(Math.max(X$(s, r) + 1, 3)), u = t.enter("codeFenced");
  let c = a.move(l);
  if (n.lang) {
    const h = t.enter(`codeFencedLang${o}`);
    c += a.move(
      t.safe(n.lang, {
        before: c,
        after: " ",
        encode: ["`"],
        ...a.current()
      })
    ), h();
  }
  if (n.lang && n.meta) {
    const h = t.enter(`codeFencedMeta${o}`);
    c += a.move(" "), c += a.move(
      t.safe(n.meta, {
        before: c,
        after: `
`,
        encode: ["`"],
        ...a.current()
      })
    ), h();
  }
  return c += a.move(`
`), s && (c += a.move(s + `
`)), c += a.move(l), u(), c;
}
function B$(n, e, t) {
  return (t ? "" : "    ") + n;
}
function Eh(n) {
  const e = n.options.quote || '"';
  if (e !== '"' && e !== "'")
    throw new Error(
      "Cannot serialize title with `" + e + "` for `options.quote`, expected `\"`, or `'`"
    );
  return e;
}
function V$(n, e, t, i) {
  const r = Eh(t), s = r === '"' ? "Quote" : "Apostrophe", o = t.enter("definition");
  let a = t.enter("label");
  const l = t.createTracker(i);
  let u = l.move("[");
  return u += l.move(
    t.safe(t.associationId(n), {
      before: u,
      after: "]",
      ...l.current()
    })
  ), u += l.move("]: "), a(), // If there’s no url, or…
  !n.url || // If there are control characters or whitespace.
  /[\0- \u007F]/.test(n.url) ? (a = t.enter("destinationLiteral"), u += l.move("<"), u += l.move(
    t.safe(n.url, { before: u, after: ">", ...l.current() })
  ), u += l.move(">")) : (a = t.enter("destinationRaw"), u += l.move(
    t.safe(n.url, {
      before: u,
      after: n.title ? " " : `
`,
      ...l.current()
    })
  )), a(), n.title && (a = t.enter(`title${s}`), u += l.move(" " + r), u += l.move(
    t.safe(n.title, {
      before: u,
      after: r,
      ...l.current()
    })
  ), u += l.move(r), a()), o(), u;
}
function Y$(n) {
  const e = n.options.emphasis || "*";
  if (e !== "*" && e !== "_")
    throw new Error(
      "Cannot serialize emphasis with `" + e + "` for `options.emphasis`, expected `*`, or `_`"
    );
  return e;
}
Q0.peek = j$;
function Q0(n, e, t, i) {
  const r = Y$(t), s = t.enter("emphasis"), o = t.createTracker(i);
  let a = o.move(r);
  return a += o.move(
    t.containerPhrasing(n, {
      before: a,
      after: r,
      ...o.current()
    })
  ), a += o.move(r), s(), a;
}
function j$(n, e, t) {
  return t.options.emphasis || "*";
}
function $0(n, e, t, i) {
  let r, s, o;
  typeof e == "function" && typeof t != "function" ? (s = void 0, o = e, r = t) : (s = e, o = t, r = i), w0(n, s, a, r);
  function a(l, u) {
    const c = u[u.length - 1], h = c ? c.children.indexOf(l) : void 0;
    return o(l, h, c);
  }
}
const U$ = {};
function zh(n, e) {
  const t = U$, i = typeof t.includeImageAlt == "boolean" ? t.includeImageAlt : !0, r = typeof t.includeHtml == "boolean" ? t.includeHtml : !0;
  return C0(n, i, r);
}
function C0(n, e, t) {
  if (F$(n)) {
    if ("value" in n)
      return n.type === "html" && !t ? "" : n.value;
    if (e && "alt" in n && n.alt)
      return n.alt;
    if ("children" in n)
      return bp(n.children, e, t);
  }
  return Array.isArray(n) ? bp(n, e, t) : "";
}
function bp(n, e, t) {
  const i = [];
  let r = -1;
  for (; ++r < n.length; )
    i[r] = C0(n[r], e, t);
  return i.join("");
}
function F$(n) {
  return !!(n && typeof n == "object");
}
function G$(n, e) {
  let t = !1;
  return $0(n, function(i) {
    if ("value" in i && /\r?\n|\r/.test(i.value) || i.type === "break")
      return t = !0, pc;
  }), !!((!n.depth || n.depth < 3) && zh(n) && (e.options.setext || t));
}
function H$(n, e, t, i) {
  const r = Math.max(Math.min(6, n.depth || 1), 1), s = t.createTracker(i);
  if (G$(n, t)) {
    const c = t.enter("headingSetext"), h = t.enter("phrasing"), f = t.containerPhrasing(n, {
      ...s.current(),
      before: `
`,
      after: `
`
    });
    return h(), c(), f + `
` + (r === 1 ? "=" : "-").repeat(
      // The whole size…
      f.length - // Minus the position of the character after the last EOL (or
      // 0 if there is none)…
      (Math.max(f.lastIndexOf("\r"), f.lastIndexOf(`
`)) + 1)
    );
  }
  const o = "#".repeat(r), a = t.enter("headingAtx"), l = t.enter("phrasing");
  s.move(o + " ");
  let u = t.containerPhrasing(n, {
    before: "# ",
    after: `
`,
    ...s.current()
  });
  return /^[\t ]/.test(u) && (u = "&#x" + u.charCodeAt(0).toString(16).toUpperCase() + ";" + u.slice(1)), u = u ? o + " " + u : o, t.options.closeAtx && (u += " " + o), l(), a(), u;
}
T0.peek = K$;
function T0(n) {
  return n.value || "";
}
function K$() {
  return "<";
}
A0.peek = J$;
function A0(n, e, t, i) {
  const r = Eh(t), s = r === '"' ? "Quote" : "Apostrophe", o = t.enter("image");
  let a = t.enter("label");
  const l = t.createTracker(i);
  let u = l.move("![");
  return u += l.move(
    t.safe(n.alt, { before: u, after: "]", ...l.current() })
  ), u += l.move("]("), a(), // If there’s no url but there is a title…
  !n.url && n.title || // If there are control characters or whitespace.
  /[\0- \u007F]/.test(n.url) ? (a = t.enter("destinationLiteral"), u += l.move("<"), u += l.move(
    t.safe(n.url, { before: u, after: ">", ...l.current() })
  ), u += l.move(">")) : (a = t.enter("destinationRaw"), u += l.move(
    t.safe(n.url, {
      before: u,
      after: n.title ? " " : ")",
      ...l.current()
    })
  )), a(), n.title && (a = t.enter(`title${s}`), u += l.move(" " + r), u += l.move(
    t.safe(n.title, {
      before: u,
      after: r,
      ...l.current()
    })
  ), u += l.move(r), a()), u += l.move(")"), o(), u;
}
function J$() {
  return "!";
}
R0.peek = eC;
function R0(n, e, t, i) {
  const r = n.referenceType, s = t.enter("imageReference");
  let o = t.enter("label");
  const a = t.createTracker(i);
  let l = a.move("![");
  const u = t.safe(n.alt, {
    before: l,
    after: "]",
    ...a.current()
  });
  l += a.move(u + "]["), o();
  const c = t.stack;
  t.stack = [], o = t.enter("reference");
  const h = t.safe(t.associationId(n), {
    before: l,
    after: "]",
    ...a.current()
  });
  return o(), t.stack = c, s(), r === "full" || !u || u !== h ? l += a.move(h + "]") : r === "shortcut" ? l = l.slice(0, -1) : l += a.move("]"), l;
}
function eC() {
  return "!";
}
M0.peek = tC;
function M0(n, e, t) {
  let i = n.value || "", r = "`", s = -1;
  for (; new RegExp("(^|[^`])" + r + "([^`]|$)").test(i); )
    r += "`";
  for (/[^ \r\n]/.test(i) && (/^[ \r\n]/.test(i) && /[ \r\n]$/.test(i) || /^`|`$/.test(i)) && (i = " " + i + " "); ++s < t.unsafe.length; ) {
    const o = t.unsafe[s], a = t.compilePattern(o);
    let l;
    if (o.atBreak)
      for (; l = a.exec(i); ) {
        let u = l.index;
        i.charCodeAt(u) === 10 && i.charCodeAt(u - 1) === 13 && u--, i = i.slice(0, u) + " " + i.slice(l.index + 1);
      }
  }
  return r + i + r;
}
function tC() {
  return "`";
}
function Z0(n, e) {
  const t = zh(n);
  return !!(!e.options.resourceLink && // If there’s a url…
  n.url && // And there’s a no title…
  !n.title && // And the content of `node` is a single text node…
  n.children && n.children.length === 1 && n.children[0].type === "text" && // And if the url is the same as the content…
  (t === n.url || "mailto:" + t === n.url) && // And that starts w/ a protocol…
  /^[a-z][a-z+.-]+:/i.test(n.url) && // And that doesn’t contain ASCII control codes (character escapes and
  // references don’t work), space, or angle brackets…
  !/[\0- <>\u007F]/.test(n.url));
}
E0.peek = nC;
function E0(n, e, t, i) {
  const r = Eh(t), s = r === '"' ? "Quote" : "Apostrophe", o = t.createTracker(i);
  let a, l;
  if (Z0(n, t)) {
    const c = t.stack;
    t.stack = [], a = t.enter("autolink");
    let h = o.move("<");
    return h += o.move(
      t.containerPhrasing(n, {
        before: h,
        after: ">",
        ...o.current()
      })
    ), h += o.move(">"), a(), t.stack = c, h;
  }
  a = t.enter("link"), l = t.enter("label");
  let u = o.move("[");
  return u += o.move(
    t.containerPhrasing(n, {
      before: u,
      after: "](",
      ...o.current()
    })
  ), u += o.move("]("), l(), // If there’s no url but there is a title…
  !n.url && n.title || // If there are control characters or whitespace.
  /[\0- \u007F]/.test(n.url) ? (l = t.enter("destinationLiteral"), u += o.move("<"), u += o.move(
    t.safe(n.url, { before: u, after: ">", ...o.current() })
  ), u += o.move(">")) : (l = t.enter("destinationRaw"), u += o.move(
    t.safe(n.url, {
      before: u,
      after: n.title ? " " : ")",
      ...o.current()
    })
  )), l(), n.title && (l = t.enter(`title${s}`), u += o.move(" " + r), u += o.move(
    t.safe(n.title, {
      before: u,
      after: r,
      ...o.current()
    })
  ), u += o.move(r), l()), u += o.move(")"), a(), u;
}
function nC(n, e, t) {
  return Z0(n, t) ? "<" : "[";
}
z0.peek = iC;
function z0(n, e, t, i) {
  const r = n.referenceType, s = t.enter("linkReference");
  let o = t.enter("label");
  const a = t.createTracker(i);
  let l = a.move("[");
  const u = t.containerPhrasing(n, {
    before: l,
    after: "]",
    ...a.current()
  });
  l += a.move(u + "]["), o();
  const c = t.stack;
  t.stack = [], o = t.enter("reference");
  const h = t.safe(t.associationId(n), {
    before: l,
    after: "]",
    ...a.current()
  });
  return o(), t.stack = c, s(), r === "full" || !u || u !== h ? l += a.move(h + "]") : r === "shortcut" ? l = l.slice(0, -1) : l += a.move("]"), l;
}
function iC() {
  return "[";
}
function Dh(n) {
  const e = n.options.bullet || "*";
  if (e !== "*" && e !== "+" && e !== "-")
    throw new Error(
      "Cannot serialize items with `" + e + "` for `options.bullet`, expected `*`, `+`, or `-`"
    );
  return e;
}
function rC(n) {
  const e = Dh(n), t = n.options.bulletOther;
  if (!t)
    return e === "*" ? "-" : "*";
  if (t !== "*" && t !== "+" && t !== "-")
    throw new Error(
      "Cannot serialize items with `" + t + "` for `options.bulletOther`, expected `*`, `+`, or `-`"
    );
  if (t === e)
    throw new Error(
      "Expected `bullet` (`" + e + "`) and `bulletOther` (`" + t + "`) to be different"
    );
  return t;
}
function sC(n) {
  const e = n.options.bulletOrdered || ".";
  if (e !== "." && e !== ")")
    throw new Error(
      "Cannot serialize items with `" + e + "` for `options.bulletOrdered`, expected `.` or `)`"
    );
  return e;
}
function D0(n) {
  const e = n.options.rule || "*";
  if (e !== "*" && e !== "-" && e !== "_")
    throw new Error(
      "Cannot serialize rules with `" + e + "` for `options.rule`, expected `*`, `-`, or `_`"
    );
  return e;
}
function oC(n, e, t, i) {
  const r = t.enter("list"), s = t.bulletCurrent;
  let o = n.ordered ? sC(t) : Dh(t);
  const a = n.ordered ? o === "." ? ")" : "." : rC(t);
  let l = e && t.bulletLastUsed ? o === t.bulletLastUsed : !1;
  if (!n.ordered) {
    const c = n.children ? n.children[0] : void 0;
    if (
      // Bullet could be used as a thematic break marker:
      (o === "*" || o === "-") && // Empty first list item:
      c && (!c.children || !c.children[0]) && // Directly in two other list items:
      t.stack[t.stack.length - 1] === "list" && t.stack[t.stack.length - 2] === "listItem" && t.stack[t.stack.length - 3] === "list" && t.stack[t.stack.length - 4] === "listItem" && // That are each the first child.
      t.indexStack[t.indexStack.length - 1] === 0 && t.indexStack[t.indexStack.length - 2] === 0 && t.indexStack[t.indexStack.length - 3] === 0 && (l = !0), D0(t) === o && c
    ) {
      let h = -1;
      for (; ++h < n.children.length; ) {
        const f = n.children[h];
        if (f && f.type === "listItem" && f.children && f.children[0] && f.children[0].type === "thematicBreak") {
          l = !0;
          break;
        }
      }
    }
  }
  l && (o = a), t.bulletCurrent = o;
  const u = t.containerFlow(n, i);
  return t.bulletLastUsed = o, t.bulletCurrent = s, r(), u;
}
function aC(n) {
  const e = n.options.listItemIndent || "one";
  if (e !== "tab" && e !== "one" && e !== "mixed")
    throw new Error(
      "Cannot serialize items with `" + e + "` for `options.listItemIndent`, expected `tab`, `one`, or `mixed`"
    );
  return e;
}
function lC(n, e, t, i) {
  const r = aC(t);
  let s = t.bulletCurrent || Dh(t);
  e && e.type === "list" && e.ordered && (s = (typeof e.start == "number" && e.start > -1 ? e.start : 1) + (t.options.incrementListMarker === !1 ? 0 : e.children.indexOf(n)) + s);
  let o = s.length + 1;
  (r === "tab" || r === "mixed" && (e && e.type === "list" && e.spread || n.spread)) && (o = Math.ceil(o / 4) * 4);
  const a = t.createTracker(i);
  a.move(s + " ".repeat(o - s.length)), a.shift(o);
  const l = t.enter("listItem"), u = t.indentLines(
    t.containerFlow(n, a.current()),
    c
  );
  return l(), u;
  function c(h, f, d) {
    return f ? (d ? "" : " ".repeat(o)) + h : (d ? s : s + " ".repeat(o - s.length)) + h;
  }
}
function uC(n, e, t, i) {
  const r = t.enter("paragraph"), s = t.enter("phrasing"), o = t.containerPhrasing(n, i);
  return s(), r(), o;
}
const cC = (
  /** @type {(node?: unknown) => node is Exclude<PhrasingContent, Html>} */
  il([
    "break",
    "delete",
    "emphasis",
    // To do: next major: removed since footnotes were added to GFM.
    "footnote",
    "footnoteReference",
    "image",
    "imageReference",
    "inlineCode",
    // Enabled by `mdast-util-math`:
    "inlineMath",
    "link",
    "linkReference",
    // Enabled by `mdast-util-mdx`:
    "mdxJsxTextElement",
    // Enabled by `mdast-util-mdx`:
    "mdxTextExpression",
    "strong",
    "text",
    // Enabled by `mdast-util-directive`:
    "textDirective"
  ])
);
function hC(n, e, t, i) {
  return (n.children.some(function(o) {
    return cC(o);
  }) ? t.containerPhrasing : t.containerFlow).call(t, n, i);
}
function fC(n) {
  const e = n.options.strong || "*";
  if (e !== "*" && e !== "_")
    throw new Error(
      "Cannot serialize strong with `" + e + "` for `options.strong`, expected `*`, or `_`"
    );
  return e;
}
I0.peek = dC;
function I0(n, e, t, i) {
  const r = fC(t), s = t.enter("strong"), o = t.createTracker(i);
  let a = o.move(r + r);
  return a += o.move(
    t.containerPhrasing(n, {
      before: a,
      after: r,
      ...o.current()
    })
  ), a += o.move(r + r), s(), a;
}
function dC(n, e, t) {
  return t.options.strong || "*";
}
function pC(n, e, t, i) {
  return t.safe(n.value, i);
}
function mC(n) {
  const e = n.options.ruleRepetition || 3;
  if (e < 3)
    throw new Error(
      "Cannot serialize rules with repetition `" + e + "` for `options.ruleRepetition`, expected `3` or more"
    );
  return e;
}
function gC(n, e, t) {
  const i = (D0(t) + (t.options.ruleSpaces ? " " : "")).repeat(mC(t));
  return t.options.ruleSpaces ? i.slice(0, -1) : i;
}
const L0 = {
  blockquote: I$,
  break: Op,
  code: q$,
  definition: V$,
  emphasis: Q0,
  hardBreak: Op,
  heading: H$,
  html: T0,
  image: A0,
  imageReference: R0,
  inlineCode: M0,
  link: E0,
  linkReference: z0,
  list: oC,
  listItem: lC,
  paragraph: uC,
  root: hC,
  strong: I0,
  text: pC,
  thematicBreak: gC
}, yp = document.createElement("i");
function Ih(n) {
  const e = "&" + n + ";";
  yp.innerHTML = e;
  const t = yp.textContent;
  return t.charCodeAt(t.length - 1) === 59 && n !== "semi" || t === e ? !1 : t;
}
function _0(n, e) {
  const t = Number.parseInt(n, e);
  return (
    // C0 except for HT, LF, FF, CR, space.
    t < 9 || t === 11 || t > 13 && t < 32 || // Control character (DEL) of C0, and C1 controls.
    t > 126 && t < 160 || // Lone high surrogates and low surrogates.
    t > 55295 && t < 57344 || // Noncharacters.
    t > 64975 && t < 65008 || /* eslint-disable no-bitwise */
    (t & 65535) === 65535 || (t & 65535) === 65534 || /* eslint-enable no-bitwise */
    // Out of range
    t > 1114111 ? "�" : String.fromCodePoint(t)
  );
}
const OC = /\\([!-/:-@[-`{-~])|&(#(?:\d{1,7}|x[\da-f]{1,6})|[\da-z]{1,31});/gi;
function bC(n) {
  return n.replace(OC, yC);
}
function yC(n, e, t) {
  if (e)
    return e;
  if (t.charCodeAt(0) === 35) {
    const r = t.charCodeAt(1), s = r === 120 || r === 88;
    return _0(t.slice(s ? 2 : 1), s ? 16 : 10);
  }
  return Ih(t) || n;
}
function kC() {
  return {
    enter: {
      table: xC,
      tableData: kp,
      tableHeader: kp,
      tableRow: SC
    },
    exit: {
      codeText: vC,
      table: wC,
      tableData: Xl,
      tableHeader: Xl,
      tableRow: Xl
    }
  };
}
function xC(n) {
  const e = n._align;
  this.enter(
    {
      type: "table",
      align: e.map(function(t) {
        return t === "none" ? null : t;
      }),
      children: []
    },
    n
  ), this.data.inTable = !0;
}
function wC(n) {
  this.exit(n), this.data.inTable = void 0;
}
function SC(n) {
  this.enter({ type: "tableRow", children: [] }, n);
}
function Xl(n) {
  this.exit(n);
}
function kp(n) {
  this.enter({ type: "tableCell", children: [] }, n);
}
function vC(n) {
  let e = this.resume();
  this.data.inTable && (e = e.replace(/\\([\\|])/g, PC));
  const t = this.stack[this.stack.length - 1];
  t.type, t.value = e, this.exit(n);
}
function PC(n, e) {
  return e === "|" ? e : n;
}
function QC(n) {
  const e = n || {}, t = e.tableCellPadding, i = e.tablePipeAlign, r = e.stringLength, s = t ? " " : "|";
  return {
    unsafe: [
      { character: "\r", inConstruct: "tableCell" },
      { character: `
`, inConstruct: "tableCell" },
      // A pipe, when followed by a tab or space (padding), or a dash or colon
      // (unpadded delimiter row), could result in a table.
      { atBreak: !0, character: "|", after: "[	 :-]" },
      // A pipe in a cell must be encoded.
      { character: "|", inConstruct: "tableCell" },
      // A colon must be followed by a dash, in which case it could start a
      // delimiter row.
      { atBreak: !0, character: ":", after: "-" },
      // A delimiter row can also start with a dash, when followed by more
      // dashes, a colon, or a pipe.
      // This is a stricter version than the built in check for lists, thematic
      // breaks, and setex heading underlines though:
      // <https://github.com/syntax-tree/mdast-util-to-markdown/blob/51a2038/lib/unsafe.js#L57>
      { atBreak: !0, character: "-", after: "[:|-]" }
    ],
    handlers: {
      inlineCode: f,
      table: o,
      tableCell: l,
      tableRow: a
    }
  };
  function o(d, p, g, O) {
    return u(c(d, g, O), d.align);
  }
  function a(d, p, g, O) {
    const m = h(d, g, O), b = u([m]);
    return b.slice(0, b.indexOf(`
`));
  }
  function l(d, p, g, O) {
    const m = g.enter("tableCell"), b = g.enter("phrasing"), w = g.containerPhrasing(d, {
      ...O,
      before: s,
      after: s
    });
    return b(), m(), w;
  }
  function u(d, p) {
    return Z$(d, {
      align: p,
      // @ts-expect-error: `markdown-table` types should support `null`.
      alignDelimiters: i,
      // @ts-expect-error: `markdown-table` types should support `null`.
      padding: t,
      // @ts-expect-error: `markdown-table` types should support `null`.
      stringLength: r
    });
  }
  function c(d, p, g) {
    const O = d.children;
    let m = -1;
    const b = [], w = p.enter("table");
    for (; ++m < O.length; )
      b[m] = h(O[m], p, g);
    return w(), b;
  }
  function h(d, p, g) {
    const O = d.children;
    let m = -1;
    const b = [], w = p.enter("tableRow");
    for (; ++m < O.length; )
      b[m] = l(O[m], d, p, g);
    return w(), b;
  }
  function f(d, p, g) {
    let O = L0.inlineCode(d, p, g);
    return g.stack.includes("tableCell") && (O = O.replace(/\|/g, "\\$&")), O;
  }
}
function $C() {
  return {
    exit: {
      taskListCheckValueChecked: xp,
      taskListCheckValueUnchecked: xp,
      paragraph: TC
    }
  };
}
function CC() {
  return {
    unsafe: [{ atBreak: !0, character: "-", after: "[:|-]" }],
    handlers: { listItem: AC }
  };
}
function xp(n) {
  const e = this.stack[this.stack.length - 2];
  e.type, e.checked = n.type === "taskListCheckValueChecked";
}
function TC(n) {
  const e = this.stack[this.stack.length - 2];
  if (e && e.type === "listItem" && typeof e.checked == "boolean") {
    const t = this.stack[this.stack.length - 1];
    t.type;
    const i = t.children[0];
    if (i && i.type === "text") {
      const r = e.children;
      let s = -1, o;
      for (; ++s < r.length; ) {
        const a = r[s];
        if (a.type === "paragraph") {
          o = a;
          break;
        }
      }
      o === t && (i.value = i.value.slice(1), i.value.length === 0 ? t.children.shift() : t.position && i.position && typeof i.position.start.offset == "number" && (i.position.start.column++, i.position.start.offset++, t.position.start = Object.assign({}, i.position.start)));
    }
  }
  this.exit(n);
}
function AC(n, e, t, i) {
  const r = n.children[0], s = typeof n.checked == "boolean" && r && r.type === "paragraph", o = "[" + (n.checked ? "x" : " ") + "] ", a = t.createTracker(i);
  s && a.move(o);
  let l = L0.listItem(n, e, t, {
    ...i,
    ...a.current()
  });
  return s && (l = l.replace(/^(?:[*+-]|\d+\.)([\r\n]| {1,3})/, u)), l;
  function u(c) {
    return c + o;
  }
}
function RC() {
  return [
    n$(),
    p$(),
    C$(),
    kC(),
    $C()
  ];
}
function MC(n) {
  return {
    extensions: [
      i$(),
      m$(),
      T$(),
      QC(n),
      CC()
    ]
  };
}
function Dt(n, e, t, i) {
  const r = n.length;
  let s = 0, o;
  if (e < 0 ? e = -e > r ? 0 : r + e : e = e > r ? r : e, t = t > 0 ? t : 0, i.length < 1e4)
    o = Array.from(i), o.unshift(e, t), n.splice(...o);
  else
    for (t && n.splice(e, t); s < i.length; )
      o = i.slice(s, s + 1e4), o.unshift(e, 0), n.splice(...o), s += 1e4, e += 1e4;
}
function At(n, e) {
  return n.length > 0 ? (Dt(n, n.length, 0, e), n) : e;
}
const wp = {}.hasOwnProperty;
function X0(n) {
  const e = {};
  let t = -1;
  for (; ++t < n.length; )
    ZC(e, n[t]);
  return e;
}
function ZC(n, e) {
  let t;
  for (t in e) {
    const r = (wp.call(n, t) ? n[t] : void 0) || (n[t] = {}), s = e[t];
    let o;
    if (s)
      for (o in s) {
        wp.call(r, o) || (r[o] = []);
        const a = s[o];
        EC(
          // @ts-expect-error Looks like a list.
          r[o],
          Array.isArray(a) ? a : a ? [a] : []
        );
      }
  }
}
function EC(n, e) {
  let t = -1;
  const i = [];
  for (; ++t < e.length; )
    (e[t].add === "after" ? n : i).push(e[t]);
  Dt(n, 0, 0, i);
}
const zC = {
  tokenize: NC,
  partial: !0
}, N0 = {
  tokenize: WC,
  partial: !0
}, W0 = {
  tokenize: qC,
  partial: !0
}, q0 = {
  tokenize: BC,
  partial: !0
}, DC = {
  tokenize: VC,
  partial: !0
}, B0 = {
  tokenize: _C,
  previous: Y0
}, V0 = {
  tokenize: XC,
  previous: j0
}, En = {
  tokenize: LC,
  previous: U0
}, On = {};
function IC() {
  return {
    text: On
  };
}
let li = 48;
for (; li < 123; )
  On[li] = En, li++, li === 58 ? li = 65 : li === 91 && (li = 97);
On[43] = En;
On[45] = En;
On[46] = En;
On[95] = En;
On[72] = [En, V0];
On[104] = [En, V0];
On[87] = [En, B0];
On[119] = [En, B0];
function LC(n, e, t) {
  const i = this;
  let r, s;
  return o;
  function o(h) {
    return !mc(h) || !U0.call(i, i.previous) || Lh(i.events) ? t(h) : (n.enter("literalAutolink"), n.enter("literalAutolinkEmail"), a(h));
  }
  function a(h) {
    return mc(h) ? (n.consume(h), a) : h === 64 ? (n.consume(h), l) : t(h);
  }
  function l(h) {
    return h === 46 ? n.check(
      DC,
      c,
      u
    )(h) : h === 45 || h === 95 || nt(h) ? (s = !0, n.consume(h), l) : c(h);
  }
  function u(h) {
    return n.consume(h), r = !0, l;
  }
  function c(h) {
    return s && r && at(i.previous) ? (n.exit("literalAutolinkEmail"), n.exit("literalAutolink"), e(h)) : t(h);
  }
}
function _C(n, e, t) {
  const i = this;
  return r;
  function r(o) {
    return o !== 87 && o !== 119 || !Y0.call(i, i.previous) || Lh(i.events) ? t(o) : (n.enter("literalAutolink"), n.enter("literalAutolinkWww"), n.check(
      zC,
      n.attempt(N0, n.attempt(W0, s), t),
      t
    )(o));
  }
  function s(o) {
    return n.exit("literalAutolinkWww"), n.exit("literalAutolink"), e(o);
  }
}
function XC(n, e, t) {
  const i = this;
  let r = "", s = !1;
  return o;
  function o(h) {
    return (h === 72 || h === 104) && j0.call(i, i.previous) && !Lh(i.events) ? (n.enter("literalAutolink"), n.enter("literalAutolinkHttp"), r += String.fromCodePoint(h), n.consume(h), a) : t(h);
  }
  function a(h) {
    if (at(h) && r.length < 5)
      return r += String.fromCodePoint(h), n.consume(h), a;
    if (h === 58) {
      const f = r.toLowerCase();
      if (f === "http" || f === "https")
        return n.consume(h), l;
    }
    return t(h);
  }
  function l(h) {
    return h === 47 ? (n.consume(h), s ? u : (s = !0, l)) : t(h);
  }
  function u(h) {
    return h === null || Pa(h) || xe(h) || Pi(h) || nl(h) ? t(h) : n.attempt(N0, n.attempt(W0, c), t)(h);
  }
  function c(h) {
    return n.exit("literalAutolinkHttp"), n.exit("literalAutolink"), e(h);
  }
}
function NC(n, e, t) {
  let i = 0;
  return r;
  function r(o) {
    return (o === 87 || o === 119) && i < 3 ? (i++, n.consume(o), r) : o === 46 && i === 3 ? (n.consume(o), s) : t(o);
  }
  function s(o) {
    return o === null ? t(o) : e(o);
  }
}
function WC(n, e, t) {
  let i, r, s;
  return o;
  function o(u) {
    return u === 46 || u === 95 ? n.check(q0, l, a)(u) : u === null || xe(u) || Pi(u) || u !== 45 && nl(u) ? l(u) : (s = !0, n.consume(u), o);
  }
  function a(u) {
    return u === 95 ? i = !0 : (r = i, i = void 0), n.consume(u), o;
  }
  function l(u) {
    return r || i || !s ? t(u) : e(u);
  }
}
function qC(n, e) {
  let t = 0, i = 0;
  return r;
  function r(o) {
    return o === 40 ? (t++, n.consume(o), r) : o === 41 && i < t ? s(o) : o === 33 || o === 34 || o === 38 || o === 39 || o === 41 || o === 42 || o === 44 || o === 46 || o === 58 || o === 59 || o === 60 || o === 63 || o === 93 || o === 95 || o === 126 ? n.check(q0, e, s)(o) : o === null || xe(o) || Pi(o) ? e(o) : (n.consume(o), r);
  }
  function s(o) {
    return o === 41 && i++, n.consume(o), r;
  }
}
function BC(n, e, t) {
  return i;
  function i(a) {
    return a === 33 || a === 34 || a === 39 || a === 41 || a === 42 || a === 44 || a === 46 || a === 58 || a === 59 || a === 63 || a === 95 || a === 126 ? (n.consume(a), i) : a === 38 ? (n.consume(a), s) : a === 93 ? (n.consume(a), r) : (
      // `<` is an end.
      a === 60 || // So is whitespace.
      a === null || xe(a) || Pi(a) ? e(a) : t(a)
    );
  }
  function r(a) {
    return a === null || a === 40 || a === 91 || xe(a) || Pi(a) ? e(a) : i(a);
  }
  function s(a) {
    return at(a) ? o(a) : t(a);
  }
  function o(a) {
    return a === 59 ? (n.consume(a), i) : at(a) ? (n.consume(a), o) : t(a);
  }
}
function VC(n, e, t) {
  return i;
  function i(s) {
    return n.consume(s), r;
  }
  function r(s) {
    return nt(s) ? t(s) : e(s);
  }
}
function Y0(n) {
  return n === null || n === 40 || n === 42 || n === 95 || n === 91 || n === 93 || n === 126 || xe(n);
}
function j0(n) {
  return !at(n);
}
function U0(n) {
  return !(n === 47 || mc(n));
}
function mc(n) {
  return n === 43 || n === 45 || n === 46 || n === 95 || nt(n);
}
function Lh(n) {
  let e = n.length, t = !1;
  for (; e--; ) {
    const i = n[e][1];
    if ((i.type === "labelLink" || i.type === "labelImage") && !i._balanced) {
      t = !0;
      break;
    }
    if (i._gfmAutolinkLiteralWalkedInto) {
      t = !1;
      break;
    }
  }
  return n.length > 0 && !t && (n[n.length - 1][1]._gfmAutolinkLiteralWalkedInto = !0), t;
}
function kr(n) {
  const e = [];
  let t = -1, i = 0, r = 0;
  for (; ++t < n.length; ) {
    const s = n.charCodeAt(t);
    let o = "";
    if (s === 37 && nt(n.charCodeAt(t + 1)) && nt(n.charCodeAt(t + 2)))
      r = 2;
    else if (s < 128)
      /[!#$&-;=?-Z_a-z~]/.test(String.fromCharCode(s)) || (o = String.fromCharCode(s));
    else if (s > 55295 && s < 57344) {
      const a = n.charCodeAt(t + 1);
      s < 56320 && a > 56319 && a < 57344 ? (o = String.fromCharCode(s, a), r = 1) : o = "�";
    } else
      o = String.fromCharCode(s);
    o && (e.push(n.slice(i, t), encodeURIComponent(o)), i = t + r + 1, o = ""), r && (t += r, r = 0);
  }
  return e.join("") + n.slice(i);
}
function Qa(n) {
  if (n === null || xe(n) || Pi(n))
    return 1;
  if (nl(n))
    return 2;
}
function sl(n, e, t) {
  const i = [];
  let r = -1;
  for (; ++r < n.length; ) {
    const s = n[r].resolveAll;
    s && !i.includes(s) && (e = s(e, t), i.push(s));
  }
  return e;
}
const gc = {
  name: "attention",
  tokenize: jC,
  resolveAll: YC
};
function YC(n, e) {
  let t = -1, i, r, s, o, a, l, u, c;
  for (; ++t < n.length; )
    if (n[t][0] === "enter" && n[t][1].type === "attentionSequence" && n[t][1]._close) {
      for (i = t; i--; )
        if (n[i][0] === "exit" && n[i][1].type === "attentionSequence" && n[i][1]._open && // If the markers are the same:
        e.sliceSerialize(n[i][1]).charCodeAt(0) === e.sliceSerialize(n[t][1]).charCodeAt(0)) {
          if ((n[i][1]._close || n[t][1]._open) && (n[t][1].end.offset - n[t][1].start.offset) % 3 && !((n[i][1].end.offset - n[i][1].start.offset + n[t][1].end.offset - n[t][1].start.offset) % 3))
            continue;
          l = n[i][1].end.offset - n[i][1].start.offset > 1 && n[t][1].end.offset - n[t][1].start.offset > 1 ? 2 : 1;
          const h = Object.assign({}, n[i][1].end), f = Object.assign({}, n[t][1].start);
          Sp(h, -l), Sp(f, l), o = {
            type: l > 1 ? "strongSequence" : "emphasisSequence",
            start: h,
            end: Object.assign({}, n[i][1].end)
          }, a = {
            type: l > 1 ? "strongSequence" : "emphasisSequence",
            start: Object.assign({}, n[t][1].start),
            end: f
          }, s = {
            type: l > 1 ? "strongText" : "emphasisText",
            start: Object.assign({}, n[i][1].end),
            end: Object.assign({}, n[t][1].start)
          }, r = {
            type: l > 1 ? "strong" : "emphasis",
            start: Object.assign({}, o.start),
            end: Object.assign({}, a.end)
          }, n[i][1].end = Object.assign({}, o.start), n[t][1].start = Object.assign({}, a.end), u = [], n[i][1].end.offset - n[i][1].start.offset && (u = At(u, [["enter", n[i][1], e], ["exit", n[i][1], e]])), u = At(u, [["enter", r, e], ["enter", o, e], ["exit", o, e], ["enter", s, e]]), u = At(u, sl(e.parser.constructs.insideSpan.null, n.slice(i + 1, t), e)), u = At(u, [["exit", s, e], ["enter", a, e], ["exit", a, e], ["exit", r, e]]), n[t][1].end.offset - n[t][1].start.offset ? (c = 2, u = At(u, [["enter", n[t][1], e], ["exit", n[t][1], e]])) : c = 0, Dt(n, i - 1, t - i + 3, u), t = i + u.length - c - 2;
          break;
        }
    }
  for (t = -1; ++t < n.length; )
    n[t][1].type === "attentionSequence" && (n[t][1].type = "data");
  return n;
}
function jC(n, e) {
  const t = this.parser.constructs.attentionMarkers.null, i = this.previous, r = Qa(i);
  let s;
  return o;
  function o(l) {
    return s = l, n.enter("attentionSequence"), a(l);
  }
  function a(l) {
    if (l === s)
      return n.consume(l), a;
    const u = n.exit("attentionSequence"), c = Qa(l), h = !c || c === 2 && r || t.includes(l), f = !r || r === 2 && c || t.includes(i);
    return u._open = !!(s === 42 ? h : h && (r || !f)), u._close = !!(s === 42 ? f : f && (c || !h)), e(l);
  }
}
function Sp(n, e) {
  n.column += e, n.offset += e, n._bufferIndex += e;
}
const UC = {
  name: "autolink",
  tokenize: FC
};
function FC(n, e, t) {
  let i = 0;
  return r;
  function r(d) {
    return n.enter("autolink"), n.enter("autolinkMarker"), n.consume(d), n.exit("autolinkMarker"), n.enter("autolinkProtocol"), s;
  }
  function s(d) {
    return at(d) ? (n.consume(d), o) : d === 64 ? t(d) : u(d);
  }
  function o(d) {
    return d === 43 || d === 45 || d === 46 || nt(d) ? (i = 1, a(d)) : u(d);
  }
  function a(d) {
    return d === 58 ? (n.consume(d), i = 0, l) : (d === 43 || d === 45 || d === 46 || nt(d)) && i++ < 32 ? (n.consume(d), a) : (i = 0, u(d));
  }
  function l(d) {
    return d === 62 ? (n.exit("autolinkProtocol"), n.enter("autolinkMarker"), n.consume(d), n.exit("autolinkMarker"), n.exit("autolink"), e) : d === null || d === 32 || d === 60 || Pa(d) ? t(d) : (n.consume(d), l);
  }
  function u(d) {
    return d === 64 ? (n.consume(d), c) : XQ(d) ? (n.consume(d), u) : t(d);
  }
  function c(d) {
    return nt(d) ? h(d) : t(d);
  }
  function h(d) {
    return d === 46 ? (n.consume(d), i = 0, c) : d === 62 ? (n.exit("autolinkProtocol").type = "autolinkEmail", n.enter("autolinkMarker"), n.consume(d), n.exit("autolinkMarker"), n.exit("autolink"), e) : f(d);
  }
  function f(d) {
    if ((d === 45 || nt(d)) && i++ < 63) {
      const p = d === 45 ? f : h;
      return n.consume(d), p;
    }
    return t(d);
  }
}
function fe(n, e, t, i) {
  const r = i ? i - 1 : Number.POSITIVE_INFINITY;
  let s = 0;
  return o;
  function o(l) {
    return ae(l) ? (n.enter(t), a(l)) : e(l);
  }
  function a(l) {
    return ae(l) && s++ < r ? (n.consume(l), a) : (n.exit(t), e(l));
  }
}
const Ns = {
  tokenize: GC,
  partial: !0
};
function GC(n, e, t) {
  return i;
  function i(s) {
    return ae(s) ? fe(n, r, "linePrefix")(s) : r(s);
  }
  function r(s) {
    return s === null || G(s) ? e(s) : t(s);
  }
}
const F0 = {
  name: "blockQuote",
  tokenize: HC,
  continuation: {
    tokenize: KC
  },
  exit: JC
};
function HC(n, e, t) {
  const i = this;
  return r;
  function r(o) {
    if (o === 62) {
      const a = i.containerState;
      return a.open || (n.enter("blockQuote", {
        _container: !0
      }), a.open = !0), n.enter("blockQuotePrefix"), n.enter("blockQuoteMarker"), n.consume(o), n.exit("blockQuoteMarker"), s;
    }
    return t(o);
  }
  function s(o) {
    return ae(o) ? (n.enter("blockQuotePrefixWhitespace"), n.consume(o), n.exit("blockQuotePrefixWhitespace"), n.exit("blockQuotePrefix"), e) : (n.exit("blockQuotePrefix"), e(o));
  }
}
function KC(n, e, t) {
  const i = this;
  return r;
  function r(o) {
    return ae(o) ? fe(n, s, "linePrefix", i.parser.constructs.disable.null.includes("codeIndented") ? void 0 : 4)(o) : s(o);
  }
  function s(o) {
    return n.attempt(F0, e, t)(o);
  }
}
function JC(n) {
  n.exit("blockQuote");
}
const G0 = {
  name: "characterEscape",
  tokenize: e3
};
function e3(n, e, t) {
  return i;
  function i(s) {
    return n.enter("characterEscape"), n.enter("escapeMarker"), n.consume(s), n.exit("escapeMarker"), r;
  }
  function r(s) {
    return WQ(s) ? (n.enter("characterEscapeValue"), n.consume(s), n.exit("characterEscapeValue"), n.exit("characterEscape"), e) : t(s);
  }
}
const H0 = {
  name: "characterReference",
  tokenize: t3
};
function t3(n, e, t) {
  const i = this;
  let r = 0, s, o;
  return a;
  function a(h) {
    return n.enter("characterReference"), n.enter("characterReferenceMarker"), n.consume(h), n.exit("characterReferenceMarker"), l;
  }
  function l(h) {
    return h === 35 ? (n.enter("characterReferenceMarkerNumeric"), n.consume(h), n.exit("characterReferenceMarkerNumeric"), u) : (n.enter("characterReferenceValue"), s = 31, o = nt, c(h));
  }
  function u(h) {
    return h === 88 || h === 120 ? (n.enter("characterReferenceMarkerHexadecimal"), n.consume(h), n.exit("characterReferenceMarkerHexadecimal"), n.enter("characterReferenceValue"), s = 6, o = NQ, c) : (n.enter("characterReferenceValue"), s = 7, o = dc, c(h));
  }
  function c(h) {
    if (h === 59 && r) {
      const f = n.exit("characterReferenceValue");
      return o === nt && !Ih(i.sliceSerialize(f)) ? t(h) : (n.enter("characterReferenceMarker"), n.consume(h), n.exit("characterReferenceMarker"), n.exit("characterReference"), e);
    }
    return o(h) && r++ < s ? (n.consume(h), c) : t(h);
  }
}
const vp = {
  tokenize: i3,
  partial: !0
}, Pp = {
  name: "codeFenced",
  tokenize: n3,
  concrete: !0
};
function n3(n, e, t) {
  const i = this, r = {
    tokenize: v,
    partial: !0
  };
  let s = 0, o = 0, a;
  return l;
  function l(k) {
    return u(k);
  }
  function u(k) {
    const C = i.events[i.events.length - 1];
    return s = C && C[1].type === "linePrefix" ? C[2].sliceSerialize(C[1], !0).length : 0, a = k, n.enter("codeFenced"), n.enter("codeFencedFence"), n.enter("codeFencedFenceSequence"), c(k);
  }
  function c(k) {
    return k === a ? (o++, n.consume(k), c) : o < 3 ? t(k) : (n.exit("codeFencedFenceSequence"), ae(k) ? fe(n, h, "whitespace")(k) : h(k));
  }
  function h(k) {
    return k === null || G(k) ? (n.exit("codeFencedFence"), i.interrupt ? e(k) : n.check(vp, g, Q)(k)) : (n.enter("codeFencedFenceInfo"), n.enter("chunkString", {
      contentType: "string"
    }), f(k));
  }
  function f(k) {
    return k === null || G(k) ? (n.exit("chunkString"), n.exit("codeFencedFenceInfo"), h(k)) : ae(k) ? (n.exit("chunkString"), n.exit("codeFencedFenceInfo"), fe(n, d, "whitespace")(k)) : k === 96 && k === a ? t(k) : (n.consume(k), f);
  }
  function d(k) {
    return k === null || G(k) ? h(k) : (n.enter("codeFencedFenceMeta"), n.enter("chunkString", {
      contentType: "string"
    }), p(k));
  }
  function p(k) {
    return k === null || G(k) ? (n.exit("chunkString"), n.exit("codeFencedFenceMeta"), h(k)) : k === 96 && k === a ? t(k) : (n.consume(k), p);
  }
  function g(k) {
    return n.attempt(r, Q, O)(k);
  }
  function O(k) {
    return n.enter("lineEnding"), n.consume(k), n.exit("lineEnding"), m;
  }
  function m(k) {
    return s > 0 && ae(k) ? fe(n, b, "linePrefix", s + 1)(k) : b(k);
  }
  function b(k) {
    return k === null || G(k) ? n.check(vp, g, Q)(k) : (n.enter("codeFlowValue"), w(k));
  }
  function w(k) {
    return k === null || G(k) ? (n.exit("codeFlowValue"), b(k)) : (n.consume(k), w);
  }
  function Q(k) {
    return n.exit("codeFenced"), e(k);
  }
  function v(k, C, I) {
    let z = 0;
    return P;
    function P(E) {
      return k.enter("lineEnding"), k.consume(E), k.exit("lineEnding"), R;
    }
    function R(E) {
      return k.enter("codeFencedFence"), ae(E) ? fe(k, A, "linePrefix", i.parser.constructs.disable.null.includes("codeIndented") ? void 0 : 4)(E) : A(E);
    }
    function A(E) {
      return E === a ? (k.enter("codeFencedFenceSequence"), j(E)) : I(E);
    }
    function j(E) {
      return E === a ? (z++, k.consume(E), j) : z >= o ? (k.exit("codeFencedFenceSequence"), ae(E) ? fe(k, U, "whitespace")(E) : U(E)) : I(E);
    }
    function U(E) {
      return E === null || G(E) ? (k.exit("codeFencedFence"), C(E)) : I(E);
    }
  }
}
function i3(n, e, t) {
  const i = this;
  return r;
  function r(o) {
    return o === null ? t(o) : (n.enter("lineEnding"), n.consume(o), n.exit("lineEnding"), s);
  }
  function s(o) {
    return i.parser.lazy[i.now().line] ? t(o) : e(o);
  }
}
const Nl = {
  name: "codeIndented",
  tokenize: s3
}, r3 = {
  tokenize: o3,
  partial: !0
};
function s3(n, e, t) {
  const i = this;
  return r;
  function r(u) {
    return n.enter("codeIndented"), fe(n, s, "linePrefix", 5)(u);
  }
  function s(u) {
    const c = i.events[i.events.length - 1];
    return c && c[1].type === "linePrefix" && c[2].sliceSerialize(c[1], !0).length >= 4 ? o(u) : t(u);
  }
  function o(u) {
    return u === null ? l(u) : G(u) ? n.attempt(r3, o, l)(u) : (n.enter("codeFlowValue"), a(u));
  }
  function a(u) {
    return u === null || G(u) ? (n.exit("codeFlowValue"), o(u)) : (n.consume(u), a);
  }
  function l(u) {
    return n.exit("codeIndented"), e(u);
  }
}
function o3(n, e, t) {
  const i = this;
  return r;
  function r(o) {
    return i.parser.lazy[i.now().line] ? t(o) : G(o) ? (n.enter("lineEnding"), n.consume(o), n.exit("lineEnding"), r) : fe(n, s, "linePrefix", 5)(o);
  }
  function s(o) {
    const a = i.events[i.events.length - 1];
    return a && a[1].type === "linePrefix" && a[2].sliceSerialize(a[1], !0).length >= 4 ? e(o) : G(o) ? r(o) : t(o);
  }
}
const a3 = {
  name: "codeText",
  tokenize: c3,
  resolve: l3,
  previous: u3
};
function l3(n) {
  let e = n.length - 4, t = 3, i, r;
  if ((n[t][1].type === "lineEnding" || n[t][1].type === "space") && (n[e][1].type === "lineEnding" || n[e][1].type === "space")) {
    for (i = t; ++i < e; )
      if (n[i][1].type === "codeTextData") {
        n[t][1].type = "codeTextPadding", n[e][1].type = "codeTextPadding", t += 2, e -= 2;
        break;
      }
  }
  for (i = t - 1, e++; ++i <= e; )
    r === void 0 ? i !== e && n[i][1].type !== "lineEnding" && (r = i) : (i === e || n[i][1].type === "lineEnding") && (n[r][1].type = "codeTextData", i !== r + 2 && (n[r][1].end = n[i - 1][1].end, n.splice(r + 2, i - r - 2), e -= i - r - 2, i = r + 2), r = void 0);
  return n;
}
function u3(n) {
  return n !== 96 || this.events[this.events.length - 1][1].type === "characterEscape";
}
function c3(n, e, t) {
  let i = 0, r, s;
  return o;
  function o(h) {
    return n.enter("codeText"), n.enter("codeTextSequence"), a(h);
  }
  function a(h) {
    return h === 96 ? (n.consume(h), i++, a) : (n.exit("codeTextSequence"), l(h));
  }
  function l(h) {
    return h === null ? t(h) : h === 32 ? (n.enter("space"), n.consume(h), n.exit("space"), l) : h === 96 ? (s = n.enter("codeTextSequence"), r = 0, c(h)) : G(h) ? (n.enter("lineEnding"), n.consume(h), n.exit("lineEnding"), l) : (n.enter("codeTextData"), u(h));
  }
  function u(h) {
    return h === null || h === 32 || h === 96 || G(h) ? (n.exit("codeTextData"), l(h)) : (n.consume(h), u);
  }
  function c(h) {
    return h === 96 ? (n.consume(h), r++, c) : r === i ? (n.exit("codeTextSequence"), n.exit("codeText"), e(h)) : (s.type = "codeTextData", u(h));
  }
}
class h3 {
  /**
   * @param {ReadonlyArray<T> | null | undefined} [initial]
   *   Initial items (optional).
   * @returns
   *   Splice buffer.
   */
  constructor(e) {
    this.left = e ? [...e] : [], this.right = [];
  }
  /**
   * Array access;
   * does not move the cursor.
   *
   * @param {number} index
   *   Index.
   * @return {T}
   *   Item.
   */
  get(e) {
    if (e < 0 || e >= this.left.length + this.right.length)
      throw new RangeError("Cannot access index `" + e + "` in a splice buffer of size `" + (this.left.length + this.right.length) + "`");
    return e < this.left.length ? this.left[e] : this.right[this.right.length - e + this.left.length - 1];
  }
  /**
   * The length of the splice buffer, one greater than the largest index in the
   * array.
   */
  get length() {
    return this.left.length + this.right.length;
  }
  /**
   * Remove and return `list[0]`;
   * moves the cursor to `0`.
   *
   * @returns {T | undefined}
   *   Item, optional.
   */
  shift() {
    return this.setCursor(0), this.right.pop();
  }
  /**
   * Slice the buffer to get an array;
   * does not move the cursor.
   *
   * @param {number} start
   *   Start.
   * @param {number | null | undefined} [end]
   *   End (optional).
   * @returns {Array<T>}
   *   Array of items.
   */
  slice(e, t) {
    const i = t ?? Number.POSITIVE_INFINITY;
    return i < this.left.length ? this.left.slice(e, i) : e > this.left.length ? this.right.slice(this.right.length - i + this.left.length, this.right.length - e + this.left.length).reverse() : this.left.slice(e).concat(this.right.slice(this.right.length - i + this.left.length).reverse());
  }
  /**
   * Mimics the behavior of Array.prototype.splice() except for the change of
   * interface necessary to avoid segfaults when patching in very large arrays.
   *
   * This operation moves cursor is moved to `start` and results in the cursor
   * placed after any inserted items.
   *
   * @param {number} start
   *   Start;
   *   zero-based index at which to start changing the array;
   *   negative numbers count backwards from the end of the array and values
   *   that are out-of bounds are clamped to the appropriate end of the array.
   * @param {number | null | undefined} [deleteCount=0]
   *   Delete count (default: `0`);
   *   maximum number of elements to delete, starting from start.
   * @param {Array<T> | null | undefined} [items=[]]
   *   Items to include in place of the deleted items (default: `[]`).
   * @return {Array<T>}
   *   Any removed items.
   */
  splice(e, t, i) {
    const r = t || 0;
    this.setCursor(Math.trunc(e));
    const s = this.right.splice(this.right.length - r, Number.POSITIVE_INFINITY);
    return i && Mr(this.left, i), s.reverse();
  }
  /**
   * Remove and return the highest-numbered item in the array, so
   * `list[list.length - 1]`;
   * Moves the cursor to `length`.
   *
   * @returns {T | undefined}
   *   Item, optional.
   */
  pop() {
    return this.setCursor(Number.POSITIVE_INFINITY), this.left.pop();
  }
  /**
   * Inserts a single item to the high-numbered side of the array;
   * moves the cursor to `length`.
   *
   * @param {T} item
   *   Item.
   * @returns {undefined}
   *   Nothing.
   */
  push(e) {
    this.setCursor(Number.POSITIVE_INFINITY), this.left.push(e);
  }
  /**
   * Inserts many items to the high-numbered side of the array.
   * Moves the cursor to `length`.
   *
   * @param {Array<T>} items
   *   Items.
   * @returns {undefined}
   *   Nothing.
   */
  pushMany(e) {
    this.setCursor(Number.POSITIVE_INFINITY), Mr(this.left, e);
  }
  /**
   * Inserts a single item to the low-numbered side of the array;
   * Moves the cursor to `0`.
   *
   * @param {T} item
   *   Item.
   * @returns {undefined}
   *   Nothing.
   */
  unshift(e) {
    this.setCursor(0), this.right.push(e);
  }
  /**
   * Inserts many items to the low-numbered side of the array;
   * moves the cursor to `0`.
   *
   * @param {Array<T>} items
   *   Items.
   * @returns {undefined}
   *   Nothing.
   */
  unshiftMany(e) {
    this.setCursor(0), Mr(this.right, e.reverse());
  }
  /**
   * Move the cursor to a specific position in the array. Requires
   * time proportional to the distance moved.
   *
   * If `n < 0`, the cursor will end up at the beginning.
   * If `n > length`, the cursor will end up at the end.
   *
   * @param {number} n
   *   Position.
   * @return {undefined}
   *   Nothing.
   */
  setCursor(e) {
    if (!(e === this.left.length || e > this.left.length && this.right.length === 0 || e < 0 && this.left.length === 0))
      if (e < this.left.length) {
        const t = this.left.splice(e, Number.POSITIVE_INFINITY);
        Mr(this.right, t.reverse());
      } else {
        const t = this.right.splice(this.left.length + this.right.length - e, Number.POSITIVE_INFINITY);
        Mr(this.left, t.reverse());
      }
  }
}
function Mr(n, e) {
  let t = 0;
  if (e.length < 1e4)
    n.push(...e);
  else
    for (; t < e.length; )
      n.push(...e.slice(t, t + 1e4)), t += 1e4;
}
function K0(n) {
  const e = {};
  let t = -1, i, r, s, o, a, l, u;
  const c = new h3(n);
  for (; ++t < c.length; ) {
    for (; t in e; )
      t = e[t];
    if (i = c.get(t), t && i[1].type === "chunkFlow" && c.get(t - 1)[1].type === "listItemPrefix" && (l = i[1]._tokenizer.events, s = 0, s < l.length && l[s][1].type === "lineEndingBlank" && (s += 2), s < l.length && l[s][1].type === "content"))
      for (; ++s < l.length && l[s][1].type !== "content"; )
        l[s][1].type === "chunkText" && (l[s][1]._isInFirstContentOfListItem = !0, s++);
    if (i[0] === "enter")
      i[1].contentType && (Object.assign(e, f3(c, t)), t = e[t], u = !0);
    else if (i[1]._container) {
      for (s = t, r = void 0; s-- && (o = c.get(s), o[1].type === "lineEnding" || o[1].type === "lineEndingBlank"); )
        o[0] === "enter" && (r && (c.get(r)[1].type = "lineEndingBlank"), o[1].type = "lineEnding", r = s);
      r && (i[1].end = Object.assign({}, c.get(r)[1].start), a = c.slice(r, t), a.unshift(i), c.splice(r, t - r + 1, a));
    }
  }
  return Dt(n, 0, Number.POSITIVE_INFINITY, c.slice(0)), !u;
}
function f3(n, e) {
  const t = n.get(e)[1], i = n.get(e)[2];
  let r = e - 1;
  const s = [], o = t._tokenizer || i.parser[t.contentType](t.start), a = o.events, l = [], u = {};
  let c, h, f = -1, d = t, p = 0, g = 0;
  const O = [g];
  for (; d; ) {
    for (; n.get(++r)[1] !== d; )
      ;
    s.push(r), d._tokenizer || (c = i.sliceStream(d), d.next || c.push(null), h && o.defineSkip(d.start), d._isInFirstContentOfListItem && (o._gfmTasklistFirstContentOfListItem = !0), o.write(c), d._isInFirstContentOfListItem && (o._gfmTasklistFirstContentOfListItem = void 0)), h = d, d = d.next;
  }
  for (d = t; ++f < a.length; )
    // Find a void token that includes a break.
    a[f][0] === "exit" && a[f - 1][0] === "enter" && a[f][1].type === a[f - 1][1].type && a[f][1].start.line !== a[f][1].end.line && (g = f + 1, O.push(g), d._tokenizer = void 0, d.previous = void 0, d = d.next);
  for (o.events = [], d ? (d._tokenizer = void 0, d.previous = void 0) : O.pop(), f = O.length; f--; ) {
    const m = a.slice(O[f], O[f + 1]), b = s.pop();
    l.push([b, b + m.length - 1]), n.splice(b, 2, m);
  }
  for (l.reverse(), f = -1; ++f < l.length; )
    u[p + l[f][0]] = p + l[f][1], p += l[f][1] - l[f][0] - 1;
  return u;
}
const d3 = {
  tokenize: g3,
  resolve: m3
}, p3 = {
  tokenize: O3,
  partial: !0
};
function m3(n) {
  return K0(n), n;
}
function g3(n, e) {
  let t;
  return i;
  function i(a) {
    return n.enter("content"), t = n.enter("chunkContent", {
      contentType: "content"
    }), r(a);
  }
  function r(a) {
    return a === null ? s(a) : G(a) ? n.check(p3, o, s)(a) : (n.consume(a), r);
  }
  function s(a) {
    return n.exit("chunkContent"), n.exit("content"), e(a);
  }
  function o(a) {
    return n.consume(a), n.exit("chunkContent"), t.next = n.enter("chunkContent", {
      contentType: "content",
      previous: t
    }), t = t.next, r;
  }
}
function O3(n, e, t) {
  const i = this;
  return r;
  function r(o) {
    return n.exit("chunkContent"), n.enter("lineEnding"), n.consume(o), n.exit("lineEnding"), fe(n, s, "linePrefix");
  }
  function s(o) {
    if (o === null || G(o))
      return t(o);
    const a = i.events[i.events.length - 1];
    return !i.parser.constructs.disable.null.includes("codeIndented") && a && a[1].type === "linePrefix" && a[2].sliceSerialize(a[1], !0).length >= 4 ? e(o) : n.interrupt(i.parser.constructs.flow, t, e)(o);
  }
}
function J0(n, e, t, i, r, s, o, a, l) {
  const u = l || Number.POSITIVE_INFINITY;
  let c = 0;
  return h;
  function h(m) {
    return m === 60 ? (n.enter(i), n.enter(r), n.enter(s), n.consume(m), n.exit(s), f) : m === null || m === 32 || m === 41 || Pa(m) ? t(m) : (n.enter(i), n.enter(o), n.enter(a), n.enter("chunkString", {
      contentType: "string"
    }), g(m));
  }
  function f(m) {
    return m === 62 ? (n.enter(s), n.consume(m), n.exit(s), n.exit(r), n.exit(i), e) : (n.enter(a), n.enter("chunkString", {
      contentType: "string"
    }), d(m));
  }
  function d(m) {
    return m === 62 ? (n.exit("chunkString"), n.exit(a), f(m)) : m === null || m === 60 || G(m) ? t(m) : (n.consume(m), m === 92 ? p : d);
  }
  function p(m) {
    return m === 60 || m === 62 || m === 92 ? (n.consume(m), d) : d(m);
  }
  function g(m) {
    return !c && (m === null || m === 41 || xe(m)) ? (n.exit("chunkString"), n.exit(a), n.exit(o), n.exit(i), e(m)) : c < u && m === 40 ? (n.consume(m), c++, g) : m === 41 ? (n.consume(m), c--, g) : m === null || m === 32 || m === 40 || Pa(m) ? t(m) : (n.consume(m), m === 92 ? O : g);
  }
  function O(m) {
    return m === 40 || m === 41 || m === 92 ? (n.consume(m), g) : g(m);
  }
}
function eb(n, e, t, i, r, s) {
  const o = this;
  let a = 0, l;
  return u;
  function u(d) {
    return n.enter(i), n.enter(r), n.consume(d), n.exit(r), n.enter(s), c;
  }
  function c(d) {
    return a > 999 || d === null || d === 91 || d === 93 && !l || // To do: remove in the future once we’ve switched from
    // `micromark-extension-footnote` to `micromark-extension-gfm-footnote`,
    // which doesn’t need this.
    // Hidden footnotes hook.
    /* c8 ignore next 3 */
    d === 94 && !a && "_hiddenFootnoteSupport" in o.parser.constructs ? t(d) : d === 93 ? (n.exit(s), n.enter(r), n.consume(d), n.exit(r), n.exit(i), e) : G(d) ? (n.enter("lineEnding"), n.consume(d), n.exit("lineEnding"), c) : (n.enter("chunkString", {
      contentType: "string"
    }), h(d));
  }
  function h(d) {
    return d === null || d === 91 || d === 93 || G(d) || a++ > 999 ? (n.exit("chunkString"), c(d)) : (n.consume(d), l || (l = !ae(d)), d === 92 ? f : h);
  }
  function f(d) {
    return d === 91 || d === 92 || d === 93 ? (n.consume(d), a++, h) : h(d);
  }
}
function tb(n, e, t, i, r, s) {
  let o;
  return a;
  function a(f) {
    return f === 34 || f === 39 || f === 40 ? (n.enter(i), n.enter(r), n.consume(f), n.exit(r), o = f === 40 ? 41 : f, l) : t(f);
  }
  function l(f) {
    return f === o ? (n.enter(r), n.consume(f), n.exit(r), n.exit(i), e) : (n.enter(s), u(f));
  }
  function u(f) {
    return f === o ? (n.exit(s), l(o)) : f === null ? t(f) : G(f) ? (n.enter("lineEnding"), n.consume(f), n.exit("lineEnding"), fe(n, u, "linePrefix")) : (n.enter("chunkString", {
      contentType: "string"
    }), c(f));
  }
  function c(f) {
    return f === o || f === null || G(f) ? (n.exit("chunkString"), u(f)) : (n.consume(f), f === 92 ? h : c);
  }
  function h(f) {
    return f === o || f === 92 ? (n.consume(f), c) : c(f);
  }
}
function Gr(n, e) {
  let t;
  return i;
  function i(r) {
    return G(r) ? (n.enter("lineEnding"), n.consume(r), n.exit("lineEnding"), t = !0, i) : ae(r) ? fe(
      n,
      i,
      t ? "linePrefix" : "lineSuffix"
    )(r) : e(r);
  }
}
const b3 = {
  name: "definition",
  tokenize: k3
}, y3 = {
  tokenize: x3,
  partial: !0
};
function k3(n, e, t) {
  const i = this;
  let r;
  return s;
  function s(d) {
    return n.enter("definition"), o(d);
  }
  function o(d) {
    return eb.call(
      i,
      n,
      a,
      // Note: we don’t need to reset the way `markdown-rs` does.
      t,
      "definitionLabel",
      "definitionLabelMarker",
      "definitionLabelString"
    )(d);
  }
  function a(d) {
    return r = jt(i.sliceSerialize(i.events[i.events.length - 1][1]).slice(1, -1)), d === 58 ? (n.enter("definitionMarker"), n.consume(d), n.exit("definitionMarker"), l) : t(d);
  }
  function l(d) {
    return xe(d) ? Gr(n, u)(d) : u(d);
  }
  function u(d) {
    return J0(
      n,
      c,
      // Note: we don’t need to reset the way `markdown-rs` does.
      t,
      "definitionDestination",
      "definitionDestinationLiteral",
      "definitionDestinationLiteralMarker",
      "definitionDestinationRaw",
      "definitionDestinationString"
    )(d);
  }
  function c(d) {
    return n.attempt(y3, h, h)(d);
  }
  function h(d) {
    return ae(d) ? fe(n, f, "whitespace")(d) : f(d);
  }
  function f(d) {
    return d === null || G(d) ? (n.exit("definition"), i.parser.defined.push(r), e(d)) : t(d);
  }
}
function x3(n, e, t) {
  return i;
  function i(a) {
    return xe(a) ? Gr(n, r)(a) : t(a);
  }
  function r(a) {
    return tb(n, s, t, "definitionTitle", "definitionTitleMarker", "definitionTitleString")(a);
  }
  function s(a) {
    return ae(a) ? fe(n, o, "whitespace")(a) : o(a);
  }
  function o(a) {
    return a === null || G(a) ? e(a) : t(a);
  }
}
const w3 = {
  name: "hardBreakEscape",
  tokenize: S3
};
function S3(n, e, t) {
  return i;
  function i(s) {
    return n.enter("hardBreakEscape"), n.consume(s), r;
  }
  function r(s) {
    return G(s) ? (n.exit("hardBreakEscape"), e(s)) : t(s);
  }
}
const v3 = {
  name: "headingAtx",
  tokenize: Q3,
  resolve: P3
};
function P3(n, e) {
  let t = n.length - 2, i = 3, r, s;
  return n[i][1].type === "whitespace" && (i += 2), t - 2 > i && n[t][1].type === "whitespace" && (t -= 2), n[t][1].type === "atxHeadingSequence" && (i === t - 1 || t - 4 > i && n[t - 2][1].type === "whitespace") && (t -= i + 1 === t ? 2 : 4), t > i && (r = {
    type: "atxHeadingText",
    start: n[i][1].start,
    end: n[t][1].end
  }, s = {
    type: "chunkText",
    start: n[i][1].start,
    end: n[t][1].end,
    contentType: "text"
  }, Dt(n, i, t - i + 1, [["enter", r, e], ["enter", s, e], ["exit", s, e], ["exit", r, e]])), n;
}
function Q3(n, e, t) {
  let i = 0;
  return r;
  function r(c) {
    return n.enter("atxHeading"), s(c);
  }
  function s(c) {
    return n.enter("atxHeadingSequence"), o(c);
  }
  function o(c) {
    return c === 35 && i++ < 6 ? (n.consume(c), o) : c === null || xe(c) ? (n.exit("atxHeadingSequence"), a(c)) : t(c);
  }
  function a(c) {
    return c === 35 ? (n.enter("atxHeadingSequence"), l(c)) : c === null || G(c) ? (n.exit("atxHeading"), e(c)) : ae(c) ? fe(n, a, "whitespace")(c) : (n.enter("atxHeadingText"), u(c));
  }
  function l(c) {
    return c === 35 ? (n.consume(c), l) : (n.exit("atxHeadingSequence"), a(c));
  }
  function u(c) {
    return c === null || c === 35 || xe(c) ? (n.exit("atxHeadingText"), a(c)) : (n.consume(c), u);
  }
}
const $3 = [
  "address",
  "article",
  "aside",
  "base",
  "basefont",
  "blockquote",
  "body",
  "caption",
  "center",
  "col",
  "colgroup",
  "dd",
  "details",
  "dialog",
  "dir",
  "div",
  "dl",
  "dt",
  "fieldset",
  "figcaption",
  "figure",
  "footer",
  "form",
  "frame",
  "frameset",
  "h1",
  "h2",
  "h3",
  "h4",
  "h5",
  "h6",
  "head",
  "header",
  "hr",
  "html",
  "iframe",
  "legend",
  "li",
  "link",
  "main",
  "menu",
  "menuitem",
  "nav",
  "noframes",
  "ol",
  "optgroup",
  "option",
  "p",
  "param",
  "search",
  "section",
  "summary",
  "table",
  "tbody",
  "td",
  "tfoot",
  "th",
  "thead",
  "title",
  "tr",
  "track",
  "ul"
], Qp = ["pre", "script", "style", "textarea"], C3 = {
  name: "htmlFlow",
  tokenize: M3,
  resolveTo: R3,
  concrete: !0
}, T3 = {
  tokenize: E3,
  partial: !0
}, A3 = {
  tokenize: Z3,
  partial: !0
};
function R3(n) {
  let e = n.length;
  for (; e-- && !(n[e][0] === "enter" && n[e][1].type === "htmlFlow"); )
    ;
  return e > 1 && n[e - 2][1].type === "linePrefix" && (n[e][1].start = n[e - 2][1].start, n[e + 1][1].start = n[e - 2][1].start, n.splice(e - 2, 2)), n;
}
function M3(n, e, t) {
  const i = this;
  let r, s, o, a, l;
  return u;
  function u(S) {
    return c(S);
  }
  function c(S) {
    return n.enter("htmlFlow"), n.enter("htmlFlowData"), n.consume(S), h;
  }
  function h(S) {
    return S === 33 ? (n.consume(S), f) : S === 47 ? (n.consume(S), s = !0, g) : S === 63 ? (n.consume(S), r = 3, i.interrupt ? e : y) : at(S) ? (n.consume(S), o = String.fromCharCode(S), O) : t(S);
  }
  function f(S) {
    return S === 45 ? (n.consume(S), r = 2, d) : S === 91 ? (n.consume(S), r = 5, a = 0, p) : at(S) ? (n.consume(S), r = 4, i.interrupt ? e : y) : t(S);
  }
  function d(S) {
    return S === 45 ? (n.consume(S), i.interrupt ? e : y) : t(S);
  }
  function p(S) {
    const Ee = "CDATA[";
    return S === Ee.charCodeAt(a++) ? (n.consume(S), a === Ee.length ? i.interrupt ? e : A : p) : t(S);
  }
  function g(S) {
    return at(S) ? (n.consume(S), o = String.fromCharCode(S), O) : t(S);
  }
  function O(S) {
    if (S === null || S === 47 || S === 62 || xe(S)) {
      const Ee = S === 47, Je = o.toLowerCase();
      return !Ee && !s && Qp.includes(Je) ? (r = 1, i.interrupt ? e(S) : A(S)) : $3.includes(o.toLowerCase()) ? (r = 6, Ee ? (n.consume(S), m) : i.interrupt ? e(S) : A(S)) : (r = 7, i.interrupt && !i.parser.lazy[i.now().line] ? t(S) : s ? b(S) : w(S));
    }
    return S === 45 || nt(S) ? (n.consume(S), o += String.fromCharCode(S), O) : t(S);
  }
  function m(S) {
    return S === 62 ? (n.consume(S), i.interrupt ? e : A) : t(S);
  }
  function b(S) {
    return ae(S) ? (n.consume(S), b) : P(S);
  }
  function w(S) {
    return S === 47 ? (n.consume(S), P) : S === 58 || S === 95 || at(S) ? (n.consume(S), Q) : ae(S) ? (n.consume(S), w) : P(S);
  }
  function Q(S) {
    return S === 45 || S === 46 || S === 58 || S === 95 || nt(S) ? (n.consume(S), Q) : v(S);
  }
  function v(S) {
    return S === 61 ? (n.consume(S), k) : ae(S) ? (n.consume(S), v) : w(S);
  }
  function k(S) {
    return S === null || S === 60 || S === 61 || S === 62 || S === 96 ? t(S) : S === 34 || S === 39 ? (n.consume(S), l = S, C) : ae(S) ? (n.consume(S), k) : I(S);
  }
  function C(S) {
    return S === l ? (n.consume(S), l = null, z) : S === null || G(S) ? t(S) : (n.consume(S), C);
  }
  function I(S) {
    return S === null || S === 34 || S === 39 || S === 47 || S === 60 || S === 61 || S === 62 || S === 96 || xe(S) ? v(S) : (n.consume(S), I);
  }
  function z(S) {
    return S === 47 || S === 62 || ae(S) ? w(S) : t(S);
  }
  function P(S) {
    return S === 62 ? (n.consume(S), R) : t(S);
  }
  function R(S) {
    return S === null || G(S) ? A(S) : ae(S) ? (n.consume(S), R) : t(S);
  }
  function A(S) {
    return S === 45 && r === 2 ? (n.consume(S), B) : S === 60 && r === 1 ? (n.consume(S), H) : S === 62 && r === 4 ? (n.consume(S), ne) : S === 63 && r === 3 ? (n.consume(S), y) : S === 93 && r === 5 ? (n.consume(S), re) : G(S) && (r === 6 || r === 7) ? (n.exit("htmlFlowData"), n.check(T3, Qe, j)(S)) : S === null || G(S) ? (n.exit("htmlFlowData"), j(S)) : (n.consume(S), A);
  }
  function j(S) {
    return n.check(A3, U, Qe)(S);
  }
  function U(S) {
    return n.enter("lineEnding"), n.consume(S), n.exit("lineEnding"), E;
  }
  function E(S) {
    return S === null || G(S) ? j(S) : (n.enter("htmlFlowData"), A(S));
  }
  function B(S) {
    return S === 45 ? (n.consume(S), y) : A(S);
  }
  function H(S) {
    return S === 47 ? (n.consume(S), o = "", K) : A(S);
  }
  function K(S) {
    if (S === 62) {
      const Ee = o.toLowerCase();
      return Qp.includes(Ee) ? (n.consume(S), ne) : A(S);
    }
    return at(S) && o.length < 8 ? (n.consume(S), o += String.fromCharCode(S), K) : A(S);
  }
  function re(S) {
    return S === 93 ? (n.consume(S), y) : A(S);
  }
  function y(S) {
    return S === 62 ? (n.consume(S), ne) : S === 45 && r === 2 ? (n.consume(S), y) : A(S);
  }
  function ne(S) {
    return S === null || G(S) ? (n.exit("htmlFlowData"), Qe(S)) : (n.consume(S), ne);
  }
  function Qe(S) {
    return n.exit("htmlFlow"), e(S);
  }
}
function Z3(n, e, t) {
  const i = this;
  return r;
  function r(o) {
    return G(o) ? (n.enter("lineEnding"), n.consume(o), n.exit("lineEnding"), s) : t(o);
  }
  function s(o) {
    return i.parser.lazy[i.now().line] ? t(o) : e(o);
  }
}
function E3(n, e, t) {
  return i;
  function i(r) {
    return n.enter("lineEnding"), n.consume(r), n.exit("lineEnding"), n.attempt(Ns, e, t);
  }
}
const z3 = {
  name: "htmlText",
  tokenize: D3
};
function D3(n, e, t) {
  const i = this;
  let r, s, o;
  return a;
  function a(y) {
    return n.enter("htmlText"), n.enter("htmlTextData"), n.consume(y), l;
  }
  function l(y) {
    return y === 33 ? (n.consume(y), u) : y === 47 ? (n.consume(y), v) : y === 63 ? (n.consume(y), w) : at(y) ? (n.consume(y), I) : t(y);
  }
  function u(y) {
    return y === 45 ? (n.consume(y), c) : y === 91 ? (n.consume(y), s = 0, p) : at(y) ? (n.consume(y), b) : t(y);
  }
  function c(y) {
    return y === 45 ? (n.consume(y), d) : t(y);
  }
  function h(y) {
    return y === null ? t(y) : y === 45 ? (n.consume(y), f) : G(y) ? (o = h, H(y)) : (n.consume(y), h);
  }
  function f(y) {
    return y === 45 ? (n.consume(y), d) : h(y);
  }
  function d(y) {
    return y === 62 ? B(y) : y === 45 ? f(y) : h(y);
  }
  function p(y) {
    const ne = "CDATA[";
    return y === ne.charCodeAt(s++) ? (n.consume(y), s === ne.length ? g : p) : t(y);
  }
  function g(y) {
    return y === null ? t(y) : y === 93 ? (n.consume(y), O) : G(y) ? (o = g, H(y)) : (n.consume(y), g);
  }
  function O(y) {
    return y === 93 ? (n.consume(y), m) : g(y);
  }
  function m(y) {
    return y === 62 ? B(y) : y === 93 ? (n.consume(y), m) : g(y);
  }
  function b(y) {
    return y === null || y === 62 ? B(y) : G(y) ? (o = b, H(y)) : (n.consume(y), b);
  }
  function w(y) {
    return y === null ? t(y) : y === 63 ? (n.consume(y), Q) : G(y) ? (o = w, H(y)) : (n.consume(y), w);
  }
  function Q(y) {
    return y === 62 ? B(y) : w(y);
  }
  function v(y) {
    return at(y) ? (n.consume(y), k) : t(y);
  }
  function k(y) {
    return y === 45 || nt(y) ? (n.consume(y), k) : C(y);
  }
  function C(y) {
    return G(y) ? (o = C, H(y)) : ae(y) ? (n.consume(y), C) : B(y);
  }
  function I(y) {
    return y === 45 || nt(y) ? (n.consume(y), I) : y === 47 || y === 62 || xe(y) ? z(y) : t(y);
  }
  function z(y) {
    return y === 47 ? (n.consume(y), B) : y === 58 || y === 95 || at(y) ? (n.consume(y), P) : G(y) ? (o = z, H(y)) : ae(y) ? (n.consume(y), z) : B(y);
  }
  function P(y) {
    return y === 45 || y === 46 || y === 58 || y === 95 || nt(y) ? (n.consume(y), P) : R(y);
  }
  function R(y) {
    return y === 61 ? (n.consume(y), A) : G(y) ? (o = R, H(y)) : ae(y) ? (n.consume(y), R) : z(y);
  }
  function A(y) {
    return y === null || y === 60 || y === 61 || y === 62 || y === 96 ? t(y) : y === 34 || y === 39 ? (n.consume(y), r = y, j) : G(y) ? (o = A, H(y)) : ae(y) ? (n.consume(y), A) : (n.consume(y), U);
  }
  function j(y) {
    return y === r ? (n.consume(y), r = void 0, E) : y === null ? t(y) : G(y) ? (o = j, H(y)) : (n.consume(y), j);
  }
  function U(y) {
    return y === null || y === 34 || y === 39 || y === 60 || y === 61 || y === 96 ? t(y) : y === 47 || y === 62 || xe(y) ? z(y) : (n.consume(y), U);
  }
  function E(y) {
    return y === 47 || y === 62 || xe(y) ? z(y) : t(y);
  }
  function B(y) {
    return y === 62 ? (n.consume(y), n.exit("htmlTextData"), n.exit("htmlText"), e) : t(y);
  }
  function H(y) {
    return n.exit("htmlTextData"), n.enter("lineEnding"), n.consume(y), n.exit("lineEnding"), K;
  }
  function K(y) {
    return ae(y) ? fe(n, re, "linePrefix", i.parser.constructs.disable.null.includes("codeIndented") ? void 0 : 4)(y) : re(y);
  }
  function re(y) {
    return n.enter("htmlTextData"), o(y);
  }
}
const _h = {
  name: "labelEnd",
  tokenize: W3,
  resolveTo: N3,
  resolveAll: X3
}, I3 = {
  tokenize: q3
}, L3 = {
  tokenize: B3
}, _3 = {
  tokenize: V3
};
function X3(n) {
  let e = -1;
  for (; ++e < n.length; ) {
    const t = n[e][1];
    (t.type === "labelImage" || t.type === "labelLink" || t.type === "labelEnd") && (n.splice(e + 1, t.type === "labelImage" ? 4 : 2), t.type = "data", e++);
  }
  return n;
}
function N3(n, e) {
  let t = n.length, i = 0, r, s, o, a;
  for (; t--; )
    if (r = n[t][1], s) {
      if (r.type === "link" || r.type === "labelLink" && r._inactive)
        break;
      n[t][0] === "enter" && r.type === "labelLink" && (r._inactive = !0);
    } else if (o) {
      if (n[t][0] === "enter" && (r.type === "labelImage" || r.type === "labelLink") && !r._balanced && (s = t, r.type !== "labelLink")) {
        i = 2;
        break;
      }
    } else
      r.type === "labelEnd" && (o = t);
  const l = {
    type: n[s][1].type === "labelLink" ? "link" : "image",
    start: Object.assign({}, n[s][1].start),
    end: Object.assign({}, n[n.length - 1][1].end)
  }, u = {
    type: "label",
    start: Object.assign({}, n[s][1].start),
    end: Object.assign({}, n[o][1].end)
  }, c = {
    type: "labelText",
    start: Object.assign({}, n[s + i + 2][1].end),
    end: Object.assign({}, n[o - 2][1].start)
  };
  return a = [["enter", l, e], ["enter", u, e]], a = At(a, n.slice(s + 1, s + i + 3)), a = At(a, [["enter", c, e]]), a = At(a, sl(e.parser.constructs.insideSpan.null, n.slice(s + i + 4, o - 3), e)), a = At(a, [["exit", c, e], n[o - 2], n[o - 1], ["exit", u, e]]), a = At(a, n.slice(o + 1)), a = At(a, [["exit", l, e]]), Dt(n, s, n.length, a), n;
}
function W3(n, e, t) {
  const i = this;
  let r = i.events.length, s, o;
  for (; r--; )
    if ((i.events[r][1].type === "labelImage" || i.events[r][1].type === "labelLink") && !i.events[r][1]._balanced) {
      s = i.events[r][1];
      break;
    }
  return a;
  function a(f) {
    return s ? s._inactive ? h(f) : (o = i.parser.defined.includes(jt(i.sliceSerialize({
      start: s.end,
      end: i.now()
    }))), n.enter("labelEnd"), n.enter("labelMarker"), n.consume(f), n.exit("labelMarker"), n.exit("labelEnd"), l) : t(f);
  }
  function l(f) {
    return f === 40 ? n.attempt(I3, c, o ? c : h)(f) : f === 91 ? n.attempt(L3, c, o ? u : h)(f) : o ? c(f) : h(f);
  }
  function u(f) {
    return n.attempt(_3, c, h)(f);
  }
  function c(f) {
    return e(f);
  }
  function h(f) {
    return s._balanced = !0, t(f);
  }
}
function q3(n, e, t) {
  return i;
  function i(h) {
    return n.enter("resource"), n.enter("resourceMarker"), n.consume(h), n.exit("resourceMarker"), r;
  }
  function r(h) {
    return xe(h) ? Gr(n, s)(h) : s(h);
  }
  function s(h) {
    return h === 41 ? c(h) : J0(n, o, a, "resourceDestination", "resourceDestinationLiteral", "resourceDestinationLiteralMarker", "resourceDestinationRaw", "resourceDestinationString", 32)(h);
  }
  function o(h) {
    return xe(h) ? Gr(n, l)(h) : c(h);
  }
  function a(h) {
    return t(h);
  }
  function l(h) {
    return h === 34 || h === 39 || h === 40 ? tb(n, u, t, "resourceTitle", "resourceTitleMarker", "resourceTitleString")(h) : c(h);
  }
  function u(h) {
    return xe(h) ? Gr(n, c)(h) : c(h);
  }
  function c(h) {
    return h === 41 ? (n.enter("resourceMarker"), n.consume(h), n.exit("resourceMarker"), n.exit("resource"), e) : t(h);
  }
}
function B3(n, e, t) {
  const i = this;
  return r;
  function r(a) {
    return eb.call(i, n, s, o, "reference", "referenceMarker", "referenceString")(a);
  }
  function s(a) {
    return i.parser.defined.includes(jt(i.sliceSerialize(i.events[i.events.length - 1][1]).slice(1, -1))) ? e(a) : t(a);
  }
  function o(a) {
    return t(a);
  }
}
function V3(n, e, t) {
  return i;
  function i(s) {
    return n.enter("reference"), n.enter("referenceMarker"), n.consume(s), n.exit("referenceMarker"), r;
  }
  function r(s) {
    return s === 93 ? (n.enter("referenceMarker"), n.consume(s), n.exit("referenceMarker"), n.exit("reference"), e) : t(s);
  }
}
const Y3 = {
  name: "labelStartImage",
  tokenize: j3,
  resolveAll: _h.resolveAll
};
function j3(n, e, t) {
  const i = this;
  return r;
  function r(a) {
    return n.enter("labelImage"), n.enter("labelImageMarker"), n.consume(a), n.exit("labelImageMarker"), s;
  }
  function s(a) {
    return a === 91 ? (n.enter("labelMarker"), n.consume(a), n.exit("labelMarker"), n.exit("labelImage"), o) : t(a);
  }
  function o(a) {
    return a === 94 && "_hiddenFootnoteSupport" in i.parser.constructs ? t(a) : e(a);
  }
}
const U3 = {
  name: "labelStartLink",
  tokenize: F3,
  resolveAll: _h.resolveAll
};
function F3(n, e, t) {
  const i = this;
  return r;
  function r(o) {
    return n.enter("labelLink"), n.enter("labelMarker"), n.consume(o), n.exit("labelMarker"), n.exit("labelLink"), s;
  }
  function s(o) {
    return o === 94 && "_hiddenFootnoteSupport" in i.parser.constructs ? t(o) : e(o);
  }
}
const Wl = {
  name: "lineEnding",
  tokenize: G3
};
function G3(n, e) {
  return t;
  function t(i) {
    return n.enter("lineEnding"), n.consume(i), n.exit("lineEnding"), fe(n, e, "linePrefix");
  }
}
const jo = {
  name: "thematicBreak",
  tokenize: H3
};
function H3(n, e, t) {
  let i = 0, r;
  return s;
  function s(u) {
    return n.enter("thematicBreak"), o(u);
  }
  function o(u) {
    return r = u, a(u);
  }
  function a(u) {
    return u === r ? (n.enter("thematicBreakSequence"), l(u)) : i >= 3 && (u === null || G(u)) ? (n.exit("thematicBreak"), e(u)) : t(u);
  }
  function l(u) {
    return u === r ? (n.consume(u), i++, l) : (n.exit("thematicBreakSequence"), ae(u) ? fe(n, a, "whitespace")(u) : a(u));
  }
}
const ut = {
  name: "list",
  tokenize: e5,
  continuation: {
    tokenize: t5
  },
  exit: i5
}, K3 = {
  tokenize: r5,
  partial: !0
}, J3 = {
  tokenize: n5,
  partial: !0
};
function e5(n, e, t) {
  const i = this, r = i.events[i.events.length - 1];
  let s = r && r[1].type === "linePrefix" ? r[2].sliceSerialize(r[1], !0).length : 0, o = 0;
  return a;
  function a(d) {
    const p = i.containerState.type || (d === 42 || d === 43 || d === 45 ? "listUnordered" : "listOrdered");
    if (p === "listUnordered" ? !i.containerState.marker || d === i.containerState.marker : dc(d)) {
      if (i.containerState.type || (i.containerState.type = p, n.enter(p, {
        _container: !0
      })), p === "listUnordered")
        return n.enter("listItemPrefix"), d === 42 || d === 45 ? n.check(jo, t, u)(d) : u(d);
      if (!i.interrupt || d === 49)
        return n.enter("listItemPrefix"), n.enter("listItemValue"), l(d);
    }
    return t(d);
  }
  function l(d) {
    return dc(d) && ++o < 10 ? (n.consume(d), l) : (!i.interrupt || o < 2) && (i.containerState.marker ? d === i.containerState.marker : d === 41 || d === 46) ? (n.exit("listItemValue"), u(d)) : t(d);
  }
  function u(d) {
    return n.enter("listItemMarker"), n.consume(d), n.exit("listItemMarker"), i.containerState.marker = i.containerState.marker || d, n.check(
      Ns,
      // Can’t be empty when interrupting.
      i.interrupt ? t : c,
      n.attempt(K3, f, h)
    );
  }
  function c(d) {
    return i.containerState.initialBlankLine = !0, s++, f(d);
  }
  function h(d) {
    return ae(d) ? (n.enter("listItemPrefixWhitespace"), n.consume(d), n.exit("listItemPrefixWhitespace"), f) : t(d);
  }
  function f(d) {
    return i.containerState.size = s + i.sliceSerialize(n.exit("listItemPrefix"), !0).length, e(d);
  }
}
function t5(n, e, t) {
  const i = this;
  return i.containerState._closeFlow = void 0, n.check(Ns, r, s);
  function r(a) {
    return i.containerState.furtherBlankLines = i.containerState.furtherBlankLines || i.containerState.initialBlankLine, fe(n, e, "listItemIndent", i.containerState.size + 1)(a);
  }
  function s(a) {
    return i.containerState.furtherBlankLines || !ae(a) ? (i.containerState.furtherBlankLines = void 0, i.containerState.initialBlankLine = void 0, o(a)) : (i.containerState.furtherBlankLines = void 0, i.containerState.initialBlankLine = void 0, n.attempt(J3, e, o)(a));
  }
  function o(a) {
    return i.containerState._closeFlow = !0, i.interrupt = void 0, fe(n, n.attempt(ut, e, t), "linePrefix", i.parser.constructs.disable.null.includes("codeIndented") ? void 0 : 4)(a);
  }
}
function n5(n, e, t) {
  const i = this;
  return fe(n, r, "listItemIndent", i.containerState.size + 1);
  function r(s) {
    const o = i.events[i.events.length - 1];
    return o && o[1].type === "listItemIndent" && o[2].sliceSerialize(o[1], !0).length === i.containerState.size ? e(s) : t(s);
  }
}
function i5(n) {
  n.exit(this.containerState.type);
}
function r5(n, e, t) {
  const i = this;
  return fe(n, r, "listItemPrefixWhitespace", i.parser.constructs.disable.null.includes("codeIndented") ? void 0 : 5);
  function r(s) {
    const o = i.events[i.events.length - 1];
    return !ae(s) && o && o[1].type === "listItemPrefixWhitespace" ? e(s) : t(s);
  }
}
const $p = {
  name: "setextUnderline",
  tokenize: o5,
  resolveTo: s5
};
function s5(n, e) {
  let t = n.length, i, r, s;
  for (; t--; )
    if (n[t][0] === "enter") {
      if (n[t][1].type === "content") {
        i = t;
        break;
      }
      n[t][1].type === "paragraph" && (r = t);
    } else
      n[t][1].type === "content" && n.splice(t, 1), !s && n[t][1].type === "definition" && (s = t);
  const o = {
    type: "setextHeading",
    start: Object.assign({}, n[r][1].start),
    end: Object.assign({}, n[n.length - 1][1].end)
  };
  return n[r][1].type = "setextHeadingText", s ? (n.splice(r, 0, ["enter", o, e]), n.splice(s + 1, 0, ["exit", n[i][1], e]), n[i][1].end = Object.assign({}, n[s][1].end)) : n[i][1] = o, n.push(["exit", o, e]), n;
}
function o5(n, e, t) {
  const i = this;
  let r;
  return s;
  function s(u) {
    let c = i.events.length, h;
    for (; c--; )
      if (i.events[c][1].type !== "lineEnding" && i.events[c][1].type !== "linePrefix" && i.events[c][1].type !== "content") {
        h = i.events[c][1].type === "paragraph";
        break;
      }
    return !i.parser.lazy[i.now().line] && (i.interrupt || h) ? (n.enter("setextHeadingLine"), r = u, o(u)) : t(u);
  }
  function o(u) {
    return n.enter("setextHeadingLineSequence"), a(u);
  }
  function a(u) {
    return u === r ? (n.consume(u), a) : (n.exit("setextHeadingLineSequence"), ae(u) ? fe(n, l, "lineSuffix")(u) : l(u));
  }
  function l(u) {
    return u === null || G(u) ? (n.exit("setextHeadingLine"), e(u)) : t(u);
  }
}
const a5 = {
  tokenize: m5,
  partial: !0
};
function l5() {
  return {
    document: {
      91: {
        tokenize: f5,
        continuation: {
          tokenize: d5
        },
        exit: p5
      }
    },
    text: {
      91: {
        tokenize: h5
      },
      93: {
        add: "after",
        tokenize: u5,
        resolveTo: c5
      }
    }
  };
}
function u5(n, e, t) {
  const i = this;
  let r = i.events.length;
  const s = i.parser.gfmFootnotes || (i.parser.gfmFootnotes = []);
  let o;
  for (; r--; ) {
    const l = i.events[r][1];
    if (l.type === "labelImage") {
      o = l;
      break;
    }
    if (l.type === "gfmFootnoteCall" || l.type === "labelLink" || l.type === "label" || l.type === "image" || l.type === "link")
      break;
  }
  return a;
  function a(l) {
    if (!o || !o._balanced)
      return t(l);
    const u = jt(
      i.sliceSerialize({
        start: o.end,
        end: i.now()
      })
    );
    return u.codePointAt(0) !== 94 || !s.includes(u.slice(1)) ? t(l) : (n.enter("gfmFootnoteCallLabelMarker"), n.consume(l), n.exit("gfmFootnoteCallLabelMarker"), e(l));
  }
}
function c5(n, e) {
  let t = n.length;
  for (; t--; )
    if (n[t][1].type === "labelImage" && n[t][0] === "enter") {
      n[t][1];
      break;
    }
  n[t + 1][1].type = "data", n[t + 3][1].type = "gfmFootnoteCallLabelMarker";
  const i = {
    type: "gfmFootnoteCall",
    start: Object.assign({}, n[t + 3][1].start),
    end: Object.assign({}, n[n.length - 1][1].end)
  }, r = {
    type: "gfmFootnoteCallMarker",
    start: Object.assign({}, n[t + 3][1].end),
    end: Object.assign({}, n[t + 3][1].end)
  };
  r.end.column++, r.end.offset++, r.end._bufferIndex++;
  const s = {
    type: "gfmFootnoteCallString",
    start: Object.assign({}, r.end),
    end: Object.assign({}, n[n.length - 1][1].start)
  }, o = {
    type: "chunkString",
    contentType: "string",
    start: Object.assign({}, s.start),
    end: Object.assign({}, s.end)
  }, a = [
    // Take the `labelImageMarker` (now `data`, the `!`)
    n[t + 1],
    n[t + 2],
    ["enter", i, e],
    // The `[`
    n[t + 3],
    n[t + 4],
    // The `^`.
    ["enter", r, e],
    ["exit", r, e],
    // Everything in between.
    ["enter", s, e],
    ["enter", o, e],
    ["exit", o, e],
    ["exit", s, e],
    // The ending (`]`, properly parsed and labelled).
    n[n.length - 2],
    n[n.length - 1],
    ["exit", i, e]
  ];
  return n.splice(t, n.length - t + 1, ...a), n;
}
function h5(n, e, t) {
  const i = this, r = i.parser.gfmFootnotes || (i.parser.gfmFootnotes = []);
  let s = 0, o;
  return a;
  function a(h) {
    return n.enter("gfmFootnoteCall"), n.enter("gfmFootnoteCallLabelMarker"), n.consume(h), n.exit("gfmFootnoteCallLabelMarker"), l;
  }
  function l(h) {
    return h !== 94 ? t(h) : (n.enter("gfmFootnoteCallMarker"), n.consume(h), n.exit("gfmFootnoteCallMarker"), n.enter("gfmFootnoteCallString"), n.enter("chunkString").contentType = "string", u);
  }
  function u(h) {
    if (
      // Too long.
      s > 999 || // Closing brace with nothing.
      h === 93 && !o || // Space or tab is not supported by GFM for some reason.
      // `\n` and `[` not being supported makes sense.
      h === null || h === 91 || xe(h)
    )
      return t(h);
    if (h === 93) {
      n.exit("chunkString");
      const f = n.exit("gfmFootnoteCallString");
      return r.includes(jt(i.sliceSerialize(f))) ? (n.enter("gfmFootnoteCallLabelMarker"), n.consume(h), n.exit("gfmFootnoteCallLabelMarker"), n.exit("gfmFootnoteCall"), e) : t(h);
    }
    return xe(h) || (o = !0), s++, n.consume(h), h === 92 ? c : u;
  }
  function c(h) {
    return h === 91 || h === 92 || h === 93 ? (n.consume(h), s++, u) : u(h);
  }
}
function f5(n, e, t) {
  const i = this, r = i.parser.gfmFootnotes || (i.parser.gfmFootnotes = []);
  let s, o = 0, a;
  return l;
  function l(p) {
    return n.enter("gfmFootnoteDefinition")._container = !0, n.enter("gfmFootnoteDefinitionLabel"), n.enter("gfmFootnoteDefinitionLabelMarker"), n.consume(p), n.exit("gfmFootnoteDefinitionLabelMarker"), u;
  }
  function u(p) {
    return p === 94 ? (n.enter("gfmFootnoteDefinitionMarker"), n.consume(p), n.exit("gfmFootnoteDefinitionMarker"), n.enter("gfmFootnoteDefinitionLabelString"), n.enter("chunkString").contentType = "string", c) : t(p);
  }
  function c(p) {
    if (
      // Too long.
      o > 999 || // Closing brace with nothing.
      p === 93 && !a || // Space or tab is not supported by GFM for some reason.
      // `\n` and `[` not being supported makes sense.
      p === null || p === 91 || xe(p)
    )
      return t(p);
    if (p === 93) {
      n.exit("chunkString");
      const g = n.exit("gfmFootnoteDefinitionLabelString");
      return s = jt(i.sliceSerialize(g)), n.enter("gfmFootnoteDefinitionLabelMarker"), n.consume(p), n.exit("gfmFootnoteDefinitionLabelMarker"), n.exit("gfmFootnoteDefinitionLabel"), f;
    }
    return xe(p) || (a = !0), o++, n.consume(p), p === 92 ? h : c;
  }
  function h(p) {
    return p === 91 || p === 92 || p === 93 ? (n.consume(p), o++, c) : c(p);
  }
  function f(p) {
    return p === 58 ? (n.enter("definitionMarker"), n.consume(p), n.exit("definitionMarker"), r.includes(s) || r.push(s), fe(
      n,
      d,
      "gfmFootnoteDefinitionWhitespace"
    )) : t(p);
  }
  function d(p) {
    return e(p);
  }
}
function d5(n, e, t) {
  return n.check(Ns, e, n.attempt(a5, e, t));
}
function p5(n) {
  n.exit("gfmFootnoteDefinition");
}
function m5(n, e, t) {
  const i = this;
  return fe(
    n,
    r,
    "gfmFootnoteDefinitionIndent",
    5
  );
  function r(s) {
    const o = i.events[i.events.length - 1];
    return o && o[1].type === "gfmFootnoteDefinitionIndent" && o[2].sliceSerialize(o[1], !0).length === 4 ? e(s) : t(s);
  }
}
function g5(n) {
  let t = (n || {}).singleTilde;
  const i = {
    tokenize: s,
    resolveAll: r
  };
  return t == null && (t = !0), {
    text: {
      126: i
    },
    insideSpan: {
      null: [i]
    },
    attentionMarkers: {
      null: [126]
    }
  };
  function r(o, a) {
    let l = -1;
    for (; ++l < o.length; )
      if (o[l][0] === "enter" && o[l][1].type === "strikethroughSequenceTemporary" && o[l][1]._close) {
        let u = l;
        for (; u--; )
          if (o[u][0] === "exit" && o[u][1].type === "strikethroughSequenceTemporary" && o[u][1]._open && // If the sizes are the same:
          o[l][1].end.offset - o[l][1].start.offset === o[u][1].end.offset - o[u][1].start.offset) {
            o[l][1].type = "strikethroughSequence", o[u][1].type = "strikethroughSequence";
            const c = {
              type: "strikethrough",
              start: Object.assign({}, o[u][1].start),
              end: Object.assign({}, o[l][1].end)
            }, h = {
              type: "strikethroughText",
              start: Object.assign({}, o[u][1].end),
              end: Object.assign({}, o[l][1].start)
            }, f = [
              ["enter", c, a],
              ["enter", o[u][1], a],
              ["exit", o[u][1], a],
              ["enter", h, a]
            ], d = a.parser.constructs.insideSpan.null;
            d && Dt(
              f,
              f.length,
              0,
              sl(d, o.slice(u + 1, l), a)
            ), Dt(f, f.length, 0, [
              ["exit", h, a],
              ["enter", o[l][1], a],
              ["exit", o[l][1], a],
              ["exit", c, a]
            ]), Dt(o, u - 1, l - u + 3, f), l = u + f.length - 2;
            break;
          }
      }
    for (l = -1; ++l < o.length; )
      o[l][1].type === "strikethroughSequenceTemporary" && (o[l][1].type = "data");
    return o;
  }
  function s(o, a, l) {
    const u = this.previous, c = this.events;
    let h = 0;
    return f;
    function f(p) {
      return u === 126 && c[c.length - 1][1].type !== "characterEscape" ? l(p) : (o.enter("strikethroughSequenceTemporary"), d(p));
    }
    function d(p) {
      const g = Qa(u);
      if (p === 126)
        return h > 1 ? l(p) : (o.consume(p), h++, d);
      if (h < 2 && !t)
        return l(p);
      const O = o.exit("strikethroughSequenceTemporary"), m = Qa(p);
      return O._open = !m || m === 2 && !!g, O._close = !g || g === 2 && !!m, a(p);
    }
  }
}
class O5 {
  /**
   * Create a new edit map.
   */
  constructor() {
    this.map = [];
  }
  /**
   * Create an edit: a remove and/or add at a certain place.
   *
   * @param {number} index
   * @param {number} remove
   * @param {Array<Event>} add
   * @returns {undefined}
   */
  add(e, t, i) {
    b5(this, e, t, i);
  }
  // To do: add this when moving to `micromark`.
  // /**
  //  * Create an edit: but insert `add` before existing additions.
  //  *
  //  * @param {number} index
  //  * @param {number} remove
  //  * @param {Array<Event>} add
  //  * @returns {undefined}
  //  */
  // addBefore(index, remove, add) {
  //   addImpl(this, index, remove, add, true)
  // }
  /**
   * Done, change the events.
   *
   * @param {Array<Event>} events
   * @returns {undefined}
   */
  consume(e) {
    if (this.map.sort(function(s, o) {
      return s[0] - o[0];
    }), this.map.length === 0)
      return;
    let t = this.map.length;
    const i = [];
    for (; t > 0; )
      t -= 1, i.push(
        e.slice(this.map[t][0] + this.map[t][1]),
        this.map[t][2]
      ), e.length = this.map[t][0];
    i.push([...e]), e.length = 0;
    let r = i.pop();
    for (; r; )
      e.push(...r), r = i.pop();
    this.map.length = 0;
  }
}
function b5(n, e, t, i) {
  let r = 0;
  if (!(t === 0 && i.length === 0)) {
    for (; r < n.map.length; ) {
      if (n.map[r][0] === e) {
        n.map[r][1] += t, n.map[r][2].push(...i);
        return;
      }
      r += 1;
    }
    n.map.push([e, t, i]);
  }
}
function y5(n, e) {
  let t = !1;
  const i = [];
  for (; e < n.length; ) {
    const r = n[e];
    if (t) {
      if (r[0] === "enter")
        r[1].type === "tableContent" && i.push(
          n[e + 1][1].type === "tableDelimiterMarker" ? "left" : "none"
        );
      else if (r[1].type === "tableContent") {
        if (n[e - 1][1].type === "tableDelimiterMarker") {
          const s = i.length - 1;
          i[s] = i[s] === "left" ? "center" : "right";
        }
      } else if (r[1].type === "tableDelimiterRow")
        break;
    } else
      r[0] === "enter" && r[1].type === "tableDelimiterRow" && (t = !0);
    e += 1;
  }
  return i;
}
function k5() {
  return {
    flow: {
      null: {
        tokenize: x5,
        resolveAll: w5
      }
    }
  };
}
function x5(n, e, t) {
  const i = this;
  let r = 0, s = 0, o;
  return a;
  function a(P) {
    let R = i.events.length - 1;
    for (; R > -1; ) {
      const U = i.events[R][1].type;
      if (U === "lineEnding" || // Note: markdown-rs uses `whitespace` instead of `linePrefix`
      U === "linePrefix")
        R--;
      else
        break;
    }
    const A = R > -1 ? i.events[R][1].type : null, j = A === "tableHead" || A === "tableRow" ? k : l;
    return j === k && i.parser.lazy[i.now().line] ? t(P) : j(P);
  }
  function l(P) {
    return n.enter("tableHead"), n.enter("tableRow"), u(P);
  }
  function u(P) {
    return P === 124 || (o = !0, s += 1), c(P);
  }
  function c(P) {
    return P === null ? t(P) : G(P) ? s > 1 ? (s = 0, i.interrupt = !0, n.exit("tableRow"), n.enter("lineEnding"), n.consume(P), n.exit("lineEnding"), d) : t(P) : ae(P) ? fe(n, c, "whitespace")(P) : (s += 1, o && (o = !1, r += 1), P === 124 ? (n.enter("tableCellDivider"), n.consume(P), n.exit("tableCellDivider"), o = !0, c) : (n.enter("data"), h(P)));
  }
  function h(P) {
    return P === null || P === 124 || xe(P) ? (n.exit("data"), c(P)) : (n.consume(P), P === 92 ? f : h);
  }
  function f(P) {
    return P === 92 || P === 124 ? (n.consume(P), h) : h(P);
  }
  function d(P) {
    return i.interrupt = !1, i.parser.lazy[i.now().line] ? t(P) : (n.enter("tableDelimiterRow"), o = !1, ae(P) ? fe(
      n,
      p,
      "linePrefix",
      i.parser.constructs.disable.null.includes("codeIndented") ? void 0 : 4
    )(P) : p(P));
  }
  function p(P) {
    return P === 45 || P === 58 ? O(P) : P === 124 ? (o = !0, n.enter("tableCellDivider"), n.consume(P), n.exit("tableCellDivider"), g) : v(P);
  }
  function g(P) {
    return ae(P) ? fe(n, O, "whitespace")(P) : O(P);
  }
  function O(P) {
    return P === 58 ? (s += 1, o = !0, n.enter("tableDelimiterMarker"), n.consume(P), n.exit("tableDelimiterMarker"), m) : P === 45 ? (s += 1, m(P)) : P === null || G(P) ? Q(P) : v(P);
  }
  function m(P) {
    return P === 45 ? (n.enter("tableDelimiterFiller"), b(P)) : v(P);
  }
  function b(P) {
    return P === 45 ? (n.consume(P), b) : P === 58 ? (o = !0, n.exit("tableDelimiterFiller"), n.enter("tableDelimiterMarker"), n.consume(P), n.exit("tableDelimiterMarker"), w) : (n.exit("tableDelimiterFiller"), w(P));
  }
  function w(P) {
    return ae(P) ? fe(n, Q, "whitespace")(P) : Q(P);
  }
  function Q(P) {
    return P === 124 ? p(P) : P === null || G(P) ? !o || r !== s ? v(P) : (n.exit("tableDelimiterRow"), n.exit("tableHead"), e(P)) : v(P);
  }
  function v(P) {
    return t(P);
  }
  function k(P) {
    return n.enter("tableRow"), C(P);
  }
  function C(P) {
    return P === 124 ? (n.enter("tableCellDivider"), n.consume(P), n.exit("tableCellDivider"), C) : P === null || G(P) ? (n.exit("tableRow"), e(P)) : ae(P) ? fe(n, C, "whitespace")(P) : (n.enter("data"), I(P));
  }
  function I(P) {
    return P === null || P === 124 || xe(P) ? (n.exit("data"), C(P)) : (n.consume(P), P === 92 ? z : I);
  }
  function z(P) {
    return P === 92 || P === 124 ? (n.consume(P), I) : I(P);
  }
}
function w5(n, e) {
  let t = -1, i = !0, r = 0, s = [0, 0, 0, 0], o = [0, 0, 0, 0], a = !1, l = 0, u, c, h;
  const f = new O5();
  for (; ++t < n.length; ) {
    const d = n[t], p = d[1];
    d[0] === "enter" ? p.type === "tableHead" ? (a = !1, l !== 0 && (Cp(f, e, l, u, c), c = void 0, l = 0), u = {
      type: "table",
      start: Object.assign({}, p.start),
      // Note: correct end is set later.
      end: Object.assign({}, p.end)
    }, f.add(t, 0, [["enter", u, e]])) : p.type === "tableRow" || p.type === "tableDelimiterRow" ? (i = !0, h = void 0, s = [0, 0, 0, 0], o = [0, t + 1, 0, 0], a && (a = !1, c = {
      type: "tableBody",
      start: Object.assign({}, p.start),
      // Note: correct end is set later.
      end: Object.assign({}, p.end)
    }, f.add(t, 0, [["enter", c, e]])), r = p.type === "tableDelimiterRow" ? 2 : c ? 3 : 1) : r && (p.type === "data" || p.type === "tableDelimiterMarker" || p.type === "tableDelimiterFiller") ? (i = !1, o[2] === 0 && (s[1] !== 0 && (o[0] = o[1], h = yo(
      f,
      e,
      s,
      r,
      void 0,
      h
    ), s = [0, 0, 0, 0]), o[2] = t)) : p.type === "tableCellDivider" && (i ? i = !1 : (s[1] !== 0 && (o[0] = o[1], h = yo(
      f,
      e,
      s,
      r,
      void 0,
      h
    )), s = o, o = [s[1], t, 0, 0])) : p.type === "tableHead" ? (a = !0, l = t) : p.type === "tableRow" || p.type === "tableDelimiterRow" ? (l = t, s[1] !== 0 ? (o[0] = o[1], h = yo(
      f,
      e,
      s,
      r,
      t,
      h
    )) : o[1] !== 0 && (h = yo(f, e, o, r, t, h)), r = 0) : r && (p.type === "data" || p.type === "tableDelimiterMarker" || p.type === "tableDelimiterFiller") && (o[3] = t);
  }
  for (l !== 0 && Cp(f, e, l, u, c), f.consume(e.events), t = -1; ++t < e.events.length; ) {
    const d = e.events[t];
    d[0] === "enter" && d[1].type === "table" && (d[1]._align = y5(e.events, t));
  }
  return n;
}
function yo(n, e, t, i, r, s) {
  const o = i === 1 ? "tableHeader" : i === 2 ? "tableDelimiter" : "tableData", a = "tableContent";
  t[0] !== 0 && (s.end = Object.assign({}, Li(e.events, t[0])), n.add(t[0], 0, [["exit", s, e]]));
  const l = Li(e.events, t[1]);
  if (s = {
    type: o,
    start: Object.assign({}, l),
    // Note: correct end is set later.
    end: Object.assign({}, l)
  }, n.add(t[1], 0, [["enter", s, e]]), t[2] !== 0) {
    const u = Li(e.events, t[2]), c = Li(e.events, t[3]), h = {
      type: a,
      start: Object.assign({}, u),
      end: Object.assign({}, c)
    };
    if (n.add(t[2], 0, [["enter", h, e]]), i !== 2) {
      const f = e.events[t[2]], d = e.events[t[3]];
      if (f[1].end = Object.assign({}, d[1].end), f[1].type = "chunkText", f[1].contentType = "text", t[3] > t[2] + 1) {
        const p = t[2] + 1, g = t[3] - t[2] - 1;
        n.add(p, g, []);
      }
    }
    n.add(t[3] + 1, 0, [["exit", h, e]]);
  }
  return r !== void 0 && (s.end = Object.assign({}, Li(e.events, r)), n.add(r, 0, [["exit", s, e]]), s = void 0), s;
}
function Cp(n, e, t, i, r) {
  const s = [], o = Li(e.events, t);
  r && (r.end = Object.assign({}, o), s.push(["exit", r, e])), i.end = Object.assign({}, o), s.push(["exit", i, e]), n.add(t + 1, 0, s);
}
function Li(n, e) {
  const t = n[e], i = t[0] === "enter" ? "start" : "end";
  return t[1][i];
}
const S5 = {
  tokenize: P5
};
function v5() {
  return {
    text: {
      91: S5
    }
  };
}
function P5(n, e, t) {
  const i = this;
  return r;
  function r(l) {
    return (
      // Exit if there’s stuff before.
      i.previous !== null || // Exit if not in the first content that is the first child of a list
      // item.
      !i._gfmTasklistFirstContentOfListItem ? t(l) : (n.enter("taskListCheck"), n.enter("taskListCheckMarker"), n.consume(l), n.exit("taskListCheckMarker"), s)
    );
  }
  function s(l) {
    return xe(l) ? (n.enter("taskListCheckValueUnchecked"), n.consume(l), n.exit("taskListCheckValueUnchecked"), o) : l === 88 || l === 120 ? (n.enter("taskListCheckValueChecked"), n.consume(l), n.exit("taskListCheckValueChecked"), o) : t(l);
  }
  function o(l) {
    return l === 93 ? (n.enter("taskListCheckMarker"), n.consume(l), n.exit("taskListCheckMarker"), n.exit("taskListCheck"), a) : t(l);
  }
  function a(l) {
    return G(l) ? e(l) : ae(l) ? n.check(
      {
        tokenize: Q5
      },
      e,
      t
    )(l) : t(l);
  }
}
function Q5(n, e, t) {
  return fe(n, i, "whitespace");
  function i(r) {
    return r === null ? t(r) : e(r);
  }
}
function $5(n) {
  return X0([
    IC(),
    l5(),
    g5(n),
    k5(),
    v5()
  ]);
}
const C5 = {};
function T5(n) {
  const e = (
    /** @type {Processor} */
    this
  ), t = n || C5, i = e.data(), r = i.micromarkExtensions || (i.micromarkExtensions = []), s = i.fromMarkdownExtensions || (i.fromMarkdownExtensions = []), o = i.toMarkdownExtensions || (i.toMarkdownExtensions = []);
  r.push($5(t)), s.push(RC()), o.push(MC(t));
}
const A5 = "horizontal", R5 = "bold", M5 = "italic", Z5 = "strikethrough", E5 = "Equation", z5 = "quote", D5 = "help", I5 = " character", L5 = "confirm", _5 = "cancel", X5 = "code", N5 = "link", W5 = "image", q5 = "table", Tp = {
  "increase-level": "increase headline",
  "decrease-level": "decrease headline",
  horizontal: A5,
  bold: R5,
  italic: M5,
  strikethrough: Z5,
  math: E5,
  quote: z5,
  "unordered-list": "unordered list",
  "ordered-list": "ordered list",
  "task-list": "task list",
  "only-editor": "editor only",
  "only-viewer": "viewer only",
  "full-screen": "fullscreen",
  help: D5,
  "release-to-update": "release to upload",
  character: I5,
  "character-count": "character count: ",
  "sync-disable": "disable sync",
  "sync-enable": "enable sync",
  "back-to-top": "back to top",
  confirm: L5,
  cancel: _5,
  code: X5,
  "code-insert": "insert code",
  "code-select": "select language",
  link: N5,
  "link-insert": "insert link",
  "link-url": "url",
  "link-alt": "alt",
  image: W5,
  "image-insert": "insert image",
  "image-url": "url",
  "image-alt": "alt",
  table: q5,
  "table-insert": "insert table",
  "table-rows": "rows",
  "table-cols": "cols",
  "table-edit": "edit",
  "table-edit-tips": "Choose the cell to edit the content"
}, B5 = "水平线", V5 = "粗体", Y5 = "斜体", j5 = "删除线", U5 = "数学公式", F5 = "引用", G5 = "帮助", H5 = " 字符", K5 = "确认", J5 = "取消", eT = "代码", tT = "链接", nT = "图片", iT = "表格", TD = {
  "increase-level": "提升一级",
  "decrease-level": "降低一级",
  horizontal: B5,
  bold: V5,
  italic: Y5,
  strikethrough: j5,
  math: U5,
  quote: F5,
  "unordered-list": "无序列表",
  "ordered-list": "有序列表",
  "task-list": "任务列表",
  "only-editor": "仅编辑",
  "only-viewer": "仅预览",
  "full-screen": "全屏",
  help: G5,
  "release-to-update": "放下图片上传",
  character: H5,
  "character-count": "字数统计：",
  "sync-disable": "禁用滚动同步",
  "sync-enable": "启用滚动同步",
  "back-to-top": "回到顶部",
  confirm: K5,
  cancel: J5,
  code: eT,
  "code-insert": "插入代码",
  "code-select": "选择语言",
  link: tT,
  "link-insert": "插入链接",
  "link-url": "链接地址",
  "link-alt": "链接介绍",
  image: nT,
  "image-insert": "插入图片",
  "image-url": "图片地址",
  "image-alt": "图片介绍",
  table: iT,
  "table-insert": "插入表格",
  "table-rows": "行数",
  "table-cols": "列数",
  "table-edit": "编辑表格",
  "table-edit-tips": "选择单元格以编辑内容"
};
function Ap(n, e) {
  var t = Object.keys(n);
  if (Object.getOwnPropertySymbols) {
    var i = Object.getOwnPropertySymbols(n);
    e && (i = i.filter(function(r) {
      return Object.getOwnPropertyDescriptor(n, r).enumerable;
    })), t.push.apply(t, i);
  }
  return t;
}
function X(n) {
  for (var e = 1; e < arguments.length; e++) {
    var t = arguments[e] != null ? arguments[e] : {};
    e % 2 ? Ap(Object(t), !0).forEach(function(i) {
      Be(n, i, t[i]);
    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(n, Object.getOwnPropertyDescriptors(t)) : Ap(Object(t)).forEach(function(i) {
      Object.defineProperty(n, i, Object.getOwnPropertyDescriptor(t, i));
    });
  }
  return n;
}
function $a(n) {
  "@babel/helpers - typeof";
  return $a = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(e) {
    return typeof e;
  } : function(e) {
    return e && typeof Symbol == "function" && e.constructor === Symbol && e !== Symbol.prototype ? "symbol" : typeof e;
  }, $a(n);
}
function rT(n, e) {
  if (!(n instanceof e))
    throw new TypeError("Cannot call a class as a function");
}
function sT(n, e) {
  for (var t = 0; t < e.length; t++) {
    var i = e[t];
    i.enumerable = i.enumerable || !1, i.configurable = !0, "value" in i && (i.writable = !0), Object.defineProperty(n, i.key, i);
  }
}
function oT(n, e, t) {
  return e && sT(n.prototype, e), Object.defineProperty(n, "prototype", {
    writable: !1
  }), n;
}
function Be(n, e, t) {
  return e in n ? Object.defineProperty(n, e, {
    value: t,
    enumerable: !0,
    configurable: !0,
    writable: !0
  }) : n[e] = t, n;
}
function Xh(n, e) {
  return lT(n) || cT(n, e) || nb(n, e) || fT();
}
function Ws(n) {
  return aT(n) || uT(n) || nb(n) || hT();
}
function aT(n) {
  if (Array.isArray(n))
    return Oc(n);
}
function lT(n) {
  if (Array.isArray(n))
    return n;
}
function uT(n) {
  if (typeof Symbol < "u" && n[Symbol.iterator] != null || n["@@iterator"] != null)
    return Array.from(n);
}
function cT(n, e) {
  var t = n == null ? null : typeof Symbol < "u" && n[Symbol.iterator] || n["@@iterator"];
  if (t != null) {
    var i = [], r = !0, s = !1, o, a;
    try {
      for (t = t.call(n); !(r = (o = t.next()).done) && (i.push(o.value), !(e && i.length === e)); r = !0)
        ;
    } catch (l) {
      s = !0, a = l;
    } finally {
      try {
        !r && t.return != null && t.return();
      } finally {
        if (s)
          throw a;
      }
    }
    return i;
  }
}
function nb(n, e) {
  if (n) {
    if (typeof n == "string")
      return Oc(n, e);
    var t = Object.prototype.toString.call(n).slice(8, -1);
    if (t === "Object" && n.constructor && (t = n.constructor.name), t === "Map" || t === "Set")
      return Array.from(n);
    if (t === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t))
      return Oc(n, e);
  }
}
function Oc(n, e) {
  (e == null || e > n.length) && (e = n.length);
  for (var t = 0, i = new Array(e); t < e; t++)
    i[t] = n[t];
  return i;
}
function hT() {
  throw new TypeError(`Invalid attempt to spread non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
}
function fT() {
  throw new TypeError(`Invalid attempt to destructure non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
}
var Rp = function() {
}, Nh = {}, ib = {}, rb = null, sb = {
  mark: Rp,
  measure: Rp
};
try {
  typeof window < "u" && (Nh = window), typeof document < "u" && (ib = document), typeof MutationObserver < "u" && (rb = MutationObserver), typeof performance < "u" && (sb = performance);
} catch {
}
var dT = Nh.navigator || {}, Mp = dT.userAgent, Zp = Mp === void 0 ? "" : Mp, ti = Nh, Re = ib, Ep = rb, ko = sb;
ti.document;
var zn = !!Re.documentElement && !!Re.head && typeof Re.addEventListener == "function" && typeof Re.createElement == "function", ob = ~Zp.indexOf("MSIE") || ~Zp.indexOf("Trident/"), xo, wo, So, vo, Po, Tn = "___FONT_AWESOME___", bc = 16, ab = "fa", lb = "svg-inline--fa", Qi = "data-fa-i2svg", yc = "data-fa-pseudo-element", pT = "data-fa-pseudo-element-pending", Wh = "data-prefix", qh = "data-icon", zp = "fontawesome-i2svg", mT = "async", gT = ["HTML", "HEAD", "STYLE", "SCRIPT"], ub = function() {
  try {
    return process.env.NODE_ENV === "production";
  } catch {
    return !1;
  }
}(), Te = "classic", ze = "sharp", Bh = [Te, ze];
function qs(n) {
  return new Proxy(n, {
    get: function(t, i) {
      return i in t ? t[i] : t[Te];
    }
  });
}
var xs = qs((xo = {}, Be(xo, Te, {
  fa: "solid",
  fas: "solid",
  "fa-solid": "solid",
  far: "regular",
  "fa-regular": "regular",
  fal: "light",
  "fa-light": "light",
  fat: "thin",
  "fa-thin": "thin",
  fad: "duotone",
  "fa-duotone": "duotone",
  fab: "brands",
  "fa-brands": "brands",
  fak: "kit",
  fakd: "kit",
  "fa-kit": "kit",
  "fa-kit-duotone": "kit"
}), Be(xo, ze, {
  fa: "solid",
  fass: "solid",
  "fa-solid": "solid",
  fasr: "regular",
  "fa-regular": "regular",
  fasl: "light",
  "fa-light": "light",
  fast: "thin",
  "fa-thin": "thin"
}), xo)), ws = qs((wo = {}, Be(wo, Te, {
  solid: "fas",
  regular: "far",
  light: "fal",
  thin: "fat",
  duotone: "fad",
  brands: "fab",
  kit: "fak"
}), Be(wo, ze, {
  solid: "fass",
  regular: "fasr",
  light: "fasl",
  thin: "fast"
}), wo)), Ss = qs((So = {}, Be(So, Te, {
  fab: "fa-brands",
  fad: "fa-duotone",
  fak: "fa-kit",
  fal: "fa-light",
  far: "fa-regular",
  fas: "fa-solid",
  fat: "fa-thin"
}), Be(So, ze, {
  fass: "fa-solid",
  fasr: "fa-regular",
  fasl: "fa-light",
  fast: "fa-thin"
}), So)), OT = qs((vo = {}, Be(vo, Te, {
  "fa-brands": "fab",
  "fa-duotone": "fad",
  "fa-kit": "fak",
  "fa-light": "fal",
  "fa-regular": "far",
  "fa-solid": "fas",
  "fa-thin": "fat"
}), Be(vo, ze, {
  "fa-solid": "fass",
  "fa-regular": "fasr",
  "fa-light": "fasl",
  "fa-thin": "fast"
}), vo)), bT = /fa(s|r|l|t|d|b|k|ss|sr|sl|st)?[\-\ ]/, cb = "fa-layers-text", yT = /Font ?Awesome ?([56 ]*)(Solid|Regular|Light|Thin|Duotone|Brands|Free|Pro|Sharp|Kit)?.*/i, kT = qs((Po = {}, Be(Po, Te, {
  900: "fas",
  400: "far",
  normal: "far",
  300: "fal",
  100: "fat"
}), Be(Po, ze, {
  900: "fass",
  400: "fasr",
  300: "fasl",
  100: "fast"
}), Po)), hb = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10], xT = hb.concat([11, 12, 13, 14, 15, 16, 17, 18, 19, 20]), wT = ["class", "data-prefix", "data-icon", "data-fa-transform", "data-fa-mask"], bi = {
  GROUP: "duotone-group",
  SWAP_OPACITY: "swap-opacity",
  PRIMARY: "primary",
  SECONDARY: "secondary"
}, vs = /* @__PURE__ */ new Set();
Object.keys(ws[Te]).map(vs.add.bind(vs));
Object.keys(ws[ze]).map(vs.add.bind(vs));
var ST = [].concat(Bh, Ws(vs), ["2xs", "xs", "sm", "lg", "xl", "2xl", "beat", "border", "fade", "beat-fade", "bounce", "flip-both", "flip-horizontal", "flip-vertical", "flip", "fw", "inverse", "layers-counter", "layers-text", "layers", "li", "pull-left", "pull-right", "pulse", "rotate-180", "rotate-270", "rotate-90", "rotate-by", "shake", "spin-pulse", "spin-reverse", "spin", "stack-1x", "stack-2x", "stack", "ul", bi.GROUP, bi.SWAP_OPACITY, bi.PRIMARY, bi.SECONDARY]).concat(hb.map(function(n) {
  return "".concat(n, "x");
})).concat(xT.map(function(n) {
  return "w-".concat(n);
})), Hr = ti.FontAwesomeConfig || {};
function vT(n) {
  var e = Re.querySelector("script[" + n + "]");
  if (e)
    return e.getAttribute(n);
}
function PT(n) {
  return n === "" ? !0 : n === "false" ? !1 : n === "true" ? !0 : n;
}
if (Re && typeof Re.querySelector == "function") {
  var QT = [["data-family-prefix", "familyPrefix"], ["data-css-prefix", "cssPrefix"], ["data-family-default", "familyDefault"], ["data-style-default", "styleDefault"], ["data-replacement-class", "replacementClass"], ["data-auto-replace-svg", "autoReplaceSvg"], ["data-auto-add-css", "autoAddCss"], ["data-auto-a11y", "autoA11y"], ["data-search-pseudo-elements", "searchPseudoElements"], ["data-observe-mutations", "observeMutations"], ["data-mutate-approach", "mutateApproach"], ["data-keep-original-source", "keepOriginalSource"], ["data-measure-performance", "measurePerformance"], ["data-show-missing-icons", "showMissingIcons"]];
  QT.forEach(function(n) {
    var e = Xh(n, 2), t = e[0], i = e[1], r = PT(vT(t));
    r != null && (Hr[i] = r);
  });
}
var fb = {
  styleDefault: "solid",
  familyDefault: "classic",
  cssPrefix: ab,
  replacementClass: lb,
  autoReplaceSvg: !0,
  autoAddCss: !0,
  autoA11y: !0,
  searchPseudoElements: !1,
  observeMutations: !0,
  mutateApproach: "async",
  keepOriginalSource: !0,
  measurePerformance: !1,
  showMissingIcons: !0
};
Hr.familyPrefix && (Hr.cssPrefix = Hr.familyPrefix);
var lr = X(X({}, fb), Hr);
lr.autoReplaceSvg || (lr.observeMutations = !1);
var V = {};
Object.keys(fb).forEach(function(n) {
  Object.defineProperty(V, n, {
    enumerable: !0,
    set: function(t) {
      lr[n] = t, Kr.forEach(function(i) {
        return i(V);
      });
    },
    get: function() {
      return lr[n];
    }
  });
});
Object.defineProperty(V, "familyPrefix", {
  enumerable: !0,
  set: function(e) {
    lr.cssPrefix = e, Kr.forEach(function(t) {
      return t(V);
    });
  },
  get: function() {
    return lr.cssPrefix;
  }
});
ti.FontAwesomeConfig = V;
var Kr = [];
function $T(n) {
  return Kr.push(n), function() {
    Kr.splice(Kr.indexOf(n), 1);
  };
}
var In = bc, cn = {
  size: 16,
  x: 0,
  y: 0,
  rotate: 0,
  flipX: !1,
  flipY: !1
};
function CT(n) {
  if (!(!n || !zn)) {
    var e = Re.createElement("style");
    e.setAttribute("type", "text/css"), e.innerHTML = n;
    for (var t = Re.head.childNodes, i = null, r = t.length - 1; r > -1; r--) {
      var s = t[r], o = (s.tagName || "").toUpperCase();
      ["STYLE", "LINK"].indexOf(o) > -1 && (i = s);
    }
    return Re.head.insertBefore(e, i), n;
  }
}
var TT = "0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ";
function Ps() {
  for (var n = 12, e = ""; n-- > 0; )
    e += TT[Math.random() * 62 | 0];
  return e;
}
function xr(n) {
  for (var e = [], t = (n || []).length >>> 0; t--; )
    e[t] = n[t];
  return e;
}
function Vh(n) {
  return n.classList ? xr(n.classList) : (n.getAttribute("class") || "").split(" ").filter(function(e) {
    return e;
  });
}
function db(n) {
  return "".concat(n).replace(/&/g, "&amp;").replace(/"/g, "&quot;").replace(/'/g, "&#39;").replace(/</g, "&lt;").replace(/>/g, "&gt;");
}
function AT(n) {
  return Object.keys(n || {}).reduce(function(e, t) {
    return e + "".concat(t, '="').concat(db(n[t]), '" ');
  }, "").trim();
}
function ol(n) {
  return Object.keys(n || {}).reduce(function(e, t) {
    return e + "".concat(t, ": ").concat(n[t].trim(), ";");
  }, "");
}
function Yh(n) {
  return n.size !== cn.size || n.x !== cn.x || n.y !== cn.y || n.rotate !== cn.rotate || n.flipX || n.flipY;
}
function RT(n) {
  var e = n.transform, t = n.containerWidth, i = n.iconWidth, r = {
    transform: "translate(".concat(t / 2, " 256)")
  }, s = "translate(".concat(e.x * 32, ", ").concat(e.y * 32, ") "), o = "scale(".concat(e.size / 16 * (e.flipX ? -1 : 1), ", ").concat(e.size / 16 * (e.flipY ? -1 : 1), ") "), a = "rotate(".concat(e.rotate, " 0 0)"), l = {
    transform: "".concat(s, " ").concat(o, " ").concat(a)
  }, u = {
    transform: "translate(".concat(i / 2 * -1, " -256)")
  };
  return {
    outer: r,
    inner: l,
    path: u
  };
}
function MT(n) {
  var e = n.transform, t = n.width, i = t === void 0 ? bc : t, r = n.height, s = r === void 0 ? bc : r, o = n.startCentered, a = o === void 0 ? !1 : o, l = "";
  return a && ob ? l += "translate(".concat(e.x / In - i / 2, "em, ").concat(e.y / In - s / 2, "em) ") : a ? l += "translate(calc(-50% + ".concat(e.x / In, "em), calc(-50% + ").concat(e.y / In, "em)) ") : l += "translate(".concat(e.x / In, "em, ").concat(e.y / In, "em) "), l += "scale(".concat(e.size / In * (e.flipX ? -1 : 1), ", ").concat(e.size / In * (e.flipY ? -1 : 1), ") "), l += "rotate(".concat(e.rotate, "deg) "), l;
}
var ZT = `:root, :host {
  --fa-font-solid: normal 900 1em/1 "Font Awesome 6 Solid";
  --fa-font-regular: normal 400 1em/1 "Font Awesome 6 Regular";
  --fa-font-light: normal 300 1em/1 "Font Awesome 6 Light";
  --fa-font-thin: normal 100 1em/1 "Font Awesome 6 Thin";
  --fa-font-duotone: normal 900 1em/1 "Font Awesome 6 Duotone";
  --fa-font-sharp-solid: normal 900 1em/1 "Font Awesome 6 Sharp";
  --fa-font-sharp-regular: normal 400 1em/1 "Font Awesome 6 Sharp";
  --fa-font-sharp-light: normal 300 1em/1 "Font Awesome 6 Sharp";
  --fa-font-sharp-thin: normal 100 1em/1 "Font Awesome 6 Sharp";
  --fa-font-brands: normal 400 1em/1 "Font Awesome 6 Brands";
}

svg:not(:root).svg-inline--fa, svg:not(:host).svg-inline--fa {
  overflow: visible;
  box-sizing: content-box;
}

.svg-inline--fa {
  display: var(--fa-display, inline-block);
  height: 1em;
  overflow: visible;
  vertical-align: -0.125em;
}
.svg-inline--fa.fa-2xs {
  vertical-align: 0.1em;
}
.svg-inline--fa.fa-xs {
  vertical-align: 0em;
}
.svg-inline--fa.fa-sm {
  vertical-align: -0.0714285705em;
}
.svg-inline--fa.fa-lg {
  vertical-align: -0.2em;
}
.svg-inline--fa.fa-xl {
  vertical-align: -0.25em;
}
.svg-inline--fa.fa-2xl {
  vertical-align: -0.3125em;
}
.svg-inline--fa.fa-pull-left {
  margin-right: var(--fa-pull-margin, 0.3em);
  width: auto;
}
.svg-inline--fa.fa-pull-right {
  margin-left: var(--fa-pull-margin, 0.3em);
  width: auto;
}
.svg-inline--fa.fa-li {
  width: var(--fa-li-width, 2em);
  top: 0.25em;
}
.svg-inline--fa.fa-fw {
  width: var(--fa-fw-width, 1.25em);
}

.fa-layers svg.svg-inline--fa {
  bottom: 0;
  left: 0;
  margin: auto;
  position: absolute;
  right: 0;
  top: 0;
}

.fa-layers-counter, .fa-layers-text {
  display: inline-block;
  position: absolute;
  text-align: center;
}

.fa-layers {
  display: inline-block;
  height: 1em;
  position: relative;
  text-align: center;
  vertical-align: -0.125em;
  width: 1em;
}
.fa-layers svg.svg-inline--fa {
  -webkit-transform-origin: center center;
          transform-origin: center center;
}

.fa-layers-text {
  left: 50%;
  top: 50%;
  -webkit-transform: translate(-50%, -50%);
          transform: translate(-50%, -50%);
  -webkit-transform-origin: center center;
          transform-origin: center center;
}

.fa-layers-counter {
  background-color: var(--fa-counter-background-color, #ff253a);
  border-radius: var(--fa-counter-border-radius, 1em);
  box-sizing: border-box;
  color: var(--fa-inverse, #fff);
  line-height: var(--fa-counter-line-height, 1);
  max-width: var(--fa-counter-max-width, 5em);
  min-width: var(--fa-counter-min-width, 1.5em);
  overflow: hidden;
  padding: var(--fa-counter-padding, 0.25em 0.5em);
  right: var(--fa-right, 0);
  text-overflow: ellipsis;
  top: var(--fa-top, 0);
  -webkit-transform: scale(var(--fa-counter-scale, 0.25));
          transform: scale(var(--fa-counter-scale, 0.25));
  -webkit-transform-origin: top right;
          transform-origin: top right;
}

.fa-layers-bottom-right {
  bottom: var(--fa-bottom, 0);
  right: var(--fa-right, 0);
  top: auto;
  -webkit-transform: scale(var(--fa-layers-scale, 0.25));
          transform: scale(var(--fa-layers-scale, 0.25));
  -webkit-transform-origin: bottom right;
          transform-origin: bottom right;
}

.fa-layers-bottom-left {
  bottom: var(--fa-bottom, 0);
  left: var(--fa-left, 0);
  right: auto;
  top: auto;
  -webkit-transform: scale(var(--fa-layers-scale, 0.25));
          transform: scale(var(--fa-layers-scale, 0.25));
  -webkit-transform-origin: bottom left;
          transform-origin: bottom left;
}

.fa-layers-top-right {
  top: var(--fa-top, 0);
  right: var(--fa-right, 0);
  -webkit-transform: scale(var(--fa-layers-scale, 0.25));
          transform: scale(var(--fa-layers-scale, 0.25));
  -webkit-transform-origin: top right;
          transform-origin: top right;
}

.fa-layers-top-left {
  left: var(--fa-left, 0);
  right: auto;
  top: var(--fa-top, 0);
  -webkit-transform: scale(var(--fa-layers-scale, 0.25));
          transform: scale(var(--fa-layers-scale, 0.25));
  -webkit-transform-origin: top left;
          transform-origin: top left;
}

.fa-1x {
  font-size: 1em;
}

.fa-2x {
  font-size: 2em;
}

.fa-3x {
  font-size: 3em;
}

.fa-4x {
  font-size: 4em;
}

.fa-5x {
  font-size: 5em;
}

.fa-6x {
  font-size: 6em;
}

.fa-7x {
  font-size: 7em;
}

.fa-8x {
  font-size: 8em;
}

.fa-9x {
  font-size: 9em;
}

.fa-10x {
  font-size: 10em;
}

.fa-2xs {
  font-size: 0.625em;
  line-height: 0.1em;
  vertical-align: 0.225em;
}

.fa-xs {
  font-size: 0.75em;
  line-height: 0.0833333337em;
  vertical-align: 0.125em;
}

.fa-sm {
  font-size: 0.875em;
  line-height: 0.0714285718em;
  vertical-align: 0.0535714295em;
}

.fa-lg {
  font-size: 1.25em;
  line-height: 0.05em;
  vertical-align: -0.075em;
}

.fa-xl {
  font-size: 1.5em;
  line-height: 0.0416666682em;
  vertical-align: -0.125em;
}

.fa-2xl {
  font-size: 2em;
  line-height: 0.03125em;
  vertical-align: -0.1875em;
}

.fa-fw {
  text-align: center;
  width: 1.25em;
}

.fa-ul {
  list-style-type: none;
  margin-left: var(--fa-li-margin, 2.5em);
  padding-left: 0;
}
.fa-ul > li {
  position: relative;
}

.fa-li {
  left: calc(var(--fa-li-width, 2em) * -1);
  position: absolute;
  text-align: center;
  width: var(--fa-li-width, 2em);
  line-height: inherit;
}

.fa-border {
  border-color: var(--fa-border-color, #eee);
  border-radius: var(--fa-border-radius, 0.1em);
  border-style: var(--fa-border-style, solid);
  border-width: var(--fa-border-width, 0.08em);
  padding: var(--fa-border-padding, 0.2em 0.25em 0.15em);
}

.fa-pull-left {
  float: left;
  margin-right: var(--fa-pull-margin, 0.3em);
}

.fa-pull-right {
  float: right;
  margin-left: var(--fa-pull-margin, 0.3em);
}

.fa-beat {
  -webkit-animation-name: fa-beat;
          animation-name: fa-beat;
  -webkit-animation-delay: var(--fa-animation-delay, 0s);
          animation-delay: var(--fa-animation-delay, 0s);
  -webkit-animation-direction: var(--fa-animation-direction, normal);
          animation-direction: var(--fa-animation-direction, normal);
  -webkit-animation-duration: var(--fa-animation-duration, 1s);
          animation-duration: var(--fa-animation-duration, 1s);
  -webkit-animation-iteration-count: var(--fa-animation-iteration-count, infinite);
          animation-iteration-count: var(--fa-animation-iteration-count, infinite);
  -webkit-animation-timing-function: var(--fa-animation-timing, ease-in-out);
          animation-timing-function: var(--fa-animation-timing, ease-in-out);
}

.fa-bounce {
  -webkit-animation-name: fa-bounce;
          animation-name: fa-bounce;
  -webkit-animation-delay: var(--fa-animation-delay, 0s);
          animation-delay: var(--fa-animation-delay, 0s);
  -webkit-animation-direction: var(--fa-animation-direction, normal);
          animation-direction: var(--fa-animation-direction, normal);
  -webkit-animation-duration: var(--fa-animation-duration, 1s);
          animation-duration: var(--fa-animation-duration, 1s);
  -webkit-animation-iteration-count: var(--fa-animation-iteration-count, infinite);
          animation-iteration-count: var(--fa-animation-iteration-count, infinite);
  -webkit-animation-timing-function: var(--fa-animation-timing, cubic-bezier(0.28, 0.84, 0.42, 1));
          animation-timing-function: var(--fa-animation-timing, cubic-bezier(0.28, 0.84, 0.42, 1));
}

.fa-fade {
  -webkit-animation-name: fa-fade;
          animation-name: fa-fade;
  -webkit-animation-delay: var(--fa-animation-delay, 0s);
          animation-delay: var(--fa-animation-delay, 0s);
  -webkit-animation-direction: var(--fa-animation-direction, normal);
          animation-direction: var(--fa-animation-direction, normal);
  -webkit-animation-duration: var(--fa-animation-duration, 1s);
          animation-duration: var(--fa-animation-duration, 1s);
  -webkit-animation-iteration-count: var(--fa-animation-iteration-count, infinite);
          animation-iteration-count: var(--fa-animation-iteration-count, infinite);
  -webkit-animation-timing-function: var(--fa-animation-timing, cubic-bezier(0.4, 0, 0.6, 1));
          animation-timing-function: var(--fa-animation-timing, cubic-bezier(0.4, 0, 0.6, 1));
}

.fa-beat-fade {
  -webkit-animation-name: fa-beat-fade;
          animation-name: fa-beat-fade;
  -webkit-animation-delay: var(--fa-animation-delay, 0s);
          animation-delay: var(--fa-animation-delay, 0s);
  -webkit-animation-direction: var(--fa-animation-direction, normal);
          animation-direction: var(--fa-animation-direction, normal);
  -webkit-animation-duration: var(--fa-animation-duration, 1s);
          animation-duration: var(--fa-animation-duration, 1s);
  -webkit-animation-iteration-count: var(--fa-animation-iteration-count, infinite);
          animation-iteration-count: var(--fa-animation-iteration-count, infinite);
  -webkit-animation-timing-function: var(--fa-animation-timing, cubic-bezier(0.4, 0, 0.6, 1));
          animation-timing-function: var(--fa-animation-timing, cubic-bezier(0.4, 0, 0.6, 1));
}

.fa-flip {
  -webkit-animation-name: fa-flip;
          animation-name: fa-flip;
  -webkit-animation-delay: var(--fa-animation-delay, 0s);
          animation-delay: var(--fa-animation-delay, 0s);
  -webkit-animation-direction: var(--fa-animation-direction, normal);
          animation-direction: var(--fa-animation-direction, normal);
  -webkit-animation-duration: var(--fa-animation-duration, 1s);
          animation-duration: var(--fa-animation-duration, 1s);
  -webkit-animation-iteration-count: var(--fa-animation-iteration-count, infinite);
          animation-iteration-count: var(--fa-animation-iteration-count, infinite);
  -webkit-animation-timing-function: var(--fa-animation-timing, ease-in-out);
          animation-timing-function: var(--fa-animation-timing, ease-in-out);
}

.fa-shake {
  -webkit-animation-name: fa-shake;
          animation-name: fa-shake;
  -webkit-animation-delay: var(--fa-animation-delay, 0s);
          animation-delay: var(--fa-animation-delay, 0s);
  -webkit-animation-direction: var(--fa-animation-direction, normal);
          animation-direction: var(--fa-animation-direction, normal);
  -webkit-animation-duration: var(--fa-animation-duration, 1s);
          animation-duration: var(--fa-animation-duration, 1s);
  -webkit-animation-iteration-count: var(--fa-animation-iteration-count, infinite);
          animation-iteration-count: var(--fa-animation-iteration-count, infinite);
  -webkit-animation-timing-function: var(--fa-animation-timing, linear);
          animation-timing-function: var(--fa-animation-timing, linear);
}

.fa-spin {
  -webkit-animation-name: fa-spin;
          animation-name: fa-spin;
  -webkit-animation-delay: var(--fa-animation-delay, 0s);
          animation-delay: var(--fa-animation-delay, 0s);
  -webkit-animation-direction: var(--fa-animation-direction, normal);
          animation-direction: var(--fa-animation-direction, normal);
  -webkit-animation-duration: var(--fa-animation-duration, 2s);
          animation-duration: var(--fa-animation-duration, 2s);
  -webkit-animation-iteration-count: var(--fa-animation-iteration-count, infinite);
          animation-iteration-count: var(--fa-animation-iteration-count, infinite);
  -webkit-animation-timing-function: var(--fa-animation-timing, linear);
          animation-timing-function: var(--fa-animation-timing, linear);
}

.fa-spin-reverse {
  --fa-animation-direction: reverse;
}

.fa-pulse,
.fa-spin-pulse {
  -webkit-animation-name: fa-spin;
          animation-name: fa-spin;
  -webkit-animation-direction: var(--fa-animation-direction, normal);
          animation-direction: var(--fa-animation-direction, normal);
  -webkit-animation-duration: var(--fa-animation-duration, 1s);
          animation-duration: var(--fa-animation-duration, 1s);
  -webkit-animation-iteration-count: var(--fa-animation-iteration-count, infinite);
          animation-iteration-count: var(--fa-animation-iteration-count, infinite);
  -webkit-animation-timing-function: var(--fa-animation-timing, steps(8));
          animation-timing-function: var(--fa-animation-timing, steps(8));
}

@media (prefers-reduced-motion: reduce) {
  .fa-beat,
.fa-bounce,
.fa-fade,
.fa-beat-fade,
.fa-flip,
.fa-pulse,
.fa-shake,
.fa-spin,
.fa-spin-pulse {
    -webkit-animation-delay: -1ms;
            animation-delay: -1ms;
    -webkit-animation-duration: 1ms;
            animation-duration: 1ms;
    -webkit-animation-iteration-count: 1;
            animation-iteration-count: 1;
    -webkit-transition-delay: 0s;
            transition-delay: 0s;
    -webkit-transition-duration: 0s;
            transition-duration: 0s;
  }
}
@-webkit-keyframes fa-beat {
  0%, 90% {
    -webkit-transform: scale(1);
            transform: scale(1);
  }
  45% {
    -webkit-transform: scale(var(--fa-beat-scale, 1.25));
            transform: scale(var(--fa-beat-scale, 1.25));
  }
}
@keyframes fa-beat {
  0%, 90% {
    -webkit-transform: scale(1);
            transform: scale(1);
  }
  45% {
    -webkit-transform: scale(var(--fa-beat-scale, 1.25));
            transform: scale(var(--fa-beat-scale, 1.25));
  }
}
@-webkit-keyframes fa-bounce {
  0% {
    -webkit-transform: scale(1, 1) translateY(0);
            transform: scale(1, 1) translateY(0);
  }
  10% {
    -webkit-transform: scale(var(--fa-bounce-start-scale-x, 1.1), var(--fa-bounce-start-scale-y, 0.9)) translateY(0);
            transform: scale(var(--fa-bounce-start-scale-x, 1.1), var(--fa-bounce-start-scale-y, 0.9)) translateY(0);
  }
  30% {
    -webkit-transform: scale(var(--fa-bounce-jump-scale-x, 0.9), var(--fa-bounce-jump-scale-y, 1.1)) translateY(var(--fa-bounce-height, -0.5em));
            transform: scale(var(--fa-bounce-jump-scale-x, 0.9), var(--fa-bounce-jump-scale-y, 1.1)) translateY(var(--fa-bounce-height, -0.5em));
  }
  50% {
    -webkit-transform: scale(var(--fa-bounce-land-scale-x, 1.05), var(--fa-bounce-land-scale-y, 0.95)) translateY(0);
            transform: scale(var(--fa-bounce-land-scale-x, 1.05), var(--fa-bounce-land-scale-y, 0.95)) translateY(0);
  }
  57% {
    -webkit-transform: scale(1, 1) translateY(var(--fa-bounce-rebound, -0.125em));
            transform: scale(1, 1) translateY(var(--fa-bounce-rebound, -0.125em));
  }
  64% {
    -webkit-transform: scale(1, 1) translateY(0);
            transform: scale(1, 1) translateY(0);
  }
  100% {
    -webkit-transform: scale(1, 1) translateY(0);
            transform: scale(1, 1) translateY(0);
  }
}
@keyframes fa-bounce {
  0% {
    -webkit-transform: scale(1, 1) translateY(0);
            transform: scale(1, 1) translateY(0);
  }
  10% {
    -webkit-transform: scale(var(--fa-bounce-start-scale-x, 1.1), var(--fa-bounce-start-scale-y, 0.9)) translateY(0);
            transform: scale(var(--fa-bounce-start-scale-x, 1.1), var(--fa-bounce-start-scale-y, 0.9)) translateY(0);
  }
  30% {
    -webkit-transform: scale(var(--fa-bounce-jump-scale-x, 0.9), var(--fa-bounce-jump-scale-y, 1.1)) translateY(var(--fa-bounce-height, -0.5em));
            transform: scale(var(--fa-bounce-jump-scale-x, 0.9), var(--fa-bounce-jump-scale-y, 1.1)) translateY(var(--fa-bounce-height, -0.5em));
  }
  50% {
    -webkit-transform: scale(var(--fa-bounce-land-scale-x, 1.05), var(--fa-bounce-land-scale-y, 0.95)) translateY(0);
            transform: scale(var(--fa-bounce-land-scale-x, 1.05), var(--fa-bounce-land-scale-y, 0.95)) translateY(0);
  }
  57% {
    -webkit-transform: scale(1, 1) translateY(var(--fa-bounce-rebound, -0.125em));
            transform: scale(1, 1) translateY(var(--fa-bounce-rebound, -0.125em));
  }
  64% {
    -webkit-transform: scale(1, 1) translateY(0);
            transform: scale(1, 1) translateY(0);
  }
  100% {
    -webkit-transform: scale(1, 1) translateY(0);
            transform: scale(1, 1) translateY(0);
  }
}
@-webkit-keyframes fa-fade {
  50% {
    opacity: var(--fa-fade-opacity, 0.4);
  }
}
@keyframes fa-fade {
  50% {
    opacity: var(--fa-fade-opacity, 0.4);
  }
}
@-webkit-keyframes fa-beat-fade {
  0%, 100% {
    opacity: var(--fa-beat-fade-opacity, 0.4);
    -webkit-transform: scale(1);
            transform: scale(1);
  }
  50% {
    opacity: 1;
    -webkit-transform: scale(var(--fa-beat-fade-scale, 1.125));
            transform: scale(var(--fa-beat-fade-scale, 1.125));
  }
}
@keyframes fa-beat-fade {
  0%, 100% {
    opacity: var(--fa-beat-fade-opacity, 0.4);
    -webkit-transform: scale(1);
            transform: scale(1);
  }
  50% {
    opacity: 1;
    -webkit-transform: scale(var(--fa-beat-fade-scale, 1.125));
            transform: scale(var(--fa-beat-fade-scale, 1.125));
  }
}
@-webkit-keyframes fa-flip {
  50% {
    -webkit-transform: rotate3d(var(--fa-flip-x, 0), var(--fa-flip-y, 1), var(--fa-flip-z, 0), var(--fa-flip-angle, -180deg));
            transform: rotate3d(var(--fa-flip-x, 0), var(--fa-flip-y, 1), var(--fa-flip-z, 0), var(--fa-flip-angle, -180deg));
  }
}
@keyframes fa-flip {
  50% {
    -webkit-transform: rotate3d(var(--fa-flip-x, 0), var(--fa-flip-y, 1), var(--fa-flip-z, 0), var(--fa-flip-angle, -180deg));
            transform: rotate3d(var(--fa-flip-x, 0), var(--fa-flip-y, 1), var(--fa-flip-z, 0), var(--fa-flip-angle, -180deg));
  }
}
@-webkit-keyframes fa-shake {
  0% {
    -webkit-transform: rotate(-15deg);
            transform: rotate(-15deg);
  }
  4% {
    -webkit-transform: rotate(15deg);
            transform: rotate(15deg);
  }
  8%, 24% {
    -webkit-transform: rotate(-18deg);
            transform: rotate(-18deg);
  }
  12%, 28% {
    -webkit-transform: rotate(18deg);
            transform: rotate(18deg);
  }
  16% {
    -webkit-transform: rotate(-22deg);
            transform: rotate(-22deg);
  }
  20% {
    -webkit-transform: rotate(22deg);
            transform: rotate(22deg);
  }
  32% {
    -webkit-transform: rotate(-12deg);
            transform: rotate(-12deg);
  }
  36% {
    -webkit-transform: rotate(12deg);
            transform: rotate(12deg);
  }
  40%, 100% {
    -webkit-transform: rotate(0deg);
            transform: rotate(0deg);
  }
}
@keyframes fa-shake {
  0% {
    -webkit-transform: rotate(-15deg);
            transform: rotate(-15deg);
  }
  4% {
    -webkit-transform: rotate(15deg);
            transform: rotate(15deg);
  }
  8%, 24% {
    -webkit-transform: rotate(-18deg);
            transform: rotate(-18deg);
  }
  12%, 28% {
    -webkit-transform: rotate(18deg);
            transform: rotate(18deg);
  }
  16% {
    -webkit-transform: rotate(-22deg);
            transform: rotate(-22deg);
  }
  20% {
    -webkit-transform: rotate(22deg);
            transform: rotate(22deg);
  }
  32% {
    -webkit-transform: rotate(-12deg);
            transform: rotate(-12deg);
  }
  36% {
    -webkit-transform: rotate(12deg);
            transform: rotate(12deg);
  }
  40%, 100% {
    -webkit-transform: rotate(0deg);
            transform: rotate(0deg);
  }
}
@-webkit-keyframes fa-spin {
  0% {
    -webkit-transform: rotate(0deg);
            transform: rotate(0deg);
  }
  100% {
    -webkit-transform: rotate(360deg);
            transform: rotate(360deg);
  }
}
@keyframes fa-spin {
  0% {
    -webkit-transform: rotate(0deg);
            transform: rotate(0deg);
  }
  100% {
    -webkit-transform: rotate(360deg);
            transform: rotate(360deg);
  }
}
.fa-rotate-90 {
  -webkit-transform: rotate(90deg);
          transform: rotate(90deg);
}

.fa-rotate-180 {
  -webkit-transform: rotate(180deg);
          transform: rotate(180deg);
}

.fa-rotate-270 {
  -webkit-transform: rotate(270deg);
          transform: rotate(270deg);
}

.fa-flip-horizontal {
  -webkit-transform: scale(-1, 1);
          transform: scale(-1, 1);
}

.fa-flip-vertical {
  -webkit-transform: scale(1, -1);
          transform: scale(1, -1);
}

.fa-flip-both,
.fa-flip-horizontal.fa-flip-vertical {
  -webkit-transform: scale(-1, -1);
          transform: scale(-1, -1);
}

.fa-rotate-by {
  -webkit-transform: rotate(var(--fa-rotate-angle, 0));
          transform: rotate(var(--fa-rotate-angle, 0));
}

.fa-stack {
  display: inline-block;
  vertical-align: middle;
  height: 2em;
  position: relative;
  width: 2.5em;
}

.fa-stack-1x,
.fa-stack-2x {
  bottom: 0;
  left: 0;
  margin: auto;
  position: absolute;
  right: 0;
  top: 0;
  z-index: var(--fa-stack-z-index, auto);
}

.svg-inline--fa.fa-stack-1x {
  height: 1em;
  width: 1.25em;
}
.svg-inline--fa.fa-stack-2x {
  height: 2em;
  width: 2.5em;
}

.fa-inverse {
  color: var(--fa-inverse, #fff);
}

.sr-only,
.fa-sr-only {
  position: absolute;
  width: 1px;
  height: 1px;
  padding: 0;
  margin: -1px;
  overflow: hidden;
  clip: rect(0, 0, 0, 0);
  white-space: nowrap;
  border-width: 0;
}

.sr-only-focusable:not(:focus),
.fa-sr-only-focusable:not(:focus) {
  position: absolute;
  width: 1px;
  height: 1px;
  padding: 0;
  margin: -1px;
  overflow: hidden;
  clip: rect(0, 0, 0, 0);
  white-space: nowrap;
  border-width: 0;
}

.svg-inline--fa .fa-primary {
  fill: var(--fa-primary-color, currentColor);
  opacity: var(--fa-primary-opacity, 1);
}

.svg-inline--fa .fa-secondary {
  fill: var(--fa-secondary-color, currentColor);
  opacity: var(--fa-secondary-opacity, 0.4);
}

.svg-inline--fa.fa-swap-opacity .fa-primary {
  opacity: var(--fa-secondary-opacity, 0.4);
}

.svg-inline--fa.fa-swap-opacity .fa-secondary {
  opacity: var(--fa-primary-opacity, 1);
}

.svg-inline--fa mask .fa-primary,
.svg-inline--fa mask .fa-secondary {
  fill: black;
}

.fad.fa-inverse,
.fa-duotone.fa-inverse {
  color: var(--fa-inverse, #fff);
}`;
function pb() {
  var n = ab, e = lb, t = V.cssPrefix, i = V.replacementClass, r = ZT;
  if (t !== n || i !== e) {
    var s = new RegExp("\\.".concat(n, "\\-"), "g"), o = new RegExp("\\--".concat(n, "\\-"), "g"), a = new RegExp("\\.".concat(e), "g");
    r = r.replace(s, ".".concat(t, "-")).replace(o, "--".concat(t, "-")).replace(a, ".".concat(i));
  }
  return r;
}
var Dp = !1;
function ql() {
  V.autoAddCss && !Dp && (CT(pb()), Dp = !0);
}
var ET = {
  mixout: function() {
    return {
      dom: {
        css: pb,
        insertCss: ql
      }
    };
  },
  hooks: function() {
    return {
      beforeDOMElementCreation: function() {
        ql();
      },
      beforeI2svg: function() {
        ql();
      }
    };
  }
}, An = ti || {};
An[Tn] || (An[Tn] = {});
An[Tn].styles || (An[Tn].styles = {});
An[Tn].hooks || (An[Tn].hooks = {});
An[Tn].shims || (An[Tn].shims = []);
var Bt = An[Tn], mb = [], zT = function n() {
  Re.removeEventListener("DOMContentLoaded", n), Ca = 1, mb.map(function(e) {
    return e();
  });
}, Ca = !1;
zn && (Ca = (Re.documentElement.doScroll ? /^loaded|^c/ : /^loaded|^i|^c/).test(Re.readyState), Ca || Re.addEventListener("DOMContentLoaded", zT));
function DT(n) {
  zn && (Ca ? setTimeout(n, 0) : mb.push(n));
}
function Bs(n) {
  var e = n.tag, t = n.attributes, i = t === void 0 ? {} : t, r = n.children, s = r === void 0 ? [] : r;
  return typeof n == "string" ? db(n) : "<".concat(e, " ").concat(AT(i), ">").concat(s.map(Bs).join(""), "</").concat(e, ">");
}
function Ip(n, e, t) {
  if (n && n[e] && n[e][t])
    return {
      prefix: e,
      iconName: t,
      icon: n[e][t]
    };
}
var Bl = function(e, t, i, r) {
  var s = Object.keys(e), o = s.length, a = t, l, u, c;
  for (i === void 0 ? (l = 1, c = e[s[0]]) : (l = 0, c = i); l < o; l++)
    u = s[l], c = a(c, e[u], u, e);
  return c;
};
function IT(n) {
  for (var e = [], t = 0, i = n.length; t < i; ) {
    var r = n.charCodeAt(t++);
    if (r >= 55296 && r <= 56319 && t < i) {
      var s = n.charCodeAt(t++);
      (s & 64512) == 56320 ? e.push(((r & 1023) << 10) + (s & 1023) + 65536) : (e.push(r), t--);
    } else
      e.push(r);
  }
  return e;
}
function kc(n) {
  var e = IT(n);
  return e.length === 1 ? e[0].toString(16) : null;
}
function LT(n, e) {
  var t = n.length, i = n.charCodeAt(e), r;
  return i >= 55296 && i <= 56319 && t > e + 1 && (r = n.charCodeAt(e + 1), r >= 56320 && r <= 57343) ? (i - 55296) * 1024 + r - 56320 + 65536 : i;
}
function Lp(n) {
  return Object.keys(n).reduce(function(e, t) {
    var i = n[t], r = !!i.icon;
    return r ? e[i.iconName] = i.icon : e[t] = i, e;
  }, {});
}
function xc(n, e) {
  var t = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, i = t.skipHooks, r = i === void 0 ? !1 : i, s = Lp(e);
  typeof Bt.hooks.addPack == "function" && !r ? Bt.hooks.addPack(n, Lp(e)) : Bt.styles[n] = X(X({}, Bt.styles[n] || {}), s), n === "fas" && xc("fa", e);
}
var Qo, $o, Co, Wi = Bt.styles, _T = Bt.shims, XT = (Qo = {}, Be(Qo, Te, Object.values(Ss[Te])), Be(Qo, ze, Object.values(Ss[ze])), Qo), jh = null, gb = {}, Ob = {}, bb = {}, yb = {}, kb = {}, NT = ($o = {}, Be($o, Te, Object.keys(xs[Te])), Be($o, ze, Object.keys(xs[ze])), $o);
function WT(n) {
  return ~ST.indexOf(n);
}
function qT(n, e) {
  var t = e.split("-"), i = t[0], r = t.slice(1).join("-");
  return i === n && r !== "" && !WT(r) ? r : null;
}
var xb = function() {
  var e = function(s) {
    return Bl(Wi, function(o, a, l) {
      return o[l] = Bl(a, s, {}), o;
    }, {});
  };
  gb = e(function(r, s, o) {
    if (s[3] && (r[s[3]] = o), s[2]) {
      var a = s[2].filter(function(l) {
        return typeof l == "number";
      });
      a.forEach(function(l) {
        r[l.toString(16)] = o;
      });
    }
    return r;
  }), Ob = e(function(r, s, o) {
    if (r[o] = o, s[2]) {
      var a = s[2].filter(function(l) {
        return typeof l == "string";
      });
      a.forEach(function(l) {
        r[l] = o;
      });
    }
    return r;
  }), kb = e(function(r, s, o) {
    var a = s[2];
    return r[o] = o, a.forEach(function(l) {
      r[l] = o;
    }), r;
  });
  var t = "far" in Wi || V.autoFetchSvg, i = Bl(_T, function(r, s) {
    var o = s[0], a = s[1], l = s[2];
    return a === "far" && !t && (a = "fas"), typeof o == "string" && (r.names[o] = {
      prefix: a,
      iconName: l
    }), typeof o == "number" && (r.unicodes[o.toString(16)] = {
      prefix: a,
      iconName: l
    }), r;
  }, {
    names: {},
    unicodes: {}
  });
  bb = i.names, yb = i.unicodes, jh = al(V.styleDefault, {
    family: V.familyDefault
  });
};
$T(function(n) {
  jh = al(n.styleDefault, {
    family: V.familyDefault
  });
});
xb();
function Uh(n, e) {
  return (gb[n] || {})[e];
}
function BT(n, e) {
  return (Ob[n] || {})[e];
}
function yi(n, e) {
  return (kb[n] || {})[e];
}
function wb(n) {
  return bb[n] || {
    prefix: null,
    iconName: null
  };
}
function VT(n) {
  var e = yb[n], t = Uh("fas", n);
  return e || (t ? {
    prefix: "fas",
    iconName: t
  } : null) || {
    prefix: null,
    iconName: null
  };
}
function ni() {
  return jh;
}
var Fh = function() {
  return {
    prefix: null,
    iconName: null,
    rest: []
  };
};
function al(n) {
  var e = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, t = e.family, i = t === void 0 ? Te : t, r = xs[i][n], s = ws[i][n] || ws[i][r], o = n in Bt.styles ? n : null;
  return s || o || null;
}
var _p = (Co = {}, Be(Co, Te, Object.keys(Ss[Te])), Be(Co, ze, Object.keys(Ss[ze])), Co);
function ll(n) {
  var e, t = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, i = t.skipLookups, r = i === void 0 ? !1 : i, s = (e = {}, Be(e, Te, "".concat(V.cssPrefix, "-").concat(Te)), Be(e, ze, "".concat(V.cssPrefix, "-").concat(ze)), e), o = null, a = Te;
  (n.includes(s[Te]) || n.some(function(u) {
    return _p[Te].includes(u);
  })) && (a = Te), (n.includes(s[ze]) || n.some(function(u) {
    return _p[ze].includes(u);
  })) && (a = ze);
  var l = n.reduce(function(u, c) {
    var h = qT(V.cssPrefix, c);
    if (Wi[c] ? (c = XT[a].includes(c) ? OT[a][c] : c, o = c, u.prefix = c) : NT[a].indexOf(c) > -1 ? (o = c, u.prefix = al(c, {
      family: a
    })) : h ? u.iconName = h : c !== V.replacementClass && c !== s[Te] && c !== s[ze] && u.rest.push(c), !r && u.prefix && u.iconName) {
      var f = o === "fa" ? wb(u.iconName) : {}, d = yi(u.prefix, u.iconName);
      f.prefix && (o = null), u.iconName = f.iconName || d || u.iconName, u.prefix = f.prefix || u.prefix, u.prefix === "far" && !Wi.far && Wi.fas && !V.autoFetchSvg && (u.prefix = "fas");
    }
    return u;
  }, Fh());
  return (n.includes("fa-brands") || n.includes("fab")) && (l.prefix = "fab"), (n.includes("fa-duotone") || n.includes("fad")) && (l.prefix = "fad"), !l.prefix && a === ze && (Wi.fass || V.autoFetchSvg) && (l.prefix = "fass", l.iconName = yi(l.prefix, l.iconName) || l.iconName), (l.prefix === "fa" || o === "fa") && (l.prefix = ni() || "fas"), l;
}
var YT = /* @__PURE__ */ function() {
  function n() {
    rT(this, n), this.definitions = {};
  }
  return oT(n, [{
    key: "add",
    value: function() {
      for (var t = this, i = arguments.length, r = new Array(i), s = 0; s < i; s++)
        r[s] = arguments[s];
      var o = r.reduce(this._pullDefinitions, {});
      Object.keys(o).forEach(function(a) {
        t.definitions[a] = X(X({}, t.definitions[a] || {}), o[a]), xc(a, o[a]);
        var l = Ss[Te][a];
        l && xc(l, o[a]), xb();
      });
    }
  }, {
    key: "reset",
    value: function() {
      this.definitions = {};
    }
  }, {
    key: "_pullDefinitions",
    value: function(t, i) {
      var r = i.prefix && i.iconName && i.icon ? {
        0: i
      } : i;
      return Object.keys(r).map(function(s) {
        var o = r[s], a = o.prefix, l = o.iconName, u = o.icon, c = u[2];
        t[a] || (t[a] = {}), c.length > 0 && c.forEach(function(h) {
          typeof h == "string" && (t[a][h] = u);
        }), t[a][l] = u;
      }), t;
    }
  }]), n;
}(), Xp = [], qi = {}, Gi = {}, jT = Object.keys(Gi);
function UT(n, e) {
  var t = e.mixoutsTo;
  return Xp = n, qi = {}, Object.keys(Gi).forEach(function(i) {
    jT.indexOf(i) === -1 && delete Gi[i];
  }), Xp.forEach(function(i) {
    var r = i.mixout ? i.mixout() : {};
    if (Object.keys(r).forEach(function(o) {
      typeof r[o] == "function" && (t[o] = r[o]), $a(r[o]) === "object" && Object.keys(r[o]).forEach(function(a) {
        t[o] || (t[o] = {}), t[o][a] = r[o][a];
      });
    }), i.hooks) {
      var s = i.hooks();
      Object.keys(s).forEach(function(o) {
        qi[o] || (qi[o] = []), qi[o].push(s[o]);
      });
    }
    i.provides && i.provides(Gi);
  }), t;
}
function wc(n, e) {
  for (var t = arguments.length, i = new Array(t > 2 ? t - 2 : 0), r = 2; r < t; r++)
    i[r - 2] = arguments[r];
  var s = qi[n] || [];
  return s.forEach(function(o) {
    e = o.apply(null, [e].concat(i));
  }), e;
}
function $i(n) {
  for (var e = arguments.length, t = new Array(e > 1 ? e - 1 : 0), i = 1; i < e; i++)
    t[i - 1] = arguments[i];
  var r = qi[n] || [];
  r.forEach(function(s) {
    s.apply(null, t);
  });
}
function Rn() {
  var n = arguments[0], e = Array.prototype.slice.call(arguments, 1);
  return Gi[n] ? Gi[n].apply(null, e) : void 0;
}
function Sc(n) {
  n.prefix === "fa" && (n.prefix = "fas");
  var e = n.iconName, t = n.prefix || ni();
  if (e)
    return e = yi(t, e) || e, Ip(Sb.definitions, t, e) || Ip(Bt.styles, t, e);
}
var Sb = new YT(), FT = function() {
  V.autoReplaceSvg = !1, V.observeMutations = !1, $i("noAuto");
}, GT = {
  i2svg: function() {
    var e = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
    return zn ? ($i("beforeI2svg", e), Rn("pseudoElements2svg", e), Rn("i2svg", e)) : Promise.reject("Operation requires a DOM of some kind.");
  },
  watch: function() {
    var e = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, t = e.autoReplaceSvgRoot;
    V.autoReplaceSvg === !1 && (V.autoReplaceSvg = !0), V.observeMutations = !0, DT(function() {
      KT({
        autoReplaceSvgRoot: t
      }), $i("watch", e);
    });
  }
}, HT = {
  icon: function(e) {
    if (e === null)
      return null;
    if ($a(e) === "object" && e.prefix && e.iconName)
      return {
        prefix: e.prefix,
        iconName: yi(e.prefix, e.iconName) || e.iconName
      };
    if (Array.isArray(e) && e.length === 2) {
      var t = e[1].indexOf("fa-") === 0 ? e[1].slice(3) : e[1], i = al(e[0]);
      return {
        prefix: i,
        iconName: yi(i, t) || t
      };
    }
    if (typeof e == "string" && (e.indexOf("".concat(V.cssPrefix, "-")) > -1 || e.match(bT))) {
      var r = ll(e.split(" "), {
        skipLookups: !0
      });
      return {
        prefix: r.prefix || ni(),
        iconName: yi(r.prefix, r.iconName) || r.iconName
      };
    }
    if (typeof e == "string") {
      var s = ni();
      return {
        prefix: s,
        iconName: yi(s, e) || e
      };
    }
  }
}, Ct = {
  noAuto: FT,
  config: V,
  dom: GT,
  parse: HT,
  library: Sb,
  findIconDefinition: Sc,
  toHtml: Bs
}, KT = function() {
  var e = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, t = e.autoReplaceSvgRoot, i = t === void 0 ? Re : t;
  (Object.keys(Bt.styles).length > 0 || V.autoFetchSvg) && zn && V.autoReplaceSvg && Ct.dom.i2svg({
    node: i
  });
};
function ul(n, e) {
  return Object.defineProperty(n, "abstract", {
    get: e
  }), Object.defineProperty(n, "html", {
    get: function() {
      return n.abstract.map(function(i) {
        return Bs(i);
      });
    }
  }), Object.defineProperty(n, "node", {
    get: function() {
      if (zn) {
        var i = Re.createElement("div");
        return i.innerHTML = n.html, i.children;
      }
    }
  }), n;
}
function JT(n) {
  var e = n.children, t = n.main, i = n.mask, r = n.attributes, s = n.styles, o = n.transform;
  if (Yh(o) && t.found && !i.found) {
    var a = t.width, l = t.height, u = {
      x: a / l / 2,
      y: 0.5
    };
    r.style = ol(X(X({}, s), {}, {
      "transform-origin": "".concat(u.x + o.x / 16, "em ").concat(u.y + o.y / 16, "em")
    }));
  }
  return [{
    tag: "svg",
    attributes: r,
    children: e
  }];
}
function eA(n) {
  var e = n.prefix, t = n.iconName, i = n.children, r = n.attributes, s = n.symbol, o = s === !0 ? "".concat(e, "-").concat(V.cssPrefix, "-").concat(t) : s;
  return [{
    tag: "svg",
    attributes: {
      style: "display: none;"
    },
    children: [{
      tag: "symbol",
      attributes: X(X({}, r), {}, {
        id: o
      }),
      children: i
    }]
  }];
}
function Gh(n) {
  var e = n.icons, t = e.main, i = e.mask, r = n.prefix, s = n.iconName, o = n.transform, a = n.symbol, l = n.title, u = n.maskId, c = n.titleId, h = n.extra, f = n.watchable, d = f === void 0 ? !1 : f, p = i.found ? i : t, g = p.width, O = p.height, m = r === "fak", b = [V.replacementClass, s ? "".concat(V.cssPrefix, "-").concat(s) : ""].filter(function(z) {
    return h.classes.indexOf(z) === -1;
  }).filter(function(z) {
    return z !== "" || !!z;
  }).concat(h.classes).join(" "), w = {
    children: [],
    attributes: X(X({}, h.attributes), {}, {
      "data-prefix": r,
      "data-icon": s,
      class: b,
      role: h.attributes.role || "img",
      xmlns: "http://www.w3.org/2000/svg",
      viewBox: "0 0 ".concat(g, " ").concat(O)
    })
  }, Q = m && !~h.classes.indexOf("fa-fw") ? {
    width: "".concat(g / O * 16 * 0.0625, "em")
  } : {};
  d && (w.attributes[Qi] = ""), l && (w.children.push({
    tag: "title",
    attributes: {
      id: w.attributes["aria-labelledby"] || "title-".concat(c || Ps())
    },
    children: [l]
  }), delete w.attributes.title);
  var v = X(X({}, w), {}, {
    prefix: r,
    iconName: s,
    main: t,
    mask: i,
    maskId: u,
    transform: o,
    symbol: a,
    styles: X(X({}, Q), h.styles)
  }), k = i.found && t.found ? Rn("generateAbstractMask", v) || {
    children: [],
    attributes: {}
  } : Rn("generateAbstractIcon", v) || {
    children: [],
    attributes: {}
  }, C = k.children, I = k.attributes;
  return v.children = C, v.attributes = I, a ? eA(v) : JT(v);
}
function Np(n) {
  var e = n.content, t = n.width, i = n.height, r = n.transform, s = n.title, o = n.extra, a = n.watchable, l = a === void 0 ? !1 : a, u = X(X(X({}, o.attributes), s ? {
    title: s
  } : {}), {}, {
    class: o.classes.join(" ")
  });
  l && (u[Qi] = "");
  var c = X({}, o.styles);
  Yh(r) && (c.transform = MT({
    transform: r,
    startCentered: !0,
    width: t,
    height: i
  }), c["-webkit-transform"] = c.transform);
  var h = ol(c);
  h.length > 0 && (u.style = h);
  var f = [];
  return f.push({
    tag: "span",
    attributes: u,
    children: [e]
  }), s && f.push({
    tag: "span",
    attributes: {
      class: "sr-only"
    },
    children: [s]
  }), f;
}
function tA(n) {
  var e = n.content, t = n.title, i = n.extra, r = X(X(X({}, i.attributes), t ? {
    title: t
  } : {}), {}, {
    class: i.classes.join(" ")
  }), s = ol(i.styles);
  s.length > 0 && (r.style = s);
  var o = [];
  return o.push({
    tag: "span",
    attributes: r,
    children: [e]
  }), t && o.push({
    tag: "span",
    attributes: {
      class: "sr-only"
    },
    children: [t]
  }), o;
}
var Vl = Bt.styles;
function vc(n) {
  var e = n[0], t = n[1], i = n.slice(4), r = Xh(i, 1), s = r[0], o = null;
  return Array.isArray(s) ? o = {
    tag: "g",
    attributes: {
      class: "".concat(V.cssPrefix, "-").concat(bi.GROUP)
    },
    children: [{
      tag: "path",
      attributes: {
        class: "".concat(V.cssPrefix, "-").concat(bi.SECONDARY),
        fill: "currentColor",
        d: s[0]
      }
    }, {
      tag: "path",
      attributes: {
        class: "".concat(V.cssPrefix, "-").concat(bi.PRIMARY),
        fill: "currentColor",
        d: s[1]
      }
    }]
  } : o = {
    tag: "path",
    attributes: {
      fill: "currentColor",
      d: s
    }
  }, {
    found: !0,
    width: e,
    height: t,
    icon: o
  };
}
var nA = {
  found: !1,
  width: 512,
  height: 512
};
function iA(n, e) {
  !ub && !V.showMissingIcons && n && console.error('Icon with name "'.concat(n, '" and prefix "').concat(e, '" is missing.'));
}
function Pc(n, e) {
  var t = e;
  return e === "fa" && V.styleDefault !== null && (e = ni()), new Promise(function(i, r) {
    if (Rn("missingIconAbstract"), t === "fa") {
      var s = wb(n) || {};
      n = s.iconName || n, e = s.prefix || e;
    }
    if (n && e && Vl[e] && Vl[e][n]) {
      var o = Vl[e][n];
      return i(vc(o));
    }
    iA(n, e), i(X(X({}, nA), {}, {
      icon: V.showMissingIcons && n ? Rn("missingIconAbstract") || {} : {}
    }));
  });
}
var Wp = function() {
}, Qc = V.measurePerformance && ko && ko.mark && ko.measure ? ko : {
  mark: Wp,
  measure: Wp
}, qr = 'FA "6.5.2"', rA = function(e) {
  return Qc.mark("".concat(qr, " ").concat(e, " begins")), function() {
    return vb(e);
  };
}, vb = function(e) {
  Qc.mark("".concat(qr, " ").concat(e, " ends")), Qc.measure("".concat(qr, " ").concat(e), "".concat(qr, " ").concat(e, " begins"), "".concat(qr, " ").concat(e, " ends"));
}, Hh = {
  begin: rA,
  end: vb
}, Uo = function() {
};
function qp(n) {
  var e = n.getAttribute ? n.getAttribute(Qi) : null;
  return typeof e == "string";
}
function sA(n) {
  var e = n.getAttribute ? n.getAttribute(Wh) : null, t = n.getAttribute ? n.getAttribute(qh) : null;
  return e && t;
}
function oA(n) {
  return n && n.classList && n.classList.contains && n.classList.contains(V.replacementClass);
}
function aA() {
  if (V.autoReplaceSvg === !0)
    return Fo.replace;
  var n = Fo[V.autoReplaceSvg];
  return n || Fo.replace;
}
function lA(n) {
  return Re.createElementNS("http://www.w3.org/2000/svg", n);
}
function uA(n) {
  return Re.createElement(n);
}
function Pb(n) {
  var e = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, t = e.ceFn, i = t === void 0 ? n.tag === "svg" ? lA : uA : t;
  if (typeof n == "string")
    return Re.createTextNode(n);
  var r = i(n.tag);
  Object.keys(n.attributes || []).forEach(function(o) {
    r.setAttribute(o, n.attributes[o]);
  });
  var s = n.children || [];
  return s.forEach(function(o) {
    r.appendChild(Pb(o, {
      ceFn: i
    }));
  }), r;
}
function cA(n) {
  var e = " ".concat(n.outerHTML, " ");
  return e = "".concat(e, "Font Awesome fontawesome.com "), e;
}
var Fo = {
  replace: function(e) {
    var t = e[0];
    if (t.parentNode)
      if (e[1].forEach(function(r) {
        t.parentNode.insertBefore(Pb(r), t);
      }), t.getAttribute(Qi) === null && V.keepOriginalSource) {
        var i = Re.createComment(cA(t));
        t.parentNode.replaceChild(i, t);
      } else
        t.remove();
  },
  nest: function(e) {
    var t = e[0], i = e[1];
    if (~Vh(t).indexOf(V.replacementClass))
      return Fo.replace(e);
    var r = new RegExp("".concat(V.cssPrefix, "-.*"));
    if (delete i[0].attributes.id, i[0].attributes.class) {
      var s = i[0].attributes.class.split(" ").reduce(function(a, l) {
        return l === V.replacementClass || l.match(r) ? a.toSvg.push(l) : a.toNode.push(l), a;
      }, {
        toNode: [],
        toSvg: []
      });
      i[0].attributes.class = s.toSvg.join(" "), s.toNode.length === 0 ? t.removeAttribute("class") : t.setAttribute("class", s.toNode.join(" "));
    }
    var o = i.map(function(a) {
      return Bs(a);
    }).join(`
`);
    t.setAttribute(Qi, ""), t.innerHTML = o;
  }
};
function Bp(n) {
  n();
}
function Qb(n, e) {
  var t = typeof e == "function" ? e : Uo;
  if (n.length === 0)
    t();
  else {
    var i = Bp;
    V.mutateApproach === mT && (i = ti.requestAnimationFrame || Bp), i(function() {
      var r = aA(), s = Hh.begin("mutate");
      n.map(r), s(), t();
    });
  }
}
var Kh = !1;
function $b() {
  Kh = !0;
}
function $c() {
  Kh = !1;
}
var Ta = null;
function Vp(n) {
  if (Ep && V.observeMutations) {
    var e = n.treeCallback, t = e === void 0 ? Uo : e, i = n.nodeCallback, r = i === void 0 ? Uo : i, s = n.pseudoElementsCallback, o = s === void 0 ? Uo : s, a = n.observeMutationsRoot, l = a === void 0 ? Re : a;
    Ta = new Ep(function(u) {
      if (!Kh) {
        var c = ni();
        xr(u).forEach(function(h) {
          if (h.type === "childList" && h.addedNodes.length > 0 && !qp(h.addedNodes[0]) && (V.searchPseudoElements && o(h.target), t(h.target)), h.type === "attributes" && h.target.parentNode && V.searchPseudoElements && o(h.target.parentNode), h.type === "attributes" && qp(h.target) && ~wT.indexOf(h.attributeName))
            if (h.attributeName === "class" && sA(h.target)) {
              var f = ll(Vh(h.target)), d = f.prefix, p = f.iconName;
              h.target.setAttribute(Wh, d || c), p && h.target.setAttribute(qh, p);
            } else
              oA(h.target) && r(h.target);
        });
      }
    }), zn && Ta.observe(l, {
      childList: !0,
      attributes: !0,
      characterData: !0,
      subtree: !0
    });
  }
}
function hA() {
  Ta && Ta.disconnect();
}
function fA(n) {
  var e = n.getAttribute("style"), t = [];
  return e && (t = e.split(";").reduce(function(i, r) {
    var s = r.split(":"), o = s[0], a = s.slice(1);
    return o && a.length > 0 && (i[o] = a.join(":").trim()), i;
  }, {})), t;
}
function dA(n) {
  var e = n.getAttribute("data-prefix"), t = n.getAttribute("data-icon"), i = n.innerText !== void 0 ? n.innerText.trim() : "", r = ll(Vh(n));
  return r.prefix || (r.prefix = ni()), e && t && (r.prefix = e, r.iconName = t), r.iconName && r.prefix || (r.prefix && i.length > 0 && (r.iconName = BT(r.prefix, n.innerText) || Uh(r.prefix, kc(n.innerText))), !r.iconName && V.autoFetchSvg && n.firstChild && n.firstChild.nodeType === Node.TEXT_NODE && (r.iconName = n.firstChild.data)), r;
}
function pA(n) {
  var e = xr(n.attributes).reduce(function(r, s) {
    return r.name !== "class" && r.name !== "style" && (r[s.name] = s.value), r;
  }, {}), t = n.getAttribute("title"), i = n.getAttribute("data-fa-title-id");
  return V.autoA11y && (t ? e["aria-labelledby"] = "".concat(V.replacementClass, "-title-").concat(i || Ps()) : (e["aria-hidden"] = "true", e.focusable = "false")), e;
}
function mA() {
  return {
    iconName: null,
    title: null,
    titleId: null,
    prefix: null,
    transform: cn,
    symbol: !1,
    mask: {
      iconName: null,
      prefix: null,
      rest: []
    },
    maskId: null,
    extra: {
      classes: [],
      styles: {},
      attributes: {}
    }
  };
}
function Yp(n) {
  var e = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {
    styleParser: !0
  }, t = dA(n), i = t.iconName, r = t.prefix, s = t.rest, o = pA(n), a = wc("parseNodeAttributes", {}, n), l = e.styleParser ? fA(n) : [];
  return X({
    iconName: i,
    title: n.getAttribute("title"),
    titleId: n.getAttribute("data-fa-title-id"),
    prefix: r,
    transform: cn,
    mask: {
      iconName: null,
      prefix: null,
      rest: []
    },
    maskId: null,
    symbol: !1,
    extra: {
      classes: s,
      styles: l,
      attributes: o
    }
  }, a);
}
var gA = Bt.styles;
function Cb(n) {
  var e = V.autoReplaceSvg === "nest" ? Yp(n, {
    styleParser: !1
  }) : Yp(n);
  return ~e.extra.classes.indexOf(cb) ? Rn("generateLayersText", n, e) : Rn("generateSvgReplacementMutation", n, e);
}
var ii = /* @__PURE__ */ new Set();
Bh.map(function(n) {
  ii.add("fa-".concat(n));
});
Object.keys(xs[Te]).map(ii.add.bind(ii));
Object.keys(xs[ze]).map(ii.add.bind(ii));
ii = Ws(ii);
function jp(n) {
  var e = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
  if (!zn)
    return Promise.resolve();
  var t = Re.documentElement.classList, i = function(h) {
    return t.add("".concat(zp, "-").concat(h));
  }, r = function(h) {
    return t.remove("".concat(zp, "-").concat(h));
  }, s = V.autoFetchSvg ? ii : Bh.map(function(c) {
    return "fa-".concat(c);
  }).concat(Object.keys(gA));
  s.includes("fa") || s.push("fa");
  var o = [".".concat(cb, ":not([").concat(Qi, "])")].concat(s.map(function(c) {
    return ".".concat(c, ":not([").concat(Qi, "])");
  })).join(", ");
  if (o.length === 0)
    return Promise.resolve();
  var a = [];
  try {
    a = xr(n.querySelectorAll(o));
  } catch {
  }
  if (a.length > 0)
    i("pending"), r("complete");
  else
    return Promise.resolve();
  var l = Hh.begin("onTree"), u = a.reduce(function(c, h) {
    try {
      var f = Cb(h);
      f && c.push(f);
    } catch (d) {
      ub || d.name === "MissingIcon" && console.error(d);
    }
    return c;
  }, []);
  return new Promise(function(c, h) {
    Promise.all(u).then(function(f) {
      Qb(f, function() {
        i("active"), i("complete"), r("pending"), typeof e == "function" && e(), l(), c();
      });
    }).catch(function(f) {
      l(), h(f);
    });
  });
}
function OA(n) {
  var e = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
  Cb(n).then(function(t) {
    t && Qb([t], e);
  });
}
function bA(n) {
  return function(e) {
    var t = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, i = (e || {}).icon ? e : Sc(e || {}), r = t.mask;
    return r && (r = (r || {}).icon ? r : Sc(r || {})), n(i, X(X({}, t), {}, {
      mask: r
    }));
  };
}
var yA = function(e) {
  var t = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, i = t.transform, r = i === void 0 ? cn : i, s = t.symbol, o = s === void 0 ? !1 : s, a = t.mask, l = a === void 0 ? null : a, u = t.maskId, c = u === void 0 ? null : u, h = t.title, f = h === void 0 ? null : h, d = t.titleId, p = d === void 0 ? null : d, g = t.classes, O = g === void 0 ? [] : g, m = t.attributes, b = m === void 0 ? {} : m, w = t.styles, Q = w === void 0 ? {} : w;
  if (e) {
    var v = e.prefix, k = e.iconName, C = e.icon;
    return ul(X({
      type: "icon"
    }, e), function() {
      return $i("beforeDOMElementCreation", {
        iconDefinition: e,
        params: t
      }), V.autoA11y && (f ? b["aria-labelledby"] = "".concat(V.replacementClass, "-title-").concat(p || Ps()) : (b["aria-hidden"] = "true", b.focusable = "false")), Gh({
        icons: {
          main: vc(C),
          mask: l ? vc(l.icon) : {
            found: !1,
            width: null,
            height: null,
            icon: {}
          }
        },
        prefix: v,
        iconName: k,
        transform: X(X({}, cn), r),
        symbol: o,
        title: f,
        maskId: c,
        titleId: p,
        extra: {
          attributes: b,
          styles: Q,
          classes: O
        }
      });
    });
  }
}, kA = {
  mixout: function() {
    return {
      icon: bA(yA)
    };
  },
  hooks: function() {
    return {
      mutationObserverCallbacks: function(t) {
        return t.treeCallback = jp, t.nodeCallback = OA, t;
      }
    };
  },
  provides: function(e) {
    e.i2svg = function(t) {
      var i = t.node, r = i === void 0 ? Re : i, s = t.callback, o = s === void 0 ? function() {
      } : s;
      return jp(r, o);
    }, e.generateSvgReplacementMutation = function(t, i) {
      var r = i.iconName, s = i.title, o = i.titleId, a = i.prefix, l = i.transform, u = i.symbol, c = i.mask, h = i.maskId, f = i.extra;
      return new Promise(function(d, p) {
        Promise.all([Pc(r, a), c.iconName ? Pc(c.iconName, c.prefix) : Promise.resolve({
          found: !1,
          width: 512,
          height: 512,
          icon: {}
        })]).then(function(g) {
          var O = Xh(g, 2), m = O[0], b = O[1];
          d([t, Gh({
            icons: {
              main: m,
              mask: b
            },
            prefix: a,
            iconName: r,
            transform: l,
            symbol: u,
            maskId: h,
            title: s,
            titleId: o,
            extra: f,
            watchable: !0
          })]);
        }).catch(p);
      });
    }, e.generateAbstractIcon = function(t) {
      var i = t.children, r = t.attributes, s = t.main, o = t.transform, a = t.styles, l = ol(a);
      l.length > 0 && (r.style = l);
      var u;
      return Yh(o) && (u = Rn("generateAbstractTransformGrouping", {
        main: s,
        transform: o,
        containerWidth: s.width,
        iconWidth: s.width
      })), i.push(u || s.icon), {
        children: i,
        attributes: r
      };
    };
  }
}, xA = {
  mixout: function() {
    return {
      layer: function(t) {
        var i = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, r = i.classes, s = r === void 0 ? [] : r;
        return ul({
          type: "layer"
        }, function() {
          $i("beforeDOMElementCreation", {
            assembler: t,
            params: i
          });
          var o = [];
          return t(function(a) {
            Array.isArray(a) ? a.map(function(l) {
              o = o.concat(l.abstract);
            }) : o = o.concat(a.abstract);
          }), [{
            tag: "span",
            attributes: {
              class: ["".concat(V.cssPrefix, "-layers")].concat(Ws(s)).join(" ")
            },
            children: o
          }];
        });
      }
    };
  }
}, wA = {
  mixout: function() {
    return {
      counter: function(t) {
        var i = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, r = i.title, s = r === void 0 ? null : r, o = i.classes, a = o === void 0 ? [] : o, l = i.attributes, u = l === void 0 ? {} : l, c = i.styles, h = c === void 0 ? {} : c;
        return ul({
          type: "counter",
          content: t
        }, function() {
          return $i("beforeDOMElementCreation", {
            content: t,
            params: i
          }), tA({
            content: t.toString(),
            title: s,
            extra: {
              attributes: u,
              styles: h,
              classes: ["".concat(V.cssPrefix, "-layers-counter")].concat(Ws(a))
            }
          });
        });
      }
    };
  }
}, SA = {
  mixout: function() {
    return {
      text: function(t) {
        var i = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, r = i.transform, s = r === void 0 ? cn : r, o = i.title, a = o === void 0 ? null : o, l = i.classes, u = l === void 0 ? [] : l, c = i.attributes, h = c === void 0 ? {} : c, f = i.styles, d = f === void 0 ? {} : f;
        return ul({
          type: "text",
          content: t
        }, function() {
          return $i("beforeDOMElementCreation", {
            content: t,
            params: i
          }), Np({
            content: t,
            transform: X(X({}, cn), s),
            title: a,
            extra: {
              attributes: h,
              styles: d,
              classes: ["".concat(V.cssPrefix, "-layers-text")].concat(Ws(u))
            }
          });
        });
      }
    };
  },
  provides: function(e) {
    e.generateLayersText = function(t, i) {
      var r = i.title, s = i.transform, o = i.extra, a = null, l = null;
      if (ob) {
        var u = parseInt(getComputedStyle(t).fontSize, 10), c = t.getBoundingClientRect();
        a = c.width / u, l = c.height / u;
      }
      return V.autoA11y && !r && (o.attributes["aria-hidden"] = "true"), Promise.resolve([t, Np({
        content: t.innerHTML,
        width: a,
        height: l,
        transform: s,
        title: r,
        extra: o,
        watchable: !0
      })]);
    };
  }
}, vA = new RegExp('"', "ug"), Up = [1105920, 1112319];
function PA(n) {
  var e = n.replace(vA, ""), t = LT(e, 0), i = t >= Up[0] && t <= Up[1], r = e.length === 2 ? e[0] === e[1] : !1;
  return {
    value: kc(r ? e[0] : e),
    isSecondary: i || r
  };
}
function Fp(n, e) {
  var t = "".concat(pT).concat(e.replace(":", "-"));
  return new Promise(function(i, r) {
    if (n.getAttribute(t) !== null)
      return i();
    var s = xr(n.children), o = s.filter(function(C) {
      return C.getAttribute(yc) === e;
    })[0], a = ti.getComputedStyle(n, e), l = a.getPropertyValue("font-family").match(yT), u = a.getPropertyValue("font-weight"), c = a.getPropertyValue("content");
    if (o && !l)
      return n.removeChild(o), i();
    if (l && c !== "none" && c !== "") {
      var h = a.getPropertyValue("content"), f = ~["Sharp"].indexOf(l[2]) ? ze : Te, d = ~["Solid", "Regular", "Light", "Thin", "Duotone", "Brands", "Kit"].indexOf(l[2]) ? ws[f][l[2].toLowerCase()] : kT[f][u], p = PA(h), g = p.value, O = p.isSecondary, m = l[0].startsWith("FontAwesome"), b = Uh(d, g), w = b;
      if (m) {
        var Q = VT(g);
        Q.iconName && Q.prefix && (b = Q.iconName, d = Q.prefix);
      }
      if (b && !O && (!o || o.getAttribute(Wh) !== d || o.getAttribute(qh) !== w)) {
        n.setAttribute(t, w), o && n.removeChild(o);
        var v = mA(), k = v.extra;
        k.attributes[yc] = e, Pc(b, d).then(function(C) {
          var I = Gh(X(X({}, v), {}, {
            icons: {
              main: C,
              mask: Fh()
            },
            prefix: d,
            iconName: w,
            extra: k,
            watchable: !0
          })), z = Re.createElementNS("http://www.w3.org/2000/svg", "svg");
          e === "::before" ? n.insertBefore(z, n.firstChild) : n.appendChild(z), z.outerHTML = I.map(function(P) {
            return Bs(P);
          }).join(`
`), n.removeAttribute(t), i();
        }).catch(r);
      } else
        i();
    } else
      i();
  });
}
function QA(n) {
  return Promise.all([Fp(n, "::before"), Fp(n, "::after")]);
}
function $A(n) {
  return n.parentNode !== document.head && !~gT.indexOf(n.tagName.toUpperCase()) && !n.getAttribute(yc) && (!n.parentNode || n.parentNode.tagName !== "svg");
}
function Gp(n) {
  if (zn)
    return new Promise(function(e, t) {
      var i = xr(n.querySelectorAll("*")).filter($A).map(QA), r = Hh.begin("searchPseudoElements");
      $b(), Promise.all(i).then(function() {
        r(), $c(), e();
      }).catch(function() {
        r(), $c(), t();
      });
    });
}
var CA = {
  hooks: function() {
    return {
      mutationObserverCallbacks: function(t) {
        return t.pseudoElementsCallback = Gp, t;
      }
    };
  },
  provides: function(e) {
    e.pseudoElements2svg = function(t) {
      var i = t.node, r = i === void 0 ? Re : i;
      V.searchPseudoElements && Gp(r);
    };
  }
}, Hp = !1, TA = {
  mixout: function() {
    return {
      dom: {
        unwatch: function() {
          $b(), Hp = !0;
        }
      }
    };
  },
  hooks: function() {
    return {
      bootstrap: function() {
        Vp(wc("mutationObserverCallbacks", {}));
      },
      noAuto: function() {
        hA();
      },
      watch: function(t) {
        var i = t.observeMutationsRoot;
        Hp ? $c() : Vp(wc("mutationObserverCallbacks", {
          observeMutationsRoot: i
        }));
      }
    };
  }
}, Kp = function(e) {
  var t = {
    size: 16,
    x: 0,
    y: 0,
    flipX: !1,
    flipY: !1,
    rotate: 0
  };
  return e.toLowerCase().split(" ").reduce(function(i, r) {
    var s = r.toLowerCase().split("-"), o = s[0], a = s.slice(1).join("-");
    if (o && a === "h")
      return i.flipX = !0, i;
    if (o && a === "v")
      return i.flipY = !0, i;
    if (a = parseFloat(a), isNaN(a))
      return i;
    switch (o) {
      case "grow":
        i.size = i.size + a;
        break;
      case "shrink":
        i.size = i.size - a;
        break;
      case "left":
        i.x = i.x - a;
        break;
      case "right":
        i.x = i.x + a;
        break;
      case "up":
        i.y = i.y - a;
        break;
      case "down":
        i.y = i.y + a;
        break;
      case "rotate":
        i.rotate = i.rotate + a;
        break;
    }
    return i;
  }, t);
}, AA = {
  mixout: function() {
    return {
      parse: {
        transform: function(t) {
          return Kp(t);
        }
      }
    };
  },
  hooks: function() {
    return {
      parseNodeAttributes: function(t, i) {
        var r = i.getAttribute("data-fa-transform");
        return r && (t.transform = Kp(r)), t;
      }
    };
  },
  provides: function(e) {
    e.generateAbstractTransformGrouping = function(t) {
      var i = t.main, r = t.transform, s = t.containerWidth, o = t.iconWidth, a = {
        transform: "translate(".concat(s / 2, " 256)")
      }, l = "translate(".concat(r.x * 32, ", ").concat(r.y * 32, ") "), u = "scale(".concat(r.size / 16 * (r.flipX ? -1 : 1), ", ").concat(r.size / 16 * (r.flipY ? -1 : 1), ") "), c = "rotate(".concat(r.rotate, " 0 0)"), h = {
        transform: "".concat(l, " ").concat(u, " ").concat(c)
      }, f = {
        transform: "translate(".concat(o / 2 * -1, " -256)")
      }, d = {
        outer: a,
        inner: h,
        path: f
      };
      return {
        tag: "g",
        attributes: X({}, d.outer),
        children: [{
          tag: "g",
          attributes: X({}, d.inner),
          children: [{
            tag: i.icon.tag,
            children: i.icon.children,
            attributes: X(X({}, i.icon.attributes), d.path)
          }]
        }]
      };
    };
  }
}, Yl = {
  x: 0,
  y: 0,
  width: "100%",
  height: "100%"
};
function Jp(n) {
  var e = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : !0;
  return n.attributes && (n.attributes.fill || e) && (n.attributes.fill = "black"), n;
}
function RA(n) {
  return n.tag === "g" ? n.children : [n];
}
var MA = {
  hooks: function() {
    return {
      parseNodeAttributes: function(t, i) {
        var r = i.getAttribute("data-fa-mask"), s = r ? ll(r.split(" ").map(function(o) {
          return o.trim();
        })) : Fh();
        return s.prefix || (s.prefix = ni()), t.mask = s, t.maskId = i.getAttribute("data-fa-mask-id"), t;
      }
    };
  },
  provides: function(e) {
    e.generateAbstractMask = function(t) {
      var i = t.children, r = t.attributes, s = t.main, o = t.mask, a = t.maskId, l = t.transform, u = s.width, c = s.icon, h = o.width, f = o.icon, d = RT({
        transform: l,
        containerWidth: h,
        iconWidth: u
      }), p = {
        tag: "rect",
        attributes: X(X({}, Yl), {}, {
          fill: "white"
        })
      }, g = c.children ? {
        children: c.children.map(Jp)
      } : {}, O = {
        tag: "g",
        attributes: X({}, d.inner),
        children: [Jp(X({
          tag: c.tag,
          attributes: X(X({}, c.attributes), d.path)
        }, g))]
      }, m = {
        tag: "g",
        attributes: X({}, d.outer),
        children: [O]
      }, b = "mask-".concat(a || Ps()), w = "clip-".concat(a || Ps()), Q = {
        tag: "mask",
        attributes: X(X({}, Yl), {}, {
          id: b,
          maskUnits: "userSpaceOnUse",
          maskContentUnits: "userSpaceOnUse"
        }),
        children: [p, m]
      }, v = {
        tag: "defs",
        children: [{
          tag: "clipPath",
          attributes: {
            id: w
          },
          children: RA(f)
        }, Q]
      };
      return i.push(v, {
        tag: "rect",
        attributes: X({
          fill: "currentColor",
          "clip-path": "url(#".concat(w, ")"),
          mask: "url(#".concat(b, ")")
        }, Yl)
      }), {
        children: i,
        attributes: r
      };
    };
  }
}, ZA = {
  provides: function(e) {
    var t = !1;
    ti.matchMedia && (t = ti.matchMedia("(prefers-reduced-motion: reduce)").matches), e.missingIconAbstract = function() {
      var i = [], r = {
        fill: "currentColor"
      }, s = {
        attributeType: "XML",
        repeatCount: "indefinite",
        dur: "2s"
      };
      i.push({
        tag: "path",
        attributes: X(X({}, r), {}, {
          d: "M156.5,447.7l-12.6,29.5c-18.7-9.5-35.9-21.2-51.5-34.9l22.7-22.7C127.6,430.5,141.5,440,156.5,447.7z M40.6,272H8.5 c1.4,21.2,5.4,41.7,11.7,61.1L50,321.2C45.1,305.5,41.8,289,40.6,272z M40.6,240c1.4-18.8,5.2-37,11.1-54.1l-29.5-12.6 C14.7,194.3,10,216.7,8.5,240H40.6z M64.3,156.5c7.8-14.9,17.2-28.8,28.1-41.5L69.7,92.3c-13.7,15.6-25.5,32.8-34.9,51.5 L64.3,156.5z M397,419.6c-13.9,12-29.4,22.3-46.1,30.4l11.9,29.8c20.7-9.9,39.8-22.6,56.9-37.6L397,419.6z M115,92.4 c13.9-12,29.4-22.3,46.1-30.4l-11.9-29.8c-20.7,9.9-39.8,22.6-56.8,37.6L115,92.4z M447.7,355.5c-7.8,14.9-17.2,28.8-28.1,41.5 l22.7,22.7c13.7-15.6,25.5-32.9,34.9-51.5L447.7,355.5z M471.4,272c-1.4,18.8-5.2,37-11.1,54.1l29.5,12.6 c7.5-21.1,12.2-43.5,13.6-66.8H471.4z M321.2,462c-15.7,5-32.2,8.2-49.2,9.4v32.1c21.2-1.4,41.7-5.4,61.1-11.7L321.2,462z M240,471.4c-18.8-1.4-37-5.2-54.1-11.1l-12.6,29.5c21.1,7.5,43.5,12.2,66.8,13.6V471.4z M462,190.8c5,15.7,8.2,32.2,9.4,49.2h32.1 c-1.4-21.2-5.4-41.7-11.7-61.1L462,190.8z M92.4,397c-12-13.9-22.3-29.4-30.4-46.1l-29.8,11.9c9.9,20.7,22.6,39.8,37.6,56.9 L92.4,397z M272,40.6c18.8,1.4,36.9,5.2,54.1,11.1l12.6-29.5C317.7,14.7,295.3,10,272,8.5V40.6z M190.8,50 c15.7-5,32.2-8.2,49.2-9.4V8.5c-21.2,1.4-41.7,5.4-61.1,11.7L190.8,50z M442.3,92.3L419.6,115c12,13.9,22.3,29.4,30.5,46.1 l29.8-11.9C470,128.5,457.3,109.4,442.3,92.3z M397,92.4l22.7-22.7c-15.6-13.7-32.8-25.5-51.5-34.9l-12.6,29.5 C370.4,72.1,384.4,81.5,397,92.4z"
        })
      });
      var o = X(X({}, s), {}, {
        attributeName: "opacity"
      }), a = {
        tag: "circle",
        attributes: X(X({}, r), {}, {
          cx: "256",
          cy: "364",
          r: "28"
        }),
        children: []
      };
      return t || a.children.push({
        tag: "animate",
        attributes: X(X({}, s), {}, {
          attributeName: "r",
          values: "28;14;28;28;14;28;"
        })
      }, {
        tag: "animate",
        attributes: X(X({}, o), {}, {
          values: "1;0;1;1;0;1;"
        })
      }), i.push(a), i.push({
        tag: "path",
        attributes: X(X({}, r), {}, {
          opacity: "1",
          d: "M263.7,312h-16c-6.6,0-12-5.4-12-12c0-71,77.4-63.9,77.4-107.8c0-20-17.8-40.2-57.4-40.2c-29.1,0-44.3,9.6-59.2,28.7 c-3.9,5-11.1,6-16.2,2.4l-13.1-9.2c-5.6-3.9-6.9-11.8-2.6-17.2c21.2-27.2,46.4-44.7,91.2-44.7c52.3,0,97.4,29.8,97.4,80.2 c0,67.6-77.4,63.5-77.4,107.8C275.7,306.6,270.3,312,263.7,312z"
        }),
        children: t ? [] : [{
          tag: "animate",
          attributes: X(X({}, o), {}, {
            values: "1;0;0;0;0;1;"
          })
        }]
      }), t || i.push({
        tag: "path",
        attributes: X(X({}, r), {}, {
          opacity: "0",
          d: "M232.5,134.5l7,168c0.3,6.4,5.6,11.5,12,11.5h9c6.4,0,11.7-5.1,12-11.5l7-168c0.3-6.8-5.2-12.5-12-12.5h-23 C237.7,122,232.2,127.7,232.5,134.5z"
        }),
        children: [{
          tag: "animate",
          attributes: X(X({}, o), {}, {
            values: "0;0;1;1;0;0;"
          })
        }]
      }), {
        tag: "g",
        attributes: {
          class: "missing"
        },
        children: i
      };
    };
  }
}, EA = {
  hooks: function() {
    return {
      parseNodeAttributes: function(t, i) {
        var r = i.getAttribute("data-fa-symbol"), s = r === null ? !1 : r === "" ? !0 : r;
        return t.symbol = s, t;
      }
    };
  }
}, zA = [ET, kA, xA, wA, SA, CA, TA, AA, MA, ZA, EA];
UT(zA, {
  mixoutsTo: Ct
});
Ct.noAuto;
var Tb = Ct.config;
Ct.library;
Ct.dom;
var Aa = Ct.parse;
Ct.findIconDefinition;
Ct.toHtml;
var DA = Ct.icon;
Ct.layer;
var IA = Ct.text;
Ct.counter;
function em(n, e) {
  var t = Object.keys(n);
  if (Object.getOwnPropertySymbols) {
    var i = Object.getOwnPropertySymbols(n);
    e && (i = i.filter(function(r) {
      return Object.getOwnPropertyDescriptor(n, r).enumerable;
    })), t.push.apply(t, i);
  }
  return t;
}
function qt(n) {
  for (var e = 1; e < arguments.length; e++) {
    var t = arguments[e] != null ? arguments[e] : {};
    e % 2 ? em(Object(t), !0).forEach(function(i) {
      ct(n, i, t[i]);
    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(n, Object.getOwnPropertyDescriptors(t)) : em(Object(t)).forEach(function(i) {
      Object.defineProperty(n, i, Object.getOwnPropertyDescriptor(t, i));
    });
  }
  return n;
}
function LA(n, e) {
  if (typeof n != "object" || !n)
    return n;
  var t = n[Symbol.toPrimitive];
  if (t !== void 0) {
    var i = t.call(n, e || "default");
    if (typeof i != "object")
      return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return (e === "string" ? String : Number)(n);
}
function _A(n) {
  var e = LA(n, "string");
  return typeof e == "symbol" ? e : e + "";
}
function Ra(n) {
  "@babel/helpers - typeof";
  return Ra = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(e) {
    return typeof e;
  } : function(e) {
    return e && typeof Symbol == "function" && e.constructor === Symbol && e !== Symbol.prototype ? "symbol" : typeof e;
  }, Ra(n);
}
function ct(n, e, t) {
  return e = _A(e), e in n ? Object.defineProperty(n, e, {
    value: t,
    enumerable: !0,
    configurable: !0,
    writable: !0
  }) : n[e] = t, n;
}
function XA(n, e) {
  if (n == null)
    return {};
  var t = {};
  for (var i in n)
    if (Object.prototype.hasOwnProperty.call(n, i)) {
      if (e.indexOf(i) >= 0)
        continue;
      t[i] = n[i];
    }
  return t;
}
function NA(n, e) {
  if (n == null)
    return {};
  var t = XA(n, e), i, r;
  if (Object.getOwnPropertySymbols) {
    var s = Object.getOwnPropertySymbols(n);
    for (r = 0; r < s.length; r++)
      i = s[r], !(e.indexOf(i) >= 0) && Object.prototype.propertyIsEnumerable.call(n, i) && (t[i] = n[i]);
  }
  return t;
}
function Cc(n) {
  return WA(n) || qA(n) || BA(n) || VA();
}
function WA(n) {
  if (Array.isArray(n))
    return Tc(n);
}
function qA(n) {
  if (typeof Symbol < "u" && n[Symbol.iterator] != null || n["@@iterator"] != null)
    return Array.from(n);
}
function BA(n, e) {
  if (n) {
    if (typeof n == "string")
      return Tc(n, e);
    var t = Object.prototype.toString.call(n).slice(8, -1);
    if (t === "Object" && n.constructor && (t = n.constructor.name), t === "Map" || t === "Set")
      return Array.from(n);
    if (t === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t))
      return Tc(n, e);
  }
}
function Tc(n, e) {
  (e == null || e > n.length) && (e = n.length);
  for (var t = 0, i = new Array(e); t < e; t++)
    i[t] = n[t];
  return i;
}
function VA() {
  throw new TypeError(`Invalid attempt to spread non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
}
var YA = typeof globalThis < "u" ? globalThis : typeof window < "u" ? window : typeof global < "u" ? global : typeof self < "u" ? self : {}, Ab = { exports: {} };
(function(n) {
  (function(e) {
    var t = function(m, b, w) {
      if (!u(b) || h(b) || f(b) || d(b) || l(b))
        return b;
      var Q, v = 0, k = 0;
      if (c(b))
        for (Q = [], k = b.length; v < k; v++)
          Q.push(t(m, b[v], w));
      else {
        Q = {};
        for (var C in b)
          Object.prototype.hasOwnProperty.call(b, C) && (Q[m(C, w)] = t(m, b[C], w));
      }
      return Q;
    }, i = function(m, b) {
      b = b || {};
      var w = b.separator || "_", Q = b.split || /(?=[A-Z])/;
      return m.split(Q).join(w);
    }, r = function(m) {
      return p(m) ? m : (m = m.replace(/[\-_\s]+(.)?/g, function(b, w) {
        return w ? w.toUpperCase() : "";
      }), m.substr(0, 1).toLowerCase() + m.substr(1));
    }, s = function(m) {
      var b = r(m);
      return b.substr(0, 1).toUpperCase() + b.substr(1);
    }, o = function(m, b) {
      return i(m, b).toLowerCase();
    }, a = Object.prototype.toString, l = function(m) {
      return typeof m == "function";
    }, u = function(m) {
      return m === Object(m);
    }, c = function(m) {
      return a.call(m) == "[object Array]";
    }, h = function(m) {
      return a.call(m) == "[object Date]";
    }, f = function(m) {
      return a.call(m) == "[object RegExp]";
    }, d = function(m) {
      return a.call(m) == "[object Boolean]";
    }, p = function(m) {
      return m = m - 0, m === m;
    }, g = function(m, b) {
      var w = b && "process" in b ? b.process : b;
      return typeof w != "function" ? m : function(Q, v) {
        return w(Q, m, v);
      };
    }, O = {
      camelize: r,
      decamelize: o,
      pascalize: s,
      depascalize: o,
      camelizeKeys: function(m, b) {
        return t(g(r, b), m);
      },
      decamelizeKeys: function(m, b) {
        return t(g(o, b), m, b);
      },
      pascalizeKeys: function(m, b) {
        return t(g(s, b), m);
      },
      depascalizeKeys: function() {
        return this.decamelizeKeys.apply(this, arguments);
      }
    };
    n.exports ? n.exports = O : e.humps = O;
  })(YA);
})(Ab);
var jA = Ab.exports, UA = ["class", "style"];
function FA(n) {
  return n.split(";").map(function(e) {
    return e.trim();
  }).filter(function(e) {
    return e;
  }).reduce(function(e, t) {
    var i = t.indexOf(":"), r = jA.camelize(t.slice(0, i)), s = t.slice(i + 1).trim();
    return e[r] = s, e;
  }, {});
}
function GA(n) {
  return n.split(/\s+/).reduce(function(e, t) {
    return e[t] = !0, e;
  }, {});
}
function Jh(n) {
  var e = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, t = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {};
  if (typeof n == "string")
    return n;
  var i = (n.children || []).map(function(l) {
    return Jh(l);
  }), r = Object.keys(n.attributes || {}).reduce(function(l, u) {
    var c = n.attributes[u];
    switch (u) {
      case "class":
        l.class = GA(c);
        break;
      case "style":
        l.style = FA(c);
        break;
      default:
        l.attrs[u] = c;
    }
    return l;
  }, {
    attrs: {},
    class: {},
    style: {}
  });
  t.class;
  var s = t.style, o = s === void 0 ? {} : s, a = NA(t, UA);
  return Gc(n.tag, qt(qt(qt({}, e), {}, {
    class: r.class,
    style: qt(qt({}, r.style), o)
  }, r.attrs), a), i);
}
var Rb = !1;
try {
  Rb = process.env.NODE_ENV === "production";
} catch {
}
function HA() {
  if (!Rb && console && typeof console.error == "function") {
    var n;
    (n = console).error.apply(n, arguments);
  }
}
function Jr(n, e) {
  return Array.isArray(e) && e.length > 0 || !Array.isArray(e) && e ? ct({}, n, e) : {};
}
function KA(n) {
  var e, t = (e = {
    "fa-spin": n.spin,
    "fa-pulse": n.pulse,
    "fa-fw": n.fixedWidth,
    "fa-border": n.border,
    "fa-li": n.listItem,
    "fa-inverse": n.inverse,
    "fa-flip": n.flip === !0,
    "fa-flip-horizontal": n.flip === "horizontal" || n.flip === "both",
    "fa-flip-vertical": n.flip === "vertical" || n.flip === "both"
  }, ct(ct(ct(ct(ct(ct(ct(ct(ct(ct(e, "fa-".concat(n.size), n.size !== null), "fa-rotate-".concat(n.rotation), n.rotation !== null), "fa-pull-".concat(n.pull), n.pull !== null), "fa-swap-opacity", n.swapOpacity), "fa-bounce", n.bounce), "fa-shake", n.shake), "fa-beat", n.beat), "fa-fade", n.fade), "fa-beat-fade", n.beatFade), "fa-flash", n.flash), ct(ct(e, "fa-spin-pulse", n.spinPulse), "fa-spin-reverse", n.spinReverse));
  return Object.keys(t).map(function(i) {
    return t[i] ? i : null;
  }).filter(function(i) {
    return i;
  });
}
function tm(n) {
  if (n && Ra(n) === "object" && n.prefix && n.iconName && n.icon)
    return n;
  if (Aa.icon)
    return Aa.icon(n);
  if (n === null)
    return null;
  if (Ra(n) === "object" && n.prefix && n.iconName)
    return n;
  if (Array.isArray(n) && n.length === 2)
    return {
      prefix: n[0],
      iconName: n[1]
    };
  if (typeof n == "string")
    return {
      prefix: "fas",
      iconName: n
    };
}
var Ac = bt({
  name: "FontAwesomeIcon",
  props: {
    border: {
      type: Boolean,
      default: !1
    },
    fixedWidth: {
      type: Boolean,
      default: !1
    },
    flip: {
      type: [Boolean, String],
      default: !1,
      validator: function(e) {
        return [!0, !1, "horizontal", "vertical", "both"].indexOf(e) > -1;
      }
    },
    icon: {
      type: [Object, Array, String],
      required: !0
    },
    mask: {
      type: [Object, Array, String],
      default: null
    },
    maskId: {
      type: String,
      default: null
    },
    listItem: {
      type: Boolean,
      default: !1
    },
    pull: {
      type: String,
      default: null,
      validator: function(e) {
        return ["right", "left"].indexOf(e) > -1;
      }
    },
    pulse: {
      type: Boolean,
      default: !1
    },
    rotation: {
      type: [String, Number],
      default: null,
      validator: function(e) {
        return [90, 180, 270].indexOf(Number.parseInt(e, 10)) > -1;
      }
    },
    swapOpacity: {
      type: Boolean,
      default: !1
    },
    size: {
      type: String,
      default: null,
      validator: function(e) {
        return ["2xs", "xs", "sm", "lg", "xl", "2xl", "1x", "2x", "3x", "4x", "5x", "6x", "7x", "8x", "9x", "10x"].indexOf(e) > -1;
      }
    },
    spin: {
      type: Boolean,
      default: !1
    },
    transform: {
      type: [String, Object],
      default: null
    },
    symbol: {
      type: [Boolean, String],
      default: !1
    },
    title: {
      type: String,
      default: null
    },
    titleId: {
      type: String,
      default: null
    },
    inverse: {
      type: Boolean,
      default: !1
    },
    bounce: {
      type: Boolean,
      default: !1
    },
    shake: {
      type: Boolean,
      default: !1
    },
    beat: {
      type: Boolean,
      default: !1
    },
    fade: {
      type: Boolean,
      default: !1
    },
    beatFade: {
      type: Boolean,
      default: !1
    },
    flash: {
      type: Boolean,
      default: !1
    },
    spinPulse: {
      type: Boolean,
      default: !1
    },
    spinReverse: {
      type: Boolean,
      default: !1
    }
  },
  setup: function(e, t) {
    var i = t.attrs, r = Qt(function() {
      return tm(e.icon);
    }), s = Qt(function() {
      return Jr("classes", KA(e));
    }), o = Qt(function() {
      return Jr("transform", typeof e.transform == "string" ? Aa.transform(e.transform) : e.transform);
    }), a = Qt(function() {
      return Jr("mask", tm(e.mask));
    }), l = Qt(function() {
      return DA(r.value, qt(qt(qt(qt({}, s.value), o.value), a.value), {}, {
        symbol: e.symbol,
        title: e.title,
        titleId: e.titleId,
        maskId: e.maskId
      }));
    });
    ft(l, function(c) {
      if (!c)
        return HA("Could not find one or more icon(s)", r.value, a.value);
    }, {
      immediate: !0
    });
    var u = Qt(function() {
      return l.value ? Jh(l.value.abstract[0], {}, i) : null;
    });
    return function() {
      return u.value;
    };
  }
});
bt({
  name: "FontAwesomeLayers",
  props: {
    fixedWidth: {
      type: Boolean,
      default: !1
    }
  },
  setup: function(e, t) {
    var i = t.slots, r = Tb.familyPrefix, s = Qt(function() {
      return ["".concat(r, "-layers")].concat(Cc(e.fixedWidth ? ["".concat(r, "-fw")] : []));
    });
    return function() {
      return Gc("div", {
        class: s.value
      }, i.default ? i.default() : []);
    };
  }
});
bt({
  name: "FontAwesomeLayersText",
  props: {
    value: {
      type: [String, Number],
      default: ""
    },
    transform: {
      type: [String, Object],
      default: null
    },
    counter: {
      type: Boolean,
      default: !1
    },
    position: {
      type: String,
      default: null,
      validator: function(e) {
        return ["bottom-left", "bottom-right", "top-left", "top-right"].indexOf(e) > -1;
      }
    }
  },
  setup: function(e, t) {
    var i = t.attrs, r = Tb.familyPrefix, s = Qt(function() {
      return Jr("classes", [].concat(Cc(e.counter ? ["".concat(r, "-layers-counter")] : []), Cc(e.position ? ["".concat(r, "-layers-").concat(e.position)] : [])));
    }), o = Qt(function() {
      return Jr("transform", typeof e.transform == "string" ? Aa.transform(e.transform) : e.transform);
    }), a = Qt(function() {
      var u = IA(e.value.toString(), qt(qt({}, o.value), s.value)), c = u.abstract;
      return e.counter && (c[0].attributes.class = c[0].attributes.class.replace("fa-layers-text", "")), c[0];
    }), l = Qt(function() {
      return Jh(a.value, {}, i);
    });
    return function() {
      return l.value;
    };
  }
});
var JA = {
  prefix: "fas",
  iconName: "message",
  icon: [512, 512, ["comment-alt"], "f27a", "M64 0C28.7 0 0 28.7 0 64V352c0 35.3 28.7 64 64 64h96v80c0 6.1 3.4 11.6 8.8 14.3s11.9 2.1 16.8-1.5L309.3 416H448c35.3 0 64-28.7 64-64V64c0-35.3-28.7-64-64-64H64z"]
}, e4 = {
  prefix: "fas",
  iconName: "info",
  icon: [192, 512, [], "f129", "M48 80a48 48 0 1 1 96 0A48 48 0 1 1 48 80zM0 224c0-17.7 14.3-32 32-32H96c17.7 0 32 14.3 32 32V448h32c17.7 0 32 14.3 32 32s-14.3 32-32 32H32c-17.7 0-32-14.3-32-32s14.3-32 32-32H64V256H32c-17.7 0-32-14.3-32-32z"]
}, t4 = {
  prefix: "fas",
  iconName: "arrows-up-to-line",
  icon: [576, 512, [], "e4c2", "M32 96l512 0c17.7 0 32-14.3 32-32s-14.3-32-32-32L32 32C14.3 32 0 46.3 0 64S14.3 96 32 96zM9.4 233.4c-12.5 12.5-12.5 32.8 0 45.3s32.8 12.5 45.3 0L96 237.3 96 448c0 17.7 14.3 32 32 32s32-14.3 32-32l0-210.7 41.4 41.4c12.5 12.5 32.8 12.5 45.3 0s12.5-32.8 0-45.3l-96-96c-12.5-12.5-32.8-12.5-45.3 0l-96 96zm320 45.3c12.5 12.5 32.8 12.5 45.3 0L416 237.3 416 448c0 17.7 14.3 32 32 32s32-14.3 32-32l0-210.7 41.4 41.4c12.5 12.5 32.8 12.5 45.3 0s12.5-32.8 0-45.3l-96-96c-12.5-12.5-32.8-12.5-45.3 0l-96 96c-12.5 12.5-12.5 32.8 0 45.3z"]
}, n4 = {
  prefix: "fas",
  iconName: "strikethrough",
  icon: [512, 512, [], "f0cc", "M161.3 144c3.2-17.2 14-30.1 33.7-38.6c21.1-9 51.8-12.3 88.6-6.5c11.9 1.9 48.8 9.1 60.1 12c17.1 4.5 34.6-5.6 39.2-22.7s-5.6-34.6-22.7-39.2c-14.3-3.8-53.6-11.4-66.6-13.4c-44.7-7-88.3-4.2-123.7 10.9c-36.5 15.6-64.4 44.8-71.8 87.3c-.1 .6-.2 1.1-.2 1.7c-2.8 23.9 .5 45.6 10.1 64.6c4.5 9 10.2 16.9 16.7 23.9H32c-17.7 0-32 14.3-32 32s14.3 32 32 32H480c17.7 0 32-14.3 32-32s-14.3-32-32-32H270.1c-.1 0-.3-.1-.4-.1l-1.1-.3c-36-10.8-65.2-19.6-85.2-33.1c-9.3-6.3-15-12.6-18.2-19.1c-3.1-6.1-5.2-14.6-3.8-27.4zM348.9 337.2c2.7 6.5 4.4 15.8 1.9 30.1c-3 17.6-13.8 30.8-33.9 39.4c-21.1 9-51.7 12.3-88.5 6.5c-18-2.9-49.1-13.5-74.4-22.1c-5.6-1.9-11-3.7-15.9-5.4c-16.8-5.6-34.9 3.5-40.5 20.3s3.5 34.9 20.3 40.5c3.6 1.2 7.9 2.7 12.7 4.3l0 0 0 0c24.9 8.5 63.6 21.7 87.6 25.6l0 0 .2 0c44.7 7 88.3 4.2 123.7-10.9c36.5-15.6 64.4-44.8 71.8-87.3c3.6-21 2.7-40.4-3.1-58.1H335.1c7 5.6 11.4 11.2 13.9 17.2z"]
}, i4 = {
  prefix: "fas",
  iconName: "table",
  icon: [512, 512, [], "f0ce", "M64 256V160H224v96H64zm0 64H224v96H64V320zm224 96V320H448v96H288zM448 256H288V160H448v96zM64 32C28.7 32 0 60.7 0 96V416c0 35.3 28.7 64 64 64H448c35.3 0 64-28.7 64-64V96c0-35.3-28.7-64-64-64H64z"]
}, r4 = {
  prefix: "fas",
  iconName: "maximize",
  icon: [512, 512, ["expand-arrows-alt"], "f31e", "M200 32H56C42.7 32 32 42.7 32 56V200c0 9.7 5.8 18.5 14.8 22.2s19.3 1.7 26.2-5.2l40-40 79 79-79 79L73 295c-6.9-6.9-17.2-8.9-26.2-5.2S32 302.3 32 312V456c0 13.3 10.7 24 24 24H200c9.7 0 18.5-5.8 22.2-14.8s1.7-19.3-5.2-26.2l-40-40 79-79 79 79-40 40c-6.9 6.9-8.9 17.2-5.2 26.2s12.5 14.8 22.2 14.8H456c13.3 0 24-10.7 24-24V312c0-9.7-5.8-18.5-14.8-22.2s-19.3-1.7-26.2 5.2l-40 40-79-79 79-79 40 40c6.9 6.9 17.2 8.9 26.2 5.2s14.8-12.5 14.8-22.2V56c0-13.3-10.7-24-24-24H312c-9.7 0-18.5 5.8-22.2 14.8s-1.7 19.3 5.2 26.2l40 40-79 79-79-79 40-40c6.9-6.9 8.9-17.2 5.2-26.2S209.7 32 200 32z"]
}, s4 = {
  prefix: "fas",
  iconName: "bold",
  icon: [384, 512, [], "f032", "M0 64C0 46.3 14.3 32 32 32H80 96 224c70.7 0 128 57.3 128 128c0 31.3-11.3 60.1-30 82.3c37.1 22.4 62 63.1 62 109.7c0 70.7-57.3 128-128 128H96 80 32c-17.7 0-32-14.3-32-32s14.3-32 32-32H48V256 96H32C14.3 96 0 81.7 0 64zM224 224c35.3 0 64-28.7 64-64s-28.7-64-64-64H112V224H224zM112 288V416H256c35.3 0 64-28.7 64-64s-28.7-64-64-64H224 112z"]
}, o4 = {
  prefix: "fas",
  iconName: "image",
  icon: [512, 512, [], "f03e", "M0 96C0 60.7 28.7 32 64 32H448c35.3 0 64 28.7 64 64V416c0 35.3-28.7 64-64 64H64c-35.3 0-64-28.7-64-64V96zM323.8 202.5c-4.5-6.6-11.9-10.5-19.8-10.5s-15.4 3.9-19.8 10.5l-87 127.6L170.7 297c-4.6-5.7-11.5-9-18.7-9s-14.2 3.3-18.7 9l-64 80c-5.8 7.2-6.9 17.1-2.9 25.4s12.4 13.6 21.6 13.6h96 32H424c8.9 0 17.1-4.9 21.2-12.8s3.6-17.4-1.4-24.7l-120-176zM112 192a48 48 0 1 0 0-96 48 48 0 1 0 0 96z"]
}, a4 = {
  prefix: "fas",
  iconName: "italic",
  icon: [384, 512, [], "f033", "M128 64c0-17.7 14.3-32 32-32H352c17.7 0 32 14.3 32 32s-14.3 32-32 32H293.3L160 416h64c17.7 0 32 14.3 32 32s-14.3 32-32 32H32c-17.7 0-32-14.3-32-32s14.3-32 32-32H90.7L224 96H160c-17.7 0-32-14.3-32-32z"]
}, l4 = {
  prefix: "fas",
  iconName: "list-ol",
  icon: [512, 512, ["list-1-2", "list-numeric"], "f0cb", "M24 56c0-13.3 10.7-24 24-24H80c13.3 0 24 10.7 24 24V176h16c13.3 0 24 10.7 24 24s-10.7 24-24 24H40c-13.3 0-24-10.7-24-24s10.7-24 24-24H56V80H48C34.7 80 24 69.3 24 56zM86.7 341.2c-6.5-7.4-18.3-6.9-24 1.2L51.5 357.9c-7.7 10.8-22.7 13.3-33.5 5.6s-13.3-22.7-5.6-33.5l11.1-15.6c23.7-33.2 72.3-35.6 99.2-4.9c21.3 24.4 20.8 60.9-1.1 84.7L86.8 432H120c13.3 0 24 10.7 24 24s-10.7 24-24 24H32c-9.5 0-18.2-5.6-22-14.4s-2.1-18.9 4.3-25.9l72-78c5.3-5.8 5.4-14.6 .3-20.5zM224 64H480c17.7 0 32 14.3 32 32s-14.3 32-32 32H224c-17.7 0-32-14.3-32-32s14.3-32 32-32zm0 160H480c17.7 0 32 14.3 32 32s-14.3 32-32 32H224c-17.7 0-32-14.3-32-32s14.3-32 32-32zm0 160H480c17.7 0 32 14.3 32 32s-14.3 32-32 32H224c-17.7 0-32-14.3-32-32s14.3-32 32-32z"]
}, u4 = {
  prefix: "fas",
  iconName: "question",
  icon: [320, 512, [10067, 10068, 61736], "3f", "M80 160c0-35.3 28.7-64 64-64h32c35.3 0 64 28.7 64 64v3.6c0 21.8-11.1 42.1-29.4 53.8l-42.2 27.1c-25.2 16.2-40.4 44.1-40.4 74V320c0 17.7 14.3 32 32 32s32-14.3 32-32v-1.4c0-8.2 4.2-15.8 11-20.2l42.2-27.1c36.6-23.6 58.8-64.1 58.8-107.7V160c0-70.7-57.3-128-128-128H144C73.3 32 16 89.3 16 160c0 17.7 14.3 32 32 32s32-14.3 32-32zm80 320a40 40 0 1 0 0-80 40 40 0 1 0 0 80z"]
}, c4 = {
  prefix: "fas",
  iconName: "code",
  icon: [640, 512, [], "f121", "M392.8 1.2c-17-4.9-34.7 5-39.6 22l-128 448c-4.9 17 5 34.7 22 39.6s34.7-5 39.6-22l128-448c4.9-17-5-34.7-22-39.6zm80.6 120.1c-12.5 12.5-12.5 32.8 0 45.3L562.7 256l-89.4 89.4c-12.5 12.5-12.5 32.8 0 45.3s32.8 12.5 45.3 0l112-112c12.5-12.5 12.5-32.8 0-45.3l-112-112c-12.5-12.5-32.8-12.5-45.3 0zm-306.7 0c-12.5-12.5-32.8-12.5-45.3 0l-112 112c-12.5 12.5-12.5 32.8 0 45.3l112 112c12.5 12.5 32.8 12.5 45.3 0s12.5-32.8 0-45.3L77.3 256l89.4-89.4c12.5-12.5 12.5-32.8 0-45.3z"]
}, h4 = {
  prefix: "fas",
  iconName: "align-left",
  icon: [448, 512, [], "f036", "M288 64c0 17.7-14.3 32-32 32H32C14.3 96 0 81.7 0 64S14.3 32 32 32H256c17.7 0 32 14.3 32 32zm0 256c0 17.7-14.3 32-32 32H32c-17.7 0-32-14.3-32-32s14.3-32 32-32H256c17.7 0 32 14.3 32 32zM0 192c0-17.7 14.3-32 32-32H416c17.7 0 32 14.3 32 32s-14.3 32-32 32H32c-17.7 0-32-14.3-32-32zM448 448c0 17.7-14.3 32-32 32H32c-17.7 0-32-14.3-32-32s14.3-32 32-32H416c17.7 0 32 14.3 32 32z"]
}, f4 = {
  prefix: "fas",
  iconName: "minus",
  icon: [448, 512, [8211, 8722, 10134, "subtract"], "f068", "M432 256c0 17.7-14.3 32-32 32L48 288c-17.7 0-32-14.3-32-32s14.3-32 32-32l352 0c17.7 0 32 14.3 32 32z"]
}, d4 = {
  prefix: "fas",
  iconName: "gear",
  icon: [512, 512, [9881, "cog"], "f013", "M495.9 166.6c3.2 8.7 .5 18.4-6.4 24.6l-43.3 39.4c1.1 8.3 1.7 16.8 1.7 25.4s-.6 17.1-1.7 25.4l43.3 39.4c6.9 6.2 9.6 15.9 6.4 24.6c-4.4 11.9-9.7 23.3-15.8 34.3l-4.7 8.1c-6.6 11-14 21.4-22.1 31.2c-5.9 7.2-15.7 9.6-24.5 6.8l-55.7-17.7c-13.4 10.3-28.2 18.9-44 25.4l-12.5 57.1c-2 9.1-9 16.3-18.2 17.8c-13.8 2.3-28 3.5-42.5 3.5s-28.7-1.2-42.5-3.5c-9.2-1.5-16.2-8.7-18.2-17.8l-12.5-57.1c-15.8-6.5-30.6-15.1-44-25.4L83.1 425.9c-8.8 2.8-18.6 .3-24.5-6.8c-8.1-9.8-15.5-20.2-22.1-31.2l-4.7-8.1c-6.1-11-11.4-22.4-15.8-34.3c-3.2-8.7-.5-18.4 6.4-24.6l43.3-39.4C64.6 273.1 64 264.6 64 256s.6-17.1 1.7-25.4L22.4 191.2c-6.9-6.2-9.6-15.9-6.4-24.6c4.4-11.9 9.7-23.3 15.8-34.3l4.7-8.1c6.6-11 14-21.4 22.1-31.2c5.9-7.2 15.7-9.6 24.5-6.8l55.7 17.7c13.4-10.3 28.2-18.9 44-25.4l12.5-57.1c2-9.1 9-16.3 18.2-17.8C227.3 1.2 241.5 0 256 0s28.7 1.2 42.5 3.5c9.2 1.5 16.2 8.7 18.2 17.8l12.5 57.1c15.8 6.5 30.6 15.1 44 25.4l55.7-17.7c8.8-2.8 18.6-.3 24.5 6.8c8.1 9.8 15.5 20.2 22.1 31.2l4.7 8.1c6.1 11 11.4 22.4 15.8 34.3zM256 336a80 80 0 1 0 0-160 80 80 0 1 0 0 160z"]
}, p4 = {
  prefix: "fas",
  iconName: "square-root-variable",
  icon: [576, 512, ["square-root-alt"], "f698", "M282.6 78.1c8-27.3 33-46.1 61.4-46.1H544c17.7 0 32 14.3 32 32s-14.3 32-32 32H344L238.7 457c-3.6 12.3-14.1 21.2-26.8 22.8s-25.1-4.6-31.5-15.6L77.6 288H32c-17.7 0-32-14.3-32-32s14.3-32 32-32H77.6c22.8 0 43.8 12.1 55.3 31.8l65.2 111.8L282.6 78.1zM393.4 233.4c12.5-12.5 32.8-12.5 45.3 0L480 274.7l41.4-41.4c12.5-12.5 32.8-12.5 45.3 0s12.5 32.8 0 45.3L525.3 320l41.4 41.4c12.5 12.5 12.5 32.8 0 45.3s-32.8 12.5-45.3 0L480 365.3l-41.4 41.4c-12.5 12.5-32.8 12.5-45.3 0s-12.5-32.8 0-45.3L434.7 320l-41.4-41.4c-12.5-12.5-12.5-32.8 0-45.3z"]
}, m4 = {
  prefix: "fas",
  iconName: "arrows-down-to-line",
  icon: [576, 512, [], "e4b8", "M544 416L32 416c-17.7 0-32 14.3-32 32s14.3 32 32 32l512 0c17.7 0 32-14.3 32-32s-14.3-32-32-32zm22.6-137.4c12.5-12.5 12.5-32.8 0-45.3s-32.8-12.5-45.3 0L480 274.7 480 64c0-17.7-14.3-32-32-32s-32 14.3-32 32l0 210.7-41.4-41.4c-12.5-12.5-32.8-12.5-45.3 0s-12.5 32.8 0 45.3l96 96c12.5 12.5 32.8 12.5 45.3 0l96-96zm-320-45.3c-12.5-12.5-32.8-12.5-45.3 0L160 274.7 160 64c0-17.7-14.3-32-32-32s-32 14.3-32 32l0 210.7L54.6 233.4c-12.5-12.5-32.8-12.5-45.3 0s-12.5 32.8 0 45.3l96 96c12.5 12.5 32.8 12.5 45.3 0l96-96c12.5-12.5 12.5-32.8 0-45.3z"]
}, g4 = {
  prefix: "fas",
  iconName: "link",
  icon: [640, 512, [128279, "chain"], "f0c1", "M579.8 267.7c56.5-56.5 56.5-148 0-204.5c-50-50-128.8-56.5-186.3-15.4l-1.6 1.1c-14.4 10.3-17.7 30.3-7.4 44.6s30.3 17.7 44.6 7.4l1.6-1.1c32.1-22.9 76-19.3 103.8 8.6c31.5 31.5 31.5 82.5 0 114L422.3 334.8c-31.5 31.5-82.5 31.5-114 0c-27.9-27.9-31.5-71.8-8.6-103.8l1.1-1.6c10.3-14.4 6.9-34.4-7.4-44.6s-34.4-6.9-44.6 7.4l-1.1 1.6C206.5 251.2 213 330 263 380c56.5 56.5 148 56.5 204.5 0L579.8 267.7zM60.2 244.3c-56.5 56.5-56.5 148 0 204.5c50 50 128.8 56.5 186.3 15.4l1.6-1.1c14.4-10.3 17.7-30.3 7.4-44.6s-30.3-17.7-44.6-7.4l-1.6 1.1c-32.1 22.9-76 19.3-103.8-8.6C74 372 74 321 105.5 289.5L217.7 177.2c31.5-31.5 82.5-31.5 114 0c27.9 27.9 31.5 71.8 8.6 103.9l-1.1 1.6c-10.3 14.4-6.9 34.4 7.4 44.6s34.4 6.9 44.6-7.4l1.1-1.6C433.5 260.8 427 182 377 132c-56.5-56.5-148-56.5-204.5 0L60.2 244.3z"]
}, O4 = {
  prefix: "fas",
  iconName: "list-ul",
  icon: [512, 512, ["list-dots"], "f0ca", "M64 144a48 48 0 1 0 0-96 48 48 0 1 0 0 96zM192 64c-17.7 0-32 14.3-32 32s14.3 32 32 32H480c17.7 0 32-14.3 32-32s-14.3-32-32-32H192zm0 160c-17.7 0-32 14.3-32 32s14.3 32 32 32H480c17.7 0 32-14.3 32-32s-14.3-32-32-32H192zm0 160c-17.7 0-32 14.3-32 32s14.3 32 32 32H480c17.7 0 32-14.3 32-32s-14.3-32-32-32H192zM64 464a48 48 0 1 0 0-96 48 48 0 1 0 0 96zm48-208a48 48 0 1 0 -96 0 48 48 0 1 0 96 0z"]
}, b4 = {
  prefix: "fas",
  iconName: "list-check",
  icon: [512, 512, ["tasks"], "f0ae", "M152.1 38.2c9.9 8.9 10.7 24 1.8 33.9l-72 80c-4.4 4.9-10.6 7.8-17.2 7.9s-12.9-2.4-17.6-7L7 113C-2.3 103.6-2.3 88.4 7 79s24.6-9.4 33.9 0l22.1 22.1 55.1-61.2c8.9-9.9 24-10.7 33.9-1.8zm0 160c9.9 8.9 10.7 24 1.8 33.9l-72 80c-4.4 4.9-10.6 7.8-17.2 7.9s-12.9-2.4-17.6-7L7 273c-9.4-9.4-9.4-24.6 0-33.9s24.6-9.4 33.9 0l22.1 22.1 55.1-61.2c8.9-9.9 24-10.7 33.9-1.8zM224 96c0-17.7 14.3-32 32-32H480c17.7 0 32 14.3 32 32s-14.3 32-32 32H256c-17.7 0-32-14.3-32-32zm0 160c0-17.7 14.3-32 32-32H480c17.7 0 32 14.3 32 32s-14.3 32-32 32H256c-17.7 0-32-14.3-32-32zM160 416c0-17.7 14.3-32 32-32H480c17.7 0 32 14.3 32 32s-14.3 32-32 32H192c-17.7 0-32-14.3-32-32zM48 368a48 48 0 1 1 0 96 48 48 0 1 1 0-96z"]
}, y4 = {
  prefix: "fas",
  iconName: "xmark",
  icon: [384, 512, [128473, 10005, 10006, 10060, 215, "close", "multiply", "remove", "times"], "f00d", "M342.6 150.6c12.5-12.5 12.5-32.8 0-45.3s-32.8-12.5-45.3 0L192 210.7 86.6 105.4c-12.5-12.5-32.8-12.5-45.3 0s-12.5 32.8 0 45.3L146.7 256 41.4 361.4c-12.5 12.5-12.5 32.8 0 45.3s32.8 12.5 45.3 0L192 301.3 297.4 406.6c12.5 12.5 32.8 12.5 45.3 0s12.5-32.8 0-45.3L237.3 256 342.6 150.6z"]
}, k4 = {
  prefix: "fas",
  iconName: "quote-left",
  icon: [448, 512, [8220, "quote-left-alt"], "f10d", "M0 216C0 149.7 53.7 96 120 96h8c17.7 0 32 14.3 32 32s-14.3 32-32 32h-8c-30.9 0-56 25.1-56 56v8h64c35.3 0 64 28.7 64 64v64c0 35.3-28.7 64-64 64H64c-35.3 0-64-28.7-64-64V320 288 216zm256 0c0-66.3 53.7-120 120-120h8c17.7 0 32 14.3 32 32s-14.3 32-32 32h-8c-30.9 0-56 25.1-56 56v8h64c35.3 0 64 28.7 64 64v64c0 35.3-28.7 64-64 64H320c-35.3 0-64-28.7-64-64V320 288 216z"]
}, x4 = {
  prefix: "fas",
  iconName: "align-right",
  icon: [448, 512, [], "f038", "M448 64c0 17.7-14.3 32-32 32H192c-17.7 0-32-14.3-32-32s14.3-32 32-32H416c17.7 0 32 14.3 32 32zm0 256c0 17.7-14.3 32-32 32H192c-17.7 0-32-14.3-32-32s14.3-32 32-32H416c17.7 0 32 14.3 32 32zM0 192c0-17.7 14.3-32 32-32H416c17.7 0 32 14.3 32 32s-14.3 32-32 32H32c-17.7 0-32-14.3-32-32zM448 448c0 17.7-14.3 32-32 32H32c-17.7 0-32-14.3-32-32s14.3-32 32-32H416c17.7 0 32 14.3 32 32z"]
}, w4 = {
  prefix: "fab",
  iconName: "github",
  icon: [496, 512, [], "f09b", "M165.9 397.4c0 2-2.3 3.6-5.2 3.6-3.3.3-5.6-1.3-5.6-3.6 0-2 2.3-3.6 5.2-3.6 3-.3 5.6 1.3 5.6 3.6zm-31.1-4.5c-.7 2 1.3 4.3 4.3 4.9 2.6 1 5.6 0 6.2-2s-1.3-4.3-4.3-5.2c-2.6-.7-5.5.3-6.2 2.3zm44.2-1.7c-2.9.7-4.9 2.6-4.6 4.9.3 2 2.9 3.3 5.9 2.6 2.9-.7 4.9-2.6 4.6-4.6-.3-1.9-3-3.2-5.9-2.9zM244.8 8C106.1 8 0 113.3 0 252c0 110.9 69.8 205.8 169.5 239.2 12.8 2.3 17.3-5.6 17.3-12.1 0-6.2-.3-40.4-.3-61.4 0 0-70 15-84.7-29.8 0 0-11.4-29.1-27.8-36.6 0 0-22.9-15.7 1.6-15.4 0 0 24.9 2 38.6 25.8 21.9 38.6 58.6 27.5 72.9 20.9 2.3-16 8.8-27.1 16-33.7-55.9-6.2-112.3-14.3-112.3-110.5 0-27.5 7.6-41.3 23.6-58.9-2.6-6.5-11.1-33.3 2.6-67.9 20.9-6.5 69 27 69 27 20-5.6 41.5-8.5 62.8-8.5s42.8 2.9 62.8 8.5c0 0 48.1-33.6 69-27 13.7 34.7 5.2 61.4 2.6 67.9 16 17.7 25.8 31.5 25.8 58.9 0 96.5-58.9 104.2-114.8 110.5 9.2 7.9 17 22.9 17 46.4 0 33.7-.3 75.4-.3 83.6 0 6.5 4.6 14.4 17.3 12.1C428.2 457.8 496 362.9 496 252 496 113.3 383.5 8 244.8 8zM97.2 352.9c-1.3 1-1 3.3.7 5.2 1.6 1.6 3.9 2.3 5.2 1 1.3-1 1-3.3-.7-5.2-1.6-1.6-3.9-2.3-5.2-1zm-10.8-8.1c-.7 1.3.3 2.9 2.3 3.9 1.6 1 3.6.7 4.3-.7.7-1.3-.3-2.9-2.3-3.9-2-.6-3.6-.3-4.3.7zm32.4 35.6c-1.6 1.3-1 4.3 1.3 6.2 2.3 2.3 5.2 2.6 6.5 1 1.3-1.3.7-4.3-1.3-6.2-2.2-2.3-5.2-2.6-6.5-1zm-11.4-14.7c-1.6 1-1.6 3.6 0 5.9 1.6 2.3 4.3 3.3 5.6 2.3 1.6-1.3 1.6-3.9 0-6.2-1.4-2.3-4-3.3-5.6-2z"]
};
const Xe = {
  xmark: y4,
  config: d4,
  headingup: t4,
  headingdown: m4,
  bold: s4,
  italic: a4,
  strikethrough: n4,
  link: g4,
  line: f4,
  listul: O4,
  listol: l4,
  listtask: b4,
  code: c4,
  block: JA,
  math: p4,
  editor: h4,
  viewer: x4,
  expand: r4,
  info: e4,
  image: o4,
  table: i4,
  quote: k4,
  help: u4,
  github: w4
}, S4 = { class: "cs-dialog-header" }, v4 = {
  key: 0,
  class: "cs-dialog-view"
}, Vs = /* @__PURE__ */ bt({
  __name: "MDialog",
  props: {
    extra: { type: Boolean, default: !1 }
  },
  emits: ["close"],
  setup(n, { emit: e }) {
    const t = e, i = n, r = Ce(void 0);
    function s(o) {
      i.extra || r.value && !r.value.contains(o.target) && t("close");
    }
    return (o, a) => (ue(), Oe("div", {
      class: "cs-dialog-container",
      onClick: s
    }, [
      q("div", {
        ref_key: "dialog",
        ref: r,
        class: wn([
          "cs-dialog",
          { "cs-dialog-big": i.extra }
        ])
      }, [
        q("div", {
          class: wn(`${i.extra ? "cs-dialog-sidebar" : ""}`)
        }, [
          q("div", S4, [
            dl(o.$slots, "header"),
            q("div", {
              class: "cs-close-container",
              onClick: a[0] || (a[0] = (l) => t("close"))
            }, [
              Vt(oe(Ac), {
                icon: oe(Xe).xmark,
                class: "cs-icon"
              }, null, 8, ["icon"])
            ])
          ]),
          dl(o.$slots, "default")
        ], 2),
        i.extra ? (ue(), Oe("div", v4, [
          dl(o.$slots, "view")
        ])) : xn("", !0)
      ], 2)
    ]));
  }
}), P4 = { class: "cs-dialog-item" }, Q4 = { class: "cs-dialog-item-label" }, $4 = ["value"], C4 = { class: "cs-dialog-item" }, T4 = {
  class: "cs-dialog-item-label",
  style: { "min-height": "50vh" }
}, A4 = { class: "cs-dialog-submit-area" }, R4 = /* @__PURE__ */ bt({
  __name: "ToolCode",
  props: {
    confirm: { type: Function },
    container: {}
  },
  setup(n) {
    const e = n;
    function t() {
      dn(null, e.container);
    }
    const i = Ce(""), r = Ce(""), s = [
      { value: "cpp", name: "C++" },
      { value: "pascal", name: "Pascal" },
      { value: "c", name: "C" },
      { value: "javascript", name: "Javascript" },
      { value: "java", name: "Java" },
      { value: "markdown", name: "Markdown" },
      { value: "latex", name: "LaTeX" }
    ];
    return (o, a) => (ue(), Ci(Vs, { onClose: t }, {
      header: Yt(() => [
        As(ce(oe(pe)("code-insert")), 1)
      ]),
      default: Yt(() => [
        q("div", null, [
          q("div", P4, [
            q("div", Q4, ce(oe(pe)("code-select")), 1),
            Sn(q("select", {
              "onUpdate:modelValue": a[0] || (a[0] = (l) => i.value = l),
              class: "cs-dialog-item-content"
            }, [
              (ue(), Oe(di, null, pi(s, (l) => q("option", {
                key: l.value,
                value: l.value
              }, ce(l.name), 9, $4)), 64))
            ], 512), [
              [Ck, i.value]
            ])
          ]),
          q("div", C4, [
            q("div", T4, ce(oe(pe)("code")), 1),
            Sn(q("textarea", {
              "onUpdate:modelValue": a[1] || (a[1] = (l) => r.value = l),
              class: "cs-dialog-item-content"
            }, null, 512), [
              [Yn, r.value]
            ])
          ]),
          q("div", A4, [
            q("button", {
              class: "cs-dialog-button cs-dialog-button-info",
              onClick: a[2] || (a[2] = () => {
                e.confirm(i.value, r.value), t();
              })
            }, ce(oe(pe)("confirm")), 1),
            q("button", {
              class: "cs-dialog-button cs-dialog-button-info",
              onClick: t
            }, ce(oe(pe)("cancel")), 1)
          ])
        ])
      ]),
      _: 1
    }));
  }
}), M4 = { class: "cs-dialog-item" }, Z4 = { class: "cs-dialog-item-label" }, E4 = { class: "cs-dialog-item" }, z4 = { class: "cs-dialog-item-label" }, D4 = {
  key: 0,
  class: "cs-dialog-item"
}, I4 = { class: "cs-dialog-submit-area" }, L4 = /* @__PURE__ */ bt({
  __name: "ToolImage",
  props: {
    confirm: { type: Function },
    upload: { type: Function },
    container: {}
  },
  setup(n) {
    const e = n;
    function t() {
      dn(null, e.container);
    }
    const i = Ce(""), r = Ce(""), s = Ce(null), o = Ce(!1);
    function a(d) {
      var p;
      if ((p = d.dataTransfer) != null && p.items) {
        for (let g = 0; g < d.dataTransfer.items.length; g++)
          if (d.dataTransfer.items[g].kind === "file") {
            o.value = !0;
            return;
          }
      }
    }
    function l() {
      o.value = !1;
    }
    function u(d) {
      d.preventDefault();
    }
    function c(d) {
      if (!e.upload || (o.value = !1, !d.dataTransfer))
        return;
      const p = e.upload(d.dataTransfer.files);
      p && (r.value = p[0].alt, i.value = p[0].url), d.preventDefault();
    }
    function h() {
      var d;
      (d = s.value) == null || d.click();
    }
    function f() {
      var d;
      if (e.upload && (d = s.value) != null && d.files) {
        const p = e.upload(s.value.files);
        p && (r.value = p[0].alt, i.value = p[0].url);
      }
    }
    return (d, p) => (ue(), Ci(Vs, { onClose: t }, {
      header: Yt(() => [
        As(ce(oe(pe)("image-insert")), 1)
      ]),
      default: Yt(() => [
        q("div", null, [
          q("div", M4, [
            q("div", Z4, ce(oe(pe)("image-url")), 1),
            Sn(q("input", {
              "onUpdate:modelValue": p[0] || (p[0] = (g) => i.value = g),
              type: "text",
              class: "cs-dialog-item-content"
            }, null, 512), [
              [Yn, i.value]
            ])
          ]),
          q("div", E4, [
            q("div", z4, ce(oe(pe)("image-alt")), 1),
            Sn(q("input", {
              "onUpdate:modelValue": p[1] || (p[1] = (g) => r.value = g),
              type: "text",
              class: "cs-dialog-item-content"
            }, null, 512), [
              [Yn, r.value]
            ])
          ]),
          e.upload ? (ue(), Oe("div", D4, [
            q("div", {
              class: "cs-dialog-upload",
              onClick: h,
              onDragenter: a,
              onDragleave: l,
              onDragover: u,
              onDrop: c
            }, ce(oe(pe)("image-upload")), 33),
            q("input", {
              ref_key: "inputImage",
              ref: s,
              type: "file",
              style: { display: "none" },
              onChange: f
            }, null, 544)
          ])) : xn("", !0),
          q("div", I4, [
            q("button", {
              class: "cs-dialog-button cs-dialog-button-info",
              onClick: p[2] || (p[2] = () => {
                e.confirm(i.value, r.value), t();
              })
            }, ce(oe(pe)("confirm")), 1),
            q("button", {
              class: "cs-dialog-button cs-dialog-button-info",
              onClick: t
            }, ce(oe(pe)("cancel")), 1)
          ])
        ])
      ]),
      _: 1
    }));
  }
}), _4 = { class: "cs-dialog-item" }, X4 = { class: "cs-dialog-item-label" }, N4 = { class: "cs-dialog-item" }, W4 = { class: "cs-dialog-item-label" }, q4 = { class: "cs-dialog-area" }, B4 = { key: 0 }, V4 = { class: "cs-dialog-submit-area" }, Y4 = { class: "cs-dialog-table-editor" }, j4 = ["data-x", "data-y"], U4 = /* @__PURE__ */ bt({
  __name: "ToolTable",
  props: {
    confirm: { type: Function },
    container: {}
  },
  setup(n) {
    const e = n;
    function t() {
      dn(null, e.container);
    }
    const i = Ce(1), r = Ce(1), s = Ce([NaN, NaN]), o = Ce([NaN, NaN]), a = Ce(""), l = Ce(!1), u = Ce([[""]]);
    function c() {
      for (i.value = Math.max(1, i.value), r.value = Math.max(1, r.value), i.value = Math.min(100, i.value), r.value = Math.min(100, r.value); u.value.length < i.value; )
        u.value.push([]);
      for (; u.value.length > i.value; )
        u.value.pop();
      for (let m of u.value) {
        for (; m.length < r.value; )
          m.push("");
        for (; m.length > r.value; )
          m.pop();
      }
    }
    function h(m, b) {
      return s.value[0] <= m && m <= o.value[0] && s.value[1] <= b && b <= o.value[1];
    }
    function f(m) {
      if (m.target) {
        l.value = !1;
        const b = Number.parseInt(m.target.dataset.x || "-1"), w = Number.parseInt(m.target.dataset.y || "-1");
        s.value = o.value = [b, w], a.value = u.value[b][w];
      }
    }
    function d(m) {
      if (!l.value && !Number.isNaN(s.value[0]) && m.target) {
        const b = Number.parseInt(m.target.dataset.x || "-1"), w = Number.parseInt(m.target.dataset.y || "-1");
        o.value = [b, w], console.log(b, w, u.value[b][w], "select2 enter"), a.value = u.value[b][w];
      }
    }
    function p() {
      l.value = !0;
    }
    const g = () => {
      if (!l.value)
        return;
      let [m, b] = s.value, [w, Q] = o.value;
      if (0 <= m && m < i.value && 0 <= w && w < i.value && 0 <= b && b < r.value && 0 <= Q && Q < r.value)
        for (let v = m; v <= w; v++)
          for (let k = b; k <= Q; k++)
            u.value[v][k] = a.value;
    }, O = (m, b) => Number.isNaN(m[0]) ? "" : m[0] === b[0] && m[1] === b[1] ? `: (${m[0]}, ${m[1]})` : `: (${m[0]}, ${m[1]}) - (${b[0]}, ${b[1]})`;
    return ft(i, c), ft(r, c), ft(a, g), (m, b) => (ue(), Ci(Vs, {
      extra: "",
      onClose: t
    }, {
      header: Yt(() => [
        As(ce(oe(pe)("table-insert")), 1)
      ]),
      view: Yt(() => [
        q("table", Y4, [
          q("tbody", null, [
            (ue(!0), Oe(di, null, pi(Object.entries(u.value), ([w, Q]) => (ue(), Oe("tr", { key: w }, [
              (ue(!0), Oe(di, null, pi(Object.entries(Q), ([v, k]) => (ue(), Oe("td", {
                key: v,
                "data-x": w,
                "data-y": v,
                class: wn({ selected: h(Number.parseInt(w), Number.parseInt(v)) }),
                onMousedown: f,
                onMouseenter: d,
                onMouseup: p
              }, ce(k) + "  ", 43, j4))), 128))
            ]))), 128))
          ])
        ])
      ]),
      default: Yt(() => [
        q("div", _4, [
          q("div", X4, ce(oe(pe)("table-rows")), 1),
          Sn(q("input", {
            "onUpdate:modelValue": b[0] || (b[0] = (w) => i.value = w),
            type: "number",
            class: "cs-dialog-item-content",
            min: "1",
            max: "100"
          }, null, 512), [
            [Yn, i.value]
          ])
        ]),
        q("div", N4, [
          q("div", W4, ce(oe(pe)("table-cols")), 1),
          Sn(q("input", {
            "onUpdate:modelValue": b[1] || (b[1] = (w) => r.value = w),
            type: "number",
            class: "cs-dialog-item-content",
            min: "1",
            max: "100"
          }, null, 512), [
            [Yn, r.value]
          ])
        ]),
        q("div", q4, [
          q("h3", null, ce(oe(pe)("table-edit")) + ce(O(s.value, o.value)), 1),
          Number.isNaN(s.value[0]) ? (ue(), Oe("p", B4, ce(oe(pe)("table-edit-tips")), 1)) : Sn((ue(), Oe("textarea", {
            key: 1,
            "onUpdate:modelValue": b[2] || (b[2] = (w) => a.value = w)
          }, null, 512)), [
            [Yn, a.value]
          ])
        ]),
        q("div", V4, [
          q("button", {
            class: "cs-dialog-button cs-dialog-button-info",
            onClick: b[3] || (b[3] = () => {
              m.confirm(i.value, r.value, u.value), t();
            })
          }, ce(oe(pe)("confirm")), 1),
          q("button", {
            class: "cs-dialog-button cs-dialog-button-info",
            onClick: t
          }, ce(oe(pe)("cancel")), 1)
        ])
      ]),
      _: 1
    }));
  }
}), F4 = { class: "cs-dialog-item" }, G4 = { class: "cs-dialog-item-label" }, H4 = { class: "cs-dialog-item" }, K4 = { class: "cs-dialog-item-label" }, J4 = { class: "cs-dialog-submit-area" }, eR = /* @__PURE__ */ bt({
  __name: "ToolLink",
  props: {
    confirm: { type: Function },
    container: {}
  },
  setup(n) {
    const e = n;
    function t() {
      dn(null, e.container);
    }
    const i = Ce(""), r = Ce("");
    return (s, o) => (ue(), Ci(Vs, { onClose: t }, {
      header: Yt(() => [
        As(ce(oe(pe)("link-insert")), 1)
      ]),
      default: Yt(() => [
        q("div", null, [
          q("div", F4, [
            q("div", G4, ce(oe(pe)("link-url")), 1),
            Sn(q("input", {
              "onUpdate:modelValue": o[0] || (o[0] = (a) => i.value = a),
              type: "text",
              class: "cs-dialog-item-content"
            }, null, 512), [
              [Yn, i.value]
            ])
          ]),
          q("div", H4, [
            q("div", K4, ce(oe(pe)("link-alt")), 1),
            Sn(q("input", {
              "onUpdate:modelValue": o[1] || (o[1] = (a) => r.value = a),
              type: "text",
              class: "cs-dialog-item-content"
            }, null, 512), [
              [Yn, r.value]
            ])
          ]),
          q("div", J4, [
            q("button", {
              class: "cs-dialog-button cs-dialog-button-info",
              onClick: o[2] || (o[2] = () => {
                e.confirm(i.value, r.value), t();
              })
            }, ce(oe(pe)("confirm")), 1),
            q("button", {
              class: "cs-dialog-button cs-dialog-button-info",
              onClick: t
            }, ce(oe(pe)("cancel")), 1)
          ])
        ])
      ]),
      _: 1
    }));
  }
}), tR = /* @__PURE__ */ q("div", null, null, -1), nR = /* @__PURE__ */ bt({
  __name: "ToolHelp",
  props: {
    confirm: { type: Function },
    container: {}
  },
  setup(n) {
    const e = n;
    function t() {
      dn(null, e.container);
    }
    return (i, r) => (ue(), Ci(Vs, { onClose: t }, {
      header: Yt(() => [
        As(ce(oe(pe)("help")), 1)
      ]),
      default: Yt(() => [
        tR
      ]),
      _: 1
    }));
  }
});
class Ma {
  static create(e, t, i, r, s) {
    let o = r + (r << 8) + e + (t << 4) | 0;
    return new Ma(e, t, i, o, s, [], []);
  }
  constructor(e, t, i, r, s, o, a) {
    this.type = e, this.value = t, this.from = i, this.hash = r, this.end = s, this.children = o, this.positions = a, this.hashProp = [[J.contextHash, r]];
  }
  addChild(e, t) {
    e.prop(J.contextHash) != this.hash && (e = new ge(e.type, e.children, e.positions, e.length, this.hashProp)), this.children.push(e), this.positions.push(t);
  }
  toTree(e, t = this.end) {
    let i = this.children.length - 1;
    return i >= 0 && (t = Math.max(t, this.positions[i] + this.children[i].length + this.from)), new ge(e.types[this.type], this.children, this.positions, t - this.from).balance({
      makeTree: (r, s, o) => new ge(qe.none, r, s, o, this.hashProp)
    });
  }
}
var Z;
(function(n) {
  n[n.Document = 1] = "Document", n[n.CodeBlock = 2] = "CodeBlock", n[n.FencedCode = 3] = "FencedCode", n[n.Blockquote = 4] = "Blockquote", n[n.HorizontalRule = 5] = "HorizontalRule", n[n.BulletList = 6] = "BulletList", n[n.OrderedList = 7] = "OrderedList", n[n.ListItem = 8] = "ListItem", n[n.ATXHeading1 = 9] = "ATXHeading1", n[n.ATXHeading2 = 10] = "ATXHeading2", n[n.ATXHeading3 = 11] = "ATXHeading3", n[n.ATXHeading4 = 12] = "ATXHeading4", n[n.ATXHeading5 = 13] = "ATXHeading5", n[n.ATXHeading6 = 14] = "ATXHeading6", n[n.SetextHeading1 = 15] = "SetextHeading1", n[n.SetextHeading2 = 16] = "SetextHeading2", n[n.HTMLBlock = 17] = "HTMLBlock", n[n.LinkReference = 18] = "LinkReference", n[n.Paragraph = 19] = "Paragraph", n[n.CommentBlock = 20] = "CommentBlock", n[n.ProcessingInstructionBlock = 21] = "ProcessingInstructionBlock", n[n.Escape = 22] = "Escape", n[n.Entity = 23] = "Entity", n[n.HardBreak = 24] = "HardBreak", n[n.Emphasis = 25] = "Emphasis", n[n.StrongEmphasis = 26] = "StrongEmphasis", n[n.Link = 27] = "Link", n[n.Image = 28] = "Image", n[n.InlineCode = 29] = "InlineCode", n[n.HTMLTag = 30] = "HTMLTag", n[n.Comment = 31] = "Comment", n[n.ProcessingInstruction = 32] = "ProcessingInstruction", n[n.Autolink = 33] = "Autolink", n[n.HeaderMark = 34] = "HeaderMark", n[n.QuoteMark = 35] = "QuoteMark", n[n.ListMark = 36] = "ListMark", n[n.LinkMark = 37] = "LinkMark", n[n.EmphasisMark = 38] = "EmphasisMark", n[n.CodeMark = 39] = "CodeMark", n[n.CodeText = 40] = "CodeText", n[n.CodeInfo = 41] = "CodeInfo", n[n.LinkTitle = 42] = "LinkTitle", n[n.LinkLabel = 43] = "LinkLabel", n[n.URL = 44] = "URL";
})(Z || (Z = {}));
class iR {
  /// @internal
  constructor(e, t) {
    this.start = e, this.content = t, this.marks = [], this.parsers = [];
  }
}
class rR {
  constructor() {
    this.text = "", this.baseIndent = 0, this.basePos = 0, this.depth = 0, this.markers = [], this.pos = 0, this.indent = 0, this.next = -1;
  }
  /// @internal
  forward() {
    this.basePos > this.pos && this.forwardInner();
  }
  /// @internal
  forwardInner() {
    let e = this.skipSpace(this.basePos);
    this.indent = this.countIndent(e, this.pos, this.indent), this.pos = e, this.next = e == this.text.length ? -1 : this.text.charCodeAt(e);
  }
  /// Skip whitespace after the given position, return the position of
  /// the next non-space character or the end of the line if there's
  /// only space after `from`.
  skipSpace(e) {
    return es(this.text, e);
  }
  /// @internal
  reset(e) {
    for (this.text = e, this.baseIndent = this.basePos = this.pos = this.indent = 0, this.forwardInner(), this.depth = 1; this.markers.length; )
      this.markers.pop();
  }
  /// Move the line's base position forward to the given position.
  /// This should only be called by composite [block
  /// parsers](#BlockParser.parse) or [markup skipping
  /// functions](#NodeSpec.composite).
  moveBase(e) {
    this.basePos = e, this.baseIndent = this.countIndent(e, this.pos, this.indent);
  }
  /// Move the line's base position forward to the given _column_.
  moveBaseColumn(e) {
    this.baseIndent = e, this.basePos = this.findColumn(e);
  }
  /// Store a composite-block-level marker. Should be called from
  /// [markup skipping functions](#NodeSpec.composite) when they
  /// consume any non-whitespace characters.
  addMarker(e) {
    this.markers.push(e);
  }
  /// Find the column position at `to`, optionally starting at a given
  /// position and column.
  countIndent(e, t = 0, i = 0) {
    for (let r = t; r < e; r++)
      i += this.text.charCodeAt(r) == 9 ? 4 - i % 4 : 1;
    return i;
  }
  /// Find the position corresponding to the given column.
  findColumn(e) {
    let t = 0;
    for (let i = 0; t < this.text.length && i < e; t++)
      i += this.text.charCodeAt(t) == 9 ? 4 - i % 4 : 1;
    return t;
  }
  /// @internal
  scrub() {
    if (!this.baseIndent)
      return this.text;
    let e = "";
    for (let t = 0; t < this.basePos; t++)
      e += " ";
    return e + this.text.slice(this.basePos);
  }
}
function nm(n, e, t) {
  if (t.pos == t.text.length || n != e.block && t.indent >= e.stack[t.depth + 1].value + t.baseIndent)
    return !0;
  if (t.indent >= t.baseIndent + 4)
    return !1;
  let i = (n.type == Z.OrderedList ? nf : tf)(t, e, !1);
  return i > 0 && (n.type != Z.BulletList || ef(t, e, !1) < 0) && t.text.charCodeAt(t.pos + i - 1) == n.value;
}
const Mb = {
  [Z.Blockquote](n, e, t) {
    return t.next != 62 ? !1 : (t.markers.push(he(Z.QuoteMark, e.lineStart + t.pos, e.lineStart + t.pos + 1)), t.moveBase(t.pos + (_t(t.text.charCodeAt(t.pos + 1)) ? 2 : 1)), n.end = e.lineStart + t.text.length, !0);
  },
  [Z.ListItem](n, e, t) {
    return t.indent < t.baseIndent + n.value && t.next > -1 ? !1 : (t.moveBaseColumn(t.baseIndent + n.value), !0);
  },
  [Z.OrderedList]: nm,
  [Z.BulletList]: nm,
  [Z.Document]() {
    return !0;
  }
};
function _t(n) {
  return n == 32 || n == 9 || n == 10 || n == 13;
}
function es(n, e = 0) {
  for (; e < n.length && _t(n.charCodeAt(e)); )
    e++;
  return e;
}
function im(n, e, t) {
  for (; e > t && _t(n.charCodeAt(e - 1)); )
    e--;
  return e;
}
function Zb(n) {
  if (n.next != 96 && n.next != 126)
    return -1;
  let e = n.pos + 1;
  for (; e < n.text.length && n.text.charCodeAt(e) == n.next; )
    e++;
  if (e < n.pos + 3)
    return -1;
  if (n.next == 96) {
    for (let t = e; t < n.text.length; t++)
      if (n.text.charCodeAt(t) == 96)
        return -1;
  }
  return e;
}
function Eb(n) {
  return n.next != 62 ? -1 : n.text.charCodeAt(n.pos + 1) == 32 ? 2 : 1;
}
function ef(n, e, t) {
  if (n.next != 42 && n.next != 45 && n.next != 95)
    return -1;
  let i = 1;
  for (let r = n.pos + 1; r < n.text.length; r++) {
    let s = n.text.charCodeAt(r);
    if (s == n.next)
      i++;
    else if (!_t(s))
      return -1;
  }
  return t && n.next == 45 && Ib(n) > -1 && n.depth == e.stack.length || i < 3 ? -1 : 1;
}
function zb(n, e) {
  for (let t = n.stack.length - 1; t >= 0; t--)
    if (n.stack[t].type == e)
      return !0;
  return !1;
}
function tf(n, e, t) {
  return (n.next == 45 || n.next == 43 || n.next == 42) && (n.pos == n.text.length - 1 || _t(n.text.charCodeAt(n.pos + 1))) && (!t || zb(e, Z.BulletList) || n.skipSpace(n.pos + 2) < n.text.length) ? 1 : -1;
}
function nf(n, e, t) {
  let i = n.pos, r = n.next;
  for (; r >= 48 && r <= 57; ) {
    i++;
    if (i == n.text.length)
      return -1;
    r = n.text.charCodeAt(i);
  }
  return i == n.pos || i > n.pos + 9 || r != 46 && r != 41 || i < n.text.length - 1 && !_t(n.text.charCodeAt(i + 1)) || t && !zb(e, Z.OrderedList) && (n.skipSpace(i + 1) == n.text.length || i > n.pos + 1 || n.next != 49) ? -1 : i + 1 - n.pos;
}
function Db(n) {
  if (n.next != 35)
    return -1;
  let e = n.pos + 1;
  for (; e < n.text.length && n.text.charCodeAt(e) == 35; )
    e++;
  if (e < n.text.length && n.text.charCodeAt(e) != 32)
    return -1;
  let t = e - n.pos;
  return t > 6 ? -1 : t;
}
function Ib(n) {
  if (n.next != 45 && n.next != 61 || n.indent >= n.baseIndent + 4)
    return -1;
  let e = n.pos + 1;
  for (; e < n.text.length && n.text.charCodeAt(e) == n.next; )
    e++;
  let t = e;
  for (; e < n.text.length && _t(n.text.charCodeAt(e)); )
    e++;
  return e == n.text.length ? t : -1;
}
const Rc = /^[ \t]*$/, Lb = /-->/, _b = /\?>/, Mc = [
  [/^<(?:script|pre|style)(?:\s|>|$)/i, /<\/(?:script|pre|style)>/i],
  [/^\s*<!--/, Lb],
  [/^\s*<\?/, _b],
  [/^\s*<![A-Z]/, />/],
  [/^\s*<!\[CDATA\[/, /\]\]>/],
  [/^\s*<\/?(?:address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h1|h2|h3|h4|h5|h6|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul)(?:\s|\/?>|$)/i, Rc],
  [/^\s*(?:<\/[a-z][\w-]*\s*>|<[a-z][\w-]*(\s+[a-z:_][\w-.]*(?:\s*=\s*(?:[^\s"'=<>`]+|'[^']*'|"[^"]*"))?)*\s*>)\s*$/i, Rc]
];
function Xb(n, e, t) {
  if (n.next != 60)
    return -1;
  let i = n.text.slice(n.pos);
  for (let r = 0, s = Mc.length - (t ? 1 : 0); r < s; r++)
    if (Mc[r][0].test(i))
      return r;
  return -1;
}
function rm(n, e) {
  let t = n.countIndent(e, n.pos, n.indent), i = n.countIndent(n.skipSpace(e), e, t);
  return i >= t + 5 ? t + 1 : i;
}
function ui(n, e, t) {
  let i = n.length - 1;
  i >= 0 && n[i].to == e && n[i].type == Z.CodeText ? n[i].to = t : n.push(he(Z.CodeText, e, t));
}
const To = {
  LinkReference: void 0,
  IndentedCode(n, e) {
    let t = e.baseIndent + 4;
    if (e.indent < t)
      return !1;
    let i = e.findColumn(t), r = n.lineStart + i, s = n.lineStart + e.text.length, o = [], a = [];
    for (ui(o, r, s); n.nextLine() && e.depth >= n.stack.length; )
      if (e.pos == e.text.length) {
        ui(a, n.lineStart - 1, n.lineStart);
        for (let l of e.markers)
          a.push(l);
      } else {
        if (e.indent < t)
          break;
        {
          if (a.length) {
            for (let u of a)
              u.type == Z.CodeText ? ui(o, u.from, u.to) : o.push(u);
            a = [];
          }
          ui(o, n.lineStart - 1, n.lineStart);
          for (let u of e.markers)
            o.push(u);
          s = n.lineStart + e.text.length;
          let l = n.lineStart + e.findColumn(e.baseIndent + 4);
          l < s && ui(o, l, s);
        }
      }
    return a.length && (a = a.filter((l) => l.type != Z.CodeText), a.length && (e.markers = a.concat(e.markers))), n.addNode(n.buffer.writeElements(o, -r).finish(Z.CodeBlock, s - r), r), !0;
  },
  FencedCode(n, e) {
    let t = Zb(e);
    if (t < 0)
      return !1;
    let i = n.lineStart + e.pos, r = e.next, s = t - e.pos, o = e.skipSpace(t), a = im(e.text, e.text.length, o), l = [he(Z.CodeMark, i, i + s)];
    o < a && l.push(he(Z.CodeInfo, n.lineStart + o, n.lineStart + a));
    for (let u = !0; n.nextLine() && e.depth >= n.stack.length; u = !1) {
      let c = e.pos;
      if (e.indent - e.baseIndent < 4)
        for (; c < e.text.length && e.text.charCodeAt(c) == r; )
          c++;
      if (c - e.pos >= s && e.skipSpace(c) == e.text.length) {
        for (let h of e.markers)
          l.push(h);
        l.push(he(Z.CodeMark, n.lineStart + e.pos, n.lineStart + c)), n.nextLine();
        break;
      } else {
        u || ui(l, n.lineStart - 1, n.lineStart);
        for (let d of e.markers)
          l.push(d);
        let h = n.lineStart + e.basePos, f = n.lineStart + e.text.length;
        h < f && ui(l, h, f);
      }
    }
    return n.addNode(n.buffer.writeElements(l, -i).finish(Z.FencedCode, n.prevLineEnd() - i), i), !0;
  },
  Blockquote(n, e) {
    let t = Eb(e);
    return t < 0 ? !1 : (n.startContext(Z.Blockquote, e.pos), n.addNode(Z.QuoteMark, n.lineStart + e.pos, n.lineStart + e.pos + 1), e.moveBase(e.pos + t), null);
  },
  HorizontalRule(n, e) {
    if (ef(e, n, !1) < 0)
      return !1;
    let t = n.lineStart + e.pos;
    return n.nextLine(), n.addNode(Z.HorizontalRule, t), !0;
  },
  BulletList(n, e) {
    let t = tf(e, n, !1);
    if (t < 0)
      return !1;
    n.block.type != Z.BulletList && n.startContext(Z.BulletList, e.basePos, e.next);
    let i = rm(e, e.pos + 1);
    return n.startContext(Z.ListItem, e.basePos, i - e.baseIndent), n.addNode(Z.ListMark, n.lineStart + e.pos, n.lineStart + e.pos + t), e.moveBaseColumn(i), null;
  },
  OrderedList(n, e) {
    let t = nf(e, n, !1);
    if (t < 0)
      return !1;
    n.block.type != Z.OrderedList && n.startContext(Z.OrderedList, e.basePos, e.text.charCodeAt(e.pos + t - 1));
    let i = rm(e, e.pos + t);
    return n.startContext(Z.ListItem, e.basePos, i - e.baseIndent), n.addNode(Z.ListMark, n.lineStart + e.pos, n.lineStart + e.pos + t), e.moveBaseColumn(i), null;
  },
  ATXHeading(n, e) {
    let t = Db(e);
    if (t < 0)
      return !1;
    let i = e.pos, r = n.lineStart + i, s = im(e.text, e.text.length, i), o = s;
    for (; o > i && e.text.charCodeAt(o - 1) == e.next; )
      o--;
    (o == s || o == i || !_t(e.text.charCodeAt(o - 1))) && (o = e.text.length);
    let a = n.buffer.write(Z.HeaderMark, 0, t).writeElements(n.parser.parseInline(e.text.slice(i + t + 1, o), r + t + 1), -r);
    o < e.text.length && a.write(Z.HeaderMark, o - i, s - i);
    let l = a.finish(Z.ATXHeading1 - 1 + t, e.text.length - i);
    return n.nextLine(), n.addNode(l, r), !0;
  },
  HTMLBlock(n, e) {
    let t = Xb(e, n, !1);
    if (t < 0)
      return !1;
    let i = n.lineStart + e.pos, r = Mc[t][1], s = [], o = r != Rc;
    for (; !r.test(e.text) && n.nextLine(); ) {
      if (e.depth < n.stack.length) {
        o = !1;
        break;
      }
      for (let u of e.markers)
        s.push(u);
    }
    o && n.nextLine();
    let a = r == Lb ? Z.CommentBlock : r == _b ? Z.ProcessingInstructionBlock : Z.HTMLBlock, l = n.prevLineEnd();
    return n.addNode(n.buffer.writeElements(s, -i).finish(a, l - i), i), !0;
  },
  SetextHeading: void 0
  // Specifies relative precedence for block-continue function
};
class sR {
  constructor(e) {
    this.stage = 0, this.elts = [], this.pos = 0, this.start = e.start, this.advance(e.content);
  }
  nextLine(e, t, i) {
    if (this.stage == -1)
      return !1;
    let r = i.content + `
` + t.scrub(), s = this.advance(r);
    return s > -1 && s < r.length ? this.complete(e, i, s) : !1;
  }
  finish(e, t) {
    return (this.stage == 2 || this.stage == 3) && es(t.content, this.pos) == t.content.length ? this.complete(e, t, t.content.length) : !1;
  }
  complete(e, t, i) {
    return e.addLeafElement(t, he(Z.LinkReference, this.start, this.start + i, this.elts)), !0;
  }
  nextStage(e) {
    return e ? (this.pos = e.to - this.start, this.elts.push(e), this.stage++, !0) : (e === !1 && (this.stage = -1), !1);
  }
  advance(e) {
    for (; ; ) {
      if (this.stage == -1)
        return -1;
      if (this.stage == 0) {
        if (!this.nextStage(Fb(e, this.pos, this.start, !0)))
          return -1;
        if (e.charCodeAt(this.pos) != 58)
          return this.stage = -1;
        this.elts.push(he(Z.LinkMark, this.pos + this.start, this.pos + this.start + 1)), this.pos++;
      } else if (this.stage == 1) {
        if (!this.nextStage(jb(e, es(e, this.pos), this.start)))
          return -1;
      } else if (this.stage == 2) {
        let t = es(e, this.pos), i = 0;
        if (t > this.pos) {
          let r = Ub(e, t, this.start);
          if (r) {
            let s = jl(e, r.to - this.start);
            s > 0 && (this.nextStage(r), i = s);
          }
        }
        return i || (i = jl(e, this.pos)), i > 0 && i < e.length ? i : -1;
      } else
        return jl(e, this.pos);
    }
  }
}
function jl(n, e) {
  for (; e < n.length; e++) {
    let t = n.charCodeAt(e);
    if (t == 10)
      break;
    if (!_t(t))
      return -1;
  }
  return e;
}
class oR {
  nextLine(e, t, i) {
    let r = t.depth < e.stack.length ? -1 : Ib(t), s = t.next;
    if (r < 0)
      return !1;
    let o = he(Z.HeaderMark, e.lineStart + t.pos, e.lineStart + r);
    return e.nextLine(), e.addLeafElement(i, he(s == 61 ? Z.SetextHeading1 : Z.SetextHeading2, i.start, e.prevLineEnd(), [
      ...e.parser.parseInline(i.content, i.start),
      o
    ])), !0;
  }
  finish() {
    return !1;
  }
}
const aR = {
  LinkReference(n, e) {
    return e.content.charCodeAt(0) == 91 ? new sR(e) : null;
  },
  SetextHeading() {
    return new oR();
  }
}, lR = [
  (n, e) => Db(e) >= 0,
  (n, e) => Zb(e) >= 0,
  (n, e) => Eb(e) >= 0,
  (n, e) => tf(e, n, !0) >= 0,
  (n, e) => nf(e, n, !0) >= 0,
  (n, e) => ef(e, n, !0) >= 0,
  (n, e) => Xb(e, n, !0) >= 0
], uR = { text: "", end: 0 };
class cR {
  /// @internal
  constructor(e, t, i, r) {
    this.parser = e, this.input = t, this.ranges = r, this.line = new rR(), this.atEnd = !1, this.reusePlaceholders = /* @__PURE__ */ new Map(), this.stoppedAt = null, this.rangeI = 0, this.to = r[r.length - 1].to, this.lineStart = this.absoluteLineStart = this.absoluteLineEnd = r[0].from, this.block = Ma.create(Z.Document, 0, this.lineStart, 0, 0), this.stack = [this.block], this.fragments = i.length ? new pR(i, t) : null, this.readLine();
  }
  get parsedPos() {
    return this.absoluteLineStart;
  }
  advance() {
    if (this.stoppedAt != null && this.absoluteLineStart > this.stoppedAt)
      return this.finish();
    let { line: e } = this;
    for (; ; ) {
      for (let i = 0; ; ) {
        let r = e.depth < this.stack.length ? this.stack[this.stack.length - 1] : null;
        for (; i < e.markers.length && (!r || e.markers[i].from < r.end); ) {
          let s = e.markers[i++];
          this.addNode(s.type, s.from, s.to);
        }
        if (!r)
          break;
        this.finishContext();
      }
      if (e.pos < e.text.length)
        break;
      if (!this.nextLine())
        return this.finish();
    }
    if (this.fragments && this.reuseFragment(e.basePos))
      return null;
    e:
      for (; ; ) {
        for (let i of this.parser.blockParsers)
          if (i) {
            let r = i(this, e);
            if (r != !1) {
              if (r == !0)
                return null;
              e.forward();
              continue e;
            }
          }
        break;
      }
    let t = new iR(this.lineStart + e.pos, e.text.slice(e.pos));
    for (let i of this.parser.leafBlockParsers)
      if (i) {
        let r = i(this, t);
        r && t.parsers.push(r);
      }
    e:
      for (; this.nextLine() && e.pos != e.text.length; ) {
        if (e.indent < e.baseIndent + 4) {
          for (let i of this.parser.endLeafBlock)
            if (i(this, e, t))
              break e;
        }
        for (let i of t.parsers)
          if (i.nextLine(this, e, t))
            return null;
        t.content += `
` + e.scrub();
        for (let i of e.markers)
          t.marks.push(i);
      }
    return this.finishLeaf(t), null;
  }
  stopAt(e) {
    if (this.stoppedAt != null && this.stoppedAt < e)
      throw new RangeError("Can't move stoppedAt forward");
    this.stoppedAt = e;
  }
  reuseFragment(e) {
    if (!this.fragments.moveTo(this.absoluteLineStart + e, this.absoluteLineStart) || !this.fragments.matches(this.block.hash))
      return !1;
    let t = this.fragments.takeNodes(this);
    return t ? (this.absoluteLineStart += t, this.lineStart = Gb(this.absoluteLineStart, this.ranges), this.moveRangeI(), this.absoluteLineStart < this.to ? (this.lineStart++, this.absoluteLineStart++, this.readLine()) : (this.atEnd = !0, this.readLine()), !0) : !1;
  }
  /// The number of parent blocks surrounding the current block.
  get depth() {
    return this.stack.length;
  }
  /// Get the type of the parent block at the given depth. When no
  /// depth is passed, return the type of the innermost parent.
  parentType(e = this.depth - 1) {
    return this.parser.nodeSet.types[this.stack[e].type];
  }
  /// Move to the next input line. This should only be called by
  /// (non-composite) [block parsers](#BlockParser.parse) that consume
  /// the line directly, or leaf block parser
  /// [`nextLine`](#LeafBlockParser.nextLine) methods when they
  /// consume the current line (and return true).
  nextLine() {
    return this.lineStart += this.line.text.length, this.absoluteLineEnd >= this.to ? (this.absoluteLineStart = this.absoluteLineEnd, this.atEnd = !0, this.readLine(), !1) : (this.lineStart++, this.absoluteLineStart = this.absoluteLineEnd + 1, this.moveRangeI(), this.readLine(), !0);
  }
  moveRangeI() {
    for (; this.rangeI < this.ranges.length - 1 && this.absoluteLineStart >= this.ranges[this.rangeI].to; )
      this.rangeI++, this.absoluteLineStart = Math.max(this.absoluteLineStart, this.ranges[this.rangeI].from);
  }
  /// @internal
  scanLine(e) {
    let t = uR;
    if (t.end = e, e >= this.to)
      t.text = "";
    else if (t.text = this.lineChunkAt(e), t.end += t.text.length, this.ranges.length > 1) {
      let i = this.absoluteLineStart, r = this.rangeI;
      for (; this.ranges[r].to < t.end; ) {
        r++;
        let s = this.ranges[r].from, o = this.lineChunkAt(s);
        t.end = s + o.length, t.text = t.text.slice(0, this.ranges[r - 1].to - i) + o, i = t.end - t.text.length;
      }
    }
    return t;
  }
  /// @internal
  readLine() {
    let { line: e } = this, { text: t, end: i } = this.scanLine(this.absoluteLineStart);
    for (this.absoluteLineEnd = i, e.reset(t); e.depth < this.stack.length; e.depth++) {
      let r = this.stack[e.depth], s = this.parser.skipContextMarkup[r.type];
      if (!s)
        throw new Error("Unhandled block context " + Z[r.type]);
      if (!s(r, this, e))
        break;
      e.forward();
    }
  }
  lineChunkAt(e) {
    let t = this.input.chunk(e), i;
    if (this.input.lineChunks)
      i = t == `
` ? "" : t;
    else {
      let r = t.indexOf(`
`);
      i = r < 0 ? t : t.slice(0, r);
    }
    return e + i.length > this.to ? i.slice(0, this.to - e) : i;
  }
  /// The end position of the previous line.
  prevLineEnd() {
    return this.atEnd ? this.lineStart : this.lineStart - 1;
  }
  /// @internal
  startContext(e, t, i = 0) {
    this.block = Ma.create(e, i, this.lineStart + t, this.block.hash, this.lineStart + this.line.text.length), this.stack.push(this.block);
  }
  /// Start a composite block. Should only be called from [block
  /// parser functions](#BlockParser.parse) that return null.
  startComposite(e, t, i = 0) {
    this.startContext(this.parser.getNodeType(e), t, i);
  }
  /// @internal
  addNode(e, t, i) {
    typeof e == "number" && (e = new ge(this.parser.nodeSet.types[e], ur, ur, (i ?? this.prevLineEnd()) - t)), this.block.addChild(e, t - this.block.from);
  }
  /// Add a block element. Can be called by [block
  /// parsers](#BlockParser.parse).
  addElement(e) {
    this.block.addChild(e.toTree(this.parser.nodeSet), e.from - this.block.from);
  }
  /// Add a block element from a [leaf parser](#LeafBlockParser). This
  /// makes sure any extra composite block markup (such as blockquote
  /// markers) inside the block are also added to the syntax tree.
  addLeafElement(e, t) {
    this.addNode(this.buffer.writeElements(zc(t.children, e.marks), -t.from).finish(t.type, t.to - t.from), t.from);
  }
  /// @internal
  finishContext() {
    let e = this.stack.pop(), t = this.stack[this.stack.length - 1];
    t.addChild(e.toTree(this.parser.nodeSet), e.from - t.from), this.block = t;
  }
  finish() {
    for (; this.stack.length > 1; )
      this.finishContext();
    return this.addGaps(this.block.toTree(this.parser.nodeSet, this.lineStart));
  }
  addGaps(e) {
    return this.ranges.length > 1 ? Nb(this.ranges, 0, e.topNode, this.ranges[0].from, this.reusePlaceholders) : e;
  }
  /// @internal
  finishLeaf(e) {
    for (let i of e.parsers)
      if (i.finish(this, e))
        return;
    let t = zc(this.parser.parseInline(e.content, e.start), e.marks);
    this.addNode(this.buffer.writeElements(t, -e.start).finish(Z.Paragraph, e.content.length), e.start);
  }
  elt(e, t, i, r) {
    return typeof e == "string" ? he(this.parser.getNodeType(e), t, i, r) : new Bb(e, t);
  }
  /// @internal
  get buffer() {
    return new qb(this.parser.nodeSet);
  }
}
function Nb(n, e, t, i, r) {
  let s = n[e].to, o = [], a = [], l = t.from + i;
  function u(c, h) {
    for (; h ? c >= s : c > s; ) {
      let f = n[e + 1].from - s;
      i += f, c += f, e++, s = n[e].to;
    }
  }
  for (let c = t.firstChild; c; c = c.nextSibling) {
    u(c.from + i, !0);
    let h = c.from + i, f, d = r.get(c.tree);
    d ? f = d : c.to + i > s ? (f = Nb(n, e, c, i, r), u(c.to + i, !1)) : f = c.toTree(), o.push(f), a.push(h - l);
  }
  return u(t.to + i, !1), new ge(t.type, o, a, t.to + i - l, t.tree ? t.tree.propValues : void 0);
}
class cl extends ph {
  /// @internal
  constructor(e, t, i, r, s, o, a, l, u) {
    super(), this.nodeSet = e, this.blockParsers = t, this.leafBlockParsers = i, this.blockNames = r, this.endLeafBlock = s, this.skipContextMarkup = o, this.inlineParsers = a, this.inlineNames = l, this.wrappers = u, this.nodeTypes = /* @__PURE__ */ Object.create(null);
    for (let c of e.types)
      this.nodeTypes[c.name] = c.id;
  }
  createParse(e, t, i) {
    let r = new cR(this, e, t, i);
    for (let s of this.wrappers)
      r = s(r, e, t, i);
    return r;
  }
  /// Reconfigure the parser.
  configure(e) {
    let t = Zc(e);
    if (!t)
      return this;
    let { nodeSet: i, skipContextMarkup: r } = this, s = this.blockParsers.slice(), o = this.leafBlockParsers.slice(), a = this.blockNames.slice(), l = this.inlineParsers.slice(), u = this.inlineNames.slice(), c = this.endLeafBlock.slice(), h = this.wrappers;
    if (Zr(t.defineNodes)) {
      r = Object.assign({}, r);
      let f = i.types.slice(), d;
      for (let p of t.defineNodes) {
        let { name: g, block: O, composite: m, style: b } = typeof p == "string" ? { name: p } : p;
        if (f.some((v) => v.name == g))
          continue;
        m && (r[f.length] = (v, k, C) => m(k, C, v.value));
        let w = f.length, Q = m ? ["Block", "BlockContext"] : O ? w >= Z.ATXHeading1 && w <= Z.SetextHeading2 ? ["Block", "LeafBlock", "Heading"] : ["Block", "LeafBlock"] : void 0;
        f.push(qe.define({
          id: w,
          name: g,
          props: Q && [[J.group, Q]]
        })), b && (d || (d = {}), Array.isArray(b) || b instanceof Wt ? d[g] = b : Object.assign(d, b));
      }
      i = new zs(f), d && (i = i.extend(pr(d)));
    }
    if (Zr(t.props) && (i = i.extend(...t.props)), Zr(t.remove))
      for (let f of t.remove) {
        let d = this.blockNames.indexOf(f), p = this.inlineNames.indexOf(f);
        d > -1 && (s[d] = o[d] = void 0), p > -1 && (l[p] = void 0);
      }
    if (Zr(t.parseBlock))
      for (let f of t.parseBlock) {
        let d = a.indexOf(f.name);
        if (d > -1)
          s[d] = f.parse, o[d] = f.leaf;
        else {
          let p = f.before ? Ao(a, f.before) : f.after ? Ao(a, f.after) + 1 : a.length - 1;
          s.splice(p, 0, f.parse), o.splice(p, 0, f.leaf), a.splice(p, 0, f.name);
        }
        f.endLeaf && c.push(f.endLeaf);
      }
    if (Zr(t.parseInline))
      for (let f of t.parseInline) {
        let d = u.indexOf(f.name);
        if (d > -1)
          l[d] = f.parse;
        else {
          let p = f.before ? Ao(u, f.before) : f.after ? Ao(u, f.after) + 1 : u.length - 1;
          l.splice(p, 0, f.parse), u.splice(p, 0, f.name);
        }
      }
    return t.wrap && (h = h.concat(t.wrap)), new cl(i, s, o, a, c, r, l, u, h);
  }
  /// @internal
  getNodeType(e) {
    let t = this.nodeTypes[e];
    if (t == null)
      throw new RangeError(`Unknown node type '${e}'`);
    return t;
  }
  /// Parse the given piece of inline text at the given offset,
  /// returning an array of [`Element`](#Element) objects representing
  /// the inline content.
  parseInline(e, t) {
    let i = new fR(this, e, t);
    e:
      for (let r = t; r < i.end; ) {
        let s = i.char(r);
        for (let o of this.inlineParsers)
          if (o) {
            let a = o(i, s, r);
            if (a >= 0) {
              r = a;
              continue e;
            }
          }
        r++;
      }
    return i.resolveMarkers(0);
  }
}
function Zr(n) {
  return n != null && n.length > 0;
}
function Zc(n) {
  if (!Array.isArray(n))
    return n;
  if (n.length == 0)
    return null;
  let e = Zc(n[0]);
  if (n.length == 1)
    return e;
  let t = Zc(n.slice(1));
  if (!t || !e)
    return e || t;
  let i = (o, a) => (o || ur).concat(a || ur), r = e.wrap, s = t.wrap;
  return {
    props: i(e.props, t.props),
    defineNodes: i(e.defineNodes, t.defineNodes),
    parseBlock: i(e.parseBlock, t.parseBlock),
    parseInline: i(e.parseInline, t.parseInline),
    remove: i(e.remove, t.remove),
    wrap: r ? s ? (o, a, l, u) => r(s(o, a, l, u), a, l, u) : r : s
  };
}
function Ao(n, e) {
  let t = n.indexOf(e);
  if (t < 0)
    throw new RangeError(`Position specified relative to unknown parser ${e}`);
  return t;
}
let Wb = [qe.none];
for (let n = 1, e; e = Z[n]; n++)
  Wb[n] = qe.define({
    id: n,
    name: e,
    props: n >= Z.Escape ? [] : [[J.group, n in Mb ? ["Block", "BlockContext"] : ["Block", "LeafBlock"]]],
    top: e == "Document"
  });
const ur = [];
class qb {
  constructor(e) {
    this.nodeSet = e, this.content = [], this.nodes = [];
  }
  write(e, t, i, r = 0) {
    return this.content.push(e, t, i, 4 + r * 4), this;
  }
  writeElements(e, t = 0) {
    for (let i of e)
      i.writeTo(this, t);
    return this;
  }
  finish(e, t) {
    return ge.build({
      buffer: this.content,
      nodeSet: this.nodeSet,
      reused: this.nodes,
      topID: e,
      length: t
    });
  }
}
let Qs = class {
  /// @internal
  constructor(e, t, i, r = ur) {
    this.type = e, this.from = t, this.to = i, this.children = r;
  }
  /// @internal
  writeTo(e, t) {
    let i = e.content.length;
    e.writeElements(this.children, t), e.content.push(this.type, this.from + t, this.to + t, e.content.length + 4 - i);
  }
  /// @internal
  toTree(e) {
    return new qb(e).writeElements(this.children, -this.from).finish(this.type, this.to - this.from);
  }
};
class Bb {
  constructor(e, t) {
    this.tree = e, this.from = t;
  }
  get to() {
    return this.from + this.tree.length;
  }
  get type() {
    return this.tree.type.id;
  }
  get children() {
    return ur;
  }
  writeTo(e, t) {
    e.nodes.push(this.tree), e.content.push(e.nodes.length - 1, this.from + t, this.to + t, -1);
  }
  toTree() {
    return this.tree;
  }
}
function he(n, e, t, i) {
  return new Qs(n, e, t, i);
}
const Vb = { resolve: "Emphasis", mark: "EmphasisMark" }, Yb = { resolve: "Emphasis", mark: "EmphasisMark" }, _i = {}, Ec = {};
class Tt {
  constructor(e, t, i, r) {
    this.type = e, this.from = t, this.to = i, this.side = r;
  }
}
const sm = "!\"#$%&'()*+,-./:;<=>?@[\\]^_`{|}~";
let $s = /[!"#$%&'()*+,\-.\/:;<=>?@\[\\\]^_`{|}~\xA1\u2010-\u2027]/;
try {
  $s = new RegExp("[\\p{Pc}|\\p{Pd}|\\p{Pe}|\\p{Pf}|\\p{Pi}|\\p{Po}|\\p{Ps}]", "u");
} catch {
}
const Ul = {
  Escape(n, e, t) {
    if (e != 92 || t == n.end - 1)
      return -1;
    let i = n.char(t + 1);
    for (let r = 0; r < sm.length; r++)
      if (sm.charCodeAt(r) == i)
        return n.append(he(Z.Escape, t, t + 2));
    return -1;
  },
  Entity(n, e, t) {
    if (e != 38)
      return -1;
    let i = /^(?:#\d+|#x[a-f\d]+|\w+);/i.exec(n.slice(t + 1, t + 31));
    return i ? n.append(he(Z.Entity, t, t + 1 + i[0].length)) : -1;
  },
  InlineCode(n, e, t) {
    if (e != 96 || t && n.char(t - 1) == 96)
      return -1;
    let i = t + 1;
    for (; i < n.end && n.char(i) == 96; )
      i++;
    let r = i - t, s = 0;
    for (; i < n.end; i++)
      if (n.char(i) == 96) {
        if (s++, s == r && n.char(i + 1) != 96)
          return n.append(he(Z.InlineCode, t, i + 1, [
            he(Z.CodeMark, t, t + r),
            he(Z.CodeMark, i + 1 - r, i + 1)
          ]));
      } else
        s = 0;
    return -1;
  },
  HTMLTag(n, e, t) {
    if (e != 60 || t == n.end - 1)
      return -1;
    let i = n.slice(t + 1, n.end), r = /^(?:[a-z][-\w+.]+:[^\s>]+|[a-z\d.!#$%&'*+/=?^_`{|}~-]+@[a-z\d](?:[a-z\d-]{0,61}[a-z\d])?(?:\.[a-z\d](?:[a-z\d-]{0,61}[a-z\d])?)*)>/i.exec(i);
    if (r)
      return n.append(he(Z.Autolink, t, t + 1 + r[0].length, [
        he(Z.LinkMark, t, t + 1),
        // url[0] includes the closing bracket, so exclude it from this slice
        he(Z.URL, t + 1, t + r[0].length),
        he(Z.LinkMark, t + r[0].length, t + 1 + r[0].length)
      ]));
    let s = /^!--[^>](?:-[^-]|[^-])*?-->/i.exec(i);
    if (s)
      return n.append(he(Z.Comment, t, t + 1 + s[0].length));
    let o = /^\?[^]*?\?>/.exec(i);
    if (o)
      return n.append(he(Z.ProcessingInstruction, t, t + 1 + o[0].length));
    let a = /^(?:![A-Z][^]*?>|!\[CDATA\[[^]*?\]\]>|\/\s*[a-zA-Z][\w-]*\s*>|\s*[a-zA-Z][\w-]*(\s+[a-zA-Z:_][\w-.:]*(?:\s*=\s*(?:[^\s"'=<>`]+|'[^']*'|"[^"]*"))?)*\s*(\/\s*)?>)/.exec(i);
    return a ? n.append(he(Z.HTMLTag, t, t + 1 + a[0].length)) : -1;
  },
  Emphasis(n, e, t) {
    if (e != 95 && e != 42)
      return -1;
    let i = t + 1;
    for (; n.char(i) == e; )
      i++;
    let r = n.slice(t - 1, t), s = n.slice(i, i + 1), o = $s.test(r), a = $s.test(s), l = /\s|^$/.test(r), u = /\s|^$/.test(s), c = !u && (!a || l || o), h = !l && (!o || u || a), f = c && (e == 42 || !h || o), d = h && (e == 42 || !c || a);
    return n.append(new Tt(e == 95 ? Vb : Yb, t, i, (f ? 1 : 0) | (d ? 2 : 0)));
  },
  HardBreak(n, e, t) {
    if (e == 92 && n.char(t + 1) == 10)
      return n.append(he(Z.HardBreak, t, t + 2));
    if (e == 32) {
      let i = t + 1;
      for (; n.char(i) == 32; )
        i++;
      if (n.char(i) == 10 && i >= t + 2)
        return n.append(he(Z.HardBreak, t, i + 1));
    }
    return -1;
  },
  Link(n, e, t) {
    return e == 91 ? n.append(new Tt(
      _i,
      t,
      t + 1,
      1
      /* Mark.Open */
    )) : -1;
  },
  Image(n, e, t) {
    return e == 33 && n.char(t + 1) == 91 ? n.append(new Tt(
      Ec,
      t,
      t + 2,
      1
      /* Mark.Open */
    )) : -1;
  },
  LinkEnd(n, e, t) {
    if (e != 93)
      return -1;
    for (let i = n.parts.length - 1; i >= 0; i--) {
      let r = n.parts[i];
      if (r instanceof Tt && (r.type == _i || r.type == Ec)) {
        if (!r.side || n.skipSpace(r.to) == t && !/[(\[]/.test(n.slice(t + 1, t + 2)))
          return n.parts[i] = null, -1;
        let s = n.takeContent(i), o = n.parts[i] = hR(n, s, r.type == _i ? Z.Link : Z.Image, r.from, t + 1);
        if (r.type == _i)
          for (let a = 0; a < i; a++) {
            let l = n.parts[a];
            l instanceof Tt && l.type == _i && (l.side = 0);
          }
        return o.to;
      }
    }
    return -1;
  }
};
function hR(n, e, t, i, r) {
  let { text: s } = n, o = n.char(r), a = r;
  if (e.unshift(he(Z.LinkMark, i, i + (t == Z.Image ? 2 : 1))), e.push(he(Z.LinkMark, r - 1, r)), o == 40) {
    let l = n.skipSpace(r + 1), u = jb(s, l - n.offset, n.offset), c;
    u && (l = n.skipSpace(u.to), l != u.to && (c = Ub(s, l - n.offset, n.offset), c && (l = n.skipSpace(c.to)))), n.char(l) == 41 && (e.push(he(Z.LinkMark, r, r + 1)), a = l + 1, u && e.push(u), c && e.push(c), e.push(he(Z.LinkMark, l, a)));
  } else if (o == 91) {
    let l = Fb(s, r - n.offset, n.offset, !1);
    l && (e.push(l), a = l.to);
  }
  return he(t, i, a, e);
}
function jb(n, e, t) {
  if (n.charCodeAt(e) == 60) {
    for (let r = e + 1; r < n.length; r++) {
      let s = n.charCodeAt(r);
      if (s == 62)
        return he(Z.URL, e + t, r + 1 + t);
      if (s == 60 || s == 10)
        return !1;
    }
    return null;
  } else {
    let r = 0, s = e;
    for (let o = !1; s < n.length; s++) {
      let a = n.charCodeAt(s);
      if (_t(a))
        break;
      if (o)
        o = !1;
      else if (a == 40)
        r++;
      else if (a == 41) {
        if (!r)
          break;
        r--;
      } else
        a == 92 && (o = !0);
    }
    return s > e ? he(Z.URL, e + t, s + t) : s == n.length ? null : !1;
  }
}
function Ub(n, e, t) {
  let i = n.charCodeAt(e);
  if (i != 39 && i != 34 && i != 40)
    return !1;
  let r = i == 40 ? 41 : i;
  for (let s = e + 1, o = !1; s < n.length; s++) {
    let a = n.charCodeAt(s);
    if (o)
      o = !1;
    else {
      if (a == r)
        return he(Z.LinkTitle, e + t, s + 1 + t);
      a == 92 && (o = !0);
    }
  }
  return null;
}
function Fb(n, e, t, i) {
  for (let r = !1, s = e + 1, o = Math.min(n.length, s + 999); s < o; s++) {
    let a = n.charCodeAt(s);
    if (r)
      r = !1;
    else {
      if (a == 93)
        return i ? !1 : he(Z.LinkLabel, e + t, s + 1 + t);
      if (i && !_t(a) && (i = !1), a == 91)
        return !1;
      a == 92 && (r = !0);
    }
  }
  return null;
}
class fR {
  /// @internal
  constructor(e, t, i) {
    this.parser = e, this.text = t, this.offset = i, this.parts = [];
  }
  /// Get the character code at the given (document-relative)
  /// position.
  char(e) {
    return e >= this.end ? -1 : this.text.charCodeAt(e - this.offset);
  }
  /// The position of the end of this inline section.
  get end() {
    return this.offset + this.text.length;
  }
  /// Get a substring of this inline section. Again uses
  /// document-relative positions.
  slice(e, t) {
    return this.text.slice(e - this.offset, t - this.offset);
  }
  /// @internal
  append(e) {
    return this.parts.push(e), e.to;
  }
  /// Add a [delimiter](#DelimiterType) at this given position. `open`
  /// and `close` indicate whether this delimiter is opening, closing,
  /// or both. Returns the end of the delimiter, for convenient
  /// returning from [parse functions](#InlineParser.parse).
  addDelimiter(e, t, i, r, s) {
    return this.append(new Tt(e, t, i, (r ? 1 : 0) | (s ? 2 : 0)));
  }
  /// Returns true when there is an unmatched link or image opening
  /// token before the current position.
  get hasOpenLink() {
    for (let e = this.parts.length - 1; e >= 0; e--) {
      let t = this.parts[e];
      if (t instanceof Tt && (t.type == _i || t.type == Ec))
        return !0;
    }
    return !1;
  }
  /// Add an inline element. Returns the end of the element.
  addElement(e) {
    return this.append(e);
  }
  /// Resolve markers between this.parts.length and from, wrapping matched markers in the
  /// appropriate node and updating the content of this.parts. @internal
  resolveMarkers(e) {
    for (let i = e; i < this.parts.length; i++) {
      let r = this.parts[i];
      if (!(r instanceof Tt && r.type.resolve && r.side & 2))
        continue;
      let s = r.type == Vb || r.type == Yb, o = r.to - r.from, a, l = i - 1;
      for (; l >= e; l--) {
        let g = this.parts[l];
        if (g instanceof Tt && g.side & 1 && g.type == r.type && // Ignore emphasis delimiters where the character count doesn't match
        !(s && (r.side & 1 || g.side & 2) && (g.to - g.from + o) % 3 == 0 && ((g.to - g.from) % 3 || o % 3))) {
          a = g;
          break;
        }
      }
      if (!a)
        continue;
      let u = r.type.resolve, c = [], h = a.from, f = r.to;
      if (s) {
        let g = Math.min(2, a.to - a.from, o);
        h = a.to - g, f = r.from + g, u = g == 1 ? "Emphasis" : "StrongEmphasis";
      }
      a.type.mark && c.push(this.elt(a.type.mark, h, a.to));
      for (let g = l + 1; g < i; g++)
        this.parts[g] instanceof Qs && c.push(this.parts[g]), this.parts[g] = null;
      r.type.mark && c.push(this.elt(r.type.mark, r.from, f));
      let d = this.elt(u, h, f, c);
      this.parts[l] = s && a.from != h ? new Tt(a.type, a.from, h, a.side) : null, (this.parts[i] = s && r.to != f ? new Tt(r.type, f, r.to, r.side) : null) ? this.parts.splice(i, 0, d) : this.parts[i] = d;
    }
    let t = [];
    for (let i = e; i < this.parts.length; i++) {
      let r = this.parts[i];
      r instanceof Qs && t.push(r);
    }
    return t;
  }
  /// Find an opening delimiter of the given type. Returns `null` if
  /// no delimiter is found, or an index that can be passed to
  /// [`takeContent`](#InlineContext.takeContent) otherwise.
  findOpeningDelimiter(e) {
    for (let t = this.parts.length - 1; t >= 0; t--) {
      let i = this.parts[t];
      if (i instanceof Tt && i.type == e)
        return t;
    }
    return null;
  }
  /// Remove all inline elements and delimiters starting from the
  /// given index (which you should get from
  /// [`findOpeningDelimiter`](#InlineContext.findOpeningDelimiter),
  /// resolve delimiters inside of them, and return them as an array
  /// of elements.
  takeContent(e) {
    let t = this.resolveMarkers(e);
    return this.parts.length = e, t;
  }
  /// Skip space after the given (document) position, returning either
  /// the position of the next non-space character or the end of the
  /// section.
  skipSpace(e) {
    return es(this.text, e - this.offset) + this.offset;
  }
  elt(e, t, i, r) {
    return typeof e == "string" ? he(this.parser.getNodeType(e), t, i, r) : new Bb(e, t);
  }
}
function zc(n, e) {
  if (!e.length)
    return n;
  if (!n.length)
    return e;
  let t = n.slice(), i = 0;
  for (let r of e) {
    for (; i < t.length && t[i].to < r.to; )
      i++;
    if (i < t.length && t[i].from < r.from) {
      let s = t[i];
      s instanceof Qs && (t[i] = new Qs(s.type, s.from, s.to, zc(s.children, [r])));
    } else
      t.splice(i++, 0, r);
  }
  return t;
}
const dR = [Z.CodeBlock, Z.ListItem, Z.OrderedList, Z.BulletList];
let pR = class {
  constructor(e, t) {
    this.fragments = e, this.input = t, this.i = 0, this.fragment = null, this.fragmentEnd = -1, this.cursor = null, e.length && (this.fragment = e[this.i++]);
  }
  nextFragment() {
    this.fragment = this.i < this.fragments.length ? this.fragments[this.i++] : null, this.cursor = null, this.fragmentEnd = -1;
  }
  moveTo(e, t) {
    for (; this.fragment && this.fragment.to <= e; )
      this.nextFragment();
    if (!this.fragment || this.fragment.from > (e ? e - 1 : 0))
      return !1;
    if (this.fragmentEnd < 0) {
      let s = this.fragment.to;
      for (; s > 0 && this.input.read(s - 1, s) != `
`; )
        s--;
      this.fragmentEnd = s ? s - 1 : 0;
    }
    let i = this.cursor;
    i || (i = this.cursor = this.fragment.tree.cursor(), i.firstChild());
    let r = e + this.fragment.offset;
    for (; i.to <= r; )
      if (!i.parent())
        return !1;
    for (; ; ) {
      if (i.from >= r)
        return this.fragment.from <= t;
      if (!i.childAfter(r))
        return !1;
    }
  }
  matches(e) {
    let t = this.cursor.tree;
    return t && t.prop(J.contextHash) == e;
  }
  takeNodes(e) {
    let t = this.cursor, i = this.fragment.offset, r = this.fragmentEnd - (this.fragment.openEnd ? 1 : 0), s = e.absoluteLineStart, o = s, a = e.block.children.length, l = o, u = a;
    for (; ; ) {
      if (t.to - i > r) {
        if (t.type.isAnonymous && t.firstChild())
          continue;
        break;
      }
      let c = Gb(t.from - i, e.ranges);
      if (t.to - i <= e.ranges[e.rangeI].to)
        e.addNode(t.tree, c);
      else {
        let h = new ge(e.parser.nodeSet.types[Z.Paragraph], [], [], 0, e.block.hashProp);
        e.reusePlaceholders.set(h, t.tree), e.addNode(h, c);
      }
      if (t.type.is("Block") && (dR.indexOf(t.type.id) < 0 ? (o = t.to - i, a = e.block.children.length) : (o = l, a = u, l = t.to - i, u = e.block.children.length)), !t.nextSibling())
        break;
    }
    for (; e.block.children.length > a; )
      e.block.children.pop(), e.block.positions.pop();
    return o - s;
  }
};
function Gb(n, e) {
  let t = n;
  for (let i = 1; i < e.length; i++) {
    let r = e[i - 1].to, s = e[i].from;
    r < n && (t -= s - r);
  }
  return t;
}
const mR = pr({
  "Blockquote/...": x.quote,
  HorizontalRule: x.contentSeparator,
  "ATXHeading1/... SetextHeading1/...": x.heading1,
  "ATXHeading2/... SetextHeading2/...": x.heading2,
  "ATXHeading3/...": x.heading3,
  "ATXHeading4/...": x.heading4,
  "ATXHeading5/...": x.heading5,
  "ATXHeading6/...": x.heading6,
  "Comment CommentBlock": x.comment,
  Escape: x.escape,
  Entity: x.character,
  "Emphasis/...": x.emphasis,
  "StrongEmphasis/...": x.strong,
  "Link/... Image/...": x.link,
  "OrderedList/... BulletList/...": x.list,
  "BlockQuote/...": x.quote,
  "InlineCode CodeText": x.monospace,
  "URL Autolink": x.url,
  "HeaderMark HardBreak QuoteMark ListMark LinkMark EmphasisMark CodeMark": x.processingInstruction,
  "CodeInfo LinkLabel": x.labelName,
  LinkTitle: x.string,
  Paragraph: x.content
}), gR = new cl(new zs(Wb).extend(mR), Object.keys(To).map((n) => To[n]), Object.keys(To).map((n) => aR[n]), Object.keys(To), lR, Mb, Object.keys(Ul).map((n) => Ul[n]), Object.keys(Ul), []);
function OR(n, e, t) {
  let i = [];
  for (let r = n.firstChild, s = e; ; r = r.nextSibling) {
    let o = r ? r.from : t;
    if (o > s && i.push({ from: s, to: o }), !r)
      break;
    s = r.to;
  }
  return i;
}
function bR(n) {
  let { codeParser: e, htmlParser: t } = n;
  return { wrap: HO((r, s) => {
    let o = r.type.id;
    if (e && (o == Z.CodeBlock || o == Z.FencedCode)) {
      let a = "";
      if (o == Z.FencedCode) {
        let u = r.node.getChild(Z.CodeInfo);
        u && (a = s.read(u.from, u.to));
      }
      let l = e(a);
      if (l)
        return { parser: l, overlay: (u) => u.type.id == Z.CodeText };
    } else if (t && (o == Z.HTMLBlock || o == Z.HTMLTag))
      return { parser: t, overlay: OR(r.node, r.from, r.to) };
    return null;
  }) };
}
const yR = { resolve: "Strikethrough", mark: "StrikethroughMark" }, kR = {
  defineNodes: [{
    name: "Strikethrough",
    style: { "Strikethrough/...": x.strikethrough }
  }, {
    name: "StrikethroughMark",
    style: x.processingInstruction
  }],
  parseInline: [{
    name: "Strikethrough",
    parse(n, e, t) {
      if (e != 126 || n.char(t + 1) != 126 || n.char(t + 2) == 126)
        return -1;
      let i = n.slice(t - 1, t), r = n.slice(t + 2, t + 3), s = /\s|^$/.test(i), o = /\s|^$/.test(r), a = $s.test(i), l = $s.test(r);
      return n.addDelimiter(yR, t, t + 2, !o && (!l || s || a), !s && (!a || o || l));
    },
    after: "Emphasis"
  }]
};
function ts(n, e, t = 0, i, r = 0) {
  let s = 0, o = !0, a = -1, l = -1, u = !1, c = () => {
    i.push(n.elt("TableCell", r + a, r + l, n.parser.parseInline(e.slice(a, l), r + a)));
  };
  for (let h = t; h < e.length; h++) {
    let f = e.charCodeAt(h);
    f == 124 && !u ? ((!o || a > -1) && s++, o = !1, i && (a > -1 && c(), i.push(n.elt("TableDelimiter", h + r, h + r + 1))), a = l = -1) : (u || f != 32 && f != 9) && (a < 0 && (a = h), l = h + 1), u = !u && f == 92;
  }
  return a > -1 && (s++, i && c()), s;
}
function om(n, e) {
  for (let t = e; t < n.length; t++) {
    let i = n.charCodeAt(t);
    if (i == 124)
      return !0;
    i == 92 && t++;
  }
  return !1;
}
const Hb = /^\|?(\s*:?-+:?\s*\|)+(\s*:?-+:?\s*)?$/;
class am {
  constructor() {
    this.rows = null;
  }
  nextLine(e, t, i) {
    if (this.rows == null) {
      this.rows = !1;
      let r;
      if ((t.next == 45 || t.next == 58 || t.next == 124) && Hb.test(r = t.text.slice(t.pos))) {
        let s = [];
        ts(e, i.content, 0, s, i.start) == ts(e, r, t.pos) && (this.rows = [
          e.elt("TableHeader", i.start, i.start + i.content.length, s),
          e.elt("TableDelimiter", e.lineStart + t.pos, e.lineStart + t.text.length)
        ]);
      }
    } else if (this.rows) {
      let r = [];
      ts(e, t.text, t.pos, r, e.lineStart), this.rows.push(e.elt("TableRow", e.lineStart + t.pos, e.lineStart + t.text.length, r));
    }
    return !1;
  }
  finish(e, t) {
    return this.rows ? (e.addLeafElement(t, e.elt("Table", t.start, t.start + t.content.length, this.rows)), !0) : !1;
  }
}
const xR = {
  defineNodes: [
    { name: "Table", block: !0 },
    { name: "TableHeader", style: { "TableHeader/...": x.heading } },
    "TableRow",
    { name: "TableCell", style: x.content },
    { name: "TableDelimiter", style: x.processingInstruction }
  ],
  parseBlock: [{
    name: "Table",
    leaf(n, e) {
      return om(e.content, 0) ? new am() : null;
    },
    endLeaf(n, e, t) {
      if (t.parsers.some((r) => r instanceof am) || !om(e.text, e.basePos))
        return !1;
      let i = n.scanLine(n.absoluteLineEnd + 1).text;
      return Hb.test(i) && ts(n, e.text, e.basePos) == ts(n, i, e.basePos);
    },
    before: "SetextHeading"
  }]
};
class wR {
  nextLine() {
    return !1;
  }
  finish(e, t) {
    return e.addLeafElement(t, e.elt("Task", t.start, t.start + t.content.length, [
      e.elt("TaskMarker", t.start, t.start + 3),
      ...e.parser.parseInline(t.content.slice(3), t.start + 3)
    ])), !0;
  }
}
const SR = {
  defineNodes: [
    { name: "Task", block: !0, style: x.list },
    { name: "TaskMarker", style: x.atom }
  ],
  parseBlock: [{
    name: "TaskList",
    leaf(n, e) {
      return /^\[[ xX]\][ \t]/.test(e.content) && n.parentType().name == "ListItem" ? new wR() : null;
    },
    after: "SetextHeading"
  }]
}, lm = /(www\.)|(https?:\/\/)|([\w.+-]+@)|(mailto:|xmpp:)/gy, um = /[\w-]+(\.[\w-]+)+(\/[^\s<]*)?/gy, vR = /[\w-]+\.[\w-]+($|\/)/, cm = /[\w.+-]+@[\w-]+(\.[\w.-]+)+/gy, hm = /\/[a-zA-Z\d@.]+/gy;
function fm(n, e, t, i) {
  let r = 0;
  for (let s = e; s < t; s++)
    n[s] == i && r++;
  return r;
}
function PR(n, e) {
  um.lastIndex = e;
  let t = um.exec(n);
  if (!t || vR.exec(t[0])[0].indexOf("_") > -1)
    return -1;
  let i = e + t[0].length;
  for (; ; ) {
    let r = n[i - 1], s;
    if (/[?!.,:*_~]/.test(r) || r == ")" && fm(n, e, i, ")") > fm(n, e, i, "("))
      i--;
    else if (r == ";" && (s = /&(?:#\d+|#x[a-f\d]+|\w+);$/.exec(n.slice(e, i))))
      i = e + s.index;
    else
      break;
  }
  return i;
}
function dm(n, e) {
  cm.lastIndex = e;
  let t = cm.exec(n);
  if (!t)
    return -1;
  let i = t[0][t[0].length - 1];
  return i == "_" || i == "-" ? -1 : e + t[0].length - (i == "." ? 1 : 0);
}
const QR = {
  parseInline: [{
    name: "Autolink",
    parse(n, e, t) {
      let i = t - n.offset;
      lm.lastIndex = i;
      let r = lm.exec(n.text), s = -1;
      if (!r)
        return -1;
      if (r[1] || r[2]) {
        if (s = PR(n.text, i + r[0].length), s > -1 && n.hasOpenLink) {
          let o = /([^\[\]]|\[[^\]]*\])*/.exec(n.text.slice(i, s));
          s = i + o[0].length;
        }
      } else
        r[3] ? s = dm(n.text, i) : (s = dm(n.text, i + r[0].length), s > -1 && r[0] == "xmpp:" && (hm.lastIndex = s, r = hm.exec(n.text), r && (s = r.index + r[0].length)));
      return s < 0 ? -1 : (n.addElement(n.elt("URL", t, s + n.offset)), s + n.offset);
    }
  }]
}, $R = [xR, SR, kR, QR];
function Kb(n, e, t) {
  return (i, r, s) => {
    if (r != n || i.char(s + 1) == n)
      return -1;
    let o = [i.elt(t, s, s + 1)];
    for (let a = s + 1; a < i.end; a++) {
      let l = i.char(a);
      if (l == n)
        return i.addElement(i.elt(e, s, a + 1, o.concat(i.elt(t, a, a + 1))));
      if (l == 92 && o.push(i.elt("Escape", a, a++ + 2)), _t(l))
        break;
    }
    return -1;
  };
}
const CR = {
  defineNodes: [
    { name: "Superscript", style: x.special(x.content) },
    { name: "SuperscriptMark", style: x.processingInstruction }
  ],
  parseInline: [{
    name: "Superscript",
    parse: Kb(94, "Superscript", "SuperscriptMark")
  }]
}, TR = {
  defineNodes: [
    { name: "Subscript", style: x.special(x.content) },
    { name: "SubscriptMark", style: x.processingInstruction }
  ],
  parseInline: [{
    name: "Subscript",
    parse: Kb(126, "Subscript", "SubscriptMark")
  }]
}, AR = {
  defineNodes: [{ name: "Emoji", style: x.character }],
  parseInline: [{
    name: "Emoji",
    parse(n, e, t) {
      let i;
      return e != 58 || !(i = /^[a-zA-Z_0-9]+:/.exec(n.slice(t + 1, n.end))) ? -1 : n.addElement(n.elt("Emoji", t, t + 1 + i[0].length));
    }
  }]
};
class Za {
  /**
  @internal
  */
  constructor(e, t, i, r, s, o, a, l, u, c = 0, h) {
    this.p = e, this.stack = t, this.state = i, this.reducePos = r, this.pos = s, this.score = o, this.buffer = a, this.bufferBase = l, this.curContext = u, this.lookAhead = c, this.parent = h;
  }
  /**
  @internal
  */
  toString() {
    return `[${this.stack.filter((e, t) => t % 3 == 0).concat(this.state)}]@${this.pos}${this.score ? "!" + this.score : ""}`;
  }
  // Start an empty stack
  /**
  @internal
  */
  static start(e, t, i = 0) {
    let r = e.parser.context;
    return new Za(e, [], t, i, i, 0, [], 0, r ? new pm(r, r.start) : null, 0, null);
  }
  /**
  The stack's current [context](#lr.ContextTracker) value, if
  any. Its type will depend on the context tracker's type
  parameter, or it will be `null` if there is no context
  tracker.
  */
  get context() {
    return this.curContext ? this.curContext.context : null;
  }
  // Push a state onto the stack, tracking its start position as well
  // as the buffer base at that point.
  /**
  @internal
  */
  pushState(e, t) {
    this.stack.push(this.state, t, this.bufferBase + this.buffer.length), this.state = e;
  }
  // Apply a reduce action
  /**
  @internal
  */
  reduce(e) {
    var t;
    let i = e >> 19, r = e & 65535, { parser: s } = this.p;
    this.reducePos < this.pos - 25 && this.setLookAhead(this.pos);
    let o = s.dynamicPrecedence(r);
    if (o && (this.score += o), i == 0) {
      this.pushState(s.getGoto(this.state, r, !0), this.reducePos), r < s.minRepeatTerm && this.storeNode(r, this.reducePos, this.reducePos, 4, !0), this.reduceContext(r, this.reducePos);
      return;
    }
    let a = this.stack.length - (i - 1) * 3 - (e & 262144 ? 6 : 0), l = a ? this.stack[a - 2] : this.p.ranges[0].from, u = this.reducePos - l;
    u >= 2e3 && !(!((t = this.p.parser.nodeSet.types[r]) === null || t === void 0) && t.isAnonymous) && (l == this.p.lastBigReductionStart ? (this.p.bigReductionCount++, this.p.lastBigReductionSize = u) : this.p.lastBigReductionSize < u && (this.p.bigReductionCount = 1, this.p.lastBigReductionStart = l, this.p.lastBigReductionSize = u));
    let c = a ? this.stack[a - 1] : 0, h = this.bufferBase + this.buffer.length - c;
    if (r < s.minRepeatTerm || e & 131072) {
      let f = s.stateFlag(
        this.state,
        1
        /* StateFlag.Skipped */
      ) ? this.pos : this.reducePos;
      this.storeNode(r, l, f, h + 4, !0);
    }
    if (e & 262144)
      this.state = this.stack[a];
    else {
      let f = this.stack[a - 3];
      this.state = s.getGoto(f, r, !0);
    }
    for (; this.stack.length > a; )
      this.stack.pop();
    this.reduceContext(r, l);
  }
  // Shift a value into the buffer
  /**
  @internal
  */
  storeNode(e, t, i, r = 4, s = !1) {
    if (e == 0 && (!this.stack.length || this.stack[this.stack.length - 1] < this.buffer.length + this.bufferBase)) {
      let o = this, a = this.buffer.length;
      if (a == 0 && o.parent && (a = o.bufferBase - o.parent.bufferBase, o = o.parent), a > 0 && o.buffer[a - 4] == 0 && o.buffer[a - 1] > -1) {
        if (t == i)
          return;
        if (o.buffer[a - 2] >= t) {
          o.buffer[a - 2] = i;
          return;
        }
      }
    }
    if (!s || this.pos == i)
      this.buffer.push(e, t, i, r);
    else {
      let o = this.buffer.length;
      if (o > 0 && this.buffer[o - 4] != 0)
        for (; o > 0 && this.buffer[o - 2] > i; )
          this.buffer[o] = this.buffer[o - 4], this.buffer[o + 1] = this.buffer[o - 3], this.buffer[o + 2] = this.buffer[o - 2], this.buffer[o + 3] = this.buffer[o - 1], o -= 4, r > 4 && (r -= 4);
      this.buffer[o] = e, this.buffer[o + 1] = t, this.buffer[o + 2] = i, this.buffer[o + 3] = r;
    }
  }
  // Apply a shift action
  /**
  @internal
  */
  shift(e, t, i, r) {
    if (e & 131072)
      this.pushState(e & 65535, this.pos);
    else if (e & 262144)
      this.pos = r, this.shiftContext(t, i), t <= this.p.parser.maxNode && this.buffer.push(t, i, r, 4);
    else {
      let s = e, { parser: o } = this.p;
      (r > this.pos || t <= o.maxNode) && (this.pos = r, o.stateFlag(
        s,
        1
        /* StateFlag.Skipped */
      ) || (this.reducePos = r)), this.pushState(s, i), this.shiftContext(t, i), t <= o.maxNode && this.buffer.push(t, i, r, 4);
    }
  }
  // Apply an action
  /**
  @internal
  */
  apply(e, t, i, r) {
    e & 65536 ? this.reduce(e) : this.shift(e, t, i, r);
  }
  // Add a prebuilt (reused) node into the buffer.
  /**
  @internal
  */
  useNode(e, t) {
    let i = this.p.reused.length - 1;
    (i < 0 || this.p.reused[i] != e) && (this.p.reused.push(e), i++);
    let r = this.pos;
    this.reducePos = this.pos = r + e.length, this.pushState(t, r), this.buffer.push(
      i,
      r,
      this.reducePos,
      -1
      /* size == -1 means this is a reused value */
    ), this.curContext && this.updateContext(this.curContext.tracker.reuse(this.curContext.context, e, this, this.p.stream.reset(this.pos - e.length)));
  }
  // Split the stack. Due to the buffer sharing and the fact
  // that `this.stack` tends to stay quite shallow, this isn't very
  // expensive.
  /**
  @internal
  */
  split() {
    let e = this, t = e.buffer.length;
    for (; t > 0 && e.buffer[t - 2] > e.reducePos; )
      t -= 4;
    let i = e.buffer.slice(t), r = e.bufferBase + t;
    for (; e && r == e.bufferBase; )
      e = e.parent;
    return new Za(this.p, this.stack.slice(), this.state, this.reducePos, this.pos, this.score, i, r, this.curContext, this.lookAhead, e);
  }
  // Try to recover from an error by 'deleting' (ignoring) one token.
  /**
  @internal
  */
  recoverByDelete(e, t) {
    let i = e <= this.p.parser.maxNode;
    i && this.storeNode(e, this.pos, t, 4), this.storeNode(0, this.pos, t, i ? 8 : 4), this.pos = this.reducePos = t, this.score -= 190;
  }
  /**
  Check if the given term would be able to be shifted (optionally
  after some reductions) on this stack. This can be useful for
  external tokenizers that want to make sure they only provide a
  given token when it applies.
  */
  canShift(e) {
    for (let t = new RR(this); ; ) {
      let i = this.p.parser.stateSlot(
        t.state,
        4
        /* ParseState.DefaultReduce */
      ) || this.p.parser.hasAction(t.state, e);
      if (i == 0)
        return !1;
      if (!(i & 65536))
        return !0;
      t.reduce(i);
    }
  }
  // Apply up to Recover.MaxNext recovery actions that conceptually
  // inserts some missing token or rule.
  /**
  @internal
  */
  recoverByInsert(e) {
    if (this.stack.length >= 300)
      return [];
    let t = this.p.parser.nextStates(this.state);
    if (t.length > 8 || this.stack.length >= 120) {
      let r = [];
      for (let s = 0, o; s < t.length; s += 2)
        (o = t[s + 1]) != this.state && this.p.parser.hasAction(o, e) && r.push(t[s], o);
      if (this.stack.length < 120)
        for (let s = 0; r.length < 8 && s < t.length; s += 2) {
          let o = t[s + 1];
          r.some((a, l) => l & 1 && a == o) || r.push(t[s], o);
        }
      t = r;
    }
    let i = [];
    for (let r = 0; r < t.length && i.length < 4; r += 2) {
      let s = t[r + 1];
      if (s == this.state)
        continue;
      let o = this.split();
      o.pushState(s, this.pos), o.storeNode(0, o.pos, o.pos, 4, !0), o.shiftContext(t[r], this.pos), o.reducePos = this.pos, o.score -= 200, i.push(o);
    }
    return i;
  }
  // Force a reduce, if possible. Return false if that can't
  // be done.
  /**
  @internal
  */
  forceReduce() {
    let { parser: e } = this.p, t = e.stateSlot(
      this.state,
      5
      /* ParseState.ForcedReduce */
    );
    if (!(t & 65536))
      return !1;
    if (!e.validAction(this.state, t)) {
      let i = t >> 19, r = t & 65535, s = this.stack.length - i * 3;
      if (s < 0 || e.getGoto(this.stack[s], r, !1) < 0) {
        let o = this.findForcedReduction();
        if (o == null)
          return !1;
        t = o;
      }
      this.storeNode(0, this.pos, this.pos, 4, !0), this.score -= 100;
    }
    return this.reducePos = this.pos, this.reduce(t), !0;
  }
  /**
  Try to scan through the automaton to find some kind of reduction
  that can be applied. Used when the regular ForcedReduce field
  isn't a valid action. @internal
  */
  findForcedReduction() {
    let { parser: e } = this.p, t = [], i = (r, s) => {
      if (!t.includes(r))
        return t.push(r), e.allActions(r, (o) => {
          if (!(o & 393216))
            if (o & 65536) {
              let a = (o >> 19) - s;
              if (a > 1) {
                let l = o & 65535, u = this.stack.length - a * 3;
                if (u >= 0 && e.getGoto(this.stack[u], l, !1) >= 0)
                  return a << 19 | 65536 | l;
              }
            } else {
              let a = i(o, s + 1);
              if (a != null)
                return a;
            }
        });
    };
    return i(this.state, 0);
  }
  /**
  @internal
  */
  forceAll() {
    for (; !this.p.parser.stateFlag(
      this.state,
      2
      /* StateFlag.Accepting */
    ); )
      if (!this.forceReduce()) {
        this.storeNode(0, this.pos, this.pos, 4, !0);
        break;
      }
    return this;
  }
  /**
  Check whether this state has no further actions (assumed to be a direct descendant of the
  top state, since any other states must be able to continue
  somehow). @internal
  */
  get deadEnd() {
    if (this.stack.length != 3)
      return !1;
    let { parser: e } = this.p;
    return e.data[e.stateSlot(
      this.state,
      1
      /* ParseState.Actions */
    )] == 65535 && !e.stateSlot(
      this.state,
      4
      /* ParseState.DefaultReduce */
    );
  }
  /**
  Restart the stack (put it back in its start state). Only safe
  when this.stack.length == 3 (state is directly below the top
  state). @internal
  */
  restart() {
    this.storeNode(0, this.pos, this.pos, 4, !0), this.state = this.stack[0], this.stack.length = 0;
  }
  /**
  @internal
  */
  sameState(e) {
    if (this.state != e.state || this.stack.length != e.stack.length)
      return !1;
    for (let t = 0; t < this.stack.length; t += 3)
      if (this.stack[t] != e.stack[t])
        return !1;
    return !0;
  }
  /**
  Get the parser used by this stack.
  */
  get parser() {
    return this.p.parser;
  }
  /**
  Test whether a given dialect (by numeric ID, as exported from
  the terms file) is enabled.
  */
  dialectEnabled(e) {
    return this.p.parser.dialect.flags[e];
  }
  shiftContext(e, t) {
    this.curContext && this.updateContext(this.curContext.tracker.shift(this.curContext.context, e, this, this.p.stream.reset(t)));
  }
  reduceContext(e, t) {
    this.curContext && this.updateContext(this.curContext.tracker.reduce(this.curContext.context, e, this, this.p.stream.reset(t)));
  }
  /**
  @internal
  */
  emitContext() {
    let e = this.buffer.length - 1;
    (e < 0 || this.buffer[e] != -3) && this.buffer.push(this.curContext.hash, this.pos, this.pos, -3);
  }
  /**
  @internal
  */
  emitLookAhead() {
    let e = this.buffer.length - 1;
    (e < 0 || this.buffer[e] != -4) && this.buffer.push(this.lookAhead, this.pos, this.pos, -4);
  }
  updateContext(e) {
    if (e != this.curContext.context) {
      let t = new pm(this.curContext.tracker, e);
      t.hash != this.curContext.hash && this.emitContext(), this.curContext = t;
    }
  }
  /**
  @internal
  */
  setLookAhead(e) {
    e > this.lookAhead && (this.emitLookAhead(), this.lookAhead = e);
  }
  /**
  @internal
  */
  close() {
    this.curContext && this.curContext.tracker.strict && this.emitContext(), this.lookAhead > 0 && this.emitLookAhead();
  }
}
class pm {
  constructor(e, t) {
    this.tracker = e, this.context = t, this.hash = e.strict ? e.hash(t) : 0;
  }
}
class RR {
  constructor(e) {
    this.start = e, this.state = e.state, this.stack = e.stack, this.base = this.stack.length;
  }
  reduce(e) {
    let t = e & 65535, i = e >> 19;
    i == 0 ? (this.stack == this.start.stack && (this.stack = this.stack.slice()), this.stack.push(this.state, 0, 0), this.base += 3) : this.base -= (i - 1) * 3;
    let r = this.start.p.parser.getGoto(this.stack[this.base - 3], t, !0);
    this.state = r;
  }
}
class Ea {
  constructor(e, t, i) {
    this.stack = e, this.pos = t, this.index = i, this.buffer = e.buffer, this.index == 0 && this.maybeNext();
  }
  static create(e, t = e.bufferBase + e.buffer.length) {
    return new Ea(e, t, t - e.bufferBase);
  }
  maybeNext() {
    let e = this.stack.parent;
    e != null && (this.index = this.stack.bufferBase - e.bufferBase, this.stack = e, this.buffer = e.buffer);
  }
  get id() {
    return this.buffer[this.index - 4];
  }
  get start() {
    return this.buffer[this.index - 3];
  }
  get end() {
    return this.buffer[this.index - 2];
  }
  get size() {
    return this.buffer[this.index - 1];
  }
  next() {
    this.index -= 4, this.pos -= 4, this.index == 0 && this.maybeNext();
  }
  fork() {
    return new Ea(this.stack, this.pos, this.index);
  }
}
function Br(n, e = Uint16Array) {
  if (typeof n != "string")
    return n;
  let t = null;
  for (let i = 0, r = 0; i < n.length; ) {
    let s = 0;
    for (; ; ) {
      let o = n.charCodeAt(i++), a = !1;
      if (o == 126) {
        s = 65535;
        break;
      }
      o >= 92 && o--, o >= 34 && o--;
      let l = o - 32;
      if (l >= 46 && (l -= 46, a = !0), s += l, a)
        break;
      s *= 46;
    }
    t ? t[r++] = s : t = new e(s);
  }
  return t;
}
class Go {
  constructor() {
    this.start = -1, this.value = -1, this.end = -1, this.extended = -1, this.lookAhead = 0, this.mask = 0, this.context = 0;
  }
}
const mm = new Go();
class MR {
  /**
  @internal
  */
  constructor(e, t) {
    this.input = e, this.ranges = t, this.chunk = "", this.chunkOff = 0, this.chunk2 = "", this.chunk2Pos = 0, this.next = -1, this.token = mm, this.rangeIndex = 0, this.pos = this.chunkPos = t[0].from, this.range = t[0], this.end = t[t.length - 1].to, this.readNext();
  }
  /**
  @internal
  */
  resolveOffset(e, t) {
    let i = this.range, r = this.rangeIndex, s = this.pos + e;
    for (; s < i.from; ) {
      if (!r)
        return null;
      let o = this.ranges[--r];
      s -= i.from - o.to, i = o;
    }
    for (; t < 0 ? s > i.to : s >= i.to; ) {
      if (r == this.ranges.length - 1)
        return null;
      let o = this.ranges[++r];
      s += o.from - i.to, i = o;
    }
    return s;
  }
  /**
  @internal
  */
  clipPos(e) {
    if (e >= this.range.from && e < this.range.to)
      return e;
    for (let t of this.ranges)
      if (t.to > e)
        return Math.max(e, t.from);
    return this.end;
  }
  /**
  Look at a code unit near the stream position. `.peek(0)` equals
  `.next`, `.peek(-1)` gives you the previous character, and so
  on.
  
  Note that looking around during tokenizing creates dependencies
  on potentially far-away content, which may reduce the
  effectiveness incremental parsing—when looking forward—or even
  cause invalid reparses when looking backward more than 25 code
  units, since the library does not track lookbehind.
  */
  peek(e) {
    let t = this.chunkOff + e, i, r;
    if (t >= 0 && t < this.chunk.length)
      i = this.pos + e, r = this.chunk.charCodeAt(t);
    else {
      let s = this.resolveOffset(e, 1);
      if (s == null)
        return -1;
      if (i = s, i >= this.chunk2Pos && i < this.chunk2Pos + this.chunk2.length)
        r = this.chunk2.charCodeAt(i - this.chunk2Pos);
      else {
        let o = this.rangeIndex, a = this.range;
        for (; a.to <= i; )
          a = this.ranges[++o];
        this.chunk2 = this.input.chunk(this.chunk2Pos = i), i + this.chunk2.length > a.to && (this.chunk2 = this.chunk2.slice(0, a.to - i)), r = this.chunk2.charCodeAt(0);
      }
    }
    return i >= this.token.lookAhead && (this.token.lookAhead = i + 1), r;
  }
  /**
  Accept a token. By default, the end of the token is set to the
  current stream position, but you can pass an offset (relative to
  the stream position) to change that.
  */
  acceptToken(e, t = 0) {
    let i = t ? this.resolveOffset(t, -1) : this.pos;
    if (i == null || i < this.token.start)
      throw new RangeError("Token end out of bounds");
    this.token.value = e, this.token.end = i;
  }
  /**
  Accept a token ending at a specific given position.
  */
  acceptTokenTo(e, t) {
    this.token.value = e, this.token.end = t;
  }
  getChunk() {
    if (this.pos >= this.chunk2Pos && this.pos < this.chunk2Pos + this.chunk2.length) {
      let { chunk: e, chunkPos: t } = this;
      this.chunk = this.chunk2, this.chunkPos = this.chunk2Pos, this.chunk2 = e, this.chunk2Pos = t, this.chunkOff = this.pos - this.chunkPos;
    } else {
      this.chunk2 = this.chunk, this.chunk2Pos = this.chunkPos;
      let e = this.input.chunk(this.pos), t = this.pos + e.length;
      this.chunk = t > this.range.to ? e.slice(0, this.range.to - this.pos) : e, this.chunkPos = this.pos, this.chunkOff = 0;
    }
  }
  readNext() {
    return this.chunkOff >= this.chunk.length && (this.getChunk(), this.chunkOff == this.chunk.length) ? this.next = -1 : this.next = this.chunk.charCodeAt(this.chunkOff);
  }
  /**
  Move the stream forward N (defaults to 1) code units. Returns
  the new value of [`next`](#lr.InputStream.next).
  */
  advance(e = 1) {
    for (this.chunkOff += e; this.pos + e >= this.range.to; ) {
      if (this.rangeIndex == this.ranges.length - 1)
        return this.setDone();
      e -= this.range.to - this.pos, this.range = this.ranges[++this.rangeIndex], this.pos = this.range.from;
    }
    return this.pos += e, this.pos >= this.token.lookAhead && (this.token.lookAhead = this.pos + 1), this.readNext();
  }
  setDone() {
    return this.pos = this.chunkPos = this.end, this.range = this.ranges[this.rangeIndex = this.ranges.length - 1], this.chunk = "", this.next = -1;
  }
  /**
  @internal
  */
  reset(e, t) {
    if (t ? (this.token = t, t.start = e, t.lookAhead = e + 1, t.value = t.extended = -1) : this.token = mm, this.pos != e) {
      if (this.pos = e, e == this.end)
        return this.setDone(), this;
      for (; e < this.range.from; )
        this.range = this.ranges[--this.rangeIndex];
      for (; e >= this.range.to; )
        this.range = this.ranges[++this.rangeIndex];
      e >= this.chunkPos && e < this.chunkPos + this.chunk.length ? this.chunkOff = e - this.chunkPos : (this.chunk = "", this.chunkOff = 0), this.readNext();
    }
    return this;
  }
  /**
  @internal
  */
  read(e, t) {
    if (e >= this.chunkPos && t <= this.chunkPos + this.chunk.length)
      return this.chunk.slice(e - this.chunkPos, t - this.chunkPos);
    if (e >= this.chunk2Pos && t <= this.chunk2Pos + this.chunk2.length)
      return this.chunk2.slice(e - this.chunk2Pos, t - this.chunk2Pos);
    if (e >= this.range.from && t <= this.range.to)
      return this.input.read(e, t);
    let i = "";
    for (let r of this.ranges) {
      if (r.from >= t)
        break;
      r.to > e && (i += this.input.read(Math.max(r.from, e), Math.min(r.to, t)));
    }
    return i;
  }
}
class Hi {
  constructor(e, t) {
    this.data = e, this.id = t;
  }
  token(e, t) {
    let { parser: i } = t.p;
    Jb(this.data, e, t, this.id, i.data, i.tokenPrecTable);
  }
}
Hi.prototype.contextual = Hi.prototype.fallback = Hi.prototype.extend = !1;
class za {
  constructor(e, t, i) {
    this.precTable = t, this.elseToken = i, this.data = typeof e == "string" ? Br(e) : e;
  }
  token(e, t) {
    let i = e.pos, r = 0;
    for (; ; ) {
      let s = e.next < 0, o = e.resolveOffset(1, 1);
      if (Jb(this.data, e, t, 0, this.data, this.precTable), e.token.value > -1)
        break;
      if (this.elseToken == null)
        return;
      if (s || r++, o == null)
        break;
      e.reset(o, e.token);
    }
    r && (e.reset(i, e.token), e.acceptToken(this.elseToken, r));
  }
}
za.prototype.contextual = Hi.prototype.fallback = Hi.prototype.extend = !1;
class Kt {
  /**
  Create a tokenizer. The first argument is the function that,
  given an input stream, scans for the types of tokens it
  recognizes at the stream's position, and calls
  [`acceptToken`](#lr.InputStream.acceptToken) when it finds
  one.
  */
  constructor(e, t = {}) {
    this.token = e, this.contextual = !!t.contextual, this.fallback = !!t.fallback, this.extend = !!t.extend;
  }
}
function Jb(n, e, t, i, r, s) {
  let o = 0, a = 1 << i, { dialect: l } = t.p.parser;
  e:
    for (; a & n[o]; ) {
      let u = n[o + 1];
      for (let d = o + 3; d < u; d += 2)
        if ((n[d + 1] & a) > 0) {
          let p = n[d];
          if (l.allows(p) && (e.token.value == -1 || e.token.value == p || ZR(p, e.token.value, r, s))) {
            e.acceptToken(p);
            break;
          }
        }
      let c = e.next, h = 0, f = n[o + 2];
      if (e.next < 0 && f > h && n[u + f * 3 - 3] == 65535) {
        o = n[u + f * 3 - 1];
        continue e;
      }
      for (; h < f; ) {
        let d = h + f >> 1, p = u + d + (d << 1), g = n[p], O = n[p + 1] || 65536;
        if (c < g)
          f = d;
        else if (c >= O)
          h = d + 1;
        else {
          o = n[p + 2], e.advance();
          continue e;
        }
      }
      break;
    }
}
function gm(n, e, t) {
  for (let i = e, r; (r = n[i]) != 65535; i++)
    if (r == t)
      return i - e;
  return -1;
}
function ZR(n, e, t, i) {
  let r = gm(t, i, e);
  return r < 0 || gm(t, i, n) < r;
}
const wt = typeof process < "u" && process.env && /\bparse\b/.test(process.env.LOG);
let Fl = null;
function Om(n, e, t) {
  let i = n.cursor(ve.IncludeAnonymous);
  for (i.moveTo(e); ; )
    if (!(t < 0 ? i.childBefore(e) : i.childAfter(e)))
      for (; ; ) {
        if ((t < 0 ? i.to < e : i.from > e) && !i.type.isError)
          return t < 0 ? Math.max(0, Math.min(
            i.to - 1,
            e - 25
            /* Lookahead.Margin */
          )) : Math.min(n.length, Math.max(
            i.from + 1,
            e + 25
            /* Lookahead.Margin */
          ));
        if (t < 0 ? i.prevSibling() : i.nextSibling())
          break;
        if (!i.parent())
          return t < 0 ? 0 : n.length;
      }
}
class ER {
  constructor(e, t) {
    this.fragments = e, this.nodeSet = t, this.i = 0, this.fragment = null, this.safeFrom = -1, this.safeTo = -1, this.trees = [], this.start = [], this.index = [], this.nextFragment();
  }
  nextFragment() {
    let e = this.fragment = this.i == this.fragments.length ? null : this.fragments[this.i++];
    if (e) {
      for (this.safeFrom = e.openStart ? Om(e.tree, e.from + e.offset, 1) - e.offset : e.from, this.safeTo = e.openEnd ? Om(e.tree, e.to + e.offset, -1) - e.offset : e.to; this.trees.length; )
        this.trees.pop(), this.start.pop(), this.index.pop();
      this.trees.push(e.tree), this.start.push(-e.offset), this.index.push(0), this.nextStart = this.safeFrom;
    } else
      this.nextStart = 1e9;
  }
  // `pos` must be >= any previously given `pos` for this cursor
  nodeAt(e) {
    if (e < this.nextStart)
      return null;
    for (; this.fragment && this.safeTo <= e; )
      this.nextFragment();
    if (!this.fragment)
      return null;
    for (; ; ) {
      let t = this.trees.length - 1;
      if (t < 0)
        return this.nextFragment(), null;
      let i = this.trees[t], r = this.index[t];
      if (r == i.children.length) {
        this.trees.pop(), this.start.pop(), this.index.pop();
        continue;
      }
      let s = i.children[r], o = this.start[t] + i.positions[r];
      if (o > e)
        return this.nextStart = o, null;
      if (s instanceof ge) {
        if (o == e) {
          if (o < this.safeFrom)
            return null;
          let a = o + s.length;
          if (a <= this.safeTo) {
            let l = s.prop(J.lookAhead);
            if (!l || a + l < this.fragment.to)
              return s;
          }
        }
        this.index[t]++, o + s.length >= Math.max(this.safeFrom, e) && (this.trees.push(s), this.start.push(o), this.index.push(0));
      } else
        this.index[t]++, this.nextStart = o + s.length;
    }
  }
}
class zR {
  constructor(e, t) {
    this.stream = t, this.tokens = [], this.mainToken = null, this.actions = [], this.tokens = e.tokenizers.map((i) => new Go());
  }
  getActions(e) {
    let t = 0, i = null, { parser: r } = e.p, { tokenizers: s } = r, o = r.stateSlot(
      e.state,
      3
      /* ParseState.TokenizerMask */
    ), a = e.curContext ? e.curContext.hash : 0, l = 0;
    for (let u = 0; u < s.length; u++) {
      if (!(1 << u & o))
        continue;
      let c = s[u], h = this.tokens[u];
      if (!(i && !c.fallback) && ((c.contextual || h.start != e.pos || h.mask != o || h.context != a) && (this.updateCachedToken(h, c, e), h.mask = o, h.context = a), h.lookAhead > h.end + 25 && (l = Math.max(h.lookAhead, l)), h.value != 0)) {
        let f = t;
        if (h.extended > -1 && (t = this.addActions(e, h.extended, h.end, t)), t = this.addActions(e, h.value, h.end, t), !c.extend && (i = h, t > f))
          break;
      }
    }
    for (; this.actions.length > t; )
      this.actions.pop();
    return l && e.setLookAhead(l), !i && e.pos == this.stream.end && (i = new Go(), i.value = e.p.parser.eofTerm, i.start = i.end = e.pos, t = this.addActions(e, i.value, i.end, t)), this.mainToken = i, this.actions;
  }
  getMainToken(e) {
    if (this.mainToken)
      return this.mainToken;
    let t = new Go(), { pos: i, p: r } = e;
    return t.start = i, t.end = Math.min(i + 1, r.stream.end), t.value = i == r.stream.end ? r.parser.eofTerm : 0, t;
  }
  updateCachedToken(e, t, i) {
    let r = this.stream.clipPos(i.pos);
    if (t.token(this.stream.reset(r, e), i), e.value > -1) {
      let { parser: s } = i.p;
      for (let o = 0; o < s.specialized.length; o++)
        if (s.specialized[o] == e.value) {
          let a = s.specializers[o](this.stream.read(e.start, e.end), i);
          if (a >= 0 && i.p.parser.dialect.allows(a >> 1)) {
            a & 1 ? e.extended = a >> 1 : e.value = a >> 1;
            break;
          }
        }
    } else
      e.value = 0, e.end = this.stream.clipPos(r + 1);
  }
  putAction(e, t, i, r) {
    for (let s = 0; s < r; s += 3)
      if (this.actions[s] == e)
        return r;
    return this.actions[r++] = e, this.actions[r++] = t, this.actions[r++] = i, r;
  }
  addActions(e, t, i, r) {
    let { state: s } = e, { parser: o } = e.p, { data: a } = o;
    for (let l = 0; l < 2; l++)
      for (let u = o.stateSlot(
        s,
        l ? 2 : 1
        /* ParseState.Actions */
      ); ; u += 3) {
        if (a[u] == 65535)
          if (a[u + 1] == 1)
            u = kn(a, u + 2);
          else {
            r == 0 && a[u + 1] == 2 && (r = this.putAction(kn(a, u + 2), t, i, r));
            break;
          }
        a[u] == t && (r = this.putAction(kn(a, u + 1), t, i, r));
      }
    return r;
  }
}
class DR {
  constructor(e, t, i, r) {
    this.parser = e, this.input = t, this.ranges = r, this.recovering = 0, this.nextStackID = 9812, this.minStackPos = 0, this.reused = [], this.stoppedAt = null, this.lastBigReductionStart = -1, this.lastBigReductionSize = 0, this.bigReductionCount = 0, this.stream = new MR(t, r), this.tokens = new zR(e, this.stream), this.topTerm = e.top[1];
    let { from: s } = r[0];
    this.stacks = [Za.start(this, e.top[0], s)], this.fragments = i.length && this.stream.end - s > e.bufferLength * 4 ? new ER(i, e.nodeSet) : null;
  }
  get parsedPos() {
    return this.minStackPos;
  }
  // Move the parser forward. This will process all parse stacks at
  // `this.pos` and try to advance them to a further position. If no
  // stack for such a position is found, it'll start error-recovery.
  //
  // When the parse is finished, this will return a syntax tree. When
  // not, it returns `null`.
  advance() {
    let e = this.stacks, t = this.minStackPos, i = this.stacks = [], r, s;
    if (this.bigReductionCount > 300 && e.length == 1) {
      let [o] = e;
      for (; o.forceReduce() && o.stack.length && o.stack[o.stack.length - 2] >= this.lastBigReductionStart; )
        ;
      this.bigReductionCount = this.lastBigReductionSize = 0;
    }
    for (let o = 0; o < e.length; o++) {
      let a = e[o];
      for (; ; ) {
        if (this.tokens.mainToken = null, a.pos > t)
          i.push(a);
        else {
          if (this.advanceStack(a, i, e))
            continue;
          {
            r || (r = [], s = []), r.push(a);
            let l = this.tokens.getMainToken(a);
            s.push(l.value, l.end);
          }
        }
        break;
      }
    }
    if (!i.length) {
      let o = r && LR(r);
      if (o)
        return wt && console.log("Finish with " + this.stackID(o)), this.stackToTree(o);
      if (this.parser.strict)
        throw wt && r && console.log("Stuck with token " + (this.tokens.mainToken ? this.parser.getName(this.tokens.mainToken.value) : "none")), new SyntaxError("No parse at " + t);
      this.recovering || (this.recovering = 5);
    }
    if (this.recovering && r) {
      let o = this.stoppedAt != null && r[0].pos > this.stoppedAt ? r[0] : this.runRecovery(r, s, i);
      if (o)
        return wt && console.log("Force-finish " + this.stackID(o)), this.stackToTree(o.forceAll());
    }
    if (this.recovering) {
      let o = this.recovering == 1 ? 1 : this.recovering * 3;
      if (i.length > o)
        for (i.sort((a, l) => l.score - a.score); i.length > o; )
          i.pop();
      i.some((a) => a.reducePos > t) && this.recovering--;
    } else if (i.length > 1) {
      e:
        for (let o = 0; o < i.length - 1; o++) {
          let a = i[o];
          for (let l = o + 1; l < i.length; l++) {
            let u = i[l];
            if (a.sameState(u) || a.buffer.length > 500 && u.buffer.length > 500)
              if ((a.score - u.score || a.buffer.length - u.buffer.length) > 0)
                i.splice(l--, 1);
              else {
                i.splice(o--, 1);
                continue e;
              }
          }
        }
      i.length > 12 && i.splice(
        12,
        i.length - 12
        /* Rec.MaxStackCount */
      );
    }
    this.minStackPos = i[0].pos;
    for (let o = 1; o < i.length; o++)
      i[o].pos < this.minStackPos && (this.minStackPos = i[o].pos);
    return null;
  }
  stopAt(e) {
    if (this.stoppedAt != null && this.stoppedAt < e)
      throw new RangeError("Can't move stoppedAt forward");
    this.stoppedAt = e;
  }
  // Returns an updated version of the given stack, or null if the
  // stack can't advance normally. When `split` and `stacks` are
  // given, stacks split off by ambiguous operations will be pushed to
  // `split`, or added to `stacks` if they move `pos` forward.
  advanceStack(e, t, i) {
    let r = e.pos, { parser: s } = this, o = wt ? this.stackID(e) + " -> " : "";
    if (this.stoppedAt != null && r > this.stoppedAt)
      return e.forceReduce() ? e : null;
    if (this.fragments) {
      let u = e.curContext && e.curContext.tracker.strict, c = u ? e.curContext.hash : 0;
      for (let h = this.fragments.nodeAt(r); h; ) {
        let f = this.parser.nodeSet.types[h.type.id] == h.type ? s.getGoto(e.state, h.type.id) : -1;
        if (f > -1 && h.length && (!u || (h.prop(J.contextHash) || 0) == c))
          return e.useNode(h, f), wt && console.log(o + this.stackID(e) + ` (via reuse of ${s.getName(h.type.id)})`), !0;
        if (!(h instanceof ge) || h.children.length == 0 || h.positions[0] > 0)
          break;
        let d = h.children[0];
        if (d instanceof ge && h.positions[0] == 0)
          h = d;
        else
          break;
      }
    }
    let a = s.stateSlot(
      e.state,
      4
      /* ParseState.DefaultReduce */
    );
    if (a > 0)
      return e.reduce(a), wt && console.log(o + this.stackID(e) + ` (via always-reduce ${s.getName(
        a & 65535
        /* Action.ValueMask */
      )})`), !0;
    if (e.stack.length >= 8400)
      for (; e.stack.length > 6e3 && e.forceReduce(); )
        ;
    let l = this.tokens.getActions(e);
    for (let u = 0; u < l.length; ) {
      let c = l[u++], h = l[u++], f = l[u++], d = u == l.length || !i, p = d ? e : e.split(), g = this.tokens.mainToken;
      if (p.apply(c, h, g ? g.start : p.pos, f), wt && console.log(o + this.stackID(p) + ` (via ${c & 65536 ? `reduce of ${s.getName(
        c & 65535
        /* Action.ValueMask */
      )}` : "shift"} for ${s.getName(h)} @ ${r}${p == e ? "" : ", split"})`), d)
        return !0;
      p.pos > r ? t.push(p) : i.push(p);
    }
    return !1;
  }
  // Advance a given stack forward as far as it will go. Returns the
  // (possibly updated) stack if it got stuck, or null if it moved
  // forward and was given to `pushStackDedup`.
  advanceFully(e, t) {
    let i = e.pos;
    for (; ; ) {
      if (!this.advanceStack(e, null, null))
        return !1;
      if (e.pos > i)
        return bm(e, t), !0;
    }
  }
  runRecovery(e, t, i) {
    let r = null, s = !1;
    for (let o = 0; o < e.length; o++) {
      let a = e[o], l = t[o << 1], u = t[(o << 1) + 1], c = wt ? this.stackID(a) + " -> " : "";
      if (a.deadEnd && (s || (s = !0, a.restart(), wt && console.log(c + this.stackID(a) + " (restarted)"), this.advanceFully(a, i))))
        continue;
      let h = a.split(), f = c;
      for (let d = 0; h.forceReduce() && d < 10 && (wt && console.log(f + this.stackID(h) + " (via force-reduce)"), !this.advanceFully(h, i)); d++)
        wt && (f = this.stackID(h) + " -> ");
      for (let d of a.recoverByInsert(l))
        wt && console.log(c + this.stackID(d) + " (via recover-insert)"), this.advanceFully(d, i);
      this.stream.end > a.pos ? (u == a.pos && (u++, l = 0), a.recoverByDelete(l, u), wt && console.log(c + this.stackID(a) + ` (via recover-delete ${this.parser.getName(l)})`), bm(a, i)) : (!r || r.score < a.score) && (r = a);
    }
    return r;
  }
  // Convert the stack's buffer to a syntax tree.
  stackToTree(e) {
    return e.close(), ge.build({
      buffer: Ea.create(e),
      nodeSet: this.parser.nodeSet,
      topID: this.topTerm,
      maxBufferLength: this.parser.bufferLength,
      reused: this.reused,
      start: this.ranges[0].from,
      length: e.pos - this.ranges[0].from,
      minRepeatType: this.parser.minRepeatTerm
    });
  }
  stackID(e) {
    let t = (Fl || (Fl = /* @__PURE__ */ new WeakMap())).get(e);
    return t || Fl.set(e, t = String.fromCodePoint(this.nextStackID++)), t + e;
  }
}
function bm(n, e) {
  for (let t = 0; t < e.length; t++) {
    let i = e[t];
    if (i.pos == n.pos && i.sameState(n)) {
      e[t].score < n.score && (e[t] = n);
      return;
    }
  }
  e.push(n);
}
class IR {
  constructor(e, t, i) {
    this.source = e, this.flags = t, this.disabled = i;
  }
  allows(e) {
    return !this.disabled || this.disabled[e] == 0;
  }
}
const Gl = (n) => n;
class ey {
  /**
  Define a context tracker.
  */
  constructor(e) {
    this.start = e.start, this.shift = e.shift || Gl, this.reduce = e.reduce || Gl, this.reuse = e.reuse || Gl, this.hash = e.hash || (() => 0), this.strict = e.strict !== !1;
  }
}
class cr extends ph {
  /**
  @internal
  */
  constructor(e) {
    if (super(), this.wrappers = [], e.version != 14)
      throw new RangeError(`Parser version (${e.version}) doesn't match runtime version (14)`);
    let t = e.nodeNames.split(" ");
    this.minRepeatTerm = t.length;
    for (let a = 0; a < e.repeatNodeCount; a++)
      t.push("");
    let i = Object.keys(e.topRules).map((a) => e.topRules[a][1]), r = [];
    for (let a = 0; a < t.length; a++)
      r.push([]);
    function s(a, l, u) {
      r[a].push([l, l.deserialize(String(u))]);
    }
    if (e.nodeProps)
      for (let a of e.nodeProps) {
        let l = a[0];
        typeof l == "string" && (l = J[l]);
        for (let u = 1; u < a.length; ) {
          let c = a[u++];
          if (c >= 0)
            s(c, l, a[u++]);
          else {
            let h = a[u + -c];
            for (let f = -c; f > 0; f--)
              s(a[u++], l, h);
            u++;
          }
        }
      }
    this.nodeSet = new zs(t.map((a, l) => qe.define({
      name: l >= this.minRepeatTerm ? void 0 : a,
      id: l,
      props: r[l],
      top: i.indexOf(l) > -1,
      error: l == 0,
      skipped: e.skippedNodes && e.skippedNodes.indexOf(l) > -1
    }))), e.propSources && (this.nodeSet = this.nodeSet.extend(...e.propSources)), this.strict = !1, this.bufferLength = YO;
    let o = Br(e.tokenData);
    this.context = e.context, this.specializerSpecs = e.specialized || [], this.specialized = new Uint16Array(this.specializerSpecs.length);
    for (let a = 0; a < this.specializerSpecs.length; a++)
      this.specialized[a] = this.specializerSpecs[a].term;
    this.specializers = this.specializerSpecs.map(ym), this.states = Br(e.states, Uint32Array), this.data = Br(e.stateData), this.goto = Br(e.goto), this.maxTerm = e.maxTerm, this.tokenizers = e.tokenizers.map((a) => typeof a == "number" ? new Hi(o, a) : a), this.topRules = e.topRules, this.dialects = e.dialects || {}, this.dynamicPrecedences = e.dynamicPrecedences || null, this.tokenPrecTable = e.tokenPrec, this.termNames = e.termNames || null, this.maxNode = this.nodeSet.types.length - 1, this.dialect = this.parseDialect(), this.top = this.topRules[Object.keys(this.topRules)[0]];
  }
  createParse(e, t, i) {
    let r = new DR(this, e, t, i);
    for (let s of this.wrappers)
      r = s(r, e, t, i);
    return r;
  }
  /**
  Get a goto table entry @internal
  */
  getGoto(e, t, i = !1) {
    let r = this.goto;
    if (t >= r[0])
      return -1;
    for (let s = r[t + 1]; ; ) {
      let o = r[s++], a = o & 1, l = r[s++];
      if (a && i)
        return l;
      for (let u = s + (o >> 1); s < u; s++)
        if (r[s] == e)
          return l;
      if (a)
        return -1;
    }
  }
  /**
  Check if this state has an action for a given terminal @internal
  */
  hasAction(e, t) {
    let i = this.data;
    for (let r = 0; r < 2; r++)
      for (let s = this.stateSlot(
        e,
        r ? 2 : 1
        /* ParseState.Actions */
      ), o; ; s += 3) {
        if ((o = i[s]) == 65535)
          if (i[s + 1] == 1)
            o = i[s = kn(i, s + 2)];
          else {
            if (i[s + 1] == 2)
              return kn(i, s + 2);
            break;
          }
        if (o == t || o == 0)
          return kn(i, s + 1);
      }
    return 0;
  }
  /**
  @internal
  */
  stateSlot(e, t) {
    return this.states[e * 6 + t];
  }
  /**
  @internal
  */
  stateFlag(e, t) {
    return (this.stateSlot(
      e,
      0
      /* ParseState.Flags */
    ) & t) > 0;
  }
  /**
  @internal
  */
  validAction(e, t) {
    return !!this.allActions(e, (i) => i == t ? !0 : null);
  }
  /**
  @internal
  */
  allActions(e, t) {
    let i = this.stateSlot(
      e,
      4
      /* ParseState.DefaultReduce */
    ), r = i ? t(i) : void 0;
    for (let s = this.stateSlot(
      e,
      1
      /* ParseState.Actions */
    ); r == null; s += 3) {
      if (this.data[s] == 65535)
        if (this.data[s + 1] == 1)
          s = kn(this.data, s + 2);
        else
          break;
      r = t(kn(this.data, s + 1));
    }
    return r;
  }
  /**
  Get the states that can follow this one through shift actions or
  goto jumps. @internal
  */
  nextStates(e) {
    let t = [];
    for (let i = this.stateSlot(
      e,
      1
      /* ParseState.Actions */
    ); ; i += 3) {
      if (this.data[i] == 65535)
        if (this.data[i + 1] == 1)
          i = kn(this.data, i + 2);
        else
          break;
      if (!(this.data[i + 2] & 1)) {
        let r = this.data[i + 1];
        t.some((s, o) => o & 1 && s == r) || t.push(this.data[i], r);
      }
    }
    return t;
  }
  /**
  Configure the parser. Returns a new parser instance that has the
  given settings modified. Settings not provided in `config` are
  kept from the original parser.
  */
  configure(e) {
    let t = Object.assign(Object.create(cr.prototype), this);
    if (e.props && (t.nodeSet = this.nodeSet.extend(...e.props)), e.top) {
      let i = this.topRules[e.top];
      if (!i)
        throw new RangeError(`Invalid top rule name ${e.top}`);
      t.top = i;
    }
    return e.tokenizers && (t.tokenizers = this.tokenizers.map((i) => {
      let r = e.tokenizers.find((s) => s.from == i);
      return r ? r.to : i;
    })), e.specializers && (t.specializers = this.specializers.slice(), t.specializerSpecs = this.specializerSpecs.map((i, r) => {
      let s = e.specializers.find((a) => a.from == i.external);
      if (!s)
        return i;
      let o = Object.assign(Object.assign({}, i), { external: s.to });
      return t.specializers[r] = ym(o), o;
    })), e.contextTracker && (t.context = e.contextTracker), e.dialect && (t.dialect = this.parseDialect(e.dialect)), e.strict != null && (t.strict = e.strict), e.wrap && (t.wrappers = t.wrappers.concat(e.wrap)), e.bufferLength != null && (t.bufferLength = e.bufferLength), t;
  }
  /**
  Tells you whether any [parse wrappers](#lr.ParserConfig.wrap)
  are registered for this parser.
  */
  hasWrappers() {
    return this.wrappers.length > 0;
  }
  /**
  Returns the name associated with a given term. This will only
  work for all terms when the parser was generated with the
  `--names` option. By default, only the names of tagged terms are
  stored.
  */
  getName(e) {
    return this.termNames ? this.termNames[e] : String(e <= this.maxNode && this.nodeSet.types[e].name || e);
  }
  /**
  The eof term id is always allocated directly after the node
  types. @internal
  */
  get eofTerm() {
    return this.maxNode + 1;
  }
  /**
  The type of top node produced by the parser.
  */
  get topNode() {
    return this.nodeSet.types[this.top[1]];
  }
  /**
  @internal
  */
  dynamicPrecedence(e) {
    let t = this.dynamicPrecedences;
    return t == null ? 0 : t[e] || 0;
  }
  /**
  @internal
  */
  parseDialect(e) {
    let t = Object.keys(this.dialects), i = t.map(() => !1);
    if (e)
      for (let s of e.split(" ")) {
        let o = t.indexOf(s);
        o >= 0 && (i[o] = !0);
      }
    let r = null;
    for (let s = 0; s < t.length; s++)
      if (!i[s])
        for (let o = this.dialects[t[s]], a; (a = this.data[o++]) != 65535; )
          (r || (r = new Uint8Array(this.maxTerm + 1)))[a] = 1;
    return new IR(e, i, r);
  }
  /**
  Used by the output of the parser generator. Not available to
  user code. @hide
  */
  static deserialize(e) {
    return new cr(e);
  }
}
function kn(n, e) {
  return n[e] | n[e + 1] << 16;
}
function LR(n) {
  let e = null;
  for (let t of n) {
    let i = t.p.stoppedAt;
    (t.pos == t.p.stream.end || i != null && t.pos > i) && t.p.parser.stateFlag(
      t.state,
      2
      /* StateFlag.Accepting */
    ) && (!e || e.score < t.score) && (e = t);
  }
  return e;
}
function ym(n) {
  if (n.external) {
    let e = n.extend ? 1 : 0;
    return (t, i) => n.external(t, i) << 1 | e;
  }
  return n.get;
}
const _R = 54, XR = 1, NR = 55, WR = 2, qR = 56, BR = 3, km = 4, VR = 5, Da = 6, ty = 7, ny = 8, iy = 9, ry = 10, YR = 11, jR = 12, UR = 13, Hl = 57, FR = 14, xm = 58, sy = 20, GR = 22, oy = 23, HR = 24, Dc = 26, ay = 27, KR = 28, JR = 31, eM = 34, tM = 36, nM = 37, iM = 0, rM = 1, sM = {
  area: !0,
  base: !0,
  br: !0,
  col: !0,
  command: !0,
  embed: !0,
  frame: !0,
  hr: !0,
  img: !0,
  input: !0,
  keygen: !0,
  link: !0,
  meta: !0,
  param: !0,
  source: !0,
  track: !0,
  wbr: !0,
  menuitem: !0
}, oM = {
  dd: !0,
  li: !0,
  optgroup: !0,
  option: !0,
  p: !0,
  rp: !0,
  rt: !0,
  tbody: !0,
  td: !0,
  tfoot: !0,
  th: !0,
  tr: !0
}, wm = {
  dd: { dd: !0, dt: !0 },
  dt: { dd: !0, dt: !0 },
  li: { li: !0 },
  option: { option: !0, optgroup: !0 },
  optgroup: { optgroup: !0 },
  p: {
    address: !0,
    article: !0,
    aside: !0,
    blockquote: !0,
    dir: !0,
    div: !0,
    dl: !0,
    fieldset: !0,
    footer: !0,
    form: !0,
    h1: !0,
    h2: !0,
    h3: !0,
    h4: !0,
    h5: !0,
    h6: !0,
    header: !0,
    hgroup: !0,
    hr: !0,
    menu: !0,
    nav: !0,
    ol: !0,
    p: !0,
    pre: !0,
    section: !0,
    table: !0,
    ul: !0
  },
  rp: { rp: !0, rt: !0 },
  rt: { rp: !0, rt: !0 },
  tbody: { tbody: !0, tfoot: !0 },
  td: { td: !0, th: !0 },
  tfoot: { tbody: !0 },
  th: { td: !0, th: !0 },
  thead: { tbody: !0, tfoot: !0 },
  tr: { tr: !0 }
};
function aM(n) {
  return n == 45 || n == 46 || n == 58 || n >= 65 && n <= 90 || n == 95 || n >= 97 && n <= 122 || n >= 161;
}
function ly(n) {
  return n == 9 || n == 10 || n == 13 || n == 32;
}
let Sm = null, vm = null, Pm = 0;
function Ic(n, e) {
  let t = n.pos + e;
  if (Pm == t && vm == n)
    return Sm;
  let i = n.peek(e);
  for (; ly(i); )
    i = n.peek(++e);
  let r = "";
  for (; aM(i); )
    r += String.fromCharCode(i), i = n.peek(++e);
  return vm = n, Pm = t, Sm = r ? r.toLowerCase() : i == lM || i == uM ? void 0 : null;
}
const uy = 60, Ia = 62, rf = 47, lM = 63, uM = 33, cM = 45;
function Qm(n, e) {
  this.name = n, this.parent = e;
}
const hM = [Da, ry, ty, ny, iy], fM = new ey({
  start: null,
  shift(n, e, t, i) {
    return hM.indexOf(e) > -1 ? new Qm(Ic(i, 1) || "", n) : n;
  },
  reduce(n, e) {
    return e == sy && n ? n.parent : n;
  },
  reuse(n, e, t, i) {
    let r = e.type.id;
    return r == Da || r == tM ? new Qm(Ic(i, 1) || "", n) : n;
  },
  strict: !1
}), dM = new Kt((n, e) => {
  if (n.next != uy) {
    n.next < 0 && e.context && n.acceptToken(Hl);
    return;
  }
  n.advance();
  let t = n.next == rf;
  t && n.advance();
  let i = Ic(n, 0);
  if (i === void 0)
    return;
  if (!i)
    return n.acceptToken(t ? FR : Da);
  let r = e.context ? e.context.name : null;
  if (t) {
    if (i == r)
      return n.acceptToken(YR);
    if (r && oM[r])
      return n.acceptToken(Hl, -2);
    if (e.dialectEnabled(iM))
      return n.acceptToken(jR);
    for (let s = e.context; s; s = s.parent)
      if (s.name == i)
        return;
    n.acceptToken(UR);
  } else {
    if (i == "script")
      return n.acceptToken(ty);
    if (i == "style")
      return n.acceptToken(ny);
    if (i == "textarea")
      return n.acceptToken(iy);
    if (sM.hasOwnProperty(i))
      return n.acceptToken(ry);
    r && wm[r] && wm[r][i] ? n.acceptToken(Hl, -1) : n.acceptToken(Da);
  }
}, { contextual: !0 }), pM = new Kt((n) => {
  for (let e = 0, t = 0; ; t++) {
    if (n.next < 0) {
      t && n.acceptToken(xm);
      break;
    }
    if (n.next == cM)
      e++;
    else if (n.next == Ia && e >= 2) {
      t >= 3 && n.acceptToken(xm, -2);
      break;
    } else
      e = 0;
    n.advance();
  }
});
function mM(n) {
  for (; n; n = n.parent)
    if (n.name == "svg" || n.name == "math")
      return !0;
  return !1;
}
const gM = new Kt((n, e) => {
  if (n.next == rf && n.peek(1) == Ia) {
    let t = e.dialectEnabled(rM) || mM(e.context);
    n.acceptToken(t ? VR : km, 2);
  } else
    n.next == Ia && n.acceptToken(km, 1);
});
function sf(n, e, t) {
  let i = 2 + n.length;
  return new Kt((r) => {
    for (let s = 0, o = 0, a = 0; ; a++) {
      if (r.next < 0) {
        a && r.acceptToken(e);
        break;
      }
      if (s == 0 && r.next == uy || s == 1 && r.next == rf || s >= 2 && s < i && r.next == n.charCodeAt(s - 2))
        s++, o++;
      else if ((s == 2 || s == i) && ly(r.next))
        o++;
      else if (s == i && r.next == Ia) {
        a > o ? r.acceptToken(e, -o) : r.acceptToken(t, -(o - 2));
        break;
      } else if ((r.next == 10 || r.next == 13) && a) {
        r.acceptToken(e, 1);
        break;
      } else
        s = o = 0;
      r.advance();
    }
  });
}
const OM = sf("script", _R, XR), bM = sf("style", NR, WR), yM = sf("textarea", qR, BR), kM = pr({
  "Text RawText": x.content,
  "StartTag StartCloseTag SelfClosingEndTag EndTag": x.angleBracket,
  TagName: x.tagName,
  "MismatchedCloseTag/TagName": [x.tagName, x.invalid],
  AttributeName: x.attributeName,
  "AttributeValue UnquotedAttributeValue": x.attributeValue,
  Is: x.definitionOperator,
  "EntityReference CharacterReference": x.character,
  Comment: x.blockComment,
  ProcessingInst: x.processingInstruction,
  DoctypeDecl: x.documentMeta
}), xM = cr.deserialize({
  version: 14,
  states: ",xOVO!rOOO!WQ#tO'#CqO!]Q#tO'#CzO!bQ#tO'#C}O!gQ#tO'#DQO!lQ#tO'#DSO!qOaO'#CpO!|ObO'#CpO#XOdO'#CpO$eO!rO'#CpOOO`'#Cp'#CpO$lO$fO'#DTO$tQ#tO'#DVO$yQ#tO'#DWOOO`'#Dk'#DkOOO`'#DY'#DYQVO!rOOO%OQ&rO,59]O%ZQ&rO,59fO%fQ&rO,59iO%qQ&rO,59lO%|Q&rO,59nOOOa'#D^'#D^O&XOaO'#CxO&dOaO,59[OOOb'#D_'#D_O&lObO'#C{O&wObO,59[OOOd'#D`'#D`O'POdO'#DOO'[OdO,59[OOO`'#Da'#DaO'dO!rO,59[O'kQ#tO'#DROOO`,59[,59[OOOp'#Db'#DbO'pO$fO,59oOOO`,59o,59oO'xQ#|O,59qO'}Q#|O,59rOOO`-E7W-E7WO(SQ&rO'#CsOOQW'#DZ'#DZO(bQ&rO1G.wOOOa1G.w1G.wOOO`1G/Y1G/YO(mQ&rO1G/QOOOb1G/Q1G/QO(xQ&rO1G/TOOOd1G/T1G/TO)TQ&rO1G/WOOO`1G/W1G/WO)`Q&rO1G/YOOOa-E7[-E7[O)kQ#tO'#CyOOO`1G.v1G.vOOOb-E7]-E7]O)pQ#tO'#C|OOOd-E7^-E7^O)uQ#tO'#DPOOO`-E7_-E7_O)zQ#|O,59mOOOp-E7`-E7`OOO`1G/Z1G/ZOOO`1G/]1G/]OOO`1G/^1G/^O*PQ,UO,59_OOQW-E7X-E7XOOOa7+$c7+$cOOO`7+$t7+$tOOOb7+$l7+$lOOOd7+$o7+$oOOO`7+$r7+$rO*[Q#|O,59eO*aQ#|O,59hO*fQ#|O,59kOOO`1G/X1G/XO*kO7[O'#CvO*|OMhO'#CvOOQW1G.y1G.yOOO`1G/P1G/POOO`1G/S1G/SOOO`1G/V1G/VOOOO'#D['#D[O+_O7[O,59bOOQW,59b,59bOOOO'#D]'#D]O+pOMhO,59bOOOO-E7Y-E7YOOQW1G.|1G.|OOOO-E7Z-E7Z",
  stateData: ",]~O!^OS~OUSOVPOWQOXROYTO[]O][O^^O`^Oa^Ob^Oc^Ox^O{_O!dZO~OfaO~OfbO~OfcO~OfdO~OfeO~O!WfOPlP!ZlP~O!XiOQoP!ZoP~O!YlORrP!ZrP~OUSOVPOWQOXROYTOZqO[]O][O^^O`^Oa^Ob^Oc^Ox^O!dZO~O!ZrO~P#dO![sO!euO~OfvO~OfwO~OS|OT}OhyO~OS!POT}OhyO~OS!ROT}OhyO~OS!TOT}OhyO~OS}OT}OhyO~O!WfOPlX!ZlX~OP!WO!Z!XO~O!XiOQoX!ZoX~OQ!ZO!Z!XO~O!YlORrX!ZrX~OR!]O!Z!XO~O!Z!XO~P#dOf!_O~O![sO!e!aO~OS!bO~OS!cO~Oi!dOSgXTgXhgX~OS!fOT!gOhyO~OS!hOT!gOhyO~OS!iOT!gOhyO~OS!jOT!gOhyO~OS!gOT!gOhyO~Of!kO~Of!lO~Of!mO~OS!nO~Ok!qO!`!oO!b!pO~OS!rO~OS!sO~OS!tO~Oa!uOb!uOc!uO!`!wO!a!uO~Oa!xOb!xOc!xO!b!wO!c!xO~Oa!uOb!uOc!uO!`!{O!a!uO~Oa!xOb!xOc!xO!b!{O!c!xO~OT~bac!dx{!d~",
  goto: "%p!`PPPPPPPPPPPPPPPPPPPP!a!gP!mPP!yP!|#P#S#Y#]#`#f#i#l#r#x!aP!a!aP$O$U$l$r$x%O%U%[%bPPPPPPPP%hX^OX`pXUOX`pezabcde{!O!Q!S!UR!q!dRhUR!XhXVOX`pRkVR!XkXWOX`pRnWR!XnXXOX`pQrXR!XpXYOX`pQ`ORx`Q{aQ!ObQ!QcQ!SdQ!UeZ!e{!O!Q!S!UQ!v!oR!z!vQ!y!pR!|!yQgUR!VgQjVR!YjQmWR![mQpXR!^pQtZR!`tS_O`ToXp",
  nodeNames: "⚠ StartCloseTag StartCloseTag StartCloseTag EndTag SelfClosingEndTag StartTag StartTag StartTag StartTag StartTag StartCloseTag StartCloseTag StartCloseTag IncompleteCloseTag Document Text EntityReference CharacterReference InvalidEntity Element OpenTag TagName Attribute AttributeName Is AttributeValue UnquotedAttributeValue ScriptText CloseTag OpenTag StyleText CloseTag OpenTag TextareaText CloseTag OpenTag CloseTag SelfClosingTag Comment ProcessingInst MismatchedCloseTag CloseTag DoctypeDecl",
  maxTerm: 67,
  context: fM,
  nodeProps: [
    ["closedBy", -10, 1, 2, 3, 7, 8, 9, 10, 11, 12, 13, "EndTag", 6, "EndTag SelfClosingEndTag", -4, 21, 30, 33, 36, "CloseTag"],
    ["openedBy", 4, "StartTag StartCloseTag", 5, "StartTag", -4, 29, 32, 35, 37, "OpenTag"],
    ["group", -9, 14, 17, 18, 19, 20, 39, 40, 41, 42, "Entity", 16, "Entity TextContent", -3, 28, 31, 34, "TextContent Entity"],
    ["isolate", -11, 21, 29, 30, 32, 33, 35, 36, 37, 38, 41, 42, "ltr", -3, 26, 27, 39, ""]
  ],
  propSources: [kM],
  skippedNodes: [0],
  repeatNodeCount: 9,
  tokenData: "!<p!aR!YOX$qXY,QYZ,QZ[$q[]&X]^,Q^p$qpq,Qqr-_rs3_sv-_vw3}wxHYx}-_}!OH{!O!P-_!P!Q$q!Q![-_![!]Mz!]!^-_!^!_!$S!_!`!;x!`!a&X!a!c-_!c!}Mz!}#R-_#R#SMz#S#T1k#T#oMz#o#s-_#s$f$q$f%W-_%W%oMz%o%p-_%p&aMz&a&b-_&b1pMz1p4U-_4U4dMz4d4e-_4e$ISMz$IS$I`-_$I`$IbMz$Ib$Kh-_$Kh%#tMz%#t&/x-_&/x&EtMz&Et&FV-_&FV;'SMz;'S;:j!#|;:j;=`3X<%l?&r-_?&r?AhMz?Ah?BY$q?BY?MnMz?MnO$q!Z$|c`PkW!a`!cpOX$qXZ&XZ[$q[^&X^p$qpq&Xqr$qrs&}sv$qvw+Pwx(tx!^$q!^!_*V!_!a&X!a#S$q#S#T&X#T;'S$q;'S;=`+z<%lO$q!R&bX`P!a`!cpOr&Xrs&}sv&Xwx(tx!^&X!^!_*V!_;'S&X;'S;=`*y<%lO&Xq'UV`P!cpOv&}wx'kx!^&}!^!_(V!_;'S&};'S;=`(n<%lO&}P'pT`POv'kw!^'k!_;'S'k;'S;=`(P<%lO'kP(SP;=`<%l'kp([S!cpOv(Vx;'S(V;'S;=`(h<%lO(Vp(kP;=`<%l(Vq(qP;=`<%l&}a({W`P!a`Or(trs'ksv(tw!^(t!^!_)e!_;'S(t;'S;=`*P<%lO(t`)jT!a`Or)esv)ew;'S)e;'S;=`)y<%lO)e`)|P;=`<%l)ea*SP;=`<%l(t!Q*^V!a`!cpOr*Vrs(Vsv*Vwx)ex;'S*V;'S;=`*s<%lO*V!Q*vP;=`<%l*V!R*|P;=`<%l&XW+UYkWOX+PZ[+P^p+Pqr+Psw+Px!^+P!a#S+P#T;'S+P;'S;=`+t<%lO+PW+wP;=`<%l+P!Z+}P;=`<%l$q!a,]``P!a`!cp!^^OX&XXY,QYZ,QZ]&X]^,Q^p&Xpq,Qqr&Xrs&}sv&Xwx(tx!^&X!^!_*V!_;'S&X;'S;=`*y<%lO&X!_-ljhS`PkW!a`!cpOX$qXZ&XZ[$q[^&X^p$qpq&Xqr-_rs&}sv-_vw/^wx(tx!P-_!P!Q$q!Q!^-_!^!_*V!_!a&X!a#S-_#S#T1k#T#s-_#s$f$q$f;'S-_;'S;=`3X<%l?Ah-_?Ah?BY$q?BY?Mn-_?MnO$q[/ebhSkWOX+PZ[+P^p+Pqr/^sw/^x!P/^!P!Q+P!Q!^/^!a#S/^#S#T0m#T#s/^#s$f+P$f;'S/^;'S;=`1e<%l?Ah/^?Ah?BY+P?BY?Mn/^?MnO+PS0rXhSqr0msw0mx!P0m!Q!^0m!a#s0m$f;'S0m;'S;=`1_<%l?Ah0m?BY?Mn0mS1bP;=`<%l0m[1hP;=`<%l/^!V1vchS`P!a`!cpOq&Xqr1krs&}sv1kvw0mwx(tx!P1k!P!Q&X!Q!^1k!^!_*V!_!a&X!a#s1k#s$f&X$f;'S1k;'S;=`3R<%l?Ah1k?Ah?BY&X?BY?Mn1k?MnO&X!V3UP;=`<%l1k!_3[P;=`<%l-_!Z3hV!`h`P!cpOv&}wx'kx!^&}!^!_(V!_;'S&};'S;=`(n<%lO&}!_4WihSkWc!ROX5uXZ7SZ[5u[^7S^p5uqr8trs7Sst>]tw8twx7Sx!P8t!P!Q5u!Q!]8t!]!^/^!^!a7S!a#S8t#S#T;{#T#s8t#s$f5u$f;'S8t;'S;=`>V<%l?Ah8t?Ah?BY5u?BY?Mn8t?MnO5u!Z5zbkWOX5uXZ7SZ[5u[^7S^p5uqr5urs7Sst+Ptw5uwx7Sx!]5u!]!^7w!^!a7S!a#S5u#S#T7S#T;'S5u;'S;=`8n<%lO5u!R7VVOp7Sqs7St!]7S!]!^7l!^;'S7S;'S;=`7q<%lO7S!R7qOa!R!R7tP;=`<%l7S!Z8OYkWa!ROX+PZ[+P^p+Pqr+Psw+Px!^+P!a#S+P#T;'S+P;'S;=`+t<%lO+P!Z8qP;=`<%l5u!_8{ihSkWOX5uXZ7SZ[5u[^7S^p5uqr8trs7Sst/^tw8twx7Sx!P8t!P!Q5u!Q!]8t!]!^:j!^!a7S!a#S8t#S#T;{#T#s8t#s$f5u$f;'S8t;'S;=`>V<%l?Ah8t?Ah?BY5u?BY?Mn8t?MnO5u!_:sbhSkWa!ROX+PZ[+P^p+Pqr/^sw/^x!P/^!P!Q+P!Q!^/^!a#S/^#S#T0m#T#s/^#s$f+P$f;'S/^;'S;=`1e<%l?Ah/^?Ah?BY+P?BY?Mn/^?MnO+P!V<QchSOp7Sqr;{rs7Sst0mtw;{wx7Sx!P;{!P!Q7S!Q!];{!]!^=]!^!a7S!a#s;{#s$f7S$f;'S;{;'S;=`>P<%l?Ah;{?Ah?BY7S?BY?Mn;{?MnO7S!V=dXhSa!Rqr0msw0mx!P0m!Q!^0m!a#s0m$f;'S0m;'S;=`1_<%l?Ah0m?BY?Mn0m!V>SP;=`<%l;{!_>YP;=`<%l8t!_>dhhSkWOX@OXZAYZ[@O[^AY^p@OqrBwrsAYswBwwxAYx!PBw!P!Q@O!Q!]Bw!]!^/^!^!aAY!a#SBw#S#TE{#T#sBw#s$f@O$f;'SBw;'S;=`HS<%l?AhBw?Ah?BY@O?BY?MnBw?MnO@O!Z@TakWOX@OXZAYZ[@O[^AY^p@Oqr@OrsAYsw@OwxAYx!]@O!]!^Az!^!aAY!a#S@O#S#TAY#T;'S@O;'S;=`Bq<%lO@O!RA]UOpAYq!]AY!]!^Ao!^;'SAY;'S;=`At<%lOAY!RAtOb!R!RAwP;=`<%lAY!ZBRYkWb!ROX+PZ[+P^p+Pqr+Psw+Px!^+P!a#S+P#T;'S+P;'S;=`+t<%lO+P!ZBtP;=`<%l@O!_COhhSkWOX@OXZAYZ[@O[^AY^p@OqrBwrsAYswBwwxAYx!PBw!P!Q@O!Q!]Bw!]!^Dj!^!aAY!a#SBw#S#TE{#T#sBw#s$f@O$f;'SBw;'S;=`HS<%l?AhBw?Ah?BY@O?BY?MnBw?MnO@O!_DsbhSkWb!ROX+PZ[+P^p+Pqr/^sw/^x!P/^!P!Q+P!Q!^/^!a#S/^#S#T0m#T#s/^#s$f+P$f;'S/^;'S;=`1e<%l?Ah/^?Ah?BY+P?BY?Mn/^?MnO+P!VFQbhSOpAYqrE{rsAYswE{wxAYx!PE{!P!QAY!Q!]E{!]!^GY!^!aAY!a#sE{#s$fAY$f;'SE{;'S;=`G|<%l?AhE{?Ah?BYAY?BY?MnE{?MnOAY!VGaXhSb!Rqr0msw0mx!P0m!Q!^0m!a#s0m$f;'S0m;'S;=`1_<%l?Ah0m?BY?Mn0m!VHPP;=`<%lE{!_HVP;=`<%lBw!ZHcW!bx`P!a`Or(trs'ksv(tw!^(t!^!_)e!_;'S(t;'S;=`*P<%lO(t!aIYlhS`PkW!a`!cpOX$qXZ&XZ[$q[^&X^p$qpq&Xqr-_rs&}sv-_vw/^wx(tx}-_}!OKQ!O!P-_!P!Q$q!Q!^-_!^!_*V!_!a&X!a#S-_#S#T1k#T#s-_#s$f$q$f;'S-_;'S;=`3X<%l?Ah-_?Ah?BY$q?BY?Mn-_?MnO$q!aK_khS`PkW!a`!cpOX$qXZ&XZ[$q[^&X^p$qpq&Xqr-_rs&}sv-_vw/^wx(tx!P-_!P!Q$q!Q!^-_!^!_*V!_!`&X!`!aMS!a#S-_#S#T1k#T#s-_#s$f$q$f;'S-_;'S;=`3X<%l?Ah-_?Ah?BY$q?BY?Mn-_?MnO$q!TM_X`P!a`!cp!eQOr&Xrs&}sv&Xwx(tx!^&X!^!_*V!_;'S&X;'S;=`*y<%lO&X!aNZ!ZhSfQ`PkW!a`!cpOX$qXZ&XZ[$q[^&X^p$qpq&Xqr-_rs&}sv-_vw/^wx(tx}-_}!OMz!O!PMz!P!Q$q!Q![Mz![!]Mz!]!^-_!^!_*V!_!a&X!a!c-_!c!}Mz!}#R-_#R#SMz#S#T1k#T#oMz#o#s-_#s$f$q$f$}-_$}%OMz%O%W-_%W%oMz%o%p-_%p&aMz&a&b-_&b1pMz1p4UMz4U4dMz4d4e-_4e$ISMz$IS$I`-_$I`$IbMz$Ib$Je-_$Je$JgMz$Jg$Kh-_$Kh%#tMz%#t&/x-_&/x&EtMz&Et&FV-_&FV;'SMz;'S;:j!#|;:j;=`3X<%l?&r-_?&r?AhMz?Ah?BY$q?BY?MnMz?MnO$q!a!$PP;=`<%lMz!R!$ZY!a`!cpOq*Vqr!$yrs(Vsv*Vwx)ex!a*V!a!b!4t!b;'S*V;'S;=`*s<%lO*V!R!%Q]!a`!cpOr*Vrs(Vsv*Vwx)ex}*V}!O!%y!O!f*V!f!g!']!g#W*V#W#X!0`#X;'S*V;'S;=`*s<%lO*V!R!&QX!a`!cpOr*Vrs(Vsv*Vwx)ex}*V}!O!&m!O;'S*V;'S;=`*s<%lO*V!R!&vV!a`!cp!dPOr*Vrs(Vsv*Vwx)ex;'S*V;'S;=`*s<%lO*V!R!'dX!a`!cpOr*Vrs(Vsv*Vwx)ex!q*V!q!r!(P!r;'S*V;'S;=`*s<%lO*V!R!(WX!a`!cpOr*Vrs(Vsv*Vwx)ex!e*V!e!f!(s!f;'S*V;'S;=`*s<%lO*V!R!(zX!a`!cpOr*Vrs(Vsv*Vwx)ex!v*V!v!w!)g!w;'S*V;'S;=`*s<%lO*V!R!)nX!a`!cpOr*Vrs(Vsv*Vwx)ex!{*V!{!|!*Z!|;'S*V;'S;=`*s<%lO*V!R!*bX!a`!cpOr*Vrs(Vsv*Vwx)ex!r*V!r!s!*}!s;'S*V;'S;=`*s<%lO*V!R!+UX!a`!cpOr*Vrs(Vsv*Vwx)ex!g*V!g!h!+q!h;'S*V;'S;=`*s<%lO*V!R!+xY!a`!cpOr!+qrs!,hsv!+qvw!-Swx!.[x!`!+q!`!a!/j!a;'S!+q;'S;=`!0Y<%lO!+qq!,mV!cpOv!,hvx!-Sx!`!,h!`!a!-q!a;'S!,h;'S;=`!.U<%lO!,hP!-VTO!`!-S!`!a!-f!a;'S!-S;'S;=`!-k<%lO!-SP!-kO{PP!-nP;=`<%l!-Sq!-xS!cp{POv(Vx;'S(V;'S;=`(h<%lO(Vq!.XP;=`<%l!,ha!.aX!a`Or!.[rs!-Ssv!.[vw!-Sw!`!.[!`!a!.|!a;'S!.[;'S;=`!/d<%lO!.[a!/TT!a`{POr)esv)ew;'S)e;'S;=`)y<%lO)ea!/gP;=`<%l!.[!R!/sV!a`!cp{POr*Vrs(Vsv*Vwx)ex;'S*V;'S;=`*s<%lO*V!R!0]P;=`<%l!+q!R!0gX!a`!cpOr*Vrs(Vsv*Vwx)ex#c*V#c#d!1S#d;'S*V;'S;=`*s<%lO*V!R!1ZX!a`!cpOr*Vrs(Vsv*Vwx)ex#V*V#V#W!1v#W;'S*V;'S;=`*s<%lO*V!R!1}X!a`!cpOr*Vrs(Vsv*Vwx)ex#h*V#h#i!2j#i;'S*V;'S;=`*s<%lO*V!R!2qX!a`!cpOr*Vrs(Vsv*Vwx)ex#m*V#m#n!3^#n;'S*V;'S;=`*s<%lO*V!R!3eX!a`!cpOr*Vrs(Vsv*Vwx)ex#d*V#d#e!4Q#e;'S*V;'S;=`*s<%lO*V!R!4XX!a`!cpOr*Vrs(Vsv*Vwx)ex#X*V#X#Y!+q#Y;'S*V;'S;=`*s<%lO*V!R!4{Y!a`!cpOr!4trs!5ksv!4tvw!6Vwx!8]x!a!4t!a!b!:]!b;'S!4t;'S;=`!;r<%lO!4tq!5pV!cpOv!5kvx!6Vx!a!5k!a!b!7W!b;'S!5k;'S;=`!8V<%lO!5kP!6YTO!a!6V!a!b!6i!b;'S!6V;'S;=`!7Q<%lO!6VP!6lTO!`!6V!`!a!6{!a;'S!6V;'S;=`!7Q<%lO!6VP!7QOxPP!7TP;=`<%l!6Vq!7]V!cpOv!5kvx!6Vx!`!5k!`!a!7r!a;'S!5k;'S;=`!8V<%lO!5kq!7yS!cpxPOv(Vx;'S(V;'S;=`(h<%lO(Vq!8YP;=`<%l!5ka!8bX!a`Or!8]rs!6Vsv!8]vw!6Vw!a!8]!a!b!8}!b;'S!8];'S;=`!:V<%lO!8]a!9SX!a`Or!8]rs!6Vsv!8]vw!6Vw!`!8]!`!a!9o!a;'S!8];'S;=`!:V<%lO!8]a!9vT!a`xPOr)esv)ew;'S)e;'S;=`)y<%lO)ea!:YP;=`<%l!8]!R!:dY!a`!cpOr!4trs!5ksv!4tvw!6Vwx!8]x!`!4t!`!a!;S!a;'S!4t;'S;=`!;r<%lO!4t!R!;]V!a`!cpxPOr*Vrs(Vsv*Vwx)ex;'S*V;'S;=`*s<%lO*V!R!;uP;=`<%l!4t!V!<TXiS`P!a`!cpOr&Xrs&}sv&Xwx(tx!^&X!^!_*V!_;'S&X;'S;=`*y<%lO&X",
  tokenizers: [OM, bM, yM, gM, dM, pM, 0, 1, 2, 3, 4, 5],
  topRules: { Document: [0, 15] },
  dialects: { noMatch: 0, selfClosing: 509 },
  tokenPrec: 511
});
function cy(n, e) {
  let t = /* @__PURE__ */ Object.create(null);
  for (let i of n.getChildren(oy)) {
    let r = i.getChild(HR), s = i.getChild(Dc) || i.getChild(ay);
    r && (t[e.read(r.from, r.to)] = s ? s.type.id == Dc ? e.read(s.from + 1, s.to - 1) : e.read(s.from, s.to) : "");
  }
  return t;
}
function $m(n, e) {
  let t = n.getChild(GR);
  return t ? e.read(t.from, t.to) : " ";
}
function Kl(n, e, t) {
  let i;
  for (let r of t)
    if (!r.attrs || r.attrs(i || (i = cy(n.node.parent.firstChild, e))))
      return { parser: r.parser };
  return null;
}
function hy(n = [], e = []) {
  let t = [], i = [], r = [], s = [];
  for (let a of n)
    (a.tag == "script" ? t : a.tag == "style" ? i : a.tag == "textarea" ? r : s).push(a);
  let o = e.length ? /* @__PURE__ */ Object.create(null) : null;
  for (let a of e)
    (o[a.name] || (o[a.name] = [])).push(a);
  return HO((a, l) => {
    let u = a.type.id;
    if (u == KR)
      return Kl(a, l, t);
    if (u == JR)
      return Kl(a, l, i);
    if (u == eM)
      return Kl(a, l, r);
    if (u == sy && s.length) {
      let c = a.node, h = c.firstChild, f = h && $m(h, l), d;
      if (f) {
        for (let p of s)
          if (p.tag == f && (!p.attrs || p.attrs(d || (d = cy(h, l))))) {
            let g = c.lastChild, O = g.type.id == nM ? g.from : c.to;
            if (O > h.to)
              return { parser: p.parser, overlay: [{ from: h.to, to: O }] };
          }
      }
    }
    if (o && u == oy) {
      let c = a.node, h;
      if (h = c.firstChild) {
        let f = o[l.read(h.from, h.to)];
        if (f)
          for (let d of f) {
            if (d.tagName && d.tagName != $m(c.parent, l))
              continue;
            let p = c.lastChild;
            if (p.type.id == Dc) {
              let g = p.from + 1, O = p.lastChild, m = p.to - (O && O.isError ? 0 : 1);
              if (m > g)
                return { parser: d.parser, overlay: [{ from: g, to: m }] };
            } else if (p.type.id == ay)
              return { parser: d.parser, overlay: [{ from: p.from, to: p.to }] };
          }
      }
    }
    return null;
  });
}
const wM = 99, Cm = 1, SM = 100, vM = 101, Tm = 2, fy = [
  9,
  10,
  11,
  12,
  13,
  32,
  133,
  160,
  5760,
  8192,
  8193,
  8194,
  8195,
  8196,
  8197,
  8198,
  8199,
  8200,
  8201,
  8202,
  8232,
  8233,
  8239,
  8287,
  12288
], PM = 58, QM = 40, dy = 95, $M = 91, Ho = 45, CM = 46, TM = 35, AM = 37, RM = 38, MM = 92, ZM = 10;
function Cs(n) {
  return n >= 65 && n <= 90 || n >= 97 && n <= 122 || n >= 161;
}
function py(n) {
  return n >= 48 && n <= 57;
}
const EM = new Kt((n, e) => {
  for (let t = !1, i = 0, r = 0; ; r++) {
    let { next: s } = n;
    if (Cs(s) || s == Ho || s == dy || t && py(s))
      !t && (s != Ho || r > 0) && (t = !0), i === r && s == Ho && i++, n.advance();
    else if (s == MM && n.peek(1) != ZM)
      n.advance(), n.next > -1 && n.advance(), t = !0;
    else {
      t && n.acceptToken(s == QM ? SM : i == 2 && e.canShift(Tm) ? Tm : vM);
      break;
    }
  }
}), zM = new Kt((n) => {
  if (fy.includes(n.peek(-1))) {
    let { next: e } = n;
    (Cs(e) || e == dy || e == TM || e == CM || e == $M || e == PM && Cs(n.peek(1)) || e == Ho || e == RM) && n.acceptToken(wM);
  }
}), DM = new Kt((n) => {
  if (!fy.includes(n.peek(-1))) {
    let { next: e } = n;
    if (e == AM && (n.advance(), n.acceptToken(Cm)), Cs(e)) {
      do
        n.advance();
      while (Cs(n.next) || py(n.next));
      n.acceptToken(Cm);
    }
  }
}), IM = pr({
  "AtKeyword import charset namespace keyframes media supports": x.definitionKeyword,
  "from to selector": x.keyword,
  NamespaceName: x.namespace,
  KeyframeName: x.labelName,
  KeyframeRangeName: x.operatorKeyword,
  TagName: x.tagName,
  ClassName: x.className,
  PseudoClassName: x.constant(x.className),
  IdName: x.labelName,
  "FeatureName PropertyName": x.propertyName,
  AttributeName: x.attributeName,
  NumberLiteral: x.number,
  KeywordQuery: x.keyword,
  UnaryQueryOp: x.operatorKeyword,
  "CallTag ValueName": x.atom,
  VariableName: x.variableName,
  Callee: x.operatorKeyword,
  Unit: x.unit,
  "UniversalSelector NestingSelector": x.definitionOperator,
  MatchOp: x.compareOperator,
  "ChildOp SiblingOp, LogicOp": x.logicOperator,
  BinOp: x.arithmeticOperator,
  Important: x.modifier,
  Comment: x.blockComment,
  ColorLiteral: x.color,
  "ParenthesizedContent StringLiteral": x.string,
  ":": x.punctuation,
  "PseudoOp #": x.derefOperator,
  "; ,": x.separator,
  "( )": x.paren,
  "[ ]": x.squareBracket,
  "{ }": x.brace
}), LM = { __proto__: null, lang: 32, "nth-child": 32, "nth-last-child": 32, "nth-of-type": 32, "nth-last-of-type": 32, dir: 32, "host-context": 32, url: 60, "url-prefix": 60, domain: 60, regexp: 60, selector: 138 }, _M = { __proto__: null, "@import": 118, "@media": 142, "@charset": 146, "@namespace": 150, "@keyframes": 156, "@supports": 168 }, XM = { __proto__: null, not: 132, only: 132 }, NM = cr.deserialize({
  version: 14,
  states: ":^QYQ[OOO#_Q[OOP#fOWOOOOQP'#Cd'#CdOOQP'#Cc'#CcO#kQ[O'#CfO$_QXO'#CaO$fQ[O'#ChO$qQ[O'#DTO$vQ[O'#DWOOQP'#Em'#EmO${QdO'#DgO%jQ[O'#DtO${QdO'#DvO%{Q[O'#DxO&WQ[O'#D{O&`Q[O'#ERO&nQ[O'#ETOOQS'#El'#ElOOQS'#EW'#EWQYQ[OOO&uQXO'#CdO'jQWO'#DcO'oQWO'#EsO'zQ[O'#EsQOQWOOP(UO#tO'#C_POOO)C@[)C@[OOQP'#Cg'#CgOOQP,59Q,59QO#kQ[O,59QO(aQ[O'#E[O({QWO,58{O)TQ[O,59SO$qQ[O,59oO$vQ[O,59rO(aQ[O,59uO(aQ[O,59wO(aQ[O,59xO)`Q[O'#DbOOQS,58{,58{OOQP'#Ck'#CkOOQO'#DR'#DROOQP,59S,59SO)gQWO,59SO)lQWO,59SOOQP'#DV'#DVOOQP,59o,59oOOQO'#DX'#DXO)qQ`O,59rOOQS'#Cp'#CpO${QdO'#CqO)yQvO'#CsO+ZQtO,5:ROOQO'#Cx'#CxO)lQWO'#CwO+oQWO'#CyO+tQ[O'#DOOOQS'#Ep'#EpOOQO'#Dj'#DjO+|Q[O'#DqO,[QWO'#EtO&`Q[O'#DoO,jQWO'#DrOOQO'#Eu'#EuO)OQWO,5:`O,oQpO,5:bOOQS'#Dz'#DzO,wQWO,5:dO,|Q[O,5:dOOQO'#D}'#D}O-UQWO,5:gO-ZQWO,5:mO-cQWO,5:oOOQS-E8U-E8UO${QdO,59}O-kQ[O'#E^O-xQWO,5;_O-xQWO,5;_POOO'#EV'#EVP.TO#tO,58yPOOO,58y,58yOOQP1G.l1G.lO.zQXO,5:vOOQO-E8Y-E8YOOQS1G.g1G.gOOQP1G.n1G.nO)gQWO1G.nO)lQWO1G.nOOQP1G/Z1G/ZO/XQ`O1G/^O/rQXO1G/aO0YQXO1G/cO0pQXO1G/dO1WQWO,59|O1]Q[O'#DSO1dQdO'#CoOOQP1G/^1G/^O${QdO1G/^O1kQpO,59]OOQS,59_,59_O${QdO,59aO1sQWO1G/mOOQS,59c,59cO1xQ!bO,59eOOQS'#DP'#DPOOQS'#EY'#EYO2QQ[O,59jOOQS,59j,59jO2YQWO'#DjO2eQWO,5:VO2jQWO,5:]O&`Q[O,5:XO&`Q[O'#E_O2rQWO,5;`O2}QWO,5:ZO(aQ[O,5:^OOQS1G/z1G/zOOQS1G/|1G/|OOQS1G0O1G0OO3`QWO1G0OO3eQdO'#EOOOQS1G0R1G0ROOQS1G0X1G0XOOQS1G0Z1G0ZO3pQtO1G/iOOQO,5:x,5:xO4WQ[O,5:xOOQO-E8[-E8[O4eQWO1G0yPOOO-E8T-E8TPOOO1G.e1G.eOOQP7+$Y7+$YOOQP7+$x7+$xO${QdO7+$xOOQS1G/h1G/hO4pQXO'#ErO4wQWO,59nO4|QtO'#EXO5tQdO'#EoO6OQWO,59ZO6TQpO7+$xOOQS1G.w1G.wOOQS1G.{1G.{OOQS7+%X7+%XO6]QWO1G/POOQS-E8W-E8WOOQS1G/U1G/UO${QdO1G/qOOQO1G/w1G/wOOQO1G/s1G/sO6bQWO,5:yOOQO-E8]-E8]O6pQXO1G/xOOQS7+%j7+%jO6wQYO'#CsOOQO'#EQ'#EQO7SQ`O'#EPOOQO'#EP'#EPO7_QWO'#E`O7gQdO,5:jOOQS,5:j,5:jO7rQtO'#E]O${QdO'#E]O8sQdO7+%TOOQO7+%T7+%TOOQO1G0d1G0dO9WQpO<<HdO9`QWO,5;^OOQP1G/Y1G/YOOQS-E8V-E8VO${QdO'#EZO9hQWO,5;ZOOQT1G.u1G.uOOQP<<Hd<<HdOOQS7+$k7+$kO9pQdO7+%]OOQO7+%d7+%dOOQO,5:k,5:kO3hQdO'#EaO7_QWO,5:zOOQS,5:z,5:zOOQS-E8^-E8^OOQS1G0U1G0UO9wQtO,5:wOOQS-E8Z-E8ZOOQO<<Ho<<HoOOQPAN>OAN>OO:xQdO,5:uOOQO-E8X-E8XOOQO<<Hw<<HwOOQO,5:{,5:{OOQO-E8_-E8_OOQS1G0f1G0f",
  stateData: ";[~O#ZOS#[QQ~OUYOXYO]VO^VOqXOxWO![aO!]ZO!i[O!k]O!m^O!p_O!v`O#XRO#bTO~OQfOUYOXYO]VO^VOqXOxWO![aO!]ZO!i[O!k]O!m^O!p_O!v`O#XeO#bTO~O#U#gP~P!ZO#[jO~O#XlO~O]qO^qOqsOtoOxrO!OtO!RvO#VuO#bnO~O!TwO~P#pO`}O#WzO#XyO~O#X!OO~O#X!QO~OQ![Ob!TOf![Oh![On!YOq!ZO#W!WO#X!SO#e!UO~Ob!^O!d!`O!g!aO#X!]O!T#hP~Oh!fOn!YO#X!eO~Oh!hO#X!hO~Ob!^O!d!`O!g!aO#X!]O~O!Y#hP~P%jO]WX]!WX^WXqWXtWXxWX!OWX!RWX!TWX#VWX#bWX~O]!mO~O!Y!nO#U#gX!S#gX~O#U#gX!S#gX~P!ZO#]!qO#^!qO#_!sO~OUYOXYO]VO^VOqXOxWO#XRO#bTO~OtoO!TwO~O`!zO#WzO#XyO~O!S#gP~P!ZOb#RO~Ob#SO~Op#TO|#UO~OP#WObgXjgX!YgX!dgX!ggX#XgXagXQgXfgXhgXngXqgXtgX!XgX#UgX#WgX#egXpgX!SgX~Ob!^Oj#XO!d!`O!g!aO#X!]O!Y#hP~Ob#[O~Op#`O#X#]O~Ob!^O!d!`O!g!aO#X#aO~Ot#eO!b#dO!T#hX!Y#hX~Ob#hO~Oj#XO!Y#jO~O!Y#kO~Oh#lOn!YO~O!T#mO~O!TwO!b#dO~O!TwO!Y#pO~O!Y#QX#U#QX!S#QX~P!ZO!Y!nO#U#ga!S#ga~O#]!qO#^!qO#_#wO~O]qO^qOqsOxrO!OtO!RvO#VuO#bnO~Ot#Oa!T#Oaa#Oa~P.`Op#yO|#zO~O]qO^qOqsOxrO#bnO~Ot}i!O}i!R}i!T}i#V}ia}i~P/aOt!Pi!O!Pi!R!Pi!T!Pi#V!Pia!Pi~P/aOt!Qi!O!Qi!R!Qi!T!Qi#V!Qia!Qi~P/aO!S#{O~Oa#fP~P(aOa#cP~P${Oa$SOj#XO~O!Y$UO~Oh$VOo$VO~Op$XO#X#]O~O]!`Xa!^X!b!^X~O]$YO~Oa$ZO!b#dO~Ot#eO!T#ha!Y#ha~O!b#dOt!ca!T!ca!Y!caa!ca~O!Y$`O~O!S$gO#X$bO#e$aO~Oj#XOt$iO!X$kO!Y!Vi#U!Vi!S!Vi~P${O!Y#Qa#U#Qa!S#Qa~P!ZO!Y!nO#U#gi!S#gi~Oa#fX~P#pOa$oO~Oj#XOQ!{Xa!{Xb!{Xf!{Xh!{Xn!{Xq!{Xt!{X#W!{X#X!{X#e!{X~Ot$qOa#cX~P${Oa$sO~Oj#XOp$tO~Oa$uO~O!b#dOt#Ra!T#Ra!Y#Ra~Oa$wO~P.`OP#WOtgX!TgX~O#e$aOt!sX!T!sX~Ot$yO!TwO~O!S$}O#X$bO#e$aO~Oj#XOQ#PXb#PXf#PXh#PXn#PXq#PXt#PX!X#PX!Y#PX#U#PX#W#PX#X#PX#e#PX!S#PX~Ot$iO!X%QO!Y!Vq#U!Vq!S!Vq~P${Oj#XOp%RO~OtoOa#fa~Ot$qOa#ca~Oa%UO~P${Oj#XOQ#Pab#Paf#Pah#Pan#Paq#Pat#Pa!X#Pa!Y#Pa#U#Pa#W#Pa#X#Pa#e#Pa!S#Pa~Oa!}at!}a~P${O#Zo#[#ej!R#e~",
  goto: "-g#jPPP#kP#nP#w$WP#w$g#wPP$mPPP$s$|$|P%`P$|P$|%z&^PPPP$|&vP&z'Q#wP'W#w'^P#wP#w#wPPP'd'y(WPP#nPP(_(_(i(_P(_P(_(_P#nP#nP#nP(l#nP(o(r(u(|#nP#nP)R)X)h)v)|*S*^*d*n*t*zPPPPPPPPPP+Q+ZP+v+yP,o,r,x-RRkQ_bOPdhw!n#skYOPdhotuvw!n#R#h#skSOPdhotuvw!n#R#h#sQmTR!tnQ{VR!xqQ!x}Q#Z!XR#x!zq![Z]!T!m#S#U#X#q#z$P$Y$i$j$q$v%Sp![Z]!T!m#S#U#X#q#z$P$Y$i$j$q$v%SU$d#m$f$yR$x$cq!XZ]!T!m#S#U#X#q#z$P$Y$i$j$q$v%Sp![Z]!T!m#S#U#X#q#z$P$Y$i$j$q$v%SQ!f^R#l!gT#^!Z#_Q|VR!yqQ!x|R#x!yQ!PWR!{rQ!RXR!|sQxUQ!wpQ#i!cQ#o!jQ#p!kQ${$eR%X$zSgPwQ!phQ#r!nR$l#sZfPhw!n#sa!b[`a!V!^!`#d#eR#b!^R!g^R!i_R#n!iS$e#m$fR%V$yV$c#m$f$yQ!rjR#v!rQdOShPwU!ldh#sR#s!nQ$P#SU$p$P$v%SQ$v$YR%S$qQ#_!ZR$W#_Q$r$PR%T$rQpUS!vp$nR$n#|Q$j#qR%P$jQ!ogS#t!o#uR#u!pQ#f!_R$^#fQ$f#mR$|$fQ$z$eR%W$z_cOPdhw!n#s^UOPdhw!n#sQ!uoQ!}tQ#OuQ#PvQ#|#RR$_#hR$Q#SQ!VZQ!d]Q#V!TQ#q!m[$O#S$P$Y$q$v%SQ$R#UQ$T#XS$h#q$jQ$m#zR%O$iR#}#RQiPR#QwQ!c[Q!kaR#Y!VU!_[a!VQ!j`Q#c!^Q#g!`Q$[#dR$]#e",
  nodeNames: "⚠ Unit VariableName Comment StyleSheet RuleSet UniversalSelector TagSelector TagName NestingSelector ClassSelector ClassName PseudoClassSelector : :: PseudoClassName PseudoClassName ) ( ArgList ValueName ParenthesizedValue ColorLiteral NumberLiteral StringLiteral BinaryExpression BinOp CallExpression Callee CallLiteral CallTag ParenthesizedContent ] [ LineNames LineName , PseudoClassName ArgList IdSelector # IdName AttributeSelector AttributeName MatchOp ChildSelector ChildOp DescendantSelector SiblingSelector SiblingOp } { Block Declaration PropertyName Important ; ImportStatement AtKeyword import KeywordQuery FeatureQuery FeatureName BinaryQuery LogicOp UnaryQuery UnaryQueryOp ParenthesizedQuery SelectorQuery selector MediaStatement media CharsetStatement charset NamespaceStatement namespace NamespaceName KeyframesStatement keyframes KeyframeName KeyframeList KeyframeSelector KeyframeRangeName SupportsStatement supports AtRule Styles",
  maxTerm: 117,
  nodeProps: [
    ["isolate", -2, 3, 24, ""],
    ["openedBy", 17, "(", 32, "[", 50, "{"],
    ["closedBy", 18, ")", 33, "]", 51, "}"]
  ],
  propSources: [IM],
  skippedNodes: [0, 3, 87],
  repeatNodeCount: 11,
  tokenData: "J^~R!^OX$}X^%u^p$}pq%uqr)Xrs.Rst/utu6duv$}vw7^wx7oxy9^yz9oz{9t{|:_|}?Q}!O?c!O!P@Q!P!Q@i!Q![Ab![!]B]!]!^CX!^!_$}!_!`Cj!`!aC{!a!b$}!b!cDw!c!}$}!}#OFa#O#P$}#P#QFr#Q#R6d#R#T$}#T#UGT#U#c$}#c#dHf#d#o$}#o#pH{#p#q6d#q#rI^#r#sIo#s#y$}#y#z%u#z$f$}$f$g%u$g#BY$}#BY#BZ%u#BZ$IS$}$IS$I_%u$I_$I|$}$I|$JO%u$JO$JT$}$JT$JU%u$JU$KV$}$KV$KW%u$KW&FU$}&FU&FV%u&FV;'S$};'S;=`JW<%lO$}`%QSOy%^z;'S%^;'S;=`%o<%lO%^`%cSo`Oy%^z;'S%^;'S;=`%o<%lO%^`%rP;=`<%l%^~%zh#Z~OX%^X^'f^p%^pq'fqy%^z#y%^#y#z'f#z$f%^$f$g'f$g#BY%^#BY#BZ'f#BZ$IS%^$IS$I_'f$I_$I|%^$I|$JO'f$JO$JT%^$JT$JU'f$JU$KV%^$KV$KW'f$KW&FU%^&FU&FV'f&FV;'S%^;'S;=`%o<%lO%^~'mh#Z~o`OX%^X^'f^p%^pq'fqy%^z#y%^#y#z'f#z$f%^$f$g'f$g#BY%^#BY#BZ'f#BZ$IS%^$IS$I_'f$I_$I|%^$I|$JO'f$JO$JT%^$JT$JU'f$JU$KV%^$KV$KW'f$KW&FU%^&FU&FV'f&FV;'S%^;'S;=`%o<%lO%^l)[UOy%^z#]%^#]#^)n#^;'S%^;'S;=`%o<%lO%^l)sUo`Oy%^z#a%^#a#b*V#b;'S%^;'S;=`%o<%lO%^l*[Uo`Oy%^z#d%^#d#e*n#e;'S%^;'S;=`%o<%lO%^l*sUo`Oy%^z#c%^#c#d+V#d;'S%^;'S;=`%o<%lO%^l+[Uo`Oy%^z#f%^#f#g+n#g;'S%^;'S;=`%o<%lO%^l+sUo`Oy%^z#h%^#h#i,V#i;'S%^;'S;=`%o<%lO%^l,[Uo`Oy%^z#T%^#T#U,n#U;'S%^;'S;=`%o<%lO%^l,sUo`Oy%^z#b%^#b#c-V#c;'S%^;'S;=`%o<%lO%^l-[Uo`Oy%^z#h%^#h#i-n#i;'S%^;'S;=`%o<%lO%^l-uS!X[o`Oy%^z;'S%^;'S;=`%o<%lO%^~.UWOY.RZr.Rrs.ns#O.R#O#P.s#P;'S.R;'S;=`/o<%lO.R~.sOh~~.vRO;'S.R;'S;=`/P;=`O.R~/SXOY.RZr.Rrs.ns#O.R#O#P.s#P;'S.R;'S;=`/o;=`<%l.R<%lO.R~/rP;=`<%l.Rn/zYxQOy%^z!Q%^!Q![0j![!c%^!c!i0j!i#T%^#T#Z0j#Z;'S%^;'S;=`%o<%lO%^l0oYo`Oy%^z!Q%^!Q![1_![!c%^!c!i1_!i#T%^#T#Z1_#Z;'S%^;'S;=`%o<%lO%^l1dYo`Oy%^z!Q%^!Q![2S![!c%^!c!i2S!i#T%^#T#Z2S#Z;'S%^;'S;=`%o<%lO%^l2ZYf[o`Oy%^z!Q%^!Q![2y![!c%^!c!i2y!i#T%^#T#Z2y#Z;'S%^;'S;=`%o<%lO%^l3QYf[o`Oy%^z!Q%^!Q![3p![!c%^!c!i3p!i#T%^#T#Z3p#Z;'S%^;'S;=`%o<%lO%^l3uYo`Oy%^z!Q%^!Q![4e![!c%^!c!i4e!i#T%^#T#Z4e#Z;'S%^;'S;=`%o<%lO%^l4lYf[o`Oy%^z!Q%^!Q![5[![!c%^!c!i5[!i#T%^#T#Z5[#Z;'S%^;'S;=`%o<%lO%^l5aYo`Oy%^z!Q%^!Q![6P![!c%^!c!i6P!i#T%^#T#Z6P#Z;'S%^;'S;=`%o<%lO%^l6WSf[o`Oy%^z;'S%^;'S;=`%o<%lO%^d6gUOy%^z!_%^!_!`6y!`;'S%^;'S;=`%o<%lO%^d7QS|So`Oy%^z;'S%^;'S;=`%o<%lO%^b7cSXQOy%^z;'S%^;'S;=`%o<%lO%^~7rWOY7oZw7owx.nx#O7o#O#P8[#P;'S7o;'S;=`9W<%lO7o~8_RO;'S7o;'S;=`8h;=`O7o~8kXOY7oZw7owx.nx#O7o#O#P8[#P;'S7o;'S;=`9W;=`<%l7o<%lO7o~9ZP;=`<%l7on9cSb^Oy%^z;'S%^;'S;=`%o<%lO%^~9tOa~n9{UUQjWOy%^z!_%^!_!`6y!`;'S%^;'S;=`%o<%lO%^n:fWjW!RQOy%^z!O%^!O!P;O!P!Q%^!Q![>T![;'S%^;'S;=`%o<%lO%^l;TUo`Oy%^z!Q%^!Q![;g![;'S%^;'S;=`%o<%lO%^l;nYo`#e[Oy%^z!Q%^!Q![;g![!g%^!g!h<^!h#X%^#X#Y<^#Y;'S%^;'S;=`%o<%lO%^l<cYo`Oy%^z{%^{|=R|}%^}!O=R!O!Q%^!Q![=j![;'S%^;'S;=`%o<%lO%^l=WUo`Oy%^z!Q%^!Q![=j![;'S%^;'S;=`%o<%lO%^l=qUo`#e[Oy%^z!Q%^!Q![=j![;'S%^;'S;=`%o<%lO%^l>[[o`#e[Oy%^z!O%^!O!P;g!P!Q%^!Q![>T![!g%^!g!h<^!h#X%^#X#Y<^#Y;'S%^;'S;=`%o<%lO%^n?VSt^Oy%^z;'S%^;'S;=`%o<%lO%^l?hWjWOy%^z!O%^!O!P;O!P!Q%^!Q![>T![;'S%^;'S;=`%o<%lO%^n@VU#bQOy%^z!Q%^!Q![;g![;'S%^;'S;=`%o<%lO%^~@nTjWOy%^z{@}{;'S%^;'S;=`%o<%lO%^~AUSo`#[~Oy%^z;'S%^;'S;=`%o<%lO%^lAg[#e[Oy%^z!O%^!O!P;g!P!Q%^!Q![>T![!g%^!g!h<^!h#X%^#X#Y<^#Y;'S%^;'S;=`%o<%lO%^bBbU]QOy%^z![%^![!]Bt!];'S%^;'S;=`%o<%lO%^bB{S^Qo`Oy%^z;'S%^;'S;=`%o<%lO%^nC^S!Y^Oy%^z;'S%^;'S;=`%o<%lO%^dCoS|SOy%^z;'S%^;'S;=`%o<%lO%^bDQU!OQOy%^z!`%^!`!aDd!a;'S%^;'S;=`%o<%lO%^bDkS!OQo`Oy%^z;'S%^;'S;=`%o<%lO%^bDzWOy%^z!c%^!c!}Ed!}#T%^#T#oEd#o;'S%^;'S;=`%o<%lO%^bEk[![Qo`Oy%^z}%^}!OEd!O!Q%^!Q![Ed![!c%^!c!}Ed!}#T%^#T#oEd#o;'S%^;'S;=`%o<%lO%^nFfSq^Oy%^z;'S%^;'S;=`%o<%lO%^nFwSp^Oy%^z;'S%^;'S;=`%o<%lO%^bGWUOy%^z#b%^#b#cGj#c;'S%^;'S;=`%o<%lO%^bGoUo`Oy%^z#W%^#W#XHR#X;'S%^;'S;=`%o<%lO%^bHYS!bQo`Oy%^z;'S%^;'S;=`%o<%lO%^bHiUOy%^z#f%^#f#gHR#g;'S%^;'S;=`%o<%lO%^fIQS!TUOy%^z;'S%^;'S;=`%o<%lO%^nIcS!S^Oy%^z;'S%^;'S;=`%o<%lO%^fItU!RQOy%^z!_%^!_!`6y!`;'S%^;'S;=`%o<%lO%^`JZP;=`<%l$}",
  tokenizers: [zM, DM, EM, 1, 2, 3, 4, new za("m~RRYZ[z{a~~g~aO#^~~dP!P!Qg~lO#_~~", 28, 105)],
  topRules: { StyleSheet: [0, 4], Styles: [1, 86] },
  specialized: [{ term: 100, get: (n) => LM[n] || -1 }, { term: 58, get: (n) => _M[n] || -1 }, { term: 101, get: (n) => XM[n] || -1 }],
  tokenPrec: 1200
});
let Jl = null;
function eu() {
  if (!Jl && typeof document == "object" && document.body) {
    let { style: n } = document.body, e = [], t = /* @__PURE__ */ new Set();
    for (let i in n)
      i != "cssText" && i != "cssFloat" && typeof n[i] == "string" && (/[A-Z]/.test(i) && (i = i.replace(/[A-Z]/g, (r) => "-" + r.toLowerCase())), t.has(i) || (e.push(i), t.add(i)));
    Jl = e.sort().map((i) => ({ type: "property", label: i }));
  }
  return Jl || [];
}
const Am = /* @__PURE__ */ [
  "active",
  "after",
  "any-link",
  "autofill",
  "backdrop",
  "before",
  "checked",
  "cue",
  "default",
  "defined",
  "disabled",
  "empty",
  "enabled",
  "file-selector-button",
  "first",
  "first-child",
  "first-letter",
  "first-line",
  "first-of-type",
  "focus",
  "focus-visible",
  "focus-within",
  "fullscreen",
  "has",
  "host",
  "host-context",
  "hover",
  "in-range",
  "indeterminate",
  "invalid",
  "is",
  "lang",
  "last-child",
  "last-of-type",
  "left",
  "link",
  "marker",
  "modal",
  "not",
  "nth-child",
  "nth-last-child",
  "nth-last-of-type",
  "nth-of-type",
  "only-child",
  "only-of-type",
  "optional",
  "out-of-range",
  "part",
  "placeholder",
  "placeholder-shown",
  "read-only",
  "read-write",
  "required",
  "right",
  "root",
  "scope",
  "selection",
  "slotted",
  "target",
  "target-text",
  "valid",
  "visited",
  "where"
].map((n) => ({ type: "class", label: n })), Rm = /* @__PURE__ */ [
  "above",
  "absolute",
  "activeborder",
  "additive",
  "activecaption",
  "after-white-space",
  "ahead",
  "alias",
  "all",
  "all-scroll",
  "alphabetic",
  "alternate",
  "always",
  "antialiased",
  "appworkspace",
  "asterisks",
  "attr",
  "auto",
  "auto-flow",
  "avoid",
  "avoid-column",
  "avoid-page",
  "avoid-region",
  "axis-pan",
  "background",
  "backwards",
  "baseline",
  "below",
  "bidi-override",
  "blink",
  "block",
  "block-axis",
  "bold",
  "bolder",
  "border",
  "border-box",
  "both",
  "bottom",
  "break",
  "break-all",
  "break-word",
  "bullets",
  "button",
  "button-bevel",
  "buttonface",
  "buttonhighlight",
  "buttonshadow",
  "buttontext",
  "calc",
  "capitalize",
  "caps-lock-indicator",
  "caption",
  "captiontext",
  "caret",
  "cell",
  "center",
  "checkbox",
  "circle",
  "cjk-decimal",
  "clear",
  "clip",
  "close-quote",
  "col-resize",
  "collapse",
  "color",
  "color-burn",
  "color-dodge",
  "column",
  "column-reverse",
  "compact",
  "condensed",
  "contain",
  "content",
  "contents",
  "content-box",
  "context-menu",
  "continuous",
  "copy",
  "counter",
  "counters",
  "cover",
  "crop",
  "cross",
  "crosshair",
  "currentcolor",
  "cursive",
  "cyclic",
  "darken",
  "dashed",
  "decimal",
  "decimal-leading-zero",
  "default",
  "default-button",
  "dense",
  "destination-atop",
  "destination-in",
  "destination-out",
  "destination-over",
  "difference",
  "disc",
  "discard",
  "disclosure-closed",
  "disclosure-open",
  "document",
  "dot-dash",
  "dot-dot-dash",
  "dotted",
  "double",
  "down",
  "e-resize",
  "ease",
  "ease-in",
  "ease-in-out",
  "ease-out",
  "element",
  "ellipse",
  "ellipsis",
  "embed",
  "end",
  "ethiopic-abegede-gez",
  "ethiopic-halehame-aa-er",
  "ethiopic-halehame-gez",
  "ew-resize",
  "exclusion",
  "expanded",
  "extends",
  "extra-condensed",
  "extra-expanded",
  "fantasy",
  "fast",
  "fill",
  "fill-box",
  "fixed",
  "flat",
  "flex",
  "flex-end",
  "flex-start",
  "footnotes",
  "forwards",
  "from",
  "geometricPrecision",
  "graytext",
  "grid",
  "groove",
  "hand",
  "hard-light",
  "help",
  "hidden",
  "hide",
  "higher",
  "highlight",
  "highlighttext",
  "horizontal",
  "hsl",
  "hsla",
  "hue",
  "icon",
  "ignore",
  "inactiveborder",
  "inactivecaption",
  "inactivecaptiontext",
  "infinite",
  "infobackground",
  "infotext",
  "inherit",
  "initial",
  "inline",
  "inline-axis",
  "inline-block",
  "inline-flex",
  "inline-grid",
  "inline-table",
  "inset",
  "inside",
  "intrinsic",
  "invert",
  "italic",
  "justify",
  "keep-all",
  "landscape",
  "large",
  "larger",
  "left",
  "level",
  "lighter",
  "lighten",
  "line-through",
  "linear",
  "linear-gradient",
  "lines",
  "list-item",
  "listbox",
  "listitem",
  "local",
  "logical",
  "loud",
  "lower",
  "lower-hexadecimal",
  "lower-latin",
  "lower-norwegian",
  "lowercase",
  "ltr",
  "luminosity",
  "manipulation",
  "match",
  "matrix",
  "matrix3d",
  "medium",
  "menu",
  "menutext",
  "message-box",
  "middle",
  "min-intrinsic",
  "mix",
  "monospace",
  "move",
  "multiple",
  "multiple_mask_images",
  "multiply",
  "n-resize",
  "narrower",
  "ne-resize",
  "nesw-resize",
  "no-close-quote",
  "no-drop",
  "no-open-quote",
  "no-repeat",
  "none",
  "normal",
  "not-allowed",
  "nowrap",
  "ns-resize",
  "numbers",
  "numeric",
  "nw-resize",
  "nwse-resize",
  "oblique",
  "opacity",
  "open-quote",
  "optimizeLegibility",
  "optimizeSpeed",
  "outset",
  "outside",
  "outside-shape",
  "overlay",
  "overline",
  "padding",
  "padding-box",
  "painted",
  "page",
  "paused",
  "perspective",
  "pinch-zoom",
  "plus-darker",
  "plus-lighter",
  "pointer",
  "polygon",
  "portrait",
  "pre",
  "pre-line",
  "pre-wrap",
  "preserve-3d",
  "progress",
  "push-button",
  "radial-gradient",
  "radio",
  "read-only",
  "read-write",
  "read-write-plaintext-only",
  "rectangle",
  "region",
  "relative",
  "repeat",
  "repeating-linear-gradient",
  "repeating-radial-gradient",
  "repeat-x",
  "repeat-y",
  "reset",
  "reverse",
  "rgb",
  "rgba",
  "ridge",
  "right",
  "rotate",
  "rotate3d",
  "rotateX",
  "rotateY",
  "rotateZ",
  "round",
  "row",
  "row-resize",
  "row-reverse",
  "rtl",
  "run-in",
  "running",
  "s-resize",
  "sans-serif",
  "saturation",
  "scale",
  "scale3d",
  "scaleX",
  "scaleY",
  "scaleZ",
  "screen",
  "scroll",
  "scrollbar",
  "scroll-position",
  "se-resize",
  "self-start",
  "self-end",
  "semi-condensed",
  "semi-expanded",
  "separate",
  "serif",
  "show",
  "single",
  "skew",
  "skewX",
  "skewY",
  "skip-white-space",
  "slide",
  "slider-horizontal",
  "slider-vertical",
  "sliderthumb-horizontal",
  "sliderthumb-vertical",
  "slow",
  "small",
  "small-caps",
  "small-caption",
  "smaller",
  "soft-light",
  "solid",
  "source-atop",
  "source-in",
  "source-out",
  "source-over",
  "space",
  "space-around",
  "space-between",
  "space-evenly",
  "spell-out",
  "square",
  "start",
  "static",
  "status-bar",
  "stretch",
  "stroke",
  "stroke-box",
  "sub",
  "subpixel-antialiased",
  "svg_masks",
  "super",
  "sw-resize",
  "symbolic",
  "symbols",
  "system-ui",
  "table",
  "table-caption",
  "table-cell",
  "table-column",
  "table-column-group",
  "table-footer-group",
  "table-header-group",
  "table-row",
  "table-row-group",
  "text",
  "text-bottom",
  "text-top",
  "textarea",
  "textfield",
  "thick",
  "thin",
  "threeddarkshadow",
  "threedface",
  "threedhighlight",
  "threedlightshadow",
  "threedshadow",
  "to",
  "top",
  "transform",
  "translate",
  "translate3d",
  "translateX",
  "translateY",
  "translateZ",
  "transparent",
  "ultra-condensed",
  "ultra-expanded",
  "underline",
  "unidirectional-pan",
  "unset",
  "up",
  "upper-latin",
  "uppercase",
  "url",
  "var",
  "vertical",
  "vertical-text",
  "view-box",
  "visible",
  "visibleFill",
  "visiblePainted",
  "visibleStroke",
  "visual",
  "w-resize",
  "wait",
  "wave",
  "wider",
  "window",
  "windowframe",
  "windowtext",
  "words",
  "wrap",
  "wrap-reverse",
  "x-large",
  "x-small",
  "xor",
  "xx-large",
  "xx-small"
].map((n) => ({ type: "keyword", label: n })).concat(/* @__PURE__ */ [
  "aliceblue",
  "antiquewhite",
  "aqua",
  "aquamarine",
  "azure",
  "beige",
  "bisque",
  "black",
  "blanchedalmond",
  "blue",
  "blueviolet",
  "brown",
  "burlywood",
  "cadetblue",
  "chartreuse",
  "chocolate",
  "coral",
  "cornflowerblue",
  "cornsilk",
  "crimson",
  "cyan",
  "darkblue",
  "darkcyan",
  "darkgoldenrod",
  "darkgray",
  "darkgreen",
  "darkkhaki",
  "darkmagenta",
  "darkolivegreen",
  "darkorange",
  "darkorchid",
  "darkred",
  "darksalmon",
  "darkseagreen",
  "darkslateblue",
  "darkslategray",
  "darkturquoise",
  "darkviolet",
  "deeppink",
  "deepskyblue",
  "dimgray",
  "dodgerblue",
  "firebrick",
  "floralwhite",
  "forestgreen",
  "fuchsia",
  "gainsboro",
  "ghostwhite",
  "gold",
  "goldenrod",
  "gray",
  "grey",
  "green",
  "greenyellow",
  "honeydew",
  "hotpink",
  "indianred",
  "indigo",
  "ivory",
  "khaki",
  "lavender",
  "lavenderblush",
  "lawngreen",
  "lemonchiffon",
  "lightblue",
  "lightcoral",
  "lightcyan",
  "lightgoldenrodyellow",
  "lightgray",
  "lightgreen",
  "lightpink",
  "lightsalmon",
  "lightseagreen",
  "lightskyblue",
  "lightslategray",
  "lightsteelblue",
  "lightyellow",
  "lime",
  "limegreen",
  "linen",
  "magenta",
  "maroon",
  "mediumaquamarine",
  "mediumblue",
  "mediumorchid",
  "mediumpurple",
  "mediumseagreen",
  "mediumslateblue",
  "mediumspringgreen",
  "mediumturquoise",
  "mediumvioletred",
  "midnightblue",
  "mintcream",
  "mistyrose",
  "moccasin",
  "navajowhite",
  "navy",
  "oldlace",
  "olive",
  "olivedrab",
  "orange",
  "orangered",
  "orchid",
  "palegoldenrod",
  "palegreen",
  "paleturquoise",
  "palevioletred",
  "papayawhip",
  "peachpuff",
  "peru",
  "pink",
  "plum",
  "powderblue",
  "purple",
  "rebeccapurple",
  "red",
  "rosybrown",
  "royalblue",
  "saddlebrown",
  "salmon",
  "sandybrown",
  "seagreen",
  "seashell",
  "sienna",
  "silver",
  "skyblue",
  "slateblue",
  "slategray",
  "snow",
  "springgreen",
  "steelblue",
  "tan",
  "teal",
  "thistle",
  "tomato",
  "turquoise",
  "violet",
  "wheat",
  "white",
  "whitesmoke",
  "yellow",
  "yellowgreen"
].map((n) => ({ type: "constant", label: n }))), WM = /* @__PURE__ */ [
  "a",
  "abbr",
  "address",
  "article",
  "aside",
  "b",
  "bdi",
  "bdo",
  "blockquote",
  "body",
  "br",
  "button",
  "canvas",
  "caption",
  "cite",
  "code",
  "col",
  "colgroup",
  "dd",
  "del",
  "details",
  "dfn",
  "dialog",
  "div",
  "dl",
  "dt",
  "em",
  "figcaption",
  "figure",
  "footer",
  "form",
  "header",
  "hgroup",
  "h1",
  "h2",
  "h3",
  "h4",
  "h5",
  "h6",
  "hr",
  "html",
  "i",
  "iframe",
  "img",
  "input",
  "ins",
  "kbd",
  "label",
  "legend",
  "li",
  "main",
  "meter",
  "nav",
  "ol",
  "output",
  "p",
  "pre",
  "ruby",
  "section",
  "select",
  "small",
  "source",
  "span",
  "strong",
  "sub",
  "summary",
  "sup",
  "table",
  "tbody",
  "td",
  "template",
  "textarea",
  "tfoot",
  "th",
  "thead",
  "tr",
  "u",
  "ul"
].map((n) => ({ type: "type", label: n })), Ln = /^(\w[\w-]*|-\w[\w-]*|)$/, qM = /^-(-[\w-]*)?$/;
function BM(n, e) {
  var t;
  if ((n.name == "(" || n.type.isError) && (n = n.parent || n), n.name != "ArgList")
    return !1;
  let i = (t = n.parent) === null || t === void 0 ? void 0 : t.firstChild;
  return (i == null ? void 0 : i.name) != "Callee" ? !1 : e.sliceString(i.from, i.to) == "var";
}
const Mm = /* @__PURE__ */ new GO(), VM = ["Declaration"];
function YM(n) {
  for (let e = n; ; ) {
    if (e.type.isTop)
      return e;
    if (!(e = e.parent))
      return n;
  }
}
function my(n, e, t) {
  if (e.to - e.from > 4096) {
    let i = Mm.get(e);
    if (i)
      return i;
    let r = [], s = /* @__PURE__ */ new Set(), o = e.cursor(ve.IncludeAnonymous);
    if (o.firstChild())
      do
        for (let a of my(n, o.node, t))
          s.has(a.label) || (s.add(a.label), r.push(a));
      while (o.nextSibling());
    return Mm.set(e, r), r;
  } else {
    let i = [], r = /* @__PURE__ */ new Set();
    return e.cursor().iterate((s) => {
      var o;
      if (t(s) && s.matchContext(VM) && ((o = s.node.nextSibling) === null || o === void 0 ? void 0 : o.name) == ":") {
        let a = n.sliceString(s.from, s.to);
        r.has(a) || (r.add(a), i.push({ label: a, type: "variable" }));
      }
    }), i;
  }
}
const jM = (n) => (e) => {
  let { state: t, pos: i } = e, r = Pe(t).resolveInner(i, -1), s = r.type.isError && r.from == r.to - 1 && t.doc.sliceString(r.from, r.to) == "-";
  if (r.name == "PropertyName" || (s || r.name == "TagName") && /^(Block|Styles)$/.test(r.resolve(r.to).name))
    return { from: r.from, options: eu(), validFor: Ln };
  if (r.name == "ValueName")
    return { from: r.from, options: Rm, validFor: Ln };
  if (r.name == "PseudoClassName")
    return { from: r.from, options: Am, validFor: Ln };
  if (n(r) || (e.explicit || s) && BM(r, t.doc))
    return {
      from: n(r) || s ? r.from : i,
      options: my(t.doc, YM(r), n),
      validFor: qM
    };
  if (r.name == "TagName") {
    for (let { parent: l } = r; l; l = l.parent)
      if (l.name == "Block")
        return { from: r.from, options: eu(), validFor: Ln };
    return { from: r.from, options: WM, validFor: Ln };
  }
  if (!e.explicit)
    return null;
  let o = r.resolve(i), a = o.childBefore(i);
  return a && a.name == ":" && o.name == "PseudoClassSelector" ? { from: i, options: Am, validFor: Ln } : a && a.name == ":" && o.name == "Declaration" || o.name == "ArgList" ? { from: i, options: Rm, validFor: Ln } : o.name == "Block" || o.name == "Styles" ? { from: i, options: eu(), validFor: Ln } : null;
}, UM = /* @__PURE__ */ jM((n) => n.name == "VariableName"), La = /* @__PURE__ */ rr.define({
  name: "css",
  parser: /* @__PURE__ */ NM.configure({
    props: [
      /* @__PURE__ */ Ds.add({
        Declaration: /* @__PURE__ */ Yo()
      }),
      /* @__PURE__ */ gr.add({
        "Block KeyframeList": r1
      })
    ]
  }),
  languageData: {
    commentTokens: { block: { open: "/*", close: "*/" } },
    indentOnInput: /^\s*\}$/,
    wordChars: "-"
  }
});
function FM() {
  return new ds(La, La.data.of({ autocomplete: UM }));
}
const GM = 312, Zm = 1, HM = 2, KM = 3, JM = 4, e7 = 313, t7 = 315, n7 = 316, i7 = 5, r7 = 6, s7 = 0, Lc = [
  9,
  10,
  11,
  12,
  13,
  32,
  133,
  160,
  5760,
  8192,
  8193,
  8194,
  8195,
  8196,
  8197,
  8198,
  8199,
  8200,
  8201,
  8202,
  8232,
  8233,
  8239,
  8287,
  12288
], gy = 125, o7 = 59, _c = 47, a7 = 42, l7 = 43, u7 = 45, c7 = 60, h7 = 44, f7 = 63, d7 = 46, p7 = new ey({
  start: !1,
  shift(n, e) {
    return e == i7 || e == r7 || e == t7 ? n : e == n7;
  },
  strict: !1
}), m7 = new Kt((n, e) => {
  let { next: t } = n;
  (t == gy || t == -1 || e.context) && n.acceptToken(e7);
}, { contextual: !0, fallback: !0 }), g7 = new Kt((n, e) => {
  let { next: t } = n, i;
  Lc.indexOf(t) > -1 || t == _c && ((i = n.peek(1)) == _c || i == a7) || t != gy && t != o7 && t != -1 && !e.context && n.acceptToken(GM);
}, { contextual: !0 }), O7 = new Kt((n, e) => {
  let { next: t } = n;
  if (t == l7 || t == u7) {
    if (n.advance(), t == n.next) {
      n.advance();
      let i = !e.context && e.canShift(Zm);
      n.acceptToken(i ? Zm : HM);
    }
  } else
    t == f7 && n.peek(1) == d7 && (n.advance(), n.advance(), (n.next < 48 || n.next > 57) && n.acceptToken(KM));
}, { contextual: !0 });
function tu(n, e) {
  return n >= 65 && n <= 90 || n >= 97 && n <= 122 || n == 95 || n >= 192 || !e && n >= 48 && n <= 57;
}
const b7 = new Kt((n, e) => {
  if (n.next != c7 || !e.dialectEnabled(s7) || (n.advance(), n.next == _c))
    return;
  let t = 0;
  for (; Lc.indexOf(n.next) > -1; )
    n.advance(), t++;
  if (tu(n.next, !0)) {
    for (n.advance(), t++; tu(n.next, !1); )
      n.advance(), t++;
    for (; Lc.indexOf(n.next) > -1; )
      n.advance(), t++;
    if (n.next == h7)
      return;
    for (let i = 0; ; i++) {
      if (i == 7) {
        if (!tu(n.next, !0))
          return;
        break;
      }
      if (n.next != "extends".charCodeAt(i))
        break;
      n.advance(), t++;
    }
  }
  n.acceptToken(JM, -t);
}), y7 = pr({
  "get set async static": x.modifier,
  "for while do if else switch try catch finally return throw break continue default case": x.controlKeyword,
  "in of await yield void typeof delete instanceof": x.operatorKeyword,
  "let var const using function class extends": x.definitionKeyword,
  "import export from": x.moduleKeyword,
  "with debugger as new": x.keyword,
  TemplateString: x.special(x.string),
  super: x.atom,
  BooleanLiteral: x.bool,
  this: x.self,
  null: x.null,
  Star: x.modifier,
  VariableName: x.variableName,
  "CallExpression/VariableName TaggedTemplateExpression/VariableName": x.function(x.variableName),
  VariableDefinition: x.definition(x.variableName),
  Label: x.labelName,
  PropertyName: x.propertyName,
  PrivatePropertyName: x.special(x.propertyName),
  "CallExpression/MemberExpression/PropertyName": x.function(x.propertyName),
  "FunctionDeclaration/VariableDefinition": x.function(x.definition(x.variableName)),
  "ClassDeclaration/VariableDefinition": x.definition(x.className),
  PropertyDefinition: x.definition(x.propertyName),
  PrivatePropertyDefinition: x.definition(x.special(x.propertyName)),
  UpdateOp: x.updateOperator,
  "LineComment Hashbang": x.lineComment,
  BlockComment: x.blockComment,
  Number: x.number,
  String: x.string,
  Escape: x.escape,
  ArithOp: x.arithmeticOperator,
  LogicOp: x.logicOperator,
  BitOp: x.bitwiseOperator,
  CompareOp: x.compareOperator,
  RegExp: x.regexp,
  Equals: x.definitionOperator,
  Arrow: x.function(x.punctuation),
  ": Spread": x.punctuation,
  "( )": x.paren,
  "[ ]": x.squareBracket,
  "{ }": x.brace,
  "InterpolationStart InterpolationEnd": x.special(x.brace),
  ".": x.derefOperator,
  ", ;": x.separator,
  "@": x.meta,
  TypeName: x.typeName,
  TypeDefinition: x.definition(x.typeName),
  "type enum interface implements namespace module declare": x.definitionKeyword,
  "abstract global Privacy readonly override": x.modifier,
  "is keyof unique infer": x.operatorKeyword,
  JSXAttributeValue: x.attributeValue,
  JSXText: x.content,
  "JSXStartTag JSXStartCloseTag JSXSelfCloseEndTag JSXEndTag": x.angleBracket,
  "JSXIdentifier JSXNameSpacedName": x.tagName,
  "JSXAttribute/JSXIdentifier JSXAttribute/JSXNameSpacedName": x.attributeName,
  "JSXBuiltin/JSXIdentifier": x.standard(x.tagName)
}), k7 = { __proto__: null, export: 20, as: 25, from: 33, default: 36, async: 41, function: 42, extends: 54, this: 58, true: 66, false: 66, null: 78, void: 82, typeof: 86, super: 102, new: 136, delete: 148, yield: 157, await: 161, class: 166, public: 229, private: 229, protected: 229, readonly: 231, instanceof: 250, satisfies: 253, in: 254, const: 256, import: 290, keyof: 345, unique: 349, infer: 355, is: 391, abstract: 411, implements: 413, type: 415, let: 418, var: 420, using: 423, interface: 429, enum: 433, namespace: 439, module: 441, declare: 445, global: 449, for: 468, of: 477, while: 480, with: 484, do: 488, if: 492, else: 494, switch: 498, case: 504, try: 510, catch: 514, finally: 518, return: 522, throw: 526, break: 530, continue: 534, debugger: 538 }, x7 = { __proto__: null, async: 123, get: 125, set: 127, declare: 189, public: 191, private: 191, protected: 191, static: 193, abstract: 195, override: 197, readonly: 203, accessor: 205, new: 395 }, w7 = { __proto__: null, "<": 187 }, S7 = cr.deserialize({
  version: 14,
  states: "$=dO%TQ^OOO%[Q^OOO'_Q`OOP(lOWOOO*zQ?NdO'#CiO+RO!bO'#CjO+aO#tO'#CjO+oO!0LbO'#D^O.QQ^O'#DdO.bQ^O'#DoO%[Q^O'#DwO0fQ^O'#EPOOQ?Mr'#EX'#EXO1PQWO'#EUOOQO'#Em'#EmOOQO'#Ih'#IhO1XQWO'#GpO1dQWO'#ElO1iQWO'#ElO3hQ?NdO'#JmO6[Q?NdO'#JnO6uQWO'#F[O6zQ&jO'#FsOOQ?Mr'#Fe'#FeO7VO,YO'#FeO7eQ7[O'#FzO9RQWO'#FyOOQ?Mr'#Jn'#JnOOQ?Mp'#Jm'#JmO9WQWO'#GtOOQU'#KZ'#KZO9cQWO'#IUO9hQ?MxO'#IVOOQU'#JZ'#JZOOQU'#IZ'#IZQ`Q^OOO`Q^OOO9pQMnO'#DsO9wQ^O'#D{O:OQ^O'#D}O9^QWO'#GpO:VQ7[O'#CoO:eQWO'#EkO:pQWO'#EvO:uQ7[O'#FdO;dQWO'#GpOOQO'#K['#K[O;iQWO'#K[O;wQWO'#GxO;wQWO'#GyO;wQWO'#G{O9^QWO'#HOO<nQWO'#HRO>VQWO'#CeO>gQWO'#H_O>oQWO'#HeO>oQWO'#HgO`Q^O'#HiO>oQWO'#HkO>oQWO'#HnO>tQWO'#HtO>yQ?MyO'#HzO%[Q^O'#H|O?UQ?MyO'#IOO?aQ?MyO'#IQO9hQ?MxO'#ISO?lQ?NdO'#CiO@nQ`O'#DiQOQWOOO%[Q^O'#D}OAUQWO'#EQO:VQ7[O'#EkOAaQWO'#EkOAlQpO'#FdOOQU'#Cg'#CgOOQ?Mp'#Dn'#DnOOQ?Mp'#Jq'#JqO%[Q^O'#JqOOQO'#Jt'#JtOOQO'#Id'#IdOBlQ`O'#EdOOQ?Mp'#Ec'#EcOOQ?Mp'#Jx'#JxOChQ?NQO'#EdOCrQ`O'#ETOOQO'#Js'#JsODWQ`O'#JtOEeQ`O'#ETOCrQ`O'#EdPErO#@ItO'#CbPOOO)CDx)CDxOOOO'#I['#I[OE}O!bO,59UOOQ?Mr,59U,59UOOOO'#I]'#I]OF]O#tO,59UO%[Q^O'#D`OOOO'#I_'#I_OFkO!0LbO,59xOOQ?Mr,59x,59xOFyQ^O'#I`OG^QWO'#JoOI]QrO'#JoO+}Q^O'#JoOIdQWO,5:OOIzQWO'#EmOJXQWO'#KOOJdQWO'#J}OJdQWO'#J}OJlQWO,5;ZOJqQWO'#J|OOQ?Mv,5:Z,5:ZOJxQ^O,5:ZOLvQ?NdO,5:cOMgQWO,5:kONQQ?MxO'#J{ONXQWO'#JzO9WQWO'#JzONmQWO'#JzONuQWO,5;YONzQWO'#JzO!#PQrO'#JnOOQ?Mr'#Ci'#CiO%[Q^O'#EPO!#oQrO,5:pOOQQ'#Ju'#JuOOQO-E<f-E<fO9^QWO,5=[O!$VQWO,5=[O!$[Q^O,5;WO!&_Q7[O'#EhO!'xQWO,5;WO!'}Q^O'#DvO!(XQ`O,5;aO!(aQ`O,5;aO%[Q^O,5;aOOQU'#FS'#FSOOQU'#FU'#FUO%[Q^O,5;bO%[Q^O,5;bO%[Q^O,5;bO%[Q^O,5;bO%[Q^O,5;bO%[Q^O,5;bO%[Q^O,5;bO%[Q^O,5;bO%[Q^O,5;bO%[Q^O,5;bO%[Q^O,5;bOOQU'#FY'#FYO!(oQ^O,5;sOOQ?Mr,5;x,5;xOOQ?Mr,5;y,5;yOOQ?Mr,5;{,5;{O%[Q^O'#IlO!*rQ?MxO,5<gO!&_Q7[O,5;bO!+aQ7[O,5;bO!-RQ7[O'#EZO%[Q^O,5;vOOQ?Mr,5;z,5;zO!-YQ&jO'#FiO!.VQ&jO'#KSO!-qQ&jO'#KSO!.^Q&jO'#KSOOQO'#KS'#KSO!.rQ&jO,5<ROOOS,5<_,5<_O!/TQ^O'#FuOOOS'#Ik'#IkO7VO,YO,5<PO!/[Q&jO'#FwOOQ?Mr,5<P,5<PO!/{Q!LQO'#CvOOQ?Mr'#Cz'#CzO!0`QWO'#CzO!0eO!0LbO'#DOO!1RQ7[O,5<dO!1YQWO,5<fO!2uQ$ISO'#GVO!3SQWO'#GWO!3XQWO'#GWO!4wQ$ISO'#G[O!5sQ`O'#G`OOQO'#Gk'#GkO!+hQ7[O'#GjOOQO'#Gm'#GmO!+hQ7[O'#GlO!6fQ!LQO'#JgOOQ?Mr'#Jg'#JgO!6pQWO'#JfO!7OQWO'#JeO!7WQWO'#CuOOQ?Mr'#Cx'#CxOOQ?Mr'#DS'#DSOOQ?Mr'#DU'#DUO1SQWO'#DWO!+hQ7[O'#F}O!+hQ7[O'#GPO!7`QWO'#GRO!7eQWO'#GSO!3XQWO'#GYO!+hQ7[O'#G_O!7jQWO'#EnO!8XQWO,5<eOOQ?Mp'#Cr'#CrO!8aQWO'#EoO!9ZQ`O'#EpOOQ?Mp'#J|'#J|O!9bQ?MxO'#K]O9hQ?MxO,5=`O`Q^O,5>pOOQU'#Jc'#JcOOQU,5>q,5>qOOQU-E<X-E<XO!;aQ?NdO,5:_O!9UQ`O,5:]O!=zQ?NdO,5:gO%[Q^O,5:gO!@bQ?NdO,5:iOOQO,5@v,5@vO!ARQ7[O,5=[O!AaQ?MxO'#JdO9RQWO'#JdO!ArQ?MxO,59ZO!A}Q`O,59ZO!BVQ7[O,59ZO:VQ7[O,59ZO!BbQWO,5;WO!BjQWO'#H^O!COQWO'#K`O%[Q^O,5;|O!9UQ`O,5<OO!CWQWO,5=wO!C]QWO,5=wO!CbQWO,5=wO9hQ?MxO,5=wO;wQWO,5=gOOQO'#Cv'#CvO!CpQ`O,5=dO!CxQ7[O,5=eO!DTQWO,5=gO!DYQpO,5=jO!DbQWO'#K[O>tQWO'#HTO9^QWO'#HVO!DgQWO'#HVO:VQ7[O'#HXO!DlQWO'#HXOOQU,5=m,5=mO!DqQWO'#HYO!ESQWO'#CoO!EXQWO,59PO!EcQWO,59PO!GhQ^O,59POOQU,59P,59PO!GxQ?MxO,59PO%[Q^O,59PO!JTQ^O'#HaOOQU'#Hb'#HbOOQU'#Hc'#HcO`Q^O,5=yO!JkQWO,5=yO`Q^O,5>PO`Q^O,5>RO!JpQWO,5>TO`Q^O,5>VO!JuQWO,5>YO!JzQ^O,5>`OOQU,5>f,5>fO%[Q^O,5>fO9hQ?MxO,5>hOOQU,5>j,5>jO# UQWO,5>jOOQU,5>l,5>lO# UQWO,5>lOOQU,5>n,5>nO# rQ`O'#D[O%[Q^O'#JqO# |Q`O'#JqO#!kQ`O'#DjO#!|Q`O'#DjO#%_Q^O'#DjO#%fQWO'#JpO#%nQWO,5:TO#%sQWO'#EqO#&RQWO'#KPO#&ZQWO,5;[O#&`Q`O'#DjO#&mQ`O'#ESOOQ?Mr,5:l,5:lO%[Q^O,5:lO#&tQWO,5:lO>tQWO,5;VO!A}Q`O,5;VO!BVQ7[O,5;VO:VQ7[O,5;VO#&|QWO,5@]O#'RQ(CYO,5:pOOQO-E<b-E<bO#(XQ?NQO,5;OOCrQ`O,5:oO#(cQ`O,5:oOCrQ`O,5;OO!ArQ?MxO,5:oOOQ?Mp'#Eg'#EgOOQO,5;O,5;OO%[Q^O,5;OO#(pQ?MxO,5;OO#({Q?MxO,5;OO!A}Q`O,5:oOOQO,5;U,5;UO#)ZQ?MxO,5;OPOOO'#IY'#IYP#)oO#@ItO,58|POOO,58|,58|OOOO-E<Y-E<YOOQ?Mr1G.p1G.pOOOO-E<Z-E<ZO#)zQpO,59zOOOO-E<]-E<]OOQ?Mr1G/d1G/dO#*PQrO,5>zO+}Q^O,5>zOOQO,5?Q,5?QO#*ZQ^O'#I`OOQO-E<^-E<^O#*hQWO,5@ZO#*pQrO,5@ZO#*wQWO,5@iOOQ?Mr1G/j1G/jO%[Q^O,5@jO#+PQWO'#IfOOQO-E<d-E<dO#*wQWO,5@iOOQ?Mp1G0u1G0uOOQ?Mv1G/u1G/uOOQ?Mv1G0V1G0VO%[Q^O,5@gO#+eQ?MxO,5@gO#+vQ?MxO,5@gO#+}QWO,5@fO9WQWO,5@fO#,VQWO,5@fO#,eQWO'#IiO#+}QWO,5@fOOQ?Mp1G0t1G0tO!(XQ`O,5:rO!(dQ`O,5:rOOQQ,5:t,5:tO#-VQYO,5:tO#-_Q7[O1G2vO9^QWO1G2vOOQ?Mr1G0r1G0rO#-mQ?NdO1G0rO#.rQ?NbO,5;SOOQ?Mr'#GU'#GUO#/`Q?NdO'#JgO!$[Q^O1G0rO#1hQrO'#JrO%[Q^O'#JrO#1rQWO,5:bOOQ?Mr'#D['#D[OOQ?Mr1G0{1G0{O%[Q^O1G0{OOQ?Mr1G1e1G1eO#1wQWO1G0{O#4]Q?NdO1G0|O#4dQ?NdO1G0|O#6zQ?NdO1G0|O#7RQ?NdO1G0|O#9YQ?NdO1G0|O#9pQ?NdO1G0|O#<gQ?NdO1G0|O#<nQ?NdO1G0|O#?OQ?NdO1G0|O#?]Q?NdO1G0|O#AWQ?NdO1G0|O#DWQ07bO'#CiO#FRQ07bO1G1_O#FYQ07bO'#JnO#FmQ?NdO,5?WOOQ?Mp-E<j-E<jO#GaQ?NdO1G0|OOQ?Mr1G0|1G0|O#IiQ7[O'#JwO#IsQWO,5:uO#IxQ?NdO1G1bO#JlQ&jO,5<VO#JtQ&jO,5<WO#J|Q&jO'#FnO#KeQWO'#FmOOQO'#KT'#KTOOQO'#Ij'#IjO#KjQ&jO1G1mOOQ?Mr1G1m1G1mOOOS1G1x1G1xO#K{Q07bO'#JmO#LVQWO,5<aO!(oQ^O,5<aOOOS-E<i-E<iOOQ?Mr1G1k1G1kO#L[Q`O'#KSOOQ?Mr,5<c,5<cO#LdQ`O,5<cOOQ?Mr,59f,59fO!&_Q7[O'#DQOOOO'#I^'#I^O#LiO!0LbO,59jOOQ?Mr,59j,59jO%[Q^O1G2OO!7eQWO'#InO#LtQ7[O,5<xOOQ?Mr,5<u,5<uO!+hQ7[O'#IqO#MdQ7[O,5=UO!+hQ7[O'#IsO#NVQ7[O,5=WO!&_Q7[O,5=YOOQO1G2Q1G2QO#NaQpO'#CrO#NtQ$ISO'#EoO$ sQ`O'#G`O$!aQpO,5<qO$!hQWO'#KWO9WQWO'#KWO$!vQWO,5<sO!+hQ7[O,5<rO$!{QWO'#GXO$#^QWO,5<rO$#cQpO'#GUO$#pQpO'#KXO$#zQWO'#KXO!&_Q7[O'#KXO$$PQWO,5<vO$$UQ`O'#GaO!5nQ`O'#GaO$$gQWO'#GcO$$lQWO'#GeO!3XQWO'#GhO$$qQ?MxO'#IpO$$|Q`O,5<zOOQ?Mv,5<z,5<zO$%TQ`O'#GaO$%cQ`O'#GbO$%kQ`O'#GbO$%pQ7[O,5=UO$&QQ7[O,5=WOOQ?Mr,5=Z,5=ZO!+hQ7[O,5@QO!+hQ7[O,5@QO$&bQWO'#IuO$&mQWO,5@PO$&uQWO,59aO$'iQ!LSO,59rOOQ?Mr'#Jk'#JkO$([Q7[O,5<iO$(}Q7[O,5<kO@fQWO,5<mOOQ?Mr,5<n,5<nO$)XQWO,5<tO$)^Q7[O,5<yO$)nQWO'#JzO!$[Q^O1G2PO$)sQWO1G2PO9WQWO'#J}O9WQWO'#EqO%[Q^O'#EqO9WQWO'#IwO$)xQ?MxO,5@wOOQU1G2z1G2zOOQU1G4[1G4[OOQ?Mr1G/y1G/yOOQ?Mr1G/w1G/wO$+zQ?NdO1G0ROOQU1G2v1G2vO!&_Q7[O1G2vO%[Q^O1G2vO#-bQWO1G2vO$.OQ7[O'#EhOOQ?Mp,5@O,5@OO$.YQ?MxO,5@OOOQU1G.u1G.uO!ArQ?MxO1G.uO!A}Q`O1G.uO!BVQ7[O1G.uO$.kQWO1G0rO$.pQWO'#CiO$.{QWO'#KaO$/TQWO,5=xO$/YQWO'#KaO$/_QWO'#KaO$/mQWO'#I}O$/{QWO,5@zO$0TQrO1G1hOOQ?Mr1G1j1G1jO9^QWO1G3cO@fQWO1G3cO$0[QWO1G3cO$0aQWO1G3cOOQU1G3c1G3cO!DTQWO1G3RO!&_Q7[O1G3OO$0fQWO1G3OOOQU1G3P1G3PO!&_Q7[O1G3PO$0kQWO1G3PO$0sQ`O'#G}OOQU1G3R1G3RO!5nQ`O'#IyO!DYQpO1G3UOOQU1G3U1G3UOOQU,5=o,5=oO$0{Q7[O,5=qO9^QWO,5=qO$$lQWO,5=sO9RQWO,5=sO!A}Q`O,5=sO!BVQ7[O,5=sO:VQ7[O,5=sO$1ZQWO'#K_O$1fQWO,5=tOOQU1G.k1G.kO$1kQ?MxO1G.kO@fQWO1G.kO$1vQWO1G.kO9hQ?MxO1G.kO$4OQrO,5@|O$4]QWO,5@|O9WQWO,5@|O$4hQ^O,5={O$4oQWO,5={OOQU1G3e1G3eO`Q^O1G3eOOQU1G3k1G3kOOQU1G3m1G3mO>oQWO1G3oO$4tQ^O1G3qO$8xQ^O'#HpOOQU1G3t1G3tO$9VQWO'#HvO>tQWO'#HxOOQU1G3z1G3zO$9_Q^O1G3zO9hQ?MxO1G4QOOQU1G4S1G4SOOQ?Mp'#G]'#G]O9hQ?MxO1G4UO9hQ?MxO1G4WO$=fQWO,5@]O!(oQ^O,5;]O9WQWO,5;]O>tQWO,5:UO!(oQ^O,5:UO!A}Q`O,5:UO$=kQ07bO,5:UOOQO,5;],5;]O$=uQ`O'#IaO$>]QWO,5@[OOQ?Mr1G/o1G/oO$>eQ`O'#IgO$>oQWO,5@kOOQ?Mp1G0v1G0vO#!|Q`O,5:UOOQO'#Ic'#IcO$>wQ`O,5:nOOQ?Mv,5:n,5:nO#&wQWO1G0WOOQ?Mr1G0W1G0WO%[Q^O1G0WOOQ?Mr1G0q1G0qO>tQWO1G0qO!A}Q`O1G0qO!BVQ7[O1G0qOOQ?Mp1G5w1G5wO!ArQ?MxO1G0ZOOQO1G0j1G0jO%[Q^O1G0jO$?OQ?MxO1G0jO$?ZQ?MxO1G0jO!A}Q`O1G0ZOCrQ`O1G0ZO$?iQ?MxO1G0jOOQO1G0Z1G0ZO$?}Q?NdO1G0jPOOO-E<W-E<WPOOO1G.h1G.hOOOO1G/f1G/fO$@XQpO,5<gO$@aQrO1G4fOOQO1G4l1G4lO%[Q^O,5>zO$@kQWO1G5uO$@sQWO1G6TO$@{QrO1G6UO9WQWO,5?QO$AVQ?NdO1G6RO%[Q^O1G6RO$AgQ?MxO1G6RO$AxQWO1G6QO$AxQWO1G6QO9WQWO1G6QO$BQQWO,5?TO9WQWO,5?TOOQO,5?T,5?TO$BfQWO,5?TO$)nQWO,5?TOOQO-E<g-E<gOOQQ1G0^1G0^OOQQ1G0`1G0`O#-YQWO1G0`OOQU7+(b7+(bO!&_Q7[O7+(bO%[Q^O7+(bO$BtQWO7+(bO$CPQ7[O7+(bO$C_Q?NdO,5=UO$EgQ?NdO,5=WO$GoQ?NdO,5=UO$I}Q?NdO,5=WO$L]Q?NdO,59rO$NbQ?NdO,5<iO%!jQ?NdO,5<kO%$rQ?NdO,5<yOOQ?Mr7+&^7+&^O%'QQ?NdO7+&^O%'tQ^O'#IbO%(RQWO,5@^O%(ZQrO,5@^OOQ?Mr1G/|1G/|O%(eQWO7+&gOOQ?Mr7+&g7+&gO%(jQ07bO,5:cO%[Q^O7+&yO%(tQ07bO,5:_O%)RQ07bO,5:gO%)]Q07bO,5:iO%)gQ7[O'#IeO%)qQWO,5@cOOQ?Mr1G0a1G0aOOQO1G1q1G1qOOQO1G1r1G1rO%)yQtO,5<YO!(oQ^O,5<XOOQO-E<h-E<hOOQ?Mr7+'X7+'XOOOS7+'d7+'dOOOS1G1{1G1{O%*UQWO1G1{OOQ?Mr1G1}1G1}O%*ZQpO,59lOOOO-E<[-E<[OOQ?Mr1G/U1G/UO%*bQ?NdO7+'jOOQ?Mr,5?Y,5?YO%+UQpO,5?YOOQ?Mr1G2d1G2dP!&_Q7[O'#InPOQ?Mr-E<l-E<lO%+tQ7[O,5?]OOQ?Mr-E<o-E<oO%,gQ7[O,5?_OOQ?Mr-E<q-E<qO%,qQpO1G2tO%,xQpO'#CrO%-`Q7[O'#J}O%-gQ^O'#EqOOQ?Mr1G2]1G2]O%-qQWO'#ImO%.VQWO,5@rO%.VQWO,5@rO%._QWO,5@rO%.jQWO,5@rOOQO1G2_1G2_O%.xQ7[O1G2^O!+hQ7[O1G2^O%/YQ$ISO'#IoO%/gQWO,5@sO!&_Q7[O,5@sO%/oQpO,5@sOOQ?Mr1G2b1G2bOOQ?Mp,5<{,5<{OOQ?Mp,5<|,5<|O$)nQWO,5<|OCcQWO,5<|O!A}Q`O,5<{OOQO'#Gd'#GdO%/yQWO,5<}OOQ?Mp,5=P,5=PO$)nQWO,5=SOOQO,5?[,5?[OOQO-E<n-E<nOOQ?Mv1G2f1G2fO!5nQ`O,5<{O%0RQWO,5<|O$$gQWO,5<}O!5nQ`O,5<|O!+hQ7[O'#IqO%0uQ7[O1G2pO!+hQ7[O'#IsO%1hQ7[O1G2rO%1rQ7[O1G5lO%1|Q7[O1G5lOOQO,5?a,5?aOOQO-E<s-E<sOOQO1G.{1G.{O!9UQ`O,59tO%[Q^O,59tOOQ?Mr,5<h,5<hO%2ZQWO1G2XO!+hQ7[O1G2`O%2`Q?NdO7+'kOOQ?Mr7+'k7+'kO!$[Q^O7+'kO%3SQWO,5;]OOQ?Mp,5?c,5?cOOQ?Mp-E<u-E<uO%3XQpO'#KYO#&wQWO7+(bO4UQrO7+(bO$BwQWO7+(bO%3cQ?NbO'#CiO%3vQ?NbO,5=QO%4hQWO,5=QOOQ?Mp1G5j1G5jOOQU7+$a7+$aO!ArQ?MxO7+$aO!A}Q`O7+$aO!$[Q^O7+&^O%4mQWO'#I|O%5UQWO,5@{OOQO1G3d1G3dO9^QWO,5@{O%5UQWO,5@{O%5^QWO,5@{OOQO,5?i,5?iOOQO-E<{-E<{OOQ?Mr7+'S7+'SO%5cQWO7+(}O9hQ?MxO7+(}O9^QWO7+(}O@fQWO7+(}OOQU7+(m7+(mO%5hQ?NbO7+(jO!&_Q7[O7+(jO%5rQpO7+(kOOQU7+(k7+(kO!&_Q7[O7+(kO%5yQWO'#K^O%6UQWO,5=iOOQO,5?e,5?eOOQO-E<w-E<wOOQU7+(p7+(pO%7eQ`O'#HWOOQU1G3]1G3]O!&_Q7[O1G3]O%[Q^O1G3]O%7lQWO1G3]O%7wQ7[O1G3]O9hQ?MxO1G3_O$$lQWO1G3_O9RQWO1G3_O!A}Q`O1G3_O!BVQ7[O1G3_O%8VQWO'#I{O%8kQWO,5@yO%8sQ`O,5@yOOQ?Mp1G3`1G3`OOQU7+$V7+$VO@fQWO7+$VO9hQ?MxO7+$VO%9OQWO7+$VO%[Q^O1G6hO%[Q^O1G6iO%9TQ?MxO1G6hO%9_Q^O1G3gO%9fQWO1G3gO%9kQ^O1G3gOOQU7+)P7+)PO9hQ?MxO7+)ZO`Q^O7+)]OOQU'#Kd'#KdOOQU'#JO'#JOO%9rQ^O,5>[OOQU,5>[,5>[O%[Q^O'#HqO%:PQWO'#HsOOQU,5>b,5>bO9WQWO,5>bOOQU,5>d,5>dOOQU7+)f7+)fOOQU7+)l7+)lOOQU7+)p7+)pOOQU7+)r7+)rO%:UQ`O1G5wO%:jQ07bO1G0wO%:tQWO1G0wOOQO1G/p1G/pO%;PQ07bO1G/pO>tQWO1G/pO!(oQ^O'#DjOOQO,5>{,5>{OOQO-E<_-E<_OOQO,5?R,5?ROOQO-E<e-E<eO!A}Q`O1G/pOOQO-E<a-E<aOOQ?Mv1G0Y1G0YOOQ?Mr7+%r7+%rO#&wQWO7+%rOOQ?Mr7+&]7+&]O>tQWO7+&]O!A}Q`O7+&]OOQO7+%u7+%uO$?}Q?NdO7+&UOOQO7+&U7+&UO%[Q^O7+&UO%;ZQ?MxO7+&UO!ArQ?MxO7+%uO!A}Q`O7+%uO%;fQ?MxO7+&UO%;tQ?NdO7++mO%[Q^O7++mO%<UQWO7++lO%<UQWO7++lOOQO1G4o1G4oO9WQWO1G4oO%<^QWO1G4oOOQQ7+%z7+%zO#&wQWO<<K|O4UQrO<<K|O%<lQWO<<K|OOQU<<K|<<K|O!&_Q7[O<<K|O%[Q^O<<K|O%<tQWO<<K|O%=PQ?NdO,5?]O%?XQ?NdO,5?_O%AaQ?NdO1G2^O%CoQ?NdO1G2pO%EwQ?NdO1G2rO%HPQrO,5>|O%[Q^O,5>|OOQO-E<`-E<`O%HZQWO1G5xOOQ?Mr<<JR<<JRO%HcQ07bO1G0rO%JjQ07bO1G0|O%JqQ07bO1G0|O%LrQ07bO1G0|O%LyQ07bO1G0|O%NkQ07bO1G0|O& RQ07bO1G0|O&#cQ07bO1G0|O&#jQ07bO1G0|O&%eQ07bO1G0|O&%rQ07bO1G0|O&'mQ07bO1G0|O&(QQ?NdO<<JeO&)VQ07bO1G0|O&*xQ07bO'#JgO&,{Q07bO1G1bO&-YQ07bO1G0RO&-dQ7[O,5?POOQO-E<c-E<cO!(oQ^O'#FpOOQO'#KU'#KUOOQO1G1t1G1tO&-nQWO1G1sO&-sQ07bO,5?WOOOS7+'g7+'gOOOO1G/W1G/WOOQ?Mr1G4t1G4tO!+hQ7[O7+(`O&0TQrO'#CiO&0_QWO,5?XO9WQWO,5?XOOQO-E<k-E<kO&0mQWO1G6^O&0mQWO1G6^O&0uQWO1G6^O&1QQ7[O7+'xO&1bQpO,5?ZO&1lQWO,5?ZO!&_Q7[O,5?ZOOQO-E<m-E<mO&1qQpO1G6_O&1{QWO1G6_OOQ?Mp1G2h1G2hO$)nQWO1G2hOOQ?Mp1G2g1G2gO&2TQWO1G2iO!&_Q7[O1G2iOOQ?Mp1G2n1G2nO!A}Q`O1G2gOCcQWO1G2hO&2YQWO1G2iO&2bQWO1G2hO&3UQ7[O,5?]OOQ?Mr-E<p-E<pO&3wQ7[O,5?_OOQ?Mr-E<r-E<rO!+hQ7[O7++WOOQ?Mr1G/`1G/`O&4RQWO1G/`OOQ?Mr7+'s7+'sO&4WQ7[O7+'zO&4hQ?NdO<<KVOOQ?Mr<<KV<<KVO&5[QWO1G0wO!&_Q7[O'#IvO&5aQWO,5@tO&7cQrO<<K|O!&_Q7[O1G2lOOQU<<G{<<G{O!ArQ?MxO<<G{O&7jQ?NdO<<IxOOQ?Mr<<Ix<<IxOOQO,5?h,5?hO&8^QWO,5?hO&8cQWO,5?hOOQO-E<z-E<zO&8qQWO1G6gO&8qQWO1G6gO9^QWO1G6gO@fQWO<<LiOOQU<<Li<<LiO&8yQWO<<LiO9hQ?MxO<<LiOOQU<<LU<<LUO%5hQ?NbO<<LUOOQU<<LV<<LVO%5rQpO<<LVO&9OQ`O'#IxO&9ZQWO,5@xO!(oQ^O,5@xOOQU1G3T1G3TO%-gQ^O'#JqOOQO'#Iz'#IzO9hQ?MxO'#IzO&9cQ`O,5=rOOQU,5=r,5=rO&9jQ`O'#EdO&:OQWO7+(wO&:TQWO7+(wOOQU7+(w7+(wO!&_Q7[O7+(wO%[Q^O7+(wO&:]QWO7+(wOOQU7+(y7+(yO9hQ?MxO7+(yO$$lQWO7+(yO9RQWO7+(yO!A}Q`O7+(yO&:hQWO,5?gOOQO-E<y-E<yOOQO'#HZ'#HZO&:sQWO1G6eO9hQ?MxO<<GqOOQU<<Gq<<GqO@fQWO<<GqO&:{QWO7+,SO&;QQWO7+,TO%[Q^O7+,SO%[Q^O7+,TOOQU7+)R7+)RO&;VQWO7+)RO&;[Q^O7+)RO&;cQWO7+)ROOQU<<Lu<<LuOOQU<<Lw<<LwOOQU-E<|-E<|OOQU1G3v1G3vO&;hQWO,5>]OOQU,5>_,5>_O&;mQWO1G3|O9WQWO7+&cO!(oQ^O7+&cOOQO7+%[7+%[O&;rQ07bO1G6UO>tQWO7+%[OOQ?Mr<<I^<<I^OOQ?Mr<<Iw<<IwO>tQWO<<IwOOQO<<Ip<<IpO$?}Q?NdO<<IpO%[Q^O<<IpOOQO<<Ia<<IaO!ArQ?MxO<<IaO&;|Q?MxO<<IpO&<XQ?NdO<= XO&<iQWO<= WOOQO7+*Z7+*ZO9WQWO7+*ZOOQUANAhANAhO&<qQrOANAhO!&_Q7[OANAhO#&wQWOANAhO4UQrOANAhO&<xQWOANAhO%[Q^OANAhO&=QQ?NdO7+'xO&?`Q?NdO,5?]O&AhQ?NdO,5?_O&CpQ?NdO7+'zO&FOQrO1G4hO&FYQ07bO7+&^O&HZQ07bO,5=UO&J_Q07bO,5=WO&JoQ07bO,5=UO&KPQ07bO,5=WO&KaQ07bO,59rO&MdQ07bO,5<iO' dQ07bO,5<kO'#dQ07bO,5<yO'%VQ07bO7+'jO'%dQ07bO7+'kO'%qQWO,5<[OOQO7+'_7+'_O'%vQ7[O<<KzOOQO1G4s1G4sO'%}QWO1G4sO'&YQWO1G4sO'&hQWO7++xO'&hQWO7++xO!&_Q7[O1G4uO'&pQpO1G4uO'&zQWO7++yOOQ?Mp7+(S7+(SO$)nQWO7+(TO''SQpO7+(TOOQ?Mp7+(R7+(RO$)nQWO7+(SO''ZQWO7+(TO!&_Q7[O7+(TOCcQWO7+(SO''`Q7[O<<NrOOQ?Mr7+$z7+$zO''jQpO,5?bOOQO-E<t-E<tO''tQ?NbO7+(WOOQUAN=gAN=gO9^QWO1G5SOOQO1G5S1G5SO'(UQWO1G5SO'(ZQWO7+,RO'(ZQWO7+,RO9hQ?MxOANBTO@fQWOANBTOOQUANBTANBTOOQUANApANApOOQUANAqANAqO'(cQWO,5?dOOQO-E<v-E<vO'(nQ07bO1G6dOOQO,5?f,5?fOOQO-E<x-E<xOOQU1G3^1G3^O%-gQ^O,5<}OOQU<<Lc<<LcO!&_Q7[O<<LcO&:OQWO<<LcO'(xQWO<<LcO%[Q^O<<LcOOQU<<Le<<LeO9hQ?MxO<<LeO$$lQWO<<LeO9RQWO<<LeO')QQ`O1G5RO')]QWO7+,POOQUAN=]AN=]O9hQ?MxOAN=]OOQU<= n<= nOOQU<= o<= oO')eQWO<= nO')jQWO<= oOOQU<<Lm<<LmO')oQWO<<LmO')tQ^O<<LmOOQU1G3w1G3wO>tQWO7+)hO'){QWO<<I}O'*WQ07bO<<I}OOQO<<Hv<<HvOOQ?MrAN?cAN?cOOQOAN?[AN?[O$?}Q?NdOAN?[OOQOAN>{AN>{O%[Q^OAN?[OOQO<<Mu<<MuOOQUG27SG27SO!&_Q7[OG27SO#&wQWOG27SO'*bQrOG27SO4UQrOG27SO'*iQWOG27SO'*qQ07bO<<JeO'+OQ07bO1G2^O',qQ07bO,5?]O'.qQ07bO,5?_O'0qQ07bO1G2pO'2qQ07bO1G2rO'4qQ07bO<<KVO'5OQ07bO<<IxOOQO1G1v1G1vO!+hQ7[OANAfOOQO7+*_7+*_O'5]QWO7+*_O'5hQWO<= dO'5pQpO7+*aOOQ?Mp<<Ko<<KoO$)nQWO<<KoOOQ?Mp<<Kn<<KnO'5zQpO<<KoO$)nQWO<<KnOOQO7+*n7+*nO9^QWO7+*nO'6RQWO<= mOOQUG27oG27oO9hQ?MxOG27oO!(oQ^O1G5OO'6ZQWO7+,OO&:OQWOANA}OOQUANA}ANA}O!&_Q7[OANA}O'6cQWOANA}OOQUANBPANBPO9hQ?MxOANBPO$$lQWOANBPOOQO'#H['#H[OOQO7+*m7+*mOOQUG22wG22wOOQUANEYANEYOOQUANEZANEZOOQUANBXANBXO'6kQWOANBXOOQU<<MS<<MSO!(oQ^OAN?iOOQOG24vG24vO$?}Q?NdOG24vO#&wQWOLD,nOOQULD,nLD,nO!&_Q7[OLD,nO'6pQrOLD,nO'6wQ07bO7+'xO'8jQ07bO,5?]O':jQ07bO,5?_O'<jQ07bO7+'zO'>]Q7[OG27QOOQO<<My<<MyOOQ?MpANAZANAZO$)nQWOANAZOOQ?MpANAYANAYOOQO<<NY<<NYOOQULD-ZLD-ZO'>mQ07bO7+*jOOQUG27iG27iO&:OQWOG27iO!&_Q7[OG27iOOQUG27kG27kO9hQ?MxOG27kOOQUG27sG27sO'>wQ07bOG25TOOQOLD*bLD*bOOQU!$(!Y!$(!YO#&wQWO!$(!YO!&_Q7[O!$(!YO'?RQ?NdOG27QOOQ?MpG26uG26uOOQULD-TLD-TO&:OQWOLD-TOOQULD-VLD-VOOQU!)9Et!)9EtO#&wQWO!)9EtOOQU!$(!o!$(!oOOQU!.K;`!.K;`O'AaQ07bOG27QO!(oQ^O'#DwO1PQWO'#EUO'CSQrO'#JmO'CZQMnO'#DsO'CbQ^O'#D{O'CiQrO'#CiO'FPQrO'#CiO!(oQ^O'#D}O'FaQ^O,5;WO!(oQ^O,5;bO!(oQ^O,5;bO!(oQ^O,5;bO!(oQ^O,5;bO!(oQ^O,5;bO!(oQ^O,5;bO!(oQ^O,5;bO!(oQ^O,5;bO!(oQ^O,5;bO!(oQ^O,5;bO!(oQ^O,5;bO!(oQ^O'#IlO'HdQWO,5<gO'HlQ7[O,5;bO'JVQ7[O,5;bO!(oQ^O,5;vO!&_Q7[O'#GjO'HlQ7[O'#GjO!&_Q7[O'#GlO'HlQ7[O'#GlO1SQWO'#DWO1SQWO'#DWO!&_Q7[O'#F}O'HlQ7[O'#F}O!&_Q7[O'#GPO'HlQ7[O'#GPO!&_Q7[O'#G_O'HlQ7[O'#G_O!(oQ^O,5:gO'J^Q`O'#D[O!(oQ^O,5@jO'FaQ^O1G0rO'JhQ07bO'#CiO!(oQ^O1G2OO!&_Q7[O'#IqO'HlQ7[O'#IqO!&_Q7[O'#IsO'HlQ7[O'#IsO'JrQpO'#CrO!&_Q7[O,5<rO'HlQ7[O,5<rO'FaQ^O1G2PO!(oQ^O7+&yO!&_Q7[O1G2^O'HlQ7[O1G2^O!&_Q7[O'#IqO'HlQ7[O'#IqO!&_Q7[O'#IsO'HlQ7[O'#IsO!&_Q7[O1G2`O'HlQ7[O1G2`O'FaQ^O7+'kO'FaQ^O7+&^O!&_Q7[OANAfO'HlQ7[OANAfO'KVQWO'#ElO'K[QWO'#ElO'KdQWO'#F[O'KiQWO'#EvO'KnQWO'#KOO'KyQWO'#J|O'LUQWO,5;WO'LZQ7[O,5<dO'LbQWO'#GWO'LgQWO'#GWO'LlQWO,5<eO'LtQWO,5;WO'L|Q07bO1G1_O'MTQWO,5<rO'MYQWO,5<rO'M_QWO,5<tO'MdQWO,5<tO'MiQWO1G2PO'MnQWO1G0rO'MsQ7[O<<KzO'MzQ7[O<<KzO7eQ7[O'#FzO9RQWO'#FyOAaQWO'#EkO!(oQ^O,5;sO!3XQWO'#GWO!3XQWO'#GWO!3XQWO'#GYO!3XQWO'#GYO!+hQ7[O7+(`O!+hQ7[O7+(`O%,qQpO1G2tO%,qQpO1G2tO!&_Q7[O,5=YO!&_Q7[O,5=Y",
  stateData: "( O~O'wOS'xOSTOS'yRQ~OPYOQYOSfOY!VOaqOdzOeyOmkOoYOpkOqkOwkOyYO{YO!PWO!TkO!UkO![XO!fuO!iZO!lYO!mYO!nYO!pvO!rwO!uxO!y]O#t!PO$V|O%e}O%g!QO%i!OO%j!OO%k!OO%n!RO%p!SO%s!TO%t!TO%v!UO&S!WO&Y!XO&[!YO&^!ZO&`![O&c!]O&i!^O&o!_O&q!`O&s!aO&u!bO&w!cO(OSO(QTO(TUO([VO(j[O(yiO~OWtO~P`OPYOQYOSfOd!jOe!iOmkOoYOpkOqkOwkOyYO{YO!PWO!TkO!UkO![!eO!fuO!iZO!lYO!mYO!nYO!pvO!r!gO!u!hO$V!kO(O!dO(QTO(TUO([VO(j[O(yiO~Oa!wOp!nO!P!oO!_!yO!`!vO!a!vO!y:lO#Q!pO#R!pO#S!xO#T!pO#U!pO#X!zO#Y!zO(P!lO(QTO(TUO(`!mO(j!sO~O'y!{O~OP]XR]X[]Xa]Xo]X}]X!P]X!Y]X!i]X!m]X#O]X#P]X#]]X#hfX#k]X#l]X#m]X#n]X#o]X#p]X#q]X#r]X#s]X#u]X#w]X#y]X#z]X$P]X'u]X([]X(m]X(t]X(u]X~O!d%PX~P(qO_!}O(Q#PO(R!}O(S#PO~O_#QO(S#PO(T#PO(U#QO~Ou#SO!R#TO(]#TO(^#VO~OPYOQYOSfOd!jOe!iOmkOoYOpkOqkOwkOyYO{YO!PWO!TkO!UkO![!eO!fuO!iZO!lYO!mYO!nYO!pvO!r!gO!u!hO$V!kO(O:pO(QTO(TUO([VO(j[O(yiO~O!X#ZO!Y#WO!V(cP!V(qP~P+}O!Z#cO~P`OPYOQYOSfOd!jOe!iOoYOpkOqkOwkOyYO{YO!PWO!TkO!UkO![!eO!fuO!iZO!lYO!mYO!nYO!pvO!r!gO!u!hO$V!kO(QTO(TUO([VO(j[O(yiO~Om#mO!X#iO!y]O#f#lO#g#iO(O:qO!h(nP~P.iO!i#oO(O#nO~O!u#sO!y]O%e#tO~O#h#uO~O!d#vO#h#uO~OP$]OR#zO[$cOo$QO}#yO!P#{O!Y$`O!i#xO!m$]O#O$SO#k$OO#l$PO#m$PO#n$PO#o$RO#p$SO#q$SO#r$bO#s$SO#u$TO#w$VO#y$XO#z$YO([VO(m$ZO(t#|O(u#}O~Oa(aX'u(aX's(aX!h(aX!V(aX![(aX%f(aX!d(aX~P1qO#P$dO#]$eO$P$eOP(bXR(bX[(bXo(bX}(bX!P(bX!Y(bX!i(bX!m(bX#O(bX#k(bX#l(bX#m(bX#n(bX#o(bX#p(bX#q(bX#r(bX#s(bX#u(bX#w(bX#y(bX#z(bX([(bX(m(bX(t(bX(u(bX![(bX%f(bX~Oa(bX'u(bX's(bX!V(bX!h(bXs(bX!d(bX~P4UO#]$eO~O$[$hO$^$gO$e$mO~OSfO![$nO$h$oO$j$qO~Oh%WOm%XOo$uOp$tOq$tOw%YOy%ZO{%[O!P$|O![$}O!f%aO!i$yO#g%bO$V%_O$r%]O$t%^O$w%`O(O$sO(QTO(TUO([$vO(t%OO(u%QOg(XP~O!i%cO~O!P%fO![%gO(O%eO~O!d%kO~Oa%lO'u%lO~O}%pO~P%[O(P!lO~P%[O%k%tO~P%[Oh%WO!i%cO(O%eO(P!lO~Oe%{O!i%cO(O%eO~O#s$SO~O}&QO![%}O!i&PO%g&TO(O%eO(P!lO(QTO(TUO`)SP~O!u#sO~O%p&VO!P)OX![)OX(O)OX~O(O&WO~O!r&]O#t!PO%g!QO%i!OO%j!OO%k!OO%n!RO%p!SO%s!TO%t!TO~Od&bOe&aO!u&_O%e&`O%x&^O~P;|Od&eOeyO![&dO!r&]O!uxO!y]O#t!PO%e}O%i!OO%j!OO%k!OO%n!RO%p!SO%s!TO%t!TO%v!UO~Ob&hO#]&kO%g&fO(P!lO~P=RO!i&lO!r&pO~O!i#oO~O![XO~Oa%lO't&xO'u%lO~Oa%lO't&{O'u%lO~Oa%lO't&}O'u%lO~O's]X!V]Xs]X!h]X&W]X![]X%f]X!d]X~P(qO!_'[O!`'TO!a'TO(P!lO(QTO(TUO~Op'RO!P'QO!X'UO(`'PO!Z(dP!Z(sP~P@YOk'_O![']O(O%eO~Oe'dO!i%cO(O%eO~O}&QO!i&PO~Op!nO!P!oO!y:lO#Q!pO#R!pO#T!pO#U!pO(P!lO(QTO(TUO(`!mO(j!sO~O!_'jO!`'iO!a'iO#S!pO#X'kO#Y'kO~PAtOa%lOh%WO!d#vO!i%cO'u%lO(m'mO~O!m'qO#]'oO~PCSOp!nO!P!oO(QTO(TUO(`!mO(j!sO~O![XOp(hX!P(hX!_(hX!`(hX!a(hX!y(hX#Q(hX#R(hX#S(hX#T(hX#U(hX#X(hX#Y(hX(P(hX(Q(hX(T(hX(`(hX(j(hX~O!`'iO!a'iO(P!lO~PCrO'z'uO'{'uO'|'wO~O_!}O(Q'yO(R!}O(S'yO~O_#QO(S'yO(T'yO(U#QO~Ou#SO!R#TO(]#TO(^'}O~O!X(PO!V'SX!V'YX!Y'SX!Y'YX~P+}O!Y(RO!V(cX~OP$]OR#zO[$cOo$QO}#yO!P#{O!Y(RO!i#xO!m$]O#O$SO#k$OO#l$PO#m$PO#n$PO#o$RO#p$SO#q$SO#r$bO#s$SO#u$TO#w$VO#y$XO#z$YO([VO(m$ZO(t#|O(u#}O~O!V(cX~PGfO!V(WO~O!V(pX!Y(pX!d(pX!h(pX(m(pX~O#](pX#h#aX!Z(pX~PIiO#](XO!V(rX!Y(rX~O!Y(YO!V(qX~O!V(]O~O#]$eO~PIiO!Z(^O~P`OR#zO}#yO!P#{O!i#xO([VOP!ka[!kao!ka!Y!ka!m!ka#O!ka#k!ka#l!ka#m!ka#n!ka#o!ka#p!ka#q!ka#r!ka#s!ka#u!ka#w!ka#y!ka#z!ka(m!ka(t!ka(u!ka~Oa!ka'u!ka's!ka!V!ka!h!kas!ka![!ka%f!ka!d!ka~PKPO!h(_O~O!d#vO#](`O(m'mO!Y(oXa(oX'u(oX~O!h(oX~PMlO!P%fO![%gO!y]O#f(eO#g(dO(O%eO~O!Y(fO!h(nX~O!h(hO~O!P%fO![%gO#g(dO(O%eO~OP(bXR(bX[(bXo(bX}(bX!P(bX!Y(bX!i(bX!m(bX#O(bX#k(bX#l(bX#m(bX#n(bX#o(bX#p(bX#q(bX#r(bX#s(bX#u(bX#w(bX#y(bX#z(bX([(bX(m(bX(t(bX(u(bX~O!d#vO!h(bX~P! YOR(jO}(iO!i#xO#P$dO!y!xa!P!xa~O!u!xa%e!xa![!xa#f!xa#g!xa(O!xa~P!#ZO!u(nO~OPYOQYOSfOd!jOe!iOmkOoYOpkOqkOwkOyYO{YO!PWO!TkO!UkO![XO!fuO!iZO!lYO!mYO!nYO!pvO!r!gO!u!hO$V!kO(O!dO(QTO(TUO([VO(j[O(yiO~Oh%WOm%XOo$uOp$tOq$tOw%YOy%ZO{;YO!P$|O![$}O!f<jO!i$yO#g;`O$V%_O$r;[O$t;^O$w%`O(O(rO(QTO(TUO([$vO(t%OO(u%QO~O#h(tO~O!X(vO!h(fP~P%[O(`(xO(j[O~O!P(zO!i#xO(`(xO(j[O~OP:kOQ:kOSfOd<fOe!iOmkOo:kOpkOqkOwkOy:kO{:kO!PWO!TkO!UkO![!eO!f:nO!iZO!l:kO!m:kO!n:kO!p:oO!r:rO!u!hO$V!kO(O)YO(QTO(TUO([VO(j[O(y<dO~O!Y$`Oa$oa'u$oa's$oa!h$oa!V$oa![$oa%f$oa!d$oa~O#t)`O~P!&_Oh%WOm%XOo$uOp$tOq$tOw%YOy%ZO{%[O!P$|O![$}O!f%aO!i$yO#g%bO$V%_O$r%]O$t%^O$w%`O(O(rO(QTO(TUO([$vO(t%OO(u%QO~Og(kP~P!+hO})eO!d)dO![$]X$Y$]X$[$]X$^$]X$e$]X~O!d)dO![(vX$Y(vX$[(vX$^(vX$e(vX~O})eO~P!-qO})eO![(vX$Y(vX$[(vX$^(vX$e(vX~O![)gO$Y)kO$[)fO$^)fO$e)lO~O!X)oO~P!(oO$[$hO$^$gO$e)sO~Ok$xX}$xX!P$xX#P$xX(t$xX(u$xX~OgjXg$xXkjX!YjX#]jX~P!/gOp)uO~Ou)vO(])wO(^)yO~Ok*SO}){O!P)|O(t%OO(u%QO~Og)zO~P!0pOg*TO~Oh%WOm%XOo$uOp$tOq$tOw%YOy%ZO{;YO!P*VO![*WO!f<jO!i$yO#g;`O$V%_O$r;[O$t;^O$w%`O(QTO(TUO([$vO(t%OO(u%QO~O!X*ZO(O*UO!h(zP~P!1_O#h*]O~O!i*^O~Oh%WOm%XOo$uOp$tOq$tOw%YOy%ZO{;YO!P$|O![$}O!f<jO!i$yO#g;`O$V%_O$r;[O$t;^O$w%`O(O*`O(QTO(TUO([$vO(t%OO(u%QO~O!X*cO!V({P~P!3^Oo*oO!P*gO!_*mO!`*fO!a*fO!i*^O#X*nO%]*iO(P!lO(`!mO~O!Z*lO~P!5RO#P$dOk(ZX}(ZX!P(ZX(t(ZX(u(ZX!Y(ZX#](ZX~Og(ZX#}(ZX~P!5zOk*tO#]*sOg(YX!Y(YX~O!Y*uOg(XX~O(O&WOg(XP~O!i*|O~O(O(rO~Om+QO!P%fO!X#iO![%gO!y]O#f#lO#g#iO(O%eO!h(nP~O!d#vO#h+RO~O!P%fO!X+TO!Y(YO![%gO(O%eO!V(qP~Op'XO!P+VO!X+UO(QTO(TUO(`(xO~O!Z(sP~P!8uO!Y+WOa)PX'u)PX~OP$]OR#zO[$cOo$QO}#yO!P#{O!i#xO!m$]O#O$SO#k$OO#l$PO#m$PO#n$PO#o$RO#p$SO#q$SO#r$bO#s$SO#u$TO#w$VO#y$XO#z$YO([VO(m$ZO(t#|O(u#}O~Oa!ga!Y!ga'u!ga's!ga!V!ga!h!gas!ga![!ga%f!ga!d!ga~P!9mOR#zO}#yO!P#{O!i#xO([VOP!oa[!oao!oa!Y!oa!m!oa#O!oa#k!oa#l!oa#m!oa#n!oa#o!oa#p!oa#q!oa#r!oa#s!oa#u!oa#w!oa#y!oa#z!oa(m!oa(t!oa(u!oa~Oa!oa'u!oa's!oa!V!oa!h!oas!oa![!oa%f!oa!d!oa~P!<TOR#zO}#yO!P#{O!i#xO([VOP!qa[!qao!qa!Y!qa!m!qa#O!qa#k!qa#l!qa#m!qa#n!qa#o!qa#p!qa#q!qa#r!qa#s!qa#u!qa#w!qa#y!qa#z!qa(m!qa(t!qa(u!qa~Oa!qa'u!qa's!qa!V!qa!h!qas!qa![!qa%f!qa!d!qa~P!>kOh%WOk+aO![']O%f+`O~O!d+cOa(WX![(WX'u(WX!Y(WX~Oa%lO![XO'u%lO~Oh%WO!i%cO~Oh%WO!i%cO(O%eO~O!d#vO#h(tO~Ob+nO%g+oO(O+kO(QTO(TUO!Z)TP~O!Y+pO`)SX~O[+tO~O`+uO~O![%}O(O%eO(P!lO`)SP~Oh%WO#]+zO~Oh%WOk+}O![$}O~O![,PO~O},RO![XO~O%k%tO~O!u,WO~Oe,]O~Ob,^O(O#nO(QTO(TUO!Z)RP~Oe%{O~O%g!QO(O&WO~P=RO[,cO`,bO~OPYOQYOSfOdzOeyOmkOoYOpkOqkOwkOyYO{YO!PWO!TkO!UkO!fuO!iZO!lYO!mYO!nYO!pvO!uxO!y]O%e}O(QTO(TUO([VO(j[O(yiO~O![!eO!r!gO$V!kO(O!dO~P!EkO`,bOa%lO'u%lO~OPYOQYOSfOd!jOe!iOmkOoYOpkOqkOwkOyYO{YO!PWO!TkO!UkO![!eO!fuO!iZO!lYO!mYO!nYO!pvO!u!hO$V!kO(O!dO(QTO(TUO([VO(j[O(yiO~Oa,hO!rwO#t!OO%i!OO%j!OO%k!OO~P!HTO!i&lO~O&Y,nO~O![,pO~O&k,rO&m,sOP&haQ&haS&haY&haa&had&hae&ham&hao&hap&haq&haw&hay&ha{&ha!P&ha!T&ha!U&ha![&ha!f&ha!i&ha!l&ha!m&ha!n&ha!p&ha!r&ha!u&ha!y&ha#t&ha$V&ha%e&ha%g&ha%i&ha%j&ha%k&ha%n&ha%p&ha%s&ha%t&ha%v&ha&S&ha&Y&ha&[&ha&^&ha&`&ha&c&ha&i&ha&o&ha&q&ha&s&ha&u&ha&w&ha's&ha(O&ha(Q&ha(T&ha([&ha(j&ha(y&ha!Z&ha&a&hab&ha&f&ha~O(O,xO~Oh!bX!Y!OX!Z!OX!d!OX!d!bX!i!bX#]!OX~O!Y!bX!Z!bX~P# ZO!d,}O#],|Oh(eX!Y#eX!Y(eX!Z#eX!Z(eX!d(eX!i(eX~Oh%WO!d-PO!i%cO!Y!^X!Z!^X~Op!nO!P!oO(QTO(TUO(`!mO~OP:kOQ:kOSfOd<fOe!iOmkOo:kOpkOqkOwkOy:kO{:kO!PWO!TkO!UkO![!eO!f:nO!iZO!l:kO!m:kO!n:kO!p:oO!r:rO!u!hO$V!kO(QTO(TUO([VO(j[O(y<dO~O(O;fO~P##_O!Y-TO!Z(dX~O!Z-VO~O!d,}O#],|O!Y#eX!Z#eX~O!Y-WO!Z(sX~O!Z-YO~O!`-ZO!a-ZO(P!lO~P#!|O!Z-^O~P'_Ok-aO![']O~O!V-fO~Op!xa!_!xa!`!xa!a!xa#Q!xa#R!xa#S!xa#T!xa#U!xa#X!xa#Y!xa(P!xa(Q!xa(T!xa(`!xa(j!xa~P!#ZO!m-kO#]-iO~PCSO!`-mO!a-mO(P!lO~PCrOa%lO#]-iO'u%lO~Oa%lO!d#vO#]-iO'u%lO~Oa%lO!d#vO!m-kO#]-iO'u%lO(m'mO~O'z'uO'{'uO'|-rO~Os-sO~O!V'Sa!Y'Sa~P!9mO!X-wO!V'SX!Y'SX~P%[O!Y(RO!V(ca~O!V(ca~PGfO!Y(YO!V(qa~O!P%fO!X-{O![%gO(O%eO!V'YX!Y'YX~O#]-}O!Y(oa!h(oaa(oa'u(oa~O!d#vO~P#+eO!Y(fO!h(na~O!P%fO![%gO#g.RO(O%eO~Om.WO!P%fO!X.TO![%gO!y]O#f.VO#g.TO(O%eO!Y']X!h']X~OR.[O!i#xO~Oh%WOk._O![']O%f.^O~Oa#`i!Y#`i'u#`i's#`i!V#`i!h#`is#`i![#`i%f#`i!d#`i~P!9mOk<pO}){O!P)|O(t%OO(u%QO~O#h#[aa#[a#]#[a'u#[a!Y#[a!h#[a![#[a!V#[a~P#.aO#h(ZXP(ZXR(ZX[(ZXa(ZXo(ZX!i(ZX!m(ZX#O(ZX#k(ZX#l(ZX#m(ZX#n(ZX#o(ZX#p(ZX#q(ZX#r(ZX#s(ZX#u(ZX#w(ZX#y(ZX#z(ZX'u(ZX([(ZX(m(ZX!h(ZX!V(ZX's(ZXs(ZX![(ZX%f(ZX!d(ZX~P!5zO!Y.lO!h(fX~P!9mO!h.oO~O!V.qO~OP$]OR#zO}#yO!P#{O!i#xO!m$]O([VO[#jia#jio#ji!Y#ji#O#ji#l#ji#m#ji#n#ji#o#ji#p#ji#q#ji#r#ji#s#ji#u#ji#w#ji#y#ji#z#ji'u#ji(m#ji(t#ji(u#ji's#ji!V#ji!h#jis#ji![#ji%f#ji!d#ji~O#k#ji~P#1|O#k$OO~P#1|OP$]OR#zO}#yO!P#{O!i#xO!m$]O#k$OO#l$PO#m$PO#n$PO([VO[#jia#ji!Y#ji#O#ji#o#ji#p#ji#q#ji#r#ji#s#ji#u#ji#w#ji#y#ji#z#ji'u#ji(m#ji(t#ji(u#ji's#ji!V#ji!h#jis#ji![#ji%f#ji!d#ji~Oo#ji~P#4kOo$QO~P#4kOP$]OR#zOo$QO}#yO!P#{O!i#xO!m$]O#k$OO#l$PO#m$PO#n$PO#o$RO([VOa#ji!Y#ji#u#ji#w#ji#y#ji#z#ji'u#ji(m#ji(t#ji(u#ji's#ji!V#ji!h#jis#ji![#ji%f#ji!d#ji~O[#ji#O#ji#p#ji#q#ji#r#ji#s#ji~P#7YO[$cO#O$SO#p$SO#q$SO#r$bO#s$SO~P#7YOP$]OR#zO[$cOo$QO}#yO!P#{O!i#xO!m$]O#O$SO#k$OO#l$PO#m$PO#n$PO#o$RO#p$SO#q$SO#r$bO#s$SO#u$TO([VO(u#}Oa#ji!Y#ji#y#ji#z#ji'u#ji(m#ji(t#ji's#ji!V#ji!h#jis#ji![#ji%f#ji!d#ji~O#w$VO~P#:WO#w#ji~P#:WOP$]OR#zO[$cOo$QO}#yO!P#{O!i#xO!m$]O#O$SO#k$OO#l$PO#m$PO#n$PO#o$RO#p$SO#q$SO#r$bO#s$SO#u$TO([VOa#ji!Y#ji#y#ji#z#ji'u#ji(m#ji's#ji!V#ji!h#jis#ji![#ji%f#ji!d#ji~O#w#ji(t#ji(u#ji~P#<uO#w$VO(t#|O(u#}O~P#<uOP$]OR#zO[$cOo$QO}#yO!P#{O!i#xO!m$]O#O$SO#k$OO#l$PO#m$PO#n$PO#o$RO#p$SO#q$SO#r$bO#s$SO#u$TO#w$VO#y$XO([VO(t#|O(u#}O~Oa#ji!Y#ji#z#ji'u#ji(m#ji's#ji!V#ji!h#jis#ji![#ji%f#ji!d#ji~P#?jOP]XR]X[]Xo]X}]X!P]X!i]X!m]X#O]X#P]X#]]X#hfX#k]X#l]X#m]X#n]X#o]X#p]X#q]X#r]X#s]X#u]X#w]X#y]X#z]X$P]X([]X(m]X(t]X(u]X!Y]X!Z]X~O#}]X~P#BQOP$]OR#zO[;SOo:vO}#yO!P#{O!i#xO!m$]O#O:xO#k:tO#l:uO#m:uO#n:uO#o:wO#p:xO#q:xO#r;RO#s:xO#u:yO#w:{O#y:}O#z;OO([VO(m$ZO(t#|O(u#}O~O#}.sO~P#D_O#P$dO#];TO$P;TO#}(bX!Z(bX~P! YOa'`a!Y'`a'u'`a's'`a!h'`a!V'`as'`a!['`a%f'`a!d'`a~P!9mOP#jiR#ji[#jia#jio#ji!Y#ji!i#ji!m#ji#O#ji#k#ji#l#ji#m#ji#n#ji#o#ji#p#ji#q#ji#r#ji#s#ji#u#ji#w#ji#y#ji#z#ji'u#ji([#ji(m#ji's#ji!V#ji!h#jis#ji![#ji%f#ji!d#ji~P#.aO!Y.wOg(kX~P!0pOg.yO~Oa$Oi!Y$Oi'u$Oi's$Oi!V$Oi!h$Ois$Oi![$Oi%f$Oi!d$Oi~P!9mO$[.zO$^.zO~O$[.{O$^.{O~O!d)dO#].|O![$bX$Y$bX$[$bX$^$bX$e$bX~O!X.}O~O![)gO$Y/PO$[)fO$^)fO$e/QO~O!Y;PO!Z(aX~P#D_O!Z/RO~O!d)dO$e(vX~O$e/TO~Ou)vO(])wO(^/WO~O!V/[O~P!&_O(t%OOk%^a}%^a!P%^a(u%^a!Y%^a#]%^a~Og%^a#}%^a~P#L{O(u%QOk%`a}%`a!P%`a(t%`a!Y%`a#]%`a~Og%`a#}%`a~P#MnO!YfX!dfX!hfX!h$xX(mfX~P!/gO!X/eO!Y(YO(O/dO!V(qP!V({P~P!1_Oo*oO!_*mO!`*fO!a*fO!i*^O#X*nO%]*iO(P!lO~Op'XO!P/fO!X+UO!Z*lO(QTO(TUO(`;cO!Z(sP~P$ XO!h/gO~P#.aO!Y/hO!d#vO(m'mO!h(zX~O!h/mO~O!P%fO!X*ZO![%gO(O%eO!h(zP~O#h/oO~O!V$xX!Y$xX!d%PX~P!/gO!Y/pO!V({X~P#.aO!d/rO~O!V/tO~Oh%WOo/xO!d#vO!i%cO(m'mO~O(O/zO~O!d+cO~Oa%lO!Y0OO'u%lO~O!Z0QO~P!5RO!`0RO!a0RO(P!lO(`!mO~O!P0TO(`!mO~O#X0UO~Og%^a!Y%^a#]%^a#}%^a~P!0pOg%`a!Y%`a#]%`a#}%`a~P!0pO(O&WOg'iX!Y'iX~O!Y*uOg(Xa~Og0_O~OR0`O}0`O!P0aO#P$dOkza(tza(uza!Yza#]za~Ogza#}za~P$&zO}){O!P)|Ok$qa(t$qa(u$qa!Y$qa#]$qa~Og$qa#}$qa~P$'sO}){O!P)|Ok$sa(t$sa(u$sa!Y$sa#]$sa~Og$sa#}$sa~P$(fO#h0dO~Og%Ra!Y%Ra#]%Ra#}%Ra~P!0pO!d#vO~O#h0gO~O!Y+WOa)Pa'u)Pa~OR#zO}#yO!P#{O!i#xO([VOP!oi[!oio!oi!Y!oi!m!oi#O!oi#k!oi#l!oi#m!oi#n!oi#o!oi#p!oi#q!oi#r!oi#s!oi#u!oi#w!oi#y!oi#z!oi(m!oi(t!oi(u!oi~Oa!oi'u!oi's!oi!V!oi!h!ois!oi![!oi%f!oi!d!oi~P$*TOh%WOo$uOp$tOq$tOw%YOy%ZO{;YO!P$|O![$}O!f<jO!i$yO#g;`O$V%_O$r;[O$t;^O$w%`O(QTO(TUO([$vO(t%OO(u%QO~Om0pO(O0oO~P$,kO!d+cOa(Wa![(Wa'u(Wa!Y(Wa~O#h0vO~O[]X!YfX!ZfX~O!Y0wO!Z)TX~O!Z0yO~O[0zO~Ob0|O(O+kO(QTO(TUO~O![%}O(O%eO`'qX!Y'qX~O!Y+pO`)Sa~O!h1PO~P!9mO[1SO~O`1TO~O#]1WO~Ok1ZO![$}O~O(`(xO!Z)QP~Oh%WOk1dO![1aO%f1cO~O[1nO!Y1lO!Z)RX~O!Z1oO~O`1qOa%lO'u%lO~O(O#nO(QTO(TUO~O#P$dO#]$eO$P$eOP(bXR(bX[(bXo(bX}(bX!P(bX!Y(bX!i(bX!m(bX#O(bX#k(bX#l(bX#m(bX#n(bX#o(bX#p(bX#q(bX#r(bX#u(bX#w(bX#y(bX#z(bX([(bX(m(bX(t(bX(u(bX~O#s1tO&W1uOa(bX~P$2RO#]$eO#s1tO&W1uO~Oa1wO~P%[Oa1yO~O&a1|OP&_iQ&_iS&_iY&_ia&_id&_ie&_im&_io&_ip&_iq&_iw&_iy&_i{&_i!P&_i!T&_i!U&_i![&_i!f&_i!i&_i!l&_i!m&_i!n&_i!p&_i!r&_i!u&_i!y&_i#t&_i$V&_i%e&_i%g&_i%i&_i%j&_i%k&_i%n&_i%p&_i%s&_i%t&_i%v&_i&S&_i&Y&_i&[&_i&^&_i&`&_i&c&_i&i&_i&o&_i&q&_i&s&_i&u&_i&w&_i's&_i(O&_i(Q&_i(T&_i([&_i(j&_i(y&_i!Z&_ib&_i&f&_i~Ob2SO!Z2QO&f2RO~P`O![XO!i2UO~O&m,sOP&hiQ&hiS&hiY&hia&hid&hie&him&hio&hip&hiq&hiw&hiy&hi{&hi!P&hi!T&hi!U&hi![&hi!f&hi!i&hi!l&hi!m&hi!n&hi!p&hi!r&hi!u&hi!y&hi#t&hi$V&hi%e&hi%g&hi%i&hi%j&hi%k&hi%n&hi%p&hi%s&hi%t&hi%v&hi&S&hi&Y&hi&[&hi&^&hi&`&hi&c&hi&i&hi&o&hi&q&hi&s&hi&u&hi&w&hi's&hi(O&hi(Q&hi(T&hi([&hi(j&hi(y&hi!Z&hi&a&hib&hi&f&hi~O!V2[O~O!Y!^a!Z!^a~P#D_Op!nO!P!oO!X2bO(`!mO!Y'TX!Z'TX~P@YO!Y-TO!Z(da~O!Y'ZX!Z'ZX~P!8uO!Y-WO!Z(sa~O!Z2iO~P'_Oa%lO#]2rO'u%lO~Oa%lO!d#vO#]2rO'u%lO~Oa%lO!d#vO!m2vO#]2rO'u%lO(m'mO~Oa%lO'u%lO~P!9mO!Y$`Os$oa~O!V'Si!Y'Si~P!9mO!Y(RO!V(ci~O!Y(YO!V(qi~O!V(ri!Y(ri~P!9mO!Y(oi!h(oia(oi'u(oi~P!9mO#]2xO!Y(oi!h(oia(oi'u(oi~O!Y(fO!h(ni~O!P%fO![%gO!y]O#f2}O#g2|O(O%eO~O!P%fO![%gO#g2|O(O%eO~Ok3UO![']O%f3TO~Oh%WOk3UO![']O%f3TO~O#h%^aP%^aR%^a[%^aa%^ao%^a!i%^a!m%^a#O%^a#k%^a#l%^a#m%^a#n%^a#o%^a#p%^a#q%^a#r%^a#s%^a#u%^a#w%^a#y%^a#z%^a'u%^a([%^a(m%^a!h%^a!V%^a's%^as%^a![%^a%f%^a!d%^a~P#L{O#h%`aP%`aR%`a[%`aa%`ao%`a!i%`a!m%`a#O%`a#k%`a#l%`a#m%`a#n%`a#o%`a#p%`a#q%`a#r%`a#s%`a#u%`a#w%`a#y%`a#z%`a'u%`a([%`a(m%`a!h%`a!V%`a's%`as%`a![%`a%f%`a!d%`a~P#MnO#h%^aP%^aR%^a[%^aa%^ao%^a!Y%^a!i%^a!m%^a#O%^a#k%^a#l%^a#m%^a#n%^a#o%^a#p%^a#q%^a#r%^a#s%^a#u%^a#w%^a#y%^a#z%^a'u%^a([%^a(m%^a!h%^a!V%^a's%^a#]%^as%^a![%^a%f%^a!d%^a~P#.aO#h%`aP%`aR%`a[%`aa%`ao%`a!Y%`a!i%`a!m%`a#O%`a#k%`a#l%`a#m%`a#n%`a#o%`a#p%`a#q%`a#r%`a#s%`a#u%`a#w%`a#y%`a#z%`a'u%`a([%`a(m%`a!h%`a!V%`a's%`a#]%`as%`a![%`a%f%`a!d%`a~P#.aO#hzaPza[zaazaoza!iza!mza#Oza#kza#lza#mza#nza#oza#pza#qza#rza#sza#uza#wza#yza#zza'uza([za(mza!hza!Vza'szasza![za%fza!dza~P$&zO#h$qaP$qaR$qa[$qaa$qao$qa!i$qa!m$qa#O$qa#k$qa#l$qa#m$qa#n$qa#o$qa#p$qa#q$qa#r$qa#s$qa#u$qa#w$qa#y$qa#z$qa'u$qa([$qa(m$qa!h$qa!V$qa's$qas$qa![$qa%f$qa!d$qa~P$'sO#h$saP$saR$sa[$saa$sao$sa!i$sa!m$sa#O$sa#k$sa#l$sa#m$sa#n$sa#o$sa#p$sa#q$sa#r$sa#s$sa#u$sa#w$sa#y$sa#z$sa'u$sa([$sa(m$sa!h$sa!V$sa's$sas$sa![$sa%f$sa!d$sa~P$(fO#h%RaP%RaR%Ra[%Raa%Rao%Ra!Y%Ra!i%Ra!m%Ra#O%Ra#k%Ra#l%Ra#m%Ra#n%Ra#o%Ra#p%Ra#q%Ra#r%Ra#s%Ra#u%Ra#w%Ra#y%Ra#z%Ra'u%Ra([%Ra(m%Ra!h%Ra!V%Ra's%Ra#]%Ras%Ra![%Ra%f%Ra!d%Ra~P#.aOa#`q!Y#`q'u#`q's#`q!V#`q!h#`qs#`q![#`q%f#`q!d#`q~P!9mO!X3^O!Y'UX!h'UX~P%[O!Y.lO!h(fa~O!Y.lO!h(fa~P!9mO!V3aO~O#}!ka!Z!ka~PKPO#}!ga!Y!ga!Z!ga~P#D_O#}!oa!Z!oa~P!<TO#}!qa!Z!qa~P!>kOg'XX!Y'XX~P!+hO!Y.wOg(ka~OSfO![3uO$c3vO~O!Z3zO~Os3{O~P#.aOa$lq!Y$lq'u$lq's$lq!V$lq!h$lqs$lq![$lq%f$lq!d$lq~P!9mO!V3|O~P#.aO}){O!P)|O(u%QOk'ea(t'ea!Y'ea#]'ea~Og'ea#}'ea~P%+]O}){O!P)|Ok'ga(t'ga(u'ga!Y'ga#]'ga~Og'ga#}'ga~P%,OO(m$ZO~P#.aO!VfX!V$xX!YfX!Y$xX!d%PX#]fX~P!/gO(O;lO~P!1_OmkO(O4OO~P.iO!P%fO!X4QO![%gO(O%eO!Y'aX!h'aX~O!Y/hO!h(za~O!Y/hO!d#vO!h(za~O!Y/hO!d#vO(m'mO!h(za~Og$zi!Y$zi#]$zi#}$zi~P!0pO!X4YO!V'cX!Y'cX~P!3^O!Y/pO!V({a~O!Y/pO!V({a~P#.aO!d#vO#s4bO~Oo4eO!d#vO(m'mO~O(t%OOk%^i}%^i!P%^i(u%^i!Y%^i#]%^i~Og%^i#}%^i~P%0^O(u%QOk%`i}%`i!P%`i(t%`i!Y%`i#]%`i~Og%`i#}%`i~P%1POg(Yi!Y(Yi~P!0pO#]4lOg(Yi!Y(Yi~P!0pO!h4oO~Oa$mq!Y$mq'u$mq's$mq!V$mq!h$mqs$mq![$mq%f$mq!d$mq~P!9mO!V4sO~O!Y4tO![(|X~P#.aOa$xX![$xX%Z]X'u$xX!Y$xX~P!/gO%Z4wOalXklX}lX!PlX![lX'ulX(tlX(ulX!YlX~O%Z4wO~Ob4}O%g5OO(O+kO(QTO(TUO!Y'pX!Z'pX~O!Y0wO!Z)Ta~O[5SO~O`5TO~Oa%lO'u%lO~P#.aO![$}O~P#.aO!Y5]O#]5_O!Z)QX~O!Z5`O~Op!nO!P5aO!_!yO!`!vO!a!vO!y:lO#Q!pO#R!pO#S!pO#T!pO#U!pO#X5fO#Y!zO(P!lO(QTO(TUO(`!mO(j!sO~O!Z5eO~P%6ZOk5kO![1aO%f5jO~Oh%WOk5kO![1aO%f5jO~Ob5rO(O#nO(QTO(TUO!Y'oX!Z'oX~O!Y1lO!Z)Ra~O(QTO(TUO(`5tO~O`5xO~O#s5{O&W5|O~PMlO!h5}O~P%[Oa6PO~Oa6PO~P%[Ob2SO!Z6UO&f2RO~P`O!d6WO~O!d6YOh(ei!Y(ei!Z(ei!d(ei!i(ei~O!Y#ei!Z#ei~P#D_O#]6ZO!Y#ei!Z#ei~O!Y!^i!Z!^i~P#D_Oa%lO#]6dO'u%lO~Oa%lO!d#vO#]6dO'u%lO~O!Y(oq!h(oqa(oq'u(oq~P!9mO!Y(fO!h(nq~O!P%fO![%gO#g6kO(O%eO~O![']O%f6nO~Ok6rO![']O%f6nO~O#h'eaP'eaR'ea['eaa'eao'ea!i'ea!m'ea#O'ea#k'ea#l'ea#m'ea#n'ea#o'ea#p'ea#q'ea#r'ea#s'ea#u'ea#w'ea#y'ea#z'ea'u'ea(['ea(m'ea!h'ea!V'ea's'eas'ea!['ea%f'ea!d'ea~P%+]O#h'gaP'gaR'ga['gaa'gao'ga!i'ga!m'ga#O'ga#k'ga#l'ga#m'ga#n'ga#o'ga#p'ga#q'ga#r'ga#s'ga#u'ga#w'ga#y'ga#z'ga'u'ga(['ga(m'ga!h'ga!V'ga's'gas'ga!['ga%f'ga!d'ga~P%,OO#h$ziP$ziR$zi[$zia$zio$zi!Y$zi!i$zi!m$zi#O$zi#k$zi#l$zi#m$zi#n$zi#o$zi#p$zi#q$zi#r$zi#s$zi#u$zi#w$zi#y$zi#z$zi'u$zi([$zi(m$zi!h$zi!V$zi's$zi#]$zis$zi![$zi%f$zi!d$zi~P#.aO#h%^iP%^iR%^i[%^ia%^io%^i!i%^i!m%^i#O%^i#k%^i#l%^i#m%^i#n%^i#o%^i#p%^i#q%^i#r%^i#s%^i#u%^i#w%^i#y%^i#z%^i'u%^i([%^i(m%^i!h%^i!V%^i's%^is%^i![%^i%f%^i!d%^i~P%0^O#h%`iP%`iR%`i[%`ia%`io%`i!i%`i!m%`i#O%`i#k%`i#l%`i#m%`i#n%`i#o%`i#p%`i#q%`i#r%`i#s%`i#u%`i#w%`i#y%`i#z%`i'u%`i([%`i(m%`i!h%`i!V%`i's%`is%`i![%`i%f%`i!d%`i~P%1PO!Y'Ua!h'Ua~P!9mO!Y.lO!h(fi~O#}#`i!Y#`i!Z#`i~P#D_OP$]OR#zO}#yO!P#{O!i#xO!m$]O([VO[#jio#ji#O#ji#l#ji#m#ji#n#ji#o#ji#p#ji#q#ji#r#ji#s#ji#u#ji#w#ji#y#ji#z#ji#}#ji(m#ji(t#ji(u#ji!Y#ji!Z#ji~O#k#ji~P%HpO#k:tO~P%HpOP$]OR#zO}#yO!P#{O!i#xO!m$]O#k:tO#l:uO#m:uO#n:uO([VO[#ji#O#ji#o#ji#p#ji#q#ji#r#ji#s#ji#u#ji#w#ji#y#ji#z#ji#}#ji(m#ji(t#ji(u#ji!Y#ji!Z#ji~Oo#ji~P%JxOo:vO~P%JxOP$]OR#zOo:vO}#yO!P#{O!i#xO!m$]O#k:tO#l:uO#m:uO#n:uO#o:wO([VO#u#ji#w#ji#y#ji#z#ji#}#ji(m#ji(t#ji(u#ji!Y#ji!Z#ji~O[#ji#O#ji#p#ji#q#ji#r#ji#s#ji~P%MQO[;SO#O:xO#p:xO#q:xO#r;RO#s:xO~P%MQOP$]OR#zO[;SOo:vO}#yO!P#{O!i#xO!m$]O#O:xO#k:tO#l:uO#m:uO#n:uO#o:wO#p:xO#q:xO#r;RO#s:xO#u:yO([VO(u#}O#y#ji#z#ji#}#ji(m#ji(t#ji!Y#ji!Z#ji~O#w:{O~P& iO#w#ji~P& iOP$]OR#zO[;SOo:vO}#yO!P#{O!i#xO!m$]O#O:xO#k:tO#l:uO#m:uO#n:uO#o:wO#p:xO#q:xO#r;RO#s:xO#u:yO([VO#y#ji#z#ji#}#ji(m#ji!Y#ji!Z#ji~O#w#ji(t#ji(u#ji~P&#qO#w:{O(t#|O(u#}O~P&#qOP$]OR#zO[;SOo:vO}#yO!P#{O!i#xO!m$]O#O:xO#k:tO#l:uO#m:uO#n:uO#o:wO#p:xO#q:xO#r;RO#s:xO#u:yO#w:{O#y:}O([VO(t#|O(u#}O~O#z#ji#}#ji(m#ji!Y#ji!Z#ji~P&&POa#{y!Y#{y'u#{y's#{y!V#{y!h#{ys#{y![#{y%f#{y!d#{y~P!9mOk<qO}){O!P)|O(t%OO(u%QO~OP#jiR#ji[#jio#ji!i#ji!m#ji#O#ji#k#ji#l#ji#m#ji#n#ji#o#ji#p#ji#q#ji#r#ji#s#ji#u#ji#w#ji#y#ji#z#ji#}#ji([#ji(m#ji!Y#ji!Z#ji~P&(tO#P$dOP(ZXR(ZX[(ZXk(ZXo(ZX}(ZX!P(ZX!i(ZX!m(ZX#O(ZX#k(ZX#l(ZX#m(ZX#n(ZX#o(ZX#p(ZX#q(ZX#r(ZX#s(ZX#u(ZX#w(ZX#y(ZX#z(ZX#}(ZX([(ZX(m(ZX(t(ZX(u(ZX!Y(ZX!Z(ZX~O#}$Oi!Y$Oi!Z$Oi~P#D_O#}!oi!Z!oi~P$*TOg'Xa!Y'Xa~P!0pO!Z7UO~O!Y'`a!Z'`a~P#D_OP]XR]X[]Xo]X}]X!P]X!V]X!Y]X!i]X!m]X#O]X#P]X#]]X#hfX#k]X#l]X#m]X#n]X#o]X#p]X#q]X#r]X#s]X#u]X#w]X#y]X#z]X$P]X([]X(m]X(t]X(u]X~O!d%WX#s%WX~P&-}O!d#vO(m'mO!Y'aa!h'aa~O!Y/hO!h(zi~O!Y/hO!d#vO!h(zi~Og$zq!Y$zq#]$zq#}$zq~P!0pO!V'ca!Y'ca~P#.aO!d7]O~O!Y/pO!V({i~P#.aO!Y/pO!V({i~O!V7aO~O!d#vO#s7fO~Oo7gO!d#vO(m'mO~O}){O!P)|O(u%QOk'fa(t'fa!Y'fa#]'fa~Og'fa#}'fa~P&2mO}){O!P)|Ok'ha(t'ha(u'ha!Y'ha#]'ha~Og'ha#}'ha~P&3`O!V7iO~Og$|q!Y$|q#]$|q#}$|q~P!0pOa$my!Y$my'u$my's$my!V$my!h$mys$my![$my%f$my!d$my~P!9mO!d6YO~O!Y4tO![(|a~O![']OP$SaR$Sa[$Sao$Sa}$Sa!P$Sa!Y$Sa!i$Sa!m$Sa#O$Sa#k$Sa#l$Sa#m$Sa#n$Sa#o$Sa#p$Sa#q$Sa#r$Sa#s$Sa#u$Sa#w$Sa#y$Sa#z$Sa([$Sa(m$Sa(t$Sa(u$Sa~O%f6nO~P&5iOa#`y!Y#`y'u#`y's#`y!V#`y!h#`ys#`y![#`y%f#`y!d#`y~P!9mO[7nO~Ob7pO(O+kO(QTO(TUO~O!Y0wO!Z)Ti~O`7tO~O(`(xO!Y'lX!Z'lX~O!Y5]O!Z)Qa~O!Z7}O~P%6ZOp!nO!P8OO(QTO(TUO(`!mO(j!sO~O![1aO~O![1aO%f8QO~Ok8TO![1aO%f8QO~O[8YO!Y'oa!Z'oa~O!Y1lO!Z)Ri~O!h8^O~O!h8_O~O!h8bO~O!h8bO~P%[Oa8dO~O!d8eO~O!h8fO~O!Y(ri!Z(ri~P#D_Oa%lO#]8nO'u%lO~O!Y(oy!h(oya(oy'u(oy~P!9mO!Y(fO!h(ny~O%f8qO~P&5iO![']O%f8qO~O#h$zqP$zqR$zq[$zqa$zqo$zq!Y$zq!i$zq!m$zq#O$zq#k$zq#l$zq#m$zq#n$zq#o$zq#p$zq#q$zq#r$zq#s$zq#u$zq#w$zq#y$zq#z$zq'u$zq([$zq(m$zq!h$zq!V$zq's$zq#]$zqs$zq![$zq%f$zq!d$zq~P#.aO#h'faP'faR'fa['faa'fao'fa!i'fa!m'fa#O'fa#k'fa#l'fa#m'fa#n'fa#o'fa#p'fa#q'fa#r'fa#s'fa#u'fa#w'fa#y'fa#z'fa'u'fa(['fa(m'fa!h'fa!V'fa's'fas'fa!['fa%f'fa!d'fa~P&2mO#h'haP'haR'ha['haa'hao'ha!i'ha!m'ha#O'ha#k'ha#l'ha#m'ha#n'ha#o'ha#p'ha#q'ha#r'ha#s'ha#u'ha#w'ha#y'ha#z'ha'u'ha(['ha(m'ha!h'ha!V'ha's'has'ha!['ha%f'ha!d'ha~P&3`O#h$|qP$|qR$|q[$|qa$|qo$|q!Y$|q!i$|q!m$|q#O$|q#k$|q#l$|q#m$|q#n$|q#o$|q#p$|q#q$|q#r$|q#s$|q#u$|q#w$|q#y$|q#z$|q'u$|q([$|q(m$|q!h$|q!V$|q's$|q#]$|qs$|q![$|q%f$|q!d$|q~P#.aO!Y'Ui!h'Ui~P!9mO#}#`q!Y#`q!Z#`q~P#D_O(t%OOP%^aR%^a[%^ao%^a!i%^a!m%^a#O%^a#k%^a#l%^a#m%^a#n%^a#o%^a#p%^a#q%^a#r%^a#s%^a#u%^a#w%^a#y%^a#z%^a#}%^a([%^a(m%^a!Y%^a!Z%^a~Ok%^a}%^a!P%^a(u%^a~P&FgO(u%QOP%`aR%`a[%`ao%`a!i%`a!m%`a#O%`a#k%`a#l%`a#m%`a#n%`a#o%`a#p%`a#q%`a#r%`a#s%`a#u%`a#w%`a#y%`a#z%`a#}%`a([%`a(m%`a!Y%`a!Z%`a~Ok%`a}%`a!P%`a(t%`a~P&HkOk<qO}){O!P)|O(u%QO~P&FgOk<qO}){O!P)|O(t%OO~P&HkOR0`O}0`O!P0aO#P$dOPza[zakzaoza!iza!mza#Oza#kza#lza#mza#nza#oza#pza#qza#rza#sza#uza#wza#yza#zza#}za([za(mza(tza(uza!Yza!Zza~O}){O!P)|OP$qaR$qa[$qak$qao$qa!i$qa!m$qa#O$qa#k$qa#l$qa#m$qa#n$qa#o$qa#p$qa#q$qa#r$qa#s$qa#u$qa#w$qa#y$qa#z$qa#}$qa([$qa(m$qa(t$qa(u$qa!Y$qa!Z$qa~O}){O!P)|OP$saR$sa[$sak$sao$sa!i$sa!m$sa#O$sa#k$sa#l$sa#m$sa#n$sa#o$sa#p$sa#q$sa#r$sa#s$sa#u$sa#w$sa#y$sa#z$sa#}$sa([$sa(m$sa(t$sa(u$sa!Y$sa!Z$sa~OP%RaR%Ra[%Rao%Ra!i%Ra!m%Ra#O%Ra#k%Ra#l%Ra#m%Ra#n%Ra#o%Ra#p%Ra#q%Ra#r%Ra#s%Ra#u%Ra#w%Ra#y%Ra#z%Ra#}%Ra([%Ra(m%Ra!Y%Ra!Z%Ra~P&(tO#}$lq!Y$lq!Z$lq~P#D_O#}$mq!Y$mq!Z$mq~P#D_O!Z9OO~O#}9PO~P!0pO!d#vO!Y'ai!h'ai~O!d#vO(m'mO!Y'ai!h'ai~O!Y/hO!h(zq~O!V'ci!Y'ci~P#.aO!Y/pO!V({q~O!V9VO~P#.aO!V9VO~Og(Yy!Y(Yy~P!0pO!Y'ja!['ja~P#.aOa%Yq![%Yq'u%Yq!Y%Yq~P#.aO[9[O~O!Y0wO!Z)Tq~O#]9`O!Y'la!Z'la~O!Y5]O!Z)Qi~P#D_O![1aO%f9dO~O(QTO(TUO(`9iO~O!Y1lO!Z)Rq~O!h9lO~O!h9mO~O!h9nO~O!h9nO~P%[O#]9qO!Y#ey!Z#ey~O!Y#ey!Z#ey~P#D_O%f9vO~P&5iO![']O%f9vO~O#}#{y!Y#{y!Z#{y~P#D_OP$ziR$zi[$zio$zi!i$zi!m$zi#O$zi#k$zi#l$zi#m$zi#n$zi#o$zi#p$zi#q$zi#r$zi#s$zi#u$zi#w$zi#y$zi#z$zi#}$zi([$zi(m$zi!Y$zi!Z$zi~P&(tO}){O!P)|O(u%QOP'eaR'ea['eak'eao'ea!i'ea!m'ea#O'ea#k'ea#l'ea#m'ea#n'ea#o'ea#p'ea#q'ea#r'ea#s'ea#u'ea#w'ea#y'ea#z'ea#}'ea(['ea(m'ea(t'ea!Y'ea!Z'ea~O}){O!P)|OP'gaR'ga['gak'gao'ga!i'ga!m'ga#O'ga#k'ga#l'ga#m'ga#n'ga#o'ga#p'ga#q'ga#r'ga#s'ga#u'ga#w'ga#y'ga#z'ga#}'ga(['ga(m'ga(t'ga(u'ga!Y'ga!Z'ga~O(t%OOP%^iR%^i[%^ik%^io%^i}%^i!P%^i!i%^i!m%^i#O%^i#k%^i#l%^i#m%^i#n%^i#o%^i#p%^i#q%^i#r%^i#s%^i#u%^i#w%^i#y%^i#z%^i#}%^i([%^i(m%^i(u%^i!Y%^i!Z%^i~O(u%QOP%`iR%`i[%`ik%`io%`i}%`i!P%`i!i%`i!m%`i#O%`i#k%`i#l%`i#m%`i#n%`i#o%`i#p%`i#q%`i#r%`i#s%`i#u%`i#w%`i#y%`i#z%`i#}%`i([%`i(m%`i(t%`i!Y%`i!Z%`i~O#}$my!Y$my!Z$my~P#D_O#}#`y!Y#`y!Z#`y~P#D_O!d#vO!Y'aq!h'aq~O!Y/hO!h(zy~O!V'cq!Y'cq~P#.aO!V:PO~P#.aO!Y0wO!Z)Ty~O!Y5]O!Z)Qq~O![1aO%f:WO~O!h:ZO~O%f:`O~P&5iOP$zqR$zq[$zqo$zq!i$zq!m$zq#O$zq#k$zq#l$zq#m$zq#n$zq#o$zq#p$zq#q$zq#r$zq#s$zq#u$zq#w$zq#y$zq#z$zq#}$zq([$zq(m$zq!Y$zq!Z$zq~P&(tO}){O!P)|O(u%QOP'faR'fa['fak'fao'fa!i'fa!m'fa#O'fa#k'fa#l'fa#m'fa#n'fa#o'fa#p'fa#q'fa#r'fa#s'fa#u'fa#w'fa#y'fa#z'fa#}'fa(['fa(m'fa(t'fa!Y'fa!Z'fa~O}){O!P)|OP'haR'ha['hak'hao'ha!i'ha!m'ha#O'ha#k'ha#l'ha#m'ha#n'ha#o'ha#p'ha#q'ha#r'ha#s'ha#u'ha#w'ha#y'ha#z'ha#}'ha(['ha(m'ha(t'ha(u'ha!Y'ha!Z'ha~OP$|qR$|q[$|qo$|q!i$|q!m$|q#O$|q#k$|q#l$|q#m$|q#n$|q#o$|q#p$|q#q$|q#r$|q#s$|q#u$|q#w$|q#y$|q#z$|q#}$|q([$|q(m$|q!Y$|q!Z$|q~P&(tOg%b!Z!Y%b!Z#]%b!Z#}%b!Z~P!0pO!Y'lq!Z'lq~P#D_O!Y#e!Z!Z#e!Z~P#D_O#h%b!ZP%b!ZR%b!Z[%b!Za%b!Zo%b!Z!Y%b!Z!i%b!Z!m%b!Z#O%b!Z#k%b!Z#l%b!Z#m%b!Z#n%b!Z#o%b!Z#p%b!Z#q%b!Z#r%b!Z#s%b!Z#u%b!Z#w%b!Z#y%b!Z#z%b!Z'u%b!Z([%b!Z(m%b!Z!h%b!Z!V%b!Z's%b!Z#]%b!Zs%b!Z![%b!Z%f%b!Z!d%b!Z~P#.aOP%b!ZR%b!Z[%b!Zo%b!Z!i%b!Z!m%b!Z#O%b!Z#k%b!Z#l%b!Z#m%b!Z#n%b!Z#o%b!Z#p%b!Z#q%b!Z#r%b!Z#s%b!Z#u%b!Z#w%b!Z#y%b!Z#z%b!Z#}%b!Z([%b!Z(m%b!Z!Y%b!Z!Z%b!Z~P&(tOs(aX~P1qO}%pO~P!(oO(P!lO~P!(oO!VfX!YfX#]fX~P&-}OP]XR]X[]Xo]X}]X!P]X!Y]X!YfX!i]X!m]X#O]X#P]X#]]X#]fX#hfX#k]X#l]X#m]X#n]X#o]X#p]X#q]X#r]X#s]X#u]X#w]X#y]X#z]X$P]X([]X(m]X(t]X(u]X~O!dfX!h]X!hfX(mfX~P'CvOP:kOQ:kOSfOd<fOe!iOmkOo:kOpkOqkOwkOy:kO{:kO!PWO!TkO!UkO![XO!f:nO!iZO!l:kO!m:kO!n:kO!p:oO!r:rO!u!hO$V!kO(O)YO(QTO(TUO([VO(j[O(y<dO~O!Y;PO!Z$oa~Oh%WOm%XOo$uOp$tOq$tOw%YOy%ZO{;ZO!P$|O![$}O!f<kO!i$yO#g;aO$V%_O$r;]O$t;_O$w%`O(O(rO(QTO(TUO([$vO(t%OO(u%QO~O#t)`O~P'HlOo!bX(m!bX~P# ZO!Z]X!ZfX~P'CvO!VfX!V$xX!YfX!Y$xX#]fX~P!/gO#h:sO~O!d#vO#h:sO~O#];TO~O#s:xO~O#];dO!Y(rX!Z(rX~O#];TO!Y(pX!Z(pX~O#h;eO~Og;gO~P!0pO#h;mO~O#h;nO~O!d#vO#h;oO~O!d#vO#h;eO~O#};pO~P#D_O#h;qO~O#h;rO~O#h;wO~O#h;xO~O#h;yO~O#h;zO~O#};{O~P!0pO#};|O~P!0pO#P#Q#R#T#U#X#f#g#r(y$r$t$w%Z%e%f%g%n%p%s%t%v%x~'yT#l!U'w(P#mp#k#no}'x$['x(O$^(`~",
  goto: "$2y)XPPPPPP)YPP)]P)nP+O/PPPPP5wPP6_PP<U?kP@OP@OPPP@OPBOP@OP@OP@OPBSPBXPBvPGoPPPGsPPPPGsJuPPPJ{KwPGsPGsPPNVGsPPPGsPGsP!!^GsP!%s!&x!'RP!'u!'y!'u!+VPPPPPPP!+v!&xPP!,W!-QP!/tGsGs!/y!3U!7l!7l!;jPPP!;rGsPPPPPPPPPPP!?QP!@_PPGs!ApPGsPGsGsGsGsGsPGs!CSP!F]P!IbP!If!Ip!It!ItP!FYP!Ix!IxP!L}P!MRGsGs!MX#!]BS@OP@OP@O@OP##i@O@O#%s@O#(c@O#*g@O@O#+V#-c#-c#-h#-q#-c#-zP#-cP@O#.d@O#2T@O@O5wPPP#5zPPP#6e#6eP#6eP#6{#6ePP#7RP#6xP#6x#7f#6x#8Q#8W5t)]#8Z)]P#8b#8b#8bP)]P)]P)]P)]PP)]P#8h#8kP#8k)]P#8oP#8rP)]P)]P)]P)]P)]P)])]PP#8x#9O#9Z#9a#9g#9m#9s#:R#:X#:c#:i#:s#:y#;Z#;a#<R#<e#<k#<q#=P#=f#?T#?c#?j#AO#A^#Bx#CW#C^#Cd#Cj#Ct#Cz#DQ#D[#Dn#DtPPPPPPPPPP#DzPPPPPPP#Eo#Hv#JV#J^#JfPPP$ lP$ u$$m$+V$+Y$+]$+x$+{$,S$,[P$,b$,eP$-R$-V$-}$/]$/b$/xPP$/}$0T$0XP$0[$0`$0d$1Y$1q$2Y$2^$2a$2d$2j$2m$2q$2uR!|RoqOXst!Z#d%k&o&q&r&t,k,p1|2PY!vQ']-]1a5dQ%rvQ%zyQ&R|Q&g!VS'T!e-TQ'c!iS'i!r!yU*f$}*W*kQ+i%{Q+v&TQ,[&aQ-Z'[Q-e'dQ-m'jQ0R*mQ1k,]R;b:o%QdOPWXYZstuvw!Z!`!g!o#S#W#Z#d#o#u#x#{$O$P$Q$R$S$T$U$V$W$X$Y$`$e%k%r&P&h&k&o&q&r&t&x'Q'_'o(P(R(X(`(t(v(z)z+R+V,h,k,p-a-i-w-}.l.s/f0a0g0v1d1t1u1w1y1|2P2R2r2x3^5a5k5{5|6P6d8O8T8d8nS#q]:l!r)[$[$n'U)o,|-P.}2b3u5_6Z9`9q:k:n:o:r:s:t:u:v:w:x:y:z:{:|:};O;P;T;b;d;e;g;o;p;y;z<gU*y%[;Y;ZQ+n%}Q,^&dQ,e&lQ0m+aQ0q+cQ0|+oQ1s,cQ3Q._Q4}0wQ5r1lQ6p3UQ7p5OR8t6r'OkOPWXYZstuvw!Z!`!g!o#S#W#Z#d#o#u#x#{$O$P$Q$R$S$T$U$V$W$X$Y$[$`$e$n%k%r&P&h&k&l&o&q&r&t&x'Q'U'_'o(P(R(X(`(t(v(z)o)z+R+V+a,h,k,p,|-P-a-i-w-}._.l.s.}/f0a0g0v1d1t1u1w1y1|2P2R2b2r2x3U3^3u5_5a5k5{5|6P6Z6d6r8O8T8d8n9`9q:k:n:o:r:s:t:u:v:w:x:y:z:{:|:};O;P;T;b;d;e;g;o;p;y;z<gt!nQ!r!v!y!z'T'[']'i'j'k-T-Z-]-m1a5d5f$z$ti#v$b$c$d$y$|%P%R%]%^%b)v)|*O*Q*S*V*]*c*s*t+`+c+z+}.^.w/]/e/o/p/r0V0X0d1W1Z1c3T3}4Y4b4l4t4w5j6n7]7f8Q8q9P9d9v:W:`;R;S;U;V;W;X;[;];^;_;`;a;h;i;j;k;m;n;q;r;s;t;u;v;w;x;{;|<d<l<m<p<qQ&U|Q'R!eU'X%g*W-WQ+n%}Q,^&dQ0c*|Q0|+oQ1R+uQ1r,bQ1s,cQ4}0wQ5W1TQ5r1lQ5u1nQ5v1qQ7p5OQ7s5TQ8]5xQ9_7tR9j8YrnOXst!V!Z#d%k&f&o&q&r&t,k,p1|2PR,`&h&x^OPXYstuvwz!Z!`!g!j!o#S#d#o#u#x#{$O$P$Q$R$S$T$U$V$W$X$Y$[$`$e$n%k%r&P&h&k&l&o&q&r&t&x'Q'_'o(R(X(`(t(v(z)o)z+R+V+a,h,k,p,|-P-a-i-w-}._.l.s.}/f0a0g0v1d1t1u1w1y1|2P2R2b2r2x3U3^3u5_5a5k5{5|6P6Z6d6r8O8T8d8n9`9q:k:n:o:r:s:t:u:v:w:x:y:z:{:|:};O;P;T;b;d;e;g;o;p;y;z<f<g[#]WZ#W#Z'U(P!b%hm#h#i#l$y%c%f(Y(d(e(f*V*Z*^+T+U+W,g,}-{.R.S.T.V/e/h2U2|2}4Q6Y6kQ%uxQ%yyS&O|&TQ&[!TQ'`!hQ'b!iQ(m#sS+h%z%{Q+l%}Q,V&_Q,Z&aS-d'c'dQ.a(nQ0u+iQ0{+oQ0}+pQ1Q+tQ1f,WS1j,[,]Q2n-eQ4|0wQ5Q0zQ5V1SQ5q1kQ7o5OQ7r5SQ9Z7nR:R9[!O${i$d%P%R%]%^%b*O*Q*]*s*t.w/o0V0X0d3}4l9P<d<l<m!S%wy!i!u%y%z%{'S'b'c'd'h'r*e+h+i-Q-d-e-l/y0u2g2n2u4dQ+b%uQ+{&XQ,O&YQ,Y&aQ.`(mQ1e,VU1i,Z,[,]Q3V.aQ5l1fS5p1j1kQ8X5q#[<h#v$b$c$y$|)v)|*S*V*c+`+c+z+}.^/]/e/p/r1W1Z1c3T4Y4b4t4w5j6n7]7f8Q8q9d9v:W:`;U;W;[;^;`;h;j;m;q;s;u;w;{<p<qo<i;R;S;V;X;];_;a;i;k;n;r;t;v;x;|W%Ui%W*u<dS&X!Q&fQ&Y!RQ&Z!SR+y&V${%Ti#v$b$c$d$y$|%P%R%]%^%b)v)|*O*Q*S*V*]*c*s*t+`+c+z+}.^.w/]/e/o/p/r0V0X0d1W1Z1c3T3}4Y4b4l4t4w5j6n7]7f8Q8q9P9d9v:W:`;R;S;U;V;W;X;[;];^;_;`;a;h;i;j;k;m;n;q;r;s;t;u;v;w;x;{;|<d<l<m<p<qT)w$v)xV*y%[;Y;ZW'X!e%g*W-WS(y#y#zQ+]%pQ+s&QS.Y(i(jQ1[,PQ4m0`R7x5]'OkOPWXYZstuvw!Z!`!g!o#S#W#Z#d#o#u#x#{$O$P$Q$R$S$T$U$V$W$X$Y$[$`$e$n%k%r&P&h&k&l&o&q&r&t&x'Q'U'_'o(P(R(X(`(t(v(z)o)z+R+V+a,h,k,p,|-P-a-i-w-}._.l.s.}/f0a0g0v1d1t1u1w1y1|2P2R2b2r2x3U3^3u5_5a5k5{5|6P6Z6d6r8O8T8d8n9`9q:k:n:o:r:s:t:u:v:w:x:y:z:{:|:};O;P;T;b;d;e;g;o;p;y;z<g$i$_c#Y#e%o%q%s(O(U(p(u(})O)P)Q)R)S)T)U)V)W)X)Z)])c)m+^+r-R-p-u-z-|.k.n.r.t.u.v/X0e2]2`2p2w3]3b3c3d3e3f3g3h3i3j3k3l3m3n3q3r3y4q4z6]6c6h6w6x7R7S7z8h8l8v8|8}9s:T:[:m<ZT#TV#U'PkOPWXYZstuvw!Z!`!g!o#S#W#Z#d#o#u#x#{$O$P$Q$R$S$T$U$V$W$X$Y$[$`$e$n%k%r&P&h&k&l&o&q&r&t&x'Q'U'_'o(P(R(X(`(t(v(z)o)z+R+V+a,h,k,p,|-P-a-i-w-}._.l.s.}/f0a0g0v1d1t1u1w1y1|2P2R2b2r2x3U3^3u5_5a5k5{5|6P6Z6d6r8O8T8d8n9`9q:k:n:o:r:s:t:u:v:w:x:y:z:{:|:};O;P;T;b;d;e;g;o;p;y;z<gQ'V!eR2c-Tv!nQ!e!r!v!y!z'T'[']'i'j'k-T-Z-]-m1a5d5fU*e$}*W*kS/y*f*mQ0S*nQ1^,RQ4d0RR4g0UnqOXst!Z#d%k&o&q&r&t,k,p1|2PQ&v!^Q's!xS(o#u:sQ+f%xQ,T&[Q,U&^Q-b'aQ-o'lS.j(t;eS0f+R;oQ0s+gQ1`,SQ2T,rQ2V,sQ2_-OQ2l-cQ2o-gS4r0g;yQ4x0tS4{0v;zQ6[2aQ6`2mQ6e2tQ7m4yQ8i6^Q8j6aQ8m6fR9p8f$d$^c#Y#e%q%s(O(U(p(u(})O)P)Q)R)S)T)U)V)W)X)Z)])c)m+^+r-R-p-u-z-|.k.n.r.u.v/X0e2]2`2p2w3]3b3c3d3e3f3g3h3i3j3k3l3m3n3q3r3y4q4z6]6c6h6w6x7R7S7z8h8l8v8|8}9s:T:[:m<ZS(k#p'fQ({#zS+[%o.tS.Z(j(lR3O.['OkOPWXYZstuvw!Z!`!g!o#S#W#Z#d#o#u#x#{$O$P$Q$R$S$T$U$V$W$X$Y$[$`$e$n%k%r&P&h&k&l&o&q&r&t&x'Q'U'_'o(P(R(X(`(t(v(z)o)z+R+V+a,h,k,p,|-P-a-i-w-}._.l.s.}/f0a0g0v1d1t1u1w1y1|2P2R2b2r2x3U3^3u5_5a5k5{5|6P6Z6d6r8O8T8d8n9`9q:k:n:o:r:s:t:u:v:w:x:y:z:{:|:};O;P;T;b;d;e;g;o;p;y;z<gS#q]:lQ&q!XQ&r!YQ&t![Q&u!]R1{,nQ'^!hQ+_%uQ-`'`S.](m+bQ2j-_W3S.`.a0l0nQ6_2kW6l3P3R3V4vU8p6m6o6qU9u8r8s8uS:^9t9wQ:f:_R:i:gU!wQ']-]T5b1a5d!Q_OXZ`st!V!Z#d#h%c%k&f&h&o&q&r&t(f,k,p.S1|2P]!pQ!r']-]1a5dT#q]:l%[{OPWXYZstuvw!Z!`!g!o#S#W#Z#d#o#u#x#{$O$P$Q$R$S$T$U$V$W$X$Y$`$e%k%r&P&h&k&l&o&q&r&t&x'Q'_'o(P(R(X(`(t(v(z)z+R+V+a,h,k,p-a-i-w-}._.l.s/f0a0g0v1d1t1u1w1y1|2P2R2r2x3U3^5a5k5{5|6P6d6r8O8T8d8nS(y#y#zS.Y(i(j!s<Q$[$n'U)o,|-P.}2b3u5_6Z9`9q:k:n:o:r:s:t:u:v:w:x:y:z:{:|:};O;P;T;b;d;e;g;o;p;y;z<gU$fd)[,eS(l#p'fU*r%S(s3pU0b*x.f6}Q4v0mQ6m3QQ8s6pR9w8tm!tQ!r!v!y!z']'i'j'k-]-m1a5d5fQ'q!uS(b#g1vS-k'h'tQ/k*YQ/w*eQ2v-nQ4U/lS4_/x0SQ7X4PS7d4e4gQ9R7YR9Y7gQ#wbQ'p!uS(a#g1vS(c#m+QQ+S%dQ+d%vQ+j%|U-j'h'q'tQ.O(bQ/j*YQ/v*eQ/|*hQ0r+eQ1g,XS2s-k-nQ2{.WS4T/k/lS4^/w0SQ4a/{Q4c/}Q5n1hQ6g2vQ7W4PQ7[4US7`4_4gQ7e4fQ8V5oS9Q7X7YQ9U7aQ9W7dQ9g8WQ9}9RQ:O9VQ:Q9YQ:Y9hQ:b:PQ<T<OQ<`<XR<a<YV!wQ']-]%[aOPWXYZstuvw!Z!`!g!o#S#W#Z#d#o#u#x#{$O$P$Q$R$S$T$U$V$W$X$Y$`$e%k%r&P&h&k&l&o&q&r&t&x'Q'_'o(P(R(X(`(t(v(z)z+R+V+a,h,k,p-a-i-w-}._.l.s/f0a0g0v1d1t1u1w1y1|2P2R2r2x3U3^5a5k5{5|6P6d6r8O8T8d8nS#wz!j!r;}$[$n'U)o,|-P.}2b3u5_6Z9`9q:k:n:o:r:s:t:u:v:w:x:y:z:{:|:};O;P;T;b;d;e;g;o;p;y;z<gR<T<f%[bOPWXYZstuvw!Z!`!g!o#S#W#Z#d#o#u#x#{$O$P$Q$R$S$T$U$V$W$X$Y$`$e%k%r&P&h&k&l&o&q&r&t&x'Q'_'o(P(R(X(`(t(v(z)z+R+V+a,h,k,p-a-i-w-}._.l.s/f0a0g0v1d1t1u1w1y1|2P2R2r2x3U3^5a5k5{5|6P6d6r8O8T8d8nQ%dj!S%vy!i!u%y%z%{'S'b'c'd'h'r*e+h+i-Q-d-e-l/y0u2g2n2u4dS%|z!jQ+e%wQ,X&aW1h,Y,Z,[,]U5o1i1j1kS8W5p5qQ9h8X!r<O$[$n'U)o,|-P.}2b3u5_6Z9`9q:k:n:o:r:s:t:u:v:w:x:y:z:{:|:};O;P;T;b;d;e;g;o;p;y;z<gQ<X<eR<Y<f%OeOPXYstuvw!Z!`!g!o#S#d#o#u#x#{$O$P$Q$R$S$T$U$V$W$X$Y$`$e%k%r&P&h&k&o&q&r&t&x'Q'_'o(R(X(`(t(v(z)z+R+V+a,h,k,p-a-i-w-}._.l.s/f0a0g0v1d1t1u1w1y1|2P2R2r2x3U3^5a5k5{5|6P6d6r8O8T8d8nY#bWZ#W#Z(P!b%hm#h#i#l$y%c%f(Y(d(e(f*V*Z*^+T+U+W,g,}-{.R.S.T.V/e/h2U2|2}4Q6Y6kQ,f&l!p<P$[$n)o,|-P.}2b3u5_6Z9`9q:k:n:o:r:s:t:u:v:w:x:y:z:{:|:};O;P;T;b;d;e;g;o;p;y;z<gR<S'UU'Y!e%g*WR2e-W%QdOPWXYZstuvw!Z!`!g!o#S#W#Z#d#o#u#x#{$O$P$Q$R$S$T$U$V$W$X$Y$`$e%k%r&P&h&k&o&q&r&t&x'Q'_'o(P(R(X(`(t(v(z)z+R+V,h,k,p-a-i-w-}.l.s/f0a0g0v1d1t1u1w1y1|2P2R2r2x3^5a5k5{5|6P6d8O8T8d8n!r)[$[$n'U)o,|-P.}2b3u5_6Z9`9q:k:n:o:r:s:t:u:v:w:x:y:z:{:|:};O;P;T;b;d;e;g;o;p;y;z<gQ,e&lQ0m+aQ3Q._Q6p3UR8t6r!b$Uc#Y%o(O(U(p(u)W)X)])c+r-p-u-z-|.k.n/X0e2p2w3]3n4q4z6c6h6w8l9s:m!P:z)Z)m-R.t2]2`3b3l3m3q3y6]6x7R7S7z8h8v8|8}:T:[<Z!f$Wc#Y%o(O(U(p(u)T)U)W)X)])c+r-p-u-z-|.k.n/X0e2p2w3]3n4q4z6c6h6w8l9s:m!T:|)Z)m-R.t2]2`3b3i3j3l3m3q3y6]6x7R7S7z8h8v8|8}:T:[<Z!^$[c#Y%o(O(U(p(u)])c+r-p-u-z-|.k.n/X0e2p2w3]3n4q4z6c6h6w8l9s:mQ3}/cz<g)Z)m-R.t2]2`3b3q3y6]6x7R7S7z8h8v8|8}:T:[<ZQ<l<nR<m<o'OkOPWXYZstuvw!Z!`!g!o#S#W#Z#d#o#u#x#{$O$P$Q$R$S$T$U$V$W$X$Y$[$`$e$n%k%r&P&h&k&l&o&q&r&t&x'Q'U'_'o(P(R(X(`(t(v(z)o)z+R+V+a,h,k,p,|-P-a-i-w-}._.l.s.}/f0a0g0v1d1t1u1w1y1|2P2R2b2r2x3U3^3u5_5a5k5{5|6P6Z6d6r8O8T8d8n9`9q:k:n:o:r:s:t:u:v:w:x:y:z:{:|:};O;P;T;b;d;e;g;o;p;y;z<gS$oh$pR3v.|'VgOPWXYZhstuvw!Z!`!g!o#S#W#Z#d#o#u#x#{$O$P$Q$R$S$T$U$V$W$X$Y$[$`$e$n$p%k%r&P&h&k&l&o&q&r&t&x'Q'U'_'o(P(R(X(`(t(v(z)o)z+R+V+a,h,k,p,|-P-a-i-w-}._.l.s.|.}/f0a0g0v1d1t1u1w1y1|2P2R2b2r2x3U3^3u5_5a5k5{5|6P6Z6d6r8O8T8d8n9`9q:k:n:o:r:s:t:u:v:w:x:y:z:{:|:};O;P;T;b;d;e;g;o;p;y;z<gT$kf$qQ$ifS)f$l)jR)r$qT$jf$qT)h$l)j'VhOPWXYZhstuvw!Z!`!g!o#S#W#Z#d#o#u#x#{$O$P$Q$R$S$T$U$V$W$X$Y$[$`$e$n$p%k%r&P&h&k&l&o&q&r&t&x'Q'U'_'o(P(R(X(`(t(v(z)o)z+R+V+a,h,k,p,|-P-a-i-w-}._.l.s.|.}/f0a0g0v1d1t1u1w1y1|2P2R2b2r2x3U3^3u5_5a5k5{5|6P6Z6d6r8O8T8d8n9`9q:k:n:o:r:s:t:u:v:w:x:y:z:{:|:};O;P;T;b;d;e;g;o;p;y;z<gT$oh$pQ$rhR)q$p%[jOPWXYZstuvw!Z!`!g!o#S#W#Z#d#o#u#x#{$O$P$Q$R$S$T$U$V$W$X$Y$`$e%k%r&P&h&k&l&o&q&r&t&x'Q'_'o(P(R(X(`(t(v(z)z+R+V+a,h,k,p-a-i-w-}._.l.s/f0a0g0v1d1t1u1w1y1|2P2R2r2x3U3^5a5k5{5|6P6d6r8O8T8d8n!s<e$[$n'U)o,|-P.}2b3u5_6Z9`9q:k:n:o:r:s:t:u:v:w:x:y:z:{:|:};O;P;T;b;d;e;g;o;p;y;z<g#elOPXZst!Z!`!o#S#d#o#{$n%k&h&k&l&o&q&r&t&x'Q'_(z)o+V+a,h,k,p-a._.}/f0a1d1t1u1w1y1|2P2R3U3u5a5k5{5|6P6r8O8T8d!O%Si$d%P%R%]%^%b*O*Q*]*s*t.w/o0V0X0d3}4l9P<d<l<m#[(s#v$b$c$y$|)v)|*S*V*c+`+c+z+}.^/]/e/p/r1W1Z1c3T4Y4b4t4w5j6n7]7f8Q8q9d9v:W:`;U;W;[;^;`;h;j;m;q;s;u;w;{<p<qQ*}%`Q/Y){o3p;R;S;V;X;];_;a;i;k;n;r;t;v;x;|!O$zi$d%P%R%]%^%b*O*Q*]*s*t.w/o0V0X0d3}4l9P<d<l<mQ*_${U*h$}*W*kQ+O%aQ/}*i#[<V#v$b$c$y$|)v)|*S*V*c+`+c+z+}.^/]/e/p/r1W1Z1c3T4Y4b4t4w5j6n7]7f8Q8q9d9v:W:`;U;W;[;^;`;h;j;m;q;s;u;w;{<p<qn<W;R;S;V;X;];_;a;i;k;n;r;t;v;x;|Q<[<hQ<]<iQ<^<jR<_<k!O%Si$d%P%R%]%^%b*O*Q*]*s*t.w/o0V0X0d3}4l9P<d<l<m#[(s#v$b$c$y$|)v)|*S*V*c+`+c+z+}.^/]/e/p/r1W1Z1c3T4Y4b4t4w5j6n7]7f8Q8q9d9v:W:`;U;W;[;^;`;h;j;m;q;s;u;w;{<p<qo3p;R;S;V;X;];_;a;i;k;n;r;t;v;x;|noOXst!Z#d%k&o&q&r&t,k,p1|2PS*b$|*VQ,y&{Q,z&}R4X/p$z%Ti#v$b$c$d$y$|%P%R%]%^%b)v)|*O*Q*S*V*]*c*s*t+`+c+z+}.^.w/]/e/o/p/r0V0X0d1W1Z1c3T3}4Y4b4l4t4w5j6n7]7f8Q8q9P9d9v:W:`;R;S;U;V;W;X;[;];^;_;`;a;h;i;j;k;m;n;q;r;s;t;u;v;w;x;{;|<d<l<m<p<qQ+|&YQ1Y,OQ5Z1XR7w5[V*j$}*W*kU*j$}*W*kT5c1a5dU/{*g/f5aT4f0T8OQ+d%vQ/|*hQ0r+eQ1g,XQ5n1hQ8V5oQ9g8WR:Y9h!O%Pi$d%P%R%]%^%b*O*Q*]*s*t.w/o0V0X0d3}4l9P<d<l<mr*O$w)a*P*q+P/n0Z0[3s4V4p7V7h9|<U<b<cS0V*p0W#[;U#v$b$c$y$|)v)|*S*V*c+`+c+z+}.^/]/e/p/r1W1Z1c3T4Y4b4t4w5j6n7]7f8Q8q9d9v:W:`;U;W;[;^;`;h;j;m;q;s;u;w;{<p<qn;V;R;S;V;X;];_;a;i;k;n;r;t;v;x;|!^;h(q)_*X*a.b.e.i/U/Z/c/s0k1V1X3Y4W4[5Y5[6s6v7^7b7j7l9T9X:a<n<o`;i3o6y6|7Q8w9x9{:jS;s.d3ZT;t6{8z!O%Ri$d%P%R%]%^%b*O*Q*]*s*t.w/o0V0X0d3}4l9P<d<l<mv*Q$w)a*R*p+P/_/n0Z0[3s4V4h4p7V7h9|<U<b<cS0X*q0Y#[;W#v$b$c$y$|)v)|*S*V*c+`+c+z+}.^/]/e/p/r1W1Z1c3T4Y4b4t4w5j6n7]7f8Q8q9d9v:W:`;U;W;[;^;`;h;j;m;q;s;u;w;{<p<qn;X;R;S;V;X;];_;a;i;k;n;r;t;v;x;|!b;j(q)_*X*a.c.d.i/U/Z/c/s0k1V1X3W3Y4W4[5Y5[6s6t6v7^7b7j7l9T9X:a<n<od;k3o6z6{7Q8w8x9x9y9{:jS;u.e3[T;v6|8{rnOXst!V!Z#d%k&f&o&q&r&t,k,p1|2PQ&c!UR,h&lrnOXst!V!Z#d%k&f&o&q&r&t,k,p1|2PR&c!UQ,Q&ZR1U+ysnOXst!V!Z#d%k&f&o&q&r&t,k,p1|2PQ1b,VS5i1e1fU8P5g5h5lS9c8R8SS:U9b9eQ:c:VR:h:dQ&j!VR,a&fR5u1nS&O|&TR0}+pQ&o!WR,k&pR,q&uT1},p2PR,u&vQ,t&vR2W,uQ'v!{R-q'vSsOtQ#dXT%ns#dQ#OTR'x#OQ#RUR'z#RQ)x$vR/V)xQ#UVR'|#UQ#XWU(S#X(T-xQ(T#YR-x(UQ-U'VR2d-UQ.m(uS3_.m3`R3`.nQ-]']R2h-]Y!rQ']-]1a5dR'g!rQ.x)aR3t.xU#_W%f*VU(Z#_([-yQ([#`R-y(VQ-X'YR2f-Xt`OXst!V!Z#d%k&f&h&o&q&r&t,k,p1|2PS#hZ%cU#r`#h.SR.S(fQ(g#jQ.P(cW.X(g.P2y6iQ2y.QR6i2zQ)j$lR/O)jQ$phR)p$pQ$acU)^$a-t;QQ-t:mR;Q)mQ/i*YW4R/i4S7Z9SU4S/j/k/lS7Z4T4UR9S7[$X)}$w(q)_)a*X*a*p*q*z*{+P.d.e.g.h.i/U/Z/_/a/c/n/s0Z0[0k1V1X3W3X3Y3o3s4V4W4[4h4j4p5Y5[6s6t6u6v6{6|7O7P7Q7V7^7b7h7j7l8w8x8y9T9X9x9y9z9{9|:a:j<U<b<c<n<oQ/q*aU4Z/q4]7_Q4]/sR7_4[S*k$}*WR0P*kr*P$w)a*p*q+P/n0Z0[3s4V4p7V7h9|<U<b<c!^.b(q)_*X*a.d.e.i/U/Z/c/s0k1V1X3Y4W4[5Y5[6s6v7^7b7j7l9T9X:a<n<oU/`*P.b6ya6y3o6{6|7Q8w9x9{:jQ0W*pQ3Z.dU4i0W3Z8zR8z6{v*R$w)a*p*q+P/_/n0Z0[3s4V4h4p7V7h9|<U<b<c!b.c(q)_*X*a.d.e.i/U/Z/c/s0k1V1X3W3Y4W4[5Y5[6s6t6v7^7b7j7l9T9X:a<n<oU/b*R.c6ze6z3o6{6|7Q8w8x9x9y9{:jQ0Y*qQ3[.eU4k0Y3[8{R8{6|Q*v%VR0^*vQ4u0kR7k4uQ+X%iR0j+XQ5^1[S7y5^9aR9a7zQ,S&[R1_,SQ5d1aR7|5dQ1m,^S5s1m8ZR8Z5uQ0x+lW5P0x5R7q9]Q5R0{Q7q5QR9]7rQ+q&OR1O+qQ2P,pR6T2PYrOXst#dQ&s!ZQ+Z%kQ,j&oQ,l&qQ,m&rQ,o&tQ1z,kS1},p2PR6S1|Q%mpQ&w!_Q&z!aQ&|!bQ'O!cQ'n!uQ+Y%jQ+f%xQ+x&UQ,`&jQ,w&yW-h'h'p'q'tQ-o'lQ0O*jQ0s+gS1p,a,dQ2X,vQ2Y,yQ2Z,zQ2o-gW2q-j-k-n-pQ4x0tQ5U1RQ5X1VQ5m1gQ5w1rQ6R1{U6b2p2s2vQ6e2tQ7m4yQ7u5WQ7v5YQ7{5cQ8U5nQ8[5vS8k6c6gQ8m6fQ9^7sQ9f8VQ9k8]Q9r8lQ:S9_Q:X9gQ:]9sR:e:YQ%xyQ'a!iQ'l!uU+g%y%z%{Q-O'SU-c'b'c'dS-g'h'rQ/u*eS0t+h+iQ2a-QS2m-d-eQ2t-lQ4`/yQ4y0uQ6^2gQ6a2nQ6f2uR7c4dS$xi<dR*w%WU%Vi%W<dR0]*uQ$wiS(q#v+cS)_$b$cQ)a$dQ*X$yS*a$|*VQ*p%PQ*q%RQ*z%]Q*{%^Q+P%bQ.d;UQ.e;WQ.g;[Q.h;^Q.i;`Q/U)vS/Z)|/]Q/_*OQ/a*QQ/c*SQ/n*]S/s*c/eQ0Z*sQ0[*th0k+`.^1c3T5j6n8Q8q9d9v:W:`Q1V+zQ1X+}Q3W;hQ3X;jQ3Y;mS3o;R;SQ3s.wQ4V/oQ4W/pQ4[/rQ4h0VQ4j0XQ4p0dQ5Y1WQ5[1ZQ6s;qQ6t;sQ6u;uQ6v;wQ6{;VQ6|;XQ7O;]Q7P;_Q7Q;aQ7V3}Q7^4YQ7b4bQ7h4lQ7j4tQ7l4wQ8w;nQ8x;iQ8y;kQ9T7]Q9X7fQ9x;rQ9y;tQ9z;vQ9{;xQ9|9PQ:a;{Q:j;|Q<U<dQ<b<lQ<c<mQ<n<pR<o<qQ*x%[Q.f;YR6};ZnpOXst!Z#d%k&o&q&r&t,k,p1|2PQ!fPS#fZ#oQ&y!`U'e!o5a8OQ'{#SQ(|#{Q)n$nS,d&h&kQ,i&lQ,v&xQ,{'QQ-_'_Q.p(zQ/S)oS0h+V/fQ0n+aQ1x,hQ2k-aQ3R._Q3x.}Q4n0aQ5h1dQ5y1tQ5z1uQ6O1wQ6Q1yQ6V2RQ6q3UQ7T3uQ8S5kQ8`5{Q8a5|Q8c6PQ8u6rQ9e8TR9o8d#YcOPXZst!Z!`!o#d#o#{%k&h&k&l&o&q&r&t&x'Q'_(z+V+a,h,k,p-a._/f0a1d1t1u1w1y1|2P2R3U5a5k5{5|6P6r8O8T8dQ#YWQ#eYQ%ouQ%qvS%sw!gS(O#W(RQ(U#ZQ(p#uQ(u#xQ(}$OQ)O$PQ)P$QQ)Q$RQ)R$SQ)S$TQ)T$UQ)U$VQ)V$WQ)W$XQ)X$YQ)Z$[Q)]$`Q)c$eW)m$n)o.}3uQ+^%rQ+r&PS-R'U2bQ-p'oS-u(P-wQ-z(XQ-|(`Q.k(tQ.n(vQ.r:kQ.t:nQ.u:oQ.v:rQ/X)zQ0e+RQ2],|Q2`-PQ2p-iQ2w-}Q3].lQ3b:sQ3c:tQ3d:uQ3e:vQ3f:wQ3g:xQ3h:yQ3i:zQ3j:{Q3k:|Q3l:}Q3m;OQ3n.sQ3q;TQ3r;bQ3y;PQ4q0gQ4z0vQ6];dQ6c2rQ6h2xQ6w3^Q6x;eQ7R;gQ7S;oQ7z5_Q8h6ZQ8l6dQ8v;pQ8|;yQ8};zQ9s8nQ:T9`Q:[9qQ:m#SR<Z<gR#[WR'W!el!tQ!r!v!y!z']'i'j'k-]-m1a5d5fS'S!e-TS-Q'T'[R2g-ZR(w#xQ!fQT-[']-]]!qQ!r']-]1a5dQ#p]R'f:lR)b$dY!uQ']-]1a5dQ'h!rS'r!v!yS't!z5fS-l'i'jQ-n'kR2u-mT#kZ%cS#jZ%cS%im,gU(c#h#i#lS.Q(d(eQ.U(fQ0i+WQ2z.RU2{.S.T.VS6j2|2}R8o6kd#^W#W#Z%f(P(Y*V+T-{/er#gZm#h#i#l%c(d(e(f+W.R.S.T.V2|2}6kS*Y$y*^Q/l*ZQ1v,gQ2^,}Q4P/hQ6X2UQ7Y4QQ8g6YT<R'U+UV#aW%f*VU#`W%f*VS(Q#W(YU(V#Z+T/eS-S'U+UT-v(P-{V'Z!e%g*WQ$lfR)t$qT)i$l)jR3w.|T*[$y*^T*d$|*VQ0l+`Q3P.^Q5g1cQ6o3TQ8R5jQ8r6nQ9b8QQ9t8qQ:V9dQ:_9vQ:d:WR:g:`nqOXst!Z#d%k&o&q&r&t,k,p1|2PQ&i!VR,`&ftmOXst!U!V!Z#d%k&f&o&q&r&t,k,p1|2PR,g&lT%jm,gR1],PR,_&dQ&S|R+w&TR+m%}T&m!W&pT&n!W&pT2O,p2P",
  nodeNames: "⚠ ArithOp ArithOp ?. JSXStartTag LineComment BlockComment Script Hashbang ExportDeclaration export Star as VariableName String Escape from ; default FunctionDeclaration async function VariableDefinition > < TypeParamList TypeDefinition extends ThisType this LiteralType ArithOp Number BooleanLiteral TemplateType InterpolationEnd Interpolation InterpolationStart NullType null VoidType void TypeofType typeof MemberExpression . PropertyName [ TemplateString Escape Interpolation super RegExp ] ArrayExpression Spread , } { ObjectExpression Property async get set PropertyDefinition Block : NewTarget new NewExpression ) ( ArgList UnaryExpression delete LogicOp BitOp YieldExpression yield AwaitExpression await ParenthesizedExpression ClassExpression class ClassBody MethodDeclaration Decorator @ MemberExpression PrivatePropertyName CallExpression TypeArgList CompareOp < declare Privacy static abstract override PrivatePropertyDefinition PropertyDeclaration readonly accessor Optional TypeAnnotation Equals StaticBlock FunctionExpression ArrowFunction ParamList ParamList ArrayPattern ObjectPattern PatternProperty Privacy readonly Arrow MemberExpression BinaryExpression ArithOp ArithOp ArithOp ArithOp BitOp CompareOp instanceof satisfies in const CompareOp BitOp BitOp BitOp LogicOp LogicOp ConditionalExpression LogicOp LogicOp AssignmentExpression UpdateOp PostfixExpression CallExpression InstantiationExpression TaggedTemplateExpression DynamicImport import ImportMeta JSXElement JSXSelfCloseEndTag JSXSelfClosingTag JSXIdentifier JSXBuiltin JSXIdentifier JSXNamespacedName JSXMemberExpression JSXSpreadAttribute JSXAttribute JSXAttributeValue JSXEscape JSXEndTag JSXOpenTag JSXFragmentTag JSXText JSXEscape JSXStartCloseTag JSXCloseTag PrefixCast ArrowFunction TypeParamList SequenceExpression InstantiationExpression KeyofType keyof UniqueType unique ImportType InferredType infer TypeName ParenthesizedType FunctionSignature ParamList NewSignature IndexedType TupleType Label ArrayType ReadonlyType ObjectType MethodType PropertyType IndexSignature PropertyDefinition CallSignature TypePredicate is NewSignature new UnionType LogicOp IntersectionType LogicOp ConditionalType ParameterizedType ClassDeclaration abstract implements type VariableDeclaration let var using TypeAliasDeclaration InterfaceDeclaration interface EnumDeclaration enum EnumBody NamespaceDeclaration namespace module AmbientDeclaration declare GlobalDeclaration global ClassDeclaration ClassBody AmbientFunctionDeclaration ExportGroup VariableName VariableName ImportDeclaration ImportGroup ForStatement for ForSpec ForInSpec ForOfSpec of WhileStatement while WithStatement with DoStatement do IfStatement if else SwitchStatement switch SwitchBody CaseLabel case DefaultLabel TryStatement try CatchClause catch FinallyClause finally ReturnStatement return ThrowStatement throw BreakStatement break ContinueStatement continue DebuggerStatement debugger LabeledStatement ExpressionStatement SingleExpression SingleClassItem",
  maxTerm: 376,
  context: p7,
  nodeProps: [
    ["isolate", -8, 5, 6, 14, 34, 36, 48, 50, 52, ""],
    ["group", -26, 9, 17, 19, 65, 204, 208, 212, 213, 215, 218, 221, 231, 233, 239, 241, 243, 245, 248, 254, 260, 262, 264, 266, 268, 270, 271, "Statement", -34, 13, 14, 29, 32, 33, 39, 48, 51, 52, 54, 59, 67, 69, 73, 77, 79, 81, 82, 107, 108, 117, 118, 135, 138, 140, 141, 142, 143, 144, 146, 147, 166, 167, 169, "Expression", -23, 28, 30, 34, 38, 40, 42, 171, 173, 175, 176, 178, 179, 180, 182, 183, 184, 186, 187, 188, 198, 200, 202, 203, "Type", -3, 85, 100, 106, "ClassItem"],
    ["openedBy", 23, "<", 35, "InterpolationStart", 53, "[", 57, "{", 70, "(", 159, "JSXStartCloseTag"],
    ["closedBy", 24, ">", 37, "InterpolationEnd", 47, "]", 58, "}", 71, ")", 164, "JSXEndTag"]
  ],
  propSources: [y7],
  skippedNodes: [0, 5, 6, 274],
  repeatNodeCount: 37,
  tokenData: "$Fq07[R!bOX%ZXY+gYZ-yZ[+g[]%Z]^.c^p%Zpq+gqr/mrs3cst:_tuEruvJSvwLkwx! Yxy!'iyz!(sz{!)}{|!,q|}!.O}!O!,q!O!P!/Y!P!Q!9j!Q!R#:O!R![#<_![!]#I_!]!^#Jk!^!_#Ku!_!`$![!`!a$$v!a!b$*T!b!c$,r!c!}Er!}#O$-|#O#P$/W#P#Q$4o#Q#R$5y#R#SEr#S#T$7W#T#o$8b#o#p$<r#p#q$=h#q#r$>x#r#s$@U#s$f%Z$f$g+g$g#BYEr#BY#BZ$A`#BZ$ISEr$IS$I_$A`$I_$I|Er$I|$I}$Dk$I}$JO$Dk$JO$JTEr$JT$JU$A`$JU$KVEr$KV$KW$A`$KW&FUEr&FU&FV$A`&FV;'SEr;'S;=`I|<%l?HTEr?HT?HU$A`?HUOEr(n%d_$h&j(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z&j&hT$h&jO!^&c!_#o&c#p;'S&c;'S;=`&w<%lO&c&j&zP;=`<%l&c'|'U]$h&j(U!bOY&}YZ&cZw&}wx&cx!^&}!^!_'}!_#O&}#O#P&c#P#o&}#o#p'}#p;'S&};'S;=`(l<%lO&}!b(SU(U!bOY'}Zw'}x#O'}#P;'S'};'S;=`(f<%lO'}!b(iP;=`<%l'}'|(oP;=`<%l&}'[(y]$h&j(RpOY(rYZ&cZr(rrs&cs!^(r!^!_)r!_#O(r#O#P&c#P#o(r#o#p)r#p;'S(r;'S;=`*a<%lO(rp)wU(RpOY)rZr)rs#O)r#P;'S)r;'S;=`*Z<%lO)rp*^P;=`<%l)r'[*dP;=`<%l(r#S*nX(Rp(U!bOY*gZr*grs'}sw*gwx)rx#O*g#P;'S*g;'S;=`+Z<%lO*g#S+^P;=`<%l*g(n+dP;=`<%l%Z07[+rq$h&j(Rp(U!b'w0/lOX%ZXY+gYZ&cZ[+g[p%Zpq+gqr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p$f%Z$f$g+g$g#BY%Z#BY#BZ+g#BZ$IS%Z$IS$I_+g$I_$JT%Z$JT$JU+g$JU$KV%Z$KV$KW+g$KW&FU%Z&FU&FV+g&FV;'S%Z;'S;=`+a<%l?HT%Z?HT?HU+g?HUO%Z07[.ST(S#S$h&j'x0/lO!^&c!_#o&c#p;'S&c;'S;=`&w<%lO&c07[.n_$h&j(Rp(U!b'x0/lOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z)3p/x`$h&j!m),Q(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_!`0z!`#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z(KW1V`#u(Ch$h&j(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_!`2X!`#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z(KW2d_#u(Ch$h&j(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z'At3l_(Q':f$h&j(U!bOY4kYZ5qZr4krs7nsw4kwx5qx!^4k!^!_8p!_#O4k#O#P5q#P#o4k#o#p8p#p;'S4k;'S;=`:X<%lO4k(^4r_$h&j(U!bOY4kYZ5qZr4krs7nsw4kwx5qx!^4k!^!_8p!_#O4k#O#P5q#P#o4k#o#p8p#p;'S4k;'S;=`:X<%lO4k&z5vX$h&jOr5qrs6cs!^5q!^!_6y!_#o5q#o#p6y#p;'S5q;'S;=`7h<%lO5q&z6jT$c`$h&jO!^&c!_#o&c#p;'S&c;'S;=`&w<%lO&c`6|TOr6yrs7]s;'S6y;'S;=`7b<%lO6y`7bO$c``7eP;=`<%l6y&z7kP;=`<%l5q(^7w]$c`$h&j(U!bOY&}YZ&cZw&}wx&cx!^&}!^!_'}!_#O&}#O#P&c#P#o&}#o#p'}#p;'S&};'S;=`(l<%lO&}!r8uZ(U!bOY8pYZ6yZr8prs9hsw8pwx6yx#O8p#O#P6y#P;'S8p;'S;=`:R<%lO8p!r9oU$c`(U!bOY'}Zw'}x#O'}#P;'S'};'S;=`(f<%lO'}!r:UP;=`<%l8p(^:[P;=`<%l4k%9[:hh$h&j(Rp(U!bOY%ZYZ&cZq%Zqr<Srs&}st%ZtuCruw%Zwx(rx!^%Z!^!_*g!_!c%Z!c!}Cr!}#O%Z#O#P&c#P#R%Z#R#SCr#S#T%Z#T#oCr#o#p*g#p$g%Z$g;'SCr;'S;=`El<%lOCr(r<__WS$h&j(Rp(U!bOY<SYZ&cZr<Srs=^sw<Swx@nx!^<S!^!_Bm!_#O<S#O#P>`#P#o<S#o#pBm#p;'S<S;'S;=`Cl<%lO<S(Q=g]WS$h&j(U!bOY=^YZ&cZw=^wx>`x!^=^!^!_?q!_#O=^#O#P>`#P#o=^#o#p?q#p;'S=^;'S;=`@h<%lO=^&n>gXWS$h&jOY>`YZ&cZ!^>`!^!_?S!_#o>`#o#p?S#p;'S>`;'S;=`?k<%lO>`S?XSWSOY?SZ;'S?S;'S;=`?e<%lO?SS?hP;=`<%l?S&n?nP;=`<%l>`!f?xWWS(U!bOY?qZw?qwx?Sx#O?q#O#P?S#P;'S?q;'S;=`@b<%lO?q!f@eP;=`<%l?q(Q@kP;=`<%l=^'`@w]WS$h&j(RpOY@nYZ&cZr@nrs>`s!^@n!^!_Ap!_#O@n#O#P>`#P#o@n#o#pAp#p;'S@n;'S;=`Bg<%lO@ntAwWWS(RpOYApZrAprs?Ss#OAp#O#P?S#P;'SAp;'S;=`Ba<%lOAptBdP;=`<%lAp'`BjP;=`<%l@n#WBvYWS(Rp(U!bOYBmZrBmrs?qswBmwxApx#OBm#O#P?S#P;'SBm;'S;=`Cf<%lOBm#WCiP;=`<%lBm(rCoP;=`<%l<S%9[C}i$h&j(j%1l(Rp(U!bOY%ZYZ&cZr%Zrs&}st%ZtuCruw%Zwx(rx!Q%Z!Q![Cr![!^%Z!^!_*g!_!c%Z!c!}Cr!}#O%Z#O#P&c#P#R%Z#R#SCr#S#T%Z#T#oCr#o#p*g#p$g%Z$g;'SCr;'S;=`El<%lOCr%9[EoP;=`<%lCr07[FRk$h&j(Rp(U!b$[#t(O,2j(`$I[OY%ZYZ&cZr%Zrs&}st%ZtuEruw%Zwx(rx}%Z}!OGv!O!Q%Z!Q![Er![!^%Z!^!_*g!_!c%Z!c!}Er!}#O%Z#O#P&c#P#R%Z#R#SEr#S#T%Z#T#oEr#o#p*g#p$g%Z$g;'SEr;'S;=`I|<%lOEr+dHRk$h&j(Rp(U!b$[#tOY%ZYZ&cZr%Zrs&}st%ZtuGvuw%Zwx(rx}%Z}!OGv!O!Q%Z!Q![Gv![!^%Z!^!_*g!_!c%Z!c!}Gv!}#O%Z#O#P&c#P#R%Z#R#SGv#S#T%Z#T#oGv#o#p*g#p$g%Z$g;'SGv;'S;=`Iv<%lOGv+dIyP;=`<%lGv07[JPP;=`<%lEr(KWJ_`$h&j(Rp(U!b#m(ChOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_!`Ka!`#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z(KWKl_$h&j$P(Ch(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z,#xLva(u+JY$h&j(Rp(U!bOY%ZYZ&cZr%Zrs&}sv%ZvwM{wx(rx!^%Z!^!_*g!_!`Ka!`#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z(KWNW`$h&j#y(Ch(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_!`Ka!`#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z'At! c_(T';W$h&j(RpOY!!bYZ!#hZr!!brs!#hsw!!bwx!$xx!^!!b!^!_!%z!_#O!!b#O#P!#h#P#o!!b#o#p!%z#p;'S!!b;'S;=`!'c<%lO!!b'l!!i_$h&j(RpOY!!bYZ!#hZr!!brs!#hsw!!bwx!$xx!^!!b!^!_!%z!_#O!!b#O#P!#h#P#o!!b#o#p!%z#p;'S!!b;'S;=`!'c<%lO!!b&z!#mX$h&jOw!#hwx6cx!^!#h!^!_!$Y!_#o!#h#o#p!$Y#p;'S!#h;'S;=`!$r<%lO!#h`!$]TOw!$Ywx7]x;'S!$Y;'S;=`!$l<%lO!$Y`!$oP;=`<%l!$Y&z!$uP;=`<%l!#h'l!%R]$c`$h&j(RpOY(rYZ&cZr(rrs&cs!^(r!^!_)r!_#O(r#O#P&c#P#o(r#o#p)r#p;'S(r;'S;=`*a<%lO(r!Q!&PZ(RpOY!%zYZ!$YZr!%zrs!$Ysw!%zwx!&rx#O!%z#O#P!$Y#P;'S!%z;'S;=`!']<%lO!%z!Q!&yU$c`(RpOY)rZr)rs#O)r#P;'S)r;'S;=`*Z<%lO)r!Q!'`P;=`<%l!%z'l!'fP;=`<%l!!b/5|!'t_!i/.^$h&j(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z#&U!)O_!h!Lf$h&j(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z-!n!*[b$h&j(Rp(U!b(P%&f#n(ChOY%ZYZ&cZr%Zrs&}sw%Zwx(rxz%Zz{!+d{!^%Z!^!_*g!_!`Ka!`#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z(KW!+o`$h&j(Rp(U!b#k(ChOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_!`Ka!`#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z+;x!,|`$h&j(Rp(U!bo+4YOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_!`Ka!`#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z,$U!.Z_!Y+Jf$h&j(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z07[!/ec$h&j(Rp(U!b}.2^OY%ZYZ&cZr%Zrs&}sw%Zwx(rx!O%Z!O!P!0p!P!Q%Z!Q![!3Y![!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z#%|!0ya$h&j(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!O%Z!O!P!2O!P!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z#%|!2Z_!X!L^$h&j(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z'Ad!3eg$h&j(Rp(U!bp'9tOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!Q%Z!Q![!3Y![!^%Z!^!_*g!_!g%Z!g!h!4|!h#O%Z#O#P&c#P#R%Z#R#S!3Y#S#X%Z#X#Y!4|#Y#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z'Ad!5Vg$h&j(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx{%Z{|!6n|}%Z}!O!6n!O!Q%Z!Q![!8S![!^%Z!^!_*g!_#O%Z#O#P&c#P#R%Z#R#S!8S#S#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z'Ad!6wc$h&j(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!Q%Z!Q![!8S![!^%Z!^!_*g!_#O%Z#O#P&c#P#R%Z#R#S!8S#S#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z'Ad!8_c$h&j(Rp(U!bp'9tOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!Q%Z!Q![!8S![!^%Z!^!_*g!_#O%Z#O#P&c#P#R%Z#R#S!8S#S#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z07[!9uf$h&j(Rp(U!b#l(ChOY!;ZYZ&cZr!;Zrs!<nsw!;Zwx!Lcxz!;Zz{#-}{!P!;Z!P!Q#/d!Q!^!;Z!^!_#(i!_!`#7S!`!a#8i!a!}!;Z!}#O#,f#O#P!Dy#P#o!;Z#o#p#(i#p;'S!;Z;'S;=`#-w<%lO!;Z?O!;fb$h&j(Rp(U!b!U7`OY!;ZYZ&cZr!;Zrs!<nsw!;Zwx!Lcx!P!;Z!P!Q#&`!Q!^!;Z!^!_#(i!_!}!;Z!}#O#,f#O#P!Dy#P#o!;Z#o#p#(i#p;'S!;Z;'S;=`#-w<%lO!;Z>^!<w`$h&j(U!b!U7`OY!<nYZ&cZw!<nwx!=yx!P!<n!P!Q!Eq!Q!^!<n!^!_!Gr!_!}!<n!}#O!KS#O#P!Dy#P#o!<n#o#p!Gr#p;'S!<n;'S;=`!L]<%lO!<n<z!>Q^$h&j!U7`OY!=yYZ&cZ!P!=y!P!Q!>|!Q!^!=y!^!_!@c!_!}!=y!}#O!CW#O#P!Dy#P#o!=y#o#p!@c#p;'S!=y;'S;=`!Ek<%lO!=y<z!?Td$h&j!U7`O!^&c!_#W&c#W#X!>|#X#Z&c#Z#[!>|#[#]&c#]#^!>|#^#a&c#a#b!>|#b#g&c#g#h!>|#h#i&c#i#j!>|#j#k!>|#k#m&c#m#n!>|#n#o&c#p;'S&c;'S;=`&w<%lO&c7`!@hX!U7`OY!@cZ!P!@c!P!Q!AT!Q!}!@c!}#O!Ar#O#P!Bq#P;'S!@c;'S;=`!CQ<%lO!@c7`!AYW!U7`#W#X!AT#Z#[!AT#]#^!AT#a#b!AT#g#h!AT#i#j!AT#j#k!AT#m#n!AT7`!AuVOY!ArZ#O!Ar#O#P!B[#P#Q!@c#Q;'S!Ar;'S;=`!Bk<%lO!Ar7`!B_SOY!ArZ;'S!Ar;'S;=`!Bk<%lO!Ar7`!BnP;=`<%l!Ar7`!BtSOY!@cZ;'S!@c;'S;=`!CQ<%lO!@c7`!CTP;=`<%l!@c<z!C][$h&jOY!CWYZ&cZ!^!CW!^!_!Ar!_#O!CW#O#P!DR#P#Q!=y#Q#o!CW#o#p!Ar#p;'S!CW;'S;=`!Ds<%lO!CW<z!DWX$h&jOY!CWYZ&cZ!^!CW!^!_!Ar!_#o!CW#o#p!Ar#p;'S!CW;'S;=`!Ds<%lO!CW<z!DvP;=`<%l!CW<z!EOX$h&jOY!=yYZ&cZ!^!=y!^!_!@c!_#o!=y#o#p!@c#p;'S!=y;'S;=`!Ek<%lO!=y<z!EnP;=`<%l!=y>^!Ezl$h&j(U!b!U7`OY&}YZ&cZw&}wx&cx!^&}!^!_'}!_#O&}#O#P&c#P#W&}#W#X!Eq#X#Z&}#Z#[!Eq#[#]&}#]#^!Eq#^#a&}#a#b!Eq#b#g&}#g#h!Eq#h#i&}#i#j!Eq#j#k!Eq#k#m&}#m#n!Eq#n#o&}#o#p'}#p;'S&};'S;=`(l<%lO&}8r!GyZ(U!b!U7`OY!GrZw!Grwx!@cx!P!Gr!P!Q!Hl!Q!}!Gr!}#O!JU#O#P!Bq#P;'S!Gr;'S;=`!J|<%lO!Gr8r!Hse(U!b!U7`OY'}Zw'}x#O'}#P#W'}#W#X!Hl#X#Z'}#Z#[!Hl#[#]'}#]#^!Hl#^#a'}#a#b!Hl#b#g'}#g#h!Hl#h#i'}#i#j!Hl#j#k!Hl#k#m'}#m#n!Hl#n;'S'};'S;=`(f<%lO'}8r!JZX(U!bOY!JUZw!JUwx!Arx#O!JU#O#P!B[#P#Q!Gr#Q;'S!JU;'S;=`!Jv<%lO!JU8r!JyP;=`<%l!JU8r!KPP;=`<%l!Gr>^!KZ^$h&j(U!bOY!KSYZ&cZw!KSwx!CWx!^!KS!^!_!JU!_#O!KS#O#P!DR#P#Q!<n#Q#o!KS#o#p!JU#p;'S!KS;'S;=`!LV<%lO!KS>^!LYP;=`<%l!KS>^!L`P;=`<%l!<n=l!Ll`$h&j(Rp!U7`OY!LcYZ&cZr!Lcrs!=ys!P!Lc!P!Q!Mn!Q!^!Lc!^!_# o!_!}!Lc!}#O#%P#O#P!Dy#P#o!Lc#o#p# o#p;'S!Lc;'S;=`#&Y<%lO!Lc=l!Mwl$h&j(Rp!U7`OY(rYZ&cZr(rrs&cs!^(r!^!_)r!_#O(r#O#P&c#P#W(r#W#X!Mn#X#Z(r#Z#[!Mn#[#](r#]#^!Mn#^#a(r#a#b!Mn#b#g(r#g#h!Mn#h#i(r#i#j!Mn#j#k!Mn#k#m(r#m#n!Mn#n#o(r#o#p)r#p;'S(r;'S;=`*a<%lO(r8Q# vZ(Rp!U7`OY# oZr# ors!@cs!P# o!P!Q#!i!Q!}# o!}#O#$R#O#P!Bq#P;'S# o;'S;=`#$y<%lO# o8Q#!pe(Rp!U7`OY)rZr)rs#O)r#P#W)r#W#X#!i#X#Z)r#Z#[#!i#[#])r#]#^#!i#^#a)r#a#b#!i#b#g)r#g#h#!i#h#i)r#i#j#!i#j#k#!i#k#m)r#m#n#!i#n;'S)r;'S;=`*Z<%lO)r8Q#$WX(RpOY#$RZr#$Rrs!Ars#O#$R#O#P!B[#P#Q# o#Q;'S#$R;'S;=`#$s<%lO#$R8Q#$vP;=`<%l#$R8Q#$|P;=`<%l# o=l#%W^$h&j(RpOY#%PYZ&cZr#%Prs!CWs!^#%P!^!_#$R!_#O#%P#O#P!DR#P#Q!Lc#Q#o#%P#o#p#$R#p;'S#%P;'S;=`#&S<%lO#%P=l#&VP;=`<%l#%P=l#&]P;=`<%l!Lc?O#&kn$h&j(Rp(U!b!U7`OY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#W%Z#W#X#&`#X#Z%Z#Z#[#&`#[#]%Z#]#^#&`#^#a%Z#a#b#&`#b#g%Z#g#h#&`#h#i%Z#i#j#&`#j#k#&`#k#m%Z#m#n#&`#n#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z9d#(r](Rp(U!b!U7`OY#(iZr#(irs!Grsw#(iwx# ox!P#(i!P!Q#)k!Q!}#(i!}#O#+`#O#P!Bq#P;'S#(i;'S;=`#,`<%lO#(i9d#)th(Rp(U!b!U7`OY*gZr*grs'}sw*gwx)rx#O*g#P#W*g#W#X#)k#X#Z*g#Z#[#)k#[#]*g#]#^#)k#^#a*g#a#b#)k#b#g*g#g#h#)k#h#i*g#i#j#)k#j#k#)k#k#m*g#m#n#)k#n;'S*g;'S;=`+Z<%lO*g9d#+gZ(Rp(U!bOY#+`Zr#+`rs!JUsw#+`wx#$Rx#O#+`#O#P!B[#P#Q#(i#Q;'S#+`;'S;=`#,Y<%lO#+`9d#,]P;=`<%l#+`9d#,cP;=`<%l#(i?O#,o`$h&j(Rp(U!bOY#,fYZ&cZr#,frs!KSsw#,fwx#%Px!^#,f!^!_#+`!_#O#,f#O#P!DR#P#Q!;Z#Q#o#,f#o#p#+`#p;'S#,f;'S;=`#-q<%lO#,f?O#-tP;=`<%l#,f?O#-zP;=`<%l!;Z07[#.[b$h&j(Rp(U!b'y0/l!U7`OY!;ZYZ&cZr!;Zrs!<nsw!;Zwx!Lcx!P!;Z!P!Q#&`!Q!^!;Z!^!_#(i!_!}!;Z!}#O#,f#O#P!Dy#P#o!;Z#o#p#(i#p;'S!;Z;'S;=`#-w<%lO!;Z07[#/o_$h&j(Rp(U!bT0/lOY#/dYZ&cZr#/drs#0nsw#/dwx#4Ox!^#/d!^!_#5}!_#O#/d#O#P#1p#P#o#/d#o#p#5}#p;'S#/d;'S;=`#6|<%lO#/d06j#0w]$h&j(U!bT0/lOY#0nYZ&cZw#0nwx#1px!^#0n!^!_#3R!_#O#0n#O#P#1p#P#o#0n#o#p#3R#p;'S#0n;'S;=`#3x<%lO#0n05W#1wX$h&jT0/lOY#1pYZ&cZ!^#1p!^!_#2d!_#o#1p#o#p#2d#p;'S#1p;'S;=`#2{<%lO#1p0/l#2iST0/lOY#2dZ;'S#2d;'S;=`#2u<%lO#2d0/l#2xP;=`<%l#2d05W#3OP;=`<%l#1p01O#3YW(U!bT0/lOY#3RZw#3Rwx#2dx#O#3R#O#P#2d#P;'S#3R;'S;=`#3r<%lO#3R01O#3uP;=`<%l#3R06j#3{P;=`<%l#0n05x#4X]$h&j(RpT0/lOY#4OYZ&cZr#4Ors#1ps!^#4O!^!_#5Q!_#O#4O#O#P#1p#P#o#4O#o#p#5Q#p;'S#4O;'S;=`#5w<%lO#4O00^#5XW(RpT0/lOY#5QZr#5Qrs#2ds#O#5Q#O#P#2d#P;'S#5Q;'S;=`#5q<%lO#5Q00^#5tP;=`<%l#5Q05x#5zP;=`<%l#4O01p#6WY(Rp(U!bT0/lOY#5}Zr#5}rs#3Rsw#5}wx#5Qx#O#5}#O#P#2d#P;'S#5};'S;=`#6v<%lO#5}01p#6yP;=`<%l#5}07[#7PP;=`<%l#/d)3h#7ab$h&j$P(Ch(Rp(U!b!U7`OY!;ZYZ&cZr!;Zrs!<nsw!;Zwx!Lcx!P!;Z!P!Q#&`!Q!^!;Z!^!_#(i!_!}!;Z!}#O#,f#O#P!Dy#P#o!;Z#o#p#(i#p;'S!;Z;'S;=`#-w<%lO!;ZAt#8vb$Y#t$h&j(Rp(U!b!U7`OY!;ZYZ&cZr!;Zrs!<nsw!;Zwx!Lcx!P!;Z!P!Q#&`!Q!^!;Z!^!_#(i!_!}!;Z!}#O#,f#O#P!Dy#P#o!;Z#o#p#(i#p;'S!;Z;'S;=`#-w<%lO!;Z'Ad#:Zp$h&j(Rp(U!bp'9tOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!O%Z!O!P!3Y!P!Q%Z!Q![#<_![!^%Z!^!_*g!_!g%Z!g!h!4|!h#O%Z#O#P&c#P#R%Z#R#S#<_#S#U%Z#U#V#?i#V#X%Z#X#Y!4|#Y#b%Z#b#c#>_#c#d#Bq#d#l%Z#l#m#Es#m#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z'Ad#<jk$h&j(Rp(U!bp'9tOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!O%Z!O!P!3Y!P!Q%Z!Q![#<_![!^%Z!^!_*g!_!g%Z!g!h!4|!h#O%Z#O#P&c#P#R%Z#R#S#<_#S#X%Z#X#Y!4|#Y#b%Z#b#c#>_#c#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z'Ad#>j_$h&j(Rp(U!bp'9tOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z'Ad#?rd$h&j(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!Q%Z!Q!R#AQ!R!S#AQ!S!^%Z!^!_*g!_#O%Z#O#P&c#P#R%Z#R#S#AQ#S#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z'Ad#A]f$h&j(Rp(U!bp'9tOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!Q%Z!Q!R#AQ!R!S#AQ!S!^%Z!^!_*g!_#O%Z#O#P&c#P#R%Z#R#S#AQ#S#b%Z#b#c#>_#c#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z'Ad#Bzc$h&j(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!Q%Z!Q!Y#DV!Y!^%Z!^!_*g!_#O%Z#O#P&c#P#R%Z#R#S#DV#S#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z'Ad#Dbe$h&j(Rp(U!bp'9tOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!Q%Z!Q!Y#DV!Y!^%Z!^!_*g!_#O%Z#O#P&c#P#R%Z#R#S#DV#S#b%Z#b#c#>_#c#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z'Ad#E|g$h&j(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!Q%Z!Q![#Ge![!^%Z!^!_*g!_!c%Z!c!i#Ge!i#O%Z#O#P&c#P#R%Z#R#S#Ge#S#T%Z#T#Z#Ge#Z#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z'Ad#Gpi$h&j(Rp(U!bp'9tOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!Q%Z!Q![#Ge![!^%Z!^!_*g!_!c%Z!c!i#Ge!i#O%Z#O#P&c#P#R%Z#R#S#Ge#S#T%Z#T#Z#Ge#Z#b%Z#b#c#>_#c#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z*)x#Il_!d$b$h&j#})Lv(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z)[#Jv_al$h&j(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z04f#LS^h#)`#O-<U(Rp(U!b(y7`OY*gZr*grs'}sw*gwx)rx!P*g!P!Q#MO!Q!^*g!^!_#Mt!_!`$ f!`#O*g#P;'S*g;'S;=`+Z<%lO*g(n#MXX$j&j(Rp(U!bOY*gZr*grs'}sw*gwx)rx#O*g#P;'S*g;'S;=`+Z<%lO*g(El#M}Z#o(Ch(Rp(U!bOY*gZr*grs'}sw*gwx)rx!_*g!_!`#Np!`#O*g#P;'S*g;'S;=`+Z<%lO*g(El#NyX$P(Ch(Rp(U!bOY*gZr*grs'}sw*gwx)rx#O*g#P;'S*g;'S;=`+Z<%lO*g(El$ oX#p(Ch(Rp(U!bOY*gZr*grs'}sw*gwx)rx#O*g#P;'S*g;'S;=`+Z<%lO*g*)x$!ga#]*!Y$h&j(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_!`0z!`!a$#l!a#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z(K[$#w_#h(Cl$h&j(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z*)x$%Vag!*r#p(Ch$e#|$h&j(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_!`$&[!`!a$'f!a#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z(KW$&g_#p(Ch$h&j(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z(KW$'qa#o(Ch$h&j(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_!`Ka!`!a$(v!a#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z(KW$)R`#o(Ch$h&j(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_!`Ka!`#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z(Kd$*`a(m(Ct$h&j(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_!a%Z!a!b$+e!b#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z(KW$+p`$h&j#z(Ch(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_!`Ka!`#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z%#`$,}_!y$Ip$h&j(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z04f$.X_!P0,v$h&j(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z(n$/]Z$h&jO!^$0O!^!_$0f!_#i$0O#i#j$0k#j#l$0O#l#m$2^#m#o$0O#o#p$0f#p;'S$0O;'S;=`$4i<%lO$0O(n$0VT_#S$h&jO!^&c!_#o&c#p;'S&c;'S;=`&w<%lO&c#S$0kO_#S(n$0p[$h&jO!Q&c!Q![$1f![!^&c!_!c&c!c!i$1f!i#T&c#T#Z$1f#Z#o&c#o#p$3|#p;'S&c;'S;=`&w<%lO&c(n$1kZ$h&jO!Q&c!Q![$2^![!^&c!_!c&c!c!i$2^!i#T&c#T#Z$2^#Z#o&c#p;'S&c;'S;=`&w<%lO&c(n$2cZ$h&jO!Q&c!Q![$3U![!^&c!_!c&c!c!i$3U!i#T&c#T#Z$3U#Z#o&c#p;'S&c;'S;=`&w<%lO&c(n$3ZZ$h&jO!Q&c!Q![$0O![!^&c!_!c&c!c!i$0O!i#T&c#T#Z$0O#Z#o&c#p;'S&c;'S;=`&w<%lO&c#S$4PR!Q![$4Y!c!i$4Y#T#Z$4Y#S$4]S!Q![$4Y!c!i$4Y#T#Z$4Y#q#r$0f(n$4lP;=`<%l$0O#1[$4z_!V#)l$h&j(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z(KW$6U`#w(Ch$h&j(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_!`Ka!`#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z+;p$7c_$h&j(Rp(U!b([+4QOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z07[$8qk$h&j(Rp(U!b(O,2j$^#t(`$I[OY%ZYZ&cZr%Zrs&}st%Ztu$8buw%Zwx(rx}%Z}!O$:f!O!Q%Z!Q![$8b![!^%Z!^!_*g!_!c%Z!c!}$8b!}#O%Z#O#P&c#P#R%Z#R#S$8b#S#T%Z#T#o$8b#o#p*g#p$g%Z$g;'S$8b;'S;=`$<l<%lO$8b+d$:qk$h&j(Rp(U!b$^#tOY%ZYZ&cZr%Zrs&}st%Ztu$:fuw%Zwx(rx}%Z}!O$:f!O!Q%Z!Q![$:f![!^%Z!^!_*g!_!c%Z!c!}$:f!}#O%Z#O#P&c#P#R%Z#R#S$:f#S#T%Z#T#o$:f#o#p*g#p$g%Z$g;'S$:f;'S;=`$<f<%lO$:f+d$<iP;=`<%l$:f07[$<oP;=`<%l$8b#Jf$<{X![#Hb(Rp(U!bOY*gZr*grs'}sw*gwx)rx#O*g#P;'S*g;'S;=`+Z<%lO*g,#x$=sa(t+JY$h&j(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_!`Ka!`#O%Z#O#P&c#P#o%Z#o#p*g#p#q$+e#q;'S%Z;'S;=`+a<%lO%Z(Kd$?V_!Z(Cds`$h&j(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z?O$@a_!n7`$h&j(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z07[$Aq|$h&j(Rp(U!b'w0/l$[#t(O,2j(`$I[OX%ZXY+gYZ&cZ[+g[p%Zpq+gqr%Zrs&}st%ZtuEruw%Zwx(rx}%Z}!OGv!O!Q%Z!Q![Er![!^%Z!^!_*g!_!c%Z!c!}Er!}#O%Z#O#P&c#P#R%Z#R#SEr#S#T%Z#T#oEr#o#p*g#p$f%Z$f$g+g$g#BYEr#BY#BZ$A`#BZ$ISEr$IS$I_$A`$I_$JTEr$JT$JU$A`$JU$KVEr$KV$KW$A`$KW&FUEr&FU&FV$A`&FV;'SEr;'S;=`I|<%l?HTEr?HT?HU$A`?HUOEr07[$D|k$h&j(Rp(U!b'x0/l$[#t(O,2j(`$I[OY%ZYZ&cZr%Zrs&}st%ZtuEruw%Zwx(rx}%Z}!OGv!O!Q%Z!Q![Er![!^%Z!^!_*g!_!c%Z!c!}Er!}#O%Z#O#P&c#P#R%Z#R#SEr#S#T%Z#T#oEr#o#p*g#p$g%Z$g;'SEr;'S;=`I|<%lOEr",
  tokenizers: [g7, O7, b7, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, m7, new za("$S~RRtu[#O#Pg#S#T#|~_P#o#pb~gOu~~jVO#i!P#i#j!U#j#l!P#l#m!q#m;'S!P;'S;=`#v<%lO!P~!UO!R~~!XS!Q![!e!c!i!e#T#Z!e#o#p#Z~!hR!Q![!q!c!i!q#T#Z!q~!tR!Q![!}!c!i!}#T#Z!}~#QR!Q![!P!c!i!P#T#Z!P~#^R!Q![#g!c!i#g#T#Z#g~#jS!Q![#g!c!i#g#T#Z#g#q#r!P~#yP;=`<%l!P~$RO(^~~", 141, 335), new za("j~RQYZXz{^~^O'{~~aP!P!Qd~iO'|~~", 25, 318)],
  topRules: { Script: [0, 7], SingleExpression: [1, 272], SingleClassItem: [2, 273] },
  dialects: { jsx: 0, ts: 14769 },
  dynamicPrecedences: { 77: 1, 79: 1, 91: 1, 167: 1, 196: 1 },
  specialized: [{ term: 322, get: (n) => k7[n] || -1 }, { term: 338, get: (n) => x7[n] || -1 }, { term: 92, get: (n) => w7[n] || -1 }],
  tokenPrec: 14793
}), Oy = [
  /* @__PURE__ */ ht("function ${name}(${params}) {\n	${}\n}", {
    label: "function",
    detail: "definition",
    type: "keyword"
  }),
  /* @__PURE__ */ ht("for (let ${index} = 0; ${index} < ${bound}; ${index}++) {\n	${}\n}", {
    label: "for",
    detail: "loop",
    type: "keyword"
  }),
  /* @__PURE__ */ ht("for (let ${name} of ${collection}) {\n	${}\n}", {
    label: "for",
    detail: "of loop",
    type: "keyword"
  }),
  /* @__PURE__ */ ht("do {\n	${}\n} while (${})", {
    label: "do",
    detail: "loop",
    type: "keyword"
  }),
  /* @__PURE__ */ ht("while (${}) {\n	${}\n}", {
    label: "while",
    detail: "loop",
    type: "keyword"
  }),
  /* @__PURE__ */ ht(`try {
	\${}
} catch (\${error}) {
	\${}
}`, {
    label: "try",
    detail: "/ catch block",
    type: "keyword"
  }),
  /* @__PURE__ */ ht("if (${}) {\n	${}\n}", {
    label: "if",
    detail: "block",
    type: "keyword"
  }),
  /* @__PURE__ */ ht(`if (\${}) {
	\${}
} else {
	\${}
}`, {
    label: "if",
    detail: "/ else block",
    type: "keyword"
  }),
  /* @__PURE__ */ ht(`class \${name} {
	constructor(\${params}) {
		\${}
	}
}`, {
    label: "class",
    detail: "definition",
    type: "keyword"
  }),
  /* @__PURE__ */ ht('import {${names}} from "${module}"\n${}', {
    label: "import",
    detail: "named",
    type: "keyword"
  }),
  /* @__PURE__ */ ht('import ${name} from "${module}"\n${}', {
    label: "import",
    detail: "default",
    type: "keyword"
  })
], v7 = /* @__PURE__ */ Oy.concat([
  /* @__PURE__ */ ht("interface ${name} {\n	${}\n}", {
    label: "interface",
    detail: "definition",
    type: "keyword"
  }),
  /* @__PURE__ */ ht("type ${name} = ${type}", {
    label: "type",
    detail: "definition",
    type: "keyword"
  }),
  /* @__PURE__ */ ht("enum ${name} {\n	${}\n}", {
    label: "enum",
    detail: "definition",
    type: "keyword"
  })
]), Em = /* @__PURE__ */ new GO(), by = /* @__PURE__ */ new Set([
  "Script",
  "Block",
  "FunctionExpression",
  "FunctionDeclaration",
  "ArrowFunction",
  "MethodDeclaration",
  "ForStatement"
]);
function Er(n) {
  return (e, t) => {
    let i = e.node.getChild("VariableDefinition");
    return i && t(i, n), !0;
  };
}
const P7 = ["FunctionDeclaration"], Q7 = {
  FunctionDeclaration: /* @__PURE__ */ Er("function"),
  ClassDeclaration: /* @__PURE__ */ Er("class"),
  ClassExpression: () => !0,
  EnumDeclaration: /* @__PURE__ */ Er("constant"),
  TypeAliasDeclaration: /* @__PURE__ */ Er("type"),
  NamespaceDeclaration: /* @__PURE__ */ Er("namespace"),
  VariableDefinition(n, e) {
    n.matchContext(P7) || e(n, "variable");
  },
  TypeDefinition(n, e) {
    e(n, "type");
  },
  __proto__: null
};
function yy(n, e) {
  let t = Em.get(e);
  if (t)
    return t;
  let i = [], r = !0;
  function s(o, a) {
    let l = n.sliceString(o.from, o.to);
    i.push({ label: l, type: a });
  }
  return e.cursor(ve.IncludeAnonymous).iterate((o) => {
    if (r)
      r = !1;
    else if (o.name) {
      let a = Q7[o.name];
      if (a && a(o, s) || by.has(o.name))
        return !1;
    } else if (o.to - o.from > 8192) {
      for (let a of yy(n, o.node))
        i.push(a);
      return !1;
    }
  }), Em.set(e, i), i;
}
const zm = /^[\w$\xa1-\uffff][\w$\d\xa1-\uffff]*$/, ky = [
  "TemplateString",
  "String",
  "RegExp",
  "LineComment",
  "BlockComment",
  "VariableDefinition",
  "TypeDefinition",
  "Label",
  "PropertyDefinition",
  "PropertyName",
  "PrivatePropertyDefinition",
  "PrivatePropertyName",
  ".",
  "?."
];
function $7(n) {
  let e = Pe(n.state).resolveInner(n.pos, -1);
  if (ky.indexOf(e.name) > -1)
    return null;
  let t = e.name == "VariableName" || e.to - e.from < 20 && zm.test(n.state.sliceDoc(e.from, e.to));
  if (!t && !n.explicit)
    return null;
  let i = [];
  for (let r = e; r; r = r.parent)
    by.has(r.name) && (i = i.concat(yy(n.state.doc, r)));
  return {
    options: i,
    from: t ? e.from : n.pos,
    validFor: zm
  };
}
const fn = /* @__PURE__ */ rr.define({
  name: "javascript",
  parser: /* @__PURE__ */ S7.configure({
    props: [
      /* @__PURE__ */ Ds.add({
        IfStatement: /* @__PURE__ */ Yo({ except: /^\s*({|else\b)/ }),
        TryStatement: /* @__PURE__ */ Yo({ except: /^\s*({|catch\b|finally\b)/ }),
        LabeledStatement: iv,
        SwitchBody: (n) => {
          let e = n.textAfter, t = /^\s*\}/.test(e), i = /^\s*(case|default)\b/.test(e);
          return n.baseIndent + (t ? 0 : i ? 1 : 2) * n.unit;
        },
        Block: /* @__PURE__ */ nv({ closing: "}" }),
        ArrowFunction: (n) => n.baseIndent + n.unit,
        "TemplateString BlockComment": () => null,
        "Statement Property": /* @__PURE__ */ Yo({ except: /^{/ }),
        JSXElement(n) {
          let e = /^\s*<\//.test(n.textAfter);
          return n.lineIndent(n.node.from) + (e ? 0 : n.unit);
        },
        JSXEscape(n) {
          let e = /\s*\}/.test(n.textAfter);
          return n.lineIndent(n.node.from) + (e ? 0 : n.unit);
        },
        "JSXOpenTag JSXSelfClosingTag"(n) {
          return n.column(n.node.from) + n.unit;
        }
      }),
      /* @__PURE__ */ gr.add({
        "Block ClassBody SwitchBody EnumBody ObjectExpression ArrayExpression ObjectType": r1,
        BlockComment(n) {
          return { from: n.from + 2, to: n.to - 2 };
        }
      })
    ]
  }),
  languageData: {
    closeBrackets: { brackets: ["(", "[", "{", "'", '"', "`"] },
    commentTokens: { line: "//", block: { open: "/*", close: "*/" } },
    indentOnInput: /^\s*(?:case |default:|\{|\}|<\/)$/,
    wordChars: "$"
  }
}), xy = {
  test: (n) => /^JSX/.test(n.name),
  facet: /* @__PURE__ */ mh({ commentTokens: { block: { open: "{/*", close: "*/}" } } })
}, wy = /* @__PURE__ */ fn.configure({ dialect: "ts" }, "typescript"), Sy = /* @__PURE__ */ fn.configure({
  dialect: "jsx",
  props: [/* @__PURE__ */ gh.add((n) => n.isTop ? [xy] : void 0)]
}), vy = /* @__PURE__ */ fn.configure({
  dialect: "jsx ts",
  props: [/* @__PURE__ */ gh.add((n) => n.isTop ? [xy] : void 0)]
}, "typescript");
let Py = (n) => ({ label: n, type: "keyword" });
const Qy = /* @__PURE__ */ "break case const continue default delete export extends false finally in instanceof let new return static super switch this throw true typeof var yield".split(" ").map(Py), C7 = /* @__PURE__ */ Qy.concat(/* @__PURE__ */ ["declare", "implements", "private", "protected", "public"].map(Py));
function T7(n = {}) {
  let e = n.jsx ? n.typescript ? vy : Sy : n.typescript ? wy : fn, t = n.typescript ? v7.concat(C7) : Oy.concat(Qy);
  return new ds(e, [
    fn.data.of({
      autocomplete: wP(ky, s0(t))
    }),
    fn.data.of({
      autocomplete: $7
    }),
    n.jsx ? M7 : []
  ]);
}
function A7(n) {
  for (; ; ) {
    if (n.name == "JSXOpenTag" || n.name == "JSXSelfClosingTag" || n.name == "JSXFragmentTag")
      return n;
    if (n.name == "JSXEscape" || !n.parent)
      return null;
    n = n.parent;
  }
}
function Dm(n, e, t = n.length) {
  for (let i = e == null ? void 0 : e.firstChild; i; i = i.nextSibling)
    if (i.name == "JSXIdentifier" || i.name == "JSXBuiltin" || i.name == "JSXNamespacedName" || i.name == "JSXMemberExpression")
      return n.sliceString(i.from, Math.min(i.to, t));
  return "";
}
const R7 = typeof navigator == "object" && /* @__PURE__ */ /Android\b/.test(navigator.userAgent), M7 = /* @__PURE__ */ _.inputHandler.of((n, e, t, i, r) => {
  if ((R7 ? n.composing : n.compositionStarted) || n.state.readOnly || e != t || i != ">" && i != "/" || !fn.isActiveAt(n.state, e, -1))
    return !1;
  let s = r(), { state: o } = s, a = o.changeByRange((l) => {
    var u;
    let { head: c } = l, h = Pe(o).resolveInner(c - 1, -1), f;
    if (h.name == "JSXStartTag" && (h = h.parent), !(o.doc.sliceString(c - 1, c) != i || h.name == "JSXAttributeValue" && h.to > c)) {
      if (i == ">" && h.name == "JSXFragmentTag")
        return { range: l, changes: { from: c, insert: "</>" } };
      if (i == "/" && h.name == "JSXStartCloseTag") {
        let d = h.parent, p = d.parent;
        if (p && d.from == c - 2 && ((f = Dm(o.doc, p.firstChild, c)) || ((u = p.firstChild) === null || u === void 0 ? void 0 : u.name) == "JSXFragmentTag")) {
          let g = `${f}>`;
          return { range: $.cursor(c + g.length, -1), changes: { from: c, insert: g } };
        }
      } else if (i == ">") {
        let d = A7(h);
        if (d && d.name == "JSXOpenTag" && !/^\/?>|^<\//.test(o.doc.sliceString(c, c + 2)) && (f = Dm(o.doc, d, c)))
          return { range: l, changes: { from: c, insert: `</${f}>` } };
      }
    }
    return { range: l };
  });
  return a.changes.empty ? !1 : (n.dispatch([
    s,
    o.update(a, { userEvent: "input.complete", scrollIntoView: !0 })
  ]), !0);
}), zr = ["_blank", "_self", "_top", "_parent"], nu = ["ascii", "utf-8", "utf-16", "latin1", "latin1"], iu = ["get", "post", "put", "delete"], ru = ["application/x-www-form-urlencoded", "multipart/form-data", "text/plain"], St = ["true", "false"], Y = {}, Z7 = {
  a: {
    attrs: {
      href: null,
      ping: null,
      type: null,
      media: null,
      target: zr,
      hreflang: null
    }
  },
  abbr: Y,
  address: Y,
  area: {
    attrs: {
      alt: null,
      coords: null,
      href: null,
      target: null,
      ping: null,
      media: null,
      hreflang: null,
      type: null,
      shape: ["default", "rect", "circle", "poly"]
    }
  },
  article: Y,
  aside: Y,
  audio: {
    attrs: {
      src: null,
      mediagroup: null,
      crossorigin: ["anonymous", "use-credentials"],
      preload: ["none", "metadata", "auto"],
      autoplay: ["autoplay"],
      loop: ["loop"],
      controls: ["controls"]
    }
  },
  b: Y,
  base: { attrs: { href: null, target: zr } },
  bdi: Y,
  bdo: Y,
  blockquote: { attrs: { cite: null } },
  body: Y,
  br: Y,
  button: {
    attrs: {
      form: null,
      formaction: null,
      name: null,
      value: null,
      autofocus: ["autofocus"],
      disabled: ["autofocus"],
      formenctype: ru,
      formmethod: iu,
      formnovalidate: ["novalidate"],
      formtarget: zr,
      type: ["submit", "reset", "button"]
    }
  },
  canvas: { attrs: { width: null, height: null } },
  caption: Y,
  center: Y,
  cite: Y,
  code: Y,
  col: { attrs: { span: null } },
  colgroup: { attrs: { span: null } },
  command: {
    attrs: {
      type: ["command", "checkbox", "radio"],
      label: null,
      icon: null,
      radiogroup: null,
      command: null,
      title: null,
      disabled: ["disabled"],
      checked: ["checked"]
    }
  },
  data: { attrs: { value: null } },
  datagrid: { attrs: { disabled: ["disabled"], multiple: ["multiple"] } },
  datalist: { attrs: { data: null } },
  dd: Y,
  del: { attrs: { cite: null, datetime: null } },
  details: { attrs: { open: ["open"] } },
  dfn: Y,
  div: Y,
  dl: Y,
  dt: Y,
  em: Y,
  embed: { attrs: { src: null, type: null, width: null, height: null } },
  eventsource: { attrs: { src: null } },
  fieldset: { attrs: { disabled: ["disabled"], form: null, name: null } },
  figcaption: Y,
  figure: Y,
  footer: Y,
  form: {
    attrs: {
      action: null,
      name: null,
      "accept-charset": nu,
      autocomplete: ["on", "off"],
      enctype: ru,
      method: iu,
      novalidate: ["novalidate"],
      target: zr
    }
  },
  h1: Y,
  h2: Y,
  h3: Y,
  h4: Y,
  h5: Y,
  h6: Y,
  head: {
    children: ["title", "base", "link", "style", "meta", "script", "noscript", "command"]
  },
  header: Y,
  hgroup: Y,
  hr: Y,
  html: {
    attrs: { manifest: null }
  },
  i: Y,
  iframe: {
    attrs: {
      src: null,
      srcdoc: null,
      name: null,
      width: null,
      height: null,
      sandbox: ["allow-top-navigation", "allow-same-origin", "allow-forms", "allow-scripts"],
      seamless: ["seamless"]
    }
  },
  img: {
    attrs: {
      alt: null,
      src: null,
      ismap: null,
      usemap: null,
      width: null,
      height: null,
      crossorigin: ["anonymous", "use-credentials"]
    }
  },
  input: {
    attrs: {
      alt: null,
      dirname: null,
      form: null,
      formaction: null,
      height: null,
      list: null,
      max: null,
      maxlength: null,
      min: null,
      name: null,
      pattern: null,
      placeholder: null,
      size: null,
      src: null,
      step: null,
      value: null,
      width: null,
      accept: ["audio/*", "video/*", "image/*"],
      autocomplete: ["on", "off"],
      autofocus: ["autofocus"],
      checked: ["checked"],
      disabled: ["disabled"],
      formenctype: ru,
      formmethod: iu,
      formnovalidate: ["novalidate"],
      formtarget: zr,
      multiple: ["multiple"],
      readonly: ["readonly"],
      required: ["required"],
      type: [
        "hidden",
        "text",
        "search",
        "tel",
        "url",
        "email",
        "password",
        "datetime",
        "date",
        "month",
        "week",
        "time",
        "datetime-local",
        "number",
        "range",
        "color",
        "checkbox",
        "radio",
        "file",
        "submit",
        "image",
        "reset",
        "button"
      ]
    }
  },
  ins: { attrs: { cite: null, datetime: null } },
  kbd: Y,
  keygen: {
    attrs: {
      challenge: null,
      form: null,
      name: null,
      autofocus: ["autofocus"],
      disabled: ["disabled"],
      keytype: ["RSA"]
    }
  },
  label: { attrs: { for: null, form: null } },
  legend: Y,
  li: { attrs: { value: null } },
  link: {
    attrs: {
      href: null,
      type: null,
      hreflang: null,
      media: null,
      sizes: ["all", "16x16", "16x16 32x32", "16x16 32x32 64x64"]
    }
  },
  map: { attrs: { name: null } },
  mark: Y,
  menu: { attrs: { label: null, type: ["list", "context", "toolbar"] } },
  meta: {
    attrs: {
      content: null,
      charset: nu,
      name: ["viewport", "application-name", "author", "description", "generator", "keywords"],
      "http-equiv": ["content-language", "content-type", "default-style", "refresh"]
    }
  },
  meter: { attrs: { value: null, min: null, low: null, high: null, max: null, optimum: null } },
  nav: Y,
  noscript: Y,
  object: {
    attrs: {
      data: null,
      type: null,
      name: null,
      usemap: null,
      form: null,
      width: null,
      height: null,
      typemustmatch: ["typemustmatch"]
    }
  },
  ol: {
    attrs: { reversed: ["reversed"], start: null, type: ["1", "a", "A", "i", "I"] },
    children: ["li", "script", "template", "ul", "ol"]
  },
  optgroup: { attrs: { disabled: ["disabled"], label: null } },
  option: { attrs: { disabled: ["disabled"], label: null, selected: ["selected"], value: null } },
  output: { attrs: { for: null, form: null, name: null } },
  p: Y,
  param: { attrs: { name: null, value: null } },
  pre: Y,
  progress: { attrs: { value: null, max: null } },
  q: { attrs: { cite: null } },
  rp: Y,
  rt: Y,
  ruby: Y,
  samp: Y,
  script: {
    attrs: {
      type: ["text/javascript"],
      src: null,
      async: ["async"],
      defer: ["defer"],
      charset: nu
    }
  },
  section: Y,
  select: {
    attrs: {
      form: null,
      name: null,
      size: null,
      autofocus: ["autofocus"],
      disabled: ["disabled"],
      multiple: ["multiple"]
    }
  },
  slot: { attrs: { name: null } },
  small: Y,
  source: { attrs: { src: null, type: null, media: null } },
  span: Y,
  strong: Y,
  style: {
    attrs: {
      type: ["text/css"],
      media: null,
      scoped: null
    }
  },
  sub: Y,
  summary: Y,
  sup: Y,
  table: Y,
  tbody: Y,
  td: { attrs: { colspan: null, rowspan: null, headers: null } },
  template: Y,
  textarea: {
    attrs: {
      dirname: null,
      form: null,
      maxlength: null,
      name: null,
      placeholder: null,
      rows: null,
      cols: null,
      autofocus: ["autofocus"],
      disabled: ["disabled"],
      readonly: ["readonly"],
      required: ["required"],
      wrap: ["soft", "hard"]
    }
  },
  tfoot: Y,
  th: { attrs: { colspan: null, rowspan: null, headers: null, scope: ["row", "col", "rowgroup", "colgroup"] } },
  thead: Y,
  time: { attrs: { datetime: null } },
  title: Y,
  tr: Y,
  track: {
    attrs: {
      src: null,
      label: null,
      default: null,
      kind: ["subtitles", "captions", "descriptions", "chapters", "metadata"],
      srclang: null
    }
  },
  ul: { children: ["li", "script", "template", "ul", "ol"] },
  var: Y,
  video: {
    attrs: {
      src: null,
      poster: null,
      width: null,
      height: null,
      crossorigin: ["anonymous", "use-credentials"],
      preload: ["auto", "metadata", "none"],
      autoplay: ["autoplay"],
      mediagroup: ["movie"],
      muted: ["muted"],
      controls: ["controls"]
    }
  },
  wbr: Y
}, $y = {
  accesskey: null,
  class: null,
  contenteditable: St,
  contextmenu: null,
  dir: ["ltr", "rtl", "auto"],
  draggable: ["true", "false", "auto"],
  dropzone: ["copy", "move", "link", "string:", "file:"],
  hidden: ["hidden"],
  id: null,
  inert: ["inert"],
  itemid: null,
  itemprop: null,
  itemref: null,
  itemscope: ["itemscope"],
  itemtype: null,
  lang: ["ar", "bn", "de", "en-GB", "en-US", "es", "fr", "hi", "id", "ja", "pa", "pt", "ru", "tr", "zh"],
  spellcheck: St,
  autocorrect: St,
  autocapitalize: St,
  style: null,
  tabindex: null,
  title: null,
  translate: ["yes", "no"],
  rel: ["stylesheet", "alternate", "author", "bookmark", "help", "license", "next", "nofollow", "noreferrer", "prefetch", "prev", "search", "tag"],
  role: /* @__PURE__ */ "alert application article banner button cell checkbox complementary contentinfo dialog document feed figure form grid gridcell heading img list listbox listitem main navigation region row rowgroup search switch tab table tabpanel textbox timer".split(" "),
  "aria-activedescendant": null,
  "aria-atomic": St,
  "aria-autocomplete": ["inline", "list", "both", "none"],
  "aria-busy": St,
  "aria-checked": ["true", "false", "mixed", "undefined"],
  "aria-controls": null,
  "aria-describedby": null,
  "aria-disabled": St,
  "aria-dropeffect": null,
  "aria-expanded": ["true", "false", "undefined"],
  "aria-flowto": null,
  "aria-grabbed": ["true", "false", "undefined"],
  "aria-haspopup": St,
  "aria-hidden": St,
  "aria-invalid": ["true", "false", "grammar", "spelling"],
  "aria-label": null,
  "aria-labelledby": null,
  "aria-level": null,
  "aria-live": ["off", "polite", "assertive"],
  "aria-multiline": St,
  "aria-multiselectable": St,
  "aria-owns": null,
  "aria-posinset": null,
  "aria-pressed": ["true", "false", "mixed", "undefined"],
  "aria-readonly": St,
  "aria-relevant": null,
  "aria-required": St,
  "aria-selected": ["true", "false", "undefined"],
  "aria-setsize": null,
  "aria-sort": ["ascending", "descending", "none", "other"],
  "aria-valuemax": null,
  "aria-valuemin": null,
  "aria-valuenow": null,
  "aria-valuetext": null
}, Cy = /* @__PURE__ */ "beforeunload copy cut dragstart dragover dragleave dragenter dragend drag paste focus blur change click load mousedown mouseenter mouseleave mouseup keydown keyup resize scroll unload".split(" ").map((n) => "on" + n);
for (let n of Cy)
  $y[n] = null;
let Ts = class {
  constructor(e, t) {
    this.tags = Object.assign(Object.assign({}, Z7), e), this.globalAttrs = Object.assign(Object.assign({}, $y), t), this.allTags = Object.keys(this.tags), this.globalAttrNames = Object.keys(this.globalAttrs);
  }
};
Ts.default = /* @__PURE__ */ new Ts();
function hr(n, e, t = n.length) {
  if (!e)
    return "";
  let i = e.firstChild, r = i && i.getChild("TagName");
  return r ? n.sliceString(r.from, Math.min(r.to, t)) : "";
}
function fr(n, e = !1) {
  for (; n; n = n.parent)
    if (n.name == "Element")
      if (e)
        e = !1;
      else
        return n;
  return null;
}
function Ty(n, e, t) {
  let i = t.tags[hr(n, fr(e))];
  return (i == null ? void 0 : i.children) || t.allTags;
}
function of(n, e) {
  let t = [];
  for (let i = fr(e); i && !i.type.isTop; i = fr(i.parent)) {
    let r = hr(n, i);
    if (r && i.lastChild.name == "CloseTag")
      break;
    r && t.indexOf(r) < 0 && (e.name == "EndTag" || e.from >= i.firstChild.to) && t.push(r);
  }
  return t;
}
const Ay = /^[:\-\.\w\u00b7-\uffff]*$/;
function Im(n, e, t, i, r) {
  let s = /\s*>/.test(n.sliceDoc(r, r + 5)) ? "" : ">", o = fr(t, !0);
  return {
    from: i,
    to: r,
    options: Ty(n.doc, o, e).map((a) => ({ label: a, type: "type" })).concat(of(n.doc, t).map((a, l) => ({
      label: "/" + a,
      apply: "/" + a + s,
      type: "type",
      boost: 99 - l
    }))),
    validFor: /^\/?[:\-\.\w\u00b7-\uffff]*$/
  };
}
function Lm(n, e, t, i) {
  let r = /\s*>/.test(n.sliceDoc(i, i + 5)) ? "" : ">";
  return {
    from: t,
    to: i,
    options: of(n.doc, e).map((s, o) => ({ label: s, apply: s + r, type: "type", boost: 99 - o })),
    validFor: Ay
  };
}
function E7(n, e, t, i) {
  let r = [], s = 0;
  for (let o of Ty(n.doc, t, e))
    r.push({ label: "<" + o, type: "type" });
  for (let o of of(n.doc, t))
    r.push({ label: "</" + o + ">", type: "type", boost: 99 - s++ });
  return { from: i, to: i, options: r, validFor: /^<\/?[:\-\.\w\u00b7-\uffff]*$/ };
}
function z7(n, e, t, i, r) {
  let s = fr(t), o = s ? e.tags[hr(n.doc, s)] : null, a = o && o.attrs ? Object.keys(o.attrs) : [], l = o && o.globalAttrs === !1 ? a : a.length ? a.concat(e.globalAttrNames) : e.globalAttrNames;
  return {
    from: i,
    to: r,
    options: l.map((u) => ({ label: u, type: "property" })),
    validFor: Ay
  };
}
function D7(n, e, t, i, r) {
  var s;
  let o = (s = t.parent) === null || s === void 0 ? void 0 : s.getChild("AttributeName"), a = [], l;
  if (o) {
    let u = n.sliceDoc(o.from, o.to), c = e.globalAttrs[u];
    if (!c) {
      let h = fr(t), f = h ? e.tags[hr(n.doc, h)] : null;
      c = (f == null ? void 0 : f.attrs) && f.attrs[u];
    }
    if (c) {
      let h = n.sliceDoc(i, r).toLowerCase(), f = '"', d = '"';
      /^['"]/.test(h) ? (l = h[0] == '"' ? /^[^"]*$/ : /^[^']*$/, f = "", d = n.sliceDoc(r, r + 1) == h[0] ? "" : h[0], h = h.slice(1), i++) : l = /^[^\s<>='"]*$/;
      for (let p of c)
        a.push({ label: p, apply: f + p + d, type: "constant" });
    }
  }
  return { from: i, to: r, options: a, validFor: l };
}
function Ry(n, e) {
  let { state: t, pos: i } = e, r = Pe(t).resolveInner(i, -1), s = r.resolve(i);
  for (let o = i, a; s == r && (a = r.childBefore(o)); ) {
    let l = a.lastChild;
    if (!l || !l.type.isError || l.from < l.to)
      break;
    s = r = a, o = l.from;
  }
  return r.name == "TagName" ? r.parent && /CloseTag$/.test(r.parent.name) ? Lm(t, r, r.from, i) : Im(t, n, r, r.from, i) : r.name == "StartTag" ? Im(t, n, r, i, i) : r.name == "StartCloseTag" || r.name == "IncompleteCloseTag" ? Lm(t, r, i, i) : r.name == "OpenTag" || r.name == "SelfClosingTag" || r.name == "AttributeName" ? z7(t, n, r, r.name == "AttributeName" ? r.from : i, i) : r.name == "Is" || r.name == "AttributeValue" || r.name == "UnquotedAttributeValue" ? D7(t, n, r, r.name == "Is" ? i : r.from, i) : e.explicit && (s.name == "Element" || s.name == "Text" || s.name == "Document") ? E7(t, n, r, i) : null;
}
function I7(n) {
  return Ry(Ts.default, n);
}
function L7(n) {
  let { extraTags: e, extraGlobalAttributes: t } = n, i = t || e ? new Ts(e, t) : Ts.default;
  return (r) => Ry(i, r);
}
const _7 = /* @__PURE__ */ fn.parser.configure({ top: "SingleExpression" }), My = [
  {
    tag: "script",
    attrs: (n) => n.type == "text/typescript" || n.lang == "ts",
    parser: wy.parser
  },
  {
    tag: "script",
    attrs: (n) => n.type == "text/babel" || n.type == "text/jsx",
    parser: Sy.parser
  },
  {
    tag: "script",
    attrs: (n) => n.type == "text/typescript-jsx",
    parser: vy.parser
  },
  {
    tag: "script",
    attrs(n) {
      return /^(importmap|speculationrules|application\/(.+\+)?json)$/i.test(n.type);
    },
    parser: _7
  },
  {
    tag: "script",
    attrs(n) {
      return !n.type || /^(?:text|application)\/(?:x-)?(?:java|ecma)script$|^module$|^$/i.test(n.type);
    },
    parser: fn.parser
  },
  {
    tag: "style",
    attrs(n) {
      return (!n.lang || n.lang == "css") && (!n.type || /^(text\/)?(x-)?(stylesheet|css)$/i.test(n.type));
    },
    parser: La.parser
  }
], Zy = /* @__PURE__ */ [
  {
    name: "style",
    parser: /* @__PURE__ */ La.parser.configure({ top: "Styles" })
  }
].concat(/* @__PURE__ */ Cy.map((n) => ({ name: n, parser: fn.parser }))), Ey = /* @__PURE__ */ rr.define({
  name: "html",
  parser: /* @__PURE__ */ xM.configure({
    props: [
      /* @__PURE__ */ Ds.add({
        Element(n) {
          let e = /^(\s*)(<\/)?/.exec(n.textAfter);
          return n.node.to <= n.pos + e[0].length ? n.continue() : n.lineIndent(n.node.from) + (e[2] ? 0 : n.unit);
        },
        "OpenTag CloseTag SelfClosingTag"(n) {
          return n.column(n.node.from) + n.unit;
        },
        Document(n) {
          if (n.pos + /\s*/.exec(n.textAfter)[0].length < n.node.to)
            return n.continue();
          let e = null, t;
          for (let i = n.node; ; ) {
            let r = i.lastChild;
            if (!r || r.name != "Element" || r.to != i.to)
              break;
            e = i = r;
          }
          return e && !((t = e.lastChild) && (t.name == "CloseTag" || t.name == "SelfClosingTag")) ? n.lineIndent(e.from) + n.unit : null;
        }
      }),
      /* @__PURE__ */ gr.add({
        Element(n) {
          let e = n.firstChild, t = n.lastChild;
          return !e || e.name != "OpenTag" ? null : { from: e.to, to: t.name == "CloseTag" ? t.from : n.to };
        }
      }),
      /* @__PURE__ */ g1.add({
        "OpenTag CloseTag": (n) => n.getChild("TagName")
      })
    ]
  }),
  languageData: {
    commentTokens: { block: { open: "<!--", close: "-->" } },
    indentOnInput: /^\s*<\/\w+\W$/,
    wordChars: "-._"
  }
}), Ko = /* @__PURE__ */ Ey.configure({
  wrap: /* @__PURE__ */ hy(My, Zy)
});
function X7(n = {}) {
  let e = "", t;
  n.matchClosingTags === !1 && (e = "noMatch"), n.selfClosingTags === !0 && (e = (e ? e + " " : "") + "selfClosing"), (n.nestedLanguages && n.nestedLanguages.length || n.nestedAttributes && n.nestedAttributes.length) && (t = hy((n.nestedLanguages || []).concat(My), (n.nestedAttributes || []).concat(Zy)));
  let i = t ? Ey.configure({ wrap: t, dialect: e }) : e ? Ko.configure({ dialect: e }) : Ko;
  return new ds(i, [
    Ko.data.of({ autocomplete: L7(n) }),
    n.autoCloseTags !== !1 ? N7 : [],
    T7().support,
    FM().support
  ]);
}
const _m = /* @__PURE__ */ new Set(/* @__PURE__ */ "area base br col command embed frame hr img input keygen link meta param source track wbr menuitem".split(" ")), N7 = /* @__PURE__ */ _.inputHandler.of((n, e, t, i, r) => {
  if (n.composing || n.state.readOnly || e != t || i != ">" && i != "/" || !Ko.isActiveAt(n.state, e, -1))
    return !1;
  let s = r(), { state: o } = s, a = o.changeByRange((l) => {
    var u, c, h;
    let f = o.doc.sliceString(l.from - 1, l.to) == i, { head: d } = l, p = Pe(o).resolveInner(d, -1), g;
    if (f && i == ">" && p.name == "EndTag") {
      let O = p.parent;
      if (((c = (u = O.parent) === null || u === void 0 ? void 0 : u.lastChild) === null || c === void 0 ? void 0 : c.name) != "CloseTag" && (g = hr(o.doc, O.parent, d)) && !_m.has(g)) {
        let m = d + (o.doc.sliceString(d, d + 1) === ">" ? 1 : 0), b = `</${g}>`;
        return { range: l, changes: { from: d, to: m, insert: b } };
      }
    } else if (f && i == "/" && p.name == "IncompleteCloseTag") {
      let O = p.parent;
      if (p.from == d - 2 && ((h = O.lastChild) === null || h === void 0 ? void 0 : h.name) != "CloseTag" && (g = hr(o.doc, O, d)) && !_m.has(g)) {
        let m = d + (o.doc.sliceString(d, d + 1) === ">" ? 1 : 0), b = `${g}>`;
        return {
          range: $.cursor(d + b.length, -1),
          changes: { from: d, to: m, insert: b }
        };
      }
    }
    return { range: l };
  });
  return a.changes.empty ? !1 : (n.dispatch([
    s,
    o.update(a, {
      userEvent: "input.complete",
      scrollIntoView: !0
    })
  ]), !0);
}), zy = /* @__PURE__ */ mh({ commentTokens: { block: { open: "<!--", close: "-->" } } }), Dy = /* @__PURE__ */ new J(), Iy = /* @__PURE__ */ gR.configure({
  props: [
    /* @__PURE__ */ gr.add((n) => !n.is("Block") || n.is("Document") || Xc(n) != null || W7(n) ? void 0 : (e, t) => ({ from: t.doc.lineAt(e.from).to, to: e.to })),
    /* @__PURE__ */ Dy.add(Xc),
    /* @__PURE__ */ Ds.add({
      Document: () => null
    }),
    /* @__PURE__ */ gi.add({
      Document: zy
    })
  ]
});
function Xc(n) {
  let e = /^(?:ATX|Setext)Heading(\d)$/.exec(n.name);
  return e ? +e[1] : void 0;
}
function W7(n) {
  return n.name == "OrderedList" || n.name == "BulletList";
}
function q7(n, e) {
  let t = n;
  for (; ; ) {
    let i = t.nextSibling, r;
    if (!i || (r = Xc(i.type)) != null && r <= e)
      break;
    t = i;
  }
  return t.to;
}
const B7 = /* @__PURE__ */ i1.of((n, e, t) => {
  for (let i = Pe(n).resolveInner(t, -1); i && !(i.from < e); i = i.parent) {
    let r = i.type.prop(Dy);
    if (r == null)
      continue;
    let s = q7(i, r);
    if (s > t)
      return { from: t, to: s };
  }
  return null;
});
function af(n) {
  return new Zt(zy, n, [B7], "markdown");
}
const V7 = /* @__PURE__ */ af(Iy), Y7 = /* @__PURE__ */ Iy.configure([$R, TR, CR, AR, {
  props: [
    /* @__PURE__ */ gr.add({
      Table: (n, e) => ({ from: e.doc.lineAt(n.from).to, to: n.to })
    })
  ]
}]), lf = /* @__PURE__ */ af(Y7);
function j7(n, e) {
  return (t) => {
    if (t && n) {
      let i = null;
      if (t = /\S*/.exec(t)[0], typeof n == "function" ? i = n(t) : i = ha.matchLanguageName(n, t, !0), i instanceof ha)
        return i.support ? i.support.language.parser : fs.getSkippingParser(i.load());
      if (i)
        return i.parser;
    }
    return e ? e.parser : null;
  };
}
class Ro {
  constructor(e, t, i, r, s, o, a) {
    this.node = e, this.from = t, this.to = i, this.spaceBefore = r, this.spaceAfter = s, this.type = o, this.item = a;
  }
  blank(e, t = !0) {
    let i = this.spaceBefore + (this.node.name == "Blockquote" ? ">" : "");
    if (e != null) {
      for (; i.length < e; )
        i += " ";
      return i;
    } else {
      for (let r = this.to - this.from - i.length - this.spaceAfter.length; r > 0; r--)
        i += " ";
      return i + (t ? this.spaceAfter : "");
    }
  }
  marker(e, t) {
    let i = this.node.name == "OrderedList" ? String(+_y(this.item, e)[2] + t) : "";
    return this.spaceBefore + i + this.type + this.spaceAfter;
  }
}
function Ly(n, e) {
  let t = [];
  for (let r = n; r && r.name != "Document"; r = r.parent)
    (r.name == "ListItem" || r.name == "Blockquote" || r.name == "FencedCode") && t.push(r);
  let i = [];
  for (let r = t.length - 1; r >= 0; r--) {
    let s = t[r], o, a = e.lineAt(s.from), l = s.from - a.from;
    if (s.name == "FencedCode")
      i.push(new Ro(s, l, l, "", "", "", null));
    else if (s.name == "Blockquote" && (o = /^ *>( ?)/.exec(a.text.slice(l))))
      i.push(new Ro(s, l, l + o[0].length, "", o[1], ">", null));
    else if (s.name == "ListItem" && s.parent.name == "OrderedList" && (o = /^( *)\d+([.)])( *)/.exec(a.text.slice(l)))) {
      let u = o[3], c = o[0].length;
      u.length >= 4 && (u = u.slice(0, u.length - 4), c -= 4), i.push(new Ro(s.parent, l, l + c, o[1], u, o[2], s));
    } else if (s.name == "ListItem" && s.parent.name == "BulletList" && (o = /^( *)([-+*])( {1,4}\[[ xX]\])?( +)/.exec(a.text.slice(l)))) {
      let u = o[4], c = o[0].length;
      u.length > 4 && (u = u.slice(0, u.length - 4), c -= 4);
      let h = o[2];
      o[3] && (h += o[3].replace(/[xX]/, " ")), i.push(new Ro(s.parent, l, l + c, o[1], u, h, s));
    }
  }
  return i;
}
function _y(n, e) {
  return /^(\s*)(\d+)(?=[.)])/.exec(e.sliceString(n.from, n.from + 10));
}
function su(n, e, t, i = 0) {
  for (let r = -1, s = n; ; ) {
    if (s.name == "ListItem") {
      let a = _y(s, e), l = +a[2];
      if (r >= 0) {
        if (l != r + 1)
          return;
        t.push({ from: s.from + a[1].length, to: s.from + a[0].length, insert: String(r + 2 + i) });
      }
      r = l;
    }
    let o = s.nextSibling;
    if (!o)
      break;
    s = o;
  }
}
function uf(n, e) {
  let t = /^[ \t]*/.exec(n)[0].length;
  if (!t || e.facet(mr) != "	")
    return n;
  let i = Ut(n, 4, t), r = "";
  for (let s = i; s > 0; )
    s >= 4 ? (r += "	", s -= 4) : (r += " ", s--);
  return r + n.slice(t);
}
const U7 = ({ state: n, dispatch: e }) => {
  let t = Pe(n), { doc: i } = n, r = null, s = n.changeByRange((o) => {
    if (!o.empty || !lf.isActiveAt(n, o.from))
      return r = { range: o };
    let a = o.from, l = i.lineAt(a), u = Ly(t.resolveInner(a, -1), i);
    for (; u.length && u[u.length - 1].from > a - l.from; )
      u.pop();
    if (!u.length)
      return r = { range: o };
    let c = u[u.length - 1];
    if (c.to - c.spaceAfter.length > a - l.from)
      return r = { range: o };
    let h = a >= c.to - c.spaceAfter.length && !/\S/.test(l.text.slice(c.to));
    if (c.item && h) {
      let O = c.node.firstChild, m = c.node.getChild("ListItem", "ListItem");
      if (O.to >= a || m && m.to < a || l.from > 0 && !/[^\s>]/.test(i.lineAt(l.from - 1).text)) {
        let b = u.length > 1 ? u[u.length - 2] : null, w, Q = "";
        b && b.item ? (w = l.from + b.from, Q = b.marker(i, 1)) : w = l.from + (b ? b.to : 0);
        let v = [{ from: w, to: a, insert: Q }];
        return c.node.name == "OrderedList" && su(c.item, i, v, -2), b && b.node.name == "OrderedList" && su(b.item, i, v), { range: $.cursor(w + Q.length), changes: v };
      } else {
        let b = Nm(u, n, l);
        return {
          range: $.cursor(a + b.length + 1),
          changes: { from: l.from, insert: b + n.lineBreak }
        };
      }
    }
    if (c.node.name == "Blockquote" && h && l.from) {
      let O = i.lineAt(l.from - 1), m = />\s*$/.exec(O.text);
      if (m && m.index == c.from) {
        let b = n.changes([
          { from: O.from + m.index, to: O.to },
          { from: l.from + c.from, to: l.to }
        ]);
        return { range: o.map(b), changes: b };
      }
    }
    let f = [];
    c.node.name == "OrderedList" && su(c.item, i, f);
    let d = c.item && c.item.from < l.from, p = "";
    if (!d || /^[\s\d.)\-+*>]*/.exec(l.text)[0].length >= c.to)
      for (let O = 0, m = u.length - 1; O <= m; O++)
        p += O == m && !d ? u[O].marker(i, 1) : u[O].blank(O < m ? Ut(l.text, 4, u[O + 1].from) - p.length : null);
    let g = a;
    for (; g > l.from && /\s/.test(l.text.charAt(g - l.from - 1)); )
      g--;
    return p = uf(p, n), F7(c.node, n.doc) && (p = Nm(u, n, l) + n.lineBreak + p), f.push({ from: g, to: a, insert: n.lineBreak + p }), { range: $.cursor(g + p.length + 1), changes: f };
  });
  return r ? !1 : (e(n.update(s, { scrollIntoView: !0, userEvent: "input" })), !0);
};
function Xm(n) {
  return n.name == "QuoteMark" || n.name == "ListMark";
}
function F7(n, e) {
  if (n.name != "OrderedList" && n.name != "BulletList")
    return !1;
  let t = n.firstChild, i = n.getChild("ListItem", "ListItem");
  if (!i)
    return !1;
  let r = e.lineAt(t.to), s = e.lineAt(i.from), o = /^[\s>]*$/.test(r.text);
  return r.number + (o ? 0 : 1) < s.number;
}
function Nm(n, e, t) {
  let i = "";
  for (let r = 0, s = n.length - 2; r <= s; r++)
    i += n[r].blank(r < s ? Ut(t.text, 4, n[r + 1].from) - i.length : null, r < s);
  return uf(i, e);
}
function G7(n, e) {
  let t = n.resolveInner(e, -1), i = e;
  Xm(t) && (i = t.from, t = t.parent);
  for (let r; r = t.childBefore(i); )
    if (Xm(r))
      i = r.from;
    else if (r.name == "OrderedList" || r.name == "BulletList")
      t = r.lastChild, i = t.to;
    else
      break;
  return t;
}
const H7 = ({ state: n, dispatch: e }) => {
  let t = Pe(n), i = null, r = n.changeByRange((s) => {
    let o = s.from, { doc: a } = n;
    if (s.empty && lf.isActiveAt(n, s.from)) {
      let l = a.lineAt(o), u = Ly(G7(t, o), a);
      if (u.length) {
        let c = u[u.length - 1], h = c.to - c.spaceAfter.length + (c.spaceAfter ? 1 : 0);
        if (o - l.from > h && !/\S/.test(l.text.slice(h, o - l.from)))
          return {
            range: $.cursor(l.from + h),
            changes: { from: l.from + h, to: o }
          };
        if (o - l.from == h && // Only apply this if we're on the line that has the
        // construct's syntax, or there's only indentation in the
        // target range
        (!c.item || l.from <= c.item.from || !/\S/.test(l.text.slice(0, c.to)))) {
          let f = l.from + c.from;
          if (c.item && c.node.from < c.item.from && /\S/.test(l.text.slice(c.from, c.to))) {
            let d = c.blank(Ut(l.text, 4, c.to) - Ut(l.text, 4, c.from));
            return f == l.from && (d = uf(d, n)), {
              range: $.cursor(f + d.length),
              changes: { from: f, to: l.from + c.to, insert: d }
            };
          }
          if (f < o)
            return { range: $.cursor(f), changes: { from: f, to: o } };
        }
      }
    }
    return i = { range: s };
  });
  return i ? !1 : (e(n.update(r, { scrollIntoView: !0, userEvent: "delete" })), !0);
}, K7 = [
  { key: "Enter", run: U7 },
  { key: "Backspace", run: H7 }
], Nc = /* @__PURE__ */ X7({ matchClosingTags: !1 });
function J7(n = {}) {
  let { codeLanguages: e, defaultCodeLanguage: t, addKeymap: i = !0, base: { parser: r } = V7, completeHTMLTags: s = !0 } = n;
  if (!(r instanceof cl))
    throw new RangeError("Base parser provided to `markdown` should be a Markdown parser");
  let o = n.extensions ? [n.extensions] : [], a = [Nc.support], l;
  t instanceof ds ? (a.push(t.support), l = t.language) : t && (l = t);
  let u = e || l ? j7(e, l) : void 0;
  o.push(bR({ codeParser: u, htmlParser: Nc.language.parser })), i && a.push(Mn.high(dr.of(K7)));
  let c = af(r.configure(o));
  return s && a.push(c.data.of({ autocomplete: eZ })), new ds(c, a);
}
function eZ(n) {
  let { state: e, pos: t } = n, i = /<[:\-\.\w\u00b7-\uffff]*$/.exec(e.sliceDoc(t - 25, t));
  if (!i)
    return null;
  let r = Pe(e).resolveInner(t, -1);
  for (; r && !r.type.isTop; ) {
    if (r.name == "CodeBlock" || r.name == "FencedCode" || r.name == "ProcessingInstructionBlock" || r.name == "CommentBlock" || r.name == "Link" || r.name == "Image")
      return null;
    r = r.parent;
  }
  return {
    from: t - i[0].length,
    to: t,
    options: tZ(),
    validFor: /^<[:\-\.\w\u00b7-\uffff]*$/
  };
}
let ou = null;
function tZ() {
  if (ou)
    return ou;
  let n = I7(new Qh(se.create({ extensions: Nc }), 0, !0));
  return ou = n ? n.options : [];
}
let pe = () => "";
function nZ(n) {
  const e = Array.isArray(n) ? Object.assign({}, Tp, ...n) : Object.assign({}, Tp, n);
  pe = (t) => e[t] || t;
}
function iZ() {
  const n = this.data();
  (n.micromarkExtensions || (n.micromarkExtensions = [])).push({ disable: { null: ["htmlText", "htmlFlow"] } });
}
function cf() {
  return {
    remark: [
      T5,
      iZ
    ],
    rehype: [],
    remarkRehypeOptions: {},
    codemirror: [
      J7({
        base: lf,
        extensions: [
          { remove: ["HTMLBlock", "HTMLTag"] }
        ],
        completeHTMLTags: !1
      })
    ],
    toolbarL: TZ(),
    toolbarR: AZ()
  };
}
const rZ = {
  name: "increase-level",
  icon: Xe.headingup,
  func: (n) => {
    const e = n.state, t = e.update(e.changeByRange((i) => {
      const r = e.doc.lineAt(i.from).number, s = e.doc.lineAt(i.to).number, o = [];
      let a = 0, l = e.doc.line(r).from;
      for (let u = r; u <= s; u++) {
        const c = e.doc.line(u), h = c.text;
        console.log(c.text);
        let f = 0, d = 0, p = 0;
        const g = h.length;
        for (; f < g && h[f] === " "; )
          f++;
        for (d = f; d < g && h[d] === "#"; )
          d++;
        for (p = d; p < g && h[p] === " "; )
          p++;
        const O = d - f, m = Math.min(O + 1, 6), b = m === 0 ? "" : "#".repeat(m) + " ";
        o.push({
          from: c.from,
          to: c.from + p,
          insert: b
        }), u === r && (a = c.from), l = l + c.length + b.length - p + 1;
      }
      return l--, {
        changes: o,
        range: $.range(a, l)
      };
    }));
    n.update([t]), n.focus();
  }
}, sZ = {
  name: "decrease-level",
  icon: Xe.headingdown,
  func: (n) => {
    const e = n.state, t = e.update(e.changeByRange((i) => {
      const r = e.doc.lineAt(i.from).number, s = e.doc.lineAt(i.to).number, o = [];
      let a = 0, l = e.doc.line(r).from;
      for (let u = r; u <= s; u++) {
        const c = e.doc.line(u), h = c.text;
        let f = 0, d = 0, p = 0;
        const g = h.length;
        for (; f < g && h[f] === " "; )
          f++;
        for (d = f; d < g && h[d] === "#"; )
          d++;
        for (p = d; p < g && h[p] === " "; )
          p++;
        const O = d - f, m = Math.max(O - 1, 0), b = m === 0 ? "" : "#".repeat(m) + " ";
        o.push({
          from: c.from,
          to: c.from + p,
          insert: b
        }), u === r && (a = c.from), l = l + c.length + b.length - p + 1;
      }
      return l--, {
        changes: o,
        range: $.range(a, l)
      };
    }));
    n.update([t]), n.focus();
  }
}, oZ = {
  name: "horizontal",
  icon: Xe.line,
  func: (n) => {
    const e = n.state, t = e.update(e.changeByRange((i) => {
      const r = `

---

`;
      return {
        changes: [
          { from: i.from, to: i.to },
          { from: i.from, insert: r }
        ],
        range: $.range(i.from + r.length, i.from + r.length)
      };
    }));
    n.update([t]), n.focus();
  }
}, aZ = {
  name: "bold",
  icon: Xe.bold,
  func: (n) => {
    const e = n.state, t = e.update(e.changeByRange((i) => ({
      changes: [
        { from: i.from, insert: "**" },
        { from: i.to, insert: "**" }
      ],
      range: $.range(i.from + 2, i.to + 2)
    })));
    n.update([t]), n.focus();
  }
}, lZ = {
  name: "italic",
  icon: Xe.italic,
  func: (n) => {
    const e = n.state, t = e.update(e.changeByRange((i) => ({
      changes: [
        { from: i.from, insert: " _" },
        { from: i.to, insert: "_ " }
      ],
      range: $.range(i.from + 2, i.to + 2)
    })));
    n.update([t]), n.focus();
  }
}, uZ = {
  name: "strikethrough",
  icon: Xe.strikethrough,
  func: (n) => {
    const e = n.state, t = e.update(e.changeByRange((i) => ({
      changes: [
        { from: i.from, insert: "~~" },
        { from: i.to, insert: "~~" }
      ],
      range: $.range(i.from + 2, i.to + 2)
    })));
    n.update([t]), n.focus();
  }
}, cZ = {
  name: "link",
  icon: Xe.link,
  func: (n, e, t) => {
    function i(s, o) {
      const a = n.state, l = a.update(a.changeByRange((u) => {
        const c = `[${o}](${s})`;
        return {
          changes: [
            { from: u.from, to: u.to },
            { from: u.from, insert: c }
          ],
          range: $.range(u.from + c.length, u.from + c.length)
        };
      }));
      n.update([l]), n.focus();
    }
    const r = Vt(
      eR,
      {
        confirm: i,
        container: t
      }
    );
    dn(r, t);
  }
}, hZ = {
  name: "image",
  icon: Xe.image,
  func: (n, e, t) => {
    function i(s, o) {
      const a = n.state, l = a.update(a.changeByRange((u) => {
        const c = `![${o}](${s})`;
        return {
          changes: [
            { from: u.from, to: u.to },
            { from: u.from, insert: c }
          ],
          range: $.range(u.from + c.length, u.from + c.length)
        };
      }));
      n.update([l]), n.focus();
    }
    const r = Vt(
      L4,
      {
        confirm: i,
        upload: e.data.upload,
        container: t
      }
    );
    dn(r, t);
  }
}, fZ = {
  name: "code",
  icon: Xe.code,
  func: (n, e, t) => {
    function i(s, o) {
      const a = n.state, l = a.update(a.changeByRange((u) => {
        const c = `
\`\`\`${s}
${o}
\`\`\`
`;
        return {
          changes: [
            { from: u.from, to: u.to },
            { from: u.from, insert: c }
          ],
          range: $.range(u.from + c.length, u.from + c.length)
        };
      }));
      n.update([l]), n.focus();
    }
    const r = Vt(
      R4,
      {
        confirm: i,
        container: t
      }
    );
    dn(r, t);
  }
}, dZ = {
  name: "table",
  icon: Xe.table,
  func: (n, e, t) => {
    function i(s, o, a) {
      const l = n.state, u = l.update(l.changeByRange((c) => {
        let h = `

`;
        for (let f = 0; f < s; f++) {
          for (let d = 0; d < o; d++)
            h += "|" + a[f][d];
          if (h += `|
`, f === 0) {
            for (let d = 0; d < o; d++)
              h += "|:-:";
            h += `|
`;
          }
        }
        return h += `
`, {
          changes: [
            { from: c.from, to: c.to },
            { from: c.from, insert: h }
          ],
          range: $.range(c.from + h.length, c.from + h.length)
        };
      }));
      n.update([u]), n.focus();
    }
    const r = Vt(
      U4,
      {
        confirm: i,
        container: t
      }
    );
    dn(r, t);
  }
}, pZ = {
  name: "quote",
  icon: Xe.quote,
  func: (n) => {
    const e = n.state, t = e.update(e.changeByRange((i) => {
      const r = e.doc.lineAt(i.from).number, s = e.doc.lineAt(i.to).number, o = [];
      let a = 0, l = e.doc.line(r).from;
      for (let u = r; u <= s; u++) {
        const c = e.doc.line(u), h = "> ";
        o.push({
          from: c.from,
          insert: h
        }), u === r && (a = c.from), l = l + c.length + h.length + 1;
      }
      return l--, {
        changes: o,
        range: $.range(a, l)
      };
    }));
    n.update([t]), n.focus();
  }
}, mZ = {
  name: "unordered-list",
  icon: Xe.listul,
  func: (n) => {
    const e = n.state, t = e.update(e.changeByRange((i) => {
      const r = e.doc.lineAt(i.from).number, s = e.doc.lineAt(i.to).number, o = [];
      let a = 0, l = e.doc.line(r).from;
      for (let u = r; u <= s; u++) {
        const c = e.doc.line(u), h = "- ";
        o.push({
          from: c.from,
          insert: h
        }), u === r && (a = c.from), l = l + c.length + h.length + 1;
      }
      return l--, {
        changes: o,
        range: $.range(a, l)
      };
    }));
    n.update([t]), n.focus();
  }
}, gZ = {
  name: "ordered-list",
  icon: Xe.listol,
  func: (n) => {
    const e = n.state, t = e.update(e.changeByRange((i) => {
      const r = e.doc.lineAt(i.from).number, s = e.doc.lineAt(i.to).number, o = [];
      let a = 0, l = e.doc.line(r).from;
      for (let u = r; u <= s; u++) {
        const c = e.doc.line(u), h = "1. ";
        o.push({
          from: c.from,
          insert: h
        }), u === r && (a = c.from), l = l + c.length + h.length + 1;
      }
      return l--, {
        changes: o,
        range: $.range(a, l)
      };
    }));
    n.update([t]), n.focus();
  }
}, OZ = {
  name: "task-list",
  icon: Xe.listtask,
  func: (n) => {
    const e = n.state, t = e.update(e.changeByRange((i) => {
      const r = e.doc.lineAt(i.from).number, s = e.doc.lineAt(i.to).number, o = [];
      let a = 0, l = e.doc.line(r).from;
      for (let u = r; u <= s; u++) {
        const c = e.doc.line(u), h = "- [ ] ";
        o.push({
          from: c.from,
          insert: h
        }), u === r && (a = c.from), l = l + c.length + h.length + 1;
      }
      return l--, {
        changes: o,
        range: $.range(a, l)
      };
    }));
    n.update([t]), n.focus();
  }
}, bZ = {
  name: "only-editor",
  icon: Xe.editor,
  active: (n, e) => !e.showViewer,
  func: (n, e) => {
    e.showViewer ? (e.showEditor = !0, e.showViewer = !1) : e.showViewer = !0;
  }
}, yZ = {
  name: "only-viewer",
  icon: Xe.viewer,
  active: (n, e) => !e.showEditor,
  func: (n, e) => {
    e.showEditor ? (e.showViewer = !0, e.showEditor = !1) : e.showEditor = !0;
  }
}, kZ = {
  name: "full-screen",
  icon: Xe.expand,
  active: (n, e) => e.fullScreen,
  func: (n, e) => {
    e.fullScreen = !e.fullScreen;
  }
}, xZ = {
  name: "help",
  icon: Xe.help,
  func: (n, e, t) => {
    const i = Vt(
      nR,
      {
        container: t,
        confirm: () => {
        }
      }
    );
    dn(i, t);
  }
}, wZ = {
  name: "math",
  icon: Xe.math,
  func: (n) => {
    const e = n.state, t = e.update(e.changeByRange((i) => ({
      changes: [
        { from: i.from, insert: " $" },
        { from: i.to, insert: "$ " }
      ],
      range: $.range(i.from + 2, i.to + 2)
    })));
    n.update([t]), n.focus();
  }
}, SZ = [rZ, sZ, oZ], vZ = [aZ, lZ, uZ, wZ], PZ = [cZ, hZ, fZ, dZ], QZ = [pZ, mZ, gZ, OZ], $Z = [bZ, yZ, kZ], CZ = [xZ];
function TZ() {
  return [
    SZ,
    vZ,
    PZ,
    QZ
  ];
}
function AZ() {
  return [
    $Z,
    CZ
  ];
}
const RZ = /* @__PURE__ */ bt({
  __name: "MEditor",
  props: /* @__PURE__ */ ea({
    plugins: { default: cf },
    disabled: { type: Boolean }
  }, {
    modelValue: {
      required: !0
    },
    modelModifiers: {}
  }),
  emits: ["update:modelValue"],
  setup(n) {
    const e = n, t = Hc(n, "modelValue"), i = Qt(() => [
      // Enable automatic line wrapping
      _.lineWrapping,
      _.theme({
        // Disable the native dashed border when codemirror is focused.
        "&.cm-focused": {
          outline: "none"
        },
        // Make the editor occupy the entire height.
        "&.cm-editor": {
          height: "100%"
        },
        // Solve the problem that codemirror cannot be scrolled when in full-screen.
        // I'm confused why z-index is set to 0 by default.
        "&.cm-scroller": {
          "z-index": "auto"
        }
      }),
      // Allow addtional plugins provided by the user.
      // Such as themes, key-binding, etc.
      ...e.plugins.codemirror || []
    ]);
    return (r, s) => (ue(), Ci(oe(_Q), {
      modelValue: t.value,
      "onUpdate:modelValue": s[0] || (s[0] = (o) => t.value = o),
      extensions: i.value,
      disabled: e.disabled
    }, null, 8, ["modelValue", "extensions", "disabled"]));
  }
});
function Wm(n) {
  if (n)
    throw n;
}
function MZ(n) {
  return n && n.__esModule && Object.prototype.hasOwnProperty.call(n, "default") ? n.default : n;
}
var Jo = Object.prototype.hasOwnProperty, Xy = Object.prototype.toString, qm = Object.defineProperty, Bm = Object.getOwnPropertyDescriptor, Vm = function(e) {
  return typeof Array.isArray == "function" ? Array.isArray(e) : Xy.call(e) === "[object Array]";
}, Ym = function(e) {
  if (!e || Xy.call(e) !== "[object Object]")
    return !1;
  var t = Jo.call(e, "constructor"), i = e.constructor && e.constructor.prototype && Jo.call(e.constructor.prototype, "isPrototypeOf");
  if (e.constructor && !t && !i)
    return !1;
  var r;
  for (r in e)
    ;
  return typeof r > "u" || Jo.call(e, r);
}, jm = function(e, t) {
  qm && t.name === "__proto__" ? qm(e, t.name, {
    enumerable: !0,
    configurable: !0,
    value: t.newValue,
    writable: !0
  }) : e[t.name] = t.newValue;
}, Um = function(e, t) {
  if (t === "__proto__")
    if (Jo.call(e, t)) {
      if (Bm)
        return Bm(e, t).value;
    } else
      return;
  return e[t];
}, ZZ = function n() {
  var e, t, i, r, s, o, a = arguments[0], l = 1, u = arguments.length, c = !1;
  for (typeof a == "boolean" && (c = a, a = arguments[1] || {}, l = 2), (a == null || typeof a != "object" && typeof a != "function") && (a = {}); l < u; ++l)
    if (e = arguments[l], e != null)
      for (t in e)
        i = Um(a, t), r = Um(e, t), a !== r && (c && r && (Ym(r) || (s = Vm(r))) ? (s ? (s = !1, o = i && Vm(i) ? i : []) : o = i && Ym(i) ? i : {}, jm(a, { name: t, newValue: n(c, o, r) })) : typeof r < "u" && jm(a, { name: t, newValue: r }));
  return a;
};
const au = /* @__PURE__ */ MZ(ZZ);
function Wc(n) {
  if (typeof n != "object" || n === null)
    return !1;
  const e = Object.getPrototypeOf(n);
  return (e === null || e === Object.prototype || Object.getPrototypeOf(e) === null) && !(Symbol.toStringTag in n) && !(Symbol.iterator in n);
}
function EZ() {
  const n = [], e = { run: t, use: i };
  return e;
  function t(...r) {
    let s = -1;
    const o = r.pop();
    if (typeof o != "function")
      throw new TypeError("Expected function as last argument, not " + o);
    a(null, ...r);
    function a(l, ...u) {
      const c = n[++s];
      let h = -1;
      if (l) {
        o(l);
        return;
      }
      for (; ++h < r.length; )
        (u[h] === null || u[h] === void 0) && (u[h] = r[h]);
      r = u, c ? zZ(c, a)(...u) : o(null, ...u);
    }
  }
  function i(r) {
    if (typeof r != "function")
      throw new TypeError(
        "Expected `middelware` to be a function, not " + r
      );
    return n.push(r), e;
  }
}
function zZ(n, e) {
  let t;
  return i;
  function i(...o) {
    const a = n.length > o.length;
    let l;
    a && o.push(r);
    try {
      l = n.apply(this, o);
    } catch (u) {
      const c = (
        /** @type {Error} */
        u
      );
      if (a && t)
        throw c;
      return r(c);
    }
    a || (l && l.then && typeof l.then == "function" ? l.then(s, r) : l instanceof Error ? r(l) : s(l));
  }
  function r(o, ...a) {
    t || (t = !0, e(o, ...a));
  }
  function s(o) {
    r(null, o);
  }
}
function ns(n) {
  return !n || typeof n != "object" ? "" : "position" in n || "type" in n ? Fm(n.position) : "start" in n || "end" in n ? Fm(n) : "line" in n || "column" in n ? qc(n) : "";
}
function qc(n) {
  return Gm(n && n.line) + ":" + Gm(n && n.column);
}
function Fm(n) {
  return qc(n && n.start) + "-" + qc(n && n.end);
}
function Gm(n) {
  return n && typeof n == "number" ? n : 1;
}
class yt extends Error {
  /**
   * Create a message for `reason`.
   *
   * > 🪦 **Note**: also has obsolete signatures.
   *
   * @overload
   * @param {string} reason
   * @param {Options | null | undefined} [options]
   * @returns
   *
   * @overload
   * @param {string} reason
   * @param {Node | NodeLike | null | undefined} parent
   * @param {string | null | undefined} [origin]
   * @returns
   *
   * @overload
   * @param {string} reason
   * @param {Point | Position | null | undefined} place
   * @param {string | null | undefined} [origin]
   * @returns
   *
   * @overload
   * @param {string} reason
   * @param {string | null | undefined} [origin]
   * @returns
   *
   * @overload
   * @param {Error | VFileMessage} cause
   * @param {Node | NodeLike | null | undefined} parent
   * @param {string | null | undefined} [origin]
   * @returns
   *
   * @overload
   * @param {Error | VFileMessage} cause
   * @param {Point | Position | null | undefined} place
   * @param {string | null | undefined} [origin]
   * @returns
   *
   * @overload
   * @param {Error | VFileMessage} cause
   * @param {string | null | undefined} [origin]
   * @returns
   *
   * @param {Error | VFileMessage | string} causeOrReason
   *   Reason for message, should use markdown.
   * @param {Node | NodeLike | Options | Point | Position | string | null | undefined} [optionsOrParentOrPlace]
   *   Configuration (optional).
   * @param {string | null | undefined} [origin]
   *   Place in code where the message originates (example:
   *   `'my-package:my-rule'` or `'my-rule'`).
   * @returns
   *   Instance of `VFileMessage`.
   */
  // eslint-disable-next-line complexity
  constructor(e, t, i) {
    super(), typeof t == "string" && (i = t, t = void 0);
    let r = "", s = {}, o = !1;
    if (t && ("line" in t && "column" in t ? s = { place: t } : "start" in t && "end" in t ? s = { place: t } : "type" in t ? s = {
      ancestors: [t],
      place: t.position
    } : s = { ...t }), typeof e == "string" ? r = e : !s.cause && e && (o = !0, r = e.message, s.cause = e), !s.ruleId && !s.source && typeof i == "string") {
      const l = i.indexOf(":");
      l === -1 ? s.ruleId = i : (s.source = i.slice(0, l), s.ruleId = i.slice(l + 1));
    }
    if (!s.place && s.ancestors && s.ancestors) {
      const l = s.ancestors[s.ancestors.length - 1];
      l && (s.place = l.position);
    }
    const a = s.place && "start" in s.place ? s.place.start : s.place;
    this.ancestors = s.ancestors || void 0, this.cause = s.cause || void 0, this.column = a ? a.column : void 0, this.fatal = void 0, this.file, this.message = r, this.line = a ? a.line : void 0, this.name = ns(s.place) || "1:1", this.place = s.place || void 0, this.reason = this.message, this.ruleId = s.ruleId || void 0, this.source = s.source || void 0, this.stack = o && s.cause && typeof s.cause.stack == "string" ? s.cause.stack : "", this.actual, this.expected, this.note, this.url;
  }
}
yt.prototype.file = "";
yt.prototype.name = "";
yt.prototype.reason = "";
yt.prototype.message = "";
yt.prototype.stack = "";
yt.prototype.column = void 0;
yt.prototype.line = void 0;
yt.prototype.ancestors = void 0;
yt.prototype.cause = void 0;
yt.prototype.fatal = void 0;
yt.prototype.place = void 0;
yt.prototype.ruleId = void 0;
yt.prototype.source = void 0;
const rn = { basename: DZ, dirname: IZ, extname: LZ, join: _Z, sep: "/" };
function DZ(n, e) {
  if (e !== void 0 && typeof e != "string")
    throw new TypeError('"ext" argument must be a string');
  Ys(n);
  let t = 0, i = -1, r = n.length, s;
  if (e === void 0 || e.length === 0 || e.length > n.length) {
    for (; r--; )
      if (n.codePointAt(r) === 47) {
        if (s) {
          t = r + 1;
          break;
        }
      } else
        i < 0 && (s = !0, i = r + 1);
    return i < 0 ? "" : n.slice(t, i);
  }
  if (e === n)
    return "";
  let o = -1, a = e.length - 1;
  for (; r--; )
    if (n.codePointAt(r) === 47) {
      if (s) {
        t = r + 1;
        break;
      }
    } else
      o < 0 && (s = !0, o = r + 1), a > -1 && (n.codePointAt(r) === e.codePointAt(a--) ? a < 0 && (i = r) : (a = -1, i = o));
  return t === i ? i = o : i < 0 && (i = n.length), n.slice(t, i);
}
function IZ(n) {
  if (Ys(n), n.length === 0)
    return ".";
  let e = -1, t = n.length, i;
  for (; --t; )
    if (n.codePointAt(t) === 47) {
      if (i) {
        e = t;
        break;
      }
    } else
      i || (i = !0);
  return e < 0 ? n.codePointAt(0) === 47 ? "/" : "." : e === 1 && n.codePointAt(0) === 47 ? "//" : n.slice(0, e);
}
function LZ(n) {
  Ys(n);
  let e = n.length, t = -1, i = 0, r = -1, s = 0, o;
  for (; e--; ) {
    const a = n.codePointAt(e);
    if (a === 47) {
      if (o) {
        i = e + 1;
        break;
      }
      continue;
    }
    t < 0 && (o = !0, t = e + 1), a === 46 ? r < 0 ? r = e : s !== 1 && (s = 1) : r > -1 && (s = -1);
  }
  return r < 0 || t < 0 || // We saw a non-dot character immediately before the dot.
  s === 0 || // The (right-most) trimmed path component is exactly `..`.
  s === 1 && r === t - 1 && r === i + 1 ? "" : n.slice(r, t);
}
function _Z(...n) {
  let e = -1, t;
  for (; ++e < n.length; )
    Ys(n[e]), n[e] && (t = t === void 0 ? n[e] : t + "/" + n[e]);
  return t === void 0 ? "." : XZ(t);
}
function XZ(n) {
  Ys(n);
  const e = n.codePointAt(0) === 47;
  let t = NZ(n, !e);
  return t.length === 0 && !e && (t = "."), t.length > 0 && n.codePointAt(n.length - 1) === 47 && (t += "/"), e ? "/" + t : t;
}
function NZ(n, e) {
  let t = "", i = 0, r = -1, s = 0, o = -1, a, l;
  for (; ++o <= n.length; ) {
    if (o < n.length)
      a = n.codePointAt(o);
    else {
      if (a === 47)
        break;
      a = 47;
    }
    if (a === 47) {
      if (!(r === o - 1 || s === 1))
        if (r !== o - 1 && s === 2) {
          if (t.length < 2 || i !== 2 || t.codePointAt(t.length - 1) !== 46 || t.codePointAt(t.length - 2) !== 46) {
            if (t.length > 2) {
              if (l = t.lastIndexOf("/"), l !== t.length - 1) {
                l < 0 ? (t = "", i = 0) : (t = t.slice(0, l), i = t.length - 1 - t.lastIndexOf("/")), r = o, s = 0;
                continue;
              }
            } else if (t.length > 0) {
              t = "", i = 0, r = o, s = 0;
              continue;
            }
          }
          e && (t = t.length > 0 ? t + "/.." : "..", i = 2);
        } else
          t.length > 0 ? t += "/" + n.slice(r + 1, o) : t = n.slice(r + 1, o), i = o - r - 1;
      r = o, s = 0;
    } else
      a === 46 && s > -1 ? s++ : s = -1;
  }
  return t;
}
function Ys(n) {
  if (typeof n != "string")
    throw new TypeError(
      "Path must be a string. Received " + JSON.stringify(n)
    );
}
const WZ = { cwd: qZ };
function qZ() {
  return "/";
}
function Bc(n) {
  return !!(n !== null && typeof n == "object" && "href" in n && n.href && "protocol" in n && n.protocol && // @ts-expect-error: indexing is fine.
  n.auth === void 0);
}
function BZ(n) {
  if (typeof n == "string")
    n = new URL(n);
  else if (!Bc(n)) {
    const e = new TypeError(
      'The "path" argument must be of type string or an instance of URL. Received `' + n + "`"
    );
    throw e.code = "ERR_INVALID_ARG_TYPE", e;
  }
  if (n.protocol !== "file:") {
    const e = new TypeError("The URL must be of scheme file");
    throw e.code = "ERR_INVALID_URL_SCHEME", e;
  }
  return VZ(n);
}
function VZ(n) {
  if (n.hostname !== "") {
    const i = new TypeError(
      'File URL host must be "localhost" or empty on darwin'
    );
    throw i.code = "ERR_INVALID_FILE_URL_HOST", i;
  }
  const e = n.pathname;
  let t = -1;
  for (; ++t < e.length; )
    if (e.codePointAt(t) === 37 && e.codePointAt(t + 1) === 50) {
      const i = e.codePointAt(t + 2);
      if (i === 70 || i === 102) {
        const r = new TypeError(
          "File URL path must not include encoded / characters"
        );
        throw r.code = "ERR_INVALID_FILE_URL_PATH", r;
      }
    }
  return decodeURIComponent(e);
}
const lu = (
  /** @type {const} */
  [
    "history",
    "path",
    "basename",
    "stem",
    "extname",
    "dirname"
  ]
);
class YZ {
  /**
   * Create a new virtual file.
   *
   * `options` is treated as:
   *
   * *   `string` or `Uint8Array` — `{value: options}`
   * *   `URL` — `{path: options}`
   * *   `VFile` — shallow copies its data over to the new file
   * *   `object` — all fields are shallow copied over to the new file
   *
   * Path related fields are set in the following order (least specific to
   * most specific): `history`, `path`, `basename`, `stem`, `extname`,
   * `dirname`.
   *
   * You cannot set `dirname` or `extname` without setting either `history`,
   * `path`, `basename`, or `stem` too.
   *
   * @param {Compatible | null | undefined} [value]
   *   File value.
   * @returns
   *   New instance.
   */
  constructor(e) {
    let t;
    e ? Bc(e) ? t = { path: e } : typeof e == "string" || jZ(e) ? t = { value: e } : t = e : t = {}, this.cwd = WZ.cwd(), this.data = {}, this.history = [], this.messages = [], this.value, this.map, this.result, this.stored;
    let i = -1;
    for (; ++i < lu.length; ) {
      const s = lu[i];
      s in t && t[s] !== void 0 && t[s] !== null && (this[s] = s === "history" ? [...t[s]] : t[s]);
    }
    let r;
    for (r in t)
      lu.includes(r) || (this[r] = t[r]);
  }
  /**
   * Get the basename (including extname) (example: `'index.min.js'`).
   *
   * @returns {string | undefined}
   *   Basename.
   */
  get basename() {
    return typeof this.path == "string" ? rn.basename(this.path) : void 0;
  }
  /**
   * Set basename (including extname) (`'index.min.js'`).
   *
   * Cannot contain path separators (`'/'` on unix, macOS, and browsers, `'\'`
   * on windows).
   * Cannot be nullified (use `file.path = file.dirname` instead).
   *
   * @param {string} basename
   *   Basename.
   * @returns {undefined}
   *   Nothing.
   */
  set basename(e) {
    cu(e, "basename"), uu(e, "basename"), this.path = rn.join(this.dirname || "", e);
  }
  /**
   * Get the parent path (example: `'~'`).
   *
   * @returns {string | undefined}
   *   Dirname.
   */
  get dirname() {
    return typeof this.path == "string" ? rn.dirname(this.path) : void 0;
  }
  /**
   * Set the parent path (example: `'~'`).
   *
   * Cannot be set if there’s no `path` yet.
   *
   * @param {string | undefined} dirname
   *   Dirname.
   * @returns {undefined}
   *   Nothing.
   */
  set dirname(e) {
    Hm(this.basename, "dirname"), this.path = rn.join(e || "", this.basename);
  }
  /**
   * Get the extname (including dot) (example: `'.js'`).
   *
   * @returns {string | undefined}
   *   Extname.
   */
  get extname() {
    return typeof this.path == "string" ? rn.extname(this.path) : void 0;
  }
  /**
   * Set the extname (including dot) (example: `'.js'`).
   *
   * Cannot contain path separators (`'/'` on unix, macOS, and browsers, `'\'`
   * on windows).
   * Cannot be set if there’s no `path` yet.
   *
   * @param {string | undefined} extname
   *   Extname.
   * @returns {undefined}
   *   Nothing.
   */
  set extname(e) {
    if (uu(e, "extname"), Hm(this.dirname, "extname"), e) {
      if (e.codePointAt(0) !== 46)
        throw new Error("`extname` must start with `.`");
      if (e.includes(".", 1))
        throw new Error("`extname` cannot contain multiple dots");
    }
    this.path = rn.join(this.dirname, this.stem + (e || ""));
  }
  /**
   * Get the full path (example: `'~/index.min.js'`).
   *
   * @returns {string}
   *   Path.
   */
  get path() {
    return this.history[this.history.length - 1];
  }
  /**
   * Set the full path (example: `'~/index.min.js'`).
   *
   * Cannot be nullified.
   * You can set a file URL (a `URL` object with a `file:` protocol) which will
   * be turned into a path with `url.fileURLToPath`.
   *
   * @param {URL | string} path
   *   Path.
   * @returns {undefined}
   *   Nothing.
   */
  set path(e) {
    Bc(e) && (e = BZ(e)), cu(e, "path"), this.path !== e && this.history.push(e);
  }
  /**
   * Get the stem (basename w/o extname) (example: `'index.min'`).
   *
   * @returns {string | undefined}
   *   Stem.
   */
  get stem() {
    return typeof this.path == "string" ? rn.basename(this.path, this.extname) : void 0;
  }
  /**
   * Set the stem (basename w/o extname) (example: `'index.min'`).
   *
   * Cannot contain path separators (`'/'` on unix, macOS, and browsers, `'\'`
   * on windows).
   * Cannot be nullified (use `file.path = file.dirname` instead).
   *
   * @param {string} stem
   *   Stem.
   * @returns {undefined}
   *   Nothing.
   */
  set stem(e) {
    cu(e, "stem"), uu(e, "stem"), this.path = rn.join(this.dirname || "", e + (this.extname || ""));
  }
  // Normal prototypal methods.
  /**
   * Create a fatal message for `reason` associated with the file.
   *
   * The `fatal` field of the message is set to `true` (error; file not usable)
   * and the `file` field is set to the current file path.
   * The message is added to the `messages` field on `file`.
   *
   * > 🪦 **Note**: also has obsolete signatures.
   *
   * @overload
   * @param {string} reason
   * @param {MessageOptions | null | undefined} [options]
   * @returns {never}
   *
   * @overload
   * @param {string} reason
   * @param {Node | NodeLike | null | undefined} parent
   * @param {string | null | undefined} [origin]
   * @returns {never}
   *
   * @overload
   * @param {string} reason
   * @param {Point | Position | null | undefined} place
   * @param {string | null | undefined} [origin]
   * @returns {never}
   *
   * @overload
   * @param {string} reason
   * @param {string | null | undefined} [origin]
   * @returns {never}
   *
   * @overload
   * @param {Error | VFileMessage} cause
   * @param {Node | NodeLike | null | undefined} parent
   * @param {string | null | undefined} [origin]
   * @returns {never}
   *
   * @overload
   * @param {Error | VFileMessage} cause
   * @param {Point | Position | null | undefined} place
   * @param {string | null | undefined} [origin]
   * @returns {never}
   *
   * @overload
   * @param {Error | VFileMessage} cause
   * @param {string | null | undefined} [origin]
   * @returns {never}
   *
   * @param {Error | VFileMessage | string} causeOrReason
   *   Reason for message, should use markdown.
   * @param {Node | NodeLike | MessageOptions | Point | Position | string | null | undefined} [optionsOrParentOrPlace]
   *   Configuration (optional).
   * @param {string | null | undefined} [origin]
   *   Place in code where the message originates (example:
   *   `'my-package:my-rule'` or `'my-rule'`).
   * @returns {never}
   *   Never.
   * @throws {VFileMessage}
   *   Message.
   */
  fail(e, t, i) {
    const r = this.message(e, t, i);
    throw r.fatal = !0, r;
  }
  /**
   * Create an info message for `reason` associated with the file.
   *
   * The `fatal` field of the message is set to `undefined` (info; change
   * likely not needed) and the `file` field is set to the current file path.
   * The message is added to the `messages` field on `file`.
   *
   * > 🪦 **Note**: also has obsolete signatures.
   *
   * @overload
   * @param {string} reason
   * @param {MessageOptions | null | undefined} [options]
   * @returns {VFileMessage}
   *
   * @overload
   * @param {string} reason
   * @param {Node | NodeLike | null | undefined} parent
   * @param {string | null | undefined} [origin]
   * @returns {VFileMessage}
   *
   * @overload
   * @param {string} reason
   * @param {Point | Position | null | undefined} place
   * @param {string | null | undefined} [origin]
   * @returns {VFileMessage}
   *
   * @overload
   * @param {string} reason
   * @param {string | null | undefined} [origin]
   * @returns {VFileMessage}
   *
   * @overload
   * @param {Error | VFileMessage} cause
   * @param {Node | NodeLike | null | undefined} parent
   * @param {string | null | undefined} [origin]
   * @returns {VFileMessage}
   *
   * @overload
   * @param {Error | VFileMessage} cause
   * @param {Point | Position | null | undefined} place
   * @param {string | null | undefined} [origin]
   * @returns {VFileMessage}
   *
   * @overload
   * @param {Error | VFileMessage} cause
   * @param {string | null | undefined} [origin]
   * @returns {VFileMessage}
   *
   * @param {Error | VFileMessage | string} causeOrReason
   *   Reason for message, should use markdown.
   * @param {Node | NodeLike | MessageOptions | Point | Position | string | null | undefined} [optionsOrParentOrPlace]
   *   Configuration (optional).
   * @param {string | null | undefined} [origin]
   *   Place in code where the message originates (example:
   *   `'my-package:my-rule'` or `'my-rule'`).
   * @returns {VFileMessage}
   *   Message.
   */
  info(e, t, i) {
    const r = this.message(e, t, i);
    return r.fatal = void 0, r;
  }
  /**
   * Create a message for `reason` associated with the file.
   *
   * The `fatal` field of the message is set to `false` (warning; change may be
   * needed) and the `file` field is set to the current file path.
   * The message is added to the `messages` field on `file`.
   *
   * > 🪦 **Note**: also has obsolete signatures.
   *
   * @overload
   * @param {string} reason
   * @param {MessageOptions | null | undefined} [options]
   * @returns {VFileMessage}
   *
   * @overload
   * @param {string} reason
   * @param {Node | NodeLike | null | undefined} parent
   * @param {string | null | undefined} [origin]
   * @returns {VFileMessage}
   *
   * @overload
   * @param {string} reason
   * @param {Point | Position | null | undefined} place
   * @param {string | null | undefined} [origin]
   * @returns {VFileMessage}
   *
   * @overload
   * @param {string} reason
   * @param {string | null | undefined} [origin]
   * @returns {VFileMessage}
   *
   * @overload
   * @param {Error | VFileMessage} cause
   * @param {Node | NodeLike | null | undefined} parent
   * @param {string | null | undefined} [origin]
   * @returns {VFileMessage}
   *
   * @overload
   * @param {Error | VFileMessage} cause
   * @param {Point | Position | null | undefined} place
   * @param {string | null | undefined} [origin]
   * @returns {VFileMessage}
   *
   * @overload
   * @param {Error | VFileMessage} cause
   * @param {string | null | undefined} [origin]
   * @returns {VFileMessage}
   *
   * @param {Error | VFileMessage | string} causeOrReason
   *   Reason for message, should use markdown.
   * @param {Node | NodeLike | MessageOptions | Point | Position | string | null | undefined} [optionsOrParentOrPlace]
   *   Configuration (optional).
   * @param {string | null | undefined} [origin]
   *   Place in code where the message originates (example:
   *   `'my-package:my-rule'` or `'my-rule'`).
   * @returns {VFileMessage}
   *   Message.
   */
  message(e, t, i) {
    const r = new yt(
      // @ts-expect-error: the overloads are fine.
      e,
      t,
      i
    );
    return this.path && (r.name = this.path + ":" + r.name, r.file = this.path), r.fatal = !1, this.messages.push(r), r;
  }
  /**
   * Serialize the file.
   *
   * > **Note**: which encodings are supported depends on the engine.
   * > For info on Node.js, see:
   * > <https://nodejs.org/api/util.html#whatwg-supported-encodings>.
   *
   * @param {string | null | undefined} [encoding='utf8']
   *   Character encoding to understand `value` as when it’s a `Uint8Array`
   *   (default: `'utf-8'`).
   * @returns {string}
   *   Serialized file.
   */
  toString(e) {
    return this.value === void 0 ? "" : typeof this.value == "string" ? this.value : new TextDecoder(e || void 0).decode(this.value);
  }
}
function uu(n, e) {
  if (n && n.includes(rn.sep))
    throw new Error(
      "`" + e + "` cannot be a path: did not expect `" + rn.sep + "`"
    );
}
function cu(n, e) {
  if (!n)
    throw new Error("`" + e + "` cannot be empty");
}
function Hm(n, e) {
  if (!n)
    throw new Error("Setting `" + e + "` requires `path` to be set too");
}
function jZ(n) {
  return !!(n && typeof n == "object" && "byteLength" in n && "byteOffset" in n);
}
const UZ = (
  /**
   * @type {new <Parameters extends Array<unknown>, Result>(property: string | symbol) => (...parameters: Parameters) => Result}
   */
  /** @type {unknown} */
  /**
   * @this {Function}
   * @param {string | symbol} property
   * @returns {(...parameters: Array<unknown>) => unknown}
   */
  function(n) {
    const i = (
      /** @type {Record<string | symbol, Function>} */
      // Prototypes do exist.
      // type-coverage:ignore-next-line
      this.constructor.prototype
    ), r = i[n], s = function() {
      return r.apply(s, arguments);
    };
    Object.setPrototypeOf(s, i);
    const o = Object.getOwnPropertyNames(r);
    for (const a of o) {
      const l = Object.getOwnPropertyDescriptor(r, a);
      l && Object.defineProperty(s, a, l);
    }
    return s;
  }
), FZ = {}.hasOwnProperty;
class hf extends UZ {
  /**
   * Create a processor.
   */
  constructor() {
    super("copy"), this.Compiler = void 0, this.Parser = void 0, this.attachers = [], this.compiler = void 0, this.freezeIndex = -1, this.frozen = void 0, this.namespace = {}, this.parser = void 0, this.transformers = EZ();
  }
  /**
   * Copy a processor.
   *
   * @deprecated
   *   This is a private internal method and should not be used.
   * @returns {Processor<ParseTree, HeadTree, TailTree, CompileTree, CompileResult>}
   *   New *unfrozen* processor ({@link Processor `Processor`}) that is
   *   configured to work the same as its ancestor.
   *   When the descendant processor is configured in the future it does not
   *   affect the ancestral processor.
   */
  copy() {
    const e = (
      /** @type {Processor<ParseTree, HeadTree, TailTree, CompileTree, CompileResult>} */
      new hf()
    );
    let t = -1;
    for (; ++t < this.attachers.length; ) {
      const i = this.attachers[t];
      e.use(...i);
    }
    return e.data(au(!0, {}, this.namespace)), e;
  }
  /**
   * Configure the processor with info available to all plugins.
   * Information is stored in an object.
   *
   * Typically, options can be given to a specific plugin, but sometimes it
   * makes sense to have information shared with several plugins.
   * For example, a list of HTML elements that are self-closing, which is
   * needed during all phases.
   *
   * > 👉 **Note**: setting information cannot occur on *frozen* processors.
   * > Call the processor first to create a new unfrozen processor.
   *
   * > 👉 **Note**: to register custom data in TypeScript, augment the
   * > {@link Data `Data`} interface.
   *
   * @example
   *   This example show how to get and set info:
   *
   *   ```js
   *   import {unified} from 'unified'
   *
   *   const processor = unified().data('alpha', 'bravo')
   *
   *   processor.data('alpha') // => 'bravo'
   *
   *   processor.data() // => {alpha: 'bravo'}
   *
   *   processor.data({charlie: 'delta'})
   *
   *   processor.data() // => {charlie: 'delta'}
   *   ```
   *
   * @template {keyof Data} Key
   *
   * @overload
   * @returns {Data}
   *
   * @overload
   * @param {Data} dataset
   * @returns {Processor<ParseTree, HeadTree, TailTree, CompileTree, CompileResult>}
   *
   * @overload
   * @param {Key} key
   * @returns {Data[Key]}
   *
   * @overload
   * @param {Key} key
   * @param {Data[Key]} value
   * @returns {Processor<ParseTree, HeadTree, TailTree, CompileTree, CompileResult>}
   *
   * @param {Data | Key} [key]
   *   Key to get or set, or entire dataset to set, or nothing to get the
   *   entire dataset (optional).
   * @param {Data[Key]} [value]
   *   Value to set (optional).
   * @returns {unknown}
   *   The current processor when setting, the value at `key` when getting, or
   *   the entire dataset when getting without key.
   */
  data(e, t) {
    return typeof e == "string" ? arguments.length === 2 ? (du("data", this.frozen), this.namespace[e] = t, this) : FZ.call(this.namespace, e) && this.namespace[e] || void 0 : e ? (du("data", this.frozen), this.namespace = e, this) : this.namespace;
  }
  /**
   * Freeze a processor.
   *
   * Frozen processors are meant to be extended and not to be configured
   * directly.
   *
   * When a processor is frozen it cannot be unfrozen.
   * New processors working the same way can be created by calling the
   * processor.
   *
   * It’s possible to freeze processors explicitly by calling `.freeze()`.
   * Processors freeze automatically when `.parse()`, `.run()`, `.runSync()`,
   * `.stringify()`, `.process()`, or `.processSync()` are called.
   *
   * @returns {Processor<ParseTree, HeadTree, TailTree, CompileTree, CompileResult>}
   *   The current processor.
   */
  freeze() {
    if (this.frozen)
      return this;
    const e = (
      /** @type {Processor} */
      /** @type {unknown} */
      this
    );
    for (; ++this.freezeIndex < this.attachers.length; ) {
      const [t, ...i] = this.attachers[this.freezeIndex];
      if (i[0] === !1)
        continue;
      i[0] === !0 && (i[0] = void 0);
      const r = t.call(e, ...i);
      typeof r == "function" && this.transformers.use(r);
    }
    return this.frozen = !0, this.freezeIndex = Number.POSITIVE_INFINITY, this;
  }
  /**
   * Parse text to a syntax tree.
   *
   * > 👉 **Note**: `parse` freezes the processor if not already *frozen*.
   *
   * > 👉 **Note**: `parse` performs the parse phase, not the run phase or other
   * > phases.
   *
   * @param {Compatible | undefined} [file]
   *   file to parse (optional); typically `string` or `VFile`; any value
   *   accepted as `x` in `new VFile(x)`.
   * @returns {ParseTree extends undefined ? Node : ParseTree}
   *   Syntax tree representing `file`.
   */
  parse(e) {
    this.freeze();
    const t = Mo(e), i = this.parser || this.Parser;
    return hu("parse", i), i(String(t), t);
  }
  /**
   * Process the given file as configured on the processor.
   *
   * > 👉 **Note**: `process` freezes the processor if not already *frozen*.
   *
   * > 👉 **Note**: `process` performs the parse, run, and stringify phases.
   *
   * @overload
   * @param {Compatible | undefined} file
   * @param {ProcessCallback<VFileWithOutput<CompileResult>>} done
   * @returns {undefined}
   *
   * @overload
   * @param {Compatible | undefined} [file]
   * @returns {Promise<VFileWithOutput<CompileResult>>}
   *
   * @param {Compatible | undefined} [file]
   *   File (optional); typically `string` or `VFile`]; any value accepted as
   *   `x` in `new VFile(x)`.
   * @param {ProcessCallback<VFileWithOutput<CompileResult>> | undefined} [done]
   *   Callback (optional).
   * @returns {Promise<VFile> | undefined}
   *   Nothing if `done` is given.
   *   Otherwise a promise, rejected with a fatal error or resolved with the
   *   processed file.
   *
   *   The parsed, transformed, and compiled value is available at
   *   `file.value` (see note).
   *
   *   > 👉 **Note**: unified typically compiles by serializing: most
   *   > compilers return `string` (or `Uint8Array`).
   *   > Some compilers, such as the one configured with
   *   > [`rehype-react`][rehype-react], return other values (in this case, a
   *   > React tree).
   *   > If you’re using a compiler that doesn’t serialize, expect different
   *   > result values.
   *   >
   *   > To register custom results in TypeScript, add them to
   *   > {@link CompileResultMap `CompileResultMap`}.
   *
   *   [rehype-react]: https://github.com/rehypejs/rehype-react
   */
  process(e, t) {
    const i = this;
    return this.freeze(), hu("process", this.parser || this.Parser), fu("process", this.compiler || this.Compiler), t ? r(void 0, t) : new Promise(r);
    function r(s, o) {
      const a = Mo(e), l = (
        /** @type {HeadTree extends undefined ? Node : HeadTree} */
        /** @type {unknown} */
        i.parse(a)
      );
      i.run(l, a, function(c, h, f) {
        if (c || !h || !f)
          return u(c);
        const d = (
          /** @type {CompileTree extends undefined ? Node : CompileTree} */
          /** @type {unknown} */
          h
        ), p = i.stringify(d, f);
        KZ(p) ? f.value = p : f.result = p, u(
          c,
          /** @type {VFileWithOutput<CompileResult>} */
          f
        );
      });
      function u(c, h) {
        c || !h ? o(c) : s ? s(h) : t(void 0, h);
      }
    }
  }
  /**
   * Process the given file as configured on the processor.
   *
   * An error is thrown if asynchronous transforms are configured.
   *
   * > 👉 **Note**: `processSync` freezes the processor if not already *frozen*.
   *
   * > 👉 **Note**: `processSync` performs the parse, run, and stringify phases.
   *
   * @param {Compatible | undefined} [file]
   *   File (optional); typically `string` or `VFile`; any value accepted as
   *   `x` in `new VFile(x)`.
   * @returns {VFileWithOutput<CompileResult>}
   *   The processed file.
   *
   *   The parsed, transformed, and compiled value is available at
   *   `file.value` (see note).
   *
   *   > 👉 **Note**: unified typically compiles by serializing: most
   *   > compilers return `string` (or `Uint8Array`).
   *   > Some compilers, such as the one configured with
   *   > [`rehype-react`][rehype-react], return other values (in this case, a
   *   > React tree).
   *   > If you’re using a compiler that doesn’t serialize, expect different
   *   > result values.
   *   >
   *   > To register custom results in TypeScript, add them to
   *   > {@link CompileResultMap `CompileResultMap`}.
   *
   *   [rehype-react]: https://github.com/rehypejs/rehype-react
   */
  processSync(e) {
    let t = !1, i;
    return this.freeze(), hu("processSync", this.parser || this.Parser), fu("processSync", this.compiler || this.Compiler), this.process(e, r), Jm("processSync", "process", t), i;
    function r(s, o) {
      t = !0, Wm(s), i = o;
    }
  }
  /**
   * Run *transformers* on a syntax tree.
   *
   * > 👉 **Note**: `run` freezes the processor if not already *frozen*.
   *
   * > 👉 **Note**: `run` performs the run phase, not other phases.
   *
   * @overload
   * @param {HeadTree extends undefined ? Node : HeadTree} tree
   * @param {RunCallback<TailTree extends undefined ? Node : TailTree>} done
   * @returns {undefined}
   *
   * @overload
   * @param {HeadTree extends undefined ? Node : HeadTree} tree
   * @param {Compatible | undefined} file
   * @param {RunCallback<TailTree extends undefined ? Node : TailTree>} done
   * @returns {undefined}
   *
   * @overload
   * @param {HeadTree extends undefined ? Node : HeadTree} tree
   * @param {Compatible | undefined} [file]
   * @returns {Promise<TailTree extends undefined ? Node : TailTree>}
   *
   * @param {HeadTree extends undefined ? Node : HeadTree} tree
   *   Tree to transform and inspect.
   * @param {(
   *   RunCallback<TailTree extends undefined ? Node : TailTree> |
   *   Compatible
   * )} [file]
   *   File associated with `node` (optional); any value accepted as `x` in
   *   `new VFile(x)`.
   * @param {RunCallback<TailTree extends undefined ? Node : TailTree>} [done]
   *   Callback (optional).
   * @returns {Promise<TailTree extends undefined ? Node : TailTree> | undefined}
   *   Nothing if `done` is given.
   *   Otherwise, a promise rejected with a fatal error or resolved with the
   *   transformed tree.
   */
  run(e, t, i) {
    Km(e), this.freeze();
    const r = this.transformers;
    return !i && typeof t == "function" && (i = t, t = void 0), i ? s(void 0, i) : new Promise(s);
    function s(o, a) {
      const l = Mo(t);
      r.run(e, l, u);
      function u(c, h, f) {
        const d = (
          /** @type {TailTree extends undefined ? Node : TailTree} */
          h || e
        );
        c ? a(c) : o ? o(d) : i(void 0, d, f);
      }
    }
  }
  /**
   * Run *transformers* on a syntax tree.
   *
   * An error is thrown if asynchronous transforms are configured.
   *
   * > 👉 **Note**: `runSync` freezes the processor if not already *frozen*.
   *
   * > 👉 **Note**: `runSync` performs the run phase, not other phases.
   *
   * @param {HeadTree extends undefined ? Node : HeadTree} tree
   *   Tree to transform and inspect.
   * @param {Compatible | undefined} [file]
   *   File associated with `node` (optional); any value accepted as `x` in
   *   `new VFile(x)`.
   * @returns {TailTree extends undefined ? Node : TailTree}
   *   Transformed tree.
   */
  runSync(e, t) {
    let i = !1, r;
    return this.run(e, t, s), Jm("runSync", "run", i), r;
    function s(o, a) {
      Wm(o), r = a, i = !0;
    }
  }
  /**
   * Compile a syntax tree.
   *
   * > 👉 **Note**: `stringify` freezes the processor if not already *frozen*.
   *
   * > 👉 **Note**: `stringify` performs the stringify phase, not the run phase
   * > or other phases.
   *
   * @param {CompileTree extends undefined ? Node : CompileTree} tree
   *   Tree to compile.
   * @param {Compatible | undefined} [file]
   *   File associated with `node` (optional); any value accepted as `x` in
   *   `new VFile(x)`.
   * @returns {CompileResult extends undefined ? Value : CompileResult}
   *   Textual representation of the tree (see note).
   *
   *   > 👉 **Note**: unified typically compiles by serializing: most compilers
   *   > return `string` (or `Uint8Array`).
   *   > Some compilers, such as the one configured with
   *   > [`rehype-react`][rehype-react], return other values (in this case, a
   *   > React tree).
   *   > If you’re using a compiler that doesn’t serialize, expect different
   *   > result values.
   *   >
   *   > To register custom results in TypeScript, add them to
   *   > {@link CompileResultMap `CompileResultMap`}.
   *
   *   [rehype-react]: https://github.com/rehypejs/rehype-react
   */
  stringify(e, t) {
    this.freeze();
    const i = Mo(t), r = this.compiler || this.Compiler;
    return fu("stringify", r), Km(e), r(e, i);
  }
  /**
   * Configure the processor to use a plugin, a list of usable values, or a
   * preset.
   *
   * If the processor is already using a plugin, the previous plugin
   * configuration is changed based on the options that are passed in.
   * In other words, the plugin is not added a second time.
   *
   * > 👉 **Note**: `use` cannot be called on *frozen* processors.
   * > Call the processor first to create a new unfrozen processor.
   *
   * @example
   *   There are many ways to pass plugins to `.use()`.
   *   This example gives an overview:
   *
   *   ```js
   *   import {unified} from 'unified'
   *
   *   unified()
   *     // Plugin with options:
   *     .use(pluginA, {x: true, y: true})
   *     // Passing the same plugin again merges configuration (to `{x: true, y: false, z: true}`):
   *     .use(pluginA, {y: false, z: true})
   *     // Plugins:
   *     .use([pluginB, pluginC])
   *     // Two plugins, the second with options:
   *     .use([pluginD, [pluginE, {}]])
   *     // Preset with plugins and settings:
   *     .use({plugins: [pluginF, [pluginG, {}]], settings: {position: false}})
   *     // Settings only:
   *     .use({settings: {position: false}})
   *   ```
   *
   * @template {Array<unknown>} [Parameters=[]]
   * @template {Node | string | undefined} [Input=undefined]
   * @template [Output=Input]
   *
   * @overload
   * @param {Preset | null | undefined} [preset]
   * @returns {Processor<ParseTree, HeadTree, TailTree, CompileTree, CompileResult>}
   *
   * @overload
   * @param {PluggableList} list
   * @returns {Processor<ParseTree, HeadTree, TailTree, CompileTree, CompileResult>}
   *
   * @overload
   * @param {Plugin<Parameters, Input, Output>} plugin
   * @param {...(Parameters | [boolean])} parameters
   * @returns {UsePlugin<ParseTree, HeadTree, TailTree, CompileTree, CompileResult, Input, Output>}
   *
   * @param {PluggableList | Plugin | Preset | null | undefined} value
   *   Usable value.
   * @param {...unknown} parameters
   *   Parameters, when a plugin is given as a usable value.
   * @returns {Processor<ParseTree, HeadTree, TailTree, CompileTree, CompileResult>}
   *   Current processor.
   */
  use(e, ...t) {
    const i = this.attachers, r = this.namespace;
    if (du("use", this.frozen), e != null)
      if (typeof e == "function")
        l(e, t);
      else if (typeof e == "object")
        Array.isArray(e) ? a(e) : o(e);
      else
        throw new TypeError("Expected usable value, not `" + e + "`");
    return this;
    function s(u) {
      if (typeof u == "function")
        l(u, []);
      else if (typeof u == "object")
        if (Array.isArray(u)) {
          const [c, ...h] = (
            /** @type {PluginTuple<Array<unknown>>} */
            u
          );
          l(c, h);
        } else
          o(u);
      else
        throw new TypeError("Expected usable value, not `" + u + "`");
    }
    function o(u) {
      if (!("plugins" in u) && !("settings" in u))
        throw new Error(
          "Expected usable value but received an empty preset, which is probably a mistake: presets typically come with `plugins` and sometimes with `settings`, but this has neither"
        );
      a(u.plugins), u.settings && (r.settings = au(!0, r.settings, u.settings));
    }
    function a(u) {
      let c = -1;
      if (u != null)
        if (Array.isArray(u))
          for (; ++c < u.length; ) {
            const h = u[c];
            s(h);
          }
        else
          throw new TypeError("Expected a list of plugins, not `" + u + "`");
    }
    function l(u, c) {
      let h = -1, f = -1;
      for (; ++h < i.length; )
        if (i[h][0] === u) {
          f = h;
          break;
        }
      if (f === -1)
        i.push([u, ...c]);
      else if (c.length > 0) {
        let [d, ...p] = c;
        const g = i[f][1];
        Wc(g) && Wc(d) && (d = au(!0, g, d)), i[f] = [u, d, ...p];
      }
    }
  }
}
const GZ = new hf().freeze();
function hu(n, e) {
  if (typeof e != "function")
    throw new TypeError("Cannot `" + n + "` without `parser`");
}
function fu(n, e) {
  if (typeof e != "function")
    throw new TypeError("Cannot `" + n + "` without `compiler`");
}
function du(n, e) {
  if (e)
    throw new Error(
      "Cannot call `" + n + "` on a frozen processor.\nCreate a new processor first, by calling it: use `processor()` instead of `processor`."
    );
}
function Km(n) {
  if (!Wc(n) || typeof n.type != "string")
    throw new TypeError("Expected node, got `" + n + "`");
}
function Jm(n, e, t) {
  if (!t)
    throw new Error(
      "`" + n + "` finished async. Use `" + e + "` instead"
    );
}
function Mo(n) {
  return HZ(n) ? n : new YZ(n);
}
function HZ(n) {
  return !!(n && typeof n == "object" && "message" in n && "messages" in n);
}
function KZ(n) {
  return typeof n == "string" || JZ(n);
}
function JZ(n) {
  return !!(n && typeof n == "object" && "byteLength" in n && "byteOffset" in n);
}
const eE = {
  tokenize: tE
};
function tE(n) {
  const e = n.attempt(
    this.parser.constructs.contentInitial,
    i,
    r
  );
  let t;
  return e;
  function i(a) {
    if (a === null) {
      n.consume(a);
      return;
    }
    return n.enter("lineEnding"), n.consume(a), n.exit("lineEnding"), fe(n, e, "linePrefix");
  }
  function r(a) {
    return n.enter("paragraph"), s(a);
  }
  function s(a) {
    const l = n.enter("chunkText", {
      contentType: "text",
      previous: t
    });
    return t && (t.next = l), t = l, o(a);
  }
  function o(a) {
    if (a === null) {
      n.exit("chunkText"), n.exit("paragraph"), n.consume(a);
      return;
    }
    return G(a) ? (n.consume(a), n.exit("chunkText"), s) : (n.consume(a), o);
  }
}
const nE = {
  tokenize: iE
}, eg = {
  tokenize: rE
};
function iE(n) {
  const e = this, t = [];
  let i = 0, r, s, o;
  return a;
  function a(w) {
    if (i < t.length) {
      const Q = t[i];
      return e.containerState = Q[1], n.attempt(
        Q[0].continuation,
        l,
        u
      )(w);
    }
    return u(w);
  }
  function l(w) {
    if (i++, e.containerState._closeFlow) {
      e.containerState._closeFlow = void 0, r && b();
      const Q = e.events.length;
      let v = Q, k;
      for (; v--; )
        if (e.events[v][0] === "exit" && e.events[v][1].type === "chunkFlow") {
          k = e.events[v][1].end;
          break;
        }
      m(i);
      let C = Q;
      for (; C < e.events.length; )
        e.events[C][1].end = Object.assign({}, k), C++;
      return Dt(
        e.events,
        v + 1,
        0,
        e.events.slice(Q)
      ), e.events.length = C, u(w);
    }
    return a(w);
  }
  function u(w) {
    if (i === t.length) {
      if (!r)
        return f(w);
      if (r.currentConstruct && r.currentConstruct.concrete)
        return p(w);
      e.interrupt = !!(r.currentConstruct && !r._gfmTableDynamicInterruptHack);
    }
    return e.containerState = {}, n.check(
      eg,
      c,
      h
    )(w);
  }
  function c(w) {
    return r && b(), m(i), f(w);
  }
  function h(w) {
    return e.parser.lazy[e.now().line] = i !== t.length, o = e.now().offset, p(w);
  }
  function f(w) {
    return e.containerState = {}, n.attempt(
      eg,
      d,
      p
    )(w);
  }
  function d(w) {
    return i++, t.push([e.currentConstruct, e.containerState]), f(w);
  }
  function p(w) {
    if (w === null) {
      r && b(), m(0), n.consume(w);
      return;
    }
    return r = r || e.parser.flow(e.now()), n.enter("chunkFlow", {
      contentType: "flow",
      previous: s,
      _tokenizer: r
    }), g(w);
  }
  function g(w) {
    if (w === null) {
      O(n.exit("chunkFlow"), !0), m(0), n.consume(w);
      return;
    }
    return G(w) ? (n.consume(w), O(n.exit("chunkFlow")), i = 0, e.interrupt = void 0, a) : (n.consume(w), g);
  }
  function O(w, Q) {
    const v = e.sliceStream(w);
    if (Q && v.push(null), w.previous = s, s && (s.next = w), s = w, r.defineSkip(w.start), r.write(v), e.parser.lazy[w.start.line]) {
      let k = r.events.length;
      for (; k--; )
        if (
          // The token starts before the line ending…
          r.events[k][1].start.offset < o && // …and either is not ended yet…
          (!r.events[k][1].end || // …or ends after it.
          r.events[k][1].end.offset > o)
        )
          return;
      const C = e.events.length;
      let I = C, z, P;
      for (; I--; )
        if (e.events[I][0] === "exit" && e.events[I][1].type === "chunkFlow") {
          if (z) {
            P = e.events[I][1].end;
            break;
          }
          z = !0;
        }
      for (m(i), k = C; k < e.events.length; )
        e.events[k][1].end = Object.assign({}, P), k++;
      Dt(
        e.events,
        I + 1,
        0,
        e.events.slice(C)
      ), e.events.length = k;
    }
  }
  function m(w) {
    let Q = t.length;
    for (; Q-- > w; ) {
      const v = t[Q];
      e.containerState = v[1], v[0].exit.call(e, n);
    }
    t.length = w;
  }
  function b() {
    r.write([null]), s = void 0, r = void 0, e.containerState._closeFlow = void 0;
  }
}
function rE(n, e, t) {
  return fe(
    n,
    n.attempt(this.parser.constructs.document, e, t),
    "linePrefix",
    this.parser.constructs.disable.null.includes("codeIndented") ? void 0 : 4
  );
}
const sE = {
  tokenize: oE
};
function oE(n) {
  const e = this, t = n.attempt(
    // Try to parse a blank line.
    Ns,
    i,
    // Try to parse initial flow (essentially, only code).
    n.attempt(
      this.parser.constructs.flowInitial,
      r,
      fe(
        n,
        n.attempt(
          this.parser.constructs.flow,
          r,
          n.attempt(d3, r)
        ),
        "linePrefix"
      )
    )
  );
  return t;
  function i(s) {
    if (s === null) {
      n.consume(s);
      return;
    }
    return n.enter("lineEndingBlank"), n.consume(s), n.exit("lineEndingBlank"), e.currentConstruct = void 0, t;
  }
  function r(s) {
    if (s === null) {
      n.consume(s);
      return;
    }
    return n.enter("lineEnding"), n.consume(s), n.exit("lineEnding"), e.currentConstruct = void 0, t;
  }
}
const aE = {
  resolveAll: Wy()
}, lE = Ny("string"), uE = Ny("text");
function Ny(n) {
  return {
    tokenize: e,
    resolveAll: Wy(
      n === "text" ? cE : void 0
    )
  };
  function e(t) {
    const i = this, r = this.parser.constructs[n], s = t.attempt(r, o, a);
    return o;
    function o(c) {
      return u(c) ? s(c) : a(c);
    }
    function a(c) {
      if (c === null) {
        t.consume(c);
        return;
      }
      return t.enter("data"), t.consume(c), l;
    }
    function l(c) {
      return u(c) ? (t.exit("data"), s(c)) : (t.consume(c), l);
    }
    function u(c) {
      if (c === null)
        return !0;
      const h = r[c];
      let f = -1;
      if (h)
        for (; ++f < h.length; ) {
          const d = h[f];
          if (!d.previous || d.previous.call(i, i.previous))
            return !0;
        }
      return !1;
    }
  }
}
function Wy(n) {
  return e;
  function e(t, i) {
    let r = -1, s;
    for (; ++r <= t.length; )
      s === void 0 ? t[r] && t[r][1].type === "data" && (s = r, r++) : (!t[r] || t[r][1].type !== "data") && (r !== s + 2 && (t[s][1].end = t[r - 1][1].end, t.splice(s + 2, r - s - 2), r = s + 2), s = void 0);
    return n ? n(t, i) : t;
  }
}
function cE(n, e) {
  let t = 0;
  for (; ++t <= n.length; )
    if ((t === n.length || n[t][1].type === "lineEnding") && n[t - 1][1].type === "data") {
      const i = n[t - 1][1], r = e.sliceStream(i);
      let s = r.length, o = -1, a = 0, l;
      for (; s--; ) {
        const u = r[s];
        if (typeof u == "string") {
          for (o = u.length; u.charCodeAt(o - 1) === 32; )
            a++, o--;
          if (o)
            break;
          o = -1;
        } else if (u === -2)
          l = !0, a++;
        else if (u !== -1) {
          s++;
          break;
        }
      }
      if (a) {
        const u = {
          type: t === n.length || l || a < 2 ? "lineSuffix" : "hardBreakTrailing",
          start: {
            line: i.end.line,
            column: i.end.column - a,
            offset: i.end.offset - a,
            _index: i.start._index + s,
            _bufferIndex: s ? o : i.start._bufferIndex + o
          },
          end: Object.assign({}, i.end)
        };
        i.end = Object.assign({}, u.start), i.start.offset === i.end.offset ? Object.assign(i, u) : (n.splice(
          t,
          0,
          ["enter", u, e],
          ["exit", u, e]
        ), t += 2);
      }
      t++;
    }
  return n;
}
function hE(n, e, t) {
  let i = Object.assign(
    t ? Object.assign({}, t) : {
      line: 1,
      column: 1,
      offset: 0
    },
    {
      _index: 0,
      _bufferIndex: -1
    }
  );
  const r = {}, s = [];
  let o = [], a = [];
  const l = {
    consume: b,
    enter: w,
    exit: Q,
    attempt: C(v),
    check: C(k),
    interrupt: C(k, {
      interrupt: !0
    })
  }, u = {
    previous: null,
    code: null,
    containerState: {},
    events: [],
    parser: n,
    sliceStream: d,
    sliceSerialize: f,
    now: p,
    defineSkip: g,
    write: h
  };
  let c = e.tokenize.call(u, l);
  return e.resolveAll && s.push(e), u;
  function h(R) {
    return o = At(o, R), O(), o[o.length - 1] !== null ? [] : (I(e, 0), u.events = sl(s, u.events, u), u.events);
  }
  function f(R, A) {
    return dE(d(R), A);
  }
  function d(R) {
    return fE(o, R);
  }
  function p() {
    const { line: R, column: A, offset: j, _index: U, _bufferIndex: E } = i;
    return {
      line: R,
      column: A,
      offset: j,
      _index: U,
      _bufferIndex: E
    };
  }
  function g(R) {
    r[R.line] = R.column, P();
  }
  function O() {
    let R;
    for (; i._index < o.length; ) {
      const A = o[i._index];
      if (typeof A == "string")
        for (R = i._index, i._bufferIndex < 0 && (i._bufferIndex = 0); i._index === R && i._bufferIndex < A.length; )
          m(A.charCodeAt(i._bufferIndex));
      else
        m(A);
    }
  }
  function m(R) {
    c = c(R);
  }
  function b(R) {
    G(R) ? (i.line++, i.column = 1, i.offset += R === -3 ? 2 : 1, P()) : R !== -1 && (i.column++, i.offset++), i._bufferIndex < 0 ? i._index++ : (i._bufferIndex++, i._bufferIndex === o[i._index].length && (i._bufferIndex = -1, i._index++)), u.previous = R;
  }
  function w(R, A) {
    const j = A || {};
    return j.type = R, j.start = p(), u.events.push(["enter", j, u]), a.push(j), j;
  }
  function Q(R) {
    const A = a.pop();
    return A.end = p(), u.events.push(["exit", A, u]), A;
  }
  function v(R, A) {
    I(R, A.from);
  }
  function k(R, A) {
    A.restore();
  }
  function C(R, A) {
    return j;
    function j(U, E, B) {
      let H, K, re, y;
      return Array.isArray(U) ? Qe(U) : "tokenize" in U ? (
        // @ts-expect-error Looks like a construct.
        Qe([U])
      ) : ne(U);
      function ne(Me) {
        return Sr;
        function Sr(Dn) {
          const Ai = Dn !== null && Me[Dn], Ri = Dn !== null && Me.null, Us = [
            // To do: add more extension tests.
            /* c8 ignore next 2 */
            ...Array.isArray(Ai) ? Ai : Ai ? [Ai] : [],
            ...Array.isArray(Ri) ? Ri : Ri ? [Ri] : []
          ];
          return Qe(Us)(Dn);
        }
      }
      function Qe(Me) {
        return H = Me, K = 0, Me.length === 0 ? B : S(Me[K]);
      }
      function S(Me) {
        return Sr;
        function Sr(Dn) {
          return y = z(), re = Me, Me.partial || (u.currentConstruct = Me), Me.name && u.parser.constructs.disable.null.includes(Me.name) ? Je() : Me.tokenize.call(
            // If we do have fields, create an object w/ `context` as its
            // prototype.
            // This allows a “live binding”, which is needed for `interrupt`.
            A ? Object.assign(Object.create(u), A) : u,
            l,
            Ee,
            Je
          )(Dn);
        }
      }
      function Ee(Me) {
        return R(re, y), E;
      }
      function Je(Me) {
        return y.restore(), ++K < H.length ? S(H[K]) : B;
      }
    }
  }
  function I(R, A) {
    R.resolveAll && !s.includes(R) && s.push(R), R.resolve && Dt(
      u.events,
      A,
      u.events.length - A,
      R.resolve(u.events.slice(A), u)
    ), R.resolveTo && (u.events = R.resolveTo(u.events, u));
  }
  function z() {
    const R = p(), A = u.previous, j = u.currentConstruct, U = u.events.length, E = Array.from(a);
    return {
      restore: B,
      from: U
    };
    function B() {
      i = R, u.previous = A, u.currentConstruct = j, u.events.length = U, a = E, P();
    }
  }
  function P() {
    i.line in r && i.column < 2 && (i.column = r[i.line], i.offset += r[i.line] - 1);
  }
}
function fE(n, e) {
  const t = e.start._index, i = e.start._bufferIndex, r = e.end._index, s = e.end._bufferIndex;
  let o;
  if (t === r)
    o = [n[t].slice(i, s)];
  else {
    if (o = n.slice(t, r), i > -1) {
      const a = o[0];
      typeof a == "string" ? o[0] = a.slice(i) : o.shift();
    }
    s > 0 && o.push(n[r].slice(0, s));
  }
  return o;
}
function dE(n, e) {
  let t = -1;
  const i = [];
  let r;
  for (; ++t < n.length; ) {
    const s = n[t];
    let o;
    if (typeof s == "string")
      o = s;
    else
      switch (s) {
        case -5: {
          o = "\r";
          break;
        }
        case -4: {
          o = `
`;
          break;
        }
        case -3: {
          o = `\r
`;
          break;
        }
        case -2: {
          o = e ? " " : "	";
          break;
        }
        case -1: {
          if (!e && r)
            continue;
          o = " ";
          break;
        }
        default:
          o = String.fromCharCode(s);
      }
    r = s === -2, i.push(o);
  }
  return i.join("");
}
const pE = {
  42: ut,
  43: ut,
  45: ut,
  48: ut,
  49: ut,
  50: ut,
  51: ut,
  52: ut,
  53: ut,
  54: ut,
  55: ut,
  56: ut,
  57: ut,
  62: F0
}, mE = {
  91: b3
}, gE = {
  [-2]: Nl,
  [-1]: Nl,
  32: Nl
}, OE = {
  35: v3,
  42: jo,
  45: [$p, jo],
  60: C3,
  61: $p,
  95: jo,
  96: Pp,
  126: Pp
}, bE = {
  38: H0,
  92: G0
}, yE = {
  [-5]: Wl,
  [-4]: Wl,
  [-3]: Wl,
  33: Y3,
  38: H0,
  42: gc,
  60: [UC, z3],
  91: U3,
  92: [w3, G0],
  93: _h,
  95: gc,
  96: a3
}, kE = {
  null: [gc, aE]
}, xE = {
  null: [42, 95]
}, wE = {
  null: []
}, SE = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  attentionMarkers: xE,
  contentInitial: mE,
  disable: wE,
  document: pE,
  flow: OE,
  flowInitial: gE,
  insideSpan: kE,
  string: bE,
  text: yE
}, Symbol.toStringTag, { value: "Module" }));
function vE(n) {
  const t = (
    /** @type {FullNormalizedExtension} */
    X0([SE, ...(n || {}).extensions || []])
  ), i = {
    defined: [],
    lazy: {},
    constructs: t,
    content: r(eE),
    document: r(nE),
    flow: r(sE),
    string: r(lE),
    text: r(uE)
  };
  return i;
  function r(s) {
    return o;
    function o(a) {
      return hE(i, s, a);
    }
  }
}
function PE(n) {
  for (; !K0(n); )
    ;
  return n;
}
const tg = /[\0\t\n\r]/g;
function QE() {
  let n = 1, e = "", t = !0, i;
  return r;
  function r(s, o, a) {
    const l = [];
    let u, c, h, f, d;
    for (s = e + (typeof s == "string" ? s.toString() : new TextDecoder(o || void 0).decode(s)), h = 0, e = "", t && (s.charCodeAt(0) === 65279 && h++, t = void 0); h < s.length; ) {
      if (tg.lastIndex = h, u = tg.exec(s), f = u && u.index !== void 0 ? u.index : s.length, d = s.charCodeAt(f), !u) {
        e = s.slice(h);
        break;
      }
      if (d === 10 && h === f && i)
        l.push(-3), i = void 0;
      else
        switch (i && (l.push(-5), i = void 0), h < f && (l.push(s.slice(h, f)), n += f - h), d) {
          case 0: {
            l.push(65533), n++;
            break;
          }
          case 9: {
            for (c = Math.ceil(n / 4) * 4, l.push(-2); n++ < c; )
              l.push(-1);
            break;
          }
          case 10: {
            l.push(-4), n = 1;
            break;
          }
          default:
            i = !0, n = 1;
        }
      h = f + 1;
    }
    return a && (i && l.push(-5), e && l.push(e), l.push(null)), l;
  }
}
const qy = {}.hasOwnProperty;
function $E(n, e, t) {
  return typeof e != "string" && (t = e, e = void 0), CE(t)(PE(vE(t).document().write(QE()(n, e, !0))));
}
function CE(n) {
  const e = {
    transforms: [],
    canContainEols: ["emphasis", "fragment", "heading", "paragraph", "strong"],
    enter: {
      autolink: s(wf),
      autolinkProtocol: z,
      autolinkEmail: z,
      atxHeading: s(yf),
      blockQuote: s(Ri),
      characterEscape: z,
      characterReference: z,
      codeFenced: s(Us),
      codeFencedFenceInfo: o,
      codeFencedFenceMeta: o,
      codeIndented: s(Us, o),
      codeText: s(gk, o),
      codeTextData: z,
      data: z,
      codeFlowValue: z,
      definition: s(Ok),
      definitionDestinationString: o,
      definitionLabelString: o,
      definitionTitleString: o,
      emphasis: s(bk),
      hardBreakEscape: s(kf),
      hardBreakTrailing: s(kf),
      htmlFlow: s(xf, o),
      htmlFlowData: z,
      htmlText: s(xf, o),
      htmlTextData: z,
      image: s(yk),
      label: o,
      link: s(wf),
      listItem: s(kk),
      listItemValue: f,
      listOrdered: s(Sf, h),
      listUnordered: s(Sf),
      paragraph: s(xk),
      reference: S,
      referenceString: o,
      resourceDestinationString: o,
      resourceTitleString: o,
      setextHeading: s(yf),
      strong: s(wk),
      thematicBreak: s(vk)
    },
    exit: {
      atxHeading: l(),
      atxHeadingSequence: v,
      autolink: l(),
      autolinkEmail: Ai,
      autolinkProtocol: Dn,
      blockQuote: l(),
      characterEscapeValue: P,
      characterReferenceMarkerHexadecimal: Je,
      characterReferenceMarkerNumeric: Je,
      characterReferenceValue: Me,
      characterReference: Sr,
      codeFenced: l(O),
      codeFencedFence: g,
      codeFencedFenceInfo: d,
      codeFencedFenceMeta: p,
      codeFlowValue: P,
      codeIndented: l(m),
      codeText: l(E),
      codeTextData: P,
      data: P,
      definition: l(),
      definitionDestinationString: Q,
      definitionLabelString: b,
      definitionTitleString: w,
      emphasis: l(),
      hardBreakEscape: l(A),
      hardBreakTrailing: l(A),
      htmlFlow: l(j),
      htmlFlowData: P,
      htmlText: l(U),
      htmlTextData: P,
      image: l(H),
      label: re,
      labelText: K,
      lineEnding: R,
      link: l(B),
      listItem: l(),
      listOrdered: l(),
      listUnordered: l(),
      paragraph: l(),
      referenceString: Ee,
      resourceDestinationString: y,
      resourceTitleString: ne,
      resource: Qe,
      setextHeading: l(I),
      setextHeadingLineSequence: C,
      setextHeadingText: k,
      strong: l(),
      thematicBreak: l()
    }
  };
  By(e, (n || {}).mdastExtensions || []);
  const t = {};
  return i;
  function i(T) {
    let D = {
      type: "root",
      children: []
    };
    const ee = {
      stack: [D],
      tokenStack: [],
      config: e,
      enter: a,
      exit: u,
      buffer: o,
      resume: c,
      data: t
    }, le = [];
    let be = -1;
    for (; ++be < T.length; )
      if (T[be][1].type === "listOrdered" || T[be][1].type === "listUnordered")
        if (T[be][0] === "enter")
          le.push(be);
        else {
          const Nt = le.pop();
          be = r(T, Nt, be);
        }
    for (be = -1; ++be < T.length; ) {
      const Nt = e[T[be][0]];
      qy.call(Nt, T[be][1].type) && Nt[T[be][1].type].call(Object.assign({
        sliceSerialize: T[be][2].sliceSerialize
      }, ee), T[be][1]);
    }
    if (ee.tokenStack.length > 0) {
      const Nt = ee.tokenStack[ee.tokenStack.length - 1];
      (Nt[1] || ng).call(ee, void 0, Nt[0]);
    }
    for (D.position = {
      start: _n(T.length > 0 ? T[0][1].start : {
        line: 1,
        column: 1,
        offset: 0
      }),
      end: _n(T.length > 0 ? T[T.length - 2][1].end : {
        line: 1,
        column: 1,
        offset: 0
      })
    }, be = -1; ++be < e.transforms.length; )
      D = e.transforms[be](D) || D;
    return D;
  }
  function r(T, D, ee) {
    let le = D - 1, be = -1, Nt = !1, oi, bn, vr, Pr;
    for (; ++le <= ee; ) {
      const kt = T[le];
      switch (kt[1].type) {
        case "listUnordered":
        case "listOrdered":
        case "blockQuote": {
          kt[0] === "enter" ? be++ : be--, Pr = void 0;
          break;
        }
        case "lineEndingBlank": {
          kt[0] === "enter" && (oi && !Pr && !be && !vr && (vr = le), Pr = void 0);
          break;
        }
        case "linePrefix":
        case "listItemValue":
        case "listItemMarker":
        case "listItemPrefix":
        case "listItemPrefixWhitespace":
          break;
        default:
          Pr = void 0;
      }
      if (!be && kt[0] === "enter" && kt[1].type === "listItemPrefix" || be === -1 && kt[0] === "exit" && (kt[1].type === "listUnordered" || kt[1].type === "listOrdered")) {
        if (oi) {
          let Mi = le;
          for (bn = void 0; Mi--; ) {
            const yn = T[Mi];
            if (yn[1].type === "lineEnding" || yn[1].type === "lineEndingBlank") {
              if (yn[0] === "exit")
                continue;
              bn && (T[bn][1].type = "lineEndingBlank", Nt = !0), yn[1].type = "lineEnding", bn = Mi;
            } else if (!(yn[1].type === "linePrefix" || yn[1].type === "blockQuotePrefix" || yn[1].type === "blockQuotePrefixWhitespace" || yn[1].type === "blockQuoteMarker" || yn[1].type === "listItemIndent"))
              break;
          }
          vr && (!bn || vr < bn) && (oi._spread = !0), oi.end = Object.assign({}, bn ? T[bn][1].start : kt[1].end), T.splice(bn || le, 0, ["exit", oi, kt[2]]), le++, ee++;
        }
        if (kt[1].type === "listItemPrefix") {
          const Mi = {
            type: "listItem",
            _spread: !1,
            start: Object.assign({}, kt[1].start),
            // @ts-expect-error: we’ll add `end` in a second.
            end: void 0
          };
          oi = Mi, T.splice(le, 0, ["enter", Mi, kt[2]]), le++, ee++, vr = void 0, Pr = !0;
        }
      }
    }
    return T[D][1]._spread = Nt, ee;
  }
  function s(T, D) {
    return ee;
    function ee(le) {
      a.call(this, T(le), le), D && D.call(this, le);
    }
  }
  function o() {
    this.stack.push({
      type: "fragment",
      children: []
    });
  }
  function a(T, D, ee) {
    this.stack[this.stack.length - 1].children.push(T), this.stack.push(T), this.tokenStack.push([D, ee]), T.position = {
      start: _n(D.start),
      // @ts-expect-error: `end` will be patched later.
      end: void 0
    };
  }
  function l(T) {
    return D;
    function D(ee) {
      T && T.call(this, ee), u.call(this, ee);
    }
  }
  function u(T, D) {
    const ee = this.stack.pop(), le = this.tokenStack.pop();
    if (le)
      le[0].type !== T.type && (D ? D.call(this, T, le[0]) : (le[1] || ng).call(this, T, le[0]));
    else
      throw new Error("Cannot close `" + T.type + "` (" + ns({
        start: T.start,
        end: T.end
      }) + "): it’s not open");
    ee.position.end = _n(T.end);
  }
  function c() {
    return zh(this.stack.pop());
  }
  function h() {
    this.data.expectingFirstListItemValue = !0;
  }
  function f(T) {
    if (this.data.expectingFirstListItemValue) {
      const D = this.stack[this.stack.length - 2];
      D.start = Number.parseInt(this.sliceSerialize(T), 10), this.data.expectingFirstListItemValue = void 0;
    }
  }
  function d() {
    const T = this.resume(), D = this.stack[this.stack.length - 1];
    D.lang = T;
  }
  function p() {
    const T = this.resume(), D = this.stack[this.stack.length - 1];
    D.meta = T;
  }
  function g() {
    this.data.flowCodeInside || (this.buffer(), this.data.flowCodeInside = !0);
  }
  function O() {
    const T = this.resume(), D = this.stack[this.stack.length - 1];
    D.value = T.replace(/^(\r?\n|\r)|(\r?\n|\r)$/g, ""), this.data.flowCodeInside = void 0;
  }
  function m() {
    const T = this.resume(), D = this.stack[this.stack.length - 1];
    D.value = T.replace(/(\r?\n|\r)$/g, "");
  }
  function b(T) {
    const D = this.resume(), ee = this.stack[this.stack.length - 1];
    ee.label = D, ee.identifier = jt(this.sliceSerialize(T)).toLowerCase();
  }
  function w() {
    const T = this.resume(), D = this.stack[this.stack.length - 1];
    D.title = T;
  }
  function Q() {
    const T = this.resume(), D = this.stack[this.stack.length - 1];
    D.url = T;
  }
  function v(T) {
    const D = this.stack[this.stack.length - 1];
    if (!D.depth) {
      const ee = this.sliceSerialize(T).length;
      D.depth = ee;
    }
  }
  function k() {
    this.data.setextHeadingSlurpLineEnding = !0;
  }
  function C(T) {
    const D = this.stack[this.stack.length - 1];
    D.depth = this.sliceSerialize(T).codePointAt(0) === 61 ? 1 : 2;
  }
  function I() {
    this.data.setextHeadingSlurpLineEnding = void 0;
  }
  function z(T) {
    const ee = this.stack[this.stack.length - 1].children;
    let le = ee[ee.length - 1];
    (!le || le.type !== "text") && (le = Sk(), le.position = {
      start: _n(T.start),
      // @ts-expect-error: we’ll add `end` later.
      end: void 0
    }, ee.push(le)), this.stack.push(le);
  }
  function P(T) {
    const D = this.stack.pop();
    D.value += this.sliceSerialize(T), D.position.end = _n(T.end);
  }
  function R(T) {
    const D = this.stack[this.stack.length - 1];
    if (this.data.atHardBreak) {
      const ee = D.children[D.children.length - 1];
      ee.position.end = _n(T.end), this.data.atHardBreak = void 0;
      return;
    }
    !this.data.setextHeadingSlurpLineEnding && e.canContainEols.includes(D.type) && (z.call(this, T), P.call(this, T));
  }
  function A() {
    this.data.atHardBreak = !0;
  }
  function j() {
    const T = this.resume(), D = this.stack[this.stack.length - 1];
    D.value = T;
  }
  function U() {
    const T = this.resume(), D = this.stack[this.stack.length - 1];
    D.value = T;
  }
  function E() {
    const T = this.resume(), D = this.stack[this.stack.length - 1];
    D.value = T;
  }
  function B() {
    const T = this.stack[this.stack.length - 1];
    if (this.data.inReference) {
      const D = this.data.referenceType || "shortcut";
      T.type += "Reference", T.referenceType = D, delete T.url, delete T.title;
    } else
      delete T.identifier, delete T.label;
    this.data.referenceType = void 0;
  }
  function H() {
    const T = this.stack[this.stack.length - 1];
    if (this.data.inReference) {
      const D = this.data.referenceType || "shortcut";
      T.type += "Reference", T.referenceType = D, delete T.url, delete T.title;
    } else
      delete T.identifier, delete T.label;
    this.data.referenceType = void 0;
  }
  function K(T) {
    const D = this.sliceSerialize(T), ee = this.stack[this.stack.length - 2];
    ee.label = bC(D), ee.identifier = jt(D).toLowerCase();
  }
  function re() {
    const T = this.stack[this.stack.length - 1], D = this.resume(), ee = this.stack[this.stack.length - 1];
    if (this.data.inReference = !0, ee.type === "link") {
      const le = T.children;
      ee.children = le;
    } else
      ee.alt = D;
  }
  function y() {
    const T = this.resume(), D = this.stack[this.stack.length - 1];
    D.url = T;
  }
  function ne() {
    const T = this.resume(), D = this.stack[this.stack.length - 1];
    D.title = T;
  }
  function Qe() {
    this.data.inReference = void 0;
  }
  function S() {
    this.data.referenceType = "collapsed";
  }
  function Ee(T) {
    const D = this.resume(), ee = this.stack[this.stack.length - 1];
    ee.label = D, ee.identifier = jt(this.sliceSerialize(T)).toLowerCase(), this.data.referenceType = "full";
  }
  function Je(T) {
    this.data.characterReferenceType = T.type;
  }
  function Me(T) {
    const D = this.sliceSerialize(T), ee = this.data.characterReferenceType;
    let le;
    ee ? (le = _0(D, ee === "characterReferenceMarkerNumeric" ? 10 : 16), this.data.characterReferenceType = void 0) : le = Ih(D);
    const be = this.stack[this.stack.length - 1];
    be.value += le;
  }
  function Sr(T) {
    const D = this.stack.pop();
    D.position.end = _n(T.end);
  }
  function Dn(T) {
    P.call(this, T);
    const D = this.stack[this.stack.length - 1];
    D.url = this.sliceSerialize(T);
  }
  function Ai(T) {
    P.call(this, T);
    const D = this.stack[this.stack.length - 1];
    D.url = "mailto:" + this.sliceSerialize(T);
  }
  function Ri() {
    return {
      type: "blockquote",
      children: []
    };
  }
  function Us() {
    return {
      type: "code",
      lang: null,
      meta: null,
      value: ""
    };
  }
  function gk() {
    return {
      type: "inlineCode",
      value: ""
    };
  }
  function Ok() {
    return {
      type: "definition",
      identifier: "",
      label: null,
      title: null,
      url: ""
    };
  }
  function bk() {
    return {
      type: "emphasis",
      children: []
    };
  }
  function yf() {
    return {
      type: "heading",
      // @ts-expect-error `depth` will be set later.
      depth: 0,
      children: []
    };
  }
  function kf() {
    return {
      type: "break"
    };
  }
  function xf() {
    return {
      type: "html",
      value: ""
    };
  }
  function yk() {
    return {
      type: "image",
      title: null,
      url: "",
      alt: null
    };
  }
  function wf() {
    return {
      type: "link",
      title: null,
      url: "",
      children: []
    };
  }
  function Sf(T) {
    return {
      type: "list",
      ordered: T.type === "listOrdered",
      start: null,
      spread: T._spread,
      children: []
    };
  }
  function kk(T) {
    return {
      type: "listItem",
      spread: T._spread,
      checked: null,
      children: []
    };
  }
  function xk() {
    return {
      type: "paragraph",
      children: []
    };
  }
  function wk() {
    return {
      type: "strong",
      children: []
    };
  }
  function Sk() {
    return {
      type: "text",
      value: ""
    };
  }
  function vk() {
    return {
      type: "thematicBreak"
    };
  }
}
function _n(n) {
  return {
    line: n.line,
    column: n.column,
    offset: n.offset
  };
}
function By(n, e) {
  let t = -1;
  for (; ++t < e.length; ) {
    const i = e[t];
    Array.isArray(i) ? By(n, i) : TE(n, i);
  }
}
function TE(n, e) {
  let t;
  for (t in e)
    if (qy.call(e, t))
      switch (t) {
        case "canContainEols": {
          const i = e[t];
          i && n[t].push(...i);
          break;
        }
        case "transforms": {
          const i = e[t];
          i && n[t].push(...i);
          break;
        }
        case "enter":
        case "exit": {
          const i = e[t];
          i && Object.assign(n[t], i);
          break;
        }
      }
}
function ng(n, e) {
  throw n ? new Error("Cannot close `" + n.type + "` (" + ns({
    start: n.start,
    end: n.end
  }) + "): a different token (`" + e.type + "`, " + ns({
    start: e.start,
    end: e.end
  }) + ") is open") : new Error("Cannot close document, a token (`" + e.type + "`, " + ns({
    start: e.start,
    end: e.end
  }) + ") is still open");
}
function AE(n) {
  const e = this;
  e.parser = t;
  function t(i) {
    return $E(i, {
      ...e.data("settings"),
      ...n,
      // Note: these options are not in the readme.
      // The goal is for them to be set by plugins on `data` instead of being
      // passed by users.
      extensions: e.data("micromarkExtensions") || [],
      mdastExtensions: e.data("fromMarkdownExtensions") || []
    });
  }
}
function RE(n, e) {
  const t = {
    type: "element",
    tagName: "blockquote",
    properties: {},
    children: n.wrap(n.all(e), !0)
  };
  return n.patch(e, t), n.applyData(e, t);
}
function ME(n, e) {
  const t = { type: "element", tagName: "br", properties: {}, children: [] };
  return n.patch(e, t), [n.applyData(e, t), { type: "text", value: `
` }];
}
function ZE(n, e) {
  const t = e.value ? e.value + `
` : "", i = {};
  e.lang && (i.className = ["language-" + e.lang]);
  let r = {
    type: "element",
    tagName: "code",
    properties: i,
    children: [{ type: "text", value: t }]
  };
  return e.meta && (r.data = { meta: e.meta }), n.patch(e, r), r = n.applyData(e, r), r = { type: "element", tagName: "pre", properties: {}, children: [r] }, n.patch(e, r), r;
}
function EE(n, e) {
  const t = {
    type: "element",
    tagName: "del",
    properties: {},
    children: n.all(e)
  };
  return n.patch(e, t), n.applyData(e, t);
}
function zE(n, e) {
  const t = {
    type: "element",
    tagName: "em",
    properties: {},
    children: n.all(e)
  };
  return n.patch(e, t), n.applyData(e, t);
}
function DE(n, e) {
  const t = typeof n.options.clobberPrefix == "string" ? n.options.clobberPrefix : "user-content-", i = String(e.identifier).toUpperCase(), r = kr(i.toLowerCase()), s = n.footnoteOrder.indexOf(i);
  let o, a = n.footnoteCounts.get(i);
  a === void 0 ? (a = 0, n.footnoteOrder.push(i), o = n.footnoteOrder.length) : o = s + 1, a += 1, n.footnoteCounts.set(i, a);
  const l = {
    type: "element",
    tagName: "a",
    properties: {
      href: "#" + t + "fn-" + r,
      id: t + "fnref-" + r + (a > 1 ? "-" + a : ""),
      dataFootnoteRef: !0,
      ariaDescribedBy: ["footnote-label"]
    },
    children: [{ type: "text", value: String(o) }]
  };
  n.patch(e, l);
  const u = {
    type: "element",
    tagName: "sup",
    properties: {},
    children: [l]
  };
  return n.patch(e, u), n.applyData(e, u);
}
function IE(n, e) {
  const t = {
    type: "element",
    tagName: "h" + e.depth,
    properties: {},
    children: n.all(e)
  };
  return n.patch(e, t), n.applyData(e, t);
}
function LE(n, e) {
  if (n.options.allowDangerousHtml) {
    const t = { type: "raw", value: e.value };
    return n.patch(e, t), n.applyData(e, t);
  }
}
function Vy(n, e) {
  const t = e.referenceType;
  let i = "]";
  if (t === "collapsed" ? i += "[]" : t === "full" && (i += "[" + (e.label || e.identifier) + "]"), e.type === "imageReference")
    return [{ type: "text", value: "![" + e.alt + i }];
  const r = n.all(e), s = r[0];
  s && s.type === "text" ? s.value = "[" + s.value : r.unshift({ type: "text", value: "[" });
  const o = r[r.length - 1];
  return o && o.type === "text" ? o.value += i : r.push({ type: "text", value: i }), r;
}
function _E(n, e) {
  const t = String(e.identifier).toUpperCase(), i = n.definitionById.get(t);
  if (!i)
    return Vy(n, e);
  const r = { src: kr(i.url || ""), alt: e.alt };
  i.title !== null && i.title !== void 0 && (r.title = i.title);
  const s = { type: "element", tagName: "img", properties: r, children: [] };
  return n.patch(e, s), n.applyData(e, s);
}
function XE(n, e) {
  const t = { src: kr(e.url) };
  e.alt !== null && e.alt !== void 0 && (t.alt = e.alt), e.title !== null && e.title !== void 0 && (t.title = e.title);
  const i = { type: "element", tagName: "img", properties: t, children: [] };
  return n.patch(e, i), n.applyData(e, i);
}
function NE(n, e) {
  const t = { type: "text", value: e.value.replace(/\r?\n|\r/g, " ") };
  n.patch(e, t);
  const i = {
    type: "element",
    tagName: "code",
    properties: {},
    children: [t]
  };
  return n.patch(e, i), n.applyData(e, i);
}
function WE(n, e) {
  const t = String(e.identifier).toUpperCase(), i = n.definitionById.get(t);
  if (!i)
    return Vy(n, e);
  const r = { href: kr(i.url || "") };
  i.title !== null && i.title !== void 0 && (r.title = i.title);
  const s = {
    type: "element",
    tagName: "a",
    properties: r,
    children: n.all(e)
  };
  return n.patch(e, s), n.applyData(e, s);
}
function qE(n, e) {
  const t = { href: kr(e.url) };
  e.title !== null && e.title !== void 0 && (t.title = e.title);
  const i = {
    type: "element",
    tagName: "a",
    properties: t,
    children: n.all(e)
  };
  return n.patch(e, i), n.applyData(e, i);
}
function BE(n, e, t) {
  const i = n.all(e), r = t ? VE(t) : Yy(e), s = {}, o = [];
  if (typeof e.checked == "boolean") {
    const c = i[0];
    let h;
    c && c.type === "element" && c.tagName === "p" ? h = c : (h = { type: "element", tagName: "p", properties: {}, children: [] }, i.unshift(h)), h.children.length > 0 && h.children.unshift({ type: "text", value: " " }), h.children.unshift({
      type: "element",
      tagName: "input",
      properties: { type: "checkbox", checked: e.checked, disabled: !0 },
      children: []
    }), s.className = ["task-list-item"];
  }
  let a = -1;
  for (; ++a < i.length; ) {
    const c = i[a];
    (r || a !== 0 || c.type !== "element" || c.tagName !== "p") && o.push({ type: "text", value: `
` }), c.type === "element" && c.tagName === "p" && !r ? o.push(...c.children) : o.push(c);
  }
  const l = i[i.length - 1];
  l && (r || l.type !== "element" || l.tagName !== "p") && o.push({ type: "text", value: `
` });
  const u = { type: "element", tagName: "li", properties: s, children: o };
  return n.patch(e, u), n.applyData(e, u);
}
function VE(n) {
  let e = !1;
  if (n.type === "list") {
    e = n.spread || !1;
    const t = n.children;
    let i = -1;
    for (; !e && ++i < t.length; )
      e = Yy(t[i]);
  }
  return e;
}
function Yy(n) {
  const e = n.spread;
  return e ?? n.children.length > 1;
}
function YE(n, e) {
  const t = {}, i = n.all(e);
  let r = -1;
  for (typeof e.start == "number" && e.start !== 1 && (t.start = e.start); ++r < i.length; ) {
    const o = i[r];
    if (o.type === "element" && o.tagName === "li" && o.properties && Array.isArray(o.properties.className) && o.properties.className.includes("task-list-item")) {
      t.className = ["contains-task-list"];
      break;
    }
  }
  const s = {
    type: "element",
    tagName: e.ordered ? "ol" : "ul",
    properties: t,
    children: n.wrap(i, !0)
  };
  return n.patch(e, s), n.applyData(e, s);
}
function jE(n, e) {
  const t = {
    type: "element",
    tagName: "p",
    properties: {},
    children: n.all(e)
  };
  return n.patch(e, t), n.applyData(e, t);
}
function UE(n, e) {
  const t = { type: "root", children: n.wrap(n.all(e)) };
  return n.patch(e, t), n.applyData(e, t);
}
function FE(n, e) {
  const t = {
    type: "element",
    tagName: "strong",
    properties: {},
    children: n.all(e)
  };
  return n.patch(e, t), n.applyData(e, t);
}
const jy = Fy("end"), Uy = Fy("start");
function Fy(n) {
  return e;
  function e(t) {
    const i = t && t.position && t.position[n] || {};
    if (typeof i.line == "number" && i.line > 0 && typeof i.column == "number" && i.column > 0)
      return {
        line: i.line,
        column: i.column,
        offset: typeof i.offset == "number" && i.offset > -1 ? i.offset : void 0
      };
  }
}
function GE(n) {
  const e = Uy(n), t = jy(n);
  if (e && t)
    return { start: e, end: t };
}
function HE(n, e) {
  const t = n.all(e), i = t.shift(), r = [];
  if (i) {
    const o = {
      type: "element",
      tagName: "thead",
      properties: {},
      children: n.wrap([i], !0)
    };
    n.patch(e.children[0], o), r.push(o);
  }
  if (t.length > 0) {
    const o = {
      type: "element",
      tagName: "tbody",
      properties: {},
      children: n.wrap(t, !0)
    }, a = Uy(e.children[1]), l = jy(e.children[e.children.length - 1]);
    a && l && (o.position = { start: a, end: l }), r.push(o);
  }
  const s = {
    type: "element",
    tagName: "table",
    properties: {},
    children: n.wrap(r, !0)
  };
  return n.patch(e, s), n.applyData(e, s);
}
function KE(n, e, t) {
  const i = t ? t.children : void 0, s = (i ? i.indexOf(e) : 1) === 0 ? "th" : "td", o = t && t.type === "table" ? t.align : void 0, a = o ? o.length : e.children.length;
  let l = -1;
  const u = [];
  for (; ++l < a; ) {
    const h = e.children[l], f = {}, d = o ? o[l] : void 0;
    d && (f.align = d);
    let p = { type: "element", tagName: s, properties: f, children: [] };
    h && (p.children = n.all(h), n.patch(h, p), p = n.applyData(h, p)), u.push(p);
  }
  const c = {
    type: "element",
    tagName: "tr",
    properties: {},
    children: n.wrap(u, !0)
  };
  return n.patch(e, c), n.applyData(e, c);
}
function JE(n, e) {
  const t = {
    type: "element",
    tagName: "td",
    // Assume body cell.
    properties: {},
    children: n.all(e)
  };
  return n.patch(e, t), n.applyData(e, t);
}
const ig = 9, rg = 32;
function ez(n) {
  const e = String(n), t = /\r?\n|\r/g;
  let i = t.exec(e), r = 0;
  const s = [];
  for (; i; )
    s.push(
      sg(e.slice(r, i.index), r > 0, !0),
      i[0]
    ), r = i.index + i[0].length, i = t.exec(e);
  return s.push(sg(e.slice(r), r > 0, !1)), s.join("");
}
function sg(n, e, t) {
  let i = 0, r = n.length;
  if (e) {
    let s = n.codePointAt(i);
    for (; s === ig || s === rg; )
      i++, s = n.codePointAt(i);
  }
  if (t) {
    let s = n.codePointAt(r - 1);
    for (; s === ig || s === rg; )
      r--, s = n.codePointAt(r - 1);
  }
  return r > i ? n.slice(i, r) : "";
}
function tz(n, e) {
  const t = { type: "text", value: ez(String(e.value)) };
  return n.patch(e, t), n.applyData(e, t);
}
function nz(n, e) {
  const t = {
    type: "element",
    tagName: "hr",
    properties: {},
    children: []
  };
  return n.patch(e, t), n.applyData(e, t);
}
const iz = {
  blockquote: RE,
  break: ME,
  code: ZE,
  delete: EE,
  emphasis: zE,
  footnoteReference: DE,
  heading: IE,
  html: LE,
  imageReference: _E,
  image: XE,
  inlineCode: NE,
  linkReference: WE,
  link: qE,
  listItem: BE,
  list: YE,
  paragraph: jE,
  // @ts-expect-error: root is different, but hard to type.
  root: UE,
  strong: FE,
  table: HE,
  tableCell: JE,
  tableRow: KE,
  text: tz,
  thematicBreak: nz,
  toml: Zo,
  yaml: Zo,
  definition: Zo,
  footnoteDefinition: Zo
};
function Zo() {
}
const Gy = -1, hl = 0, _a = 1, Xa = 2, ff = 3, df = 4, pf = 5, mf = 6, Hy = 7, Ky = 8, og = typeof self == "object" ? self : globalThis, rz = (n, e) => {
  const t = (r, s) => (n.set(s, r), r), i = (r) => {
    if (n.has(r))
      return n.get(r);
    const [s, o] = e[r];
    switch (s) {
      case hl:
      case Gy:
        return t(o, r);
      case _a: {
        const a = t([], r);
        for (const l of o)
          a.push(i(l));
        return a;
      }
      case Xa: {
        const a = t({}, r);
        for (const [l, u] of o)
          a[i(l)] = i(u);
        return a;
      }
      case ff:
        return t(new Date(o), r);
      case df: {
        const { source: a, flags: l } = o;
        return t(new RegExp(a, l), r);
      }
      case pf: {
        const a = t(/* @__PURE__ */ new Map(), r);
        for (const [l, u] of o)
          a.set(i(l), i(u));
        return a;
      }
      case mf: {
        const a = t(/* @__PURE__ */ new Set(), r);
        for (const l of o)
          a.add(i(l));
        return a;
      }
      case Hy: {
        const { name: a, message: l } = o;
        return t(new og[a](l), r);
      }
      case Ky:
        return t(BigInt(o), r);
      case "BigInt":
        return t(Object(BigInt(o)), r);
    }
    return t(new og[s](o), r);
  };
  return i;
}, ag = (n) => rz(/* @__PURE__ */ new Map(), n)(0), Ei = "", { toString: sz } = {}, { keys: oz } = Object, Dr = (n) => {
  const e = typeof n;
  if (e !== "object" || !n)
    return [hl, e];
  const t = sz.call(n).slice(8, -1);
  switch (t) {
    case "Array":
      return [_a, Ei];
    case "Object":
      return [Xa, Ei];
    case "Date":
      return [ff, Ei];
    case "RegExp":
      return [df, Ei];
    case "Map":
      return [pf, Ei];
    case "Set":
      return [mf, Ei];
  }
  return t.includes("Array") ? [_a, t] : t.includes("Error") ? [Hy, t] : [Xa, t];
}, Eo = ([n, e]) => n === hl && (e === "function" || e === "symbol"), az = (n, e, t, i) => {
  const r = (o, a) => {
    const l = i.push(o) - 1;
    return t.set(a, l), l;
  }, s = (o) => {
    if (t.has(o))
      return t.get(o);
    let [a, l] = Dr(o);
    switch (a) {
      case hl: {
        let c = o;
        switch (l) {
          case "bigint":
            a = Ky, c = o.toString();
            break;
          case "function":
          case "symbol":
            if (n)
              throw new TypeError("unable to serialize " + l);
            c = null;
            break;
          case "undefined":
            return r([Gy], o);
        }
        return r([a, c], o);
      }
      case _a: {
        if (l)
          return r([l, [...o]], o);
        const c = [], h = r([a, c], o);
        for (const f of o)
          c.push(s(f));
        return h;
      }
      case Xa: {
        if (l)
          switch (l) {
            case "BigInt":
              return r([l, o.toString()], o);
            case "Boolean":
            case "Number":
            case "String":
              return r([l, o.valueOf()], o);
          }
        if (e && "toJSON" in o)
          return s(o.toJSON());
        const c = [], h = r([a, c], o);
        for (const f of oz(o))
          (n || !Eo(Dr(o[f]))) && c.push([s(f), s(o[f])]);
        return h;
      }
      case ff:
        return r([a, o.toISOString()], o);
      case df: {
        const { source: c, flags: h } = o;
        return r([a, { source: c, flags: h }], o);
      }
      case pf: {
        const c = [], h = r([a, c], o);
        for (const [f, d] of o)
          (n || !(Eo(Dr(f)) || Eo(Dr(d)))) && c.push([s(f), s(d)]);
        return h;
      }
      case mf: {
        const c = [], h = r([a, c], o);
        for (const f of o)
          (n || !Eo(Dr(f))) && c.push(s(f));
        return h;
      }
    }
    const { message: u } = o;
    return r([a, { name: l, message: u }], o);
  };
  return s;
}, lg = (n, { json: e, lossy: t } = {}) => {
  const i = [];
  return az(!(e || t), !!e, /* @__PURE__ */ new Map(), i)(n), i;
}, Na = typeof structuredClone == "function" ? (
  /* c8 ignore start */
  (n, e) => e && ("json" in e || "lossy" in e) ? ag(lg(n, e)) : structuredClone(n)
) : (n, e) => ag(lg(n, e));
function lz(n, e) {
  const t = [{ type: "text", value: "↩" }];
  return e > 1 && t.push({
    type: "element",
    tagName: "sup",
    properties: {},
    children: [{ type: "text", value: String(e) }]
  }), t;
}
function uz(n, e) {
  return "Back to reference " + (n + 1) + (e > 1 ? "-" + e : "");
}
function cz(n) {
  const e = typeof n.options.clobberPrefix == "string" ? n.options.clobberPrefix : "user-content-", t = n.options.footnoteBackContent || lz, i = n.options.footnoteBackLabel || uz, r = n.options.footnoteLabel || "Footnotes", s = n.options.footnoteLabelTagName || "h2", o = n.options.footnoteLabelProperties || {
    className: ["sr-only"]
  }, a = [];
  let l = -1;
  for (; ++l < n.footnoteOrder.length; ) {
    const u = n.footnoteById.get(
      n.footnoteOrder[l]
    );
    if (!u)
      continue;
    const c = n.all(u), h = String(u.identifier).toUpperCase(), f = kr(h.toLowerCase());
    let d = 0;
    const p = [], g = n.footnoteCounts.get(h);
    for (; g !== void 0 && ++d <= g; ) {
      p.length > 0 && p.push({ type: "text", value: " " });
      let b = typeof t == "string" ? t : t(l, d);
      typeof b == "string" && (b = { type: "text", value: b }), p.push({
        type: "element",
        tagName: "a",
        properties: {
          href: "#" + e + "fnref-" + f + (d > 1 ? "-" + d : ""),
          dataFootnoteBackref: "",
          ariaLabel: typeof i == "string" ? i : i(l, d),
          className: ["data-footnote-backref"]
        },
        children: Array.isArray(b) ? b : [b]
      });
    }
    const O = c[c.length - 1];
    if (O && O.type === "element" && O.tagName === "p") {
      const b = O.children[O.children.length - 1];
      b && b.type === "text" ? b.value += " " : O.children.push({ type: "text", value: " " }), O.children.push(...p);
    } else
      c.push(...p);
    const m = {
      type: "element",
      tagName: "li",
      properties: { id: e + "fn-" + f },
      children: n.wrap(c, !0)
    };
    n.patch(u, m), a.push(m);
  }
  if (a.length !== 0)
    return {
      type: "element",
      tagName: "section",
      properties: { dataFootnotes: !0, className: ["footnotes"] },
      children: [
        {
          type: "element",
          tagName: s,
          properties: {
            ...Na(o),
            id: "footnote-label"
          },
          children: [{ type: "text", value: r }]
        },
        { type: "text", value: `
` },
        {
          type: "element",
          tagName: "ol",
          properties: {},
          children: n.wrap(a, !0)
        },
        { type: "text", value: `
` }
      ]
    };
}
const Vc = {}.hasOwnProperty, hz = {};
function fz(n, e) {
  const t = e || hz, i = /* @__PURE__ */ new Map(), r = /* @__PURE__ */ new Map(), s = /* @__PURE__ */ new Map(), o = { ...iz, ...t.handlers }, a = {
    all: u,
    applyData: pz,
    definitionById: i,
    footnoteById: r,
    footnoteCounts: s,
    footnoteOrder: [],
    handlers: o,
    one: l,
    options: t,
    patch: dz,
    wrap: gz
  };
  return $0(n, function(c) {
    if (c.type === "definition" || c.type === "footnoteDefinition") {
      const h = c.type === "definition" ? i : r, f = String(c.identifier).toUpperCase();
      h.has(f) || h.set(f, c);
    }
  }), a;
  function l(c, h) {
    const f = c.type, d = a.handlers[f];
    if (Vc.call(a.handlers, f) && d)
      return d(a, c, h);
    if (a.options.passThrough && a.options.passThrough.includes(f)) {
      if ("children" in c) {
        const { children: g, ...O } = c, m = Na(O);
        return m.children = a.all(c), m;
      }
      return Na(c);
    }
    return (a.options.unknownHandler || mz)(a, c, h);
  }
  function u(c) {
    const h = [];
    if ("children" in c) {
      const f = c.children;
      let d = -1;
      for (; ++d < f.length; ) {
        const p = a.one(f[d], c);
        if (p) {
          if (d && f[d - 1].type === "break" && (!Array.isArray(p) && p.type === "text" && (p.value = ug(p.value)), !Array.isArray(p) && p.type === "element")) {
            const g = p.children[0];
            g && g.type === "text" && (g.value = ug(g.value));
          }
          Array.isArray(p) ? h.push(...p) : h.push(p);
        }
      }
    }
    return h;
  }
}
function dz(n, e) {
  n.position && (e.position = GE(n));
}
function pz(n, e) {
  let t = e;
  if (n && n.data) {
    const i = n.data.hName, r = n.data.hChildren, s = n.data.hProperties;
    if (typeof i == "string")
      if (t.type === "element")
        t.tagName = i;
      else {
        const o = "children" in t ? t.children : [t];
        t = { type: "element", tagName: i, properties: {}, children: o };
      }
    t.type === "element" && s && Object.assign(t.properties, Na(s)), "children" in t && t.children && r !== null && r !== void 0 && (t.children = r);
  }
  return t;
}
function mz(n, e) {
  const t = e.data || {}, i = "value" in e && !(Vc.call(t, "hProperties") || Vc.call(t, "hChildren")) ? { type: "text", value: e.value } : {
    type: "element",
    tagName: "div",
    properties: {},
    children: n.all(e)
  };
  return n.patch(e, i), n.applyData(e, i);
}
function gz(n, e) {
  const t = [];
  let i = -1;
  for (e && t.push({ type: "text", value: `
` }); ++i < n.length; )
    i && t.push({ type: "text", value: `
` }), t.push(n[i]);
  return e && n.length > 0 && t.push({ type: "text", value: `
` }), t;
}
function ug(n) {
  let e = 0, t = n.charCodeAt(e);
  for (; t === 9 || t === 32; )
    e++, t = n.charCodeAt(e);
  return n.slice(e);
}
function cg(n, e) {
  const t = fz(n, e), i = t.one(n, void 0), r = cz(t), s = Array.isArray(i) ? { type: "root", children: i } : i || { type: "root", children: [] };
  return r && s.children.push({ type: "text", value: `
` }, r), s;
}
function Oz(n, e) {
  return n && "run" in n ? async function(t, i) {
    const r = (
      /** @type {HastRoot} */
      cg(t, { file: i, ...e })
    );
    await n.run(r, i);
  } : function(t, i) {
    return (
      /** @type {HastRoot} */
      cg(t, { file: i, ...e || n })
    );
  };
}
const bz = [
  "area",
  "base",
  "basefont",
  "bgsound",
  "br",
  "col",
  "command",
  "embed",
  "frame",
  "hr",
  "image",
  "img",
  "input",
  "keygen",
  "link",
  "meta",
  "param",
  "source",
  "track",
  "wbr"
];
class js {
  /**
   * @constructor
   * @param {Properties} property
   * @param {Normal} normal
   * @param {string} [space]
   */
  constructor(e, t, i) {
    this.property = e, this.normal = t, i && (this.space = i);
  }
}
js.prototype.property = {};
js.prototype.normal = {};
js.prototype.space = null;
function Jy(n, e) {
  const t = {}, i = {};
  let r = -1;
  for (; ++r < n.length; )
    Object.assign(t, n[r].property), Object.assign(i, n[r].normal);
  return new js(t, i, e);
}
function Yc(n) {
  return n.toLowerCase();
}
class Xt {
  /**
   * @constructor
   * @param {string} property
   * @param {string} attribute
   */
  constructor(e, t) {
    this.property = e, this.attribute = t;
  }
}
Xt.prototype.space = null;
Xt.prototype.boolean = !1;
Xt.prototype.booleanish = !1;
Xt.prototype.overloadedBoolean = !1;
Xt.prototype.number = !1;
Xt.prototype.commaSeparated = !1;
Xt.prototype.spaceSeparated = !1;
Xt.prototype.commaOrSpaceSeparated = !1;
Xt.prototype.mustUseProperty = !1;
Xt.prototype.defined = !1;
let yz = 0;
const ie = Ti(), Le = Ti(), ek = Ti(), M = Ti(), we = Ti(), Ki = Ti(), vt = Ti();
function Ti() {
  return 2 ** ++yz;
}
const jc = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  boolean: ie,
  booleanish: Le,
  commaOrSpaceSeparated: vt,
  commaSeparated: Ki,
  number: M,
  overloadedBoolean: ek,
  spaceSeparated: we
}, Symbol.toStringTag, { value: "Module" })), pu = Object.keys(jc);
class gf extends Xt {
  /**
   * @constructor
   * @param {string} property
   * @param {string} attribute
   * @param {number|null} [mask]
   * @param {string} [space]
   */
  constructor(e, t, i, r) {
    let s = -1;
    if (super(e, t), hg(this, "space", r), typeof i == "number")
      for (; ++s < pu.length; ) {
        const o = pu[s];
        hg(this, pu[s], (i & jc[o]) === jc[o]);
      }
  }
}
gf.prototype.defined = !0;
function hg(n, e, t) {
  t && (n[e] = t);
}
const kz = {}.hasOwnProperty;
function wr(n) {
  const e = {}, t = {};
  let i;
  for (i in n.properties)
    if (kz.call(n.properties, i)) {
      const r = n.properties[i], s = new gf(
        i,
        n.transform(n.attributes || {}, i),
        r,
        n.space
      );
      n.mustUseProperty && n.mustUseProperty.includes(i) && (s.mustUseProperty = !0), e[i] = s, t[Yc(i)] = i, t[Yc(s.attribute)] = i;
    }
  return new js(e, t, n.space);
}
const tk = wr({
  space: "xlink",
  transform(n, e) {
    return "xlink:" + e.slice(5).toLowerCase();
  },
  properties: {
    xLinkActuate: null,
    xLinkArcRole: null,
    xLinkHref: null,
    xLinkRole: null,
    xLinkShow: null,
    xLinkTitle: null,
    xLinkType: null
  }
}), nk = wr({
  space: "xml",
  transform(n, e) {
    return "xml:" + e.slice(3).toLowerCase();
  },
  properties: { xmlLang: null, xmlBase: null, xmlSpace: null }
});
function ik(n, e) {
  return e in n ? n[e] : e;
}
function rk(n, e) {
  return ik(n, e.toLowerCase());
}
const sk = wr({
  space: "xmlns",
  attributes: { xmlnsxlink: "xmlns:xlink" },
  transform: rk,
  properties: { xmlns: null, xmlnsXLink: null }
}), ok = wr({
  transform(n, e) {
    return e === "role" ? e : "aria-" + e.slice(4).toLowerCase();
  },
  properties: {
    ariaActiveDescendant: null,
    ariaAtomic: Le,
    ariaAutoComplete: null,
    ariaBusy: Le,
    ariaChecked: Le,
    ariaColCount: M,
    ariaColIndex: M,
    ariaColSpan: M,
    ariaControls: we,
    ariaCurrent: null,
    ariaDescribedBy: we,
    ariaDetails: null,
    ariaDisabled: Le,
    ariaDropEffect: we,
    ariaErrorMessage: null,
    ariaExpanded: Le,
    ariaFlowTo: we,
    ariaGrabbed: Le,
    ariaHasPopup: null,
    ariaHidden: Le,
    ariaInvalid: null,
    ariaKeyShortcuts: null,
    ariaLabel: null,
    ariaLabelledBy: we,
    ariaLevel: M,
    ariaLive: null,
    ariaModal: Le,
    ariaMultiLine: Le,
    ariaMultiSelectable: Le,
    ariaOrientation: null,
    ariaOwns: we,
    ariaPlaceholder: null,
    ariaPosInSet: M,
    ariaPressed: Le,
    ariaReadOnly: Le,
    ariaRelevant: null,
    ariaRequired: Le,
    ariaRoleDescription: we,
    ariaRowCount: M,
    ariaRowIndex: M,
    ariaRowSpan: M,
    ariaSelected: Le,
    ariaSetSize: M,
    ariaSort: null,
    ariaValueMax: M,
    ariaValueMin: M,
    ariaValueNow: M,
    ariaValueText: null,
    role: null
  }
}), xz = wr({
  space: "html",
  attributes: {
    acceptcharset: "accept-charset",
    classname: "class",
    htmlfor: "for",
    httpequiv: "http-equiv"
  },
  transform: rk,
  mustUseProperty: ["checked", "multiple", "muted", "selected"],
  properties: {
    // Standard Properties.
    abbr: null,
    accept: Ki,
    acceptCharset: we,
    accessKey: we,
    action: null,
    allow: null,
    allowFullScreen: ie,
    allowPaymentRequest: ie,
    allowUserMedia: ie,
    alt: null,
    as: null,
    async: ie,
    autoCapitalize: null,
    autoComplete: we,
    autoFocus: ie,
    autoPlay: ie,
    blocking: we,
    capture: null,
    charSet: null,
    checked: ie,
    cite: null,
    className: we,
    cols: M,
    colSpan: null,
    content: null,
    contentEditable: Le,
    controls: ie,
    controlsList: we,
    coords: M | Ki,
    crossOrigin: null,
    data: null,
    dateTime: null,
    decoding: null,
    default: ie,
    defer: ie,
    dir: null,
    dirName: null,
    disabled: ie,
    download: ek,
    draggable: Le,
    encType: null,
    enterKeyHint: null,
    fetchPriority: null,
    form: null,
    formAction: null,
    formEncType: null,
    formMethod: null,
    formNoValidate: ie,
    formTarget: null,
    headers: we,
    height: M,
    hidden: ie,
    high: M,
    href: null,
    hrefLang: null,
    htmlFor: we,
    httpEquiv: we,
    id: null,
    imageSizes: null,
    imageSrcSet: null,
    inert: ie,
    inputMode: null,
    integrity: null,
    is: null,
    isMap: ie,
    itemId: null,
    itemProp: we,
    itemRef: we,
    itemScope: ie,
    itemType: we,
    kind: null,
    label: null,
    lang: null,
    language: null,
    list: null,
    loading: null,
    loop: ie,
    low: M,
    manifest: null,
    max: null,
    maxLength: M,
    media: null,
    method: null,
    min: null,
    minLength: M,
    multiple: ie,
    muted: ie,
    name: null,
    nonce: null,
    noModule: ie,
    noValidate: ie,
    onAbort: null,
    onAfterPrint: null,
    onAuxClick: null,
    onBeforeMatch: null,
    onBeforePrint: null,
    onBeforeToggle: null,
    onBeforeUnload: null,
    onBlur: null,
    onCancel: null,
    onCanPlay: null,
    onCanPlayThrough: null,
    onChange: null,
    onClick: null,
    onClose: null,
    onContextLost: null,
    onContextMenu: null,
    onContextRestored: null,
    onCopy: null,
    onCueChange: null,
    onCut: null,
    onDblClick: null,
    onDrag: null,
    onDragEnd: null,
    onDragEnter: null,
    onDragExit: null,
    onDragLeave: null,
    onDragOver: null,
    onDragStart: null,
    onDrop: null,
    onDurationChange: null,
    onEmptied: null,
    onEnded: null,
    onError: null,
    onFocus: null,
    onFormData: null,
    onHashChange: null,
    onInput: null,
    onInvalid: null,
    onKeyDown: null,
    onKeyPress: null,
    onKeyUp: null,
    onLanguageChange: null,
    onLoad: null,
    onLoadedData: null,
    onLoadedMetadata: null,
    onLoadEnd: null,
    onLoadStart: null,
    onMessage: null,
    onMessageError: null,
    onMouseDown: null,
    onMouseEnter: null,
    onMouseLeave: null,
    onMouseMove: null,
    onMouseOut: null,
    onMouseOver: null,
    onMouseUp: null,
    onOffline: null,
    onOnline: null,
    onPageHide: null,
    onPageShow: null,
    onPaste: null,
    onPause: null,
    onPlay: null,
    onPlaying: null,
    onPopState: null,
    onProgress: null,
    onRateChange: null,
    onRejectionHandled: null,
    onReset: null,
    onResize: null,
    onScroll: null,
    onScrollEnd: null,
    onSecurityPolicyViolation: null,
    onSeeked: null,
    onSeeking: null,
    onSelect: null,
    onSlotChange: null,
    onStalled: null,
    onStorage: null,
    onSubmit: null,
    onSuspend: null,
    onTimeUpdate: null,
    onToggle: null,
    onUnhandledRejection: null,
    onUnload: null,
    onVolumeChange: null,
    onWaiting: null,
    onWheel: null,
    open: ie,
    optimum: M,
    pattern: null,
    ping: we,
    placeholder: null,
    playsInline: ie,
    popover: null,
    popoverTarget: null,
    popoverTargetAction: null,
    poster: null,
    preload: null,
    readOnly: ie,
    referrerPolicy: null,
    rel: we,
    required: ie,
    reversed: ie,
    rows: M,
    rowSpan: M,
    sandbox: we,
    scope: null,
    scoped: ie,
    seamless: ie,
    selected: ie,
    shadowRootClonable: ie,
    shadowRootDelegatesFocus: ie,
    shadowRootMode: null,
    shape: null,
    size: M,
    sizes: null,
    slot: null,
    span: M,
    spellCheck: Le,
    src: null,
    srcDoc: null,
    srcLang: null,
    srcSet: null,
    start: M,
    step: null,
    style: null,
    tabIndex: M,
    target: null,
    title: null,
    translate: null,
    type: null,
    typeMustMatch: ie,
    useMap: null,
    value: Le,
    width: M,
    wrap: null,
    writingSuggestions: null,
    // Legacy.
    // See: https://html.spec.whatwg.org/#other-elements,-attributes-and-apis
    align: null,
    // Several. Use CSS `text-align` instead,
    aLink: null,
    // `<body>`. Use CSS `a:active {color}` instead
    archive: we,
    // `<object>`. List of URIs to archives
    axis: null,
    // `<td>` and `<th>`. Use `scope` on `<th>`
    background: null,
    // `<body>`. Use CSS `background-image` instead
    bgColor: null,
    // `<body>` and table elements. Use CSS `background-color` instead
    border: M,
    // `<table>`. Use CSS `border-width` instead,
    borderColor: null,
    // `<table>`. Use CSS `border-color` instead,
    bottomMargin: M,
    // `<body>`
    cellPadding: null,
    // `<table>`
    cellSpacing: null,
    // `<table>`
    char: null,
    // Several table elements. When `align=char`, sets the character to align on
    charOff: null,
    // Several table elements. When `char`, offsets the alignment
    classId: null,
    // `<object>`
    clear: null,
    // `<br>`. Use CSS `clear` instead
    code: null,
    // `<object>`
    codeBase: null,
    // `<object>`
    codeType: null,
    // `<object>`
    color: null,
    // `<font>` and `<hr>`. Use CSS instead
    compact: ie,
    // Lists. Use CSS to reduce space between items instead
    declare: ie,
    // `<object>`
    event: null,
    // `<script>`
    face: null,
    // `<font>`. Use CSS instead
    frame: null,
    // `<table>`
    frameBorder: null,
    // `<iframe>`. Use CSS `border` instead
    hSpace: M,
    // `<img>` and `<object>`
    leftMargin: M,
    // `<body>`
    link: null,
    // `<body>`. Use CSS `a:link {color: *}` instead
    longDesc: null,
    // `<frame>`, `<iframe>`, and `<img>`. Use an `<a>`
    lowSrc: null,
    // `<img>`. Use a `<picture>`
    marginHeight: M,
    // `<body>`
    marginWidth: M,
    // `<body>`
    noResize: ie,
    // `<frame>`
    noHref: ie,
    // `<area>`. Use no href instead of an explicit `nohref`
    noShade: ie,
    // `<hr>`. Use background-color and height instead of borders
    noWrap: ie,
    // `<td>` and `<th>`
    object: null,
    // `<applet>`
    profile: null,
    // `<head>`
    prompt: null,
    // `<isindex>`
    rev: null,
    // `<link>`
    rightMargin: M,
    // `<body>`
    rules: null,
    // `<table>`
    scheme: null,
    // `<meta>`
    scrolling: Le,
    // `<frame>`. Use overflow in the child context
    standby: null,
    // `<object>`
    summary: null,
    // `<table>`
    text: null,
    // `<body>`. Use CSS `color` instead
    topMargin: M,
    // `<body>`
    valueType: null,
    // `<param>`
    version: null,
    // `<html>`. Use a doctype.
    vAlign: null,
    // Several. Use CSS `vertical-align` instead
    vLink: null,
    // `<body>`. Use CSS `a:visited {color}` instead
    vSpace: M,
    // `<img>` and `<object>`
    // Non-standard Properties.
    allowTransparency: null,
    autoCorrect: null,
    autoSave: null,
    disablePictureInPicture: ie,
    disableRemotePlayback: ie,
    prefix: null,
    property: null,
    results: M,
    security: null,
    unselectable: null
  }
}), wz = wr({
  space: "svg",
  attributes: {
    accentHeight: "accent-height",
    alignmentBaseline: "alignment-baseline",
    arabicForm: "arabic-form",
    baselineShift: "baseline-shift",
    capHeight: "cap-height",
    className: "class",
    clipPath: "clip-path",
    clipRule: "clip-rule",
    colorInterpolation: "color-interpolation",
    colorInterpolationFilters: "color-interpolation-filters",
    colorProfile: "color-profile",
    colorRendering: "color-rendering",
    crossOrigin: "crossorigin",
    dataType: "datatype",
    dominantBaseline: "dominant-baseline",
    enableBackground: "enable-background",
    fillOpacity: "fill-opacity",
    fillRule: "fill-rule",
    floodColor: "flood-color",
    floodOpacity: "flood-opacity",
    fontFamily: "font-family",
    fontSize: "font-size",
    fontSizeAdjust: "font-size-adjust",
    fontStretch: "font-stretch",
    fontStyle: "font-style",
    fontVariant: "font-variant",
    fontWeight: "font-weight",
    glyphName: "glyph-name",
    glyphOrientationHorizontal: "glyph-orientation-horizontal",
    glyphOrientationVertical: "glyph-orientation-vertical",
    hrefLang: "hreflang",
    horizAdvX: "horiz-adv-x",
    horizOriginX: "horiz-origin-x",
    horizOriginY: "horiz-origin-y",
    imageRendering: "image-rendering",
    letterSpacing: "letter-spacing",
    lightingColor: "lighting-color",
    markerEnd: "marker-end",
    markerMid: "marker-mid",
    markerStart: "marker-start",
    navDown: "nav-down",
    navDownLeft: "nav-down-left",
    navDownRight: "nav-down-right",
    navLeft: "nav-left",
    navNext: "nav-next",
    navPrev: "nav-prev",
    navRight: "nav-right",
    navUp: "nav-up",
    navUpLeft: "nav-up-left",
    navUpRight: "nav-up-right",
    onAbort: "onabort",
    onActivate: "onactivate",
    onAfterPrint: "onafterprint",
    onBeforePrint: "onbeforeprint",
    onBegin: "onbegin",
    onCancel: "oncancel",
    onCanPlay: "oncanplay",
    onCanPlayThrough: "oncanplaythrough",
    onChange: "onchange",
    onClick: "onclick",
    onClose: "onclose",
    onCopy: "oncopy",
    onCueChange: "oncuechange",
    onCut: "oncut",
    onDblClick: "ondblclick",
    onDrag: "ondrag",
    onDragEnd: "ondragend",
    onDragEnter: "ondragenter",
    onDragExit: "ondragexit",
    onDragLeave: "ondragleave",
    onDragOver: "ondragover",
    onDragStart: "ondragstart",
    onDrop: "ondrop",
    onDurationChange: "ondurationchange",
    onEmptied: "onemptied",
    onEnd: "onend",
    onEnded: "onended",
    onError: "onerror",
    onFocus: "onfocus",
    onFocusIn: "onfocusin",
    onFocusOut: "onfocusout",
    onHashChange: "onhashchange",
    onInput: "oninput",
    onInvalid: "oninvalid",
    onKeyDown: "onkeydown",
    onKeyPress: "onkeypress",
    onKeyUp: "onkeyup",
    onLoad: "onload",
    onLoadedData: "onloadeddata",
    onLoadedMetadata: "onloadedmetadata",
    onLoadStart: "onloadstart",
    onMessage: "onmessage",
    onMouseDown: "onmousedown",
    onMouseEnter: "onmouseenter",
    onMouseLeave: "onmouseleave",
    onMouseMove: "onmousemove",
    onMouseOut: "onmouseout",
    onMouseOver: "onmouseover",
    onMouseUp: "onmouseup",
    onMouseWheel: "onmousewheel",
    onOffline: "onoffline",
    onOnline: "ononline",
    onPageHide: "onpagehide",
    onPageShow: "onpageshow",
    onPaste: "onpaste",
    onPause: "onpause",
    onPlay: "onplay",
    onPlaying: "onplaying",
    onPopState: "onpopstate",
    onProgress: "onprogress",
    onRateChange: "onratechange",
    onRepeat: "onrepeat",
    onReset: "onreset",
    onResize: "onresize",
    onScroll: "onscroll",
    onSeeked: "onseeked",
    onSeeking: "onseeking",
    onSelect: "onselect",
    onShow: "onshow",
    onStalled: "onstalled",
    onStorage: "onstorage",
    onSubmit: "onsubmit",
    onSuspend: "onsuspend",
    onTimeUpdate: "ontimeupdate",
    onToggle: "ontoggle",
    onUnload: "onunload",
    onVolumeChange: "onvolumechange",
    onWaiting: "onwaiting",
    onZoom: "onzoom",
    overlinePosition: "overline-position",
    overlineThickness: "overline-thickness",
    paintOrder: "paint-order",
    panose1: "panose-1",
    pointerEvents: "pointer-events",
    referrerPolicy: "referrerpolicy",
    renderingIntent: "rendering-intent",
    shapeRendering: "shape-rendering",
    stopColor: "stop-color",
    stopOpacity: "stop-opacity",
    strikethroughPosition: "strikethrough-position",
    strikethroughThickness: "strikethrough-thickness",
    strokeDashArray: "stroke-dasharray",
    strokeDashOffset: "stroke-dashoffset",
    strokeLineCap: "stroke-linecap",
    strokeLineJoin: "stroke-linejoin",
    strokeMiterLimit: "stroke-miterlimit",
    strokeOpacity: "stroke-opacity",
    strokeWidth: "stroke-width",
    tabIndex: "tabindex",
    textAnchor: "text-anchor",
    textDecoration: "text-decoration",
    textRendering: "text-rendering",
    transformOrigin: "transform-origin",
    typeOf: "typeof",
    underlinePosition: "underline-position",
    underlineThickness: "underline-thickness",
    unicodeBidi: "unicode-bidi",
    unicodeRange: "unicode-range",
    unitsPerEm: "units-per-em",
    vAlphabetic: "v-alphabetic",
    vHanging: "v-hanging",
    vIdeographic: "v-ideographic",
    vMathematical: "v-mathematical",
    vectorEffect: "vector-effect",
    vertAdvY: "vert-adv-y",
    vertOriginX: "vert-origin-x",
    vertOriginY: "vert-origin-y",
    wordSpacing: "word-spacing",
    writingMode: "writing-mode",
    xHeight: "x-height",
    // These were camelcased in Tiny. Now lowercased in SVG 2
    playbackOrder: "playbackorder",
    timelineBegin: "timelinebegin"
  },
  transform: ik,
  properties: {
    about: vt,
    accentHeight: M,
    accumulate: null,
    additive: null,
    alignmentBaseline: null,
    alphabetic: M,
    amplitude: M,
    arabicForm: null,
    ascent: M,
    attributeName: null,
    attributeType: null,
    azimuth: M,
    bandwidth: null,
    baselineShift: null,
    baseFrequency: null,
    baseProfile: null,
    bbox: null,
    begin: null,
    bias: M,
    by: null,
    calcMode: null,
    capHeight: M,
    className: we,
    clip: null,
    clipPath: null,
    clipPathUnits: null,
    clipRule: null,
    color: null,
    colorInterpolation: null,
    colorInterpolationFilters: null,
    colorProfile: null,
    colorRendering: null,
    content: null,
    contentScriptType: null,
    contentStyleType: null,
    crossOrigin: null,
    cursor: null,
    cx: null,
    cy: null,
    d: null,
    dataType: null,
    defaultAction: null,
    descent: M,
    diffuseConstant: M,
    direction: null,
    display: null,
    dur: null,
    divisor: M,
    dominantBaseline: null,
    download: ie,
    dx: null,
    dy: null,
    edgeMode: null,
    editable: null,
    elevation: M,
    enableBackground: null,
    end: null,
    event: null,
    exponent: M,
    externalResourcesRequired: null,
    fill: null,
    fillOpacity: M,
    fillRule: null,
    filter: null,
    filterRes: null,
    filterUnits: null,
    floodColor: null,
    floodOpacity: null,
    focusable: null,
    focusHighlight: null,
    fontFamily: null,
    fontSize: null,
    fontSizeAdjust: null,
    fontStretch: null,
    fontStyle: null,
    fontVariant: null,
    fontWeight: null,
    format: null,
    fr: null,
    from: null,
    fx: null,
    fy: null,
    g1: Ki,
    g2: Ki,
    glyphName: Ki,
    glyphOrientationHorizontal: null,
    glyphOrientationVertical: null,
    glyphRef: null,
    gradientTransform: null,
    gradientUnits: null,
    handler: null,
    hanging: M,
    hatchContentUnits: null,
    hatchUnits: null,
    height: null,
    href: null,
    hrefLang: null,
    horizAdvX: M,
    horizOriginX: M,
    horizOriginY: M,
    id: null,
    ideographic: M,
    imageRendering: null,
    initialVisibility: null,
    in: null,
    in2: null,
    intercept: M,
    k: M,
    k1: M,
    k2: M,
    k3: M,
    k4: M,
    kernelMatrix: vt,
    kernelUnitLength: null,
    keyPoints: null,
    // SEMI_COLON_SEPARATED
    keySplines: null,
    // SEMI_COLON_SEPARATED
    keyTimes: null,
    // SEMI_COLON_SEPARATED
    kerning: null,
    lang: null,
    lengthAdjust: null,
    letterSpacing: null,
    lightingColor: null,
    limitingConeAngle: M,
    local: null,
    markerEnd: null,
    markerMid: null,
    markerStart: null,
    markerHeight: null,
    markerUnits: null,
    markerWidth: null,
    mask: null,
    maskContentUnits: null,
    maskUnits: null,
    mathematical: null,
    max: null,
    media: null,
    mediaCharacterEncoding: null,
    mediaContentEncodings: null,
    mediaSize: M,
    mediaTime: null,
    method: null,
    min: null,
    mode: null,
    name: null,
    navDown: null,
    navDownLeft: null,
    navDownRight: null,
    navLeft: null,
    navNext: null,
    navPrev: null,
    navRight: null,
    navUp: null,
    navUpLeft: null,
    navUpRight: null,
    numOctaves: null,
    observer: null,
    offset: null,
    onAbort: null,
    onActivate: null,
    onAfterPrint: null,
    onBeforePrint: null,
    onBegin: null,
    onCancel: null,
    onCanPlay: null,
    onCanPlayThrough: null,
    onChange: null,
    onClick: null,
    onClose: null,
    onCopy: null,
    onCueChange: null,
    onCut: null,
    onDblClick: null,
    onDrag: null,
    onDragEnd: null,
    onDragEnter: null,
    onDragExit: null,
    onDragLeave: null,
    onDragOver: null,
    onDragStart: null,
    onDrop: null,
    onDurationChange: null,
    onEmptied: null,
    onEnd: null,
    onEnded: null,
    onError: null,
    onFocus: null,
    onFocusIn: null,
    onFocusOut: null,
    onHashChange: null,
    onInput: null,
    onInvalid: null,
    onKeyDown: null,
    onKeyPress: null,
    onKeyUp: null,
    onLoad: null,
    onLoadedData: null,
    onLoadedMetadata: null,
    onLoadStart: null,
    onMessage: null,
    onMouseDown: null,
    onMouseEnter: null,
    onMouseLeave: null,
    onMouseMove: null,
    onMouseOut: null,
    onMouseOver: null,
    onMouseUp: null,
    onMouseWheel: null,
    onOffline: null,
    onOnline: null,
    onPageHide: null,
    onPageShow: null,
    onPaste: null,
    onPause: null,
    onPlay: null,
    onPlaying: null,
    onPopState: null,
    onProgress: null,
    onRateChange: null,
    onRepeat: null,
    onReset: null,
    onResize: null,
    onScroll: null,
    onSeeked: null,
    onSeeking: null,
    onSelect: null,
    onShow: null,
    onStalled: null,
    onStorage: null,
    onSubmit: null,
    onSuspend: null,
    onTimeUpdate: null,
    onToggle: null,
    onUnload: null,
    onVolumeChange: null,
    onWaiting: null,
    onZoom: null,
    opacity: null,
    operator: null,
    order: null,
    orient: null,
    orientation: null,
    origin: null,
    overflow: null,
    overlay: null,
    overlinePosition: M,
    overlineThickness: M,
    paintOrder: null,
    panose1: null,
    path: null,
    pathLength: M,
    patternContentUnits: null,
    patternTransform: null,
    patternUnits: null,
    phase: null,
    ping: we,
    pitch: null,
    playbackOrder: null,
    pointerEvents: null,
    points: null,
    pointsAtX: M,
    pointsAtY: M,
    pointsAtZ: M,
    preserveAlpha: null,
    preserveAspectRatio: null,
    primitiveUnits: null,
    propagate: null,
    property: vt,
    r: null,
    radius: null,
    referrerPolicy: null,
    refX: null,
    refY: null,
    rel: vt,
    rev: vt,
    renderingIntent: null,
    repeatCount: null,
    repeatDur: null,
    requiredExtensions: vt,
    requiredFeatures: vt,
    requiredFonts: vt,
    requiredFormats: vt,
    resource: null,
    restart: null,
    result: null,
    rotate: null,
    rx: null,
    ry: null,
    scale: null,
    seed: null,
    shapeRendering: null,
    side: null,
    slope: null,
    snapshotTime: null,
    specularConstant: M,
    specularExponent: M,
    spreadMethod: null,
    spacing: null,
    startOffset: null,
    stdDeviation: null,
    stemh: null,
    stemv: null,
    stitchTiles: null,
    stopColor: null,
    stopOpacity: null,
    strikethroughPosition: M,
    strikethroughThickness: M,
    string: null,
    stroke: null,
    strokeDashArray: vt,
    strokeDashOffset: null,
    strokeLineCap: null,
    strokeLineJoin: null,
    strokeMiterLimit: M,
    strokeOpacity: M,
    strokeWidth: null,
    style: null,
    surfaceScale: M,
    syncBehavior: null,
    syncBehaviorDefault: null,
    syncMaster: null,
    syncTolerance: null,
    syncToleranceDefault: null,
    systemLanguage: vt,
    tabIndex: M,
    tableValues: null,
    target: null,
    targetX: M,
    targetY: M,
    textAnchor: null,
    textDecoration: null,
    textRendering: null,
    textLength: null,
    timelineBegin: null,
    title: null,
    transformBehavior: null,
    type: null,
    typeOf: vt,
    to: null,
    transform: null,
    transformOrigin: null,
    u1: null,
    u2: null,
    underlinePosition: M,
    underlineThickness: M,
    unicode: null,
    unicodeBidi: null,
    unicodeRange: null,
    unitsPerEm: M,
    values: null,
    vAlphabetic: M,
    vMathematical: M,
    vectorEffect: null,
    vHanging: M,
    vIdeographic: M,
    version: null,
    vertAdvY: M,
    vertOriginX: M,
    vertOriginY: M,
    viewBox: null,
    viewTarget: null,
    visibility: null,
    width: null,
    widths: null,
    wordSpacing: null,
    writingMode: null,
    x: null,
    x1: null,
    x2: null,
    xChannelSelector: null,
    xHeight: M,
    y: null,
    y1: null,
    y2: null,
    yChannelSelector: null,
    z: null,
    zoomAndPan: null
  }
}), Sz = /^data[-\w.:]+$/i, fg = /-[a-z]/g, vz = /[A-Z]/g;
function Pz(n, e) {
  const t = Yc(e);
  let i = e, r = Xt;
  if (t in n.normal)
    return n.property[n.normal[t]];
  if (t.length > 4 && t.slice(0, 4) === "data" && Sz.test(e)) {
    if (e.charAt(4) === "-") {
      const s = e.slice(5).replace(fg, $z);
      i = "data" + s.charAt(0).toUpperCase() + s.slice(1);
    } else {
      const s = e.slice(4);
      if (!fg.test(s)) {
        let o = s.replace(vz, Qz);
        o.charAt(0) !== "-" && (o = "-" + o), e = "data" + o;
      }
    }
    r = gf;
  }
  return new r(i, e);
}
function Qz(n) {
  return "-" + n.toLowerCase();
}
function $z(n) {
  return n.charAt(1).toUpperCase();
}
const Cz = Jy([nk, tk, sk, ok, xz], "html"), ak = Jy([nk, tk, sk, ok, wz], "svg"), Tz = /["&'<>`]/g, Az = /[\uD800-\uDBFF][\uDC00-\uDFFF]/g, Rz = (
  // eslint-disable-next-line no-control-regex, unicorn/no-hex-escape
  /[\x01-\t\v\f\x0E-\x1F\x7F\x81\x8D\x8F\x90\x9D\xA0-\uFFFF]/g
), Mz = /[|\\{}()[\]^$+*?.]/g, dg = /* @__PURE__ */ new WeakMap();
function Zz(n, e) {
  if (n = n.replace(
    e.subset ? Ez(e.subset) : Tz,
    i
  ), e.subset || e.escapeOnly)
    return n;
  return n.replace(Az, t).replace(Rz, i);
  function t(r, s, o) {
    return e.format(
      (r.charCodeAt(0) - 55296) * 1024 + r.charCodeAt(1) - 56320 + 65536,
      o.charCodeAt(s + 2),
      e
    );
  }
  function i(r, s, o) {
    return e.format(
      r.charCodeAt(0),
      o.charCodeAt(s + 1),
      e
    );
  }
}
function Ez(n) {
  let e = dg.get(n);
  return e || (e = zz(n), dg.set(n, e)), e;
}
function zz(n) {
  const e = [];
  let t = -1;
  for (; ++t < n.length; )
    e.push(n[t].replace(Mz, "\\$&"));
  return new RegExp("(?:" + e.join("|") + ")", "g");
}
const Dz = /[\dA-Fa-f]/;
function Iz(n, e, t) {
  const i = "&#x" + n.toString(16).toUpperCase();
  return t && e && !Dz.test(String.fromCharCode(e)) ? i : i + ";";
}
const Lz = /\d/;
function _z(n, e, t) {
  const i = "&#" + String(n);
  return t && e && !Lz.test(String.fromCharCode(e)) ? i : i + ";";
}
const Xz = [
  "AElig",
  "AMP",
  "Aacute",
  "Acirc",
  "Agrave",
  "Aring",
  "Atilde",
  "Auml",
  "COPY",
  "Ccedil",
  "ETH",
  "Eacute",
  "Ecirc",
  "Egrave",
  "Euml",
  "GT",
  "Iacute",
  "Icirc",
  "Igrave",
  "Iuml",
  "LT",
  "Ntilde",
  "Oacute",
  "Ocirc",
  "Ograve",
  "Oslash",
  "Otilde",
  "Ouml",
  "QUOT",
  "REG",
  "THORN",
  "Uacute",
  "Ucirc",
  "Ugrave",
  "Uuml",
  "Yacute",
  "aacute",
  "acirc",
  "acute",
  "aelig",
  "agrave",
  "amp",
  "aring",
  "atilde",
  "auml",
  "brvbar",
  "ccedil",
  "cedil",
  "cent",
  "copy",
  "curren",
  "deg",
  "divide",
  "eacute",
  "ecirc",
  "egrave",
  "eth",
  "euml",
  "frac12",
  "frac14",
  "frac34",
  "gt",
  "iacute",
  "icirc",
  "iexcl",
  "igrave",
  "iquest",
  "iuml",
  "laquo",
  "lt",
  "macr",
  "micro",
  "middot",
  "nbsp",
  "not",
  "ntilde",
  "oacute",
  "ocirc",
  "ograve",
  "ordf",
  "ordm",
  "oslash",
  "otilde",
  "ouml",
  "para",
  "plusmn",
  "pound",
  "quot",
  "raquo",
  "reg",
  "sect",
  "shy",
  "sup1",
  "sup2",
  "sup3",
  "szlig",
  "thorn",
  "times",
  "uacute",
  "ucirc",
  "ugrave",
  "uml",
  "uuml",
  "yacute",
  "yen",
  "yuml"
], mu = {
  nbsp: " ",
  iexcl: "¡",
  cent: "¢",
  pound: "£",
  curren: "¤",
  yen: "¥",
  brvbar: "¦",
  sect: "§",
  uml: "¨",
  copy: "©",
  ordf: "ª",
  laquo: "«",
  not: "¬",
  shy: "­",
  reg: "®",
  macr: "¯",
  deg: "°",
  plusmn: "±",
  sup2: "²",
  sup3: "³",
  acute: "´",
  micro: "µ",
  para: "¶",
  middot: "·",
  cedil: "¸",
  sup1: "¹",
  ordm: "º",
  raquo: "»",
  frac14: "¼",
  frac12: "½",
  frac34: "¾",
  iquest: "¿",
  Agrave: "À",
  Aacute: "Á",
  Acirc: "Â",
  Atilde: "Ã",
  Auml: "Ä",
  Aring: "Å",
  AElig: "Æ",
  Ccedil: "Ç",
  Egrave: "È",
  Eacute: "É",
  Ecirc: "Ê",
  Euml: "Ë",
  Igrave: "Ì",
  Iacute: "Í",
  Icirc: "Î",
  Iuml: "Ï",
  ETH: "Ð",
  Ntilde: "Ñ",
  Ograve: "Ò",
  Oacute: "Ó",
  Ocirc: "Ô",
  Otilde: "Õ",
  Ouml: "Ö",
  times: "×",
  Oslash: "Ø",
  Ugrave: "Ù",
  Uacute: "Ú",
  Ucirc: "Û",
  Uuml: "Ü",
  Yacute: "Ý",
  THORN: "Þ",
  szlig: "ß",
  agrave: "à",
  aacute: "á",
  acirc: "â",
  atilde: "ã",
  auml: "ä",
  aring: "å",
  aelig: "æ",
  ccedil: "ç",
  egrave: "è",
  eacute: "é",
  ecirc: "ê",
  euml: "ë",
  igrave: "ì",
  iacute: "í",
  icirc: "î",
  iuml: "ï",
  eth: "ð",
  ntilde: "ñ",
  ograve: "ò",
  oacute: "ó",
  ocirc: "ô",
  otilde: "õ",
  ouml: "ö",
  divide: "÷",
  oslash: "ø",
  ugrave: "ù",
  uacute: "ú",
  ucirc: "û",
  uuml: "ü",
  yacute: "ý",
  thorn: "þ",
  yuml: "ÿ",
  fnof: "ƒ",
  Alpha: "Α",
  Beta: "Β",
  Gamma: "Γ",
  Delta: "Δ",
  Epsilon: "Ε",
  Zeta: "Ζ",
  Eta: "Η",
  Theta: "Θ",
  Iota: "Ι",
  Kappa: "Κ",
  Lambda: "Λ",
  Mu: "Μ",
  Nu: "Ν",
  Xi: "Ξ",
  Omicron: "Ο",
  Pi: "Π",
  Rho: "Ρ",
  Sigma: "Σ",
  Tau: "Τ",
  Upsilon: "Υ",
  Phi: "Φ",
  Chi: "Χ",
  Psi: "Ψ",
  Omega: "Ω",
  alpha: "α",
  beta: "β",
  gamma: "γ",
  delta: "δ",
  epsilon: "ε",
  zeta: "ζ",
  eta: "η",
  theta: "θ",
  iota: "ι",
  kappa: "κ",
  lambda: "λ",
  mu: "μ",
  nu: "ν",
  xi: "ξ",
  omicron: "ο",
  pi: "π",
  rho: "ρ",
  sigmaf: "ς",
  sigma: "σ",
  tau: "τ",
  upsilon: "υ",
  phi: "φ",
  chi: "χ",
  psi: "ψ",
  omega: "ω",
  thetasym: "ϑ",
  upsih: "ϒ",
  piv: "ϖ",
  bull: "•",
  hellip: "…",
  prime: "′",
  Prime: "″",
  oline: "‾",
  frasl: "⁄",
  weierp: "℘",
  image: "ℑ",
  real: "ℜ",
  trade: "™",
  alefsym: "ℵ",
  larr: "←",
  uarr: "↑",
  rarr: "→",
  darr: "↓",
  harr: "↔",
  crarr: "↵",
  lArr: "⇐",
  uArr: "⇑",
  rArr: "⇒",
  dArr: "⇓",
  hArr: "⇔",
  forall: "∀",
  part: "∂",
  exist: "∃",
  empty: "∅",
  nabla: "∇",
  isin: "∈",
  notin: "∉",
  ni: "∋",
  prod: "∏",
  sum: "∑",
  minus: "−",
  lowast: "∗",
  radic: "√",
  prop: "∝",
  infin: "∞",
  ang: "∠",
  and: "∧",
  or: "∨",
  cap: "∩",
  cup: "∪",
  int: "∫",
  there4: "∴",
  sim: "∼",
  cong: "≅",
  asymp: "≈",
  ne: "≠",
  equiv: "≡",
  le: "≤",
  ge: "≥",
  sub: "⊂",
  sup: "⊃",
  nsub: "⊄",
  sube: "⊆",
  supe: "⊇",
  oplus: "⊕",
  otimes: "⊗",
  perp: "⊥",
  sdot: "⋅",
  lceil: "⌈",
  rceil: "⌉",
  lfloor: "⌊",
  rfloor: "⌋",
  lang: "〈",
  rang: "〉",
  loz: "◊",
  spades: "♠",
  clubs: "♣",
  hearts: "♥",
  diams: "♦",
  quot: '"',
  amp: "&",
  lt: "<",
  gt: ">",
  OElig: "Œ",
  oelig: "œ",
  Scaron: "Š",
  scaron: "š",
  Yuml: "Ÿ",
  circ: "ˆ",
  tilde: "˜",
  ensp: " ",
  emsp: " ",
  thinsp: " ",
  zwnj: "‌",
  zwj: "‍",
  lrm: "‎",
  rlm: "‏",
  ndash: "–",
  mdash: "—",
  lsquo: "‘",
  rsquo: "’",
  sbquo: "‚",
  ldquo: "“",
  rdquo: "”",
  bdquo: "„",
  dagger: "†",
  Dagger: "‡",
  permil: "‰",
  lsaquo: "‹",
  rsaquo: "›",
  euro: "€"
}, Nz = [
  "cent",
  "copy",
  "divide",
  "gt",
  "lt",
  "not",
  "para",
  "times"
], lk = {}.hasOwnProperty, Uc = {};
let zo;
for (zo in mu)
  lk.call(mu, zo) && (Uc[mu[zo]] = zo);
const Wz = /[^\dA-Za-z]/;
function qz(n, e, t, i) {
  const r = String.fromCharCode(n);
  if (lk.call(Uc, r)) {
    const s = Uc[r], o = "&" + s;
    return t && Xz.includes(s) && !Nz.includes(s) && (!i || e && e !== 61 && Wz.test(String.fromCharCode(e))) ? o : o + ";";
  }
  return "";
}
function Bz(n, e, t) {
  let i = Iz(n, e, t.omitOptionalSemicolons), r;
  if ((t.useNamedReferences || t.useShortestReferences) && (r = qz(
    n,
    e,
    t.omitOptionalSemicolons,
    t.attribute
  )), (t.useShortestReferences || !r) && t.useShortestReferences) {
    const s = _z(n, e, t.omitOptionalSemicolons);
    s.length < i.length && (i = s);
  }
  return r && (!t.useShortestReferences || r.length < i.length) ? r : i;
}
function Ji(n, e) {
  return Zz(n, Object.assign({ format: Bz }, e));
}
const Vz = /^>|^->|<!--|-->|--!>|<!-$/g, Yz = [">"], jz = ["<", ">"];
function Uz(n, e, t, i) {
  return i.settings.bogusComments ? "<?" + Ji(
    n.value,
    Object.assign({}, i.settings.characterReferences, {
      subset: Yz
    })
  ) + ">" : "<!--" + n.value.replace(Vz, r) + "-->";
  function r(s) {
    return Ji(
      s,
      Object.assign({}, i.settings.characterReferences, {
        subset: jz
      })
    );
  }
}
function Fz(n, e, t, i) {
  return "<!" + (i.settings.upperDoctype ? "DOCTYPE" : "doctype") + (i.settings.tightDoctype ? "" : " ") + "html>";
}
function Gz(n, e) {
  const t = e || {};
  return (n[n.length - 1] === "" ? [...n, ""] : n).join(
    (t.padRight ? " " : "") + "," + (t.padLeft === !1 ? "" : " ")
  ).trim();
}
function Hz(n) {
  return n.join(" ").trim();
}
const Kz = /[ \t\n\f\r]/g;
function Of(n) {
  return typeof n == "object" ? n.type === "text" ? pg(n.value) : !1 : pg(n);
}
function pg(n) {
  return n.replace(Kz, "") === "";
}
const Ve = ck(1), uk = ck(-1), Jz = [];
function ck(n) {
  return e;
  function e(t, i, r) {
    const s = t ? t.children : Jz;
    let o = (i || 0) + n, a = s[o];
    if (!r)
      for (; a && Of(a); )
        o += n, a = s[o];
    return a;
  }
}
const e6 = {}.hasOwnProperty;
function hk(n) {
  return e;
  function e(t, i, r) {
    return e6.call(n, t.tagName) && n[t.tagName](t, i, r);
  }
}
const bf = hk({
  body: n6,
  caption: gu,
  colgroup: gu,
  dd: o6,
  dt: s6,
  head: gu,
  html: t6,
  li: r6,
  optgroup: a6,
  option: l6,
  p: i6,
  rp: mg,
  rt: mg,
  tbody: c6,
  td: gg,
  tfoot: h6,
  th: gg,
  thead: u6,
  tr: f6
});
function gu(n, e, t) {
  const i = Ve(t, e, !0);
  return !i || i.type !== "comment" && !(i.type === "text" && Of(i.value.charAt(0)));
}
function t6(n, e, t) {
  const i = Ve(t, e);
  return !i || i.type !== "comment";
}
function n6(n, e, t) {
  const i = Ve(t, e);
  return !i || i.type !== "comment";
}
function i6(n, e, t) {
  const i = Ve(t, e);
  return i ? i.type === "element" && (i.tagName === "address" || i.tagName === "article" || i.tagName === "aside" || i.tagName === "blockquote" || i.tagName === "details" || i.tagName === "div" || i.tagName === "dl" || i.tagName === "fieldset" || i.tagName === "figcaption" || i.tagName === "figure" || i.tagName === "footer" || i.tagName === "form" || i.tagName === "h1" || i.tagName === "h2" || i.tagName === "h3" || i.tagName === "h4" || i.tagName === "h5" || i.tagName === "h6" || i.tagName === "header" || i.tagName === "hgroup" || i.tagName === "hr" || i.tagName === "main" || i.tagName === "menu" || i.tagName === "nav" || i.tagName === "ol" || i.tagName === "p" || i.tagName === "pre" || i.tagName === "section" || i.tagName === "table" || i.tagName === "ul") : !t || // Confusing parent.
  !(t.type === "element" && (t.tagName === "a" || t.tagName === "audio" || t.tagName === "del" || t.tagName === "ins" || t.tagName === "map" || t.tagName === "noscript" || t.tagName === "video"));
}
function r6(n, e, t) {
  const i = Ve(t, e);
  return !i || i.type === "element" && i.tagName === "li";
}
function s6(n, e, t) {
  const i = Ve(t, e);
  return !!(i && i.type === "element" && (i.tagName === "dt" || i.tagName === "dd"));
}
function o6(n, e, t) {
  const i = Ve(t, e);
  return !i || i.type === "element" && (i.tagName === "dt" || i.tagName === "dd");
}
function mg(n, e, t) {
  const i = Ve(t, e);
  return !i || i.type === "element" && (i.tagName === "rp" || i.tagName === "rt");
}
function a6(n, e, t) {
  const i = Ve(t, e);
  return !i || i.type === "element" && i.tagName === "optgroup";
}
function l6(n, e, t) {
  const i = Ve(t, e);
  return !i || i.type === "element" && (i.tagName === "option" || i.tagName === "optgroup");
}
function u6(n, e, t) {
  const i = Ve(t, e);
  return !!(i && i.type === "element" && (i.tagName === "tbody" || i.tagName === "tfoot"));
}
function c6(n, e, t) {
  const i = Ve(t, e);
  return !i || i.type === "element" && (i.tagName === "tbody" || i.tagName === "tfoot");
}
function h6(n, e, t) {
  return !Ve(t, e);
}
function f6(n, e, t) {
  const i = Ve(t, e);
  return !i || i.type === "element" && i.tagName === "tr";
}
function gg(n, e, t) {
  const i = Ve(t, e);
  return !i || i.type === "element" && (i.tagName === "td" || i.tagName === "th");
}
const d6 = hk({
  body: g6,
  colgroup: O6,
  head: m6,
  html: p6,
  tbody: b6
});
function p6(n) {
  const e = Ve(n, -1);
  return !e || e.type !== "comment";
}
function m6(n) {
  const e = n.children, t = [];
  let i = -1;
  for (; ++i < e.length; ) {
    const r = e[i];
    if (r.type === "element" && (r.tagName === "title" || r.tagName === "base")) {
      if (t.includes(r.tagName))
        return !1;
      t.push(r.tagName);
    }
  }
  return e.length > 0;
}
function g6(n) {
  const e = Ve(n, -1, !0);
  return !e || e.type !== "comment" && !(e.type === "text" && Of(e.value.charAt(0))) && !(e.type === "element" && (e.tagName === "meta" || e.tagName === "link" || e.tagName === "script" || e.tagName === "style" || e.tagName === "template"));
}
function O6(n, e, t) {
  const i = uk(t, e), r = Ve(n, -1, !0);
  return t && i && i.type === "element" && i.tagName === "colgroup" && bf(i, t.children.indexOf(i), t) ? !1 : !!(r && r.type === "element" && r.tagName === "col");
}
function b6(n, e, t) {
  const i = uk(t, e), r = Ve(n, -1);
  return t && i && i.type === "element" && (i.tagName === "thead" || i.tagName === "tbody") && bf(i, t.children.indexOf(i), t) ? !1 : !!(r && r.type === "element" && r.tagName === "tr");
}
const Do = {
  // See: <https://html.spec.whatwg.org/#attribute-name-state>.
  name: [
    [`	
\f\r &/=>`.split(""), `	
\f\r "&'/=>\``.split("")],
    [`\0	
\f\r "&'/<=>`.split(""), `\0	
\f\r "&'/<=>\``.split("")]
  ],
  // See: <https://html.spec.whatwg.org/#attribute-value-(unquoted)-state>.
  unquoted: [
    [`	
\f\r &>`.split(""), `\0	
\f\r "&'<=>\``.split("")],
    [`\0	
\f\r "&'<=>\``.split(""), `\0	
\f\r "&'<=>\``.split("")]
  ],
  // See: <https://html.spec.whatwg.org/#attribute-value-(single-quoted)-state>.
  single: [
    ["&'".split(""), "\"&'`".split("")],
    ["\0&'".split(""), "\0\"&'`".split("")]
  ],
  // See: <https://html.spec.whatwg.org/#attribute-value-(double-quoted)-state>.
  double: [
    ['"&'.split(""), "\"&'`".split("")],
    ['\0"&'.split(""), "\0\"&'`".split("")]
  ]
};
function y6(n, e, t, i) {
  const r = i.schema, s = r.space === "svg" ? !1 : i.settings.omitOptionalTags;
  let o = r.space === "svg" ? i.settings.closeEmptyElements : i.settings.voids.includes(n.tagName.toLowerCase());
  const a = [];
  let l;
  r.space === "html" && n.tagName === "svg" && (i.schema = ak);
  const u = k6(i, n.properties), c = i.all(
    r.space === "html" && n.tagName === "template" ? n.content : n
  );
  return i.schema = r, c && (o = !1), (u || !s || !d6(n, e, t)) && (a.push("<", n.tagName, u ? " " + u : ""), o && (r.space === "svg" || i.settings.closeSelfClosing) && (l = u.charAt(u.length - 1), (!i.settings.tightSelfClosing || l === "/" || l && l !== '"' && l !== "'") && a.push(" "), a.push("/")), a.push(">")), a.push(c), !o && (!s || !bf(n, e, t)) && a.push("</" + n.tagName + ">"), a.join("");
}
function k6(n, e) {
  const t = [];
  let i = -1, r;
  if (e) {
    for (r in e)
      if (e[r] !== null && e[r] !== void 0) {
        const s = x6(n, r, e[r]);
        s && t.push(s);
      }
  }
  for (; ++i < t.length; ) {
    const s = n.settings.tightAttributes ? t[i].charAt(t[i].length - 1) : void 0;
    i !== t.length - 1 && s !== '"' && s !== "'" && (t[i] += " ");
  }
  return t.join("");
}
function x6(n, e, t) {
  const i = Pz(n.schema, e), r = n.settings.allowParseErrors && n.schema.space === "html" ? 0 : 1, s = n.settings.allowDangerousCharacters ? 0 : 1;
  let o = n.quote, a;
  if (i.overloadedBoolean && (t === i.attribute || t === "") ? t = !0 : (i.boolean || i.overloadedBoolean && typeof t != "string") && (t = !!t), t == null || t === !1 || typeof t == "number" && Number.isNaN(t))
    return "";
  const l = Ji(
    i.attribute,
    Object.assign({}, n.settings.characterReferences, {
      // Always encode without parse errors in non-HTML.
      subset: Do.name[r][s]
    })
  );
  return t === !0 || (t = Array.isArray(t) ? (i.commaSeparated ? Gz : Hz)(t, {
    padLeft: !n.settings.tightCommaSeparatedLists
  }) : String(t), n.settings.collapseEmptyAttributes && !t) ? l : (n.settings.preferUnquoted && (a = Ji(
    t,
    Object.assign({}, n.settings.characterReferences, {
      attribute: !0,
      subset: Do.unquoted[r][s]
    })
  )), a !== t && (n.settings.quoteSmart && va(t, o) > va(t, n.alternative) && (o = n.alternative), a = o + Ji(
    t,
    Object.assign({}, n.settings.characterReferences, {
      // Always encode without parse errors in non-HTML.
      subset: (o === "'" ? Do.single : Do.double)[r][s],
      attribute: !0
    })
  ) + o), l + (a && "=" + a));
}
const w6 = ["<", "&"];
function fk(n, e, t, i) {
  return t && t.type === "element" && (t.tagName === "script" || t.tagName === "style") ? n.value : Ji(
    n.value,
    Object.assign({}, i.settings.characterReferences, {
      subset: w6
    })
  );
}
function S6(n, e, t, i) {
  return i.settings.allowDangerousHtml ? n.value : fk(n, e, t, i);
}
function v6(n, e, t, i) {
  return i.all(n);
}
const P6 = D$("type", {
  invalid: Q6,
  unknown: $6,
  handlers: { comment: Uz, doctype: Fz, element: y6, raw: S6, root: v6, text: fk }
});
function Q6(n) {
  throw new Error("Expected node, not `" + n + "`");
}
function $6(n) {
  const e = (
    /** @type {Nodes} */
    n
  );
  throw new Error("Cannot compile unknown node `" + e.type + "`");
}
const C6 = {}, T6 = {}, A6 = [];
function R6(n, e) {
  const t = e || C6, i = t.quote || '"', r = i === '"' ? "'" : '"';
  if (i !== '"' && i !== "'")
    throw new Error("Invalid quote `" + i + "`, expected `'` or `\"`");
  return {
    one: M6,
    all: Z6,
    settings: {
      omitOptionalTags: t.omitOptionalTags || !1,
      allowParseErrors: t.allowParseErrors || !1,
      allowDangerousCharacters: t.allowDangerousCharacters || !1,
      quoteSmart: t.quoteSmart || !1,
      preferUnquoted: t.preferUnquoted || !1,
      tightAttributes: t.tightAttributes || !1,
      upperDoctype: t.upperDoctype || !1,
      tightDoctype: t.tightDoctype || !1,
      bogusComments: t.bogusComments || !1,
      tightCommaSeparatedLists: t.tightCommaSeparatedLists || !1,
      tightSelfClosing: t.tightSelfClosing || !1,
      collapseEmptyAttributes: t.collapseEmptyAttributes || !1,
      allowDangerousHtml: t.allowDangerousHtml || !1,
      voids: t.voids || bz,
      characterReferences: t.characterReferences || T6,
      closeSelfClosing: t.closeSelfClosing || !1,
      closeEmptyElements: t.closeEmptyElements || !1
    },
    schema: t.space === "svg" ? ak : Cz,
    quote: i,
    alternative: r
  }.one(
    Array.isArray(n) ? { type: "root", children: n } : n,
    void 0,
    void 0
  );
}
function M6(n, e, t) {
  return P6(n, e, t, this);
}
function Z6(n) {
  const e = [], t = n && n.children || A6;
  let i = -1;
  for (; ++i < t.length; )
    e[i] = this.one(t[i], i, n);
  return e.join("");
}
function E6(n) {
  const e = this, t = { ...e.data("settings"), ...n };
  e.compiler = i;
  function i(r) {
    return R6(r, t);
  }
}
var z6 = typeof global == "object" && global && global.Object === Object && global, D6 = typeof self == "object" && self && self.Object === Object && self, dk = z6 || D6 || Function("return this")(), Wa = dk.Symbol, pk = Object.prototype, I6 = pk.hasOwnProperty, L6 = pk.toString, Ir = Wa ? Wa.toStringTag : void 0;
function _6(n) {
  var e = I6.call(n, Ir), t = n[Ir];
  try {
    n[Ir] = void 0;
    var i = !0;
  } catch {
  }
  var r = L6.call(n);
  return i && (e ? n[Ir] = t : delete n[Ir]), r;
}
var X6 = Object.prototype, N6 = X6.toString;
function W6(n) {
  return N6.call(n);
}
var q6 = "[object Null]", B6 = "[object Undefined]", Og = Wa ? Wa.toStringTag : void 0;
function V6(n) {
  return n == null ? n === void 0 ? B6 : q6 : Og && Og in Object(n) ? _6(n) : W6(n);
}
function Y6(n) {
  return n != null && typeof n == "object";
}
var j6 = "[object Symbol]";
function U6(n) {
  return typeof n == "symbol" || Y6(n) && V6(n) == j6;
}
var F6 = /\s/;
function G6(n) {
  for (var e = n.length; e-- && F6.test(n.charAt(e)); )
    ;
  return e;
}
var H6 = /^\s+/;
function K6(n) {
  return n && n.slice(0, G6(n) + 1).replace(H6, "");
}
function qa(n) {
  var e = typeof n;
  return n != null && (e == "object" || e == "function");
}
var bg = NaN, J6 = /^[-+]0x[0-9a-f]+$/i, eD = /^0b[01]+$/i, tD = /^0o[0-7]+$/i, nD = parseInt;
function yg(n) {
  if (typeof n == "number")
    return n;
  if (U6(n))
    return bg;
  if (qa(n)) {
    var e = typeof n.valueOf == "function" ? n.valueOf() : n;
    n = qa(e) ? e + "" : e;
  }
  if (typeof n != "string")
    return n === 0 ? n : +n;
  n = K6(n);
  var t = eD.test(n);
  return t || tD.test(n) ? nD(n.slice(2), t ? 2 : 8) : J6.test(n) ? bg : +n;
}
var Ou = function() {
  return dk.Date.now();
}, iD = "Expected a function", rD = Math.max, sD = Math.min;
function mk(n, e, t) {
  var i, r, s, o, a, l, u = 0, c = !1, h = !1, f = !0;
  if (typeof n != "function")
    throw new TypeError(iD);
  e = yg(e) || 0, qa(t) && (c = !!t.leading, h = "maxWait" in t, s = h ? rD(yg(t.maxWait) || 0, e) : s, f = "trailing" in t ? !!t.trailing : f);
  function d(k) {
    var C = i, I = r;
    return i = r = void 0, u = k, o = n.apply(I, C), o;
  }
  function p(k) {
    return u = k, a = setTimeout(m, e), c ? d(k) : o;
  }
  function g(k) {
    var C = k - l, I = k - u, z = e - C;
    return h ? sD(z, s - I) : z;
  }
  function O(k) {
    var C = k - l, I = k - u;
    return l === void 0 || C >= e || C < 0 || h && I >= s;
  }
  function m() {
    var k = Ou();
    if (O(k))
      return b(k);
    a = setTimeout(m, g(k));
  }
  function b(k) {
    return a = void 0, f && i ? d(k) : (i = r = void 0, o);
  }
  function w() {
    a !== void 0 && clearTimeout(a), u = 0, i = l = r = a = void 0;
  }
  function Q() {
    return a === void 0 ? o : b(Ou());
  }
  function v() {
    var k = Ou(), C = O(k);
    if (i = arguments, r = this, l = k, C) {
      if (a === void 0)
        return p(l);
      if (h)
        return clearTimeout(a), a = setTimeout(m, e), d(l);
    }
    return a === void 0 && (a = setTimeout(m, e)), o;
  }
  return v.cancel = w, v.flush = Q, v;
}
var oD = "Expected a function";
function aD(n, e, t) {
  var i = !0, r = !0;
  if (typeof n != "function")
    throw new TypeError(oD);
  return qa(t) && (i = "leading" in t ? !!t.leading : i, r = "trailing" in t ? !!t.trailing : r), mk(n, e, {
    leading: i,
    maxWait: e,
    trailing: r
  });
}
const lD = ["innerHTML"], uD = /* @__PURE__ */ bt({
  __name: "MViewer",
  props: /* @__PURE__ */ ea({
    plugins: { default: cf },
    interval: { default: 0 }
  }, {
    modelValue: {
      required: !0
    },
    modelModifiers: {}
  }),
  emits: /* @__PURE__ */ ea(["update"], ["update:modelValue"]),
  setup(n, { emit: e }) {
    const t = n, i = Hc(n, "modelValue"), r = Ce(null), s = Ce(null), o = Ce(""), a = e, l = function() {
      return (d) => {
        s.value = d;
      };
    };
    function u() {
      const d = GZ();
      return d.use(AE), t.plugins.remark && d.use(t.plugins.remark), d.use(Oz, t.plugins.remarkRehypeOptions), t.plugins.rehype && d.use(t.plugins.rehype), d.use(l), d.use(E6, { allowDangerousHtml: !0 }), d.freeze(), d;
    }
    const c = u();
    async function h(d) {
      return c.process(d);
    }
    const f = aD(() => {
      try {
        h(i.value).then((d) => {
          o.value = d.toString(), Tk().then(() => {
            a("update", s.value, r.value);
          });
        });
      } catch (d) {
        console.log(d);
      }
    }, t.interval);
    return ft(i, () => {
      f();
    }), Fc(() => {
      f();
    }), (d, p) => (ue(), Oe("div", {
      ref_key: "real",
      ref: r,
      class: "markdown",
      innerHTML: o.value
    }, null, 8, lD));
  }
}), cD = { class: "cs-toolbar" }, hD = { key: 0 }, fD = ["onClick"], dD = { class: "cs-toolbar-tool-button" }, pD = { class: "cs-tooltip" }, mD = { key: 1 }, gD = ["onClick"], OD = { class: "cs-toolbar-tool-button" }, bD = { class: "cs-tooltip" }, yD = /* @__PURE__ */ bt({
  __name: "MToolbar",
  props: {
    toolbarL: {},
    toolbarR: {},
    getCodemirror: { type: Function },
    getCasketstar: { type: Function },
    dialog: {},
    disabled: { type: Boolean }
  },
  setup(n) {
    const e = n;
    function t(r) {
      if (e.disabled)
        return;
      const s = e.getCodemirror(), o = e.getCasketstar();
      s && o && r.func(s, o, e.dialog);
    }
    const i = (r) => {
      if (r.active) {
        const s = e.getCodemirror(), o = e.getCasketstar();
        if (s && o)
          return r.active(s, o, e.dialog);
      }
      return !1;
    };
    return (r, s) => (ue(), Oe("div", cD, [
      e.toolbarL ? (ue(), Oe("div", hD, [
        (ue(!0), Oe(di, null, pi(e.toolbarL, (o, a) => (ue(), Oe("span", {
          key: a,
          class: "cs-toolbar-group"
        }, [
          (ue(!0), Oe(di, null, pi(o, (l) => (ue(), Oe("span", {
            key: l.name,
            class: wn(["cs-toolbar-tool", { active: i(l) }]),
            onClick: (u) => t(l)
          }, [
            q("span", dD, [
              Vt(oe(Ac), {
                icon: l.icon,
                class: "cs-icon"
              }, null, 8, ["icon"])
            ]),
            q("span", pD, ce(oe(pe)(l.name)), 1)
          ], 10, fD))), 128))
        ]))), 128))
      ])) : xn("", !0),
      e.toolbarR ? (ue(), Oe("div", mD, [
        (ue(!0), Oe(di, null, pi(e.toolbarR, (o, a) => (ue(), Oe("span", {
          key: a,
          class: "cs-toolbar-group"
        }, [
          (ue(!0), Oe(di, null, pi(o, (l) => (ue(), Oe("span", {
            key: l.name,
            class: wn(["cs-toolbar-tool", { active: i(l) }]),
            onClick: (u) => t(l)
          }, [
            q("span", OD, [
              Vt(oe(Ac), {
                icon: l.icon,
                class: "cs-icon"
              }, null, 8, ["icon"])
            ]),
            q("span", bD, ce(oe(pe)(l.name)), 1)
          ], 10, gD))), 128))
        ]))), 128))
      ])) : xn("", !0)
    ]));
  }
}), kD = {
  key: 0,
  class: "cs-header"
}, xD = {
  key: 1,
  class: "cs-footer"
}, wD = { class: "cs-footer-left" }, SD = { class: "cs-footer-right" }, ZD = /* @__PURE__ */ bt({
  __name: "CasketStar",
  props: /* @__PURE__ */ ea({
    plugins: { default: cf },
    hideHeader: { type: Boolean, default: !1 },
    hideFooter: { type: Boolean, default: !1 },
    lang: { default: () => [] },
    upload: { type: Function, default: void 0 },
    height: { default: "400px" },
    disabled: { type: Boolean, default: !1 }
  }, {
    modelValue: { required: !0 },
    modelModifiers: {}
  }),
  emits: ["update:modelValue"],
  setup(n) {
    let e;
    const t = n, i = Ce({
      showEditor: !0,
      showViewer: !0,
      fullScreen: !1,
      interval: 100,
      data: {
        upload: t.upload
      }
    });
    ft(i.value, () => {
      b();
    });
    const r = Hc(n, "modelValue");
    nZ(t.lang);
    const s = Ce(!1);
    function o(E) {
      e = E.view, c.value = e.scrollDOM, c.value.onscroll = () => C(), c.value.ondragover = j, c.value.ondragenter = R, c.value.ondragleave = A, c.value.ondrop = U;
    }
    let a = [], l = [];
    const u = Ce(!0), c = Ce(null), h = Ce(null), f = Ce(null);
    let d = null, p = null;
    function g() {
      return c.value ? c.value.scrollHeight - c.value.getBoundingClientRect().height : 0;
    }
    function O() {
      return h.value ? h.value.scrollHeight - h.value.getBoundingClientRect().height : 0;
    }
    function m() {
      var H;
      if (!e || !c.value || !h.value || !u.value || !d || !p)
        return;
      a = [0], l = [0];
      for (const K of d.children)
        ((H = K.position) == null ? void 0 : H.start.offset) !== void 0 && a.push(K.position.start.offset);
      const E = h.value.scrollTop - h.value.getBoundingClientRect().top;
      let B = 0;
      for (const [K, re] of Object.entries(p.children))
        if (!re.classList.contains("katex-display")) {
          const { top: y, bottom: ne } = re.getBoundingClientRect();
          l.push(y + E), B = ne + E;
        }
      a.push(e.state.doc.length), l.push(B);
    }
    const b = mk(m, 200);
    function w(E, B) {
      d = E, p = B, b(), C();
    }
    function Q() {
      return e;
    }
    function v() {
      return i.value;
    }
    let k = "editor";
    function C(E) {
      var K, re;
      if (!e || !c.value || E !== !0 && (k !== "editor" || !u.value))
        return;
      const B = c.value.scrollTop, H = e.lineBlockAtHeight(B).from;
      if (B + 1 >= g()) {
        (K = h.value) == null || K.scrollTo({ top: O() + 10 });
        return;
      }
      for (let y = 0; y + 1 < a.length; y++) {
        const ne = a[y], Qe = a[y + 1], S = e.lineBlockAt(ne).top, Ee = e.lineBlockAt(Qe).top;
        if (ne <= H && H < Qe) {
          const Je = (B - S) / (Ee - S), Me = l[y] + Je * (l[y + 1] - l[y]);
          (re = h.value) == null || re.scrollTo({ top: Me });
          return;
        }
      }
    }
    function I() {
      var B, H;
      if (k !== "viewer" || !e || !h.value || !u.value)
        return;
      const E = h.value.scrollTop;
      if (E + 1 >= O()) {
        (B = c.value) == null || B.scrollTo({ top: g() + 10 });
        return;
      }
      for (let K = 0; K + 1 < a.length; K++) {
        const re = l[K], y = l[K + 1], ne = (E - re) / (y - re);
        if (re <= E && E < y) {
          const Qe = a[K], S = a[K + 1], Ee = e.lineBlockAt(Qe).top, Je = e.lineBlockAt(S).top, Me = ne * (Je - Ee);
          (H = c.value) == null || H.scrollTo({ top: Ee + Me });
          return;
        }
      }
    }
    function z() {
      u.value ? u.value = !1 : (u.value = !0, m(), C(!0));
    }
    function P() {
      c.value && c.value.scrollTo({ top: 0 }), h.value && h.value.scrollTo({ top: 0 });
    }
    function R(E) {
      var B;
      if ((B = E.dataTransfer) != null && B.items) {
        for (let H = 0; H < E.dataTransfer.items.length; H++)
          if (E.dataTransfer.items[H].kind === "file") {
            s.value = !0;
            return;
          }
      }
    }
    function A() {
      s.value = !1;
    }
    function j(E) {
      E.preventDefault();
    }
    function U(E) {
      var H;
      if (!t.upload || (s.value = !1, !((H = E.dataTransfer) != null && H.files)))
        return;
      const B = t.upload(E.dataTransfer.files);
      if (B !== void 0 && e) {
        const K = e.state;
        let re = "";
        for (let ne = 0; ne < B.length; ne++)
          re += `![${B[ne].alt}](${B[ne].url})`;
        const y = K.update(K.changeByRange((ne) => ({
          changes: [
            { from: ne.from, to: ne.to },
            { from: ne.from, insert: re }
          ],
          range: $.range(ne.from + re.length, ne.from + re.length)
        })));
        e.update([y]), e.focus();
      }
      E.preventDefault();
    }
    return Fc(() => {
      addEventListener("resize", b);
    }), Ak(() => {
      e == null || e.destroy();
    }), (E, B) => {
      var H;
      return ue(), Oe("div", {
        class: wn(["casket cs-main", { "cs-full-screen": i.value.fullScreen }])
      }, [
        t.hideHeader ? xn("", !0) : (ue(), Oe("div", kD, [
          Vt(yD, {
            "toolbar-l": t.plugins.toolbarL,
            "toolbar-r": t.plugins.toolbarR,
            "get-codemirror": Q,
            "get-casketstar": v,
            dialog: f.value,
            disabled: t.disabled
          }, null, 8, ["toolbar-l", "toolbar-r", "dialog", "disabled"])
        ])),
        q("div", {
          class: "cs-content",
          style: Rk({ height: t.height })
        }, [
          i.value.showEditor ? (ue(), Oe("div", {
            key: 0,
            class: wn(["cs-editor", {
              "cs-midline": i.value.showViewer,
              "cs-zone-half": i.value.showViewer,
              "cs-zone-full": !i.value.showViewer
            }]),
            onMouseover: B[1] || (B[1] = (K) => vf(k) ? k.value = "editor" : k = "editor")
          }, [
            Vt(RZ, {
              modelValue: r.value,
              "onUpdate:modelValue": B[0] || (B[0] = (K) => r.value = K),
              plugins: E.plugins,
              disabled: t.disabled,
              onReady: o
            }, null, 8, ["modelValue", "plugins", "disabled"]),
            t.upload ? (ue(), Oe("div", {
              key: 0,
              class: wn(["cs-upload", { dragging: s.value }])
            }, ce(oe(pe)("release-to-update")), 3)) : xn("", !0)
          ], 34)) : xn("", !0),
          i.value.showViewer ? (ue(), Oe("div", {
            key: 1,
            ref_key: "viewer",
            ref: h,
            class: wn(["cs-viewer", {
              "cs-zone-half": i.value.showEditor,
              "cs-zone-full": !i.value.showEditor
            }]),
            onScroll: I,
            onMouseover: B[3] || (B[3] = (K) => vf(k) ? k.value = "viewer" : k = "viewer")
          }, [
            Vt(uD, {
              modelValue: r.value,
              "onUpdate:modelValue": B[2] || (B[2] = (K) => r.value = K),
              plugins: E.plugins,
              interval: i.value.interval,
              onUpdate: w
            }, null, 8, ["modelValue", "plugins", "interval"])
          ], 34)) : xn("", !0)
        ], 4),
        t.hideFooter ? xn("", !0) : (ue(), Oe("div", xD, [
          q("div", wD, ce(oe(pe)("character-count")) + ce(((H = Q()) == null ? void 0 : H.state.doc.length) || 0) + ce(oe(pe)("character")), 1),
          q("div", SD, [
            q("span", {
              class: "cs-footer-button",
              onClick: z
            }, ce(u.value ? oe(pe)("sync-disable") : oe(pe)("sync-enable")), 1),
            q("span", {
              class: "cs-footer-button",
              onClick: P
            }, ce(oe(pe)("back-to-top")), 1)
          ])
        ])),
        (ue(), Ci(Mk, { to: "body" }, [
          q("div", {
            ref_key: "dialog",
            ref: f,
            class: "casket"
          }, null, 512)
        ]))
      ], 2);
    };
  }
});
export {
  RZ as CasketEditor,
  ZD as CasketStar,
  uD as CasketViewer,
  Ac as FontAwesomeIcon,
  Vs as MDialog,
  aZ as ToolBold,
  fZ as ToolCode,
  sZ as ToolDecrease,
  kZ as ToolFullScreen,
  QZ as ToolGroupBlock,
  $Z as ToolGroupCasket,
  CZ as ToolGroupHelp,
  vZ as ToolGroupInline,
  PZ as ToolGroupInterline,
  SZ as ToolGroupTitle,
  xZ as ToolHelp,
  oZ as ToolHorizontal,
  hZ as ToolImage,
  rZ as ToolIncrease,
  lZ as ToolItalic,
  cZ as ToolLink,
  wZ as ToolMath,
  gZ as ToolOList,
  bZ as ToolOnlyEdit,
  yZ as ToolOnlyView,
  pZ as ToolQuote,
  uZ as ToolStrikethrough,
  dZ as ToolTable,
  OZ as ToolTaskList,
  mZ as ToolUList,
  V7 as commonmarkLanguage,
  Xe as defaultIcons,
  Tp as enUS,
  cf as getDefaultPlugins,
  TZ as getDefaultToolbarL,
  AZ as getDefaultToolbarR,
  pe as i18n,
  nZ as initI18n,
  J7 as markdown,
  lf as markdownLanguage,
  iZ as remarkNoHtml,
  TD as zhCN
};
